(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
    typeof define === 'function' && define.amd ? define(factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, (global["pptist-import-pptx"] = global["pptist-import-pptx"] || {}, global["pptist-import-pptx"].js = factory()));
})(this, (function () { 'use strict';

    // private property
    var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";


    // public method for encoding
    var encode = function(input, utf8) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            }
            else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output + _keyStr.charAt(enc1) + _keyStr.charAt(enc2) + _keyStr.charAt(enc3) + _keyStr.charAt(enc4);

        }

        return output;
    };

    // public method for decoding
    var decode = function(input, utf8) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        return output;

    };

    var base64$1 = {
    	encode: encode,
    	decode: decode
    };

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    function createCommonjsModule(fn, module) {
    	return module = { exports: {} }, fn(module, module.exports), module.exports;
    }

    var support = createCommonjsModule(function (module, exports) {
    exports.base64 = true;
    exports.array = true;
    exports.string = true;
    exports.arraybuffer = typeof ArrayBuffer !== "undefined" && typeof Uint8Array !== "undefined";
    // contains true if JSZip can read/generate nodejs Buffer, false otherwise.
    // Browserify will provide a Buffer implementation for browsers, which is
    // an augmented Uint8Array (i.e., can be used as either Buffer or U8).
    exports.nodebuffer = typeof Buffer !== "undefined";
    // contains true if JSZip can read/generate Uint8Array, false otherwise.
    exports.uint8array = typeof Uint8Array !== "undefined";

    if (typeof ArrayBuffer === "undefined") {
        exports.blob = false;
    }
    else {
        var buffer = new ArrayBuffer(0);
        try {
            exports.blob = new Blob([buffer], {
                type: "application/zip"
            }).size === 0;
        }
        catch (e) {
            try {
                var Builder = window.BlobBuilder || window.WebKitBlobBuilder || window.MozBlobBuilder || window.MSBlobBuilder;
                var builder = new Builder();
                builder.append(buffer);
                exports.blob = builder.getBlob('application/zip').size === 0;
            }
            catch (e) {
                exports.blob = false;
            }
        }
    }
    });
    support.base64;
    support.array;
    support.string;
    support.arraybuffer;
    support.nodebuffer;
    support.uint8array;
    support.blob;

    var common = createCommonjsModule(function (module, exports) {


    var TYPED_OK =  (typeof Uint8Array !== 'undefined') &&
                    (typeof Uint16Array !== 'undefined') &&
                    (typeof Int32Array !== 'undefined');

    function _has(obj, key) {
      return Object.prototype.hasOwnProperty.call(obj, key);
    }

    exports.assign = function (obj /*from1, from2, from3, ...*/) {
      var sources = Array.prototype.slice.call(arguments, 1);
      while (sources.length) {
        var source = sources.shift();
        if (!source) { continue; }

        if (typeof source !== 'object') {
          throw new TypeError(source + 'must be non-object');
        }

        for (var p in source) {
          if (_has(source, p)) {
            obj[p] = source[p];
          }
        }
      }

      return obj;
    };


    // reduce buffer size, avoiding mem copy
    exports.shrinkBuf = function (buf, size) {
      if (buf.length === size) { return buf; }
      if (buf.subarray) { return buf.subarray(0, size); }
      buf.length = size;
      return buf;
    };


    var fnTyped = {
      arraySet: function (dest, src, src_offs, len, dest_offs) {
        if (src.subarray && dest.subarray) {
          dest.set(src.subarray(src_offs, src_offs + len), dest_offs);
          return;
        }
        // Fallback to ordinary array
        for (var i = 0; i < len; i++) {
          dest[dest_offs + i] = src[src_offs + i];
        }
      },
      // Join array of chunks to single array.
      flattenChunks: function (chunks) {
        var i, l, len, pos, chunk, result;

        // calculate data length
        len = 0;
        for (i = 0, l = chunks.length; i < l; i++) {
          len += chunks[i].length;
        }

        // join chunks
        result = new Uint8Array(len);
        pos = 0;
        for (i = 0, l = chunks.length; i < l; i++) {
          chunk = chunks[i];
          result.set(chunk, pos);
          pos += chunk.length;
        }

        return result;
      }
    };

    var fnUntyped = {
      arraySet: function (dest, src, src_offs, len, dest_offs) {
        for (var i = 0; i < len; i++) {
          dest[dest_offs + i] = src[src_offs + i];
        }
      },
      // Join array of chunks to single array.
      flattenChunks: function (chunks) {
        return [].concat.apply([], chunks);
      }
    };


    // Enable/Disable typed arrays use, for testing
    //
    exports.setTyped = function (on) {
      if (on) {
        exports.Buf8  = Uint8Array;
        exports.Buf16 = Uint16Array;
        exports.Buf32 = Int32Array;
        exports.assign(exports, fnTyped);
      } else {
        exports.Buf8  = Array;
        exports.Buf16 = Array;
        exports.Buf32 = Array;
        exports.assign(exports, fnUntyped);
      }
    };

    exports.setTyped(TYPED_OK);
    });
    common.assign;
    common.shrinkBuf;
    common.setTyped;
    common.Buf8;
    common.Buf16;
    common.Buf32;

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    /* eslint-disable space-unary-ops */



    /* Public constants ==========================================================*/
    /* ===========================================================================*/


    //var Z_FILTERED          = 1;
    //var Z_HUFFMAN_ONLY      = 2;
    //var Z_RLE               = 3;
    var Z_FIXED$1               = 4;
    //var Z_DEFAULT_STRATEGY  = 0;

    /* Possible values of the data_type field (though see inflate()) */
    var Z_BINARY              = 0;
    var Z_TEXT                = 1;
    //var Z_ASCII             = 1; // = Z_TEXT
    var Z_UNKNOWN$1             = 2;

    /*============================================================================*/


    function zero$1(buf) { var len = buf.length; while (--len >= 0) { buf[len] = 0; } }

    // From zutil.h

    var STORED_BLOCK = 0;
    var STATIC_TREES = 1;
    var DYN_TREES    = 2;
    /* The three kinds of block type */

    var MIN_MATCH$1    = 3;
    var MAX_MATCH$1    = 258;
    /* The minimum and maximum match lengths */

    // From deflate.h
    /* ===========================================================================
     * Internal compression state.
     */

    var LENGTH_CODES$1  = 29;
    /* number of length codes, not counting the special END_BLOCK code */

    var LITERALS$1      = 256;
    /* number of literal bytes 0..255 */

    var L_CODES$1       = LITERALS$1 + 1 + LENGTH_CODES$1;
    /* number of Literal or Length codes, including the END_BLOCK code */

    var D_CODES$1       = 30;
    /* number of distance codes */

    var BL_CODES$1      = 19;
    /* number of codes used to transfer the bit lengths */

    var HEAP_SIZE$1     = 2 * L_CODES$1 + 1;
    /* maximum heap size */

    var MAX_BITS$1      = 15;
    /* All codes must not exceed MAX_BITS bits */

    var Buf_size      = 16;
    /* size of bit buffer in bi_buf */


    /* ===========================================================================
     * Constants
     */

    var MAX_BL_BITS = 7;
    /* Bit length codes must not exceed MAX_BL_BITS bits */

    var END_BLOCK   = 256;
    /* end of block literal code */

    var REP_3_6     = 16;
    /* repeat previous bit length 3-6 times (2 bits of repeat count) */

    var REPZ_3_10   = 17;
    /* repeat a zero length 3-10 times  (3 bits of repeat count) */

    var REPZ_11_138 = 18;
    /* repeat a zero length 11-138 times  (7 bits of repeat count) */

    /* eslint-disable comma-spacing,array-bracket-spacing */
    var extra_lbits =   /* extra bits for each length code */
      [0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0];

    var extra_dbits =   /* extra bits for each distance code */
      [0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13];

    var extra_blbits =  /* extra bits for each bit length code */
      [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7];

    var bl_order =
      [16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];
    /* eslint-enable comma-spacing,array-bracket-spacing */

    /* The lengths of the bit length codes are sent in order of decreasing
     * probability, to avoid transmitting the lengths for unused bit length codes.
     */

    /* ===========================================================================
     * Local data. These are initialized only once.
     */

    // We pre-fill arrays with 0 to avoid uninitialized gaps

    var DIST_CODE_LEN = 512; /* see definition of array dist_code below */

    // !!!! Use flat array instead of structure, Freq = i*2, Len = i*2+1
    var static_ltree  = new Array((L_CODES$1 + 2) * 2);
    zero$1(static_ltree);
    /* The static literal tree. Since the bit lengths are imposed, there is no
     * need for the L_CODES extra codes used during heap construction. However
     * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
     * below).
     */

    var static_dtree  = new Array(D_CODES$1 * 2);
    zero$1(static_dtree);
    /* The static distance tree. (Actually a trivial tree since all codes use
     * 5 bits.)
     */

    var _dist_code    = new Array(DIST_CODE_LEN);
    zero$1(_dist_code);
    /* Distance codes. The first 256 values correspond to the distances
     * 3 .. 258, the last 256 values correspond to the top 8 bits of
     * the 15 bit distances.
     */

    var _length_code  = new Array(MAX_MATCH$1 - MIN_MATCH$1 + 1);
    zero$1(_length_code);
    /* length code for each normalized match length (0 == MIN_MATCH) */

    var base_length   = new Array(LENGTH_CODES$1);
    zero$1(base_length);
    /* First normalized length for each code (0 = MIN_MATCH) */

    var base_dist     = new Array(D_CODES$1);
    zero$1(base_dist);
    /* First normalized distance for each code (0 = distance of 1) */


    function StaticTreeDesc(static_tree, extra_bits, extra_base, elems, max_length) {

      this.static_tree  = static_tree;  /* static tree or NULL */
      this.extra_bits   = extra_bits;   /* extra bits for each code or NULL */
      this.extra_base   = extra_base;   /* base index for extra_bits */
      this.elems        = elems;        /* max number of elements in the tree */
      this.max_length   = max_length;   /* max bit length for the codes */

      // show if `static_tree` has data or dummy - needed for monomorphic objects
      this.has_stree    = static_tree && static_tree.length;
    }


    var static_l_desc;
    var static_d_desc;
    var static_bl_desc;


    function TreeDesc(dyn_tree, stat_desc) {
      this.dyn_tree = dyn_tree;     /* the dynamic tree */
      this.max_code = 0;            /* largest code with non zero frequency */
      this.stat_desc = stat_desc;   /* the corresponding static tree */
    }



    function d_code(dist) {
      return dist < 256 ? _dist_code[dist] : _dist_code[256 + (dist >>> 7)];
    }


    /* ===========================================================================
     * Output a short LSB first on the stream.
     * IN assertion: there is enough room in pendingBuf.
     */
    function put_short(s, w) {
    //    put_byte(s, (uch)((w) & 0xff));
    //    put_byte(s, (uch)((ush)(w) >> 8));
      s.pending_buf[s.pending++] = (w) & 0xff;
      s.pending_buf[s.pending++] = (w >>> 8) & 0xff;
    }


    /* ===========================================================================
     * Send a value on a given number of bits.
     * IN assertion: length <= 16 and value fits in length bits.
     */
    function send_bits(s, value, length) {
      if (s.bi_valid > (Buf_size - length)) {
        s.bi_buf |= (value << s.bi_valid) & 0xffff;
        put_short(s, s.bi_buf);
        s.bi_buf = value >> (Buf_size - s.bi_valid);
        s.bi_valid += length - Buf_size;
      } else {
        s.bi_buf |= (value << s.bi_valid) & 0xffff;
        s.bi_valid += length;
      }
    }


    function send_code(s, c, tree) {
      send_bits(s, tree[c * 2]/*.Code*/, tree[c * 2 + 1]/*.Len*/);
    }


    /* ===========================================================================
     * Reverse the first len bits of a code, using straightforward code (a faster
     * method would use a table)
     * IN assertion: 1 <= len <= 15
     */
    function bi_reverse(code, len) {
      var res = 0;
      do {
        res |= code & 1;
        code >>>= 1;
        res <<= 1;
      } while (--len > 0);
      return res >>> 1;
    }


    /* ===========================================================================
     * Flush the bit buffer, keeping at most 7 bits in it.
     */
    function bi_flush(s) {
      if (s.bi_valid === 16) {
        put_short(s, s.bi_buf);
        s.bi_buf = 0;
        s.bi_valid = 0;

      } else if (s.bi_valid >= 8) {
        s.pending_buf[s.pending++] = s.bi_buf & 0xff;
        s.bi_buf >>= 8;
        s.bi_valid -= 8;
      }
    }


    /* ===========================================================================
     * Compute the optimal bit lengths for a tree and update the total bit length
     * for the current block.
     * IN assertion: the fields freq and dad are set, heap[heap_max] and
     *    above are the tree nodes sorted by increasing frequency.
     * OUT assertions: the field len is set to the optimal bit length, the
     *     array bl_count contains the frequencies for each bit length.
     *     The length opt_len is updated; static_len is also updated if stree is
     *     not null.
     */
    function gen_bitlen(s, desc)
    //    deflate_state *s;
    //    tree_desc *desc;    /* the tree descriptor */
    {
      var tree            = desc.dyn_tree;
      var max_code        = desc.max_code;
      var stree           = desc.stat_desc.static_tree;
      var has_stree       = desc.stat_desc.has_stree;
      var extra           = desc.stat_desc.extra_bits;
      var base            = desc.stat_desc.extra_base;
      var max_length      = desc.stat_desc.max_length;
      var h;              /* heap index */
      var n, m;           /* iterate over the tree elements */
      var bits;           /* bit length */
      var xbits;          /* extra bits */
      var f;              /* frequency */
      var overflow = 0;   /* number of elements with bit length too large */

      for (bits = 0; bits <= MAX_BITS$1; bits++) {
        s.bl_count[bits] = 0;
      }

      /* In a first pass, compute the optimal bit lengths (which may
       * overflow in the case of the bit length tree).
       */
      tree[s.heap[s.heap_max] * 2 + 1]/*.Len*/ = 0; /* root of the heap */

      for (h = s.heap_max + 1; h < HEAP_SIZE$1; h++) {
        n = s.heap[h];
        bits = tree[tree[n * 2 + 1]/*.Dad*/ * 2 + 1]/*.Len*/ + 1;
        if (bits > max_length) {
          bits = max_length;
          overflow++;
        }
        tree[n * 2 + 1]/*.Len*/ = bits;
        /* We overwrite tree[n].Dad which is no longer needed */

        if (n > max_code) { continue; } /* not a leaf node */

        s.bl_count[bits]++;
        xbits = 0;
        if (n >= base) {
          xbits = extra[n - base];
        }
        f = tree[n * 2]/*.Freq*/;
        s.opt_len += f * (bits + xbits);
        if (has_stree) {
          s.static_len += f * (stree[n * 2 + 1]/*.Len*/ + xbits);
        }
      }
      if (overflow === 0) { return; }

      // Trace((stderr,"\nbit length overflow\n"));
      /* This happens for example on obj2 and pic of the Calgary corpus */

      /* Find the first bit length which could increase: */
      do {
        bits = max_length - 1;
        while (s.bl_count[bits] === 0) { bits--; }
        s.bl_count[bits]--;      /* move one leaf down the tree */
        s.bl_count[bits + 1] += 2; /* move one overflow item as its brother */
        s.bl_count[max_length]--;
        /* The brother of the overflow item also moves one step up,
         * but this does not affect bl_count[max_length]
         */
        overflow -= 2;
      } while (overflow > 0);

      /* Now recompute all bit lengths, scanning in increasing frequency.
       * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
       * lengths instead of fixing only the wrong ones. This idea is taken
       * from 'ar' written by Haruhiko Okumura.)
       */
      for (bits = max_length; bits !== 0; bits--) {
        n = s.bl_count[bits];
        while (n !== 0) {
          m = s.heap[--h];
          if (m > max_code) { continue; }
          if (tree[m * 2 + 1]/*.Len*/ !== bits) {
            // Trace((stderr,"code %d bits %d->%d\n", m, tree[m].Len, bits));
            s.opt_len += (bits - tree[m * 2 + 1]/*.Len*/) * tree[m * 2]/*.Freq*/;
            tree[m * 2 + 1]/*.Len*/ = bits;
          }
          n--;
        }
      }
    }


    /* ===========================================================================
     * Generate the codes for a given tree and bit counts (which need not be
     * optimal).
     * IN assertion: the array bl_count contains the bit length statistics for
     * the given tree and the field len is set for all tree elements.
     * OUT assertion: the field code is set for all tree elements of non
     *     zero code length.
     */
    function gen_codes(tree, max_code, bl_count)
    //    ct_data *tree;             /* the tree to decorate */
    //    int max_code;              /* largest code with non zero frequency */
    //    ushf *bl_count;            /* number of codes at each bit length */
    {
      var next_code = new Array(MAX_BITS$1 + 1); /* next code value for each bit length */
      var code = 0;              /* running code value */
      var bits;                  /* bit index */
      var n;                     /* code index */

      /* The distribution counts are first used to generate the code values
       * without bit reversal.
       */
      for (bits = 1; bits <= MAX_BITS$1; bits++) {
        next_code[bits] = code = (code + bl_count[bits - 1]) << 1;
      }
      /* Check that the bit counts in bl_count are consistent. The last code
       * must be all ones.
       */
      //Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
      //        "inconsistent bit counts");
      //Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

      for (n = 0;  n <= max_code; n++) {
        var len = tree[n * 2 + 1]/*.Len*/;
        if (len === 0) { continue; }
        /* Now reverse the bits */
        tree[n * 2]/*.Code*/ = bi_reverse(next_code[len]++, len);

        //Tracecv(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
        //     n, (isgraph(n) ? n : ' '), len, tree[n].Code, next_code[len]-1));
      }
    }


    /* ===========================================================================
     * Initialize the various 'constant' tables.
     */
    function tr_static_init() {
      var n;        /* iterates over tree elements */
      var bits;     /* bit counter */
      var length;   /* length value */
      var code;     /* code value */
      var dist;     /* distance index */
      var bl_count = new Array(MAX_BITS$1 + 1);
      /* number of codes at each bit length for an optimal tree */

      // do check in _tr_init()
      //if (static_init_done) return;

      /* For some embedded targets, global variables are not initialized: */
    /*#ifdef NO_INIT_GLOBAL_POINTERS
      static_l_desc.static_tree = static_ltree;
      static_l_desc.extra_bits = extra_lbits;
      static_d_desc.static_tree = static_dtree;
      static_d_desc.extra_bits = extra_dbits;
      static_bl_desc.extra_bits = extra_blbits;
    #endif*/

      /* Initialize the mapping length (0..255) -> length code (0..28) */
      length = 0;
      for (code = 0; code < LENGTH_CODES$1 - 1; code++) {
        base_length[code] = length;
        for (n = 0; n < (1 << extra_lbits[code]); n++) {
          _length_code[length++] = code;
        }
      }
      //Assert (length == 256, "tr_static_init: length != 256");
      /* Note that the length 255 (match length 258) can be represented
       * in two different ways: code 284 + 5 bits or code 285, so we
       * overwrite length_code[255] to use the best encoding:
       */
      _length_code[length - 1] = code;

      /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
      dist = 0;
      for (code = 0; code < 16; code++) {
        base_dist[code] = dist;
        for (n = 0; n < (1 << extra_dbits[code]); n++) {
          _dist_code[dist++] = code;
        }
      }
      //Assert (dist == 256, "tr_static_init: dist != 256");
      dist >>= 7; /* from now on, all distances are divided by 128 */
      for (; code < D_CODES$1; code++) {
        base_dist[code] = dist << 7;
        for (n = 0; n < (1 << (extra_dbits[code] - 7)); n++) {
          _dist_code[256 + dist++] = code;
        }
      }
      //Assert (dist == 256, "tr_static_init: 256+dist != 512");

      /* Construct the codes of the static literal tree */
      for (bits = 0; bits <= MAX_BITS$1; bits++) {
        bl_count[bits] = 0;
      }

      n = 0;
      while (n <= 143) {
        static_ltree[n * 2 + 1]/*.Len*/ = 8;
        n++;
        bl_count[8]++;
      }
      while (n <= 255) {
        static_ltree[n * 2 + 1]/*.Len*/ = 9;
        n++;
        bl_count[9]++;
      }
      while (n <= 279) {
        static_ltree[n * 2 + 1]/*.Len*/ = 7;
        n++;
        bl_count[7]++;
      }
      while (n <= 287) {
        static_ltree[n * 2 + 1]/*.Len*/ = 8;
        n++;
        bl_count[8]++;
      }
      /* Codes 286 and 287 do not exist, but we must include them in the
       * tree construction to get a canonical Huffman tree (longest code
       * all ones)
       */
      gen_codes(static_ltree, L_CODES$1 + 1, bl_count);

      /* The static distance tree is trivial: */
      for (n = 0; n < D_CODES$1; n++) {
        static_dtree[n * 2 + 1]/*.Len*/ = 5;
        static_dtree[n * 2]/*.Code*/ = bi_reverse(n, 5);
      }

      // Now data ready and we can init static trees
      static_l_desc = new StaticTreeDesc(static_ltree, extra_lbits, LITERALS$1 + 1, L_CODES$1, MAX_BITS$1);
      static_d_desc = new StaticTreeDesc(static_dtree, extra_dbits, 0,          D_CODES$1, MAX_BITS$1);
      static_bl_desc = new StaticTreeDesc(new Array(0), extra_blbits, 0,         BL_CODES$1, MAX_BL_BITS);

      //static_init_done = true;
    }


    /* ===========================================================================
     * Initialize a new block.
     */
    function init_block(s) {
      var n; /* iterates over tree elements */

      /* Initialize the trees. */
      for (n = 0; n < L_CODES$1;  n++) { s.dyn_ltree[n * 2]/*.Freq*/ = 0; }
      for (n = 0; n < D_CODES$1;  n++) { s.dyn_dtree[n * 2]/*.Freq*/ = 0; }
      for (n = 0; n < BL_CODES$1; n++) { s.bl_tree[n * 2]/*.Freq*/ = 0; }

      s.dyn_ltree[END_BLOCK * 2]/*.Freq*/ = 1;
      s.opt_len = s.static_len = 0;
      s.last_lit = s.matches = 0;
    }


    /* ===========================================================================
     * Flush the bit buffer and align the output on a byte boundary
     */
    function bi_windup(s)
    {
      if (s.bi_valid > 8) {
        put_short(s, s.bi_buf);
      } else if (s.bi_valid > 0) {
        //put_byte(s, (Byte)s->bi_buf);
        s.pending_buf[s.pending++] = s.bi_buf;
      }
      s.bi_buf = 0;
      s.bi_valid = 0;
    }

    /* ===========================================================================
     * Copy a stored block, storing first the length and its
     * one's complement if requested.
     */
    function copy_block(s, buf, len, header)
    //DeflateState *s;
    //charf    *buf;    /* the input data */
    //unsigned len;     /* its length */
    //int      header;  /* true if block header must be written */
    {
      bi_windup(s);        /* align on byte boundary */

      if (header) {
        put_short(s, len);
        put_short(s, ~len);
      }
    //  while (len--) {
    //    put_byte(s, *buf++);
    //  }
      common.arraySet(s.pending_buf, s.window, buf, len, s.pending);
      s.pending += len;
    }

    /* ===========================================================================
     * Compares to subtrees, using the tree depth as tie breaker when
     * the subtrees have equal frequency. This minimizes the worst case length.
     */
    function smaller(tree, n, m, depth) {
      var _n2 = n * 2;
      var _m2 = m * 2;
      return (tree[_n2]/*.Freq*/ < tree[_m2]/*.Freq*/ ||
             (tree[_n2]/*.Freq*/ === tree[_m2]/*.Freq*/ && depth[n] <= depth[m]));
    }

    /* ===========================================================================
     * Restore the heap property by moving down the tree starting at node k,
     * exchanging a node with the smallest of its two sons if necessary, stopping
     * when the heap property is re-established (each father smaller than its
     * two sons).
     */
    function pqdownheap(s, tree, k)
    //    deflate_state *s;
    //    ct_data *tree;  /* the tree to restore */
    //    int k;               /* node to move down */
    {
      var v = s.heap[k];
      var j = k << 1;  /* left son of k */
      while (j <= s.heap_len) {
        /* Set j to the smallest of the two sons: */
        if (j < s.heap_len &&
          smaller(tree, s.heap[j + 1], s.heap[j], s.depth)) {
          j++;
        }
        /* Exit if v is smaller than both sons */
        if (smaller(tree, v, s.heap[j], s.depth)) { break; }

        /* Exchange v with the smallest son */
        s.heap[k] = s.heap[j];
        k = j;

        /* And continue down the tree, setting j to the left son of k */
        j <<= 1;
      }
      s.heap[k] = v;
    }


    // inlined manually
    // var SMALLEST = 1;

    /* ===========================================================================
     * Send the block data compressed using the given Huffman trees
     */
    function compress_block(s, ltree, dtree)
    //    deflate_state *s;
    //    const ct_data *ltree; /* literal tree */
    //    const ct_data *dtree; /* distance tree */
    {
      var dist;           /* distance of matched string */
      var lc;             /* match length or unmatched char (if dist == 0) */
      var lx = 0;         /* running index in l_buf */
      var code;           /* the code to send */
      var extra;          /* number of extra bits to send */

      if (s.last_lit !== 0) {
        do {
          dist = (s.pending_buf[s.d_buf + lx * 2] << 8) | (s.pending_buf[s.d_buf + lx * 2 + 1]);
          lc = s.pending_buf[s.l_buf + lx];
          lx++;

          if (dist === 0) {
            send_code(s, lc, ltree); /* send a literal byte */
            //Tracecv(isgraph(lc), (stderr," '%c' ", lc));
          } else {
            /* Here, lc is the match length - MIN_MATCH */
            code = _length_code[lc];
            send_code(s, code + LITERALS$1 + 1, ltree); /* send the length code */
            extra = extra_lbits[code];
            if (extra !== 0) {
              lc -= base_length[code];
              send_bits(s, lc, extra);       /* send the extra length bits */
            }
            dist--; /* dist is now the match distance - 1 */
            code = d_code(dist);
            //Assert (code < D_CODES, "bad d_code");

            send_code(s, code, dtree);       /* send the distance code */
            extra = extra_dbits[code];
            if (extra !== 0) {
              dist -= base_dist[code];
              send_bits(s, dist, extra);   /* send the extra distance bits */
            }
          } /* literal or match pair ? */

          /* Check that the overlay between pending_buf and d_buf+l_buf is ok: */
          //Assert((uInt)(s->pending) < s->lit_bufsize + 2*lx,
          //       "pendingBuf overflow");

        } while (lx < s.last_lit);
      }

      send_code(s, END_BLOCK, ltree);
    }


    /* ===========================================================================
     * Construct one Huffman tree and assigns the code bit strings and lengths.
     * Update the total bit length for the current block.
     * IN assertion: the field freq is set for all tree elements.
     * OUT assertions: the fields len and code are set to the optimal bit length
     *     and corresponding code. The length opt_len is updated; static_len is
     *     also updated if stree is not null. The field max_code is set.
     */
    function build_tree(s, desc)
    //    deflate_state *s;
    //    tree_desc *desc; /* the tree descriptor */
    {
      var tree     = desc.dyn_tree;
      var stree    = desc.stat_desc.static_tree;
      var has_stree = desc.stat_desc.has_stree;
      var elems    = desc.stat_desc.elems;
      var n, m;          /* iterate over heap elements */
      var max_code = -1; /* largest code with non zero frequency */
      var node;          /* new node being created */

      /* Construct the initial heap, with least frequent element in
       * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
       * heap[0] is not used.
       */
      s.heap_len = 0;
      s.heap_max = HEAP_SIZE$1;

      for (n = 0; n < elems; n++) {
        if (tree[n * 2]/*.Freq*/ !== 0) {
          s.heap[++s.heap_len] = max_code = n;
          s.depth[n] = 0;

        } else {
          tree[n * 2 + 1]/*.Len*/ = 0;
        }
      }

      /* The pkzip format requires that at least one distance code exists,
       * and that at least one bit should be sent even if there is only one
       * possible code. So to avoid special checks later on we force at least
       * two codes of non zero frequency.
       */
      while (s.heap_len < 2) {
        node = s.heap[++s.heap_len] = (max_code < 2 ? ++max_code : 0);
        tree[node * 2]/*.Freq*/ = 1;
        s.depth[node] = 0;
        s.opt_len--;

        if (has_stree) {
          s.static_len -= stree[node * 2 + 1]/*.Len*/;
        }
        /* node is 0 or 1 so it does not have extra bits */
      }
      desc.max_code = max_code;

      /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
       * establish sub-heaps of increasing lengths:
       */
      for (n = (s.heap_len >> 1/*int /2*/); n >= 1; n--) { pqdownheap(s, tree, n); }

      /* Construct the Huffman tree by repeatedly combining the least two
       * frequent nodes.
       */
      node = elems;              /* next internal node of the tree */
      do {
        //pqremove(s, tree, n);  /* n = node of least frequency */
        /*** pqremove ***/
        n = s.heap[1/*SMALLEST*/];
        s.heap[1/*SMALLEST*/] = s.heap[s.heap_len--];
        pqdownheap(s, tree, 1/*SMALLEST*/);
        /***/

        m = s.heap[1/*SMALLEST*/]; /* m = node of next least frequency */

        s.heap[--s.heap_max] = n; /* keep the nodes sorted by frequency */
        s.heap[--s.heap_max] = m;

        /* Create a new node father of n and m */
        tree[node * 2]/*.Freq*/ = tree[n * 2]/*.Freq*/ + tree[m * 2]/*.Freq*/;
        s.depth[node] = (s.depth[n] >= s.depth[m] ? s.depth[n] : s.depth[m]) + 1;
        tree[n * 2 + 1]/*.Dad*/ = tree[m * 2 + 1]/*.Dad*/ = node;

        /* and insert the new node in the heap */
        s.heap[1/*SMALLEST*/] = node++;
        pqdownheap(s, tree, 1/*SMALLEST*/);

      } while (s.heap_len >= 2);

      s.heap[--s.heap_max] = s.heap[1/*SMALLEST*/];

      /* At this point, the fields freq and dad are set. We can now
       * generate the bit lengths.
       */
      gen_bitlen(s, desc);

      /* The field len is now set, we can generate the bit codes */
      gen_codes(tree, max_code, s.bl_count);
    }


    /* ===========================================================================
     * Scan a literal or distance tree to determine the frequencies of the codes
     * in the bit length tree.
     */
    function scan_tree(s, tree, max_code)
    //    deflate_state *s;
    //    ct_data *tree;   /* the tree to be scanned */
    //    int max_code;    /* and its largest code of non zero frequency */
    {
      var n;                     /* iterates over all tree elements */
      var prevlen = -1;          /* last emitted length */
      var curlen;                /* length of current code */

      var nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

      var count = 0;             /* repeat count of the current code */
      var max_count = 7;         /* max repeat count */
      var min_count = 4;         /* min repeat count */

      if (nextlen === 0) {
        max_count = 138;
        min_count = 3;
      }
      tree[(max_code + 1) * 2 + 1]/*.Len*/ = 0xffff; /* guard */

      for (n = 0; n <= max_code; n++) {
        curlen = nextlen;
        nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

        if (++count < max_count && curlen === nextlen) {
          continue;

        } else if (count < min_count) {
          s.bl_tree[curlen * 2]/*.Freq*/ += count;

        } else if (curlen !== 0) {

          if (curlen !== prevlen) { s.bl_tree[curlen * 2]/*.Freq*/++; }
          s.bl_tree[REP_3_6 * 2]/*.Freq*/++;

        } else if (count <= 10) {
          s.bl_tree[REPZ_3_10 * 2]/*.Freq*/++;

        } else {
          s.bl_tree[REPZ_11_138 * 2]/*.Freq*/++;
        }

        count = 0;
        prevlen = curlen;

        if (nextlen === 0) {
          max_count = 138;
          min_count = 3;

        } else if (curlen === nextlen) {
          max_count = 6;
          min_count = 3;

        } else {
          max_count = 7;
          min_count = 4;
        }
      }
    }


    /* ===========================================================================
     * Send a literal or distance tree in compressed form, using the codes in
     * bl_tree.
     */
    function send_tree(s, tree, max_code)
    //    deflate_state *s;
    //    ct_data *tree; /* the tree to be scanned */
    //    int max_code;       /* and its largest code of non zero frequency */
    {
      var n;                     /* iterates over all tree elements */
      var prevlen = -1;          /* last emitted length */
      var curlen;                /* length of current code */

      var nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

      var count = 0;             /* repeat count of the current code */
      var max_count = 7;         /* max repeat count */
      var min_count = 4;         /* min repeat count */

      /* tree[max_code+1].Len = -1; */  /* guard already set */
      if (nextlen === 0) {
        max_count = 138;
        min_count = 3;
      }

      for (n = 0; n <= max_code; n++) {
        curlen = nextlen;
        nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

        if (++count < max_count && curlen === nextlen) {
          continue;

        } else if (count < min_count) {
          do { send_code(s, curlen, s.bl_tree); } while (--count !== 0);

        } else if (curlen !== 0) {
          if (curlen !== prevlen) {
            send_code(s, curlen, s.bl_tree);
            count--;
          }
          //Assert(count >= 3 && count <= 6, " 3_6?");
          send_code(s, REP_3_6, s.bl_tree);
          send_bits(s, count - 3, 2);

        } else if (count <= 10) {
          send_code(s, REPZ_3_10, s.bl_tree);
          send_bits(s, count - 3, 3);

        } else {
          send_code(s, REPZ_11_138, s.bl_tree);
          send_bits(s, count - 11, 7);
        }

        count = 0;
        prevlen = curlen;
        if (nextlen === 0) {
          max_count = 138;
          min_count = 3;

        } else if (curlen === nextlen) {
          max_count = 6;
          min_count = 3;

        } else {
          max_count = 7;
          min_count = 4;
        }
      }
    }


    /* ===========================================================================
     * Construct the Huffman tree for the bit lengths and return the index in
     * bl_order of the last bit length code to send.
     */
    function build_bl_tree(s) {
      var max_blindex;  /* index of last bit length code of non zero freq */

      /* Determine the bit length frequencies for literal and distance trees */
      scan_tree(s, s.dyn_ltree, s.l_desc.max_code);
      scan_tree(s, s.dyn_dtree, s.d_desc.max_code);

      /* Build the bit length tree: */
      build_tree(s, s.bl_desc);
      /* opt_len now includes the length of the tree representations, except
       * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
       */

      /* Determine the number of bit length codes to send. The pkzip format
       * requires that at least 4 bit length codes be sent. (appnote.txt says
       * 3 but the actual value used is 4.)
       */
      for (max_blindex = BL_CODES$1 - 1; max_blindex >= 3; max_blindex--) {
        if (s.bl_tree[bl_order[max_blindex] * 2 + 1]/*.Len*/ !== 0) {
          break;
        }
      }
      /* Update opt_len to include the bit length tree and counts */
      s.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;
      //Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
      //        s->opt_len, s->static_len));

      return max_blindex;
    }


    /* ===========================================================================
     * Send the header for a block using dynamic Huffman trees: the counts, the
     * lengths of the bit length codes, the literal tree and the distance tree.
     * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
     */
    function send_all_trees(s, lcodes, dcodes, blcodes)
    //    deflate_state *s;
    //    int lcodes, dcodes, blcodes; /* number of codes for each tree */
    {
      var rank;                    /* index in bl_order */

      //Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
      //Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
      //        "too many codes");
      //Tracev((stderr, "\nbl counts: "));
      send_bits(s, lcodes - 257, 5); /* not +255 as stated in appnote.txt */
      send_bits(s, dcodes - 1,   5);
      send_bits(s, blcodes - 4,  4); /* not -3 as stated in appnote.txt */
      for (rank = 0; rank < blcodes; rank++) {
        //Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
        send_bits(s, s.bl_tree[bl_order[rank] * 2 + 1]/*.Len*/, 3);
      }
      //Tracev((stderr, "\nbl tree: sent %ld", s->bits_sent));

      send_tree(s, s.dyn_ltree, lcodes - 1); /* literal tree */
      //Tracev((stderr, "\nlit tree: sent %ld", s->bits_sent));

      send_tree(s, s.dyn_dtree, dcodes - 1); /* distance tree */
      //Tracev((stderr, "\ndist tree: sent %ld", s->bits_sent));
    }


    /* ===========================================================================
     * Check if the data type is TEXT or BINARY, using the following algorithm:
     * - TEXT if the two conditions below are satisfied:
     *    a) There are no non-portable control characters belonging to the
     *       "black list" (0..6, 14..25, 28..31).
     *    b) There is at least one printable character belonging to the
     *       "white list" (9 {TAB}, 10 {LF}, 13 {CR}, 32..255).
     * - BINARY otherwise.
     * - The following partially-portable control characters form a
     *   "gray list" that is ignored in this detection algorithm:
     *   (7 {BEL}, 8 {BS}, 11 {VT}, 12 {FF}, 26 {SUB}, 27 {ESC}).
     * IN assertion: the fields Freq of dyn_ltree are set.
     */
    function detect_data_type(s) {
      /* black_mask is the bit mask of black-listed bytes
       * set bits 0..6, 14..25, and 28..31
       * 0xf3ffc07f = binary 11110011111111111100000001111111
       */
      var black_mask = 0xf3ffc07f;
      var n;

      /* Check for non-textual ("black-listed") bytes. */
      for (n = 0; n <= 31; n++, black_mask >>>= 1) {
        if ((black_mask & 1) && (s.dyn_ltree[n * 2]/*.Freq*/ !== 0)) {
          return Z_BINARY;
        }
      }

      /* Check for textual ("white-listed") bytes. */
      if (s.dyn_ltree[9 * 2]/*.Freq*/ !== 0 || s.dyn_ltree[10 * 2]/*.Freq*/ !== 0 ||
          s.dyn_ltree[13 * 2]/*.Freq*/ !== 0) {
        return Z_TEXT;
      }
      for (n = 32; n < LITERALS$1; n++) {
        if (s.dyn_ltree[n * 2]/*.Freq*/ !== 0) {
          return Z_TEXT;
        }
      }

      /* There are no "black-listed" or "white-listed" bytes:
       * this stream either is empty or has tolerated ("gray-listed") bytes only.
       */
      return Z_BINARY;
    }


    var static_init_done = false;

    /* ===========================================================================
     * Initialize the tree data structures for a new zlib stream.
     */
    function _tr_init(s)
    {

      if (!static_init_done) {
        tr_static_init();
        static_init_done = true;
      }

      s.l_desc  = new TreeDesc(s.dyn_ltree, static_l_desc);
      s.d_desc  = new TreeDesc(s.dyn_dtree, static_d_desc);
      s.bl_desc = new TreeDesc(s.bl_tree, static_bl_desc);

      s.bi_buf = 0;
      s.bi_valid = 0;

      /* Initialize the first block of the first file: */
      init_block(s);
    }


    /* ===========================================================================
     * Send a stored block
     */
    function _tr_stored_block(s, buf, stored_len, last)
    //DeflateState *s;
    //charf *buf;       /* input block */
    //ulg stored_len;   /* length of input block */
    //int last;         /* one if this is the last block for a file */
    {
      send_bits(s, (STORED_BLOCK << 1) + (last ? 1 : 0), 3);    /* send block type */
      copy_block(s, buf, stored_len, true); /* with header */
    }


    /* ===========================================================================
     * Send one empty static block to give enough lookahead for inflate.
     * This takes 10 bits, of which 7 may remain in the bit buffer.
     */
    function _tr_align(s) {
      send_bits(s, STATIC_TREES << 1, 3);
      send_code(s, END_BLOCK, static_ltree);
      bi_flush(s);
    }


    /* ===========================================================================
     * Determine the best encoding for the current block: dynamic trees, static
     * trees or store, and output the encoded block to the zip file.
     */
    function _tr_flush_block(s, buf, stored_len, last)
    //DeflateState *s;
    //charf *buf;       /* input block, or NULL if too old */
    //ulg stored_len;   /* length of input block */
    //int last;         /* one if this is the last block for a file */
    {
      var opt_lenb, static_lenb;  /* opt_len and static_len in bytes */
      var max_blindex = 0;        /* index of last bit length code of non zero freq */

      /* Build the Huffman trees unless a stored block is forced */
      if (s.level > 0) {

        /* Check if the file is binary or text */
        if (s.strm.data_type === Z_UNKNOWN$1) {
          s.strm.data_type = detect_data_type(s);
        }

        /* Construct the literal and distance trees */
        build_tree(s, s.l_desc);
        // Tracev((stderr, "\nlit data: dyn %ld, stat %ld", s->opt_len,
        //        s->static_len));

        build_tree(s, s.d_desc);
        // Tracev((stderr, "\ndist data: dyn %ld, stat %ld", s->opt_len,
        //        s->static_len));
        /* At this point, opt_len and static_len are the total bit lengths of
         * the compressed block data, excluding the tree representations.
         */

        /* Build the bit length tree for the above two trees, and get the index
         * in bl_order of the last bit length code to send.
         */
        max_blindex = build_bl_tree(s);

        /* Determine the best encoding. Compute the block lengths in bytes. */
        opt_lenb = (s.opt_len + 3 + 7) >>> 3;
        static_lenb = (s.static_len + 3 + 7) >>> 3;

        // Tracev((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u ",
        //        opt_lenb, s->opt_len, static_lenb, s->static_len, stored_len,
        //        s->last_lit));

        if (static_lenb <= opt_lenb) { opt_lenb = static_lenb; }

      } else {
        // Assert(buf != (char*)0, "lost buf");
        opt_lenb = static_lenb = stored_len + 5; /* force a stored block */
      }

      if ((stored_len + 4 <= opt_lenb) && (buf !== -1)) {
        /* 4: two words for the lengths */

        /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
         * Otherwise we can't have processed more than WSIZE input bytes since
         * the last block flush, because compression would have been
         * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
         * transform a block into a stored block.
         */
        _tr_stored_block(s, buf, stored_len, last);

      } else if (s.strategy === Z_FIXED$1 || static_lenb === opt_lenb) {

        send_bits(s, (STATIC_TREES << 1) + (last ? 1 : 0), 3);
        compress_block(s, static_ltree, static_dtree);

      } else {
        send_bits(s, (DYN_TREES << 1) + (last ? 1 : 0), 3);
        send_all_trees(s, s.l_desc.max_code + 1, s.d_desc.max_code + 1, max_blindex + 1);
        compress_block(s, s.dyn_ltree, s.dyn_dtree);
      }
      // Assert (s->compressed_len == s->bits_sent, "bad compressed size");
      /* The above check is made mod 2^32, for files larger than 512 MB
       * and uLong implemented on 32 bits.
       */
      init_block(s);

      if (last) {
        bi_windup(s);
      }
      // Tracev((stderr,"\ncomprlen %lu(%lu) ", s->compressed_len>>3,
      //       s->compressed_len-7*last));
    }

    /* ===========================================================================
     * Save the match info and tally the frequency counts. Return true if
     * the current block must be flushed.
     */
    function _tr_tally(s, dist, lc)
    //    deflate_state *s;
    //    unsigned dist;  /* distance of matched string */
    //    unsigned lc;    /* match length-MIN_MATCH or unmatched char (if dist==0) */
    {
      //var out_length, in_length, dcode;

      s.pending_buf[s.d_buf + s.last_lit * 2]     = (dist >>> 8) & 0xff;
      s.pending_buf[s.d_buf + s.last_lit * 2 + 1] = dist & 0xff;

      s.pending_buf[s.l_buf + s.last_lit] = lc & 0xff;
      s.last_lit++;

      if (dist === 0) {
        /* lc is the unmatched char */
        s.dyn_ltree[lc * 2]/*.Freq*/++;
      } else {
        s.matches++;
        /* Here, lc is the match length - MIN_MATCH */
        dist--;             /* dist = match distance - 1 */
        //Assert((ush)dist < (ush)MAX_DIST(s) &&
        //       (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
        //       (ush)d_code(dist) < (ush)D_CODES,  "_tr_tally: bad match");

        s.dyn_ltree[(_length_code[lc] + LITERALS$1 + 1) * 2]/*.Freq*/++;
        s.dyn_dtree[d_code(dist) * 2]/*.Freq*/++;
      }

    // (!) This block is disabled in zlib defaults,
    // don't enable it for binary compatibility

    //#ifdef TRUNCATE_BLOCK
    //  /* Try to guess if it is profitable to stop the current block here */
    //  if ((s.last_lit & 0x1fff) === 0 && s.level > 2) {
    //    /* Compute an upper bound for the compressed length */
    //    out_length = s.last_lit*8;
    //    in_length = s.strstart - s.block_start;
    //
    //    for (dcode = 0; dcode < D_CODES; dcode++) {
    //      out_length += s.dyn_dtree[dcode*2]/*.Freq*/ * (5 + extra_dbits[dcode]);
    //    }
    //    out_length >>>= 3;
    //    //Tracev((stderr,"\nlast_lit %u, in %ld, out ~%ld(%ld%%) ",
    //    //       s->last_lit, in_length, out_length,
    //    //       100L - out_length*100L/in_length));
    //    if (s.matches < (s.last_lit>>1)/*int /2*/ && out_length < (in_length>>1)/*int /2*/) {
    //      return true;
    //    }
    //  }
    //#endif

      return (s.last_lit === s.lit_bufsize - 1);
      /* We avoid equality with lit_bufsize because of wraparound at 64K
       * on 16 bit machines and because stored blocks are restricted to
       * 64K-1 bytes.
       */
    }

    var _tr_init_1  = _tr_init;
    var _tr_stored_block_1 = _tr_stored_block;
    var _tr_flush_block_1  = _tr_flush_block;
    var _tr_tally_1 = _tr_tally;
    var _tr_align_1 = _tr_align;

    var trees = {
    	_tr_init: _tr_init_1,
    	_tr_stored_block: _tr_stored_block_1,
    	_tr_flush_block: _tr_flush_block_1,
    	_tr_tally: _tr_tally_1,
    	_tr_align: _tr_align_1
    };

    // Note: adler32 takes 12% for level 0 and 2% for level 6.
    // It isn't worth it to make additional optimizations as in original.
    // Small size is preferable.

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    function adler32(adler, buf, len, pos) {
      var s1 = (adler & 0xffff) |0,
          s2 = ((adler >>> 16) & 0xffff) |0,
          n = 0;

      while (len !== 0) {
        // Set limit ~ twice less than 5552, to keep
        // s2 in 31-bits, because we force signed ints.
        // in other case %= will fail.
        n = len > 2000 ? 2000 : len;
        len -= n;

        do {
          s1 = (s1 + buf[pos++]) |0;
          s2 = (s2 + s1) |0;
        } while (--n);

        s1 %= 65521;
        s2 %= 65521;
      }

      return (s1 | (s2 << 16)) |0;
    }


    var adler32_1 = adler32;

    // Note: we can't get significant speed boost here.
    // So write code to minimize size - no pregenerated tables
    // and array tools dependencies.

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    // Use ordinary array, since untyped makes no boost here
    function makeTable() {
      var c, table = [];

      for (var n = 0; n < 256; n++) {
        c = n;
        for (var k = 0; k < 8; k++) {
          c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
        }
        table[n] = c;
      }

      return table;
    }

    // Create table on load. Just 255 signed longs. Not a problem.
    var crcTable = makeTable();


    function crc32$1(crc, buf, len, pos) {
      var t = crcTable,
          end = pos + len;

      crc ^= -1;

      for (var i = pos; i < end; i++) {
        crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
      }

      return (crc ^ (-1)); // >>> 0;
    }


    var crc32_1 = crc32$1;

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    var messages = {
      2:      'need dictionary',     /* Z_NEED_DICT       2  */
      1:      'stream end',          /* Z_STREAM_END      1  */
      0:      '',                    /* Z_OK              0  */
      '-1':   'file error',          /* Z_ERRNO         (-1) */
      '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
      '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
      '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
      '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
      '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
    };

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.







    /* Public constants ==========================================================*/
    /* ===========================================================================*/


    /* Allowed flush values; see deflate() and inflate() below for details */
    var Z_NO_FLUSH$1      = 0;
    var Z_PARTIAL_FLUSH = 1;
    //var Z_SYNC_FLUSH    = 2;
    var Z_FULL_FLUSH    = 3;
    var Z_FINISH$2        = 4;
    var Z_BLOCK$1         = 5;
    //var Z_TREES         = 6;


    /* Return codes for the compression/decompression functions. Negative values
     * are errors, positive values are used for special but normal events.
     */
    var Z_OK$2            = 0;
    var Z_STREAM_END$2    = 1;
    //var Z_NEED_DICT     = 2;
    //var Z_ERRNO         = -1;
    var Z_STREAM_ERROR$1  = -2;
    var Z_DATA_ERROR$1    = -3;
    //var Z_MEM_ERROR     = -4;
    var Z_BUF_ERROR$1     = -5;
    //var Z_VERSION_ERROR = -6;


    /* compression levels */
    //var Z_NO_COMPRESSION      = 0;
    //var Z_BEST_SPEED          = 1;
    //var Z_BEST_COMPRESSION    = 9;
    var Z_DEFAULT_COMPRESSION$1 = -1;


    var Z_FILTERED            = 1;
    var Z_HUFFMAN_ONLY        = 2;
    var Z_RLE                 = 3;
    var Z_FIXED               = 4;
    var Z_DEFAULT_STRATEGY$1    = 0;

    /* Possible values of the data_type field (though see inflate()) */
    //var Z_BINARY              = 0;
    //var Z_TEXT                = 1;
    //var Z_ASCII               = 1; // = Z_TEXT
    var Z_UNKNOWN             = 2;


    /* The deflate compression method */
    var Z_DEFLATED$2  = 8;

    /*============================================================================*/


    var MAX_MEM_LEVEL = 9;
    /* Maximum value for memLevel in deflateInit2 */
    var MAX_WBITS$1 = 15;
    /* 32K LZ77 window */
    var DEF_MEM_LEVEL = 8;


    var LENGTH_CODES  = 29;
    /* number of length codes, not counting the special END_BLOCK code */
    var LITERALS      = 256;
    /* number of literal bytes 0..255 */
    var L_CODES       = LITERALS + 1 + LENGTH_CODES;
    /* number of Literal or Length codes, including the END_BLOCK code */
    var D_CODES       = 30;
    /* number of distance codes */
    var BL_CODES      = 19;
    /* number of codes used to transfer the bit lengths */
    var HEAP_SIZE     = 2 * L_CODES + 1;
    /* maximum heap size */
    var MAX_BITS  = 15;
    /* All codes must not exceed MAX_BITS bits */

    var MIN_MATCH = 3;
    var MAX_MATCH = 258;
    var MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

    var PRESET_DICT = 0x20;

    var INIT_STATE = 42;
    var EXTRA_STATE = 69;
    var NAME_STATE = 73;
    var COMMENT_STATE = 91;
    var HCRC_STATE = 103;
    var BUSY_STATE = 113;
    var FINISH_STATE = 666;

    var BS_NEED_MORE      = 1; /* block not completed, need more input or more output */
    var BS_BLOCK_DONE     = 2; /* block flush performed */
    var BS_FINISH_STARTED = 3; /* finish started, need only more output at next deflate */
    var BS_FINISH_DONE    = 4; /* finish done, accept no more input or output */

    var OS_CODE = 0x03; // Unix :) . Don't detect, use this default.

    function err(strm, errorCode) {
      strm.msg = messages[errorCode];
      return errorCode;
    }

    function rank(f) {
      return ((f) << 1) - ((f) > 4 ? 9 : 0);
    }

    function zero(buf) { var len = buf.length; while (--len >= 0) { buf[len] = 0; } }


    /* =========================================================================
     * Flush as much pending output as possible. All deflate() output goes
     * through this function so some applications may wish to modify it
     * to avoid allocating a large strm->output buffer and copying into it.
     * (See also read_buf()).
     */
    function flush_pending(strm) {
      var s = strm.state;

      //_tr_flush_bits(s);
      var len = s.pending;
      if (len > strm.avail_out) {
        len = strm.avail_out;
      }
      if (len === 0) { return; }

      common.arraySet(strm.output, s.pending_buf, s.pending_out, len, strm.next_out);
      strm.next_out += len;
      s.pending_out += len;
      strm.total_out += len;
      strm.avail_out -= len;
      s.pending -= len;
      if (s.pending === 0) {
        s.pending_out = 0;
      }
    }


    function flush_block_only(s, last) {
      trees._tr_flush_block(s, (s.block_start >= 0 ? s.block_start : -1), s.strstart - s.block_start, last);
      s.block_start = s.strstart;
      flush_pending(s.strm);
    }


    function put_byte(s, b) {
      s.pending_buf[s.pending++] = b;
    }


    /* =========================================================================
     * Put a short in the pending buffer. The 16-bit value is put in MSB order.
     * IN assertion: the stream state is correct and there is enough room in
     * pending_buf.
     */
    function putShortMSB(s, b) {
    //  put_byte(s, (Byte)(b >> 8));
    //  put_byte(s, (Byte)(b & 0xff));
      s.pending_buf[s.pending++] = (b >>> 8) & 0xff;
      s.pending_buf[s.pending++] = b & 0xff;
    }


    /* ===========================================================================
     * Read a new buffer from the current input stream, update the adler32
     * and total number of bytes read.  All deflate() input goes through
     * this function so some applications may wish to modify it to avoid
     * allocating a large strm->input buffer and copying from it.
     * (See also flush_pending()).
     */
    function read_buf(strm, buf, start, size) {
      var len = strm.avail_in;

      if (len > size) { len = size; }
      if (len === 0) { return 0; }

      strm.avail_in -= len;

      // zmemcpy(buf, strm->next_in, len);
      common.arraySet(buf, strm.input, strm.next_in, len, start);
      if (strm.state.wrap === 1) {
        strm.adler = adler32_1(strm.adler, buf, len, start);
      }

      else if (strm.state.wrap === 2) {
        strm.adler = crc32_1(strm.adler, buf, len, start);
      }

      strm.next_in += len;
      strm.total_in += len;

      return len;
    }


    /* ===========================================================================
     * Set match_start to the longest match starting at the given string and
     * return its length. Matches shorter or equal to prev_length are discarded,
     * in which case the result is equal to prev_length and match_start is
     * garbage.
     * IN assertions: cur_match is the head of the hash chain for the current
     *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
     * OUT assertion: the match length is not greater than s->lookahead.
     */
    function longest_match(s, cur_match) {
      var chain_length = s.max_chain_length;      /* max hash chain length */
      var scan = s.strstart; /* current string */
      var match;                       /* matched string */
      var len;                           /* length of current match */
      var best_len = s.prev_length;              /* best match length so far */
      var nice_match = s.nice_match;             /* stop if match long enough */
      var limit = (s.strstart > (s.w_size - MIN_LOOKAHEAD)) ?
          s.strstart - (s.w_size - MIN_LOOKAHEAD) : 0/*NIL*/;

      var _win = s.window; // shortcut

      var wmask = s.w_mask;
      var prev  = s.prev;

      /* Stop when cur_match becomes <= limit. To simplify the code,
       * we prevent matches with the string of window index 0.
       */

      var strend = s.strstart + MAX_MATCH;
      var scan_end1  = _win[scan + best_len - 1];
      var scan_end   = _win[scan + best_len];

      /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
       * It is easy to get rid of this optimization if necessary.
       */
      // Assert(s->hash_bits >= 8 && MAX_MATCH == 258, "Code too clever");

      /* Do not waste too much time if we already have a good match: */
      if (s.prev_length >= s.good_match) {
        chain_length >>= 2;
      }
      /* Do not look for matches beyond the end of the input. This is necessary
       * to make deflate deterministic.
       */
      if (nice_match > s.lookahead) { nice_match = s.lookahead; }

      // Assert((ulg)s->strstart <= s->window_size-MIN_LOOKAHEAD, "need lookahead");

      do {
        // Assert(cur_match < s->strstart, "no future");
        match = cur_match;

        /* Skip to next match if the match length cannot increase
         * or if the match length is less than 2.  Note that the checks below
         * for insufficient lookahead only occur occasionally for performance
         * reasons.  Therefore uninitialized memory will be accessed, and
         * conditional jumps will be made that depend on those values.
         * However the length of the match is limited to the lookahead, so
         * the output of deflate is not affected by the uninitialized values.
         */

        if (_win[match + best_len]     !== scan_end  ||
            _win[match + best_len - 1] !== scan_end1 ||
            _win[match]                !== _win[scan] ||
            _win[++match]              !== _win[scan + 1]) {
          continue;
        }

        /* The check at best_len-1 can be removed because it will be made
         * again later. (This heuristic is not always a win.)
         * It is not necessary to compare scan[2] and match[2] since they
         * are always equal when the other bytes match, given that
         * the hash keys are equal and that HASH_BITS >= 8.
         */
        scan += 2;
        match++;
        // Assert(*scan == *match, "match[2]?");

        /* We check for insufficient lookahead only every 8th comparison;
         * the 256th check will be made at strstart+258.
         */
        do {
          /*jshint noempty:false*/
        } while (_win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                 _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                 _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                 _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
                 scan < strend);

        // Assert(scan <= s->window+(unsigned)(s->window_size-1), "wild scan");

        len = MAX_MATCH - (strend - scan);
        scan = strend - MAX_MATCH;

        if (len > best_len) {
          s.match_start = cur_match;
          best_len = len;
          if (len >= nice_match) {
            break;
          }
          scan_end1  = _win[scan + best_len - 1];
          scan_end   = _win[scan + best_len];
        }
      } while ((cur_match = prev[cur_match & wmask]) > limit && --chain_length !== 0);

      if (best_len <= s.lookahead) {
        return best_len;
      }
      return s.lookahead;
    }


    /* ===========================================================================
     * Fill the window when the lookahead becomes insufficient.
     * Updates strstart and lookahead.
     *
     * IN assertion: lookahead < MIN_LOOKAHEAD
     * OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
     *    At least one byte has been read, or avail_in == 0; reads are
     *    performed for at least two bytes (required for the zip translate_eol
     *    option -- not supported here).
     */
    function fill_window(s) {
      var _w_size = s.w_size;
      var p, n, m, more, str;

      //Assert(s->lookahead < MIN_LOOKAHEAD, "already enough lookahead");

      do {
        more = s.window_size - s.lookahead - s.strstart;

        // JS ints have 32 bit, block below not needed
        /* Deal with !@#$% 64K limit: */
        //if (sizeof(int) <= 2) {
        //    if (more == 0 && s->strstart == 0 && s->lookahead == 0) {
        //        more = wsize;
        //
        //  } else if (more == (unsigned)(-1)) {
        //        /* Very unlikely, but possible on 16 bit machine if
        //         * strstart == 0 && lookahead == 1 (input done a byte at time)
        //         */
        //        more--;
        //    }
        //}


        /* If the window is almost full and there is insufficient lookahead,
         * move the upper half to the lower one to make room in the upper half.
         */
        if (s.strstart >= _w_size + (_w_size - MIN_LOOKAHEAD)) {

          common.arraySet(s.window, s.window, _w_size, _w_size, 0);
          s.match_start -= _w_size;
          s.strstart -= _w_size;
          /* we now have strstart >= MAX_DIST */
          s.block_start -= _w_size;

          /* Slide the hash table (could be avoided with 32 bit values
           at the expense of memory usage). We slide even when level == 0
           to keep the hash table consistent if we switch back to level > 0
           later. (Using level 0 permanently is not an optimal usage of
           zlib, so we don't care about this pathological case.)
           */

          n = s.hash_size;
          p = n;
          do {
            m = s.head[--p];
            s.head[p] = (m >= _w_size ? m - _w_size : 0);
          } while (--n);

          n = _w_size;
          p = n;
          do {
            m = s.prev[--p];
            s.prev[p] = (m >= _w_size ? m - _w_size : 0);
            /* If n is not on any hash chain, prev[n] is garbage but
             * its value will never be used.
             */
          } while (--n);

          more += _w_size;
        }
        if (s.strm.avail_in === 0) {
          break;
        }

        /* If there was no sliding:
         *    strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
         *    more == window_size - lookahead - strstart
         * => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
         * => more >= window_size - 2*WSIZE + 2
         * In the BIG_MEM or MMAP case (not yet supported),
         *   window_size == input_size + MIN_LOOKAHEAD  &&
         *   strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
         * Otherwise, window_size == 2*WSIZE so more >= 2.
         * If there was sliding, more >= WSIZE. So in all cases, more >= 2.
         */
        //Assert(more >= 2, "more < 2");
        n = read_buf(s.strm, s.window, s.strstart + s.lookahead, more);
        s.lookahead += n;

        /* Initialize the hash value now that we have some input: */
        if (s.lookahead + s.insert >= MIN_MATCH) {
          str = s.strstart - s.insert;
          s.ins_h = s.window[str];

          /* UPDATE_HASH(s, s->ins_h, s->window[str + 1]); */
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + 1]) & s.hash_mask;
    //#if MIN_MATCH != 3
    //        Call update_hash() MIN_MATCH-3 more times
    //#endif
          while (s.insert) {
            /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
            s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

            s.prev[str & s.w_mask] = s.head[s.ins_h];
            s.head[s.ins_h] = str;
            str++;
            s.insert--;
            if (s.lookahead + s.insert < MIN_MATCH) {
              break;
            }
          }
        }
        /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
         * but this is not important since only literal bytes will be emitted.
         */

      } while (s.lookahead < MIN_LOOKAHEAD && s.strm.avail_in !== 0);

      /* If the WIN_INIT bytes after the end of the current data have never been
       * written, then zero those bytes in order to avoid memory check reports of
       * the use of uninitialized (or uninitialised as Julian writes) bytes by
       * the longest match routines.  Update the high water mark for the next
       * time through here.  WIN_INIT is set to MAX_MATCH since the longest match
       * routines allow scanning to strstart + MAX_MATCH, ignoring lookahead.
       */
    //  if (s.high_water < s.window_size) {
    //    var curr = s.strstart + s.lookahead;
    //    var init = 0;
    //
    //    if (s.high_water < curr) {
    //      /* Previous high water mark below current data -- zero WIN_INIT
    //       * bytes or up to end of window, whichever is less.
    //       */
    //      init = s.window_size - curr;
    //      if (init > WIN_INIT)
    //        init = WIN_INIT;
    //      zmemzero(s->window + curr, (unsigned)init);
    //      s->high_water = curr + init;
    //    }
    //    else if (s->high_water < (ulg)curr + WIN_INIT) {
    //      /* High water mark at or above current data, but below current data
    //       * plus WIN_INIT -- zero out to current data plus WIN_INIT, or up
    //       * to end of window, whichever is less.
    //       */
    //      init = (ulg)curr + WIN_INIT - s->high_water;
    //      if (init > s->window_size - s->high_water)
    //        init = s->window_size - s->high_water;
    //      zmemzero(s->window + s->high_water, (unsigned)init);
    //      s->high_water += init;
    //    }
    //  }
    //
    //  Assert((ulg)s->strstart <= s->window_size - MIN_LOOKAHEAD,
    //    "not enough room for search");
    }

    /* ===========================================================================
     * Copy without compression as much as possible from the input stream, return
     * the current block state.
     * This function does not insert new strings in the dictionary since
     * uncompressible data is probably not useful. This function is used
     * only for the level=0 compression option.
     * NOTE: this function should be optimized to avoid extra copying from
     * window to pending_buf.
     */
    function deflate_stored(s, flush) {
      /* Stored blocks are limited to 0xffff bytes, pending_buf is limited
       * to pending_buf_size, and each stored block has a 5 byte header:
       */
      var max_block_size = 0xffff;

      if (max_block_size > s.pending_buf_size - 5) {
        max_block_size = s.pending_buf_size - 5;
      }

      /* Copy as much as possible from input to output: */
      for (;;) {
        /* Fill the window as much as possible: */
        if (s.lookahead <= 1) {

          //Assert(s->strstart < s->w_size+MAX_DIST(s) ||
          //  s->block_start >= (long)s->w_size, "slide too late");
    //      if (!(s.strstart < s.w_size + (s.w_size - MIN_LOOKAHEAD) ||
    //        s.block_start >= s.w_size)) {
    //        throw  new Error("slide too late");
    //      }

          fill_window(s);
          if (s.lookahead === 0 && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }

          if (s.lookahead === 0) {
            break;
          }
          /* flush the current block */
        }
        //Assert(s->block_start >= 0L, "block gone");
    //    if (s.block_start < 0) throw new Error("block gone");

        s.strstart += s.lookahead;
        s.lookahead = 0;

        /* Emit a stored block if pending_buf will be full: */
        var max_start = s.block_start + max_block_size;

        if (s.strstart === 0 || s.strstart >= max_start) {
          /* strstart == 0 is possible when wraparound on 16-bit machine */
          s.lookahead = s.strstart - max_start;
          s.strstart = max_start;
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/


        }
        /* Flush if we may have to slide, otherwise block_start may become
         * negative and the data will be gone:
         */
        if (s.strstart - s.block_start >= (s.w_size - MIN_LOOKAHEAD)) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }

      s.insert = 0;

      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }

      if (s.strstart > s.block_start) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }

      return BS_NEED_MORE;
    }

    /* ===========================================================================
     * Compress as much as possible from the input stream, return the current
     * block state.
     * This function does not perform lazy evaluation of matches and inserts
     * new strings in the dictionary only for unmatched strings or for short
     * matches. It is used only for the fast compression options.
     */
    function deflate_fast(s, flush) {
      var hash_head;        /* head of the hash chain */
      var bflush;           /* set if current block must be flushed */

      for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the next match, plus MIN_MATCH bytes to insert the
         * string following the next match.
         */
        if (s.lookahead < MIN_LOOKAHEAD) {
          fill_window(s);
          if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }
          if (s.lookahead === 0) {
            break; /* flush the current block */
          }
        }

        /* Insert the string window[strstart .. strstart+2] in the
         * dictionary, and set hash_head to the head of the hash chain:
         */
        hash_head = 0/*NIL*/;
        if (s.lookahead >= MIN_MATCH) {
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
        }

        /* Find the longest match, discarding those <= prev_length.
         * At this point we have always match_length < MIN_MATCH
         */
        if (hash_head !== 0/*NIL*/ && ((s.strstart - hash_head) <= (s.w_size - MIN_LOOKAHEAD))) {
          /* To simplify the code, we prevent matches with the string
           * of window index 0 (in particular we have to avoid a match
           * of the string with itself at the start of the input file).
           */
          s.match_length = longest_match(s, hash_head);
          /* longest_match() sets match_start */
        }
        if (s.match_length >= MIN_MATCH) {
          // check_match(s, s.strstart, s.match_start, s.match_length); // for debug only

          /*** _tr_tally_dist(s, s.strstart - s.match_start,
                         s.match_length - MIN_MATCH, bflush); ***/
          bflush = trees._tr_tally(s, s.strstart - s.match_start, s.match_length - MIN_MATCH);

          s.lookahead -= s.match_length;

          /* Insert new strings in the hash table only if the match length
           * is not too large. This saves time but degrades compression.
           */
          if (s.match_length <= s.max_lazy_match/*max_insert_length*/ && s.lookahead >= MIN_MATCH) {
            s.match_length--; /* string at strstart already in table */
            do {
              s.strstart++;
              /*** INSERT_STRING(s, s.strstart, hash_head); ***/
              s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
              hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
              s.head[s.ins_h] = s.strstart;
              /***/
              /* strstart never exceeds WSIZE-MAX_MATCH, so there are
               * always MIN_MATCH bytes ahead.
               */
            } while (--s.match_length !== 0);
            s.strstart++;
          } else
          {
            s.strstart += s.match_length;
            s.match_length = 0;
            s.ins_h = s.window[s.strstart];
            /* UPDATE_HASH(s, s.ins_h, s.window[s.strstart+1]); */
            s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + 1]) & s.hash_mask;

    //#if MIN_MATCH != 3
    //                Call UPDATE_HASH() MIN_MATCH-3 more times
    //#endif
            /* If lookahead < MIN_MATCH, ins_h is garbage, but it does not
             * matter since it will be recomputed at next deflate call.
             */
          }
        } else {
          /* No match, output a literal byte */
          //Tracevv((stderr,"%c", s.window[s.strstart]));
          /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
          bflush = trees._tr_tally(s, 0, s.window[s.strstart]);

          s.lookahead--;
          s.strstart++;
        }
        if (bflush) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }
      s.insert = ((s.strstart < (MIN_MATCH - 1)) ? s.strstart : MIN_MATCH - 1);
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
      return BS_BLOCK_DONE;
    }

    /* ===========================================================================
     * Same as above, but achieves better compression. We use a lazy
     * evaluation for matches: a match is finally adopted only if there is
     * no better match at the next window position.
     */
    function deflate_slow(s, flush) {
      var hash_head;          /* head of hash chain */
      var bflush;              /* set if current block must be flushed */

      var max_insert;

      /* Process the input block. */
      for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the next match, plus MIN_MATCH bytes to insert the
         * string following the next match.
         */
        if (s.lookahead < MIN_LOOKAHEAD) {
          fill_window(s);
          if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }
          if (s.lookahead === 0) { break; } /* flush the current block */
        }

        /* Insert the string window[strstart .. strstart+2] in the
         * dictionary, and set hash_head to the head of the hash chain:
         */
        hash_head = 0/*NIL*/;
        if (s.lookahead >= MIN_MATCH) {
          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
          s.head[s.ins_h] = s.strstart;
          /***/
        }

        /* Find the longest match, discarding those <= prev_length.
         */
        s.prev_length = s.match_length;
        s.prev_match = s.match_start;
        s.match_length = MIN_MATCH - 1;

        if (hash_head !== 0/*NIL*/ && s.prev_length < s.max_lazy_match &&
            s.strstart - hash_head <= (s.w_size - MIN_LOOKAHEAD)/*MAX_DIST(s)*/) {
          /* To simplify the code, we prevent matches with the string
           * of window index 0 (in particular we have to avoid a match
           * of the string with itself at the start of the input file).
           */
          s.match_length = longest_match(s, hash_head);
          /* longest_match() sets match_start */

          if (s.match_length <= 5 &&
             (s.strategy === Z_FILTERED || (s.match_length === MIN_MATCH && s.strstart - s.match_start > 4096/*TOO_FAR*/))) {

            /* If prev_match is also MIN_MATCH, match_start is garbage
             * but we will ignore the current match anyway.
             */
            s.match_length = MIN_MATCH - 1;
          }
        }
        /* If there was a match at the previous step and the current
         * match is not better, output the previous match:
         */
        if (s.prev_length >= MIN_MATCH && s.match_length <= s.prev_length) {
          max_insert = s.strstart + s.lookahead - MIN_MATCH;
          /* Do not insert strings in hash table beyond this. */

          //check_match(s, s.strstart-1, s.prev_match, s.prev_length);

          /***_tr_tally_dist(s, s.strstart - 1 - s.prev_match,
                         s.prev_length - MIN_MATCH, bflush);***/
          bflush = trees._tr_tally(s, s.strstart - 1 - s.prev_match, s.prev_length - MIN_MATCH);
          /* Insert in hash table all strings up to the end of the match.
           * strstart-1 and strstart are already inserted. If there is not
           * enough lookahead, the last two strings are not inserted in
           * the hash table.
           */
          s.lookahead -= s.prev_length - 1;
          s.prev_length -= 2;
          do {
            if (++s.strstart <= max_insert) {
              /*** INSERT_STRING(s, s.strstart, hash_head); ***/
              s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[s.strstart + MIN_MATCH - 1]) & s.hash_mask;
              hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
              s.head[s.ins_h] = s.strstart;
              /***/
            }
          } while (--s.prev_length !== 0);
          s.match_available = 0;
          s.match_length = MIN_MATCH - 1;
          s.strstart++;

          if (bflush) {
            /*** FLUSH_BLOCK(s, 0); ***/
            flush_block_only(s, false);
            if (s.strm.avail_out === 0) {
              return BS_NEED_MORE;
            }
            /***/
          }

        } else if (s.match_available) {
          /* If there was no match at the previous position, output a
           * single literal. If there was a match but the current match
           * is longer, truncate the previous match to a single literal.
           */
          //Tracevv((stderr,"%c", s->window[s->strstart-1]));
          /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
          bflush = trees._tr_tally(s, 0, s.window[s.strstart - 1]);

          if (bflush) {
            /*** FLUSH_BLOCK_ONLY(s, 0) ***/
            flush_block_only(s, false);
            /***/
          }
          s.strstart++;
          s.lookahead--;
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
        } else {
          /* There is no previous match to compare with, wait for
           * the next step to decide.
           */
          s.match_available = 1;
          s.strstart++;
          s.lookahead--;
        }
      }
      //Assert (flush != Z_NO_FLUSH, "no flush?");
      if (s.match_available) {
        //Tracevv((stderr,"%c", s->window[s->strstart-1]));
        /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
        bflush = trees._tr_tally(s, 0, s.window[s.strstart - 1]);

        s.match_available = 0;
      }
      s.insert = s.strstart < MIN_MATCH - 1 ? s.strstart : MIN_MATCH - 1;
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }

      return BS_BLOCK_DONE;
    }


    /* ===========================================================================
     * For Z_RLE, simply look for runs of bytes, generate matches only of distance
     * one.  Do not maintain a hash table.  (It will be regenerated if this run of
     * deflate switches away from Z_RLE.)
     */
    function deflate_rle(s, flush) {
      var bflush;            /* set if current block must be flushed */
      var prev;              /* byte at distance one to match */
      var scan, strend;      /* scan goes up to strend for length of run */

      var _win = s.window;

      for (;;) {
        /* Make sure that we always have enough lookahead, except
         * at the end of the input file. We need MAX_MATCH bytes
         * for the longest run, plus one for the unrolled loop.
         */
        if (s.lookahead <= MAX_MATCH) {
          fill_window(s);
          if (s.lookahead <= MAX_MATCH && flush === Z_NO_FLUSH$1) {
            return BS_NEED_MORE;
          }
          if (s.lookahead === 0) { break; } /* flush the current block */
        }

        /* See how many times the previous byte repeats */
        s.match_length = 0;
        if (s.lookahead >= MIN_MATCH && s.strstart > 0) {
          scan = s.strstart - 1;
          prev = _win[scan];
          if (prev === _win[++scan] && prev === _win[++scan] && prev === _win[++scan]) {
            strend = s.strstart + MAX_MATCH;
            do {
              /*jshint noempty:false*/
            } while (prev === _win[++scan] && prev === _win[++scan] &&
                     prev === _win[++scan] && prev === _win[++scan] &&
                     prev === _win[++scan] && prev === _win[++scan] &&
                     prev === _win[++scan] && prev === _win[++scan] &&
                     scan < strend);
            s.match_length = MAX_MATCH - (strend - scan);
            if (s.match_length > s.lookahead) {
              s.match_length = s.lookahead;
            }
          }
          //Assert(scan <= s->window+(uInt)(s->window_size-1), "wild scan");
        }

        /* Emit match if have run of MIN_MATCH or longer, else emit literal */
        if (s.match_length >= MIN_MATCH) {
          //check_match(s, s.strstart, s.strstart - 1, s.match_length);

          /*** _tr_tally_dist(s, 1, s.match_length - MIN_MATCH, bflush); ***/
          bflush = trees._tr_tally(s, 1, s.match_length - MIN_MATCH);

          s.lookahead -= s.match_length;
          s.strstart += s.match_length;
          s.match_length = 0;
        } else {
          /* No match, output a literal byte */
          //Tracevv((stderr,"%c", s->window[s->strstart]));
          /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
          bflush = trees._tr_tally(s, 0, s.window[s.strstart]);

          s.lookahead--;
          s.strstart++;
        }
        if (bflush) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }
      s.insert = 0;
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
      return BS_BLOCK_DONE;
    }

    /* ===========================================================================
     * For Z_HUFFMAN_ONLY, do not look for matches.  Do not maintain a hash table.
     * (It will be regenerated if this run of deflate switches away from Huffman.)
     */
    function deflate_huff(s, flush) {
      var bflush;             /* set if current block must be flushed */

      for (;;) {
        /* Make sure that we have a literal to write. */
        if (s.lookahead === 0) {
          fill_window(s);
          if (s.lookahead === 0) {
            if (flush === Z_NO_FLUSH$1) {
              return BS_NEED_MORE;
            }
            break;      /* flush the current block */
          }
        }

        /* Output a literal byte */
        s.match_length = 0;
        //Tracevv((stderr,"%c", s->window[s->strstart]));
        /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
        bflush = trees._tr_tally(s, 0, s.window[s.strstart]);
        s.lookahead--;
        s.strstart++;
        if (bflush) {
          /*** FLUSH_BLOCK(s, 0); ***/
          flush_block_only(s, false);
          if (s.strm.avail_out === 0) {
            return BS_NEED_MORE;
          }
          /***/
        }
      }
      s.insert = 0;
      if (flush === Z_FINISH$2) {
        /*** FLUSH_BLOCK(s, 1); ***/
        flush_block_only(s, true);
        if (s.strm.avail_out === 0) {
          return BS_FINISH_STARTED;
        }
        /***/
        return BS_FINISH_DONE;
      }
      if (s.last_lit) {
        /*** FLUSH_BLOCK(s, 0); ***/
        flush_block_only(s, false);
        if (s.strm.avail_out === 0) {
          return BS_NEED_MORE;
        }
        /***/
      }
      return BS_BLOCK_DONE;
    }

    /* Values for max_lazy_match, good_match and max_chain_length, depending on
     * the desired pack level (0..9). The values given below have been tuned to
     * exclude worst case performance for pathological files. Better values may be
     * found for specific files.
     */
    function Config(good_length, max_lazy, nice_length, max_chain, func) {
      this.good_length = good_length;
      this.max_lazy = max_lazy;
      this.nice_length = nice_length;
      this.max_chain = max_chain;
      this.func = func;
    }

    var configuration_table;

    configuration_table = [
      /*      good lazy nice chain */
      new Config(0, 0, 0, 0, deflate_stored),          /* 0 store only */
      new Config(4, 4, 8, 4, deflate_fast),            /* 1 max speed, no lazy matches */
      new Config(4, 5, 16, 8, deflate_fast),           /* 2 */
      new Config(4, 6, 32, 32, deflate_fast),          /* 3 */

      new Config(4, 4, 16, 16, deflate_slow),          /* 4 lazy matches */
      new Config(8, 16, 32, 32, deflate_slow),         /* 5 */
      new Config(8, 16, 128, 128, deflate_slow),       /* 6 */
      new Config(8, 32, 128, 256, deflate_slow),       /* 7 */
      new Config(32, 128, 258, 1024, deflate_slow),    /* 8 */
      new Config(32, 258, 258, 4096, deflate_slow)     /* 9 max compression */
    ];


    /* ===========================================================================
     * Initialize the "longest match" routines for a new zlib stream
     */
    function lm_init(s) {
      s.window_size = 2 * s.w_size;

      /*** CLEAR_HASH(s); ***/
      zero(s.head); // Fill with NIL (= 0);

      /* Set the default configuration parameters:
       */
      s.max_lazy_match = configuration_table[s.level].max_lazy;
      s.good_match = configuration_table[s.level].good_length;
      s.nice_match = configuration_table[s.level].nice_length;
      s.max_chain_length = configuration_table[s.level].max_chain;

      s.strstart = 0;
      s.block_start = 0;
      s.lookahead = 0;
      s.insert = 0;
      s.match_length = s.prev_length = MIN_MATCH - 1;
      s.match_available = 0;
      s.ins_h = 0;
    }


    function DeflateState() {
      this.strm = null;            /* pointer back to this zlib stream */
      this.status = 0;            /* as the name implies */
      this.pending_buf = null;      /* output still pending */
      this.pending_buf_size = 0;  /* size of pending_buf */
      this.pending_out = 0;       /* next pending byte to output to the stream */
      this.pending = 0;           /* nb of bytes in the pending buffer */
      this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
      this.gzhead = null;         /* gzip header information to write */
      this.gzindex = 0;           /* where in extra, name, or comment */
      this.method = Z_DEFLATED$2; /* can only be DEFLATED */
      this.last_flush = -1;   /* value of flush param for previous deflate call */

      this.w_size = 0;  /* LZ77 window size (32K by default) */
      this.w_bits = 0;  /* log2(w_size)  (8..16) */
      this.w_mask = 0;  /* w_size - 1 */

      this.window = null;
      /* Sliding window. Input bytes are read into the second half of the window,
       * and move to the first half later to keep a dictionary of at least wSize
       * bytes. With this organization, matches are limited to a distance of
       * wSize-MAX_MATCH bytes, but this ensures that IO is always
       * performed with a length multiple of the block size.
       */

      this.window_size = 0;
      /* Actual size of window: 2*wSize, except when the user input buffer
       * is directly used as sliding window.
       */

      this.prev = null;
      /* Link to older string with same hash index. To limit the size of this
       * array to 64K, this link is maintained only for the last 32K strings.
       * An index in this array is thus a window index modulo 32K.
       */

      this.head = null;   /* Heads of the hash chains or NIL. */

      this.ins_h = 0;       /* hash index of string to be inserted */
      this.hash_size = 0;   /* number of elements in hash table */
      this.hash_bits = 0;   /* log2(hash_size) */
      this.hash_mask = 0;   /* hash_size-1 */

      this.hash_shift = 0;
      /* Number of bits by which ins_h must be shifted at each input
       * step. It must be such that after MIN_MATCH steps, the oldest
       * byte no longer takes part in the hash key, that is:
       *   hash_shift * MIN_MATCH >= hash_bits
       */

      this.block_start = 0;
      /* Window position at the beginning of the current output block. Gets
       * negative when the window is moved backwards.
       */

      this.match_length = 0;      /* length of best match */
      this.prev_match = 0;        /* previous match */
      this.match_available = 0;   /* set if previous match exists */
      this.strstart = 0;          /* start of string to insert */
      this.match_start = 0;       /* start of matching string */
      this.lookahead = 0;         /* number of valid bytes ahead in window */

      this.prev_length = 0;
      /* Length of the best match at previous step. Matches not greater than this
       * are discarded. This is used in the lazy match evaluation.
       */

      this.max_chain_length = 0;
      /* To speed up deflation, hash chains are never searched beyond this
       * length.  A higher limit improves compression ratio but degrades the
       * speed.
       */

      this.max_lazy_match = 0;
      /* Attempt to find a better match only when the current match is strictly
       * smaller than this value. This mechanism is used only for compression
       * levels >= 4.
       */
      // That's alias to max_lazy_match, don't use directly
      //this.max_insert_length = 0;
      /* Insert new strings in the hash table only if the match length is not
       * greater than this length. This saves time but degrades compression.
       * max_insert_length is used only for compression levels <= 3.
       */

      this.level = 0;     /* compression level (1..9) */
      this.strategy = 0;  /* favor or force Huffman coding*/

      this.good_match = 0;
      /* Use a faster search when the previous match is longer than this */

      this.nice_match = 0; /* Stop searching when current match exceeds this */

                  /* used by trees.c: */

      /* Didn't use ct_data typedef below to suppress compiler warning */

      // struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
      // struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
      // struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */

      // Use flat array of DOUBLE size, with interleaved fata,
      // because JS does not support effective
      this.dyn_ltree  = new common.Buf16(HEAP_SIZE * 2);
      this.dyn_dtree  = new common.Buf16((2 * D_CODES + 1) * 2);
      this.bl_tree    = new common.Buf16((2 * BL_CODES + 1) * 2);
      zero(this.dyn_ltree);
      zero(this.dyn_dtree);
      zero(this.bl_tree);

      this.l_desc   = null;         /* desc. for literal tree */
      this.d_desc   = null;         /* desc. for distance tree */
      this.bl_desc  = null;         /* desc. for bit length tree */

      //ush bl_count[MAX_BITS+1];
      this.bl_count = new common.Buf16(MAX_BITS + 1);
      /* number of codes at each bit length for an optimal tree */

      //int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
      this.heap = new common.Buf16(2 * L_CODES + 1);  /* heap used to build the Huffman trees */
      zero(this.heap);

      this.heap_len = 0;               /* number of elements in the heap */
      this.heap_max = 0;               /* element of largest frequency */
      /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
       * The same heap array is used to build all trees.
       */

      this.depth = new common.Buf16(2 * L_CODES + 1); //uch depth[2*L_CODES+1];
      zero(this.depth);
      /* Depth of each subtree used as tie breaker for trees of equal frequency
       */

      this.l_buf = 0;          /* buffer index for literals or lengths */

      this.lit_bufsize = 0;
      /* Size of match buffer for literals/lengths.  There are 4 reasons for
       * limiting lit_bufsize to 64K:
       *   - frequencies can be kept in 16 bit counters
       *   - if compression is not successful for the first block, all input
       *     data is still in the window so we can still emit a stored block even
       *     when input comes from standard input.  (This can also be done for
       *     all blocks if lit_bufsize is not greater than 32K.)
       *   - if compression is not successful for a file smaller than 64K, we can
       *     even emit a stored file instead of a stored block (saving 5 bytes).
       *     This is applicable only for zip (not gzip or zlib).
       *   - creating new Huffman trees less frequently may not provide fast
       *     adaptation to changes in the input data statistics. (Take for
       *     example a binary file with poorly compressible code followed by
       *     a highly compressible string table.) Smaller buffer sizes give
       *     fast adaptation but have of course the overhead of transmitting
       *     trees more frequently.
       *   - I can't count above 4
       */

      this.last_lit = 0;      /* running index in l_buf */

      this.d_buf = 0;
      /* Buffer index for distances. To simplify the code, d_buf and l_buf have
       * the same number of elements. To use different lengths, an extra flag
       * array would be necessary.
       */

      this.opt_len = 0;       /* bit length of current block with optimal trees */
      this.static_len = 0;    /* bit length of current block with static trees */
      this.matches = 0;       /* number of string matches in current block */
      this.insert = 0;        /* bytes at end of window left to insert */


      this.bi_buf = 0;
      /* Output buffer. bits are inserted starting at the bottom (least
       * significant bits).
       */
      this.bi_valid = 0;
      /* Number of valid bits in bi_buf.  All bits above the last valid bit
       * are always zero.
       */

      // Used for window memory init. We safely ignore it for JS. That makes
      // sense only for pointers and memory check tools.
      //this.high_water = 0;
      /* High water mark offset in window for initialized bytes -- bytes above
       * this are set to zero in order to avoid memory check warnings when
       * longest match routines access bytes past the input.  This is then
       * updated to the new high water mark.
       */
    }


    function deflateResetKeep(strm) {
      var s;

      if (!strm || !strm.state) {
        return err(strm, Z_STREAM_ERROR$1);
      }

      strm.total_in = strm.total_out = 0;
      strm.data_type = Z_UNKNOWN;

      s = strm.state;
      s.pending = 0;
      s.pending_out = 0;

      if (s.wrap < 0) {
        s.wrap = -s.wrap;
        /* was made negative by deflate(..., Z_FINISH); */
      }
      s.status = (s.wrap ? INIT_STATE : BUSY_STATE);
      strm.adler = (s.wrap === 2) ?
        0  // crc32(0, Z_NULL, 0)
      :
        1; // adler32(0, Z_NULL, 0)
      s.last_flush = Z_NO_FLUSH$1;
      trees._tr_init(s);
      return Z_OK$2;
    }


    function deflateReset(strm) {
      var ret = deflateResetKeep(strm);
      if (ret === Z_OK$2) {
        lm_init(strm.state);
      }
      return ret;
    }


    function deflateSetHeader(strm, head) {
      if (!strm || !strm.state) { return Z_STREAM_ERROR$1; }
      if (strm.state.wrap !== 2) { return Z_STREAM_ERROR$1; }
      strm.state.gzhead = head;
      return Z_OK$2;
    }


    function deflateInit2(strm, level, method, windowBits, memLevel, strategy) {
      if (!strm) { // === Z_NULL
        return Z_STREAM_ERROR$1;
      }
      var wrap = 1;

      if (level === Z_DEFAULT_COMPRESSION$1) {
        level = 6;
      }

      if (windowBits < 0) { /* suppress zlib wrapper */
        wrap = 0;
        windowBits = -windowBits;
      }

      else if (windowBits > 15) {
        wrap = 2;           /* write gzip wrapper instead */
        windowBits -= 16;
      }


      if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || method !== Z_DEFLATED$2 ||
        windowBits < 8 || windowBits > 15 || level < 0 || level > 9 ||
        strategy < 0 || strategy > Z_FIXED) {
        return err(strm, Z_STREAM_ERROR$1);
      }


      if (windowBits === 8) {
        windowBits = 9;
      }
      /* until 256-byte window bug fixed */

      var s = new DeflateState();

      strm.state = s;
      s.strm = strm;

      s.wrap = wrap;
      s.gzhead = null;
      s.w_bits = windowBits;
      s.w_size = 1 << s.w_bits;
      s.w_mask = s.w_size - 1;

      s.hash_bits = memLevel + 7;
      s.hash_size = 1 << s.hash_bits;
      s.hash_mask = s.hash_size - 1;
      s.hash_shift = ~~((s.hash_bits + MIN_MATCH - 1) / MIN_MATCH);

      s.window = new common.Buf8(s.w_size * 2);
      s.head = new common.Buf16(s.hash_size);
      s.prev = new common.Buf16(s.w_size);

      // Don't need mem init magic for JS.
      //s.high_water = 0;  /* nothing written to s->window yet */

      s.lit_bufsize = 1 << (memLevel + 6); /* 16K elements by default */

      s.pending_buf_size = s.lit_bufsize * 4;

      //overlay = (ushf *) ZALLOC(strm, s->lit_bufsize, sizeof(ush)+2);
      //s->pending_buf = (uchf *) overlay;
      s.pending_buf = new common.Buf8(s.pending_buf_size);

      // It is offset from `s.pending_buf` (size is `s.lit_bufsize * 2`)
      //s->d_buf = overlay + s->lit_bufsize/sizeof(ush);
      s.d_buf = 1 * s.lit_bufsize;

      //s->l_buf = s->pending_buf + (1+sizeof(ush))*s->lit_bufsize;
      s.l_buf = (1 + 2) * s.lit_bufsize;

      s.level = level;
      s.strategy = strategy;
      s.method = method;

      return deflateReset(strm);
    }

    function deflateInit(strm, level) {
      return deflateInit2(strm, level, Z_DEFLATED$2, MAX_WBITS$1, DEF_MEM_LEVEL, Z_DEFAULT_STRATEGY$1);
    }


    function deflate$1(strm, flush) {
      var old_flush, s;
      var beg, val; // for gzip header write only

      if (!strm || !strm.state ||
        flush > Z_BLOCK$1 || flush < 0) {
        return strm ? err(strm, Z_STREAM_ERROR$1) : Z_STREAM_ERROR$1;
      }

      s = strm.state;

      if (!strm.output ||
          (!strm.input && strm.avail_in !== 0) ||
          (s.status === FINISH_STATE && flush !== Z_FINISH$2)) {
        return err(strm, (strm.avail_out === 0) ? Z_BUF_ERROR$1 : Z_STREAM_ERROR$1);
      }

      s.strm = strm; /* just in case */
      old_flush = s.last_flush;
      s.last_flush = flush;

      /* Write the header */
      if (s.status === INIT_STATE) {

        if (s.wrap === 2) { // GZIP header
          strm.adler = 0;  //crc32(0L, Z_NULL, 0);
          put_byte(s, 31);
          put_byte(s, 139);
          put_byte(s, 8);
          if (!s.gzhead) { // s->gzhead == Z_NULL
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, 0);
            put_byte(s, s.level === 9 ? 2 :
                        (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                         4 : 0));
            put_byte(s, OS_CODE);
            s.status = BUSY_STATE;
          }
          else {
            put_byte(s, (s.gzhead.text ? 1 : 0) +
                        (s.gzhead.hcrc ? 2 : 0) +
                        (!s.gzhead.extra ? 0 : 4) +
                        (!s.gzhead.name ? 0 : 8) +
                        (!s.gzhead.comment ? 0 : 16)
            );
            put_byte(s, s.gzhead.time & 0xff);
            put_byte(s, (s.gzhead.time >> 8) & 0xff);
            put_byte(s, (s.gzhead.time >> 16) & 0xff);
            put_byte(s, (s.gzhead.time >> 24) & 0xff);
            put_byte(s, s.level === 9 ? 2 :
                        (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
                         4 : 0));
            put_byte(s, s.gzhead.os & 0xff);
            if (s.gzhead.extra && s.gzhead.extra.length) {
              put_byte(s, s.gzhead.extra.length & 0xff);
              put_byte(s, (s.gzhead.extra.length >> 8) & 0xff);
            }
            if (s.gzhead.hcrc) {
              strm.adler = crc32_1(strm.adler, s.pending_buf, s.pending, 0);
            }
            s.gzindex = 0;
            s.status = EXTRA_STATE;
          }
        }
        else // DEFLATE header
        {
          var header = (Z_DEFLATED$2 + ((s.w_bits - 8) << 4)) << 8;
          var level_flags = -1;

          if (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2) {
            level_flags = 0;
          } else if (s.level < 6) {
            level_flags = 1;
          } else if (s.level === 6) {
            level_flags = 2;
          } else {
            level_flags = 3;
          }
          header |= (level_flags << 6);
          if (s.strstart !== 0) { header |= PRESET_DICT; }
          header += 31 - (header % 31);

          s.status = BUSY_STATE;
          putShortMSB(s, header);

          /* Save the adler32 of the preset dictionary: */
          if (s.strstart !== 0) {
            putShortMSB(s, strm.adler >>> 16);
            putShortMSB(s, strm.adler & 0xffff);
          }
          strm.adler = 1; // adler32(0L, Z_NULL, 0);
        }
      }

    //#ifdef GZIP
      if (s.status === EXTRA_STATE) {
        if (s.gzhead.extra/* != Z_NULL*/) {
          beg = s.pending;  /* start of bytes to update crc */

          while (s.gzindex < (s.gzhead.extra.length & 0xffff)) {
            if (s.pending === s.pending_buf_size) {
              if (s.gzhead.hcrc && s.pending > beg) {
                strm.adler = crc32_1(strm.adler, s.pending_buf, s.pending - beg, beg);
              }
              flush_pending(strm);
              beg = s.pending;
              if (s.pending === s.pending_buf_size) {
                break;
              }
            }
            put_byte(s, s.gzhead.extra[s.gzindex] & 0xff);
            s.gzindex++;
          }
          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32_1(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          if (s.gzindex === s.gzhead.extra.length) {
            s.gzindex = 0;
            s.status = NAME_STATE;
          }
        }
        else {
          s.status = NAME_STATE;
        }
      }
      if (s.status === NAME_STATE) {
        if (s.gzhead.name/* != Z_NULL*/) {
          beg = s.pending;  /* start of bytes to update crc */
          //int val;

          do {
            if (s.pending === s.pending_buf_size) {
              if (s.gzhead.hcrc && s.pending > beg) {
                strm.adler = crc32_1(strm.adler, s.pending_buf, s.pending - beg, beg);
              }
              flush_pending(strm);
              beg = s.pending;
              if (s.pending === s.pending_buf_size) {
                val = 1;
                break;
              }
            }
            // JS specific: little magic to add zero terminator to end of string
            if (s.gzindex < s.gzhead.name.length) {
              val = s.gzhead.name.charCodeAt(s.gzindex++) & 0xff;
            } else {
              val = 0;
            }
            put_byte(s, val);
          } while (val !== 0);

          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32_1(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          if (val === 0) {
            s.gzindex = 0;
            s.status = COMMENT_STATE;
          }
        }
        else {
          s.status = COMMENT_STATE;
        }
      }
      if (s.status === COMMENT_STATE) {
        if (s.gzhead.comment/* != Z_NULL*/) {
          beg = s.pending;  /* start of bytes to update crc */
          //int val;

          do {
            if (s.pending === s.pending_buf_size) {
              if (s.gzhead.hcrc && s.pending > beg) {
                strm.adler = crc32_1(strm.adler, s.pending_buf, s.pending - beg, beg);
              }
              flush_pending(strm);
              beg = s.pending;
              if (s.pending === s.pending_buf_size) {
                val = 1;
                break;
              }
            }
            // JS specific: little magic to add zero terminator to end of string
            if (s.gzindex < s.gzhead.comment.length) {
              val = s.gzhead.comment.charCodeAt(s.gzindex++) & 0xff;
            } else {
              val = 0;
            }
            put_byte(s, val);
          } while (val !== 0);

          if (s.gzhead.hcrc && s.pending > beg) {
            strm.adler = crc32_1(strm.adler, s.pending_buf, s.pending - beg, beg);
          }
          if (val === 0) {
            s.status = HCRC_STATE;
          }
        }
        else {
          s.status = HCRC_STATE;
        }
      }
      if (s.status === HCRC_STATE) {
        if (s.gzhead.hcrc) {
          if (s.pending + 2 > s.pending_buf_size) {
            flush_pending(strm);
          }
          if (s.pending + 2 <= s.pending_buf_size) {
            put_byte(s, strm.adler & 0xff);
            put_byte(s, (strm.adler >> 8) & 0xff);
            strm.adler = 0; //crc32(0L, Z_NULL, 0);
            s.status = BUSY_STATE;
          }
        }
        else {
          s.status = BUSY_STATE;
        }
      }
    //#endif

      /* Flush as much pending output as possible */
      if (s.pending !== 0) {
        flush_pending(strm);
        if (strm.avail_out === 0) {
          /* Since avail_out is 0, deflate will be called again with
           * more output space, but possibly with both pending and
           * avail_in equal to zero. There won't be anything to do,
           * but this is not an error situation so make sure we
           * return OK instead of BUF_ERROR at next call of deflate:
           */
          s.last_flush = -1;
          return Z_OK$2;
        }

        /* Make sure there is something to do and avoid duplicate consecutive
         * flushes. For repeated and useless calls with Z_FINISH, we keep
         * returning Z_STREAM_END instead of Z_BUF_ERROR.
         */
      } else if (strm.avail_in === 0 && rank(flush) <= rank(old_flush) &&
        flush !== Z_FINISH$2) {
        return err(strm, Z_BUF_ERROR$1);
      }

      /* User must not provide more input after the first FINISH: */
      if (s.status === FINISH_STATE && strm.avail_in !== 0) {
        return err(strm, Z_BUF_ERROR$1);
      }

      /* Start a new block or continue the current one.
       */
      if (strm.avail_in !== 0 || s.lookahead !== 0 ||
        (flush !== Z_NO_FLUSH$1 && s.status !== FINISH_STATE)) {
        var bstate = (s.strategy === Z_HUFFMAN_ONLY) ? deflate_huff(s, flush) :
          (s.strategy === Z_RLE ? deflate_rle(s, flush) :
            configuration_table[s.level].func(s, flush));

        if (bstate === BS_FINISH_STARTED || bstate === BS_FINISH_DONE) {
          s.status = FINISH_STATE;
        }
        if (bstate === BS_NEED_MORE || bstate === BS_FINISH_STARTED) {
          if (strm.avail_out === 0) {
            s.last_flush = -1;
            /* avoid BUF_ERROR next call, see above */
          }
          return Z_OK$2;
          /* If flush != Z_NO_FLUSH && avail_out == 0, the next call
           * of deflate should use the same flush parameter to make sure
           * that the flush is complete. So we don't have to output an
           * empty block here, this will be done at next call. This also
           * ensures that for a very small output buffer, we emit at most
           * one empty block.
           */
        }
        if (bstate === BS_BLOCK_DONE) {
          if (flush === Z_PARTIAL_FLUSH) {
            trees._tr_align(s);
          }
          else if (flush !== Z_BLOCK$1) { /* FULL_FLUSH or SYNC_FLUSH */

            trees._tr_stored_block(s, 0, 0, false);
            /* For a full flush, this empty block will be recognized
             * as a special marker by inflate_sync().
             */
            if (flush === Z_FULL_FLUSH) {
              /*** CLEAR_HASH(s); ***/             /* forget history */
              zero(s.head); // Fill with NIL (= 0);

              if (s.lookahead === 0) {
                s.strstart = 0;
                s.block_start = 0;
                s.insert = 0;
              }
            }
          }
          flush_pending(strm);
          if (strm.avail_out === 0) {
            s.last_flush = -1; /* avoid BUF_ERROR at next call, see above */
            return Z_OK$2;
          }
        }
      }
      //Assert(strm->avail_out > 0, "bug2");
      //if (strm.avail_out <= 0) { throw new Error("bug2");}

      if (flush !== Z_FINISH$2) { return Z_OK$2; }
      if (s.wrap <= 0) { return Z_STREAM_END$2; }

      /* Write the trailer */
      if (s.wrap === 2) {
        put_byte(s, strm.adler & 0xff);
        put_byte(s, (strm.adler >> 8) & 0xff);
        put_byte(s, (strm.adler >> 16) & 0xff);
        put_byte(s, (strm.adler >> 24) & 0xff);
        put_byte(s, strm.total_in & 0xff);
        put_byte(s, (strm.total_in >> 8) & 0xff);
        put_byte(s, (strm.total_in >> 16) & 0xff);
        put_byte(s, (strm.total_in >> 24) & 0xff);
      }
      else
      {
        putShortMSB(s, strm.adler >>> 16);
        putShortMSB(s, strm.adler & 0xffff);
      }

      flush_pending(strm);
      /* If avail_out is zero, the application will call deflate again
       * to flush the rest.
       */
      if (s.wrap > 0) { s.wrap = -s.wrap; }
      /* write the trailer only once! */
      return s.pending !== 0 ? Z_OK$2 : Z_STREAM_END$2;
    }

    function deflateEnd(strm) {
      var status;

      if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
        return Z_STREAM_ERROR$1;
      }

      status = strm.state.status;
      if (status !== INIT_STATE &&
        status !== EXTRA_STATE &&
        status !== NAME_STATE &&
        status !== COMMENT_STATE &&
        status !== HCRC_STATE &&
        status !== BUSY_STATE &&
        status !== FINISH_STATE
      ) {
        return err(strm, Z_STREAM_ERROR$1);
      }

      strm.state = null;

      return status === BUSY_STATE ? err(strm, Z_DATA_ERROR$1) : Z_OK$2;
    }


    /* =========================================================================
     * Initializes the compression dictionary from the given byte
     * sequence without producing any compressed output.
     */
    function deflateSetDictionary(strm, dictionary) {
      var dictLength = dictionary.length;

      var s;
      var str, n;
      var wrap;
      var avail;
      var next;
      var input;
      var tmpDict;

      if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
        return Z_STREAM_ERROR$1;
      }

      s = strm.state;
      wrap = s.wrap;

      if (wrap === 2 || (wrap === 1 && s.status !== INIT_STATE) || s.lookahead) {
        return Z_STREAM_ERROR$1;
      }

      /* when using zlib wrappers, compute Adler-32 for provided dictionary */
      if (wrap === 1) {
        /* adler32(strm->adler, dictionary, dictLength); */
        strm.adler = adler32_1(strm.adler, dictionary, dictLength, 0);
      }

      s.wrap = 0;   /* avoid computing Adler-32 in read_buf */

      /* if dictionary would fill window, just replace the history */
      if (dictLength >= s.w_size) {
        if (wrap === 0) {            /* already empty otherwise */
          /*** CLEAR_HASH(s); ***/
          zero(s.head); // Fill with NIL (= 0);
          s.strstart = 0;
          s.block_start = 0;
          s.insert = 0;
        }
        /* use the tail */
        // dictionary = dictionary.slice(dictLength - s.w_size);
        tmpDict = new common.Buf8(s.w_size);
        common.arraySet(tmpDict, dictionary, dictLength - s.w_size, s.w_size, 0);
        dictionary = tmpDict;
        dictLength = s.w_size;
      }
      /* insert dictionary into window and hash */
      avail = strm.avail_in;
      next = strm.next_in;
      input = strm.input;
      strm.avail_in = dictLength;
      strm.next_in = 0;
      strm.input = dictionary;
      fill_window(s);
      while (s.lookahead >= MIN_MATCH) {
        str = s.strstart;
        n = s.lookahead - (MIN_MATCH - 1);
        do {
          /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
          s.ins_h = ((s.ins_h << s.hash_shift) ^ s.window[str + MIN_MATCH - 1]) & s.hash_mask;

          s.prev[str & s.w_mask] = s.head[s.ins_h];

          s.head[s.ins_h] = str;
          str++;
        } while (--n);
        s.strstart = str;
        s.lookahead = MIN_MATCH - 1;
        fill_window(s);
      }
      s.strstart += s.lookahead;
      s.block_start = s.strstart;
      s.insert = s.lookahead;
      s.lookahead = 0;
      s.match_length = s.prev_length = MIN_MATCH - 1;
      s.match_available = 0;
      strm.next_in = next;
      strm.input = input;
      strm.avail_in = avail;
      s.wrap = wrap;
      return Z_OK$2;
    }


    var deflateInit_1 = deflateInit;
    var deflateInit2_1 = deflateInit2;
    var deflateReset_1 = deflateReset;
    var deflateResetKeep_1 = deflateResetKeep;
    var deflateSetHeader_1 = deflateSetHeader;
    var deflate_2$1 = deflate$1;
    var deflateEnd_1 = deflateEnd;
    var deflateSetDictionary_1 = deflateSetDictionary;
    var deflateInfo = 'pako deflate (from Nodeca project)';

    /* Not implemented
    exports.deflateBound = deflateBound;
    exports.deflateCopy = deflateCopy;
    exports.deflateParams = deflateParams;
    exports.deflatePending = deflatePending;
    exports.deflatePrime = deflatePrime;
    exports.deflateTune = deflateTune;
    */

    var deflate_1$1 = {
    	deflateInit: deflateInit_1,
    	deflateInit2: deflateInit2_1,
    	deflateReset: deflateReset_1,
    	deflateResetKeep: deflateResetKeep_1,
    	deflateSetHeader: deflateSetHeader_1,
    	deflate: deflate_2$1,
    	deflateEnd: deflateEnd_1,
    	deflateSetDictionary: deflateSetDictionary_1,
    	deflateInfo: deflateInfo
    };

    // Quick check if we can use fast array to bin string conversion
    //
    // - apply(Array) can fail on Android 2.2
    // - apply(Uint8Array) can fail on iOS 5.1 Safari
    //
    var STR_APPLY_OK = true;
    var STR_APPLY_UIA_OK = true;

    try { String.fromCharCode.apply(null, [ 0 ]); } catch (__) { STR_APPLY_OK = false; }
    try { String.fromCharCode.apply(null, new Uint8Array(1)); } catch (__) { STR_APPLY_UIA_OK = false; }


    // Table with utf8 lengths (calculated by first byte of sequence)
    // Note, that 5 & 6-byte values and some 4-byte values can not be represented in JS,
    // because max possible codepoint is 0x10ffff
    var _utf8len$1 = new common.Buf8(256);
    for (var q = 0; q < 256; q++) {
      _utf8len$1[q] = (q >= 252 ? 6 : q >= 248 ? 5 : q >= 240 ? 4 : q >= 224 ? 3 : q >= 192 ? 2 : 1);
    }
    _utf8len$1[254] = _utf8len$1[254] = 1; // Invalid sequence start


    // convert string to array (typed, when possible)
    var string2buf$1 = function (str) {
      var buf, c, c2, m_pos, i, str_len = str.length, buf_len = 0;

      // count binary size
      for (m_pos = 0; m_pos < str_len; m_pos++) {
        c = str.charCodeAt(m_pos);
        if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
          c2 = str.charCodeAt(m_pos + 1);
          if ((c2 & 0xfc00) === 0xdc00) {
            c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
            m_pos++;
          }
        }
        buf_len += c < 0x80 ? 1 : c < 0x800 ? 2 : c < 0x10000 ? 3 : 4;
      }

      // allocate buffer
      buf = new common.Buf8(buf_len);

      // convert
      for (i = 0, m_pos = 0; i < buf_len; m_pos++) {
        c = str.charCodeAt(m_pos);
        if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
          c2 = str.charCodeAt(m_pos + 1);
          if ((c2 & 0xfc00) === 0xdc00) {
            c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
            m_pos++;
          }
        }
        if (c < 0x80) {
          /* one byte */
          buf[i++] = c;
        } else if (c < 0x800) {
          /* two bytes */
          buf[i++] = 0xC0 | (c >>> 6);
          buf[i++] = 0x80 | (c & 0x3f);
        } else if (c < 0x10000) {
          /* three bytes */
          buf[i++] = 0xE0 | (c >>> 12);
          buf[i++] = 0x80 | (c >>> 6 & 0x3f);
          buf[i++] = 0x80 | (c & 0x3f);
        } else {
          /* four bytes */
          buf[i++] = 0xf0 | (c >>> 18);
          buf[i++] = 0x80 | (c >>> 12 & 0x3f);
          buf[i++] = 0x80 | (c >>> 6 & 0x3f);
          buf[i++] = 0x80 | (c & 0x3f);
        }
      }

      return buf;
    };

    // Helper (used in 2 places)
    function buf2binstring(buf, len) {
      // On Chrome, the arguments in a function call that are allowed is `65534`.
      // If the length of the buffer is smaller than that, we can use this optimization,
      // otherwise we will take a slower path.
      if (len < 65534) {
        if ((buf.subarray && STR_APPLY_UIA_OK) || (!buf.subarray && STR_APPLY_OK)) {
          return String.fromCharCode.apply(null, common.shrinkBuf(buf, len));
        }
      }

      var result = '';
      for (var i = 0; i < len; i++) {
        result += String.fromCharCode(buf[i]);
      }
      return result;
    }


    // Convert byte array to binary string
    var buf2binstring_1 = function (buf) {
      return buf2binstring(buf, buf.length);
    };


    // Convert binary string (typed, when possible)
    var binstring2buf = function (str) {
      var buf = new common.Buf8(str.length);
      for (var i = 0, len = buf.length; i < len; i++) {
        buf[i] = str.charCodeAt(i);
      }
      return buf;
    };


    // convert array to string
    var buf2string$1 = function (buf, max) {
      var i, out, c, c_len;
      var len = max || buf.length;

      // Reserve max possible length (2 words per char)
      // NB: by unknown reasons, Array is significantly faster for
      //     String.fromCharCode.apply than Uint16Array.
      var utf16buf = new Array(len * 2);

      for (out = 0, i = 0; i < len;) {
        c = buf[i++];
        // quick process ascii
        if (c < 0x80) { utf16buf[out++] = c; continue; }

        c_len = _utf8len$1[c];
        // skip 5 & 6 byte codes
        if (c_len > 4) { utf16buf[out++] = 0xfffd; i += c_len - 1; continue; }

        // apply mask on first byte
        c &= c_len === 2 ? 0x1f : c_len === 3 ? 0x0f : 0x07;
        // join the rest
        while (c_len > 1 && i < len) {
          c = (c << 6) | (buf[i++] & 0x3f);
          c_len--;
        }

        // terminated by end of string?
        if (c_len > 1) { utf16buf[out++] = 0xfffd; continue; }

        if (c < 0x10000) {
          utf16buf[out++] = c;
        } else {
          c -= 0x10000;
          utf16buf[out++] = 0xd800 | ((c >> 10) & 0x3ff);
          utf16buf[out++] = 0xdc00 | (c & 0x3ff);
        }
      }

      return buf2binstring(utf16buf, out);
    };


    // Calculate max possible position in utf8 buffer,
    // that will not break sequence. If that's not possible
    // - (very small limits) return max size as is.
    //
    // buf[] - utf8 bytes array
    // max   - length limit (mandatory);
    var utf8border$1 = function (buf, max) {
      var pos;

      max = max || buf.length;
      if (max > buf.length) { max = buf.length; }

      // go back from last position, until start of sequence found
      pos = max - 1;
      while (pos >= 0 && (buf[pos] & 0xC0) === 0x80) { pos--; }

      // Very small and broken sequence,
      // return max, because we should return something anyway.
      if (pos < 0) { return max; }

      // If we came to start of buffer - that means buffer is too small,
      // return max too.
      if (pos === 0) { return max; }

      return (pos + _utf8len$1[buf[pos]] > max) ? pos : max;
    };

    var strings = {
    	string2buf: string2buf$1,
    	buf2binstring: buf2binstring_1,
    	binstring2buf: binstring2buf,
    	buf2string: buf2string$1,
    	utf8border: utf8border$1
    };

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    function ZStream() {
      /* next input byte */
      this.input = null; // JS specific, because we have no pointers
      this.next_in = 0;
      /* number of bytes available at input */
      this.avail_in = 0;
      /* total number of input bytes read so far */
      this.total_in = 0;
      /* next output byte should be put there */
      this.output = null; // JS specific, because we have no pointers
      this.next_out = 0;
      /* remaining free space at output */
      this.avail_out = 0;
      /* total number of bytes output so far */
      this.total_out = 0;
      /* last error message, NULL if no error */
      this.msg = ''/*Z_NULL*/;
      /* not visible by applications */
      this.state = null;
      /* best guess about the data type: binary or text */
      this.data_type = 2/*Z_UNKNOWN*/;
      /* adler32 value of the uncompressed data */
      this.adler = 0;
    }

    var zstream = ZStream;

    var toString$1 = Object.prototype.toString;

    /* Public constants ==========================================================*/
    /* ===========================================================================*/

    var Z_NO_FLUSH      = 0;
    var Z_FINISH$1        = 4;

    var Z_OK$1            = 0;
    var Z_STREAM_END$1    = 1;
    var Z_SYNC_FLUSH    = 2;

    var Z_DEFAULT_COMPRESSION = -1;

    var Z_DEFAULT_STRATEGY    = 0;

    var Z_DEFLATED$1  = 8;

    /* ===========================================================================*/


    /**
     * class Deflate
     *
     * Generic JS-style wrapper for zlib calls. If you don't need
     * streaming behaviour - use more simple functions: [[deflate]],
     * [[deflateRaw]] and [[gzip]].
     **/

    /* internal
     * Deflate.chunks -> Array
     *
     * Chunks of output data, if [[Deflate#onData]] not overridden.
     **/

    /**
     * Deflate.result -> Uint8Array|Array
     *
     * Compressed result, generated by default [[Deflate#onData]]
     * and [[Deflate#onEnd]] handlers. Filled after you push last chunk
     * (call [[Deflate#push]] with `Z_FINISH` / `true` param)  or if you
     * push a chunk with explicit flush (call [[Deflate#push]] with
     * `Z_SYNC_FLUSH` param).
     **/

    /**
     * Deflate.err -> Number
     *
     * Error code after deflate finished. 0 (Z_OK) on success.
     * You will not need it in real life, because deflate errors
     * are possible only on wrong options or bad `onData` / `onEnd`
     * custom handlers.
     **/

    /**
     * Deflate.msg -> String
     *
     * Error message, if [[Deflate.err]] != 0
     **/


    /**
     * new Deflate(options)
     * - options (Object): zlib deflate options.
     *
     * Creates new deflator instance with specified params. Throws exception
     * on bad params. Supported options:
     *
     * - `level`
     * - `windowBits`
     * - `memLevel`
     * - `strategy`
     * - `dictionary`
     *
     * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
     * for more information on these.
     *
     * Additional options, for internal needs:
     *
     * - `chunkSize` - size of generated data chunks (16K by default)
     * - `raw` (Boolean) - do raw deflate
     * - `gzip` (Boolean) - create gzip wrapper
     * - `to` (String) - if equal to 'string', then result will be "binary string"
     *    (each char code [0..255])
     * - `header` (Object) - custom header for gzip
     *   - `text` (Boolean) - true if compressed data believed to be text
     *   - `time` (Number) - modification time, unix timestamp
     *   - `os` (Number) - operation system code
     *   - `extra` (Array) - array of bytes with extra data (max 65536)
     *   - `name` (String) - file name (binary string)
     *   - `comment` (String) - comment (binary string)
     *   - `hcrc` (Boolean) - true if header crc should be added
     *
     * ##### Example:
     *
     * ```javascript
     * var pako = require('pako')
     *   , chunk1 = Uint8Array([1,2,3,4,5,6,7,8,9])
     *   , chunk2 = Uint8Array([10,11,12,13,14,15,16,17,18,19]);
     *
     * var deflate = new pako.Deflate({ level: 3});
     *
     * deflate.push(chunk1, false);
     * deflate.push(chunk2, true);  // true -> last chunk
     *
     * if (deflate.err) { throw new Error(deflate.err); }
     *
     * console.log(deflate.result);
     * ```
     **/
    function Deflate(options) {
      if (!(this instanceof Deflate)) return new Deflate(options);

      this.options = common.assign({
        level: Z_DEFAULT_COMPRESSION,
        method: Z_DEFLATED$1,
        chunkSize: 16384,
        windowBits: 15,
        memLevel: 8,
        strategy: Z_DEFAULT_STRATEGY,
        to: ''
      }, options || {});

      var opt = this.options;

      if (opt.raw && (opt.windowBits > 0)) {
        opt.windowBits = -opt.windowBits;
      }

      else if (opt.gzip && (opt.windowBits > 0) && (opt.windowBits < 16)) {
        opt.windowBits += 16;
      }

      this.err    = 0;      // error code, if happens (0 = Z_OK)
      this.msg    = '';     // error message
      this.ended  = false;  // used to avoid multiple onEnd() calls
      this.chunks = [];     // chunks of compressed data

      this.strm = new zstream();
      this.strm.avail_out = 0;

      var status = deflate_1$1.deflateInit2(
        this.strm,
        opt.level,
        opt.method,
        opt.windowBits,
        opt.memLevel,
        opt.strategy
      );

      if (status !== Z_OK$1) {
        throw new Error(messages[status]);
      }

      if (opt.header) {
        deflate_1$1.deflateSetHeader(this.strm, opt.header);
      }

      if (opt.dictionary) {
        var dict;
        // Convert data if needed
        if (typeof opt.dictionary === 'string') {
          // If we need to compress text, change encoding to utf8.
          dict = strings.string2buf(opt.dictionary);
        } else if (toString$1.call(opt.dictionary) === '[object ArrayBuffer]') {
          dict = new Uint8Array(opt.dictionary);
        } else {
          dict = opt.dictionary;
        }

        status = deflate_1$1.deflateSetDictionary(this.strm, dict);

        if (status !== Z_OK$1) {
          throw new Error(messages[status]);
        }

        this._dict_set = true;
      }
    }

    /**
     * Deflate#push(data[, mode]) -> Boolean
     * - data (Uint8Array|Array|ArrayBuffer|String): input data. Strings will be
     *   converted to utf8 byte sequence.
     * - mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE modes.
     *   See constants. Skipped or `false` means Z_NO_FLUSH, `true` means Z_FINISH.
     *
     * Sends input data to deflate pipe, generating [[Deflate#onData]] calls with
     * new compressed chunks. Returns `true` on success. The last data block must have
     * mode Z_FINISH (or `true`). That will flush internal pending buffers and call
     * [[Deflate#onEnd]]. For interim explicit flushes (without ending the stream) you
     * can use mode Z_SYNC_FLUSH, keeping the compression context.
     *
     * On fail call [[Deflate#onEnd]] with error code and return false.
     *
     * We strongly recommend to use `Uint8Array` on input for best speed (output
     * array format is detected automatically). Also, don't skip last param and always
     * use the same type in your code (boolean or number). That will improve JS speed.
     *
     * For regular `Array`-s make sure all elements are [0..255].
     *
     * ##### Example
     *
     * ```javascript
     * push(chunk, false); // push one of data chunks
     * ...
     * push(chunk, true);  // push last chunk
     * ```
     **/
    Deflate.prototype.push = function (data, mode) {
      var strm = this.strm;
      var chunkSize = this.options.chunkSize;
      var status, _mode;

      if (this.ended) { return false; }

      _mode = (mode === ~~mode) ? mode : ((mode === true) ? Z_FINISH$1 : Z_NO_FLUSH);

      // Convert data if needed
      if (typeof data === 'string') {
        // If we need to compress text, change encoding to utf8.
        strm.input = strings.string2buf(data);
      } else if (toString$1.call(data) === '[object ArrayBuffer]') {
        strm.input = new Uint8Array(data);
      } else {
        strm.input = data;
      }

      strm.next_in = 0;
      strm.avail_in = strm.input.length;

      do {
        if (strm.avail_out === 0) {
          strm.output = new common.Buf8(chunkSize);
          strm.next_out = 0;
          strm.avail_out = chunkSize;
        }
        status = deflate_1$1.deflate(strm, _mode);    /* no bad return value */

        if (status !== Z_STREAM_END$1 && status !== Z_OK$1) {
          this.onEnd(status);
          this.ended = true;
          return false;
        }
        if (strm.avail_out === 0 || (strm.avail_in === 0 && (_mode === Z_FINISH$1 || _mode === Z_SYNC_FLUSH))) {
          if (this.options.to === 'string') {
            this.onData(strings.buf2binstring(common.shrinkBuf(strm.output, strm.next_out)));
          } else {
            this.onData(common.shrinkBuf(strm.output, strm.next_out));
          }
        }
      } while ((strm.avail_in > 0 || strm.avail_out === 0) && status !== Z_STREAM_END$1);

      // Finalize on the last chunk.
      if (_mode === Z_FINISH$1) {
        status = deflate_1$1.deflateEnd(this.strm);
        this.onEnd(status);
        this.ended = true;
        return status === Z_OK$1;
      }

      // callback interim results if Z_SYNC_FLUSH.
      if (_mode === Z_SYNC_FLUSH) {
        this.onEnd(Z_OK$1);
        strm.avail_out = 0;
        return true;
      }

      return true;
    };


    /**
     * Deflate#onData(chunk) -> Void
     * - chunk (Uint8Array|Array|String): output data. Type of array depends
     *   on js engine support. When string output requested, each chunk
     *   will be string.
     *
     * By default, stores data blocks in `chunks[]` property and glue
     * those in `onEnd`. Override this handler, if you need another behaviour.
     **/
    Deflate.prototype.onData = function (chunk) {
      this.chunks.push(chunk);
    };


    /**
     * Deflate#onEnd(status) -> Void
     * - status (Number): deflate status. 0 (Z_OK) on success,
     *   other if not.
     *
     * Called once after you tell deflate that the input stream is
     * complete (Z_FINISH) or should be flushed (Z_SYNC_FLUSH)
     * or if an error happened. By default - join collected chunks,
     * free memory and fill `results` / `err` properties.
     **/
    Deflate.prototype.onEnd = function (status) {
      // On success - join
      if (status === Z_OK$1) {
        if (this.options.to === 'string') {
          this.result = this.chunks.join('');
        } else {
          this.result = common.flattenChunks(this.chunks);
        }
      }
      this.chunks = [];
      this.err = status;
      this.msg = this.strm.msg;
    };


    /**
     * deflate(data[, options]) -> Uint8Array|Array|String
     * - data (Uint8Array|Array|String): input data to compress.
     * - options (Object): zlib deflate options.
     *
     * Compress `data` with deflate algorithm and `options`.
     *
     * Supported options are:
     *
     * - level
     * - windowBits
     * - memLevel
     * - strategy
     * - dictionary
     *
     * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
     * for more information on these.
     *
     * Sugar (options):
     *
     * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
     *   negative windowBits implicitly.
     * - `to` (String) - if equal to 'string', then result will be "binary string"
     *    (each char code [0..255])
     *
     * ##### Example:
     *
     * ```javascript
     * var pako = require('pako')
     *   , data = Uint8Array([1,2,3,4,5,6,7,8,9]);
     *
     * console.log(pako.deflate(data));
     * ```
     **/
    function deflate(input, options) {
      var deflator = new Deflate(options);

      deflator.push(input, true);

      // That will never happens, if you don't cheat with options :)
      if (deflator.err) { throw deflator.msg || messages[deflator.err]; }

      return deflator.result;
    }


    /**
     * deflateRaw(data[, options]) -> Uint8Array|Array|String
     * - data (Uint8Array|Array|String): input data to compress.
     * - options (Object): zlib deflate options.
     *
     * The same as [[deflate]], but creates raw data, without wrapper
     * (header and adler32 crc).
     **/
    function deflateRaw(input, options) {
      options = options || {};
      options.raw = true;
      return deflate(input, options);
    }


    /**
     * gzip(data[, options]) -> Uint8Array|Array|String
     * - data (Uint8Array|Array|String): input data to compress.
     * - options (Object): zlib deflate options.
     *
     * The same as [[deflate]], but create gzip wrapper instead of
     * deflate one.
     **/
    function gzip(input, options) {
      options = options || {};
      options.gzip = true;
      return deflate(input, options);
    }


    var Deflate_1 = Deflate;
    var deflate_2 = deflate;
    var deflateRaw_1 = deflateRaw;
    var gzip_1 = gzip;

    var deflate_1 = {
    	Deflate: Deflate_1,
    	deflate: deflate_2,
    	deflateRaw: deflateRaw_1,
    	gzip: gzip_1
    };

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    // See state defs from inflate.js
    var BAD$1 = 30;       /* got a data error -- remain here until reset */
    var TYPE$1 = 12;      /* i: waiting for type bits, including last-flag bit */

    /*
       Decode literal, length, and distance codes and write out the resulting
       literal and match bytes until either not enough input or output is
       available, an end-of-block is encountered, or a data error is encountered.
       When large enough input and output buffers are supplied to inflate(), for
       example, a 16K input buffer and a 64K output buffer, more than 95% of the
       inflate execution time is spent in this routine.

       Entry assumptions:

            state.mode === LEN
            strm.avail_in >= 6
            strm.avail_out >= 258
            start >= strm.avail_out
            state.bits < 8

       On return, state.mode is one of:

            LEN -- ran out of enough output space or enough available input
            TYPE -- reached end of block code, inflate() to interpret next block
            BAD -- error in block data

       Notes:

        - The maximum input bits used by a length/distance pair is 15 bits for the
          length code, 5 bits for the length extra, 15 bits for the distance code,
          and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
          Therefore if strm.avail_in >= 6, then there is enough input to avoid
          checking for available input while decoding.

        - The maximum bytes that a single length/distance pair can output is 258
          bytes, which is the maximum length that can be coded.  inflate_fast()
          requires strm.avail_out >= 258 for each loop to avoid checking for
          output space.
     */
    var inffast = function inflate_fast(strm, start) {
      var state;
      var _in;                    /* local strm.input */
      var last;                   /* have enough input while in < last */
      var _out;                   /* local strm.output */
      var beg;                    /* inflate()'s initial strm.output */
      var end;                    /* while out < end, enough space available */
    //#ifdef INFLATE_STRICT
      var dmax;                   /* maximum distance from zlib header */
    //#endif
      var wsize;                  /* window size or zero if not using window */
      var whave;                  /* valid bytes in the window */
      var wnext;                  /* window write index */
      // Use `s_window` instead `window`, avoid conflict with instrumentation tools
      var s_window;               /* allocated sliding window, if wsize != 0 */
      var hold;                   /* local strm.hold */
      var bits;                   /* local strm.bits */
      var lcode;                  /* local strm.lencode */
      var dcode;                  /* local strm.distcode */
      var lmask;                  /* mask for first level of length codes */
      var dmask;                  /* mask for first level of distance codes */
      var here;                   /* retrieved table entry */
      var op;                     /* code bits, operation, extra bits, or */
                                  /*  window position, window bytes to copy */
      var len;                    /* match length, unused bytes */
      var dist;                   /* match distance */
      var from;                   /* where to copy match from */
      var from_source;


      var input, output; // JS specific, because we have no pointers

      /* copy state to local variables */
      state = strm.state;
      //here = state.here;
      _in = strm.next_in;
      input = strm.input;
      last = _in + (strm.avail_in - 5);
      _out = strm.next_out;
      output = strm.output;
      beg = _out - (start - strm.avail_out);
      end = _out + (strm.avail_out - 257);
    //#ifdef INFLATE_STRICT
      dmax = state.dmax;
    //#endif
      wsize = state.wsize;
      whave = state.whave;
      wnext = state.wnext;
      s_window = state.window;
      hold = state.hold;
      bits = state.bits;
      lcode = state.lencode;
      dcode = state.distcode;
      lmask = (1 << state.lenbits) - 1;
      dmask = (1 << state.distbits) - 1;


      /* decode literals and length/distances until end-of-block or not enough
         input data or output space */

      top:
      do {
        if (bits < 15) {
          hold += input[_in++] << bits;
          bits += 8;
          hold += input[_in++] << bits;
          bits += 8;
        }

        here = lcode[hold & lmask];

        dolen:
        for (;;) { // Goto emulation
          op = here >>> 24/*here.bits*/;
          hold >>>= op;
          bits -= op;
          op = (here >>> 16) & 0xff/*here.op*/;
          if (op === 0) {                          /* literal */
            //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
            //        "inflate:         literal '%c'\n" :
            //        "inflate:         literal 0x%02x\n", here.val));
            output[_out++] = here & 0xffff/*here.val*/;
          }
          else if (op & 16) {                     /* length base */
            len = here & 0xffff/*here.val*/;
            op &= 15;                           /* number of extra bits */
            if (op) {
              if (bits < op) {
                hold += input[_in++] << bits;
                bits += 8;
              }
              len += hold & ((1 << op) - 1);
              hold >>>= op;
              bits -= op;
            }
            //Tracevv((stderr, "inflate:         length %u\n", len));
            if (bits < 15) {
              hold += input[_in++] << bits;
              bits += 8;
              hold += input[_in++] << bits;
              bits += 8;
            }
            here = dcode[hold & dmask];

            dodist:
            for (;;) { // goto emulation
              op = here >>> 24/*here.bits*/;
              hold >>>= op;
              bits -= op;
              op = (here >>> 16) & 0xff/*here.op*/;

              if (op & 16) {                      /* distance base */
                dist = here & 0xffff/*here.val*/;
                op &= 15;                       /* number of extra bits */
                if (bits < op) {
                  hold += input[_in++] << bits;
                  bits += 8;
                  if (bits < op) {
                    hold += input[_in++] << bits;
                    bits += 8;
                  }
                }
                dist += hold & ((1 << op) - 1);
    //#ifdef INFLATE_STRICT
                if (dist > dmax) {
                  strm.msg = 'invalid distance too far back';
                  state.mode = BAD$1;
                  break top;
                }
    //#endif
                hold >>>= op;
                bits -= op;
                //Tracevv((stderr, "inflate:         distance %u\n", dist));
                op = _out - beg;                /* max distance in output */
                if (dist > op) {                /* see if copy from window */
                  op = dist - op;               /* distance back in window */
                  if (op > whave) {
                    if (state.sane) {
                      strm.msg = 'invalid distance too far back';
                      state.mode = BAD$1;
                      break top;
                    }

    // (!) This block is disabled in zlib defaults,
    // don't enable it for binary compatibility
    //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
    //                if (len <= op - whave) {
    //                  do {
    //                    output[_out++] = 0;
    //                  } while (--len);
    //                  continue top;
    //                }
    //                len -= op - whave;
    //                do {
    //                  output[_out++] = 0;
    //                } while (--op > whave);
    //                if (op === 0) {
    //                  from = _out - dist;
    //                  do {
    //                    output[_out++] = output[from++];
    //                  } while (--len);
    //                  continue top;
    //                }
    //#endif
                  }
                  from = 0; // window index
                  from_source = s_window;
                  if (wnext === 0) {           /* very common case */
                    from += wsize - op;
                    if (op < len) {         /* some from window */
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = _out - dist;  /* rest from output */
                      from_source = output;
                    }
                  }
                  else if (wnext < op) {      /* wrap around window */
                    from += wsize + wnext - op;
                    op -= wnext;
                    if (op < len) {         /* some from end of window */
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = 0;
                      if (wnext < len) {  /* some from start of window */
                        op = wnext;
                        len -= op;
                        do {
                          output[_out++] = s_window[from++];
                        } while (--op);
                        from = _out - dist;      /* rest from output */
                        from_source = output;
                      }
                    }
                  }
                  else {                      /* contiguous in window */
                    from += wnext - op;
                    if (op < len) {         /* some from window */
                      len -= op;
                      do {
                        output[_out++] = s_window[from++];
                      } while (--op);
                      from = _out - dist;  /* rest from output */
                      from_source = output;
                    }
                  }
                  while (len > 2) {
                    output[_out++] = from_source[from++];
                    output[_out++] = from_source[from++];
                    output[_out++] = from_source[from++];
                    len -= 3;
                  }
                  if (len) {
                    output[_out++] = from_source[from++];
                    if (len > 1) {
                      output[_out++] = from_source[from++];
                    }
                  }
                }
                else {
                  from = _out - dist;          /* copy direct from output */
                  do {                        /* minimum length is three */
                    output[_out++] = output[from++];
                    output[_out++] = output[from++];
                    output[_out++] = output[from++];
                    len -= 3;
                  } while (len > 2);
                  if (len) {
                    output[_out++] = output[from++];
                    if (len > 1) {
                      output[_out++] = output[from++];
                    }
                  }
                }
              }
              else if ((op & 64) === 0) {          /* 2nd level distance code */
                here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
                continue dodist;
              }
              else {
                strm.msg = 'invalid distance code';
                state.mode = BAD$1;
                break top;
              }

              break; // need to emulate goto via "continue"
            }
          }
          else if ((op & 64) === 0) {              /* 2nd level length code */
            here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
            continue dolen;
          }
          else if (op & 32) {                     /* end-of-block */
            //Tracevv((stderr, "inflate:         end of block\n"));
            state.mode = TYPE$1;
            break top;
          }
          else {
            strm.msg = 'invalid literal/length code';
            state.mode = BAD$1;
            break top;
          }

          break; // need to emulate goto via "continue"
        }
      } while (_in < last && _out < end);

      /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
      len = bits >> 3;
      _in -= len;
      bits -= len << 3;
      hold &= (1 << bits) - 1;

      /* update state and return */
      strm.next_in = _in;
      strm.next_out = _out;
      strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
      strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
      state.hold = hold;
      state.bits = bits;
      return;
    };

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.



    var MAXBITS = 15;
    var ENOUGH_LENS$1 = 852;
    var ENOUGH_DISTS$1 = 592;
    //var ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

    var CODES$1 = 0;
    var LENS$1 = 1;
    var DISTS$1 = 2;

    var lbase = [ /* Length codes 257..285 base */
      3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
      35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
    ];

    var lext = [ /* Length codes 257..285 extra */
      16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
      19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
    ];

    var dbase = [ /* Distance codes 0..29 base */
      1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
      257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
      8193, 12289, 16385, 24577, 0, 0
    ];

    var dext = [ /* Distance codes 0..29 extra */
      16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
      23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
      28, 28, 29, 29, 64, 64
    ];

    var inftrees = function inflate_table(type, lens, lens_index, codes, table, table_index, work, opts)
    {
      var bits = opts.bits;
          //here = opts.here; /* table entry for duplication */

      var len = 0;               /* a code's length in bits */
      var sym = 0;               /* index of code symbols */
      var min = 0, max = 0;          /* minimum and maximum code lengths */
      var root = 0;              /* number of index bits for root table */
      var curr = 0;              /* number of index bits for current table */
      var drop = 0;              /* code bits to drop for sub-table */
      var left = 0;                   /* number of prefix codes available */
      var used = 0;              /* code entries in table used */
      var huff = 0;              /* Huffman code */
      var incr;              /* for incrementing code, index */
      var fill;              /* index for replicating entries */
      var low;               /* low bits for current root entry */
      var mask;              /* mask for low root bits */
      var next;             /* next available space in table */
      var base = null;     /* base value table to use */
      var base_index = 0;
    //  var shoextra;    /* extra bits table to use */
      var end;                    /* use base and extra for symbol > end */
      var count = new common.Buf16(MAXBITS + 1); //[MAXBITS+1];    /* number of codes of each length */
      var offs = new common.Buf16(MAXBITS + 1); //[MAXBITS+1];     /* offsets in table for each length */
      var extra = null;
      var extra_index = 0;

      var here_bits, here_op, here_val;

      /*
       Process a set of code lengths to create a canonical Huffman code.  The
       code lengths are lens[0..codes-1].  Each length corresponds to the
       symbols 0..codes-1.  The Huffman code is generated by first sorting the
       symbols by length from short to long, and retaining the symbol order
       for codes with equal lengths.  Then the code starts with all zero bits
       for the first code of the shortest length, and the codes are integer
       increments for the same length, and zeros are appended as the length
       increases.  For the deflate format, these bits are stored backwards
       from their more natural integer increment ordering, and so when the
       decoding tables are built in the large loop below, the integer codes
       are incremented backwards.

       This routine assumes, but does not check, that all of the entries in
       lens[] are in the range 0..MAXBITS.  The caller must assure this.
       1..MAXBITS is interpreted as that code length.  zero means that that
       symbol does not occur in this code.

       The codes are sorted by computing a count of codes for each length,
       creating from that a table of starting indices for each length in the
       sorted table, and then entering the symbols in order in the sorted
       table.  The sorted table is work[], with that space being provided by
       the caller.

       The length counts are used for other purposes as well, i.e. finding
       the minimum and maximum length codes, determining if there are any
       codes at all, checking for a valid set of lengths, and looking ahead
       at length counts to determine sub-table sizes when building the
       decoding tables.
       */

      /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
      for (len = 0; len <= MAXBITS; len++) {
        count[len] = 0;
      }
      for (sym = 0; sym < codes; sym++) {
        count[lens[lens_index + sym]]++;
      }

      /* bound code lengths, force root to be within code lengths */
      root = bits;
      for (max = MAXBITS; max >= 1; max--) {
        if (count[max] !== 0) { break; }
      }
      if (root > max) {
        root = max;
      }
      if (max === 0) {                     /* no symbols to code at all */
        //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
        //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
        //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
        table[table_index++] = (1 << 24) | (64 << 16) | 0;


        //table.op[opts.table_index] = 64;
        //table.bits[opts.table_index] = 1;
        //table.val[opts.table_index++] = 0;
        table[table_index++] = (1 << 24) | (64 << 16) | 0;

        opts.bits = 1;
        return 0;     /* no symbols, but wait for decoding to report error */
      }
      for (min = 1; min < max; min++) {
        if (count[min] !== 0) { break; }
      }
      if (root < min) {
        root = min;
      }

      /* check for an over-subscribed or incomplete set of lengths */
      left = 1;
      for (len = 1; len <= MAXBITS; len++) {
        left <<= 1;
        left -= count[len];
        if (left < 0) {
          return -1;
        }        /* over-subscribed */
      }
      if (left > 0 && (type === CODES$1 || max !== 1)) {
        return -1;                      /* incomplete set */
      }

      /* generate offsets into symbol table for each length for sorting */
      offs[1] = 0;
      for (len = 1; len < MAXBITS; len++) {
        offs[len + 1] = offs[len] + count[len];
      }

      /* sort symbols by length, by symbol order within each length */
      for (sym = 0; sym < codes; sym++) {
        if (lens[lens_index + sym] !== 0) {
          work[offs[lens[lens_index + sym]]++] = sym;
        }
      }

      /*
       Create and fill in decoding tables.  In this loop, the table being
       filled is at next and has curr index bits.  The code being used is huff
       with length len.  That code is converted to an index by dropping drop
       bits off of the bottom.  For codes where len is less than drop + curr,
       those top drop + curr - len bits are incremented through all values to
       fill the table with replicated entries.

       root is the number of index bits for the root table.  When len exceeds
       root, sub-tables are created pointed to by the root entry with an index
       of the low root bits of huff.  This is saved in low to check for when a
       new sub-table should be started.  drop is zero when the root table is
       being filled, and drop is root when sub-tables are being filled.

       When a new sub-table is needed, it is necessary to look ahead in the
       code lengths to determine what size sub-table is needed.  The length
       counts are used for this, and so count[] is decremented as codes are
       entered in the tables.

       used keeps track of how many table entries have been allocated from the
       provided *table space.  It is checked for LENS and DIST tables against
       the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
       the initial root table size constants.  See the comments in inftrees.h
       for more information.

       sym increments through all symbols, and the loop terminates when
       all codes of length max, i.e. all codes, have been processed.  This
       routine permits incomplete codes, so another loop after this one fills
       in the rest of the decoding tables with invalid code markers.
       */

      /* set up for code type */
      // poor man optimization - use if-else instead of switch,
      // to avoid deopts in old v8
      if (type === CODES$1) {
        base = extra = work;    /* dummy value--not used */
        end = 19;

      } else if (type === LENS$1) {
        base = lbase;
        base_index -= 257;
        extra = lext;
        extra_index -= 257;
        end = 256;

      } else {                    /* DISTS */
        base = dbase;
        extra = dext;
        end = -1;
      }

      /* initialize opts for loop */
      huff = 0;                   /* starting code */
      sym = 0;                    /* starting code symbol */
      len = min;                  /* starting code length */
      next = table_index;              /* current table to fill in */
      curr = root;                /* current table index bits */
      drop = 0;                   /* current bits to drop from code for index */
      low = -1;                   /* trigger new sub-table when len > root */
      used = 1 << root;          /* use root table entries */
      mask = used - 1;            /* mask for comparing low */

      /* check available table space */
      if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
        (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
        return 1;
      }

      /* process all codes and make table entries */
      for (;;) {
        /* create table entry */
        here_bits = len - drop;
        if (work[sym] < end) {
          here_op = 0;
          here_val = work[sym];
        }
        else if (work[sym] > end) {
          here_op = extra[extra_index + work[sym]];
          here_val = base[base_index + work[sym]];
        }
        else {
          here_op = 32 + 64;         /* end of block */
          here_val = 0;
        }

        /* replicate for those indices with low len bits equal to huff */
        incr = 1 << (len - drop);
        fill = 1 << curr;
        min = fill;                 /* save offset to next table */
        do {
          fill -= incr;
          table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val |0;
        } while (fill !== 0);

        /* backwards increment the len-bit code huff */
        incr = 1 << (len - 1);
        while (huff & incr) {
          incr >>= 1;
        }
        if (incr !== 0) {
          huff &= incr - 1;
          huff += incr;
        } else {
          huff = 0;
        }

        /* go to next symbol, update count, len */
        sym++;
        if (--count[len] === 0) {
          if (len === max) { break; }
          len = lens[lens_index + work[sym]];
        }

        /* create new sub-table if needed */
        if (len > root && (huff & mask) !== low) {
          /* if first time, transition to sub-tables */
          if (drop === 0) {
            drop = root;
          }

          /* increment past last table */
          next += min;            /* here min is 1 << curr */

          /* determine length of next table */
          curr = len - drop;
          left = 1 << curr;
          while (curr + drop < max) {
            left -= count[curr + drop];
            if (left <= 0) { break; }
            curr++;
            left <<= 1;
          }

          /* check for enough space */
          used += 1 << curr;
          if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
            (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
            return 1;
          }

          /* point entry in root table to sub-table */
          low = huff & mask;
          /*table.op[low] = curr;
          table.bits[low] = root;
          table.val[low] = next - opts.table_index;*/
          table[low] = (root << 24) | (curr << 16) | (next - table_index) |0;
        }
      }

      /* fill in remaining table entry if code is incomplete (guaranteed to have
       at most one remaining entry, since if the code is incomplete, the
       maximum code length that was allowed to get this far is one bit) */
      if (huff !== 0) {
        //table.op[next + huff] = 64;            /* invalid code marker */
        //table.bits[next + huff] = len - drop;
        //table.val[next + huff] = 0;
        table[next + huff] = ((len - drop) << 24) | (64 << 16) |0;
      }

      /* set return parameters */
      //opts.table_index += used;
      opts.bits = root;
      return 0;
    };

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.







    var CODES = 0;
    var LENS = 1;
    var DISTS = 2;

    /* Public constants ==========================================================*/
    /* ===========================================================================*/


    /* Allowed flush values; see deflate() and inflate() below for details */
    //var Z_NO_FLUSH      = 0;
    //var Z_PARTIAL_FLUSH = 1;
    //var Z_SYNC_FLUSH    = 2;
    //var Z_FULL_FLUSH    = 3;
    var Z_FINISH        = 4;
    var Z_BLOCK         = 5;
    var Z_TREES         = 6;


    /* Return codes for the compression/decompression functions. Negative values
     * are errors, positive values are used for special but normal events.
     */
    var Z_OK            = 0;
    var Z_STREAM_END    = 1;
    var Z_NEED_DICT     = 2;
    //var Z_ERRNO         = -1;
    var Z_STREAM_ERROR  = -2;
    var Z_DATA_ERROR    = -3;
    var Z_MEM_ERROR     = -4;
    var Z_BUF_ERROR     = -5;
    //var Z_VERSION_ERROR = -6;

    /* The deflate compression method */
    var Z_DEFLATED  = 8;


    /* STATES ====================================================================*/
    /* ===========================================================================*/


    var    HEAD = 1;       /* i: waiting for magic header */
    var    FLAGS = 2;      /* i: waiting for method and flags (gzip) */
    var    TIME = 3;       /* i: waiting for modification time (gzip) */
    var    OS = 4;         /* i: waiting for extra flags and operating system (gzip) */
    var    EXLEN = 5;      /* i: waiting for extra length (gzip) */
    var    EXTRA = 6;      /* i: waiting for extra bytes (gzip) */
    var    NAME = 7;       /* i: waiting for end of file name (gzip) */
    var    COMMENT = 8;    /* i: waiting for end of comment (gzip) */
    var    HCRC = 9;       /* i: waiting for header crc (gzip) */
    var    DICTID = 10;    /* i: waiting for dictionary check value */
    var    DICT = 11;      /* waiting for inflateSetDictionary() call */
    var        TYPE = 12;      /* i: waiting for type bits, including last-flag bit */
    var        TYPEDO = 13;    /* i: same, but skip check to exit inflate on new block */
    var        STORED = 14;    /* i: waiting for stored size (length and complement) */
    var        COPY_ = 15;     /* i/o: same as COPY below, but only first time in */
    var        COPY = 16;      /* i/o: waiting for input or output to copy stored block */
    var        TABLE = 17;     /* i: waiting for dynamic block table lengths */
    var        LENLENS = 18;   /* i: waiting for code length code lengths */
    var        CODELENS = 19;  /* i: waiting for length/lit and distance code lengths */
    var            LEN_ = 20;      /* i: same as LEN below, but only first time in */
    var            LEN = 21;       /* i: waiting for length/lit/eob code */
    var            LENEXT = 22;    /* i: waiting for length extra bits */
    var            DIST = 23;      /* i: waiting for distance code */
    var            DISTEXT = 24;   /* i: waiting for distance extra bits */
    var            MATCH = 25;     /* o: waiting for output space to copy string */
    var            LIT = 26;       /* o: waiting for output space to write literal */
    var    CHECK = 27;     /* i: waiting for 32-bit check value */
    var    LENGTH = 28;    /* i: waiting for 32-bit length (gzip) */
    var    DONE = 29;      /* finished check, done -- remain here until reset */
    var    BAD = 30;       /* got a data error -- remain here until reset */
    var    MEM = 31;       /* got an inflate() memory error -- remain here until reset */
    var    SYNC = 32;      /* looking for synchronization bytes to restart inflate() */

    /* ===========================================================================*/



    var ENOUGH_LENS = 852;
    var ENOUGH_DISTS = 592;
    //var ENOUGH =  (ENOUGH_LENS+ENOUGH_DISTS);

    var MAX_WBITS = 15;
    /* 32K LZ77 window */
    var DEF_WBITS = MAX_WBITS;


    function zswap32(q) {
      return  (((q >>> 24) & 0xff) +
              ((q >>> 8) & 0xff00) +
              ((q & 0xff00) << 8) +
              ((q & 0xff) << 24));
    }


    function InflateState() {
      this.mode = 0;             /* current inflate mode */
      this.last = false;          /* true if processing last block */
      this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
      this.havedict = false;      /* true if dictionary provided */
      this.flags = 0;             /* gzip header method and flags (0 if zlib) */
      this.dmax = 0;              /* zlib header max distance (INFLATE_STRICT) */
      this.check = 0;             /* protected copy of check value */
      this.total = 0;             /* protected copy of output count */
      // TODO: may be {}
      this.head = null;           /* where to save gzip header information */

      /* sliding window */
      this.wbits = 0;             /* log base 2 of requested window size */
      this.wsize = 0;             /* window size or zero if not using window */
      this.whave = 0;             /* valid bytes in the window */
      this.wnext = 0;             /* window write index */
      this.window = null;         /* allocated sliding window, if needed */

      /* bit accumulator */
      this.hold = 0;              /* input bit accumulator */
      this.bits = 0;              /* number of bits in "in" */

      /* for string and stored block copying */
      this.length = 0;            /* literal or length of data to copy */
      this.offset = 0;            /* distance back to copy string from */

      /* for table and code decoding */
      this.extra = 0;             /* extra bits needed */

      /* fixed and dynamic code tables */
      this.lencode = null;          /* starting table for length/literal codes */
      this.distcode = null;         /* starting table for distance codes */
      this.lenbits = 0;           /* index bits for lencode */
      this.distbits = 0;          /* index bits for distcode */

      /* dynamic table building */
      this.ncode = 0;             /* number of code length code lengths */
      this.nlen = 0;              /* number of length code lengths */
      this.ndist = 0;             /* number of distance code lengths */
      this.have = 0;              /* number of code lengths in lens[] */
      this.next = null;              /* next available space in codes[] */

      this.lens = new common.Buf16(320); /* temporary storage for code lengths */
      this.work = new common.Buf16(288); /* work area for code table building */

      /*
       because we don't have pointers in js, we use lencode and distcode directly
       as buffers so we don't need codes
      */
      //this.codes = new utils.Buf32(ENOUGH);       /* space for code tables */
      this.lendyn = null;              /* dynamic table for length/literal codes (JS specific) */
      this.distdyn = null;             /* dynamic table for distance codes (JS specific) */
      this.sane = 0;                   /* if false, allow invalid distance too far */
      this.back = 0;                   /* bits back of last unprocessed length/lit */
      this.was = 0;                    /* initial length of match */
    }

    function inflateResetKeep(strm) {
      var state;

      if (!strm || !strm.state) { return Z_STREAM_ERROR; }
      state = strm.state;
      strm.total_in = strm.total_out = state.total = 0;
      strm.msg = ''; /*Z_NULL*/
      if (state.wrap) {       /* to support ill-conceived Java test suite */
        strm.adler = state.wrap & 1;
      }
      state.mode = HEAD;
      state.last = 0;
      state.havedict = 0;
      state.dmax = 32768;
      state.head = null/*Z_NULL*/;
      state.hold = 0;
      state.bits = 0;
      //state.lencode = state.distcode = state.next = state.codes;
      state.lencode = state.lendyn = new common.Buf32(ENOUGH_LENS);
      state.distcode = state.distdyn = new common.Buf32(ENOUGH_DISTS);

      state.sane = 1;
      state.back = -1;
      //Tracev((stderr, "inflate: reset\n"));
      return Z_OK;
    }

    function inflateReset(strm) {
      var state;

      if (!strm || !strm.state) { return Z_STREAM_ERROR; }
      state = strm.state;
      state.wsize = 0;
      state.whave = 0;
      state.wnext = 0;
      return inflateResetKeep(strm);

    }

    function inflateReset2(strm, windowBits) {
      var wrap;
      var state;

      /* get the state */
      if (!strm || !strm.state) { return Z_STREAM_ERROR; }
      state = strm.state;

      /* extract wrap request from windowBits parameter */
      if (windowBits < 0) {
        wrap = 0;
        windowBits = -windowBits;
      }
      else {
        wrap = (windowBits >> 4) + 1;
        if (windowBits < 48) {
          windowBits &= 15;
        }
      }

      /* set number of window bits, free window if different */
      if (windowBits && (windowBits < 8 || windowBits > 15)) {
        return Z_STREAM_ERROR;
      }
      if (state.window !== null && state.wbits !== windowBits) {
        state.window = null;
      }

      /* update state and reset the rest of it */
      state.wrap = wrap;
      state.wbits = windowBits;
      return inflateReset(strm);
    }

    function inflateInit2(strm, windowBits) {
      var ret;
      var state;

      if (!strm) { return Z_STREAM_ERROR; }
      //strm.msg = Z_NULL;                 /* in case we return an error */

      state = new InflateState();

      //if (state === Z_NULL) return Z_MEM_ERROR;
      //Tracev((stderr, "inflate: allocated\n"));
      strm.state = state;
      state.window = null/*Z_NULL*/;
      ret = inflateReset2(strm, windowBits);
      if (ret !== Z_OK) {
        strm.state = null/*Z_NULL*/;
      }
      return ret;
    }

    function inflateInit(strm) {
      return inflateInit2(strm, DEF_WBITS);
    }


    /*
     Return state with length and distance decoding tables and index sizes set to
     fixed code decoding.  Normally this returns fixed tables from inffixed.h.
     If BUILDFIXED is defined, then instead this routine builds the tables the
     first time it's called, and returns those tables the first time and
     thereafter.  This reduces the size of the code by about 2K bytes, in
     exchange for a little execution time.  However, BUILDFIXED should not be
     used for threaded applications, since the rewriting of the tables and virgin
     may not be thread-safe.
     */
    var virgin = true;

    var lenfix, distfix; // We have no pointers in JS, so keep tables separate

    function fixedtables(state) {
      /* build fixed huffman tables if first call (may not be thread safe) */
      if (virgin) {
        var sym;

        lenfix = new common.Buf32(512);
        distfix = new common.Buf32(32);

        /* literal/length table */
        sym = 0;
        while (sym < 144) { state.lens[sym++] = 8; }
        while (sym < 256) { state.lens[sym++] = 9; }
        while (sym < 280) { state.lens[sym++] = 7; }
        while (sym < 288) { state.lens[sym++] = 8; }

        inftrees(LENS,  state.lens, 0, 288, lenfix,   0, state.work, { bits: 9 });

        /* distance table */
        sym = 0;
        while (sym < 32) { state.lens[sym++] = 5; }

        inftrees(DISTS, state.lens, 0, 32,   distfix, 0, state.work, { bits: 5 });

        /* do this just once */
        virgin = false;
      }

      state.lencode = lenfix;
      state.lenbits = 9;
      state.distcode = distfix;
      state.distbits = 5;
    }


    /*
     Update the window with the last wsize (normally 32K) bytes written before
     returning.  If window does not exist yet, create it.  This is only called
     when a window is already in use, or when output has been written during this
     inflate call, but the end of the deflate stream has not been reached yet.
     It is also called to create a window for dictionary data when a dictionary
     is loaded.

     Providing output buffers larger than 32K to inflate() should provide a speed
     advantage, since only the last 32K of output is copied to the sliding window
     upon return from inflate(), and since all distances after the first 32K of
     output will fall in the output data, making match copies simpler and faster.
     The advantage may be dependent on the size of the processor's data caches.
     */
    function updatewindow(strm, src, end, copy) {
      var dist;
      var state = strm.state;

      /* if it hasn't been done already, allocate space for the window */
      if (state.window === null) {
        state.wsize = 1 << state.wbits;
        state.wnext = 0;
        state.whave = 0;

        state.window = new common.Buf8(state.wsize);
      }

      /* copy state->wsize or less output bytes into the circular window */
      if (copy >= state.wsize) {
        common.arraySet(state.window, src, end - state.wsize, state.wsize, 0);
        state.wnext = 0;
        state.whave = state.wsize;
      }
      else {
        dist = state.wsize - state.wnext;
        if (dist > copy) {
          dist = copy;
        }
        //zmemcpy(state->window + state->wnext, end - copy, dist);
        common.arraySet(state.window, src, end - copy, dist, state.wnext);
        copy -= dist;
        if (copy) {
          //zmemcpy(state->window, end - copy, copy);
          common.arraySet(state.window, src, end - copy, copy, 0);
          state.wnext = copy;
          state.whave = state.wsize;
        }
        else {
          state.wnext += dist;
          if (state.wnext === state.wsize) { state.wnext = 0; }
          if (state.whave < state.wsize) { state.whave += dist; }
        }
      }
      return 0;
    }

    function inflate$1(strm, flush) {
      var state;
      var input, output;          // input/output buffers
      var next;                   /* next input INDEX */
      var put;                    /* next output INDEX */
      var have, left;             /* available input and output */
      var hold;                   /* bit buffer */
      var bits;                   /* bits in bit buffer */
      var _in, _out;              /* save starting available input and output */
      var copy;                   /* number of stored or match bytes to copy */
      var from;                   /* where to copy match bytes from */
      var from_source;
      var here = 0;               /* current decoding table entry */
      var here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
      //var last;                   /* parent table entry */
      var last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
      var len;                    /* length to copy for repeats, bits to drop */
      var ret;                    /* return code */
      var hbuf = new common.Buf8(4);    /* buffer for gzip header crc calculation */
      var opts;

      var n; // temporary var for NEED_BITS

      var order = /* permutation of code lengths */
        [ 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 ];


      if (!strm || !strm.state || !strm.output ||
          (!strm.input && strm.avail_in !== 0)) {
        return Z_STREAM_ERROR;
      }

      state = strm.state;
      if (state.mode === TYPE) { state.mode = TYPEDO; }    /* skip check */


      //--- LOAD() ---
      put = strm.next_out;
      output = strm.output;
      left = strm.avail_out;
      next = strm.next_in;
      input = strm.input;
      have = strm.avail_in;
      hold = state.hold;
      bits = state.bits;
      //---

      _in = have;
      _out = left;
      ret = Z_OK;

      inf_leave: // goto emulation
      for (;;) {
        switch (state.mode) {
          case HEAD:
            if (state.wrap === 0) {
              state.mode = TYPEDO;
              break;
            }
            //=== NEEDBITS(16);
            while (bits < 16) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((state.wrap & 2) && hold === 0x8b1f) {  /* gzip header */
              state.check = 0/*crc32(0L, Z_NULL, 0)*/;
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32_1(state.check, hbuf, 2, 0);
              //===//

              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
              state.mode = FLAGS;
              break;
            }
            state.flags = 0;           /* expect zlib header */
            if (state.head) {
              state.head.done = false;
            }
            if (!(state.wrap & 1) ||   /* check if zlib header allowed */
              (((hold & 0xff)/*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
              strm.msg = 'incorrect header check';
              state.mode = BAD;
              break;
            }
            if ((hold & 0x0f)/*BITS(4)*/ !== Z_DEFLATED) {
              strm.msg = 'unknown compression method';
              state.mode = BAD;
              break;
            }
            //--- DROPBITS(4) ---//
            hold >>>= 4;
            bits -= 4;
            //---//
            len = (hold & 0x0f)/*BITS(4)*/ + 8;
            if (state.wbits === 0) {
              state.wbits = len;
            }
            else if (len > state.wbits) {
              strm.msg = 'invalid window size';
              state.mode = BAD;
              break;
            }
            state.dmax = 1 << len;
            //Tracev((stderr, "inflate:   zlib header ok\n"));
            strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
            state.mode = hold & 0x200 ? DICTID : TYPE;
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            break;
          case FLAGS:
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.flags = hold;
            if ((state.flags & 0xff) !== Z_DEFLATED) {
              strm.msg = 'unknown compression method';
              state.mode = BAD;
              break;
            }
            if (state.flags & 0xe000) {
              strm.msg = 'unknown header flags set';
              state.mode = BAD;
              break;
            }
            if (state.head) {
              state.head.text = ((hold >> 8) & 1);
            }
            if (state.flags & 0x0200) {
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32_1(state.check, hbuf, 2, 0);
              //===//
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = TIME;
            /* falls through */
          case TIME:
            //=== NEEDBITS(32); */
            while (bits < 32) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if (state.head) {
              state.head.time = hold;
            }
            if (state.flags & 0x0200) {
              //=== CRC4(state.check, hold)
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              hbuf[2] = (hold >>> 16) & 0xff;
              hbuf[3] = (hold >>> 24) & 0xff;
              state.check = crc32_1(state.check, hbuf, 4, 0);
              //===
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = OS;
            /* falls through */
          case OS:
            //=== NEEDBITS(16); */
            while (bits < 16) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if (state.head) {
              state.head.xflags = (hold & 0xff);
              state.head.os = (hold >> 8);
            }
            if (state.flags & 0x0200) {
              //=== CRC2(state.check, hold);
              hbuf[0] = hold & 0xff;
              hbuf[1] = (hold >>> 8) & 0xff;
              state.check = crc32_1(state.check, hbuf, 2, 0);
              //===//
            }
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = EXLEN;
            /* falls through */
          case EXLEN:
            if (state.flags & 0x0400) {
              //=== NEEDBITS(16); */
              while (bits < 16) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.length = hold;
              if (state.head) {
                state.head.extra_len = hold;
              }
              if (state.flags & 0x0200) {
                //=== CRC2(state.check, hold);
                hbuf[0] = hold & 0xff;
                hbuf[1] = (hold >>> 8) & 0xff;
                state.check = crc32_1(state.check, hbuf, 2, 0);
                //===//
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
            }
            else if (state.head) {
              state.head.extra = null/*Z_NULL*/;
            }
            state.mode = EXTRA;
            /* falls through */
          case EXTRA:
            if (state.flags & 0x0400) {
              copy = state.length;
              if (copy > have) { copy = have; }
              if (copy) {
                if (state.head) {
                  len = state.head.extra_len - state.length;
                  if (!state.head.extra) {
                    // Use untyped array for more convenient processing later
                    state.head.extra = new Array(state.head.extra_len);
                  }
                  common.arraySet(
                    state.head.extra,
                    input,
                    next,
                    // extra field is limited to 65536 bytes
                    // - no need for additional size check
                    copy,
                    /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
                    len
                  );
                  //zmemcpy(state.head.extra + len, next,
                  //        len + copy > state.head.extra_max ?
                  //        state.head.extra_max - len : copy);
                }
                if (state.flags & 0x0200) {
                  state.check = crc32_1(state.check, input, copy, next);
                }
                have -= copy;
                next += copy;
                state.length -= copy;
              }
              if (state.length) { break inf_leave; }
            }
            state.length = 0;
            state.mode = NAME;
            /* falls through */
          case NAME:
            if (state.flags & 0x0800) {
              if (have === 0) { break inf_leave; }
              copy = 0;
              do {
                // TODO: 2 or 1 bytes?
                len = input[next + copy++];
                /* use constant limit because in js we should not preallocate memory */
                if (state.head && len &&
                    (state.length < 65536 /*state.head.name_max*/)) {
                  state.head.name += String.fromCharCode(len);
                }
              } while (len && copy < have);

              if (state.flags & 0x0200) {
                state.check = crc32_1(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              if (len) { break inf_leave; }
            }
            else if (state.head) {
              state.head.name = null;
            }
            state.length = 0;
            state.mode = COMMENT;
            /* falls through */
          case COMMENT:
            if (state.flags & 0x1000) {
              if (have === 0) { break inf_leave; }
              copy = 0;
              do {
                len = input[next + copy++];
                /* use constant limit because in js we should not preallocate memory */
                if (state.head && len &&
                    (state.length < 65536 /*state.head.comm_max*/)) {
                  state.head.comment += String.fromCharCode(len);
                }
              } while (len && copy < have);
              if (state.flags & 0x0200) {
                state.check = crc32_1(state.check, input, copy, next);
              }
              have -= copy;
              next += copy;
              if (len) { break inf_leave; }
            }
            else if (state.head) {
              state.head.comment = null;
            }
            state.mode = HCRC;
            /* falls through */
          case HCRC:
            if (state.flags & 0x0200) {
              //=== NEEDBITS(16); */
              while (bits < 16) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              if (hold !== (state.check & 0xffff)) {
                strm.msg = 'header crc mismatch';
                state.mode = BAD;
                break;
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
            }
            if (state.head) {
              state.head.hcrc = ((state.flags >> 9) & 1);
              state.head.done = true;
            }
            strm.adler = state.check = 0;
            state.mode = TYPE;
            break;
          case DICTID:
            //=== NEEDBITS(32); */
            while (bits < 32) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            strm.adler = state.check = zswap32(hold);
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = DICT;
            /* falls through */
          case DICT:
            if (state.havedict === 0) {
              //--- RESTORE() ---
              strm.next_out = put;
              strm.avail_out = left;
              strm.next_in = next;
              strm.avail_in = have;
              state.hold = hold;
              state.bits = bits;
              //---
              return Z_NEED_DICT;
            }
            strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
            state.mode = TYPE;
            /* falls through */
          case TYPE:
            if (flush === Z_BLOCK || flush === Z_TREES) { break inf_leave; }
            /* falls through */
          case TYPEDO:
            if (state.last) {
              //--- BYTEBITS() ---//
              hold >>>= bits & 7;
              bits -= bits & 7;
              //---//
              state.mode = CHECK;
              break;
            }
            //=== NEEDBITS(3); */
            while (bits < 3) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.last = (hold & 0x01)/*BITS(1)*/;
            //--- DROPBITS(1) ---//
            hold >>>= 1;
            bits -= 1;
            //---//

            switch ((hold & 0x03)/*BITS(2)*/) {
              case 0:                             /* stored block */
                //Tracev((stderr, "inflate:     stored block%s\n",
                //        state.last ? " (last)" : ""));
                state.mode = STORED;
                break;
              case 1:                             /* fixed block */
                fixedtables(state);
                //Tracev((stderr, "inflate:     fixed codes block%s\n",
                //        state.last ? " (last)" : ""));
                state.mode = LEN_;             /* decode codes */
                if (flush === Z_TREES) {
                  //--- DROPBITS(2) ---//
                  hold >>>= 2;
                  bits -= 2;
                  //---//
                  break inf_leave;
                }
                break;
              case 2:                             /* dynamic block */
                //Tracev((stderr, "inflate:     dynamic codes block%s\n",
                //        state.last ? " (last)" : ""));
                state.mode = TABLE;
                break;
              case 3:
                strm.msg = 'invalid block type';
                state.mode = BAD;
            }
            //--- DROPBITS(2) ---//
            hold >>>= 2;
            bits -= 2;
            //---//
            break;
          case STORED:
            //--- BYTEBITS() ---// /* go to byte boundary */
            hold >>>= bits & 7;
            bits -= bits & 7;
            //---//
            //=== NEEDBITS(32); */
            while (bits < 32) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
              strm.msg = 'invalid stored block lengths';
              state.mode = BAD;
              break;
            }
            state.length = hold & 0xffff;
            //Tracev((stderr, "inflate:       stored length %u\n",
            //        state.length));
            //=== INITBITS();
            hold = 0;
            bits = 0;
            //===//
            state.mode = COPY_;
            if (flush === Z_TREES) { break inf_leave; }
            /* falls through */
          case COPY_:
            state.mode = COPY;
            /* falls through */
          case COPY:
            copy = state.length;
            if (copy) {
              if (copy > have) { copy = have; }
              if (copy > left) { copy = left; }
              if (copy === 0) { break inf_leave; }
              //--- zmemcpy(put, next, copy); ---
              common.arraySet(output, input, next, copy, put);
              //---//
              have -= copy;
              next += copy;
              left -= copy;
              put += copy;
              state.length -= copy;
              break;
            }
            //Tracev((stderr, "inflate:       stored end\n"));
            state.mode = TYPE;
            break;
          case TABLE:
            //=== NEEDBITS(14); */
            while (bits < 14) {
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
            }
            //===//
            state.nlen = (hold & 0x1f)/*BITS(5)*/ + 257;
            //--- DROPBITS(5) ---//
            hold >>>= 5;
            bits -= 5;
            //---//
            state.ndist = (hold & 0x1f)/*BITS(5)*/ + 1;
            //--- DROPBITS(5) ---//
            hold >>>= 5;
            bits -= 5;
            //---//
            state.ncode = (hold & 0x0f)/*BITS(4)*/ + 4;
            //--- DROPBITS(4) ---//
            hold >>>= 4;
            bits -= 4;
            //---//
    //#ifndef PKZIP_BUG_WORKAROUND
            if (state.nlen > 286 || state.ndist > 30) {
              strm.msg = 'too many length or distance symbols';
              state.mode = BAD;
              break;
            }
    //#endif
            //Tracev((stderr, "inflate:       table sizes ok\n"));
            state.have = 0;
            state.mode = LENLENS;
            /* falls through */
          case LENLENS:
            while (state.have < state.ncode) {
              //=== NEEDBITS(3);
              while (bits < 3) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.lens[order[state.have++]] = (hold & 0x07);//BITS(3);
              //--- DROPBITS(3) ---//
              hold >>>= 3;
              bits -= 3;
              //---//
            }
            while (state.have < 19) {
              state.lens[order[state.have++]] = 0;
            }
            // We have separate tables & no pointers. 2 commented lines below not needed.
            //state.next = state.codes;
            //state.lencode = state.next;
            // Switch to use dynamic table
            state.lencode = state.lendyn;
            state.lenbits = 7;

            opts = { bits: state.lenbits };
            ret = inftrees(CODES, state.lens, 0, 19, state.lencode, 0, state.work, opts);
            state.lenbits = opts.bits;

            if (ret) {
              strm.msg = 'invalid code lengths set';
              state.mode = BAD;
              break;
            }
            //Tracev((stderr, "inflate:       code lengths ok\n"));
            state.have = 0;
            state.mode = CODELENS;
            /* falls through */
          case CODELENS:
            while (state.have < state.nlen + state.ndist) {
              for (;;) {
                here = state.lencode[hold & ((1 << state.lenbits) - 1)];/*BITS(state.lenbits)*/
                here_bits = here >>> 24;
                here_op = (here >>> 16) & 0xff;
                here_val = here & 0xffff;

                if ((here_bits) <= bits) { break; }
                //--- PULLBYTE() ---//
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
                //---//
              }
              if (here_val < 16) {
                //--- DROPBITS(here.bits) ---//
                hold >>>= here_bits;
                bits -= here_bits;
                //---//
                state.lens[state.have++] = here_val;
              }
              else {
                if (here_val === 16) {
                  //=== NEEDBITS(here.bits + 2);
                  n = here_bits + 2;
                  while (bits < n) {
                    if (have === 0) { break inf_leave; }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  //===//
                  //--- DROPBITS(here.bits) ---//
                  hold >>>= here_bits;
                  bits -= here_bits;
                  //---//
                  if (state.have === 0) {
                    strm.msg = 'invalid bit length repeat';
                    state.mode = BAD;
                    break;
                  }
                  len = state.lens[state.have - 1];
                  copy = 3 + (hold & 0x03);//BITS(2);
                  //--- DROPBITS(2) ---//
                  hold >>>= 2;
                  bits -= 2;
                  //---//
                }
                else if (here_val === 17) {
                  //=== NEEDBITS(here.bits + 3);
                  n = here_bits + 3;
                  while (bits < n) {
                    if (have === 0) { break inf_leave; }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  //===//
                  //--- DROPBITS(here.bits) ---//
                  hold >>>= here_bits;
                  bits -= here_bits;
                  //---//
                  len = 0;
                  copy = 3 + (hold & 0x07);//BITS(3);
                  //--- DROPBITS(3) ---//
                  hold >>>= 3;
                  bits -= 3;
                  //---//
                }
                else {
                  //=== NEEDBITS(here.bits + 7);
                  n = here_bits + 7;
                  while (bits < n) {
                    if (have === 0) { break inf_leave; }
                    have--;
                    hold += input[next++] << bits;
                    bits += 8;
                  }
                  //===//
                  //--- DROPBITS(here.bits) ---//
                  hold >>>= here_bits;
                  bits -= here_bits;
                  //---//
                  len = 0;
                  copy = 11 + (hold & 0x7f);//BITS(7);
                  //--- DROPBITS(7) ---//
                  hold >>>= 7;
                  bits -= 7;
                  //---//
                }
                if (state.have + copy > state.nlen + state.ndist) {
                  strm.msg = 'invalid bit length repeat';
                  state.mode = BAD;
                  break;
                }
                while (copy--) {
                  state.lens[state.have++] = len;
                }
              }
            }

            /* handle error breaks in while */
            if (state.mode === BAD) { break; }

            /* check for end-of-block code (better have one) */
            if (state.lens[256] === 0) {
              strm.msg = 'invalid code -- missing end-of-block';
              state.mode = BAD;
              break;
            }

            /* build code tables -- note: do not change the lenbits or distbits
               values here (9 and 6) without reading the comments in inftrees.h
               concerning the ENOUGH constants, which depend on those values */
            state.lenbits = 9;

            opts = { bits: state.lenbits };
            ret = inftrees(LENS, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
            // We have separate tables & no pointers. 2 commented lines below not needed.
            // state.next_index = opts.table_index;
            state.lenbits = opts.bits;
            // state.lencode = state.next;

            if (ret) {
              strm.msg = 'invalid literal/lengths set';
              state.mode = BAD;
              break;
            }

            state.distbits = 6;
            //state.distcode.copy(state.codes);
            // Switch to use dynamic table
            state.distcode = state.distdyn;
            opts = { bits: state.distbits };
            ret = inftrees(DISTS, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
            // We have separate tables & no pointers. 2 commented lines below not needed.
            // state.next_index = opts.table_index;
            state.distbits = opts.bits;
            // state.distcode = state.next;

            if (ret) {
              strm.msg = 'invalid distances set';
              state.mode = BAD;
              break;
            }
            //Tracev((stderr, 'inflate:       codes ok\n'));
            state.mode = LEN_;
            if (flush === Z_TREES) { break inf_leave; }
            /* falls through */
          case LEN_:
            state.mode = LEN;
            /* falls through */
          case LEN:
            if (have >= 6 && left >= 258) {
              //--- RESTORE() ---
              strm.next_out = put;
              strm.avail_out = left;
              strm.next_in = next;
              strm.avail_in = have;
              state.hold = hold;
              state.bits = bits;
              //---
              inffast(strm, _out);
              //--- LOAD() ---
              put = strm.next_out;
              output = strm.output;
              left = strm.avail_out;
              next = strm.next_in;
              input = strm.input;
              have = strm.avail_in;
              hold = state.hold;
              bits = state.bits;
              //---

              if (state.mode === TYPE) {
                state.back = -1;
              }
              break;
            }
            state.back = 0;
            for (;;) {
              here = state.lencode[hold & ((1 << state.lenbits) - 1)];  /*BITS(state.lenbits)*/
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if (here_bits <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            if (here_op && (here_op & 0xf0) === 0) {
              last_bits = here_bits;
              last_op = here_op;
              last_val = here_val;
              for (;;) {
                here = state.lencode[last_val +
                        ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
                here_bits = here >>> 24;
                here_op = (here >>> 16) & 0xff;
                here_val = here & 0xffff;

                if ((last_bits + here_bits) <= bits) { break; }
                //--- PULLBYTE() ---//
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
                //---//
              }
              //--- DROPBITS(last.bits) ---//
              hold >>>= last_bits;
              bits -= last_bits;
              //---//
              state.back += last_bits;
            }
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            state.back += here_bits;
            state.length = here_val;
            if (here_op === 0) {
              //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
              //        "inflate:         literal '%c'\n" :
              //        "inflate:         literal 0x%02x\n", here.val));
              state.mode = LIT;
              break;
            }
            if (here_op & 32) {
              //Tracevv((stderr, "inflate:         end of block\n"));
              state.back = -1;
              state.mode = TYPE;
              break;
            }
            if (here_op & 64) {
              strm.msg = 'invalid literal/length code';
              state.mode = BAD;
              break;
            }
            state.extra = here_op & 15;
            state.mode = LENEXT;
            /* falls through */
          case LENEXT:
            if (state.extra) {
              //=== NEEDBITS(state.extra);
              n = state.extra;
              while (bits < n) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.length += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
              //--- DROPBITS(state.extra) ---//
              hold >>>= state.extra;
              bits -= state.extra;
              //---//
              state.back += state.extra;
            }
            //Tracevv((stderr, "inflate:         length %u\n", state.length));
            state.was = state.length;
            state.mode = DIST;
            /* falls through */
          case DIST:
            for (;;) {
              here = state.distcode[hold & ((1 << state.distbits) - 1)];/*BITS(state.distbits)*/
              here_bits = here >>> 24;
              here_op = (here >>> 16) & 0xff;
              here_val = here & 0xffff;

              if ((here_bits) <= bits) { break; }
              //--- PULLBYTE() ---//
              if (have === 0) { break inf_leave; }
              have--;
              hold += input[next++] << bits;
              bits += 8;
              //---//
            }
            if ((here_op & 0xf0) === 0) {
              last_bits = here_bits;
              last_op = here_op;
              last_val = here_val;
              for (;;) {
                here = state.distcode[last_val +
                        ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
                here_bits = here >>> 24;
                here_op = (here >>> 16) & 0xff;
                here_val = here & 0xffff;

                if ((last_bits + here_bits) <= bits) { break; }
                //--- PULLBYTE() ---//
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
                //---//
              }
              //--- DROPBITS(last.bits) ---//
              hold >>>= last_bits;
              bits -= last_bits;
              //---//
              state.back += last_bits;
            }
            //--- DROPBITS(here.bits) ---//
            hold >>>= here_bits;
            bits -= here_bits;
            //---//
            state.back += here_bits;
            if (here_op & 64) {
              strm.msg = 'invalid distance code';
              state.mode = BAD;
              break;
            }
            state.offset = here_val;
            state.extra = (here_op) & 15;
            state.mode = DISTEXT;
            /* falls through */
          case DISTEXT:
            if (state.extra) {
              //=== NEEDBITS(state.extra);
              n = state.extra;
              while (bits < n) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              state.offset += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
              //--- DROPBITS(state.extra) ---//
              hold >>>= state.extra;
              bits -= state.extra;
              //---//
              state.back += state.extra;
            }
    //#ifdef INFLATE_STRICT
            if (state.offset > state.dmax) {
              strm.msg = 'invalid distance too far back';
              state.mode = BAD;
              break;
            }
    //#endif
            //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
            state.mode = MATCH;
            /* falls through */
          case MATCH:
            if (left === 0) { break inf_leave; }
            copy = _out - left;
            if (state.offset > copy) {         /* copy from window */
              copy = state.offset - copy;
              if (copy > state.whave) {
                if (state.sane) {
                  strm.msg = 'invalid distance too far back';
                  state.mode = BAD;
                  break;
                }
    // (!) This block is disabled in zlib defaults,
    // don't enable it for binary compatibility
    //#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
    //          Trace((stderr, "inflate.c too far\n"));
    //          copy -= state.whave;
    //          if (copy > state.length) { copy = state.length; }
    //          if (copy > left) { copy = left; }
    //          left -= copy;
    //          state.length -= copy;
    //          do {
    //            output[put++] = 0;
    //          } while (--copy);
    //          if (state.length === 0) { state.mode = LEN; }
    //          break;
    //#endif
              }
              if (copy > state.wnext) {
                copy -= state.wnext;
                from = state.wsize - copy;
              }
              else {
                from = state.wnext - copy;
              }
              if (copy > state.length) { copy = state.length; }
              from_source = state.window;
            }
            else {                              /* copy from output */
              from_source = output;
              from = put - state.offset;
              copy = state.length;
            }
            if (copy > left) { copy = left; }
            left -= copy;
            state.length -= copy;
            do {
              output[put++] = from_source[from++];
            } while (--copy);
            if (state.length === 0) { state.mode = LEN; }
            break;
          case LIT:
            if (left === 0) { break inf_leave; }
            output[put++] = state.length;
            left--;
            state.mode = LEN;
            break;
          case CHECK:
            if (state.wrap) {
              //=== NEEDBITS(32);
              while (bits < 32) {
                if (have === 0) { break inf_leave; }
                have--;
                // Use '|' instead of '+' to make sure that result is signed
                hold |= input[next++] << bits;
                bits += 8;
              }
              //===//
              _out -= left;
              strm.total_out += _out;
              state.total += _out;
              if (_out) {
                strm.adler = state.check =
                    /*UPDATE(state.check, put - _out, _out);*/
                    (state.flags ? crc32_1(state.check, output, _out, put - _out) : adler32_1(state.check, output, _out, put - _out));

              }
              _out = left;
              // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
              if ((state.flags ? hold : zswap32(hold)) !== state.check) {
                strm.msg = 'incorrect data check';
                state.mode = BAD;
                break;
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
              //Tracev((stderr, "inflate:   check matches trailer\n"));
            }
            state.mode = LENGTH;
            /* falls through */
          case LENGTH:
            if (state.wrap && state.flags) {
              //=== NEEDBITS(32);
              while (bits < 32) {
                if (have === 0) { break inf_leave; }
                have--;
                hold += input[next++] << bits;
                bits += 8;
              }
              //===//
              if (hold !== (state.total & 0xffffffff)) {
                strm.msg = 'incorrect length check';
                state.mode = BAD;
                break;
              }
              //=== INITBITS();
              hold = 0;
              bits = 0;
              //===//
              //Tracev((stderr, "inflate:   length matches trailer\n"));
            }
            state.mode = DONE;
            /* falls through */
          case DONE:
            ret = Z_STREAM_END;
            break inf_leave;
          case BAD:
            ret = Z_DATA_ERROR;
            break inf_leave;
          case MEM:
            return Z_MEM_ERROR;
          case SYNC:
            /* falls through */
          default:
            return Z_STREAM_ERROR;
        }
      }

      // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

      /*
         Return from inflate(), updating the total counts and the check value.
         If there was no progress during the inflate() call, return a buffer
         error.  Call updatewindow() to create and/or update the window state.
         Note: a memory error from inflate() is non-recoverable.
       */

      //--- RESTORE() ---
      strm.next_out = put;
      strm.avail_out = left;
      strm.next_in = next;
      strm.avail_in = have;
      state.hold = hold;
      state.bits = bits;
      //---

      if (state.wsize || (_out !== strm.avail_out && state.mode < BAD &&
                          (state.mode < CHECK || flush !== Z_FINISH))) {
        if (updatewindow(strm, strm.output, strm.next_out, _out - strm.avail_out)) ;
      }
      _in -= strm.avail_in;
      _out -= strm.avail_out;
      strm.total_in += _in;
      strm.total_out += _out;
      state.total += _out;
      if (state.wrap && _out) {
        strm.adler = state.check = /*UPDATE(state.check, strm.next_out - _out, _out);*/
          (state.flags ? crc32_1(state.check, output, _out, strm.next_out - _out) : adler32_1(state.check, output, _out, strm.next_out - _out));
      }
      strm.data_type = state.bits + (state.last ? 64 : 0) +
                        (state.mode === TYPE ? 128 : 0) +
                        (state.mode === LEN_ || state.mode === COPY_ ? 256 : 0);
      if (((_in === 0 && _out === 0) || flush === Z_FINISH) && ret === Z_OK) {
        ret = Z_BUF_ERROR;
      }
      return ret;
    }

    function inflateEnd(strm) {

      if (!strm || !strm.state /*|| strm->zfree == (free_func)0*/) {
        return Z_STREAM_ERROR;
      }

      var state = strm.state;
      if (state.window) {
        state.window = null;
      }
      strm.state = null;
      return Z_OK;
    }

    function inflateGetHeader(strm, head) {
      var state;

      /* check state */
      if (!strm || !strm.state) { return Z_STREAM_ERROR; }
      state = strm.state;
      if ((state.wrap & 2) === 0) { return Z_STREAM_ERROR; }

      /* save header structure */
      state.head = head;
      head.done = false;
      return Z_OK;
    }

    function inflateSetDictionary(strm, dictionary) {
      var dictLength = dictionary.length;

      var state;
      var dictid;
      var ret;

      /* check state */
      if (!strm /* == Z_NULL */ || !strm.state /* == Z_NULL */) { return Z_STREAM_ERROR; }
      state = strm.state;

      if (state.wrap !== 0 && state.mode !== DICT) {
        return Z_STREAM_ERROR;
      }

      /* check for correct dictionary identifier */
      if (state.mode === DICT) {
        dictid = 1; /* adler32(0, null, 0)*/
        /* dictid = adler32(dictid, dictionary, dictLength); */
        dictid = adler32_1(dictid, dictionary, dictLength, 0);
        if (dictid !== state.check) {
          return Z_DATA_ERROR;
        }
      }
      /* copy dictionary to window using updatewindow(), which will amend the
       existing dictionary if appropriate */
      ret = updatewindow(strm, dictionary, dictLength, dictLength);
      if (ret) {
        state.mode = MEM;
        return Z_MEM_ERROR;
      }
      state.havedict = 1;
      // Tracev((stderr, "inflate:   dictionary set\n"));
      return Z_OK;
    }

    var inflateReset_1 = inflateReset;
    var inflateReset2_1 = inflateReset2;
    var inflateResetKeep_1 = inflateResetKeep;
    var inflateInit_1 = inflateInit;
    var inflateInit2_1 = inflateInit2;
    var inflate_2$1 = inflate$1;
    var inflateEnd_1 = inflateEnd;
    var inflateGetHeader_1 = inflateGetHeader;
    var inflateSetDictionary_1 = inflateSetDictionary;
    var inflateInfo = 'pako inflate (from Nodeca project)';

    /* Not implemented
    exports.inflateCopy = inflateCopy;
    exports.inflateGetDictionary = inflateGetDictionary;
    exports.inflateMark = inflateMark;
    exports.inflatePrime = inflatePrime;
    exports.inflateSync = inflateSync;
    exports.inflateSyncPoint = inflateSyncPoint;
    exports.inflateUndermine = inflateUndermine;
    */

    var inflate_1$1 = {
    	inflateReset: inflateReset_1,
    	inflateReset2: inflateReset2_1,
    	inflateResetKeep: inflateResetKeep_1,
    	inflateInit: inflateInit_1,
    	inflateInit2: inflateInit2_1,
    	inflate: inflate_2$1,
    	inflateEnd: inflateEnd_1,
    	inflateGetHeader: inflateGetHeader_1,
    	inflateSetDictionary: inflateSetDictionary_1,
    	inflateInfo: inflateInfo
    };

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    var constants = {

      /* Allowed flush values; see deflate() and inflate() below for details */
      Z_NO_FLUSH:         0,
      Z_PARTIAL_FLUSH:    1,
      Z_SYNC_FLUSH:       2,
      Z_FULL_FLUSH:       3,
      Z_FINISH:           4,
      Z_BLOCK:            5,
      Z_TREES:            6,

      /* Return codes for the compression/decompression functions. Negative values
      * are errors, positive values are used for special but normal events.
      */
      Z_OK:               0,
      Z_STREAM_END:       1,
      Z_NEED_DICT:        2,
      Z_ERRNO:           -1,
      Z_STREAM_ERROR:    -2,
      Z_DATA_ERROR:      -3,
      //Z_MEM_ERROR:     -4,
      Z_BUF_ERROR:       -5,
      //Z_VERSION_ERROR: -6,

      /* compression levels */
      Z_NO_COMPRESSION:         0,
      Z_BEST_SPEED:             1,
      Z_BEST_COMPRESSION:       9,
      Z_DEFAULT_COMPRESSION:   -1,


      Z_FILTERED:               1,
      Z_HUFFMAN_ONLY:           2,
      Z_RLE:                    3,
      Z_FIXED:                  4,
      Z_DEFAULT_STRATEGY:       0,

      /* Possible values of the data_type field (though see inflate()) */
      Z_BINARY:                 0,
      Z_TEXT:                   1,
      //Z_ASCII:                1, // = Z_TEXT (deprecated)
      Z_UNKNOWN:                2,

      /* The deflate compression method */
      Z_DEFLATED:               8
      //Z_NULL:                 null // Use -1 or null inline, depending on var type
    };
    constants.Z_NO_FLUSH;
    constants.Z_PARTIAL_FLUSH;
    constants.Z_SYNC_FLUSH;
    constants.Z_FULL_FLUSH;
    constants.Z_FINISH;
    constants.Z_BLOCK;
    constants.Z_TREES;
    constants.Z_OK;
    constants.Z_STREAM_END;
    constants.Z_NEED_DICT;
    constants.Z_ERRNO;
    constants.Z_STREAM_ERROR;
    constants.Z_DATA_ERROR;
    constants.Z_BUF_ERROR;
    constants.Z_NO_COMPRESSION;
    constants.Z_BEST_SPEED;
    constants.Z_BEST_COMPRESSION;
    constants.Z_DEFAULT_COMPRESSION;
    constants.Z_FILTERED;
    constants.Z_HUFFMAN_ONLY;
    constants.Z_RLE;
    constants.Z_FIXED;
    constants.Z_DEFAULT_STRATEGY;
    constants.Z_BINARY;
    constants.Z_TEXT;
    constants.Z_UNKNOWN;
    constants.Z_DEFLATED;

    // (C) 1995-2013 Jean-loup Gailly and Mark Adler
    // (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
    //
    // This software is provided 'as-is', without any express or implied
    // warranty. In no event will the authors be held liable for any damages
    // arising from the use of this software.
    //
    // Permission is granted to anyone to use this software for any purpose,
    // including commercial applications, and to alter it and redistribute it
    // freely, subject to the following restrictions:
    //
    // 1. The origin of this software must not be misrepresented; you must not
    //   claim that you wrote the original software. If you use this software
    //   in a product, an acknowledgment in the product documentation would be
    //   appreciated but is not required.
    // 2. Altered source versions must be plainly marked as such, and must not be
    //   misrepresented as being the original software.
    // 3. This notice may not be removed or altered from any source distribution.

    function GZheader() {
      /* true if compressed data believed to be text */
      this.text       = 0;
      /* modification time */
      this.time       = 0;
      /* extra flags (not used when writing a gzip file) */
      this.xflags     = 0;
      /* operating system */
      this.os         = 0;
      /* pointer to extra field or Z_NULL if none */
      this.extra      = null;
      /* extra field length (valid if extra != Z_NULL) */
      this.extra_len  = 0; // Actually, we don't need it in JS,
                           // but leave for few code modifications

      //
      // Setup limits is not necessary because in js we should not preallocate memory
      // for inflate use constant limit in 65536 bytes
      //

      /* space at extra (only when reading header) */
      // this.extra_max  = 0;
      /* pointer to zero-terminated file name or Z_NULL */
      this.name       = '';
      /* space at name (only when reading header) */
      // this.name_max   = 0;
      /* pointer to zero-terminated comment or Z_NULL */
      this.comment    = '';
      /* space at comment (only when reading header) */
      // this.comm_max   = 0;
      /* true if there was or will be a header crc */
      this.hcrc       = 0;
      /* true when done reading gzip header (not used when writing a gzip file) */
      this.done       = false;
    }

    var gzheader = GZheader;

    var toString = Object.prototype.toString;

    /**
     * class Inflate
     *
     * Generic JS-style wrapper for zlib calls. If you don't need
     * streaming behaviour - use more simple functions: [[inflate]]
     * and [[inflateRaw]].
     **/

    /* internal
     * inflate.chunks -> Array
     *
     * Chunks of output data, if [[Inflate#onData]] not overridden.
     **/

    /**
     * Inflate.result -> Uint8Array|Array|String
     *
     * Uncompressed result, generated by default [[Inflate#onData]]
     * and [[Inflate#onEnd]] handlers. Filled after you push last chunk
     * (call [[Inflate#push]] with `Z_FINISH` / `true` param) or if you
     * push a chunk with explicit flush (call [[Inflate#push]] with
     * `Z_SYNC_FLUSH` param).
     **/

    /**
     * Inflate.err -> Number
     *
     * Error code after inflate finished. 0 (Z_OK) on success.
     * Should be checked if broken data possible.
     **/

    /**
     * Inflate.msg -> String
     *
     * Error message, if [[Inflate.err]] != 0
     **/


    /**
     * new Inflate(options)
     * - options (Object): zlib inflate options.
     *
     * Creates new inflator instance with specified params. Throws exception
     * on bad params. Supported options:
     *
     * - `windowBits`
     * - `dictionary`
     *
     * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
     * for more information on these.
     *
     * Additional options, for internal needs:
     *
     * - `chunkSize` - size of generated data chunks (16K by default)
     * - `raw` (Boolean) - do raw inflate
     * - `to` (String) - if equal to 'string', then result will be converted
     *   from utf8 to utf16 (javascript) string. When string output requested,
     *   chunk length can differ from `chunkSize`, depending on content.
     *
     * By default, when no options set, autodetect deflate/gzip data format via
     * wrapper header.
     *
     * ##### Example:
     *
     * ```javascript
     * var pako = require('pako')
     *   , chunk1 = Uint8Array([1,2,3,4,5,6,7,8,9])
     *   , chunk2 = Uint8Array([10,11,12,13,14,15,16,17,18,19]);
     *
     * var inflate = new pako.Inflate({ level: 3});
     *
     * inflate.push(chunk1, false);
     * inflate.push(chunk2, true);  // true -> last chunk
     *
     * if (inflate.err) { throw new Error(inflate.err); }
     *
     * console.log(inflate.result);
     * ```
     **/
    function Inflate(options) {
      if (!(this instanceof Inflate)) return new Inflate(options);

      this.options = common.assign({
        chunkSize: 16384,
        windowBits: 0,
        to: ''
      }, options || {});

      var opt = this.options;

      // Force window size for `raw` data, if not set directly,
      // because we have no header for autodetect.
      if (opt.raw && (opt.windowBits >= 0) && (opt.windowBits < 16)) {
        opt.windowBits = -opt.windowBits;
        if (opt.windowBits === 0) { opt.windowBits = -15; }
      }

      // If `windowBits` not defined (and mode not raw) - set autodetect flag for gzip/deflate
      if ((opt.windowBits >= 0) && (opt.windowBits < 16) &&
          !(options && options.windowBits)) {
        opt.windowBits += 32;
      }

      // Gzip header has no info about windows size, we can do autodetect only
      // for deflate. So, if window size not set, force it to max when gzip possible
      if ((opt.windowBits > 15) && (opt.windowBits < 48)) {
        // bit 3 (16) -> gzipped data
        // bit 4 (32) -> autodetect gzip/deflate
        if ((opt.windowBits & 15) === 0) {
          opt.windowBits |= 15;
        }
      }

      this.err    = 0;      // error code, if happens (0 = Z_OK)
      this.msg    = '';     // error message
      this.ended  = false;  // used to avoid multiple onEnd() calls
      this.chunks = [];     // chunks of compressed data

      this.strm   = new zstream();
      this.strm.avail_out = 0;

      var status  = inflate_1$1.inflateInit2(
        this.strm,
        opt.windowBits
      );

      if (status !== constants.Z_OK) {
        throw new Error(messages[status]);
      }

      this.header = new gzheader();

      inflate_1$1.inflateGetHeader(this.strm, this.header);

      // Setup dictionary
      if (opt.dictionary) {
        // Convert data if needed
        if (typeof opt.dictionary === 'string') {
          opt.dictionary = strings.string2buf(opt.dictionary);
        } else if (toString.call(opt.dictionary) === '[object ArrayBuffer]') {
          opt.dictionary = new Uint8Array(opt.dictionary);
        }
        if (opt.raw) { //In raw mode we need to set the dictionary early
          status = inflate_1$1.inflateSetDictionary(this.strm, opt.dictionary);
          if (status !== constants.Z_OK) {
            throw new Error(messages[status]);
          }
        }
      }
    }

    /**
     * Inflate#push(data[, mode]) -> Boolean
     * - data (Uint8Array|Array|ArrayBuffer|String): input data
     * - mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE modes.
     *   See constants. Skipped or `false` means Z_NO_FLUSH, `true` means Z_FINISH.
     *
     * Sends input data to inflate pipe, generating [[Inflate#onData]] calls with
     * new output chunks. Returns `true` on success. The last data block must have
     * mode Z_FINISH (or `true`). That will flush internal pending buffers and call
     * [[Inflate#onEnd]]. For interim explicit flushes (without ending the stream) you
     * can use mode Z_SYNC_FLUSH, keeping the decompression context.
     *
     * On fail call [[Inflate#onEnd]] with error code and return false.
     *
     * We strongly recommend to use `Uint8Array` on input for best speed (output
     * format is detected automatically). Also, don't skip last param and always
     * use the same type in your code (boolean or number). That will improve JS speed.
     *
     * For regular `Array`-s make sure all elements are [0..255].
     *
     * ##### Example
     *
     * ```javascript
     * push(chunk, false); // push one of data chunks
     * ...
     * push(chunk, true);  // push last chunk
     * ```
     **/
    Inflate.prototype.push = function (data, mode) {
      var strm = this.strm;
      var chunkSize = this.options.chunkSize;
      var dictionary = this.options.dictionary;
      var status, _mode;
      var next_out_utf8, tail, utf8str;

      // Flag to properly process Z_BUF_ERROR on testing inflate call
      // when we check that all output data was flushed.
      var allowBufError = false;

      if (this.ended) { return false; }
      _mode = (mode === ~~mode) ? mode : ((mode === true) ? constants.Z_FINISH : constants.Z_NO_FLUSH);

      // Convert data if needed
      if (typeof data === 'string') {
        // Only binary strings can be decompressed on practice
        strm.input = strings.binstring2buf(data);
      } else if (toString.call(data) === '[object ArrayBuffer]') {
        strm.input = new Uint8Array(data);
      } else {
        strm.input = data;
      }

      strm.next_in = 0;
      strm.avail_in = strm.input.length;

      do {
        if (strm.avail_out === 0) {
          strm.output = new common.Buf8(chunkSize);
          strm.next_out = 0;
          strm.avail_out = chunkSize;
        }

        status = inflate_1$1.inflate(strm, constants.Z_NO_FLUSH);    /* no bad return value */

        if (status === constants.Z_NEED_DICT && dictionary) {
          status = inflate_1$1.inflateSetDictionary(this.strm, dictionary);
        }

        if (status === constants.Z_BUF_ERROR && allowBufError === true) {
          status = constants.Z_OK;
          allowBufError = false;
        }

        if (status !== constants.Z_STREAM_END && status !== constants.Z_OK) {
          this.onEnd(status);
          this.ended = true;
          return false;
        }

        if (strm.next_out) {
          if (strm.avail_out === 0 || status === constants.Z_STREAM_END || (strm.avail_in === 0 && (_mode === constants.Z_FINISH || _mode === constants.Z_SYNC_FLUSH))) {

            if (this.options.to === 'string') {

              next_out_utf8 = strings.utf8border(strm.output, strm.next_out);

              tail = strm.next_out - next_out_utf8;
              utf8str = strings.buf2string(strm.output, next_out_utf8);

              // move tail
              strm.next_out = tail;
              strm.avail_out = chunkSize - tail;
              if (tail) { common.arraySet(strm.output, strm.output, next_out_utf8, tail, 0); }

              this.onData(utf8str);

            } else {
              this.onData(common.shrinkBuf(strm.output, strm.next_out));
            }
          }
        }

        // When no more input data, we should check that internal inflate buffers
        // are flushed. The only way to do it when avail_out = 0 - run one more
        // inflate pass. But if output data not exists, inflate return Z_BUF_ERROR.
        // Here we set flag to process this error properly.
        //
        // NOTE. Deflate does not return error in this case and does not needs such
        // logic.
        if (strm.avail_in === 0 && strm.avail_out === 0) {
          allowBufError = true;
        }

      } while ((strm.avail_in > 0 || strm.avail_out === 0) && status !== constants.Z_STREAM_END);

      if (status === constants.Z_STREAM_END) {
        _mode = constants.Z_FINISH;
      }

      // Finalize on the last chunk.
      if (_mode === constants.Z_FINISH) {
        status = inflate_1$1.inflateEnd(this.strm);
        this.onEnd(status);
        this.ended = true;
        return status === constants.Z_OK;
      }

      // callback interim results if Z_SYNC_FLUSH.
      if (_mode === constants.Z_SYNC_FLUSH) {
        this.onEnd(constants.Z_OK);
        strm.avail_out = 0;
        return true;
      }

      return true;
    };


    /**
     * Inflate#onData(chunk) -> Void
     * - chunk (Uint8Array|Array|String): output data. Type of array depends
     *   on js engine support. When string output requested, each chunk
     *   will be string.
     *
     * By default, stores data blocks in `chunks[]` property and glue
     * those in `onEnd`. Override this handler, if you need another behaviour.
     **/
    Inflate.prototype.onData = function (chunk) {
      this.chunks.push(chunk);
    };


    /**
     * Inflate#onEnd(status) -> Void
     * - status (Number): inflate status. 0 (Z_OK) on success,
     *   other if not.
     *
     * Called either after you tell inflate that the input stream is
     * complete (Z_FINISH) or should be flushed (Z_SYNC_FLUSH)
     * or if an error happened. By default - join collected chunks,
     * free memory and fill `results` / `err` properties.
     **/
    Inflate.prototype.onEnd = function (status) {
      // On success - join
      if (status === constants.Z_OK) {
        if (this.options.to === 'string') {
          // Glue & convert here, until we teach pako to send
          // utf8 aligned strings to onData
          this.result = this.chunks.join('');
        } else {
          this.result = common.flattenChunks(this.chunks);
        }
      }
      this.chunks = [];
      this.err = status;
      this.msg = this.strm.msg;
    };


    /**
     * inflate(data[, options]) -> Uint8Array|Array|String
     * - data (Uint8Array|Array|String): input data to decompress.
     * - options (Object): zlib inflate options.
     *
     * Decompress `data` with inflate/ungzip and `options`. Autodetect
     * format via wrapper header by default. That's why we don't provide
     * separate `ungzip` method.
     *
     * Supported options are:
     *
     * - windowBits
     *
     * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
     * for more information.
     *
     * Sugar (options):
     *
     * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
     *   negative windowBits implicitly.
     * - `to` (String) - if equal to 'string', then result will be converted
     *   from utf8 to utf16 (javascript) string. When string output requested,
     *   chunk length can differ from `chunkSize`, depending on content.
     *
     *
     * ##### Example:
     *
     * ```javascript
     * var pako = require('pako')
     *   , input = pako.deflate([1,2,3,4,5,6,7,8,9])
     *   , output;
     *
     * try {
     *   output = pako.inflate(input);
     * } catch (err)
     *   console.log(err);
     * }
     * ```
     **/
    function inflate(input, options) {
      var inflator = new Inflate(options);

      inflator.push(input, true);

      // That will never happens, if you don't cheat with options :)
      if (inflator.err) { throw inflator.msg || messages[inflator.err]; }

      return inflator.result;
    }


    /**
     * inflateRaw(data[, options]) -> Uint8Array|Array|String
     * - data (Uint8Array|Array|String): input data to decompress.
     * - options (Object): zlib inflate options.
     *
     * The same as [[inflate]], but creates raw data, without wrapper
     * (header and adler32 crc).
     **/
    function inflateRaw(input, options) {
      options = options || {};
      options.raw = true;
      return inflate(input, options);
    }


    /**
     * ungzip(data[, options]) -> Uint8Array|Array|String
     * - data (Uint8Array|Array|String): input data to decompress.
     * - options (Object): zlib inflate options.
     *
     * Just shortcut to [[inflate]], because it autodetects format
     * by header.content. Done for convenience.
     **/


    var Inflate_1 = Inflate;
    var inflate_2 = inflate;
    var inflateRaw_1 = inflateRaw;
    var ungzip  = inflate;

    var inflate_1 = {
    	Inflate: Inflate_1,
    	inflate: inflate_2,
    	inflateRaw: inflateRaw_1,
    	ungzip: ungzip
    };

    var assign    = common.assign;





    var pako = {};

    assign(pako, deflate_1, inflate_1, constants);

    var _pako_1_0_11_pako = pako;

    var USE_TYPEDARRAY = (typeof Uint8Array !== 'undefined') && (typeof Uint16Array !== 'undefined') && (typeof Uint32Array !== 'undefined');


    var uncompressInputType = USE_TYPEDARRAY ? "uint8array" : "array";
    var compressInputType = USE_TYPEDARRAY ? "uint8array" : "array";

    var magic = "\x08\x00";
    var compress = function(input, compressionOptions) {
        return _pako_1_0_11_pako.deflateRaw(input, {
            level : compressionOptions.level || -1 // default compression
        });
    };
    var uncompress =  function(input) {
        return _pako_1_0_11_pako.inflateRaw(input);
    };

    var flate = {
    	uncompressInputType: uncompressInputType,
    	compressInputType: compressInputType,
    	magic: magic,
    	compress: compress,
    	uncompress: uncompress
    };

    var STORE = {
        magic: "\x00\x00",
        compress: function(content, compressionOptions) {
            return content; // no compression
        },
        uncompress: function(content) {
            return content; // no compression
        },
        compressInputType: null,
        uncompressInputType: null
    };
    var DEFLATE = flate;

    var compressions = {
    	STORE: STORE,
    	DEFLATE: DEFLATE
    };

    var nodeBuffer = function(data, encoding){
        return new Buffer(data, encoding);
    };
    var test = function(b){
        return Buffer.isBuffer(b);
    };
    nodeBuffer.test = test;

    var utils = createCommonjsModule(function (module, exports) {



    /**
     * Convert a string to a "binary string" : a string containing only char codes between 0 and 255.
     * @param {string} str the string to transform.
     * @return {String} the binary string.
     */
    exports.string2binary = function(str) {
        var result = "";
        for (var i = 0; i < str.length; i++) {
            result += String.fromCharCode(str.charCodeAt(i) & 0xff);
        }
        return result;
    };
    exports.arrayBuffer2Blob = function(buffer, mimeType) {
        exports.checkSupport("blob");
    	mimeType = mimeType || 'application/zip';

        try {
            // Blob constructor
            return new Blob([buffer], {
                type: mimeType
            });
        }
        catch (e) {

            try {
                // deprecated, browser only, old way
                var Builder = window.BlobBuilder || window.WebKitBlobBuilder || window.MozBlobBuilder || window.MSBlobBuilder;
                var builder = new Builder();
                builder.append(buffer);
                return builder.getBlob(mimeType);
            }
            catch (e) {

                // well, fuck ?!
                throw new Error("Bug : can't construct the Blob.");
            }
        }


    };
    /**
     * The identity function.
     * @param {Object} input the input.
     * @return {Object} the same input.
     */
    function identity(input) {
        return input;
    }

    /**
     * Fill in an array with a string.
     * @param {String} str the string to use.
     * @param {Array|ArrayBuffer|Uint8Array|Buffer} array the array to fill in (will be mutated).
     * @return {Array|ArrayBuffer|Uint8Array|Buffer} the updated array.
     */
    function stringToArrayLike(str, array) {
        for (var i = 0; i < str.length; ++i) {
            array[i] = str.charCodeAt(i) & 0xFF;
        }
        return array;
    }

    /**
     * Transform an array-like object to a string.
     * @param {Array|ArrayBuffer|Uint8Array|Buffer} array the array to transform.
     * @return {String} the result.
     */
    function arrayLikeToString(array) {
        // Performances notes :
        // --------------------
        // String.fromCharCode.apply(null, array) is the fastest, see
        // see http://jsperf.com/converting-a-uint8array-to-a-string/2
        // but the stack is limited (and we can get huge arrays !).
        //
        // result += String.fromCharCode(array[i]); generate too many strings !
        //
        // This code is inspired by http://jsperf.com/arraybuffer-to-string-apply-performance/2
        var chunk = 65536;
        var result = [],
            len = array.length,
            type = exports.getTypeOf(array),
            k = 0,
            canUseApply = true;
          try {
             switch(type) {
                case "uint8array":
                   String.fromCharCode.apply(null, new Uint8Array(0));
                   break;
                case "nodebuffer":
                   String.fromCharCode.apply(null, nodeBuffer(0));
                   break;
             }
          } catch(e) {
             canUseApply = false;
          }

          // no apply : slow and painful algorithm
          // default browser on android 4.*
          if (!canUseApply) {
             var resultStr = "";
             for(var i = 0; i < array.length;i++) {
                resultStr += String.fromCharCode(array[i]);
             }
        return resultStr;
        }
        while (k < len && chunk > 1) {
            try {
                if (type === "array" || type === "nodebuffer") {
                    result.push(String.fromCharCode.apply(null, array.slice(k, Math.min(k + chunk, len))));
                }
                else {
                    result.push(String.fromCharCode.apply(null, array.subarray(k, Math.min(k + chunk, len))));
                }
                k += chunk;
            }
            catch (e) {
                chunk = Math.floor(chunk / 2);
            }
        }
        return result.join("");
    }

    exports.applyFromCharCode = arrayLikeToString;


    /**
     * Copy the data from an array-like to an other array-like.
     * @param {Array|ArrayBuffer|Uint8Array|Buffer} arrayFrom the origin array.
     * @param {Array|ArrayBuffer|Uint8Array|Buffer} arrayTo the destination array which will be mutated.
     * @return {Array|ArrayBuffer|Uint8Array|Buffer} the updated destination array.
     */
    function arrayLikeToArrayLike(arrayFrom, arrayTo) {
        for (var i = 0; i < arrayFrom.length; i++) {
            arrayTo[i] = arrayFrom[i];
        }
        return arrayTo;
    }

    // a matrix containing functions to transform everything into everything.
    var transform = {};

    // string to ?
    transform["string"] = {
        "string": identity,
        "array": function(input) {
            return stringToArrayLike(input, new Array(input.length));
        },
        "arraybuffer": function(input) {
            return transform["string"]["uint8array"](input).buffer;
        },
        "uint8array": function(input) {
            return stringToArrayLike(input, new Uint8Array(input.length));
        },
        "nodebuffer": function(input) {
            return stringToArrayLike(input, nodeBuffer(input.length));
        }
    };

    // array to ?
    transform["array"] = {
        "string": arrayLikeToString,
        "array": identity,
        "arraybuffer": function(input) {
            return (new Uint8Array(input)).buffer;
        },
        "uint8array": function(input) {
            return new Uint8Array(input);
        },
        "nodebuffer": function(input) {
            return nodeBuffer(input);
        }
    };

    // arraybuffer to ?
    transform["arraybuffer"] = {
        "string": function(input) {
            return arrayLikeToString(new Uint8Array(input));
        },
        "array": function(input) {
            return arrayLikeToArrayLike(new Uint8Array(input), new Array(input.byteLength));
        },
        "arraybuffer": identity,
        "uint8array": function(input) {
            return new Uint8Array(input);
        },
        "nodebuffer": function(input) {
            return nodeBuffer(new Uint8Array(input));
        }
    };

    // uint8array to ?
    transform["uint8array"] = {
        "string": arrayLikeToString,
        "array": function(input) {
            return arrayLikeToArrayLike(input, new Array(input.length));
        },
        "arraybuffer": function(input) {
            return input.buffer;
        },
        "uint8array": identity,
        "nodebuffer": function(input) {
            return nodeBuffer(input);
        }
    };

    // nodebuffer to ?
    transform["nodebuffer"] = {
        "string": arrayLikeToString,
        "array": function(input) {
            return arrayLikeToArrayLike(input, new Array(input.length));
        },
        "arraybuffer": function(input) {
            return transform["nodebuffer"]["uint8array"](input).buffer;
        },
        "uint8array": function(input) {
            return arrayLikeToArrayLike(input, new Uint8Array(input.length));
        },
        "nodebuffer": identity
    };

    /**
     * Transform an input into any type.
     * The supported output type are : string, array, uint8array, arraybuffer, nodebuffer.
     * If no output type is specified, the unmodified input will be returned.
     * @param {String} outputType the output type.
     * @param {String|Array|ArrayBuffer|Uint8Array|Buffer} input the input to convert.
     * @throws {Error} an Error if the browser doesn't support the requested output type.
     */
    exports.transformTo = function(outputType, input) {
        if (!input) {
            // undefined, null, etc
            // an empty string won't harm.
            input = "";
        }
        if (!outputType) {
            return input;
        }
        exports.checkSupport(outputType);
        var inputType = exports.getTypeOf(input);
        var result = transform[inputType][outputType](input);
        return result;
    };

    /**
     * Return the type of the input.
     * The type will be in a format valid for JSZip.utils.transformTo : string, array, uint8array, arraybuffer.
     * @param {Object} input the input to identify.
     * @return {String} the (lowercase) type of the input.
     */
    exports.getTypeOf = function(input) {
        if (typeof input === "string") {
            return "string";
        }
        if (Object.prototype.toString.call(input) === "[object Array]") {
            return "array";
        }
        if (support.nodebuffer && nodeBuffer.test(input)) {
            return "nodebuffer";
        }
        if (support.uint8array && input instanceof Uint8Array) {
            return "uint8array";
        }
        if (support.arraybuffer && input instanceof ArrayBuffer) {
            return "arraybuffer";
        }
    };

    /**
     * Throw an exception if the type is not supported.
     * @param {String} type the type to check.
     * @throws {Error} an Error if the browser doesn't support the requested type.
     */
    exports.checkSupport = function(type) {
        var supported = support[type.toLowerCase()];
        if (!supported) {
            throw new Error(type + " is not supported by this browser");
        }
    };
    exports.MAX_VALUE_16BITS = 65535;
    exports.MAX_VALUE_32BITS = -1; // well, "\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF" is parsed as -1

    /**
     * Prettify a string read as binary.
     * @param {string} str the string to prettify.
     * @return {string} a pretty string.
     */
    exports.pretty = function(str) {
        var res = '',
            code, i;
        for (i = 0; i < (str || "").length; i++) {
            code = str.charCodeAt(i);
            res += '\\x' + (code < 16 ? "0" : "") + code.toString(16).toUpperCase();
        }
        return res;
    };

    /**
     * Find a compression registered in JSZip.
     * @param {string} compressionMethod the method magic to find.
     * @return {Object|null} the JSZip compression object, null if none found.
     */
    exports.findCompression = function(compressionMethod) {
        for (var method in compressions) {
            if (!compressions.hasOwnProperty(method)) {
                continue;
            }
            if (compressions[method].magic === compressionMethod) {
                return compressions[method];
            }
        }
        return null;
    };
    /**
    * Cross-window, cross-Node-context regular expression detection
    * @param  {Object}  object Anything
    * @return {Boolean}        true if the object is a regular expression,
    * false otherwise
    */
    exports.isRegExp = function (object) {
        return Object.prototype.toString.call(object) === "[object RegExp]";
    };

    /**
     * Merge the objects passed as parameters into a new one.
     * @private
     * @param {...Object} var_args All objects to merge.
     * @return {Object} a new object with the data of the others.
     */
    exports.extend = function() {
        var result = {}, i, attr;
        for (i = 0; i < arguments.length; i++) { // arguments is not enumerable in some browsers
            for (attr in arguments[i]) {
                if (arguments[i].hasOwnProperty(attr) && typeof result[attr] === "undefined") {
                    result[attr] = arguments[i][attr];
                }
            }
        }
        return result;
    };
    });
    utils.string2binary;
    utils.arrayBuffer2Blob;
    utils.applyFromCharCode;
    utils.transformTo;
    utils.getTypeOf;
    utils.checkSupport;
    utils.MAX_VALUE_16BITS;
    utils.MAX_VALUE_32BITS;
    utils.pretty;
    utils.findCompression;
    utils.isRegExp;
    utils.extend;

    var table = [
        0x00000000, 0x77073096, 0xEE0E612C, 0x990951BA,
        0x076DC419, 0x706AF48F, 0xE963A535, 0x9E6495A3,
        0x0EDB8832, 0x79DCB8A4, 0xE0D5E91E, 0x97D2D988,
        0x09B64C2B, 0x7EB17CBD, 0xE7B82D07, 0x90BF1D91,
        0x1DB71064, 0x6AB020F2, 0xF3B97148, 0x84BE41DE,
        0x1ADAD47D, 0x6DDDE4EB, 0xF4D4B551, 0x83D385C7,
        0x136C9856, 0x646BA8C0, 0xFD62F97A, 0x8A65C9EC,
        0x14015C4F, 0x63066CD9, 0xFA0F3D63, 0x8D080DF5,
        0x3B6E20C8, 0x4C69105E, 0xD56041E4, 0xA2677172,
        0x3C03E4D1, 0x4B04D447, 0xD20D85FD, 0xA50AB56B,
        0x35B5A8FA, 0x42B2986C, 0xDBBBC9D6, 0xACBCF940,
        0x32D86CE3, 0x45DF5C75, 0xDCD60DCF, 0xABD13D59,
        0x26D930AC, 0x51DE003A, 0xC8D75180, 0xBFD06116,
        0x21B4F4B5, 0x56B3C423, 0xCFBA9599, 0xB8BDA50F,
        0x2802B89E, 0x5F058808, 0xC60CD9B2, 0xB10BE924,
        0x2F6F7C87, 0x58684C11, 0xC1611DAB, 0xB6662D3D,
        0x76DC4190, 0x01DB7106, 0x98D220BC, 0xEFD5102A,
        0x71B18589, 0x06B6B51F, 0x9FBFE4A5, 0xE8B8D433,
        0x7807C9A2, 0x0F00F934, 0x9609A88E, 0xE10E9818,
        0x7F6A0DBB, 0x086D3D2D, 0x91646C97, 0xE6635C01,
        0x6B6B51F4, 0x1C6C6162, 0x856530D8, 0xF262004E,
        0x6C0695ED, 0x1B01A57B, 0x8208F4C1, 0xF50FC457,
        0x65B0D9C6, 0x12B7E950, 0x8BBEB8EA, 0xFCB9887C,
        0x62DD1DDF, 0x15DA2D49, 0x8CD37CF3, 0xFBD44C65,
        0x4DB26158, 0x3AB551CE, 0xA3BC0074, 0xD4BB30E2,
        0x4ADFA541, 0x3DD895D7, 0xA4D1C46D, 0xD3D6F4FB,
        0x4369E96A, 0x346ED9FC, 0xAD678846, 0xDA60B8D0,
        0x44042D73, 0x33031DE5, 0xAA0A4C5F, 0xDD0D7CC9,
        0x5005713C, 0x270241AA, 0xBE0B1010, 0xC90C2086,
        0x5768B525, 0x206F85B3, 0xB966D409, 0xCE61E49F,
        0x5EDEF90E, 0x29D9C998, 0xB0D09822, 0xC7D7A8B4,
        0x59B33D17, 0x2EB40D81, 0xB7BD5C3B, 0xC0BA6CAD,
        0xEDB88320, 0x9ABFB3B6, 0x03B6E20C, 0x74B1D29A,
        0xEAD54739, 0x9DD277AF, 0x04DB2615, 0x73DC1683,
        0xE3630B12, 0x94643B84, 0x0D6D6A3E, 0x7A6A5AA8,
        0xE40ECF0B, 0x9309FF9D, 0x0A00AE27, 0x7D079EB1,
        0xF00F9344, 0x8708A3D2, 0x1E01F268, 0x6906C2FE,
        0xF762575D, 0x806567CB, 0x196C3671, 0x6E6B06E7,
        0xFED41B76, 0x89D32BE0, 0x10DA7A5A, 0x67DD4ACC,
        0xF9B9DF6F, 0x8EBEEFF9, 0x17B7BE43, 0x60B08ED5,
        0xD6D6A3E8, 0xA1D1937E, 0x38D8C2C4, 0x4FDFF252,
        0xD1BB67F1, 0xA6BC5767, 0x3FB506DD, 0x48B2364B,
        0xD80D2BDA, 0xAF0A1B4C, 0x36034AF6, 0x41047A60,
        0xDF60EFC3, 0xA867DF55, 0x316E8EEF, 0x4669BE79,
        0xCB61B38C, 0xBC66831A, 0x256FD2A0, 0x5268E236,
        0xCC0C7795, 0xBB0B4703, 0x220216B9, 0x5505262F,
        0xC5BA3BBE, 0xB2BD0B28, 0x2BB45A92, 0x5CB36A04,
        0xC2D7FFA7, 0xB5D0CF31, 0x2CD99E8B, 0x5BDEAE1D,
        0x9B64C2B0, 0xEC63F226, 0x756AA39C, 0x026D930A,
        0x9C0906A9, 0xEB0E363F, 0x72076785, 0x05005713,
        0x95BF4A82, 0xE2B87A14, 0x7BB12BAE, 0x0CB61B38,
        0x92D28E9B, 0xE5D5BE0D, 0x7CDCEFB7, 0x0BDBDF21,
        0x86D3D2D4, 0xF1D4E242, 0x68DDB3F8, 0x1FDA836E,
        0x81BE16CD, 0xF6B9265B, 0x6FB077E1, 0x18B74777,
        0x88085AE6, 0xFF0F6A70, 0x66063BCA, 0x11010B5C,
        0x8F659EFF, 0xF862AE69, 0x616BFFD3, 0x166CCF45,
        0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2,
        0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB,
        0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0,
        0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9,
        0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6,
        0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF,
        0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94,
        0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D
    ];

    /**
     *
     *  Javascript crc32
     *  http://www.webtoolkit.info/
     *
     */
    var crc32 = function crc32(input, crc) {
        if (typeof input === "undefined" || !input.length) {
            return 0;
        }

        var isArray = utils.getTypeOf(input) !== "string";

        if (typeof(crc) == "undefined") {
            crc = 0;
        }
        var x = 0;
        var y = 0;
        var b = 0;

        crc = crc ^ (-1);
        for (var i = 0, iTop = input.length; i < iTop; i++) {
            b = isArray ? input[i] : input.charCodeAt(i);
            y = (crc ^ b) & 0xFF;
            x = table[y];
            crc = (crc >>> 8) ^ x;
        }

        return crc ^ (-1);
    };

    var LOCAL_FILE_HEADER = "PK\x03\x04";
    var CENTRAL_FILE_HEADER = "PK\x01\x02";
    var CENTRAL_DIRECTORY_END = "PK\x05\x06";
    var ZIP64_CENTRAL_DIRECTORY_LOCATOR = "PK\x06\x07";
    var ZIP64_CENTRAL_DIRECTORY_END = "PK\x06\x06";
    var DATA_DESCRIPTOR = "PK\x07\x08";

    var signature = {
    	LOCAL_FILE_HEADER: LOCAL_FILE_HEADER,
    	CENTRAL_FILE_HEADER: CENTRAL_FILE_HEADER,
    	CENTRAL_DIRECTORY_END: CENTRAL_DIRECTORY_END,
    	ZIP64_CENTRAL_DIRECTORY_LOCATOR: ZIP64_CENTRAL_DIRECTORY_LOCATOR,
    	ZIP64_CENTRAL_DIRECTORY_END: ZIP64_CENTRAL_DIRECTORY_END,
    	DATA_DESCRIPTOR: DATA_DESCRIPTOR
    };

    var base64 = false;
    var binary = false;
    var dir = false;
    var createFolders = false;
    var date = null;
    var compression = null;
    var compressionOptions = null;
    var comment = null;
    var unixPermissions = null;
    var dosPermissions = null;

    var defaults = {
    	base64: base64,
    	binary: binary,
    	dir: dir,
    	createFolders: createFolders,
    	date: date,
    	compression: compression,
    	compressionOptions: compressionOptions,
    	comment: comment,
    	unixPermissions: unixPermissions,
    	dosPermissions: dosPermissions
    };

    function CompressedObject() {
        this.compressedSize = 0;
        this.uncompressedSize = 0;
        this.crc32 = 0;
        this.compressionMethod = null;
        this.compressedContent = null;
    }

    CompressedObject.prototype = {
        /**
         * Return the decompressed content in an unspecified format.
         * The format will depend on the decompressor.
         * @return {Object} the decompressed content.
         */
        getContent: function() {
            return null; // see implementation
        },
        /**
         * Return the compressed content in an unspecified format.
         * The format will depend on the compressed conten source.
         * @return {Object} the compressed content.
         */
        getCompressedContent: function() {
            return null; // see implementation
        }
    };
    var compressedObject = CompressedObject;

    /**
     * The following functions come from pako, from pako/lib/utils/strings
     * released under the MIT license, see pako https://github.com/nodeca/pako/
     */

    // Table with utf8 lengths (calculated by first byte of sequence)
    // Note, that 5 & 6-byte values and some 4-byte values can not be represented in JS,
    // because max possible codepoint is 0x10ffff
    var _utf8len = new Array(256);
    for (var i=0; i<256; i++) {
      _utf8len[i] = (i >= 252 ? 6 : i >= 248 ? 5 : i >= 240 ? 4 : i >= 224 ? 3 : i >= 192 ? 2 : 1);
    }
    _utf8len[254]=_utf8len[254]=1; // Invalid sequence start

    // convert string to array (typed, when possible)
    var string2buf = function (str) {
        var buf, c, c2, m_pos, i, str_len = str.length, buf_len = 0;

        // count binary size
        for (m_pos = 0; m_pos < str_len; m_pos++) {
            c = str.charCodeAt(m_pos);
            if ((c & 0xfc00) === 0xd800 && (m_pos+1 < str_len)) {
                c2 = str.charCodeAt(m_pos+1);
                if ((c2 & 0xfc00) === 0xdc00) {
                    c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
                    m_pos++;
                }
            }
            buf_len += c < 0x80 ? 1 : c < 0x800 ? 2 : c < 0x10000 ? 3 : 4;
        }

        // allocate buffer
        if (support.uint8array) {
            buf = new Uint8Array(buf_len);
        } else {
            buf = new Array(buf_len);
        }

        // convert
        for (i=0, m_pos = 0; i < buf_len; m_pos++) {
            c = str.charCodeAt(m_pos);
            if ((c & 0xfc00) === 0xd800 && (m_pos+1 < str_len)) {
                c2 = str.charCodeAt(m_pos+1);
                if ((c2 & 0xfc00) === 0xdc00) {
                    c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
                    m_pos++;
                }
            }
            if (c < 0x80) {
                /* one byte */
                buf[i++] = c;
            } else if (c < 0x800) {
                /* two bytes */
                buf[i++] = 0xC0 | (c >>> 6);
                buf[i++] = 0x80 | (c & 0x3f);
            } else if (c < 0x10000) {
                /* three bytes */
                buf[i++] = 0xE0 | (c >>> 12);
                buf[i++] = 0x80 | (c >>> 6 & 0x3f);
                buf[i++] = 0x80 | (c & 0x3f);
            } else {
                /* four bytes */
                buf[i++] = 0xf0 | (c >>> 18);
                buf[i++] = 0x80 | (c >>> 12 & 0x3f);
                buf[i++] = 0x80 | (c >>> 6 & 0x3f);
                buf[i++] = 0x80 | (c & 0x3f);
            }
        }

        return buf;
    };

    // Calculate max possible position in utf8 buffer,
    // that will not break sequence. If that's not possible
    // - (very small limits) return max size as is.
    //
    // buf[] - utf8 bytes array
    // max   - length limit (mandatory);
    var utf8border = function(buf, max) {
        var pos;

        max = max || buf.length;
        if (max > buf.length) { max = buf.length; }

        // go back from last position, until start of sequence found
        pos = max-1;
        while (pos >= 0 && (buf[pos] & 0xC0) === 0x80) { pos--; }

        // Fuckup - very small and broken sequence,
        // return max, because we should return something anyway.
        if (pos < 0) { return max; }

        // If we came to start of buffer - that means vuffer is too small,
        // return max too.
        if (pos === 0) { return max; }

        return (pos + _utf8len[buf[pos]] > max) ? pos : max;
    };

    // convert array to string
    var buf2string = function (buf) {
        var i, out, c, c_len;
        var len = buf.length;

        // Reserve max possible length (2 words per char)
        // NB: by unknown reasons, Array is significantly faster for
        //     String.fromCharCode.apply than Uint16Array.
        var utf16buf = new Array(len*2);

        for (out=0, i=0; i<len;) {
            c = buf[i++];
            // quick process ascii
            if (c < 0x80) { utf16buf[out++] = c; continue; }

            c_len = _utf8len[c];
            // skip 5 & 6 byte codes
            if (c_len > 4) { utf16buf[out++] = 0xfffd; i += c_len-1; continue; }

            // apply mask on first byte
            c &= c_len === 2 ? 0x1f : c_len === 3 ? 0x0f : 0x07;
            // join the rest
            while (c_len > 1 && i < len) {
                c = (c << 6) | (buf[i++] & 0x3f);
                c_len--;
            }

            // terminated by end of string?
            if (c_len > 1) { utf16buf[out++] = 0xfffd; continue; }

            if (c < 0x10000) {
                utf16buf[out++] = c;
            } else {
                c -= 0x10000;
                utf16buf[out++] = 0xd800 | ((c >> 10) & 0x3ff);
                utf16buf[out++] = 0xdc00 | (c & 0x3ff);
            }
        }

        // shrinkBuf(utf16buf, out)
        if (utf16buf.length !== out) {
            if(utf16buf.subarray) {
                utf16buf = utf16buf.subarray(0, out);
            } else {
                utf16buf.length = out;
            }
        }

        // return String.fromCharCode.apply(null, utf16buf);
        return utils.applyFromCharCode(utf16buf);
    };


    // That's all for the pako functions.


    /**
     * Transform a javascript string into an array (typed if possible) of bytes,
     * UTF-8 encoded.
     * @param {String} str the string to encode
     * @return {Array|Uint8Array|Buffer} the UTF-8 encoded string.
     */
    var utf8encode = function utf8encode(str) {
        if (support.nodebuffer) {
            return nodeBuffer(str, "utf-8");
        }

        return string2buf(str);
    };


    /**
     * Transform a bytes array (or a representation) representing an UTF-8 encoded
     * string into a javascript string.
     * @param {Array|Uint8Array|Buffer} buf the data de decode
     * @return {String} the decoded string.
     */
    var utf8decode = function utf8decode(buf) {
        if (support.nodebuffer) {
            return utils.transformTo("nodebuffer", buf).toString("utf-8");
        }

        buf = utils.transformTo(support.uint8array ? "uint8array" : "array", buf);

        // return buf2string(buf);
        // Chrome prefers to work with "small" chunks of data
        // for the method buf2string.
        // Firefox and Chrome has their own shortcut, IE doesn't seem to really care.
        var result = [], k = 0, len = buf.length, chunk = 65536;
        while (k < len) {
            var nextBoundary = utf8border(buf, Math.min(k + chunk, len));
            if (support.uint8array) {
                result.push(buf2string(buf.subarray(k, nextBoundary)));
            } else {
                result.push(buf2string(buf.slice(k, nextBoundary)));
            }
            k = nextBoundary;
        }
        return result.join("");

    };
    // vim: set shiftwidth=4 softtabstop=4:

    var utf8 = {
    	utf8encode: utf8encode,
    	utf8decode: utf8decode
    };

    /**
     * An object to write any content to a string.
     * @constructor
     */
    var StringWriter = function() {
        this.data = [];
    };
    StringWriter.prototype = {
        /**
         * Append any content to the current string.
         * @param {Object} input the content to add.
         */
        append: function(input) {
            input = utils.transformTo("string", input);
            this.data.push(input);
        },
        /**
         * Finalize the construction an return the result.
         * @return {string} the generated string.
         */
        finalize: function() {
            return this.data.join("");
        }
    };

    var stringWriter = StringWriter;

    /**
     * An object to write any content to an Uint8Array.
     * @constructor
     * @param {number} length The length of the array.
     */
    var Uint8ArrayWriter = function(length) {
        this.data = new Uint8Array(length);
        this.index = 0;
    };
    Uint8ArrayWriter.prototype = {
        /**
         * Append any content to the current array.
         * @param {Object} input the content to add.
         */
        append: function(input) {
            if (input.length !== 0) {
                // with an empty Uint8Array, Opera fails with a "Offset larger than array size"
                input = utils.transformTo("uint8array", input);
                this.data.set(input, this.index);
                this.index += input.length;
            }
        },
        /**
         * Finalize the construction an return the result.
         * @return {Uint8Array} the generated array.
         */
        finalize: function() {
            return this.data;
        }
    };

    var uint8ArrayWriter = Uint8ArrayWriter;

    /**
     * Returns the raw data of a ZipObject, decompress the content if necessary.
     * @param {ZipObject} file the file to use.
     * @return {String|ArrayBuffer|Uint8Array|Buffer} the data.
     */
    var getRawData = function(file) {
        if (file._data instanceof compressedObject) {
            file._data = file._data.getContent();
            file.options.binary = true;
            file.options.base64 = false;

            if (utils.getTypeOf(file._data) === "uint8array") {
                var copy = file._data;
                // when reading an arraybuffer, the CompressedObject mechanism will keep it and subarray() a Uint8Array.
                // if we request a file in the same format, we might get the same Uint8Array or its ArrayBuffer (the original zip file).
                file._data = new Uint8Array(copy.length);
                // with an empty Uint8Array, Opera fails with a "Offset larger than array size"
                if (copy.length !== 0) {
                    file._data.set(copy, 0);
                }
            }
        }
        return file._data;
    };

    /**
     * Returns the data of a ZipObject in a binary form. If the content is an unicode string, encode it.
     * @param {ZipObject} file the file to use.
     * @return {String|ArrayBuffer|Uint8Array|Buffer} the data.
     */
    var getBinaryData = function(file) {
        var result = getRawData(file),
            type = utils.getTypeOf(result);
        if (type === "string") {
            if (!file.options.binary) {
                // unicode text !
                // unicode string => binary string is a painful process, check if we can avoid it.
                if (support.nodebuffer) {
                    return nodeBuffer(result, "utf-8");
                }
            }
            return file.asBinary();
        }
        return result;
    };

    /**
     * Transform this._data into a string.
     * @param {function} filter a function String -> String, applied if not null on the result.
     * @return {String} the string representing this._data.
     */
    var dataToString = function(asUTF8) {
        var result = getRawData(this);
        if (result === null || typeof result === "undefined") {
            return "";
        }
        // if the data is a base64 string, we decode it before checking the encoding !
        if (this.options.base64) {
            result = base64$1.decode(result);
        }
        if (asUTF8 && this.options.binary) {
            // JSZip.prototype.utf8decode supports arrays as input
            // skip to array => string step, utf8decode will do it.
            result = out.utf8decode(result);
        }
        else {
            // no utf8 transformation, do the array => string step.
            result = utils.transformTo("string", result);
        }

        if (!asUTF8 && !this.options.binary) {
            result = utils.transformTo("string", out.utf8encode(result));
        }
        return result;
    };
    /**
     * A simple object representing a file in the zip file.
     * @constructor
     * @param {string} name the name of the file
     * @param {String|ArrayBuffer|Uint8Array|Buffer} data the data
     * @param {Object} options the options of the file
     */
    var ZipObject = function(name, data, options) {
        this.name = name;
        this.dir = options.dir;
        this.date = options.date;
        this.comment = options.comment;
        this.unixPermissions = options.unixPermissions;
        this.dosPermissions = options.dosPermissions;

        this._data = data;
        this.options = options;

        /*
         * This object contains initial values for dir and date.
         * With them, we can check if the user changed the deprecated metadata in
         * `ZipObject#options` or not.
         */
        this._initialMetadata = {
          dir : options.dir,
          date : options.date
        };
    };

    ZipObject.prototype = {
        /**
         * Return the content as UTF8 string.
         * @return {string} the UTF8 string.
         */
        asText: function() {
            return dataToString.call(this, true);
        },
        /**
         * Returns the binary content.
         * @return {string} the content as binary.
         */
        asBinary: function() {
            return dataToString.call(this, false);
        },
        /**
         * Returns the content as a nodejs Buffer.
         * @return {Buffer} the content as a Buffer.
         */
        asNodeBuffer: function() {
            var result = getBinaryData(this);
            return utils.transformTo("nodebuffer", result);
        },
        /**
         * Returns the content as an Uint8Array.
         * @return {Uint8Array} the content as an Uint8Array.
         */
        asUint8Array: function() {
            var result = getBinaryData(this);
            return utils.transformTo("uint8array", result);
        },
        /**
         * Returns the content as an ArrayBuffer.
         * @return {ArrayBuffer} the content as an ArrayBufer.
         */
        asArrayBuffer: function() {
            return this.asUint8Array().buffer;
        }
    };

    /**
     * Transform an integer into a string in hexadecimal.
     * @private
     * @param {number} dec the number to convert.
     * @param {number} bytes the number of bytes to generate.
     * @returns {string} the result.
     */
    var decToHex = function(dec, bytes) {
        var hex = "",
            i;
        for (i = 0; i < bytes; i++) {
            hex += String.fromCharCode(dec & 0xff);
            dec = dec >>> 8;
        }
        return hex;
    };

    /**
     * Transforms the (incomplete) options from the user into the complete
     * set of options to create a file.
     * @private
     * @param {Object} o the options from the user.
     * @return {Object} the complete set of options.
     */
    var prepareFileAttrs = function(o) {
        o = o || {};
        if (o.base64 === true && (o.binary === null || o.binary === undefined)) {
            o.binary = true;
        }
        o = utils.extend(o, defaults);
        o.date = o.date || new Date();
        if (o.compression !== null) o.compression = o.compression.toUpperCase();

        return o;
    };

    /**
     * Add a file in the current folder.
     * @private
     * @param {string} name the name of the file
     * @param {String|ArrayBuffer|Uint8Array|Buffer} data the data of the file
     * @param {Object} o the options of the file
     * @return {Object} the new file.
     */
    var fileAdd = function(name, data, o) {
        // be sure sub folders exist
        var dataType = utils.getTypeOf(data),
            parent;

        o = prepareFileAttrs(o);

        if (typeof o.unixPermissions === "string") {
            o.unixPermissions = parseInt(o.unixPermissions, 8);
        }

        // UNX_IFDIR  0040000 see zipinfo.c
        if (o.unixPermissions && (o.unixPermissions & 0x4000)) {
            o.dir = true;
        }
        // Bit 4    Directory
        if (o.dosPermissions && (o.dosPermissions & 0x0010)) {
            o.dir = true;
        }

        if (o.dir) {
            name = forceTrailingSlash(name);
        }

        if (o.createFolders && (parent = parentFolder(name))) {
            folderAdd.call(this, parent, true);
        }

        if (o.dir || data === null || typeof data === "undefined") {
            o.base64 = false;
            o.binary = false;
            data = null;
            dataType = null;
        }
        else if (dataType === "string") {
            if (o.binary && !o.base64) {
                // optimizedBinaryString == true means that the file has already been filtered with a 0xFF mask
                if (o.optimizedBinaryString !== true) {
                    // this is a string, not in a base64 format.
                    // Be sure that this is a correct "binary string"
                    data = utils.string2binary(data);
                }
            }
        }
        else { // arraybuffer, uint8array, ...
            o.base64 = false;
            o.binary = true;

            if (!dataType && !(data instanceof compressedObject)) {
                throw new Error("The data of '" + name + "' is in an unsupported format !");
            }

            // special case : it's way easier to work with Uint8Array than with ArrayBuffer
            if (dataType === "arraybuffer") {
                data = utils.transformTo("uint8array", data);
            }
        }

        var object = new ZipObject(name, data, o);
        this.files[name] = object;
        return object;
    };

    /**
     * Find the parent folder of the path.
     * @private
     * @param {string} path the path to use
     * @return {string} the parent folder, or ""
     */
    var parentFolder = function (path) {
        if (path.slice(-1) == '/') {
            path = path.substring(0, path.length - 1);
        }
        var lastSlash = path.lastIndexOf('/');
        return (lastSlash > 0) ? path.substring(0, lastSlash) : "";
    };


    /**
     * Returns the path with a slash at the end.
     * @private
     * @param {String} path the path to check.
     * @return {String} the path with a trailing slash.
     */
    var forceTrailingSlash = function(path) {
        // Check the name ends with a /
        if (path.slice(-1) != "/") {
            path += "/"; // IE doesn't like substr(-1)
        }
        return path;
    };
    /**
     * Add a (sub) folder in the current folder.
     * @private
     * @param {string} name the folder's name
     * @param {boolean=} [createFolders] If true, automatically create sub
     *  folders. Defaults to false.
     * @return {Object} the new folder.
     */
    var folderAdd = function(name, createFolders) {
        createFolders = (typeof createFolders !== 'undefined') ? createFolders : false;

        name = forceTrailingSlash(name);

        // Does this folder already exist?
        if (!this.files[name]) {
            fileAdd.call(this, name, null, {
                dir: true,
                createFolders: createFolders
            });
        }
        return this.files[name];
    };

    /**
     * Generate a JSZip.CompressedObject for a given zipOject.
     * @param {ZipObject} file the object to read.
     * @param {JSZip.compression} compression the compression to use.
     * @param {Object} compressionOptions the options to use when compressing.
     * @return {JSZip.CompressedObject} the compressed result.
     */
    var generateCompressedObjectFrom = function(file, compression, compressionOptions) {
        var result = new compressedObject(),
            content;

        // the data has not been decompressed, we might reuse things !
        if (file._data instanceof compressedObject) {
            result.uncompressedSize = file._data.uncompressedSize;
            result.crc32 = file._data.crc32;

            if (result.uncompressedSize === 0 || file.dir) {
                compression = compressions['STORE'];
                result.compressedContent = "";
                result.crc32 = 0;
            }
            else if (file._data.compressionMethod === compression.magic) {
                result.compressedContent = file._data.getCompressedContent();
            }
            else {
                content = file._data.getContent();
                // need to decompress / recompress
                result.compressedContent = compression.compress(utils.transformTo(compression.compressInputType, content), compressionOptions);
            }
        }
        else {
            // have uncompressed data
            content = getBinaryData(file);
            if (!content || content.length === 0 || file.dir) {
                compression = compressions['STORE'];
                content = "";
            }
            result.uncompressedSize = content.length;
            result.crc32 = crc32(content);
            result.compressedContent = compression.compress(utils.transformTo(compression.compressInputType, content), compressionOptions);
        }

        result.compressedSize = result.compressedContent.length;
        result.compressionMethod = compression.magic;

        return result;
    };




    /**
     * Generate the UNIX part of the external file attributes.
     * @param {Object} unixPermissions the unix permissions or null.
     * @param {Boolean} isDir true if the entry is a directory, false otherwise.
     * @return {Number} a 32 bit integer.
     *
     * adapted from http://unix.stackexchange.com/questions/14705/the-zip-formats-external-file-attribute :
     *
     * TTTTsstrwxrwxrwx0000000000ADVSHR
     * ^^^^____________________________ file type, see zipinfo.c (UNX_*)
     *     ^^^_________________________ setuid, setgid, sticky
     *        ^^^^^^^^^________________ permissions
     *                 ^^^^^^^^^^______ not used ?
     *                           ^^^^^^ DOS attribute bits : Archive, Directory, Volume label, System file, Hidden, Read only
     */
    var generateUnixExternalFileAttr = function (unixPermissions, isDir) {

        var result = unixPermissions;
        if (!unixPermissions) {
            // I can't use octal values in strict mode, hence the hexa.
            //  040775 => 0x41fd
            // 0100664 => 0x81b4
            result = isDir ? 0x41fd : 0x81b4;
        }

        return (result & 0xFFFF) << 16;
    };

    /**
     * Generate the DOS part of the external file attributes.
     * @param {Object} dosPermissions the dos permissions or null.
     * @param {Boolean} isDir true if the entry is a directory, false otherwise.
     * @return {Number} a 32 bit integer.
     *
     * Bit 0     Read-Only
     * Bit 1     Hidden
     * Bit 2     System
     * Bit 3     Volume Label
     * Bit 4     Directory
     * Bit 5     Archive
     */
    var generateDosExternalFileAttr = function (dosPermissions, isDir) {

        // the dir flag is already set for compatibility

        return (dosPermissions || 0)  & 0x3F;
    };

    /**
     * Generate the various parts used in the construction of the final zip file.
     * @param {string} name the file name.
     * @param {ZipObject} file the file content.
     * @param {JSZip.CompressedObject} compressedObject the compressed object.
     * @param {number} offset the current offset from the start of the zip file.
     * @param {String} platform let's pretend we are this platform (change platform dependents fields)
     * @param {Function} encodeFileName the function to encode the file name / comment.
     * @return {object} the zip parts.
     */
    var generateZipParts = function(name, file, compressedObject, offset, platform, encodeFileName) {
        compressedObject.compressedContent;
            var useCustomEncoding = encodeFileName !== utf8.utf8encode,
            encodedFileName = utils.transformTo("string", encodeFileName(file.name)),
            utfEncodedFileName = utils.transformTo("string", utf8.utf8encode(file.name)),
            comment = file.comment || "",
            encodedComment = utils.transformTo("string", encodeFileName(comment)),
            utfEncodedComment = utils.transformTo("string", utf8.utf8encode(comment)),
            useUTF8ForFileName = utfEncodedFileName.length !== file.name.length,
            useUTF8ForComment = utfEncodedComment.length !== comment.length,
            o = file.options,
            dosTime,
            dosDate,
            extraFields = "",
            unicodePathExtraField = "",
            unicodeCommentExtraField = "",
            dir, date;


        // handle the deprecated options.dir
        if (file._initialMetadata.dir !== file.dir) {
            dir = file.dir;
        } else {
            dir = o.dir;
        }

        // handle the deprecated options.date
        if(file._initialMetadata.date !== file.date) {
            date = file.date;
        } else {
            date = o.date;
        }

        var extFileAttr = 0;
        var versionMadeBy = 0;
        if (dir) {
            // dos or unix, we set the dos dir flag
            extFileAttr |= 0x00010;
        }
        if(platform === "UNIX") {
            versionMadeBy = 0x031E; // UNIX, version 3.0
            extFileAttr |= generateUnixExternalFileAttr(file.unixPermissions, dir);
        } else { // DOS or other, fallback to DOS
            versionMadeBy = 0x0014; // DOS, version 2.0
            extFileAttr |= generateDosExternalFileAttr(file.dosPermissions);
        }

        // date
        // @see http://www.delorie.com/djgpp/doc/rbinter/it/52/13.html
        // @see http://www.delorie.com/djgpp/doc/rbinter/it/65/16.html
        // @see http://www.delorie.com/djgpp/doc/rbinter/it/66/16.html

        dosTime = date.getHours();
        dosTime = dosTime << 6;
        dosTime = dosTime | date.getMinutes();
        dosTime = dosTime << 5;
        dosTime = dosTime | date.getSeconds() / 2;

        dosDate = date.getFullYear() - 1980;
        dosDate = dosDate << 4;
        dosDate = dosDate | (date.getMonth() + 1);
        dosDate = dosDate << 5;
        dosDate = dosDate | date.getDate();

        if (useUTF8ForFileName) {
            // set the unicode path extra field. unzip needs at least one extra
            // field to correctly handle unicode path, so using the path is as good
            // as any other information. This could improve the situation with
            // other archive managers too.
            // This field is usually used without the utf8 flag, with a non
            // unicode path in the header (winrar, winzip). This helps (a bit)
            // with the messy Windows' default compressed folders feature but
            // breaks on p7zip which doesn't seek the unicode path extra field.
            // So for now, UTF-8 everywhere !
            unicodePathExtraField =
                // Version
                decToHex(1, 1) +
                // NameCRC32
                decToHex(crc32(encodedFileName), 4) +
                // UnicodeName
                utfEncodedFileName;

            extraFields +=
                // Info-ZIP Unicode Path Extra Field
                "\x75\x70" +
                // size
                decToHex(unicodePathExtraField.length, 2) +
                // content
                unicodePathExtraField;
        }

        if(useUTF8ForComment) {

            unicodeCommentExtraField =
                // Version
                decToHex(1, 1) +
                // CommentCRC32
                decToHex(this.crc32(encodedComment), 4) +
                // UnicodeName
                utfEncodedComment;

            extraFields +=
                // Info-ZIP Unicode Path Extra Field
                "\x75\x63" +
                // size
                decToHex(unicodeCommentExtraField.length, 2) +
                // content
                unicodeCommentExtraField;
        }

        var header = "";

        // version needed to extract
        header += "\x0A\x00";
        // general purpose bit flag
        // set bit 11 if utf8
        header += !useCustomEncoding && (useUTF8ForFileName || useUTF8ForComment) ? "\x00\x08" : "\x00\x00";
        // compression method
        header += compressedObject.compressionMethod;
        // last mod file time
        header += decToHex(dosTime, 2);
        // last mod file date
        header += decToHex(dosDate, 2);
        // crc-32
        header += decToHex(compressedObject.crc32, 4);
        // compressed size
        header += decToHex(compressedObject.compressedSize, 4);
        // uncompressed size
        header += decToHex(compressedObject.uncompressedSize, 4);
        // file name length
        header += decToHex(encodedFileName.length, 2);
        // extra field length
        header += decToHex(extraFields.length, 2);


        var fileRecord = signature.LOCAL_FILE_HEADER + header + encodedFileName + extraFields;

        var dirRecord = signature.CENTRAL_FILE_HEADER +
        // version made by (00: DOS)
        decToHex(versionMadeBy, 2) +
        // file header (common to file and central directory)
        header +
        // file comment length
        decToHex(encodedComment.length, 2) +
        // disk number start
        "\x00\x00" +
        // internal file attributes TODO
        "\x00\x00" +
        // external file attributes
        decToHex(extFileAttr, 4) +
        // relative offset of local header
        decToHex(offset, 4) +
        // file name
        encodedFileName +
        // extra field
        extraFields +
        // file comment
        encodedComment;

        return {
            fileRecord: fileRecord,
            dirRecord: dirRecord,
            compressedObject: compressedObject
        };
    };


    // return the actual prototype of JSZip
    var out = {
        /**
         * Read an existing zip and merge the data in the current JSZip object.
         * The implementation is in jszip-load.js, don't forget to include it.
         * @param {String|ArrayBuffer|Uint8Array|Buffer} stream  The stream to load
         * @param {Object} options Options for loading the stream.
         *  options.base64 : is the stream in base64 ? default : false
         * @return {JSZip} the current JSZip object
         */
        load: function(stream, options) {
            throw new Error("Load method is not defined. Is the file jszip-load.js included ?");
        },

        /**
         * Filter nested files/folders with the specified function.
         * @param {Function} search the predicate to use :
         * function (relativePath, file) {...}
         * It takes 2 arguments : the relative path and the file.
         * @return {Array} An array of matching elements.
         */
        filter: function(search) {
            var result = [],
                filename, relativePath, file, fileClone;
            for (filename in this.files) {
                file = this.files[filename];
                // return a new object, don't let the user mess with our internal objects :)
                fileClone = new ZipObject(file.name, file._data, utils.extend(file.options));
                relativePath = filename.slice(this.root.length, filename.length);
                if (filename.slice(0, this.root.length) === this.root && // the file is in the current root
                search(relativePath, fileClone)) { // and the file matches the function
                    result.push(fileClone);
                }
            }
            return result;
        },

        /**
         * Add a file to the zip file, or search a file.
         * @param   {string|RegExp} name The name of the file to add (if data is defined),
         * the name of the file to find (if no data) or a regex to match files.
         * @param   {String|ArrayBuffer|Uint8Array|Buffer} data  The file data, either raw or base64 encoded
         * @param   {Object} o     File options
         * @return  {JSZip|Object|Array} this JSZip object (when adding a file),
         * a file (when searching by string) or an array of files (when searching by regex).
         */
        file: function(name, data, o) {
            if (arguments.length === 1) {
                if (utils.isRegExp(name)) {
                    var regexp = name;
                    return this.filter(function(relativePath, file) {
                        return !file.dir && regexp.test(relativePath);
                    });
                }
                else { // text
                    return this.filter(function(relativePath, file) {
                        return !file.dir && relativePath === name;
                    })[0] || null;
                }
            }
            else { // more than one argument : we have data !
                name = this.root + name;
                fileAdd.call(this, name, data, o);
            }
            return this;
        },

        /**
         * Add a directory to the zip file, or search.
         * @param   {String|RegExp} arg The name of the directory to add, or a regex to search folders.
         * @return  {JSZip} an object with the new directory as the root, or an array containing matching folders.
         */
        folder: function(arg) {
            if (!arg) {
                return this;
            }

            if (utils.isRegExp(arg)) {
                return this.filter(function(relativePath, file) {
                    return file.dir && arg.test(relativePath);
                });
            }

            // else, name is a new folder
            var name = this.root + arg;
            var newFolder = folderAdd.call(this, name);

            // Allow chaining by returning a new object with this folder as the root
            var ret = this.clone();
            ret.root = newFolder.name;
            return ret;
        },

        /**
         * Delete a file, or a directory and all sub-files, from the zip
         * @param {string} name the name of the file to delete
         * @return {JSZip} this JSZip object
         */
        remove: function(name) {
            name = this.root + name;
            var file = this.files[name];
            if (!file) {
                // Look for any folders
                if (name.slice(-1) != "/") {
                    name += "/";
                }
                file = this.files[name];
            }

            if (file && !file.dir) {
                // file
                delete this.files[name];
            } else {
                // maybe a folder, delete recursively
                var kids = this.filter(function(relativePath, file) {
                    return file.name.slice(0, name.length) === name;
                });
                for (var i = 0; i < kids.length; i++) {
                    delete this.files[kids[i].name];
                }
            }

            return this;
        },

        /**
         * Generate the complete zip file
         * @param {Object} options the options to generate the zip file :
         * - base64, (deprecated, use type instead) true to generate base64.
         * - compression, "STORE" by default.
         * - type, "base64" by default. Values are : string, base64, uint8array, arraybuffer, blob.
         * @return {String|Uint8Array|ArrayBuffer|Buffer|Blob} the zip file
         */
        generate: function(options) {
            options = utils.extend(options || {}, {
                base64: true,
                compression: "STORE",
                compressionOptions : null,
                type: "base64",
                platform: "DOS",
                comment: null,
                mimeType: 'application/zip',
                encodeFileName: utf8.utf8encode
            });

            utils.checkSupport(options.type);

            // accept nodejs `process.platform`
            if(
              options.platform === 'darwin' ||
              options.platform === 'freebsd' ||
              options.platform === 'linux' ||
              options.platform === 'sunos'
            ) {
              options.platform = "UNIX";
            }
            if (options.platform === 'win32') {
              options.platform = "DOS";
            }

            var zipData = [],
                localDirLength = 0,
                centralDirLength = 0,
                writer, i,
                encodedComment = utils.transformTo("string", options.encodeFileName(options.comment || this.comment || ""));

            // first, generate all the zip parts.
            for (var name in this.files) {
                var file = this.files[name];

                var compressionName = file.options.compression || options.compression.toUpperCase();
                var compression = compressions[compressionName];
                if (!compression) {
                    throw new Error(compressionName + " is not a valid compression method !");
                }
                var compressionOptions = file.options.compressionOptions || options.compressionOptions || {};

                var compressedObject = generateCompressedObjectFrom.call(this, file, compression, compressionOptions);

                var zipPart = generateZipParts.call(this, name, file, compressedObject, localDirLength, options.platform, options.encodeFileName);
                localDirLength += zipPart.fileRecord.length + compressedObject.compressedSize;
                centralDirLength += zipPart.dirRecord.length;
                zipData.push(zipPart);
            }

            var dirEnd = "";

            // end of central dir signature
            dirEnd = signature.CENTRAL_DIRECTORY_END +
            // number of this disk
            "\x00\x00" +
            // number of the disk with the start of the central directory
            "\x00\x00" +
            // total number of entries in the central directory on this disk
            decToHex(zipData.length, 2) +
            // total number of entries in the central directory
            decToHex(zipData.length, 2) +
            // size of the central directory   4 bytes
            decToHex(centralDirLength, 4) +
            // offset of start of central directory with respect to the starting disk number
            decToHex(localDirLength, 4) +
            // .ZIP file comment length
            decToHex(encodedComment.length, 2) +
            // .ZIP file comment
            encodedComment;


            // we have all the parts (and the total length)
            // time to create a writer !
            var typeName = options.type.toLowerCase();
            if(typeName==="uint8array"||typeName==="arraybuffer"||typeName==="blob"||typeName==="nodebuffer") {
                writer = new uint8ArrayWriter(localDirLength + centralDirLength + dirEnd.length);
            }else {
                writer = new stringWriter(localDirLength + centralDirLength + dirEnd.length);
            }

            for (i = 0; i < zipData.length; i++) {
                writer.append(zipData[i].fileRecord);
                writer.append(zipData[i].compressedObject.compressedContent);
            }
            for (i = 0; i < zipData.length; i++) {
                writer.append(zipData[i].dirRecord);
            }

            writer.append(dirEnd);

            var zip = writer.finalize();



            switch(options.type.toLowerCase()) {
                // case "zip is an Uint8Array"
                case "uint8array" :
                case "arraybuffer" :
                case "nodebuffer" :
                   return utils.transformTo(options.type.toLowerCase(), zip);
                case "blob" :
                   return utils.arrayBuffer2Blob(utils.transformTo("arraybuffer", zip), options.mimeType);
                // case "zip is a string"
                case "base64" :
                   return (options.base64) ? base64$1.encode(zip) : zip;
                default : // case "string" :
                   return zip;
             }

        },

        /**
         * @deprecated
         * This method will be removed in a future version without replacement.
         */
        crc32: function (input, crc) {
            return crc32(input, crc);
        },

        /**
         * @deprecated
         * This method will be removed in a future version without replacement.
         */
        utf8encode: function (string) {
            return utils.transformTo("string", utf8.utf8encode(string));
        },

        /**
         * @deprecated
         * This method will be removed in a future version without replacement.
         */
        utf8decode: function (input) {
            return utf8.utf8decode(input);
        }
    };
    var object = out;

    function DataReader(data) {
        this.data = null; // type : see implementation
        this.length = 0;
        this.index = 0;
        this.zero = 0;
    }
    DataReader.prototype = {
        /**
         * Check that the offset will not go too far.
         * @param {string} offset the additional offset to check.
         * @throws {Error} an Error if the offset is out of bounds.
         */
        checkOffset: function(offset) {
            this.checkIndex(this.index + offset);
        },
        /**
         * Check that the specifed index will not be too far.
         * @param {string} newIndex the index to check.
         * @throws {Error} an Error if the index is out of bounds.
         */
        checkIndex: function(newIndex) {
            if (this.length < this.zero + newIndex || newIndex < 0) {
                throw new Error("End of data reached (data length = " + this.length + ", asked index = " + (newIndex) + "). Corrupted zip ?");
            }
        },
        /**
         * Change the index.
         * @param {number} newIndex The new index.
         * @throws {Error} if the new index is out of the data.
         */
        setIndex: function(newIndex) {
            this.checkIndex(newIndex);
            this.index = newIndex;
        },
        /**
         * Skip the next n bytes.
         * @param {number} n the number of bytes to skip.
         * @throws {Error} if the new index is out of the data.
         */
        skip: function(n) {
            this.setIndex(this.index + n);
        },
        /**
         * Get the byte at the specified index.
         * @param {number} i the index to use.
         * @return {number} a byte.
         */
        byteAt: function(i) {
            // see implementations
        },
        /**
         * Get the next number with a given byte size.
         * @param {number} size the number of bytes to read.
         * @return {number} the corresponding number.
         */
        readInt: function(size) {
            var result = 0,
                i;
            this.checkOffset(size);
            for (i = this.index + size - 1; i >= this.index; i--) {
                result = (result << 8) + this.byteAt(i);
            }
            this.index += size;
            return result;
        },
        /**
         * Get the next string with a given byte size.
         * @param {number} size the number of bytes to read.
         * @return {string} the corresponding string.
         */
        readString: function(size) {
            return utils.transformTo("string", this.readData(size));
        },
        /**
         * Get raw data without conversion, <size> bytes.
         * @param {number} size the number of bytes to read.
         * @return {Object} the raw data, implementation specific.
         */
        readData: function(size) {
            // see implementations
        },
        /**
         * Find the last occurence of a zip signature (4 bytes).
         * @param {string} sig the signature to find.
         * @return {number} the index of the last occurence, -1 if not found.
         */
        lastIndexOfSignature: function(sig) {
            // see implementations
        },
        /**
         * Get the next date.
         * @return {Date} the date.
         */
        readDate: function() {
            var dostime = this.readInt(4);
            return new Date(
            ((dostime >> 25) & 0x7f) + 1980, // year
            ((dostime >> 21) & 0x0f) - 1, // month
            (dostime >> 16) & 0x1f, // day
            (dostime >> 11) & 0x1f, // hour
            (dostime >> 5) & 0x3f, // minute
            (dostime & 0x1f) << 1); // second
        }
    };
    var dataReader = DataReader;

    function StringReader(data, optimizedBinaryString) {
        this.data = data;
        if (!optimizedBinaryString) {
            this.data = utils.string2binary(this.data);
        }
        this.length = this.data.length;
        this.index = 0;
        this.zero = 0;
    }
    StringReader.prototype = new dataReader();
    /**
     * @see DataReader.byteAt
     */
    StringReader.prototype.byteAt = function(i) {
        return this.data.charCodeAt(this.zero + i);
    };
    /**
     * @see DataReader.lastIndexOfSignature
     */
    StringReader.prototype.lastIndexOfSignature = function(sig) {
        return this.data.lastIndexOf(sig) - this.zero;
    };
    /**
     * @see DataReader.readData
     */
    StringReader.prototype.readData = function(size) {
        this.checkOffset(size);
        // this will work because the constructor applied the "& 0xff" mask.
        var result = this.data.slice(this.zero + this.index, this.zero + this.index + size);
        this.index += size;
        return result;
    };
    var stringReader = StringReader;

    function ArrayReader(data) {
        if (data) {
            this.data = data;
            this.length = this.data.length;
            this.index = 0;
            this.zero = 0;

            for(var i = 0; i < this.data.length; i++) {
                data[i] = data[i] & 0xFF;
            }
        }
    }
    ArrayReader.prototype = new dataReader();
    /**
     * @see DataReader.byteAt
     */
    ArrayReader.prototype.byteAt = function(i) {
        return this.data[this.zero + i];
    };
    /**
     * @see DataReader.lastIndexOfSignature
     */
    ArrayReader.prototype.lastIndexOfSignature = function(sig) {
        var sig0 = sig.charCodeAt(0),
            sig1 = sig.charCodeAt(1),
            sig2 = sig.charCodeAt(2),
            sig3 = sig.charCodeAt(3);
        for (var i = this.length - 4; i >= 0; --i) {
            if (this.data[i] === sig0 && this.data[i + 1] === sig1 && this.data[i + 2] === sig2 && this.data[i + 3] === sig3) {
                return i - this.zero;
            }
        }

        return -1;
    };
    /**
     * @see DataReader.readData
     */
    ArrayReader.prototype.readData = function(size) {
        this.checkOffset(size);
        if(size === 0) {
            return [];
        }
        var result = this.data.slice(this.zero + this.index, this.zero + this.index + size);
        this.index += size;
        return result;
    };
    var arrayReader = ArrayReader;

    function Uint8ArrayReader(data) {
        if (data) {
            this.data = data;
            this.length = this.data.length;
            this.index = 0;
            this.zero = 0;
        }
    }
    Uint8ArrayReader.prototype = new arrayReader();
    /**
     * @see DataReader.readData
     */
    Uint8ArrayReader.prototype.readData = function(size) {
        this.checkOffset(size);
        if(size === 0) {
            // in IE10, when using subarray(idx, idx), we get the array [0x00] instead of [].
            return new Uint8Array(0);
        }
        var result = this.data.subarray(this.zero + this.index, this.zero + this.index + size);
        this.index += size;
        return result;
    };
    var uint8ArrayReader = Uint8ArrayReader;

    function NodeBufferReader(data) {
        this.data = data;
        this.length = this.data.length;
        this.index = 0;
        this.zero = 0;
    }
    NodeBufferReader.prototype = new uint8ArrayReader();

    /**
     * @see DataReader.readData
     */
    NodeBufferReader.prototype.readData = function(size) {
        this.checkOffset(size);
        var result = this.data.slice(this.zero + this.index, this.zero + this.index + size);
        this.index += size;
        return result;
    };
    var nodeBufferReader = NodeBufferReader;

    var MADE_BY_DOS = 0x00;
    var MADE_BY_UNIX = 0x03;

    // class ZipEntry {{{
    /**
     * An entry in the zip file.
     * @constructor
     * @param {Object} options Options of the current file.
     * @param {Object} loadOptions Options for loading the stream.
     */
    function ZipEntry(options, loadOptions) {
        this.options = options;
        this.loadOptions = loadOptions;
    }
    ZipEntry.prototype = {
        /**
         * say if the file is encrypted.
         * @return {boolean} true if the file is encrypted, false otherwise.
         */
        isEncrypted: function() {
            // bit 1 is set
            return (this.bitFlag & 0x0001) === 0x0001;
        },
        /**
         * say if the file has utf-8 filename/comment.
         * @return {boolean} true if the filename/comment is in utf-8, false otherwise.
         */
        useUTF8: function() {
            // bit 11 is set
            return (this.bitFlag & 0x0800) === 0x0800;
        },
        /**
         * Prepare the function used to generate the compressed content from this ZipFile.
         * @param {DataReader} reader the reader to use.
         * @param {number} from the offset from where we should read the data.
         * @param {number} length the length of the data to read.
         * @return {Function} the callback to get the compressed content (the type depends of the DataReader class).
         */
        prepareCompressedContent: function(reader, from, length) {
            return function() {
                var previousIndex = reader.index;
                reader.setIndex(from);
                var compressedFileData = reader.readData(length);
                reader.setIndex(previousIndex);

                return compressedFileData;
            };
        },
        /**
         * Prepare the function used to generate the uncompressed content from this ZipFile.
         * @param {DataReader} reader the reader to use.
         * @param {number} from the offset from where we should read the data.
         * @param {number} length the length of the data to read.
         * @param {JSZip.compression} compression the compression used on this file.
         * @param {number} uncompressedSize the uncompressed size to expect.
         * @return {Function} the callback to get the uncompressed content (the type depends of the DataReader class).
         */
        prepareContent: function(reader, from, length, compression, uncompressedSize) {
            return function() {

                var compressedFileData = utils.transformTo(compression.uncompressInputType, this.getCompressedContent());
                var uncompressedFileData = compression.uncompress(compressedFileData);

                if (uncompressedFileData.length !== uncompressedSize) {
                    throw new Error("Bug : uncompressed data size mismatch");
                }

                return uncompressedFileData;
            };
        },
        /**
         * Read the local part of a zip file and add the info in this object.
         * @param {DataReader} reader the reader to use.
         */
        readLocalPart: function(reader) {
            var compression, localExtraFieldsLength;

            // we already know everything from the central dir !
            // If the central dir data are false, we are doomed.
            // On the bright side, the local part is scary  : zip64, data descriptors, both, etc.
            // The less data we get here, the more reliable this should be.
            // Let's skip the whole header and dash to the data !
            reader.skip(22);
            // in some zip created on windows, the filename stored in the central dir contains \ instead of /.
            // Strangely, the filename here is OK.
            // I would love to treat these zip files as corrupted (see http://www.info-zip.org/FAQ.html#backslashes
            // or APPNOTE#4.4.17.1, "All slashes MUST be forward slashes '/'") but there are a lot of bad zip generators...
            // Search "unzip mismatching "local" filename continuing with "central" filename version" on
            // the internet.
            //
            // I think I see the logic here : the central directory is used to display
            // content and the local directory is used to extract the files. Mixing / and \
            // may be used to display \ to windows users and use / when extracting the files.
            // Unfortunately, this lead also to some issues : http://seclists.org/fulldisclosure/2009/Sep/394
            this.fileNameLength = reader.readInt(2);
            localExtraFieldsLength = reader.readInt(2); // can't be sure this will be the same as the central dir
            this.fileName = reader.readData(this.fileNameLength);
            reader.skip(localExtraFieldsLength);

            if (this.compressedSize == -1 || this.uncompressedSize == -1) {
                throw new Error("Bug or corrupted zip : didn't get enough informations from the central directory " + "(compressedSize == -1 || uncompressedSize == -1)");
            }

            compression = utils.findCompression(this.compressionMethod);
            if (compression === null) { // no compression found
                throw new Error("Corrupted zip : compression " + utils.pretty(this.compressionMethod) + " unknown (inner file : " +  utils.transformTo("string", this.fileName) + ")");
            }
            this.decompressed = new compressedObject();
            this.decompressed.compressedSize = this.compressedSize;
            this.decompressed.uncompressedSize = this.uncompressedSize;
            this.decompressed.crc32 = this.crc32;
            this.decompressed.compressionMethod = this.compressionMethod;
            this.decompressed.getCompressedContent = this.prepareCompressedContent(reader, reader.index, this.compressedSize, compression);
            this.decompressed.getContent = this.prepareContent(reader, reader.index, this.compressedSize, compression, this.uncompressedSize);

            // we need to compute the crc32...
            if (this.loadOptions.checkCRC32) {
                this.decompressed = utils.transformTo("string", this.decompressed.getContent());
                if (object.crc32(this.decompressed) !== this.crc32) {
                    throw new Error("Corrupted zip : CRC32 mismatch");
                }
            }
        },

        /**
         * Read the central part of a zip file and add the info in this object.
         * @param {DataReader} reader the reader to use.
         */
        readCentralPart: function(reader) {
            this.versionMadeBy = reader.readInt(2);
            this.versionNeeded = reader.readInt(2);
            this.bitFlag = reader.readInt(2);
            this.compressionMethod = reader.readString(2);
            this.date = reader.readDate();
            this.crc32 = reader.readInt(4);
            this.compressedSize = reader.readInt(4);
            this.uncompressedSize = reader.readInt(4);
            this.fileNameLength = reader.readInt(2);
            this.extraFieldsLength = reader.readInt(2);
            this.fileCommentLength = reader.readInt(2);
            this.diskNumberStart = reader.readInt(2);
            this.internalFileAttributes = reader.readInt(2);
            this.externalFileAttributes = reader.readInt(4);
            this.localHeaderOffset = reader.readInt(4);

            if (this.isEncrypted()) {
                throw new Error("Encrypted zip are not supported");
            }

            this.fileName = reader.readData(this.fileNameLength);
            this.readExtraFields(reader);
            this.parseZIP64ExtraField(reader);
            this.fileComment = reader.readData(this.fileCommentLength);
        },

        /**
         * Parse the external file attributes and get the unix/dos permissions.
         */
        processAttributes: function () {
            this.unixPermissions = null;
            this.dosPermissions = null;
            var madeBy = this.versionMadeBy >> 8;

            // Check if we have the DOS directory flag set.
            // We look for it in the DOS and UNIX permissions
            // but some unknown platform could set it as a compatibility flag.
            this.dir = this.externalFileAttributes & 0x0010 ? true : false;

            if(madeBy === MADE_BY_DOS) {
                // first 6 bits (0 to 5)
                this.dosPermissions = this.externalFileAttributes & 0x3F;
            }

            if(madeBy === MADE_BY_UNIX) {
                this.unixPermissions = (this.externalFileAttributes >> 16) & 0xFFFF;
                // the octal permissions are in (this.unixPermissions & 0x01FF).toString(8);
            }

            // fail safe : if the name ends with a / it probably means a folder
            if (!this.dir && this.fileNameStr.slice(-1) === '/') {
                this.dir = true;
            }
        },

        /**
         * Parse the ZIP64 extra field and merge the info in the current ZipEntry.
         * @param {DataReader} reader the reader to use.
         */
        parseZIP64ExtraField: function(reader) {

            if (!this.extraFields[0x0001]) {
                return;
            }

            // should be something, preparing the extra reader
            var extraReader = new stringReader(this.extraFields[0x0001].value);

            // I really hope that these 64bits integer can fit in 32 bits integer, because js
            // won't let us have more.
            if (this.uncompressedSize === utils.MAX_VALUE_32BITS) {
                this.uncompressedSize = extraReader.readInt(8);
            }
            if (this.compressedSize === utils.MAX_VALUE_32BITS) {
                this.compressedSize = extraReader.readInt(8);
            }
            if (this.localHeaderOffset === utils.MAX_VALUE_32BITS) {
                this.localHeaderOffset = extraReader.readInt(8);
            }
            if (this.diskNumberStart === utils.MAX_VALUE_32BITS) {
                this.diskNumberStart = extraReader.readInt(4);
            }
        },
        /**
         * Read the central part of a zip file and add the info in this object.
         * @param {DataReader} reader the reader to use.
         */
        readExtraFields: function(reader) {
            var start = reader.index,
                extraFieldId,
                extraFieldLength,
                extraFieldValue;

            this.extraFields = this.extraFields || {};

            while (reader.index < start + this.extraFieldsLength) {
                extraFieldId = reader.readInt(2);
                extraFieldLength = reader.readInt(2);
                extraFieldValue = reader.readString(extraFieldLength);

                this.extraFields[extraFieldId] = {
                    id: extraFieldId,
                    length: extraFieldLength,
                    value: extraFieldValue
                };
            }
        },
        /**
         * Apply an UTF8 transformation if needed.
         */
        handleUTF8: function() {
            var decodeParamType = support.uint8array ? "uint8array" : "array";
            if (this.useUTF8()) {
                this.fileNameStr = object.utf8decode(this.fileName);
                this.fileCommentStr = object.utf8decode(this.fileComment);
            } else {
                var upath = this.findExtraFieldUnicodePath();
                if (upath !== null) {
                    this.fileNameStr = upath;
                } else {
                    var fileNameByteArray =  utils.transformTo(decodeParamType, this.fileName);
                    this.fileNameStr = this.loadOptions.decodeFileName(fileNameByteArray);
                }

                var ucomment = this.findExtraFieldUnicodeComment();
                if (ucomment !== null) {
                    this.fileCommentStr = ucomment;
                } else {
                    var commentByteArray =  utils.transformTo(decodeParamType, this.fileComment);
                    this.fileCommentStr = this.loadOptions.decodeFileName(commentByteArray);
                }
            }
        },

        /**
         * Find the unicode path declared in the extra field, if any.
         * @return {String} the unicode path, null otherwise.
         */
        findExtraFieldUnicodePath: function() {
            var upathField = this.extraFields[0x7075];
            if (upathField) {
                var extraReader = new stringReader(upathField.value);

                // wrong version
                if (extraReader.readInt(1) !== 1) {
                    return null;
                }

                // the crc of the filename changed, this field is out of date.
                if (object.crc32(this.fileName) !== extraReader.readInt(4)) {
                    return null;
                }

                return object.utf8decode(extraReader.readString(upathField.length - 5));
            }
            return null;
        },

        /**
         * Find the unicode comment declared in the extra field, if any.
         * @return {String} the unicode comment, null otherwise.
         */
        findExtraFieldUnicodeComment: function() {
            var ucommentField = this.extraFields[0x6375];
            if (ucommentField) {
                var extraReader = new stringReader(ucommentField.value);

                // wrong version
                if (extraReader.readInt(1) !== 1) {
                    return null;
                }

                // the crc of the comment changed, this field is out of date.
                if (object.crc32(this.fileComment) !== extraReader.readInt(4)) {
                    return null;
                }

                return object.utf8decode(extraReader.readString(ucommentField.length - 5));
            }
            return null;
        }
    };
    var zipEntry = ZipEntry;

    //  class ZipEntries {{{
    /**
     * All the entries in the zip file.
     * @constructor
     * @param {String|ArrayBuffer|Uint8Array} data the binary stream to load.
     * @param {Object} loadOptions Options for loading the stream.
     */
    function ZipEntries(data, loadOptions) {
        this.files = [];
        this.loadOptions = loadOptions;
        if (data) {
            this.load(data);
        }
    }
    ZipEntries.prototype = {
        /**
         * Check that the reader is on the speficied signature.
         * @param {string} expectedSignature the expected signature.
         * @throws {Error} if it is an other signature.
         */
        checkSignature: function(expectedSignature) {
            var signature = this.reader.readString(4);
            if (signature !== expectedSignature) {
                throw new Error("Corrupted zip or bug : unexpected signature " + "(" + utils.pretty(signature) + ", expected " + utils.pretty(expectedSignature) + ")");
            }
        },
        /**
         * Check if the given signature is at the given index.
         * @param {number} askedIndex the index to check.
         * @param {string} expectedSignature the signature to expect.
         * @return {boolean} true if the signature is here, false otherwise.
         */
        isSignature: function(askedIndex, expectedSignature) {
            var currentIndex = this.reader.index;
            this.reader.setIndex(askedIndex);
            var signature = this.reader.readString(4);
            var result = signature === expectedSignature;
            this.reader.setIndex(currentIndex);
            return result;
        },
        /**
         * Read the end of the central directory.
         */
        readBlockEndOfCentral: function() {
            this.diskNumber = this.reader.readInt(2);
            this.diskWithCentralDirStart = this.reader.readInt(2);
            this.centralDirRecordsOnThisDisk = this.reader.readInt(2);
            this.centralDirRecords = this.reader.readInt(2);
            this.centralDirSize = this.reader.readInt(4);
            this.centralDirOffset = this.reader.readInt(4);

            this.zipCommentLength = this.reader.readInt(2);
            // warning : the encoding depends of the system locale
            // On a linux machine with LANG=en_US.utf8, this field is utf8 encoded.
            // On a windows machine, this field is encoded with the localized windows code page.
            var zipComment = this.reader.readData(this.zipCommentLength);
            var decodeParamType = support.uint8array ? "uint8array" : "array";
            // To get consistent behavior with the generation part, we will assume that
            // this is utf8 encoded unless specified otherwise.
            var decodeContent = utils.transformTo(decodeParamType, zipComment);
            this.zipComment = this.loadOptions.decodeFileName(decodeContent);
        },
        /**
         * Read the end of the Zip 64 central directory.
         * Not merged with the method readEndOfCentral :
         * The end of central can coexist with its Zip64 brother,
         * I don't want to read the wrong number of bytes !
         */
        readBlockZip64EndOfCentral: function() {
            this.zip64EndOfCentralSize = this.reader.readInt(8);
            this.versionMadeBy = this.reader.readString(2);
            this.versionNeeded = this.reader.readInt(2);
            this.diskNumber = this.reader.readInt(4);
            this.diskWithCentralDirStart = this.reader.readInt(4);
            this.centralDirRecordsOnThisDisk = this.reader.readInt(8);
            this.centralDirRecords = this.reader.readInt(8);
            this.centralDirSize = this.reader.readInt(8);
            this.centralDirOffset = this.reader.readInt(8);

            this.zip64ExtensibleData = {};
            var extraDataSize = this.zip64EndOfCentralSize - 44,
                index = 0,
                extraFieldId,
                extraFieldLength,
                extraFieldValue;
            while (index < extraDataSize) {
                extraFieldId = this.reader.readInt(2);
                extraFieldLength = this.reader.readInt(4);
                extraFieldValue = this.reader.readString(extraFieldLength);
                this.zip64ExtensibleData[extraFieldId] = {
                    id: extraFieldId,
                    length: extraFieldLength,
                    value: extraFieldValue
                };
            }
        },
        /**
         * Read the end of the Zip 64 central directory locator.
         */
        readBlockZip64EndOfCentralLocator: function() {
            this.diskWithZip64CentralDirStart = this.reader.readInt(4);
            this.relativeOffsetEndOfZip64CentralDir = this.reader.readInt(8);
            this.disksCount = this.reader.readInt(4);
            if (this.disksCount > 1) {
                throw new Error("Multi-volumes zip are not supported");
            }
        },
        /**
         * Read the local files, based on the offset read in the central part.
         */
        readLocalFiles: function() {
            var i, file;
            for (i = 0; i < this.files.length; i++) {
                file = this.files[i];
                this.reader.setIndex(file.localHeaderOffset);
                this.checkSignature(signature.LOCAL_FILE_HEADER);
                file.readLocalPart(this.reader);
                file.handleUTF8();
                file.processAttributes();
            }
        },
        /**
         * Read the central directory.
         */
        readCentralDir: function() {
            var file;

            this.reader.setIndex(this.centralDirOffset);
            while (this.reader.readString(4) === signature.CENTRAL_FILE_HEADER) {
                file = new zipEntry({
                    zip64: this.zip64
                }, this.loadOptions);
                file.readCentralPart(this.reader);
                this.files.push(file);
            }

            if (this.centralDirRecords !== this.files.length) {
                if (this.centralDirRecords !== 0 && this.files.length === 0) {
                    // We expected some records but couldn't find ANY.
                    // This is really suspicious, as if something went wrong.
                    throw new Error("Corrupted zip or bug: expected " + this.centralDirRecords + " records in central dir, got " + this.files.length);
                }
            }
        },
        /**
         * Read the end of central directory.
         */
        readEndOfCentral: function() {
            var offset = this.reader.lastIndexOfSignature(signature.CENTRAL_DIRECTORY_END);
            if (offset < 0) {
                // Check if the content is a truncated zip or complete garbage.
                // A "LOCAL_FILE_HEADER" is not required at the beginning (auto
                // extractible zip for example) but it can give a good hint.
                // If an ajax request was used without responseType, we will also
                // get unreadable data.
                var isGarbage = !this.isSignature(0, signature.LOCAL_FILE_HEADER);

                if (isGarbage) {
                    throw new Error("Can't find end of central directory : is this a zip file ? " +
                                    "If it is, see http://stuk.github.io/jszip/documentation/howto/read_zip.html");
                } else {
                    throw new Error("Corrupted zip : can't find end of central directory");
                }
            }
            this.reader.setIndex(offset);
            var endOfCentralDirOffset = offset;
            this.checkSignature(signature.CENTRAL_DIRECTORY_END);
            this.readBlockEndOfCentral();


            /* extract from the zip spec :
                4)  If one of the fields in the end of central directory
                    record is too small to hold required data, the field
                    should be set to -1 (0xFFFF or 0xFFFFFFFF) and the
                    ZIP64 format record should be created.
                5)  The end of central directory record and the
                    Zip64 end of central directory locator record must
                    reside on the same disk when splitting or spanning
                    an archive.
             */
            if (this.diskNumber === utils.MAX_VALUE_16BITS || this.diskWithCentralDirStart === utils.MAX_VALUE_16BITS || this.centralDirRecordsOnThisDisk === utils.MAX_VALUE_16BITS || this.centralDirRecords === utils.MAX_VALUE_16BITS || this.centralDirSize === utils.MAX_VALUE_32BITS || this.centralDirOffset === utils.MAX_VALUE_32BITS) {
                this.zip64 = true;

                /*
                Warning : the zip64 extension is supported, but ONLY if the 64bits integer read from
                the zip file can fit into a 32bits integer. This cannot be solved : Javascript represents
                all numbers as 64-bit double precision IEEE 754 floating point numbers.
                So, we have 53bits for integers and bitwise operations treat everything as 32bits.
                see https://developer.mozilla.org/en-US/docs/JavaScript/Reference/Operators/Bitwise_Operators
                and http://www.ecma-international.org/publications/files/ECMA-ST/ECMA-262.pdf section 8.5
                */

                // should look for a zip64 EOCD locator
                offset = this.reader.lastIndexOfSignature(signature.ZIP64_CENTRAL_DIRECTORY_LOCATOR);
                if (offset < 0) {
                    throw new Error("Corrupted zip : can't find the ZIP64 end of central directory locator");
                }
                this.reader.setIndex(offset);
                this.checkSignature(signature.ZIP64_CENTRAL_DIRECTORY_LOCATOR);
                this.readBlockZip64EndOfCentralLocator();

                // now the zip64 EOCD record
                if (!this.isSignature(this.relativeOffsetEndOfZip64CentralDir, signature.ZIP64_CENTRAL_DIRECTORY_END)) {
                    // console.warn("ZIP64 end of central directory not where expected.");
                    this.relativeOffsetEndOfZip64CentralDir = this.reader.lastIndexOfSignature(signature.ZIP64_CENTRAL_DIRECTORY_END);
                    if (this.relativeOffsetEndOfZip64CentralDir < 0) {
                        throw new Error("Corrupted zip : can't find the ZIP64 end of central directory");
                    }
                }
                this.reader.setIndex(this.relativeOffsetEndOfZip64CentralDir);
                this.checkSignature(signature.ZIP64_CENTRAL_DIRECTORY_END);
                this.readBlockZip64EndOfCentral();
            }

            var expectedEndOfCentralDirOffset = this.centralDirOffset + this.centralDirSize;
            if (this.zip64) {
                expectedEndOfCentralDirOffset += 20; // end of central dir 64 locator
                expectedEndOfCentralDirOffset += 12 /* should not include the leading 12 bytes */ + this.zip64EndOfCentralSize;
            }

            var extraBytes = endOfCentralDirOffset - expectedEndOfCentralDirOffset;

            if (extraBytes > 0) {
                // console.warn(extraBytes, "extra bytes at beginning or within zipfile");
                if (this.isSignature(endOfCentralDirOffset, signature.CENTRAL_FILE_HEADER)) ; else {
                    // the offset is wrong, update the "zero" of the reader
                    // this happens if data has been prepended (crx files for example)
                    this.reader.zero = extraBytes;
                }
            } else if (extraBytes < 0) {
                throw new Error("Corrupted zip: missing " + Math.abs(extraBytes) + " bytes.");
            }
        },
        prepareReader: function(data) {
            var type = utils.getTypeOf(data);
            utils.checkSupport(type);
            if (type === "string" && !support.uint8array) {
                this.reader = new stringReader(data, this.loadOptions.optimizedBinaryString);
            }
            else if (type === "nodebuffer") {
                this.reader = new nodeBufferReader(data);
            }
            else if (support.uint8array) {
                this.reader = new uint8ArrayReader(utils.transformTo("uint8array", data));
            } else if (support.array) {
                this.reader = new arrayReader(utils.transformTo("array", data));
            } else {
                throw new Error("Unexpected error: unsupported type '" + type + "'");
            }
        },
        /**
         * Read a zip file and create ZipEntries.
         * @param {String|ArrayBuffer|Uint8Array|Buffer} data the binary string representing a zip file.
         */
        load: function(data) {
            this.prepareReader(data);
            this.readEndOfCentral();
            this.readCentralDir();
            this.readLocalFiles();
        }
    };
    // }}} end of ZipEntries
    var zipEntries = ZipEntries;

    var load = function(data, options) {
        var files, zipEntries$1, i, input;
        options = utils.extend(options || {}, {
            base64: false,
            checkCRC32: false,
            optimizedBinaryString : false,
            createFolders: false,
            decodeFileName: utf8.utf8decode
        });
        if (options.base64) {
            data = base64$1.decode(data);
        }

        zipEntries$1 = new zipEntries(data, options);
        files = zipEntries$1.files;
        for (i = 0; i < files.length; i++) {
            input = files[i];
            this.file(input.fileNameStr, input.decompressed, {
                binary: true,
                optimizedBinaryString: true,
                date: input.date,
                dir: input.dir,
                comment : input.fileCommentStr.length ? input.fileCommentStr : null,
                unixPermissions : input.unixPermissions,
                dosPermissions : input.dosPermissions,
                createFolders: options.createFolders
            });
        }
        if (zipEntries$1.zipComment.length) {
            this.comment = zipEntries$1.zipComment;
        }

        return this;
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var string2binary = function(str) {
        return utils.string2binary(str);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var string2Uint8Array = function(str) {
        return utils.transformTo("uint8array", str);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var uint8Array2String = function(array) {
        return utils.transformTo("string", array);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var string2Blob = function(str) {
        var buffer = utils.transformTo("arraybuffer", str);
        return utils.arrayBuffer2Blob(buffer);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var arrayBuffer2Blob = function(buffer) {
        return utils.arrayBuffer2Blob(buffer);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var transformTo = function(outputType, input) {
        return utils.transformTo(outputType, input);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var getTypeOf = function(input) {
        return utils.getTypeOf(input);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var checkSupport = function(type) {
        return utils.checkSupport(type);
    };

    /**
     * @deprecated
     * This value will be removed in a future version without replacement.
     */
    var MAX_VALUE_16BITS = utils.MAX_VALUE_16BITS;

    /**
     * @deprecated
     * This value will be removed in a future version without replacement.
     */
    var MAX_VALUE_32BITS = utils.MAX_VALUE_32BITS;


    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var pretty = function(str) {
        return utils.pretty(str);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var findCompression = function(compressionMethod) {
        return utils.findCompression(compressionMethod);
    };

    /**
     * @deprecated
     * This function will be removed in a future version without replacement.
     */
    var isRegExp = function (object) {
        return utils.isRegExp(object);
    };

    var deprecatedPublicUtils = {
    	string2binary: string2binary,
    	string2Uint8Array: string2Uint8Array,
    	uint8Array2String: uint8Array2String,
    	string2Blob: string2Blob,
    	arrayBuffer2Blob: arrayBuffer2Blob,
    	transformTo: transformTo,
    	getTypeOf: getTypeOf,
    	checkSupport: checkSupport,
    	MAX_VALUE_16BITS: MAX_VALUE_16BITS,
    	MAX_VALUE_32BITS: MAX_VALUE_32BITS,
    	pretty: pretty,
    	findCompression: findCompression,
    	isRegExp: isRegExp
    };

    /**
    Usage:
       zip = new JSZip();
       zip.file("hello.txt", "Hello, World!").file("tempfile", "nothing");
       zip.folder("images").file("smile.gif", base64Data, {base64: true});
       zip.file("Xmas.txt", "Ho ho ho !", {date : new Date("December 25, 2007 00:00:01")});
       zip.remove("tempfile");

       base64zip = zip.generate();

    **/

    /**
     * Representation a of zip file in js
     * @constructor
     * @param {String=|ArrayBuffer=|Uint8Array=} data the data to load, if any (optional).
     * @param {Object=} options the options for creating this objects (optional).
     */
    function JSZip(data, options) {
        // if this constructor is used without `new`, it adds `new` before itself:
        if(!(this instanceof JSZip)) return new JSZip(data, options);

        // object containing the files :
        // {
        //   "folder/" : {...},
        //   "folder/data.txt" : {...}
        // }
        // NOTE: we use a null prototype because we do not
        // want filenames like "toString" coming from a zip file
        // to overwrite methods and attributes in a normal Object.
        this.files = Object.create(null);

        this.comment = null;

        // Where we are in the hierarchy
        this.root = "";
        if (data) {
            this.load(data, options);
        }
        this.clone = function() {
            var newObj = new JSZip();
            for (var i in this) {
                if (typeof this[i] !== "function") {
                    newObj[i] = this[i];
                }
            }
            return newObj;
        };
    }
    JSZip.prototype = object;
    JSZip.prototype.load = load;
    JSZip.support = support;
    JSZip.defaults = defaults;

    /**
     * @deprecated
     * This namespace will be removed in a future version without replacement.
     */
    JSZip.utils = deprecatedPublicUtils;

    JSZip.base64 = {
        /**
         * @deprecated
         * This method will be removed in a future version without replacement.
         */
        encode : function(input) {
            return base64$1.encode(input);
        },
        /**
         * @deprecated
         * This method will be removed in a future version without replacement.
         */
        decode : function(input) {
            return base64$1.decode(input);
        }
    };
    JSZip.compressions = compressions;
    var lib = JSZip;

    var tinycolor = createCommonjsModule(function (module) {
    // TinyColor v1.4.2
    // https://github.com/bgrins/TinyColor
    // Brian Grinstead, MIT License

    (function(Math) {

    var trimLeft = /^\s+/,
        trimRight = /\s+$/,
        tinyCounter = 0,
        mathRound = Math.round,
        mathMin = Math.min,
        mathMax = Math.max,
        mathRandom = Math.random;

    function tinycolor (color, opts) {

        color = (color) ? color : '';
        opts = opts || { };

        // If input is already a tinycolor, return itself
        if (color instanceof tinycolor) {
           return color;
        }
        // If we are called as a function, call using new instead
        if (!(this instanceof tinycolor)) {
            return new tinycolor(color, opts);
        }

        var rgb = inputToRGB(color);
        this._originalInput = color,
        this._r = rgb.r,
        this._g = rgb.g,
        this._b = rgb.b,
        this._a = rgb.a,
        this._roundA = mathRound(100*this._a) / 100,
        this._format = opts.format || rgb.format;
        this._gradientType = opts.gradientType;

        // Don't let the range of [0,255] come back in [0,1].
        // Potentially lose a little bit of precision here, but will fix issues where
        // .5 gets interpreted as half of the total, instead of half of 1
        // If it was supposed to be 128, this was already taken care of by `inputToRgb`
        if (this._r < 1) { this._r = mathRound(this._r); }
        if (this._g < 1) { this._g = mathRound(this._g); }
        if (this._b < 1) { this._b = mathRound(this._b); }

        this._ok = rgb.ok;
        this._tc_id = tinyCounter++;
    }

    tinycolor.prototype = {
        isDark: function() {
            return this.getBrightness() < 128;
        },
        isLight: function() {
            return !this.isDark();
        },
        isValid: function() {
            return this._ok;
        },
        getOriginalInput: function() {
          return this._originalInput;
        },
        getFormat: function() {
            return this._format;
        },
        getAlpha: function() {
            return this._a;
        },
        getBrightness: function() {
            //http://www.w3.org/TR/AERT#color-contrast
            var rgb = this.toRgb();
            return (rgb.r * 299 + rgb.g * 587 + rgb.b * 114) / 1000;
        },
        getLuminance: function() {
            //http://www.w3.org/TR/2008/REC-WCAG20-20081211/#relativeluminancedef
            var rgb = this.toRgb();
            var RsRGB, GsRGB, BsRGB, R, G, B;
            RsRGB = rgb.r/255;
            GsRGB = rgb.g/255;
            BsRGB = rgb.b/255;

            if (RsRGB <= 0.03928) {R = RsRGB / 12.92;} else {R = Math.pow(((RsRGB + 0.055) / 1.055), 2.4);}
            if (GsRGB <= 0.03928) {G = GsRGB / 12.92;} else {G = Math.pow(((GsRGB + 0.055) / 1.055), 2.4);}
            if (BsRGB <= 0.03928) {B = BsRGB / 12.92;} else {B = Math.pow(((BsRGB + 0.055) / 1.055), 2.4);}
            return (0.2126 * R) + (0.7152 * G) + (0.0722 * B);
        },
        setAlpha: function(value) {
            this._a = boundAlpha(value);
            this._roundA = mathRound(100*this._a) / 100;
            return this;
        },
        toHsv: function() {
            var hsv = rgbToHsv(this._r, this._g, this._b);
            return { h: hsv.h * 360, s: hsv.s, v: hsv.v, a: this._a };
        },
        toHsvString: function() {
            var hsv = rgbToHsv(this._r, this._g, this._b);
            var h = mathRound(hsv.h * 360), s = mathRound(hsv.s * 100), v = mathRound(hsv.v * 100);
            return (this._a == 1) ?
              "hsv("  + h + ", " + s + "%, " + v + "%)" :
              "hsva(" + h + ", " + s + "%, " + v + "%, "+ this._roundA + ")";
        },
        toHsl: function() {
            var hsl = rgbToHsl(this._r, this._g, this._b);
            return { h: hsl.h * 360, s: hsl.s, l: hsl.l, a: this._a };
        },
        toHslString: function() {
            var hsl = rgbToHsl(this._r, this._g, this._b);
            var h = mathRound(hsl.h * 360), s = mathRound(hsl.s * 100), l = mathRound(hsl.l * 100);
            return (this._a == 1) ?
              "hsl("  + h + ", " + s + "%, " + l + "%)" :
              "hsla(" + h + ", " + s + "%, " + l + "%, "+ this._roundA + ")";
        },
        toHex: function(allow3Char) {
            return rgbToHex(this._r, this._g, this._b, allow3Char);
        },
        toHexString: function(allow3Char) {
            return '#' + this.toHex(allow3Char);
        },
        toHex8: function(allow4Char) {
            return rgbaToHex(this._r, this._g, this._b, this._a, allow4Char);
        },
        toHex8String: function(allow4Char) {
            return '#' + this.toHex8(allow4Char);
        },
        toRgb: function() {
            return { r: mathRound(this._r), g: mathRound(this._g), b: mathRound(this._b), a: this._a };
        },
        toRgbString: function() {
            return (this._a == 1) ?
              "rgb("  + mathRound(this._r) + ", " + mathRound(this._g) + ", " + mathRound(this._b) + ")" :
              "rgba(" + mathRound(this._r) + ", " + mathRound(this._g) + ", " + mathRound(this._b) + ", " + this._roundA + ")";
        },
        toPercentageRgb: function() {
            return { r: mathRound(bound01(this._r, 255) * 100) + "%", g: mathRound(bound01(this._g, 255) * 100) + "%", b: mathRound(bound01(this._b, 255) * 100) + "%", a: this._a };
        },
        toPercentageRgbString: function() {
            return (this._a == 1) ?
              "rgb("  + mathRound(bound01(this._r, 255) * 100) + "%, " + mathRound(bound01(this._g, 255) * 100) + "%, " + mathRound(bound01(this._b, 255) * 100) + "%)" :
              "rgba(" + mathRound(bound01(this._r, 255) * 100) + "%, " + mathRound(bound01(this._g, 255) * 100) + "%, " + mathRound(bound01(this._b, 255) * 100) + "%, " + this._roundA + ")";
        },
        toName: function() {
            if (this._a === 0) {
                return "transparent";
            }

            if (this._a < 1) {
                return false;
            }

            return hexNames[rgbToHex(this._r, this._g, this._b, true)] || false;
        },
        toFilter: function(secondColor) {
            var hex8String = '#' + rgbaToArgbHex(this._r, this._g, this._b, this._a);
            var secondHex8String = hex8String;
            var gradientType = this._gradientType ? "GradientType = 1, " : "";

            if (secondColor) {
                var s = tinycolor(secondColor);
                secondHex8String = '#' + rgbaToArgbHex(s._r, s._g, s._b, s._a);
            }

            return "progid:DXImageTransform.Microsoft.gradient("+gradientType+"startColorstr="+hex8String+",endColorstr="+secondHex8String+")";
        },
        toString: function(format) {
            var formatSet = !!format;
            format = format || this._format;

            var formattedString = false;
            var hasAlpha = this._a < 1 && this._a >= 0;
            var needsAlphaFormat = !formatSet && hasAlpha && (format === "hex" || format === "hex6" || format === "hex3" || format === "hex4" || format === "hex8" || format === "name");

            if (needsAlphaFormat) {
                // Special case for "transparent", all other non-alpha formats
                // will return rgba when there is transparency.
                if (format === "name" && this._a === 0) {
                    return this.toName();
                }
                return this.toRgbString();
            }
            if (format === "rgb") {
                formattedString = this.toRgbString();
            }
            if (format === "prgb") {
                formattedString = this.toPercentageRgbString();
            }
            if (format === "hex" || format === "hex6") {
                formattedString = this.toHexString();
            }
            if (format === "hex3") {
                formattedString = this.toHexString(true);
            }
            if (format === "hex4") {
                formattedString = this.toHex8String(true);
            }
            if (format === "hex8") {
                formattedString = this.toHex8String();
            }
            if (format === "name") {
                formattedString = this.toName();
            }
            if (format === "hsl") {
                formattedString = this.toHslString();
            }
            if (format === "hsv") {
                formattedString = this.toHsvString();
            }

            return formattedString || this.toHexString();
        },
        clone: function() {
            return tinycolor(this.toString());
        },

        _applyModification: function(fn, args) {
            var color = fn.apply(null, [this].concat([].slice.call(args)));
            this._r = color._r;
            this._g = color._g;
            this._b = color._b;
            this.setAlpha(color._a);
            return this;
        },
        lighten: function() {
            return this._applyModification(lighten, arguments);
        },
        brighten: function() {
            return this._applyModification(brighten, arguments);
        },
        darken: function() {
            return this._applyModification(darken, arguments);
        },
        desaturate: function() {
            return this._applyModification(desaturate, arguments);
        },
        saturate: function() {
            return this._applyModification(saturate, arguments);
        },
        greyscale: function() {
            return this._applyModification(greyscale, arguments);
        },
        spin: function() {
            return this._applyModification(spin, arguments);
        },

        _applyCombination: function(fn, args) {
            return fn.apply(null, [this].concat([].slice.call(args)));
        },
        analogous: function() {
            return this._applyCombination(analogous, arguments);
        },
        complement: function() {
            return this._applyCombination(complement, arguments);
        },
        monochromatic: function() {
            return this._applyCombination(monochromatic, arguments);
        },
        splitcomplement: function() {
            return this._applyCombination(splitcomplement, arguments);
        },
        triad: function() {
            return this._applyCombination(triad, arguments);
        },
        tetrad: function() {
            return this._applyCombination(tetrad, arguments);
        }
    };

    // If input is an object, force 1 into "1.0" to handle ratios properly
    // String input requires "1.0" as input, so 1 will be treated as 1
    tinycolor.fromRatio = function(color, opts) {
        if (typeof color == "object") {
            var newColor = {};
            for (var i in color) {
                if (color.hasOwnProperty(i)) {
                    if (i === "a") {
                        newColor[i] = color[i];
                    }
                    else {
                        newColor[i] = convertToPercentage(color[i]);
                    }
                }
            }
            color = newColor;
        }

        return tinycolor(color, opts);
    };

    // Given a string or object, convert that input to RGB
    // Possible string inputs:
    //
    //     "red"
    //     "#f00" or "f00"
    //     "#ff0000" or "ff0000"
    //     "#ff000000" or "ff000000"
    //     "rgb 255 0 0" or "rgb (255, 0, 0)"
    //     "rgb 1.0 0 0" or "rgb (1, 0, 0)"
    //     "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
    //     "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
    //     "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
    //     "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
    //     "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
    //
    function inputToRGB(color) {

        var rgb = { r: 0, g: 0, b: 0 };
        var a = 1;
        var s = null;
        var v = null;
        var l = null;
        var ok = false;
        var format = false;

        if (typeof color == "string") {
            color = stringInputToObject(color);
        }

        if (typeof color == "object") {
            if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
                rgb = rgbToRgb(color.r, color.g, color.b);
                ok = true;
                format = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
            }
            else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
                s = convertToPercentage(color.s);
                v = convertToPercentage(color.v);
                rgb = hsvToRgb(color.h, s, v);
                ok = true;
                format = "hsv";
            }
            else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
                s = convertToPercentage(color.s);
                l = convertToPercentage(color.l);
                rgb = hslToRgb(color.h, s, l);
                ok = true;
                format = "hsl";
            }

            if (color.hasOwnProperty("a")) {
                a = color.a;
            }
        }

        a = boundAlpha(a);

        return {
            ok: ok,
            format: color.format || format,
            r: mathMin(255, mathMax(rgb.r, 0)),
            g: mathMin(255, mathMax(rgb.g, 0)),
            b: mathMin(255, mathMax(rgb.b, 0)),
            a: a
        };
    }


    // Conversion Functions
    // --------------------

    // `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
    // <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>

    // `rgbToRgb`
    // Handle bounds / percentage checking to conform to CSS color spec
    // <http://www.w3.org/TR/css3-color/>
    // *Assumes:* r, g, b in [0, 255] or [0, 1]
    // *Returns:* { r, g, b } in [0, 255]
    function rgbToRgb(r, g, b){
        return {
            r: bound01(r, 255) * 255,
            g: bound01(g, 255) * 255,
            b: bound01(b, 255) * 255
        };
    }

    // `rgbToHsl`
    // Converts an RGB color value to HSL.
    // *Assumes:* r, g, and b are contained in [0, 255] or [0, 1]
    // *Returns:* { h, s, l } in [0,1]
    function rgbToHsl(r, g, b) {

        r = bound01(r, 255);
        g = bound01(g, 255);
        b = bound01(b, 255);

        var max = mathMax(r, g, b), min = mathMin(r, g, b);
        var h, s, l = (max + min) / 2;

        if(max == min) {
            h = s = 0; // achromatic
        }
        else {
            var d = max - min;
            s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
            switch(max) {
                case r: h = (g - b) / d + (g < b ? 6 : 0); break;
                case g: h = (b - r) / d + 2; break;
                case b: h = (r - g) / d + 4; break;
            }

            h /= 6;
        }

        return { h: h, s: s, l: l };
    }

    // `hslToRgb`
    // Converts an HSL color value to RGB.
    // *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
    // *Returns:* { r, g, b } in the set [0, 255]
    function hslToRgb(h, s, l) {
        var r, g, b;

        h = bound01(h, 360);
        s = bound01(s, 100);
        l = bound01(l, 100);

        function hue2rgb(p, q, t) {
            if(t < 0) t += 1;
            if(t > 1) t -= 1;
            if(t < 1/6) return p + (q - p) * 6 * t;
            if(t < 1/2) return q;
            if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
            return p;
        }

        if(s === 0) {
            r = g = b = l; // achromatic
        }
        else {
            var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
            var p = 2 * l - q;
            r = hue2rgb(p, q, h + 1/3);
            g = hue2rgb(p, q, h);
            b = hue2rgb(p, q, h - 1/3);
        }

        return { r: r * 255, g: g * 255, b: b * 255 };
    }

    // `rgbToHsv`
    // Converts an RGB color value to HSV
    // *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
    // *Returns:* { h, s, v } in [0,1]
    function rgbToHsv(r, g, b) {

        r = bound01(r, 255);
        g = bound01(g, 255);
        b = bound01(b, 255);

        var max = mathMax(r, g, b), min = mathMin(r, g, b);
        var h, s, v = max;

        var d = max - min;
        s = max === 0 ? 0 : d / max;

        if(max == min) {
            h = 0; // achromatic
        }
        else {
            switch(max) {
                case r: h = (g - b) / d + (g < b ? 6 : 0); break;
                case g: h = (b - r) / d + 2; break;
                case b: h = (r - g) / d + 4; break;
            }
            h /= 6;
        }
        return { h: h, s: s, v: v };
    }

    // `hsvToRgb`
    // Converts an HSV color value to RGB.
    // *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
    // *Returns:* { r, g, b } in the set [0, 255]
     function hsvToRgb(h, s, v) {

        h = bound01(h, 360) * 6;
        s = bound01(s, 100);
        v = bound01(v, 100);

        var i = Math.floor(h),
            f = h - i,
            p = v * (1 - s),
            q = v * (1 - f * s),
            t = v * (1 - (1 - f) * s),
            mod = i % 6,
            r = [v, q, p, p, t, v][mod],
            g = [t, v, v, q, p, p][mod],
            b = [p, p, t, v, v, q][mod];

        return { r: r * 255, g: g * 255, b: b * 255 };
    }

    // `rgbToHex`
    // Converts an RGB color to hex
    // Assumes r, g, and b are contained in the set [0, 255]
    // Returns a 3 or 6 character hex
    function rgbToHex(r, g, b, allow3Char) {

        var hex = [
            pad2(mathRound(r).toString(16)),
            pad2(mathRound(g).toString(16)),
            pad2(mathRound(b).toString(16))
        ];

        // Return a 3 character hex if possible
        if (allow3Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1)) {
            return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
        }

        return hex.join("");
    }

    // `rgbaToHex`
    // Converts an RGBA color plus alpha transparency to hex
    // Assumes r, g, b are contained in the set [0, 255] and
    // a in [0, 1]. Returns a 4 or 8 character rgba hex
    function rgbaToHex(r, g, b, a, allow4Char) {

        var hex = [
            pad2(mathRound(r).toString(16)),
            pad2(mathRound(g).toString(16)),
            pad2(mathRound(b).toString(16)),
            pad2(convertDecimalToHex(a))
        ];

        // Return a 4 character hex if possible
        if (allow4Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1) && hex[3].charAt(0) == hex[3].charAt(1)) {
            return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0) + hex[3].charAt(0);
        }

        return hex.join("");
    }

    // `rgbaToArgbHex`
    // Converts an RGBA color to an ARGB Hex8 string
    // Rarely used, but required for "toFilter()"
    function rgbaToArgbHex(r, g, b, a) {

        var hex = [
            pad2(convertDecimalToHex(a)),
            pad2(mathRound(r).toString(16)),
            pad2(mathRound(g).toString(16)),
            pad2(mathRound(b).toString(16))
        ];

        return hex.join("");
    }

    // `equals`
    // Can be called with any tinycolor input
    tinycolor.equals = function (color1, color2) {
        if (!color1 || !color2) { return false; }
        return tinycolor(color1).toRgbString() == tinycolor(color2).toRgbString();
    };

    tinycolor.random = function() {
        return tinycolor.fromRatio({
            r: mathRandom(),
            g: mathRandom(),
            b: mathRandom()
        });
    };


    // Modification Functions
    // ----------------------
    // Thanks to less.js for some of the basics here
    // <https://github.com/cloudhead/less.js/blob/master/lib/less/functions.js>

    function desaturate(color, amount) {
        amount = (amount === 0) ? 0 : (amount || 10);
        var hsl = tinycolor(color).toHsl();
        hsl.s -= amount / 100;
        hsl.s = clamp01(hsl.s);
        return tinycolor(hsl);
    }

    function saturate(color, amount) {
        amount = (amount === 0) ? 0 : (amount || 10);
        var hsl = tinycolor(color).toHsl();
        hsl.s += amount / 100;
        hsl.s = clamp01(hsl.s);
        return tinycolor(hsl);
    }

    function greyscale(color) {
        return tinycolor(color).desaturate(100);
    }

    function lighten (color, amount) {
        amount = (amount === 0) ? 0 : (amount || 10);
        var hsl = tinycolor(color).toHsl();
        hsl.l += amount / 100;
        hsl.l = clamp01(hsl.l);
        return tinycolor(hsl);
    }

    function brighten(color, amount) {
        amount = (amount === 0) ? 0 : (amount || 10);
        var rgb = tinycolor(color).toRgb();
        rgb.r = mathMax(0, mathMin(255, rgb.r - mathRound(255 * - (amount / 100))));
        rgb.g = mathMax(0, mathMin(255, rgb.g - mathRound(255 * - (amount / 100))));
        rgb.b = mathMax(0, mathMin(255, rgb.b - mathRound(255 * - (amount / 100))));
        return tinycolor(rgb);
    }

    function darken (color, amount) {
        amount = (amount === 0) ? 0 : (amount || 10);
        var hsl = tinycolor(color).toHsl();
        hsl.l -= amount / 100;
        hsl.l = clamp01(hsl.l);
        return tinycolor(hsl);
    }

    // Spin takes a positive or negative amount within [-360, 360] indicating the change of hue.
    // Values outside of this range will be wrapped into this range.
    function spin(color, amount) {
        var hsl = tinycolor(color).toHsl();
        var hue = (hsl.h + amount) % 360;
        hsl.h = hue < 0 ? 360 + hue : hue;
        return tinycolor(hsl);
    }

    // Combination Functions
    // ---------------------
    // Thanks to jQuery xColor for some of the ideas behind these
    // <https://github.com/infusion/jQuery-xcolor/blob/master/jquery.xcolor.js>

    function complement(color) {
        var hsl = tinycolor(color).toHsl();
        hsl.h = (hsl.h + 180) % 360;
        return tinycolor(hsl);
    }

    function triad(color) {
        var hsl = tinycolor(color).toHsl();
        var h = hsl.h;
        return [
            tinycolor(color),
            tinycolor({ h: (h + 120) % 360, s: hsl.s, l: hsl.l }),
            tinycolor({ h: (h + 240) % 360, s: hsl.s, l: hsl.l })
        ];
    }

    function tetrad(color) {
        var hsl = tinycolor(color).toHsl();
        var h = hsl.h;
        return [
            tinycolor(color),
            tinycolor({ h: (h + 90) % 360, s: hsl.s, l: hsl.l }),
            tinycolor({ h: (h + 180) % 360, s: hsl.s, l: hsl.l }),
            tinycolor({ h: (h + 270) % 360, s: hsl.s, l: hsl.l })
        ];
    }

    function splitcomplement(color) {
        var hsl = tinycolor(color).toHsl();
        var h = hsl.h;
        return [
            tinycolor(color),
            tinycolor({ h: (h + 72) % 360, s: hsl.s, l: hsl.l}),
            tinycolor({ h: (h + 216) % 360, s: hsl.s, l: hsl.l})
        ];
    }

    function analogous(color, results, slices) {
        results = results || 6;
        slices = slices || 30;

        var hsl = tinycolor(color).toHsl();
        var part = 360 / slices;
        var ret = [tinycolor(color)];

        for (hsl.h = ((hsl.h - (part * results >> 1)) + 720) % 360; --results; ) {
            hsl.h = (hsl.h + part) % 360;
            ret.push(tinycolor(hsl));
        }
        return ret;
    }

    function monochromatic(color, results) {
        results = results || 6;
        var hsv = tinycolor(color).toHsv();
        var h = hsv.h, s = hsv.s, v = hsv.v;
        var ret = [];
        var modification = 1 / results;

        while (results--) {
            ret.push(tinycolor({ h: h, s: s, v: v}));
            v = (v + modification) % 1;
        }

        return ret;
    }

    // Utility Functions
    // ---------------------

    tinycolor.mix = function(color1, color2, amount) {
        amount = (amount === 0) ? 0 : (amount || 50);

        var rgb1 = tinycolor(color1).toRgb();
        var rgb2 = tinycolor(color2).toRgb();

        var p = amount / 100;

        var rgba = {
            r: ((rgb2.r - rgb1.r) * p) + rgb1.r,
            g: ((rgb2.g - rgb1.g) * p) + rgb1.g,
            b: ((rgb2.b - rgb1.b) * p) + rgb1.b,
            a: ((rgb2.a - rgb1.a) * p) + rgb1.a
        };

        return tinycolor(rgba);
    };


    // Readability Functions
    // ---------------------
    // <http://www.w3.org/TR/2008/REC-WCAG20-20081211/#contrast-ratiodef (WCAG Version 2)

    // `contrast`
    // Analyze the 2 colors and returns the color contrast defined by (WCAG Version 2)
    tinycolor.readability = function(color1, color2) {
        var c1 = tinycolor(color1);
        var c2 = tinycolor(color2);
        return (Math.max(c1.getLuminance(),c2.getLuminance())+0.05) / (Math.min(c1.getLuminance(),c2.getLuminance())+0.05);
    };

    // `isReadable`
    // Ensure that foreground and background color combinations meet WCAG2 guidelines.
    // The third argument is an optional Object.
    //      the 'level' property states 'AA' or 'AAA' - if missing or invalid, it defaults to 'AA';
    //      the 'size' property states 'large' or 'small' - if missing or invalid, it defaults to 'small'.
    // If the entire object is absent, isReadable defaults to {level:"AA",size:"small"}.

    // *Example*
    //    tinycolor.isReadable("#000", "#111") => false
    //    tinycolor.isReadable("#000", "#111",{level:"AA",size:"large"}) => false
    tinycolor.isReadable = function(color1, color2, wcag2) {
        var readability = tinycolor.readability(color1, color2);
        var wcag2Parms, out;

        out = false;

        wcag2Parms = validateWCAG2Parms(wcag2);
        switch (wcag2Parms.level + wcag2Parms.size) {
            case "AAsmall":
            case "AAAlarge":
                out = readability >= 4.5;
                break;
            case "AAlarge":
                out = readability >= 3;
                break;
            case "AAAsmall":
                out = readability >= 7;
                break;
        }
        return out;

    };

    // `mostReadable`
    // Given a base color and a list of possible foreground or background
    // colors for that base, returns the most readable color.
    // Optionally returns Black or White if the most readable color is unreadable.
    // *Example*
    //    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:false}).toHexString(); // "#112255"
    //    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:true}).toHexString();  // "#ffffff"
    //    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"large"}).toHexString(); // "#faf3f3"
    //    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"small"}).toHexString(); // "#ffffff"
    tinycolor.mostReadable = function(baseColor, colorList, args) {
        var bestColor = null;
        var bestScore = 0;
        var readability;
        var includeFallbackColors, level, size ;
        args = args || {};
        includeFallbackColors = args.includeFallbackColors ;
        level = args.level;
        size = args.size;

        for (var i= 0; i < colorList.length ; i++) {
            readability = tinycolor.readability(baseColor, colorList[i]);
            if (readability > bestScore) {
                bestScore = readability;
                bestColor = tinycolor(colorList[i]);
            }
        }

        if (tinycolor.isReadable(baseColor, bestColor, {"level":level,"size":size}) || !includeFallbackColors) {
            return bestColor;
        }
        else {
            args.includeFallbackColors=false;
            return tinycolor.mostReadable(baseColor,["#fff", "#000"],args);
        }
    };


    // Big List of Colors
    // ------------------
    // <http://www.w3.org/TR/css3-color/#svg-color>
    var names = tinycolor.names = {
        aliceblue: "f0f8ff",
        antiquewhite: "faebd7",
        aqua: "0ff",
        aquamarine: "7fffd4",
        azure: "f0ffff",
        beige: "f5f5dc",
        bisque: "ffe4c4",
        black: "000",
        blanchedalmond: "ffebcd",
        blue: "00f",
        blueviolet: "8a2be2",
        brown: "a52a2a",
        burlywood: "deb887",
        burntsienna: "ea7e5d",
        cadetblue: "5f9ea0",
        chartreuse: "7fff00",
        chocolate: "d2691e",
        coral: "ff7f50",
        cornflowerblue: "6495ed",
        cornsilk: "fff8dc",
        crimson: "dc143c",
        cyan: "0ff",
        darkblue: "00008b",
        darkcyan: "008b8b",
        darkgoldenrod: "b8860b",
        darkgray: "a9a9a9",
        darkgreen: "006400",
        darkgrey: "a9a9a9",
        darkkhaki: "bdb76b",
        darkmagenta: "8b008b",
        darkolivegreen: "556b2f",
        darkorange: "ff8c00",
        darkorchid: "9932cc",
        darkred: "8b0000",
        darksalmon: "e9967a",
        darkseagreen: "8fbc8f",
        darkslateblue: "483d8b",
        darkslategray: "2f4f4f",
        darkslategrey: "2f4f4f",
        darkturquoise: "00ced1",
        darkviolet: "9400d3",
        deeppink: "ff1493",
        deepskyblue: "00bfff",
        dimgray: "696969",
        dimgrey: "696969",
        dodgerblue: "1e90ff",
        firebrick: "b22222",
        floralwhite: "fffaf0",
        forestgreen: "228b22",
        fuchsia: "f0f",
        gainsboro: "dcdcdc",
        ghostwhite: "f8f8ff",
        gold: "ffd700",
        goldenrod: "daa520",
        gray: "808080",
        green: "008000",
        greenyellow: "adff2f",
        grey: "808080",
        honeydew: "f0fff0",
        hotpink: "ff69b4",
        indianred: "cd5c5c",
        indigo: "4b0082",
        ivory: "fffff0",
        khaki: "f0e68c",
        lavender: "e6e6fa",
        lavenderblush: "fff0f5",
        lawngreen: "7cfc00",
        lemonchiffon: "fffacd",
        lightblue: "add8e6",
        lightcoral: "f08080",
        lightcyan: "e0ffff",
        lightgoldenrodyellow: "fafad2",
        lightgray: "d3d3d3",
        lightgreen: "90ee90",
        lightgrey: "d3d3d3",
        lightpink: "ffb6c1",
        lightsalmon: "ffa07a",
        lightseagreen: "20b2aa",
        lightskyblue: "87cefa",
        lightslategray: "789",
        lightslategrey: "789",
        lightsteelblue: "b0c4de",
        lightyellow: "ffffe0",
        lime: "0f0",
        limegreen: "32cd32",
        linen: "faf0e6",
        magenta: "f0f",
        maroon: "800000",
        mediumaquamarine: "66cdaa",
        mediumblue: "0000cd",
        mediumorchid: "ba55d3",
        mediumpurple: "9370db",
        mediumseagreen: "3cb371",
        mediumslateblue: "7b68ee",
        mediumspringgreen: "00fa9a",
        mediumturquoise: "48d1cc",
        mediumvioletred: "c71585",
        midnightblue: "191970",
        mintcream: "f5fffa",
        mistyrose: "ffe4e1",
        moccasin: "ffe4b5",
        navajowhite: "ffdead",
        navy: "000080",
        oldlace: "fdf5e6",
        olive: "808000",
        olivedrab: "6b8e23",
        orange: "ffa500",
        orangered: "ff4500",
        orchid: "da70d6",
        palegoldenrod: "eee8aa",
        palegreen: "98fb98",
        paleturquoise: "afeeee",
        palevioletred: "db7093",
        papayawhip: "ffefd5",
        peachpuff: "ffdab9",
        peru: "cd853f",
        pink: "ffc0cb",
        plum: "dda0dd",
        powderblue: "b0e0e6",
        purple: "800080",
        rebeccapurple: "663399",
        red: "f00",
        rosybrown: "bc8f8f",
        royalblue: "4169e1",
        saddlebrown: "8b4513",
        salmon: "fa8072",
        sandybrown: "f4a460",
        seagreen: "2e8b57",
        seashell: "fff5ee",
        sienna: "a0522d",
        silver: "c0c0c0",
        skyblue: "87ceeb",
        slateblue: "6a5acd",
        slategray: "708090",
        slategrey: "708090",
        snow: "fffafa",
        springgreen: "00ff7f",
        steelblue: "4682b4",
        tan: "d2b48c",
        teal: "008080",
        thistle: "d8bfd8",
        tomato: "ff6347",
        turquoise: "40e0d0",
        violet: "ee82ee",
        wheat: "f5deb3",
        white: "fff",
        whitesmoke: "f5f5f5",
        yellow: "ff0",
        yellowgreen: "9acd32"
    };

    // Make it easy to access colors via `hexNames[hex]`
    var hexNames = tinycolor.hexNames = flip(names);


    // Utilities
    // ---------

    // `{ 'name1': 'val1' }` becomes `{ 'val1': 'name1' }`
    function flip(o) {
        var flipped = { };
        for (var i in o) {
            if (o.hasOwnProperty(i)) {
                flipped[o[i]] = i;
            }
        }
        return flipped;
    }

    // Return a valid alpha value [0,1] with all invalid values being set to 1
    function boundAlpha(a) {
        a = parseFloat(a);

        if (isNaN(a) || a < 0 || a > 1) {
            a = 1;
        }

        return a;
    }

    // Take input from [0, n] and return it as [0, 1]
    function bound01(n, max) {
        if (isOnePointZero(n)) { n = "100%"; }

        var processPercent = isPercentage(n);
        n = mathMin(max, mathMax(0, parseFloat(n)));

        // Automatically convert percentage into number
        if (processPercent) {
            n = parseInt(n * max, 10) / 100;
        }

        // Handle floating point rounding errors
        if ((Math.abs(n - max) < 0.000001)) {
            return 1;
        }

        // Convert into [0, 1] range if it isn't already
        return (n % max) / parseFloat(max);
    }

    // Force a number between 0 and 1
    function clamp01(val) {
        return mathMin(1, mathMax(0, val));
    }

    // Parse a base-16 hex value into a base-10 integer
    function parseIntFromHex(val) {
        return parseInt(val, 16);
    }

    // Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
    // <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
    function isOnePointZero(n) {
        return typeof n == "string" && n.indexOf('.') != -1 && parseFloat(n) === 1;
    }

    // Check to see if string passed in is a percentage
    function isPercentage(n) {
        return typeof n === "string" && n.indexOf('%') != -1;
    }

    // Force a hex value to have 2 characters
    function pad2(c) {
        return c.length == 1 ? '0' + c : '' + c;
    }

    // Replace a decimal with it's percentage value
    function convertToPercentage(n) {
        if (n <= 1) {
            n = (n * 100) + "%";
        }

        return n;
    }

    // Converts a decimal to a hex value
    function convertDecimalToHex(d) {
        return Math.round(parseFloat(d) * 255).toString(16);
    }
    // Converts a hex value to a decimal
    function convertHexToDecimal(h) {
        return (parseIntFromHex(h) / 255);
    }

    var matchers = (function() {

        // <http://www.w3.org/TR/css3-values/#integers>
        var CSS_INTEGER = "[-\\+]?\\d+%?";

        // <http://www.w3.org/TR/css3-values/#number-value>
        var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";

        // Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
        var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";

        // Actual matching.
        // Parentheses and commas are optional, but not required.
        // Whitespace can take the place of commas or opening paren
        var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
        var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";

        return {
            CSS_UNIT: new RegExp(CSS_UNIT),
            rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
            rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
            hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
            hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
            hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
            hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
            hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
            hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
            hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
            hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
        };
    })();

    // `isValidCSSUnit`
    // Take in a single string / number and check to see if it looks like a CSS unit
    // (see `matchers` above for definition).
    function isValidCSSUnit(color) {
        return !!matchers.CSS_UNIT.exec(color);
    }

    // `stringInputToObject`
    // Permissive string parsing.  Take in a number of formats, and output an object
    // based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
    function stringInputToObject(color) {

        color = color.replace(trimLeft,'').replace(trimRight, '').toLowerCase();
        var named = false;
        if (names[color]) {
            color = names[color];
            named = true;
        }
        else if (color == 'transparent') {
            return { r: 0, g: 0, b: 0, a: 0, format: "name" };
        }

        // Try to match string input using regular expressions.
        // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
        // Just return an object and let the conversion functions handle that.
        // This way the result will be the same whether the tinycolor is initialized with string or object.
        var match;
        if ((match = matchers.rgb.exec(color))) {
            return { r: match[1], g: match[2], b: match[3] };
        }
        if ((match = matchers.rgba.exec(color))) {
            return { r: match[1], g: match[2], b: match[3], a: match[4] };
        }
        if ((match = matchers.hsl.exec(color))) {
            return { h: match[1], s: match[2], l: match[3] };
        }
        if ((match = matchers.hsla.exec(color))) {
            return { h: match[1], s: match[2], l: match[3], a: match[4] };
        }
        if ((match = matchers.hsv.exec(color))) {
            return { h: match[1], s: match[2], v: match[3] };
        }
        if ((match = matchers.hsva.exec(color))) {
            return { h: match[1], s: match[2], v: match[3], a: match[4] };
        }
        if ((match = matchers.hex8.exec(color))) {
            return {
                r: parseIntFromHex(match[1]),
                g: parseIntFromHex(match[2]),
                b: parseIntFromHex(match[3]),
                a: convertHexToDecimal(match[4]),
                format: named ? "name" : "hex8"
            };
        }
        if ((match = matchers.hex6.exec(color))) {
            return {
                r: parseIntFromHex(match[1]),
                g: parseIntFromHex(match[2]),
                b: parseIntFromHex(match[3]),
                format: named ? "name" : "hex"
            };
        }
        if ((match = matchers.hex4.exec(color))) {
            return {
                r: parseIntFromHex(match[1] + '' + match[1]),
                g: parseIntFromHex(match[2] + '' + match[2]),
                b: parseIntFromHex(match[3] + '' + match[3]),
                a: convertHexToDecimal(match[4] + '' + match[4]),
                format: named ? "name" : "hex8"
            };
        }
        if ((match = matchers.hex3.exec(color))) {
            return {
                r: parseIntFromHex(match[1] + '' + match[1]),
                g: parseIntFromHex(match[2] + '' + match[2]),
                b: parseIntFromHex(match[3] + '' + match[3]),
                format: named ? "name" : "hex"
            };
        }

        return false;
    }

    function validateWCAG2Parms(parms) {
        // return valid WCAG2 parms for isReadable.
        // If input parms are invalid, return {"level":"AA", "size":"small"}
        var level, size;
        parms = parms || {"level":"AA", "size":"small"};
        level = (parms.level || "AA").toUpperCase();
        size = (parms.size || "small").toLowerCase();
        if (level !== "AA" && level !== "AAA") {
            level = "AA";
        }
        if (size !== "small" && size !== "large") {
            size = "small";
        }
        return {"level":level, "size":size};
    }

    // Node: Export function
    if (module.exports) {
        module.exports = tinycolor;
    }
    // AMD/requirejs: Define the module
    else {
        window.tinycolor = tinycolor;
    }

    })(Math);
    });

    function _typeof(obj) {
      "@babel/helpers - typeof";

      return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
        return typeof obj;
      } : function (obj) {
        return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      }, _typeof(obj);
    }

    var _order = 1;
    function tXml(b) {
      function c() {
        for (var g = []; b[a];) {
          if (60 == b.charCodeAt(a)) {
            if (47 === b.charCodeAt(a + 1)) {
              a = b.indexOf(">", a);
              break;
            } else if (33 === b.charCodeAt(a + 1)) {
              if (45 == b.charCodeAt(a + 2)) {
                for (; 62 !== b.charCodeAt(a) || 45 != b.charCodeAt(a - 1) || 45 != b.charCodeAt(a - 2) || -1 == a;) {
                  a = b.indexOf(">", a + 1);
                }
                -1 === a && (a = b.length);
              } else for (a += 2; 62 !== b.charCodeAt(a); a++) {
              }
              a++;
              continue;
            } else if (63 === b.charCodeAt(a + 1)) {
              a = b.indexOf(">", a);
              a++;
              continue;
            }
            a++;
            for (var d = a; -1 === "\r\n\t>/= ".indexOf(b[a]); a++) {
            }
            for (var f = b.slice(d, a), k = !1, h = {}; 62 !== b.charCodeAt(a); a++) {
              if (d = b.charCodeAt(a), 64 < d && 91 > d || 96 < d && 123 > d) {
                for (d = a; -1 === "\r\n\t>/= ".indexOf(b[a]); a++) {
                }
                for (var d = b.slice(d, a), e = b.charCodeAt(a); 39 !== e && 34 !== e;) {
                  a++, e = b.charCodeAt(a);
                }
                var e = b[a],
                  l = ++a;
                a = b.indexOf(e, l);
                e = b.slice(l, a);
                k || (h = {}, k = !0);
                h[d] = e;
              }
            }
            if (47 !== b.charCodeAt(a - 1)) {
              a++;
              var m = c();
            }
            g.push({
              children: m,
              tagName: f,
              attrs: h
            });
          } else f = a, a = b.indexOf("<", a) - 1, -2 === a && (a = b.length), f = b.slice(f, a + 1), 0 < f.trim().length && g.push(f);
          a++;
        }
        return g;
      }
      var a = 0;
      _order = 1;
      return simplefy(c());
    }
    function simplefy(b) {
      var c = {};
      if (void 0 === b) return {};
      if (1 === b.length && "string" == typeof b[0]) return b[0];
      b.forEach(function (a) {
        c[a.tagName] || (c[a.tagName] = []);
        if ("object" === _typeof(a)) {
          var b = simplefy(a.children);
          try {
            a.attrs && (b.attrs = a.attrs);
            void 0 === b.attrs ? b.attrs = {
              order: _order
            } : b.attrs.order = _order;
          } catch (e) {}
          _order++;
          c[a.tagName].push(b);
        }
      });
      for (var a in c) {
        1 == c[a].length && (c[a] = c[a][0]);
      }
      return c;
    }

    var jquery1_11_3_min = createCommonjsModule(function (module) {
      /*! jQuery v1.11.3 | (c) 2005, 2015 jQuery Foundation, Inc. | jquery.org/license */
      !function (a, b) {
        module.exports = a.document ? b(a, !0) : function (a) {
          if (!a.document) throw new Error("jQuery requires a window with a document");
          return b(a);
        } ;
      }("undefined" != typeof window ? window : commonjsGlobal, function (a, b) {
        var c = [],
          d = c.slice,
          e = c.concat,
          f = c.push,
          g = c.indexOf,
          h = {},
          i = h.toString,
          j = h.hasOwnProperty,
          k = {},
          l = "1.11.3",
          m = function m(a, b) {
            return new m.fn.init(a, b);
          },
          n = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,
          o = /^-ms-/,
          p = /-([\da-z])/gi,
          q = function q(a, b) {
            return b.toUpperCase();
          };
        m.fn = m.prototype = {
          jquery: l,
          constructor: m,
          selector: "",
          length: 0,
          toArray: function toArray() {
            return d.call(this);
          },
          get: function get(a) {
            return null != a ? 0 > a ? this[a + this.length] : this[a] : d.call(this);
          },
          pushStack: function pushStack(a) {
            var b = m.merge(this.constructor(), a);
            return b.prevObject = this, b.context = this.context, b;
          },
          each: function each(a, b) {
            return m.each(this, a, b);
          },
          map: function map(a) {
            return this.pushStack(m.map(this, function (b, c) {
              return a.call(b, c, b);
            }));
          },
          slice: function slice() {
            return this.pushStack(d.apply(this, arguments));
          },
          first: function first() {
            return this.eq(0);
          },
          last: function last() {
            return this.eq(-1);
          },
          eq: function eq(a) {
            var b = this.length,
              c = +a + (0 > a ? b : 0);
            return this.pushStack(c >= 0 && b > c ? [this[c]] : []);
          },
          end: function end() {
            return this.prevObject || this.constructor(null);
          },
          push: f,
          sort: c.sort,
          splice: c.splice
        }, m.extend = m.fn.extend = function () {
          var a,
            b,
            c,
            d,
            e,
            f,
            g = arguments[0] || {},
            h = 1,
            i = arguments.length,
            j = !1;
          for ("boolean" == typeof g && (j = g, g = arguments[h] || {}, h++), "object" == _typeof(g) || m.isFunction(g) || (g = {}), h === i && (g = this, h--); i > h; h++) {
            if (null != (e = arguments[h])) for (d in e) {
              a = g[d], c = e[d], g !== c && (j && c && (m.isPlainObject(c) || (b = m.isArray(c))) ? (b ? (b = !1, f = a && m.isArray(a) ? a : []) : f = a && m.isPlainObject(a) ? a : {}, g[d] = m.extend(j, f, c)) : void 0 !== c && (g[d] = c));
            }
          }
          return g;
        }, m.extend({
          expando: "jQuery" + (l + Math.random()).replace(/\D/g, ""),
          isReady: !0,
          error: function error(a) {
            throw new Error(a);
          },
          noop: function noop() {},
          isFunction: function isFunction(a) {
            return "function" === m.type(a);
          },
          isArray: Array.isArray || function (a) {
            return "array" === m.type(a);
          },
          isWindow: function isWindow(a) {
            return null != a && a == a.window;
          },
          isNumeric: function isNumeric(a) {
            return !m.isArray(a) && a - parseFloat(a) + 1 >= 0;
          },
          isEmptyObject: function isEmptyObject(a) {
            var b;
            for (b in a) {
              return !1;
            }
            return !0;
          },
          isPlainObject: function isPlainObject(a) {
            var b;
            if (!a || "object" !== m.type(a) || a.nodeType || m.isWindow(a)) return !1;
            try {
              if (a.constructor && !j.call(a, "constructor") && !j.call(a.constructor.prototype, "isPrototypeOf")) return !1;
            } catch (c) {
              return !1;
            }
            if (k.ownLast) for (b in a) {
              return j.call(a, b);
            }
            for (b in a) {
            }
            return void 0 === b || j.call(a, b);
          },
          type: function type(a) {
            return null == a ? a + "" : "object" == _typeof(a) || "function" == typeof a ? h[i.call(a)] || "object" : _typeof(a);
          },
          globalEval: function globalEval(b) {
            b && m.trim(b) && (a.execScript || function (b) {
              a.eval.call(a, b);
            })(b);
          },
          camelCase: function camelCase(a) {
            return a.replace(o, "ms-").replace(p, q);
          },
          nodeName: function nodeName(a, b) {
            return a.nodeName && a.nodeName.toLowerCase() === b.toLowerCase();
          },
          each: function each(a, b, c) {
            var d,
              e = 0,
              f = a.length,
              g = r(a);
            if (c) {
              if (g) {
                for (; f > e; e++) {
                  if (d = b.apply(a[e], c), d === !1) break;
                }
              } else for (e in a) {
                if (d = b.apply(a[e], c), d === !1) break;
              }
            } else if (g) {
              for (; f > e; e++) {
                if (d = b.call(a[e], e, a[e]), d === !1) break;
              }
            } else for (e in a) {
              if (d = b.call(a[e], e, a[e]), d === !1) break;
            }
            return a;
          },
          trim: function trim(a) {
            return null == a ? "" : (a + "").replace(n, "");
          },
          makeArray: function makeArray(a, b) {
            var c = b || [];
            return null != a && (r(Object(a)) ? m.merge(c, "string" == typeof a ? [a] : a) : f.call(c, a)), c;
          },
          inArray: function inArray(a, b, c) {
            var d;
            if (b) {
              if (g) return g.call(b, a, c);
              for (d = b.length, c = c ? 0 > c ? Math.max(0, d + c) : c : 0; d > c; c++) {
                if (c in b && b[c] === a) return c;
              }
            }
            return -1;
          },
          merge: function merge(a, b) {
            var c = +b.length,
              d = 0,
              e = a.length;
            while (c > d) {
              a[e++] = b[d++];
            }
            if (c !== c) while (void 0 !== b[d]) {
              a[e++] = b[d++];
            }
            return a.length = e, a;
          },
          grep: function grep(a, b, c) {
            for (var d, e = [], f = 0, g = a.length, h = !c; g > f; f++) {
              d = !b(a[f], f), d !== h && e.push(a[f]);
            }
            return e;
          },
          map: function map(a, b, c) {
            var d,
              f = 0,
              g = a.length,
              h = r(a),
              i = [];
            if (h) for (; g > f; f++) {
              d = b(a[f], f, c), null != d && i.push(d);
            } else for (f in a) {
              d = b(a[f], f, c), null != d && i.push(d);
            }
            return e.apply([], i);
          },
          guid: 1,
          proxy: function proxy(a, b) {
            var c, e, f;
            return "string" == typeof b && (f = a[b], b = a, a = f), m.isFunction(a) ? (c = d.call(arguments, 2), e = function e() {
              return a.apply(b || this, c.concat(d.call(arguments)));
            }, e.guid = a.guid = a.guid || m.guid++, e) : void 0;
          },
          now: function now() {
            return +new Date();
          },
          support: k
        }), m.each("Boolean Number String Function Array Date RegExp Object Error".split(" "), function (a, b) {
          h["[object " + b + "]"] = b.toLowerCase();
        });
        function r(a) {
          var b = "length" in a && a.length,
            c = m.type(a);
          return "function" === c || m.isWindow(a) ? !1 : 1 === a.nodeType && b ? !0 : "array" === c || 0 === b || "number" == typeof b && b > 0 && b - 1 in a;
        }
        var s = function (a) {
          var b,
            c,
            d,
            e,
            f,
            g,
            h,
            i,
            j,
            k,
            l,
            m,
            n,
            o,
            p,
            q,
            r,
            s,
            t,
            u = "sizzle" + 1 * new Date(),
            v = a.document,
            w = 0,
            x = 0,
            y = ha(),
            z = ha(),
            A = ha(),
            B = function B(a, b) {
              return a === b && (l = !0), 0;
            },
            C = 1 << 31,
            D = {}.hasOwnProperty,
            E = [],
            F = E.pop,
            G = E.push,
            H = E.push,
            I = E.slice,
            J = function J(a, b) {
              for (var c = 0, d = a.length; d > c; c++) {
                if (a[c] === b) return c;
              }
              return -1;
            },
            K = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",
            L = "[\\x20\\t\\r\\n\\f]",
            M = "(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+",
            N = M.replace("w", "w#"),
            O = "\\[" + L + "*(" + M + ")(?:" + L + "*([*^$|!~]?=)" + L + "*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|(" + N + "))|)" + L + "*\\]",
            P = ":(" + M + ")(?:\\((('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|((?:\\\\.|[^\\\\()[\\]]|" + O + ")*)|.*)\\)|)",
            Q = new RegExp(L + "+", "g"),
            R = new RegExp("^" + L + "+|((?:^|[^\\\\])(?:\\\\.)*)" + L + "+$", "g"),
            S = new RegExp("^" + L + "*," + L + "*"),
            T = new RegExp("^" + L + "*([>+~]|" + L + ")" + L + "*"),
            U = new RegExp("=" + L + "*([^\\]'\"]*?)" + L + "*\\]", "g"),
            V = new RegExp(P),
            W = new RegExp("^" + N + "$"),
            X = {
              ID: new RegExp("^#(" + M + ")"),
              CLASS: new RegExp("^\\.(" + M + ")"),
              TAG: new RegExp("^(" + M.replace("w", "w*") + ")"),
              ATTR: new RegExp("^" + O),
              PSEUDO: new RegExp("^" + P),
              CHILD: new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + L + "*(even|odd|(([+-]|)(\\d*)n|)" + L + "*(?:([+-]|)" + L + "*(\\d+)|))" + L + "*\\)|)", "i"),
              bool: new RegExp("^(?:" + K + ")$", "i"),
              needsContext: new RegExp("^" + L + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + L + "*((?:-\\d)?\\d*)" + L + "*\\)|)(?=[^-]|$)", "i")
            },
            Y = /^(?:input|select|textarea|button)$/i,
            Z = /^h\d$/i,
            $ = /^[^{]+\{\s*\[native \w/,
            _ = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,
            aa = /[+~]/,
            ba = /'|\\/g,
            ca = new RegExp("\\\\([\\da-f]{1,6}" + L + "?|(" + L + ")|.)", "ig"),
            da = function da(a, b, c) {
              var d = "0x" + b - 65536;
              return d !== d || c ? b : 0 > d ? String.fromCharCode(d + 65536) : String.fromCharCode(d >> 10 | 55296, 1023 & d | 56320);
            },
            ea = function ea() {
              m();
            };
          try {
            H.apply(E = I.call(v.childNodes), v.childNodes), E[v.childNodes.length].nodeType;
          } catch (fa) {
            H = {
              apply: E.length ? function (a, b) {
                G.apply(a, I.call(b));
              } : function (a, b) {
                var c = a.length,
                  d = 0;
                while (a[c++] = b[d++]) {
                }
                a.length = c - 1;
              }
            };
          }
          function ga(a, b, d, e) {
            var f, h, j, k, l, o, r, s, w, x;
            if ((b ? b.ownerDocument || b : v) !== n && m(b), b = b || n, d = d || [], k = b.nodeType, "string" != typeof a || !a || 1 !== k && 9 !== k && 11 !== k) return d;
            if (!e && p) {
              if (11 !== k && (f = _.exec(a))) if (j = f[1]) {
                if (9 === k) {
                  if (h = b.getElementById(j), !h || !h.parentNode) return d;
                  if (h.id === j) return d.push(h), d;
                } else if (b.ownerDocument && (h = b.ownerDocument.getElementById(j)) && t(b, h) && h.id === j) return d.push(h), d;
              } else {
                if (f[2]) return H.apply(d, b.getElementsByTagName(a)), d;
                if ((j = f[3]) && c.getElementsByClassName) return H.apply(d, b.getElementsByClassName(j)), d;
              }
              if (c.qsa && (!q || !q.test(a))) {
                if (s = r = u, w = b, x = 1 !== k && a, 1 === k && "object" !== b.nodeName.toLowerCase()) {
                  o = g(a), (r = b.getAttribute("id")) ? s = r.replace(ba, "\\$&") : b.setAttribute("id", s), s = "[id='" + s + "'] ", l = o.length;
                  while (l--) {
                    o[l] = s + ra(o[l]);
                  }
                  w = aa.test(a) && pa(b.parentNode) || b, x = o.join(",");
                }
                if (x) try {
                  return H.apply(d, w.querySelectorAll(x)), d;
                } catch (y) {} finally {
                  r || b.removeAttribute("id");
                }
              }
            }
            return i(a.replace(R, "$1"), b, d, e);
          }
          function ha() {
            var a = [];
            function b(c, e) {
              return a.push(c + " ") > d.cacheLength && delete b[a.shift()], b[c + " "] = e;
            }
            return b;
          }
          function ia(a) {
            return a[u] = !0, a;
          }
          function ja(a) {
            var b = n.createElement("div");
            try {
              return !!a(b);
            } catch (c) {
              return !1;
            } finally {
              b.parentNode && b.parentNode.removeChild(b), b = null;
            }
          }
          function ka(a, b) {
            var c = a.split("|"),
              e = a.length;
            while (e--) {
              d.attrHandle[c[e]] = b;
            }
          }
          function la(a, b) {
            var c = b && a,
              d = c && 1 === a.nodeType && 1 === b.nodeType && (~b.sourceIndex || C) - (~a.sourceIndex || C);
            if (d) return d;
            if (c) while (c = c.nextSibling) {
              if (c === b) return -1;
            }
            return a ? 1 : -1;
          }
          function ma(a) {
            return function (b) {
              var c = b.nodeName.toLowerCase();
              return "input" === c && b.type === a;
            };
          }
          function na(a) {
            return function (b) {
              var c = b.nodeName.toLowerCase();
              return ("input" === c || "button" === c) && b.type === a;
            };
          }
          function oa(a) {
            return ia(function (b) {
              return b = +b, ia(function (c, d) {
                var e,
                  f = a([], c.length, b),
                  g = f.length;
                while (g--) {
                  c[e = f[g]] && (c[e] = !(d[e] = c[e]));
                }
              });
            });
          }
          function pa(a) {
            return a && "undefined" != typeof a.getElementsByTagName && a;
          }
          c = ga.support = {}, f = ga.isXML = function (a) {
            var b = a && (a.ownerDocument || a).documentElement;
            return b ? "HTML" !== b.nodeName : !1;
          }, m = ga.setDocument = function (a) {
            var b,
              e,
              g = a ? a.ownerDocument || a : v;
            return g !== n && 9 === g.nodeType && g.documentElement ? (n = g, o = g.documentElement, e = g.defaultView, e && e !== e.top && (e.addEventListener ? e.addEventListener("unload", ea, !1) : e.attachEvent && e.attachEvent("onunload", ea)), p = !f(g), c.attributes = ja(function (a) {
              return a.className = "i", !a.getAttribute("className");
            }), c.getElementsByTagName = ja(function (a) {
              return a.appendChild(g.createComment("")), !a.getElementsByTagName("*").length;
            }), c.getElementsByClassName = $.test(g.getElementsByClassName), c.getById = ja(function (a) {
              return o.appendChild(a).id = u, !g.getElementsByName || !g.getElementsByName(u).length;
            }), c.getById ? (d.find.ID = function (a, b) {
              if ("undefined" != typeof b.getElementById && p) {
                var c = b.getElementById(a);
                return c && c.parentNode ? [c] : [];
              }
            }, d.filter.ID = function (a) {
              var b = a.replace(ca, da);
              return function (a) {
                return a.getAttribute("id") === b;
              };
            }) : (delete d.find.ID, d.filter.ID = function (a) {
              var b = a.replace(ca, da);
              return function (a) {
                var c = "undefined" != typeof a.getAttributeNode && a.getAttributeNode("id");
                return c && c.value === b;
              };
            }), d.find.TAG = c.getElementsByTagName ? function (a, b) {
              return "undefined" != typeof b.getElementsByTagName ? b.getElementsByTagName(a) : c.qsa ? b.querySelectorAll(a) : void 0;
            } : function (a, b) {
              var c,
                d = [],
                e = 0,
                f = b.getElementsByTagName(a);
              if ("*" === a) {
                while (c = f[e++]) {
                  1 === c.nodeType && d.push(c);
                }
                return d;
              }
              return f;
            }, d.find.CLASS = c.getElementsByClassName && function (a, b) {
              return p ? b.getElementsByClassName(a) : void 0;
            }, r = [], q = [], (c.qsa = $.test(g.querySelectorAll)) && (ja(function (a) {
              o.appendChild(a).innerHTML = "<a id='" + u + "'></a><select id='" + u + "-\f]' msallowcapture=''><option selected=''></option></select>", a.querySelectorAll("[msallowcapture^='']").length && q.push("[*^$]=" + L + "*(?:''|\"\")"), a.querySelectorAll("[selected]").length || q.push("\\[" + L + "*(?:value|" + K + ")"), a.querySelectorAll("[id~=" + u + "-]").length || q.push("~="), a.querySelectorAll(":checked").length || q.push(":checked"), a.querySelectorAll("a#" + u + "+*").length || q.push(".#.+[+~]");
            }), ja(function (a) {
              var b = g.createElement("input");
              b.setAttribute("type", "hidden"), a.appendChild(b).setAttribute("name", "D"), a.querySelectorAll("[name=d]").length && q.push("name" + L + "*[*^$|!~]?="), a.querySelectorAll(":enabled").length || q.push(":enabled", ":disabled"), a.querySelectorAll("*,:x"), q.push(",.*:");
            })), (c.matchesSelector = $.test(s = o.matches || o.webkitMatchesSelector || o.mozMatchesSelector || o.oMatchesSelector || o.msMatchesSelector)) && ja(function (a) {
              c.disconnectedMatch = s.call(a, "div"), s.call(a, "[s!='']:x"), r.push("!=", P);
            }), q = q.length && new RegExp(q.join("|")), r = r.length && new RegExp(r.join("|")), b = $.test(o.compareDocumentPosition), t = b || $.test(o.contains) ? function (a, b) {
              var c = 9 === a.nodeType ? a.documentElement : a,
                d = b && b.parentNode;
              return a === d || !(!d || 1 !== d.nodeType || !(c.contains ? c.contains(d) : a.compareDocumentPosition && 16 & a.compareDocumentPosition(d)));
            } : function (a, b) {
              if (b) while (b = b.parentNode) {
                if (b === a) return !0;
              }
              return !1;
            }, B = b ? function (a, b) {
              if (a === b) return l = !0, 0;
              var d = !a.compareDocumentPosition - !b.compareDocumentPosition;
              return d ? d : (d = (a.ownerDocument || a) === (b.ownerDocument || b) ? a.compareDocumentPosition(b) : 1, 1 & d || !c.sortDetached && b.compareDocumentPosition(a) === d ? a === g || a.ownerDocument === v && t(v, a) ? -1 : b === g || b.ownerDocument === v && t(v, b) ? 1 : k ? J(k, a) - J(k, b) : 0 : 4 & d ? -1 : 1);
            } : function (a, b) {
              if (a === b) return l = !0, 0;
              var c,
                d = 0,
                e = a.parentNode,
                f = b.parentNode,
                h = [a],
                i = [b];
              if (!e || !f) return a === g ? -1 : b === g ? 1 : e ? -1 : f ? 1 : k ? J(k, a) - J(k, b) : 0;
              if (e === f) return la(a, b);
              c = a;
              while (c = c.parentNode) {
                h.unshift(c);
              }
              c = b;
              while (c = c.parentNode) {
                i.unshift(c);
              }
              while (h[d] === i[d]) {
                d++;
              }
              return d ? la(h[d], i[d]) : h[d] === v ? -1 : i[d] === v ? 1 : 0;
            }, g) : n;
          }, ga.matches = function (a, b) {
            return ga(a, null, null, b);
          }, ga.matchesSelector = function (a, b) {
            if ((a.ownerDocument || a) !== n && m(a), b = b.replace(U, "='$1']"), !(!c.matchesSelector || !p || r && r.test(b) || q && q.test(b))) try {
              var d = s.call(a, b);
              if (d || c.disconnectedMatch || a.document && 11 !== a.document.nodeType) return d;
            } catch (e) {}
            return ga(b, n, null, [a]).length > 0;
          }, ga.contains = function (a, b) {
            return (a.ownerDocument || a) !== n && m(a), t(a, b);
          }, ga.attr = function (a, b) {
            (a.ownerDocument || a) !== n && m(a);
            var e = d.attrHandle[b.toLowerCase()],
              f = e && D.call(d.attrHandle, b.toLowerCase()) ? e(a, b, !p) : void 0;
            return void 0 !== f ? f : c.attributes || !p ? a.getAttribute(b) : (f = a.getAttributeNode(b)) && f.specified ? f.value : null;
          }, ga.error = function (a) {
            throw new Error("Syntax error, unrecognized expression: " + a);
          }, ga.uniqueSort = function (a) {
            var b,
              d = [],
              e = 0,
              f = 0;
            if (l = !c.detectDuplicates, k = !c.sortStable && a.slice(0), a.sort(B), l) {
              while (b = a[f++]) {
                b === a[f] && (e = d.push(f));
              }
              while (e--) {
                a.splice(d[e], 1);
              }
            }
            return k = null, a;
          }, e = ga.getText = function (a) {
            var b,
              c = "",
              d = 0,
              f = a.nodeType;
            if (f) {
              if (1 === f || 9 === f || 11 === f) {
                if ("string" == typeof a.textContent) return a.textContent;
                for (a = a.firstChild; a; a = a.nextSibling) {
                  c += e(a);
                }
              } else if (3 === f || 4 === f) return a.nodeValue;
            } else while (b = a[d++]) {
              c += e(b);
            }
            return c;
          }, d = ga.selectors = {
            cacheLength: 50,
            createPseudo: ia,
            match: X,
            attrHandle: {},
            find: {},
            relative: {
              ">": {
                dir: "parentNode",
                first: !0
              },
              " ": {
                dir: "parentNode"
              },
              "+": {
                dir: "previousSibling",
                first: !0
              },
              "~": {
                dir: "previousSibling"
              }
            },
            preFilter: {
              ATTR: function ATTR(a) {
                return a[1] = a[1].replace(ca, da), a[3] = (a[3] || a[4] || a[5] || "").replace(ca, da), "~=" === a[2] && (a[3] = " " + a[3] + " "), a.slice(0, 4);
              },
              CHILD: function CHILD(a) {
                return a[1] = a[1].toLowerCase(), "nth" === a[1].slice(0, 3) ? (a[3] || ga.error(a[0]), a[4] = +(a[4] ? a[5] + (a[6] || 1) : 2 * ("even" === a[3] || "odd" === a[3])), a[5] = +(a[7] + a[8] || "odd" === a[3])) : a[3] && ga.error(a[0]), a;
              },
              PSEUDO: function PSEUDO(a) {
                var b,
                  c = !a[6] && a[2];
                return X.CHILD.test(a[0]) ? null : (a[3] ? a[2] = a[4] || a[5] || "" : c && V.test(c) && (b = g(c, !0)) && (b = c.indexOf(")", c.length - b) - c.length) && (a[0] = a[0].slice(0, b), a[2] = c.slice(0, b)), a.slice(0, 3));
              }
            },
            filter: {
              TAG: function TAG(a) {
                var b = a.replace(ca, da).toLowerCase();
                return "*" === a ? function () {
                  return !0;
                } : function (a) {
                  return a.nodeName && a.nodeName.toLowerCase() === b;
                };
              },
              CLASS: function CLASS(a) {
                var b = y[a + " "];
                return b || (b = new RegExp("(^|" + L + ")" + a + "(" + L + "|$)")) && y(a, function (a) {
                  return b.test("string" == typeof a.className && a.className || "undefined" != typeof a.getAttribute && a.getAttribute("class") || "");
                });
              },
              ATTR: function ATTR(a, b, c) {
                return function (d) {
                  var e = ga.attr(d, a);
                  return null == e ? "!=" === b : b ? (e += "", "=" === b ? e === c : "!=" === b ? e !== c : "^=" === b ? c && 0 === e.indexOf(c) : "*=" === b ? c && e.indexOf(c) > -1 : "$=" === b ? c && e.slice(-c.length) === c : "~=" === b ? (" " + e.replace(Q, " ") + " ").indexOf(c) > -1 : "|=" === b ? e === c || e.slice(0, c.length + 1) === c + "-" : !1) : !0;
                };
              },
              CHILD: function CHILD(a, b, c, d, e) {
                var f = "nth" !== a.slice(0, 3),
                  g = "last" !== a.slice(-4),
                  h = "of-type" === b;
                return 1 === d && 0 === e ? function (a) {
                  return !!a.parentNode;
                } : function (b, c, i) {
                  var j,
                    k,
                    l,
                    m,
                    n,
                    o,
                    p = f !== g ? "nextSibling" : "previousSibling",
                    q = b.parentNode,
                    r = h && b.nodeName.toLowerCase(),
                    s = !i && !h;
                  if (q) {
                    if (f) {
                      while (p) {
                        l = b;
                        while (l = l[p]) {
                          if (h ? l.nodeName.toLowerCase() === r : 1 === l.nodeType) return !1;
                        }
                        o = p = "only" === a && !o && "nextSibling";
                      }
                      return !0;
                    }
                    if (o = [g ? q.firstChild : q.lastChild], g && s) {
                      k = q[u] || (q[u] = {}), j = k[a] || [], n = j[0] === w && j[1], m = j[0] === w && j[2], l = n && q.childNodes[n];
                      while (l = ++n && l && l[p] || (m = n = 0) || o.pop()) {
                        if (1 === l.nodeType && ++m && l === b) {
                          k[a] = [w, n, m];
                          break;
                        }
                      }
                    } else if (s && (j = (b[u] || (b[u] = {}))[a]) && j[0] === w) m = j[1];else while (l = ++n && l && l[p] || (m = n = 0) || o.pop()) {
                      if ((h ? l.nodeName.toLowerCase() === r : 1 === l.nodeType) && ++m && (s && ((l[u] || (l[u] = {}))[a] = [w, m]), l === b)) break;
                    }
                    return m -= e, m === d || m % d === 0 && m / d >= 0;
                  }
                };
              },
              PSEUDO: function PSEUDO(a, b) {
                var c,
                  e = d.pseudos[a] || d.setFilters[a.toLowerCase()] || ga.error("unsupported pseudo: " + a);
                return e[u] ? e(b) : e.length > 1 ? (c = [a, a, "", b], d.setFilters.hasOwnProperty(a.toLowerCase()) ? ia(function (a, c) {
                  var d,
                    f = e(a, b),
                    g = f.length;
                  while (g--) {
                    d = J(a, f[g]), a[d] = !(c[d] = f[g]);
                  }
                }) : function (a) {
                  return e(a, 0, c);
                }) : e;
              }
            },
            pseudos: {
              not: ia(function (a) {
                var b = [],
                  c = [],
                  d = h(a.replace(R, "$1"));
                return d[u] ? ia(function (a, b, c, e) {
                  var f,
                    g = d(a, null, e, []),
                    h = a.length;
                  while (h--) {
                    (f = g[h]) && (a[h] = !(b[h] = f));
                  }
                }) : function (a, e, f) {
                  return b[0] = a, d(b, null, f, c), b[0] = null, !c.pop();
                };
              }),
              has: ia(function (a) {
                return function (b) {
                  return ga(a, b).length > 0;
                };
              }),
              contains: ia(function (a) {
                return a = a.replace(ca, da), function (b) {
                  return (b.textContent || b.innerText || e(b)).indexOf(a) > -1;
                };
              }),
              lang: ia(function (a) {
                return W.test(a || "") || ga.error("unsupported lang: " + a), a = a.replace(ca, da).toLowerCase(), function (b) {
                  var c;
                  do {
                    if (c = p ? b.lang : b.getAttribute("xml:lang") || b.getAttribute("lang")) return c = c.toLowerCase(), c === a || 0 === c.indexOf(a + "-");
                  } while ((b = b.parentNode) && 1 === b.nodeType);
                  return !1;
                };
              }),
              target: function target(b) {
                var c = a.location && a.location.hash;
                return c && c.slice(1) === b.id;
              },
              root: function root(a) {
                return a === o;
              },
              focus: function focus(a) {
                return a === n.activeElement && (!n.hasFocus || n.hasFocus()) && !!(a.type || a.href || ~a.tabIndex);
              },
              enabled: function enabled(a) {
                return a.disabled === !1;
              },
              disabled: function disabled(a) {
                return a.disabled === !0;
              },
              checked: function checked(a) {
                var b = a.nodeName.toLowerCase();
                return "input" === b && !!a.checked || "option" === b && !!a.selected;
              },
              selected: function selected(a) {
                return a.parentNode && a.parentNode.selectedIndex, a.selected === !0;
              },
              empty: function empty(a) {
                for (a = a.firstChild; a; a = a.nextSibling) {
                  if (a.nodeType < 6) return !1;
                }
                return !0;
              },
              parent: function parent(a) {
                return !d.pseudos.empty(a);
              },
              header: function header(a) {
                return Z.test(a.nodeName);
              },
              input: function input(a) {
                return Y.test(a.nodeName);
              },
              button: function button(a) {
                var b = a.nodeName.toLowerCase();
                return "input" === b && "button" === a.type || "button" === b;
              },
              text: function text(a) {
                var b;
                return "input" === a.nodeName.toLowerCase() && "text" === a.type && (null == (b = a.getAttribute("type")) || "text" === b.toLowerCase());
              },
              first: oa(function () {
                return [0];
              }),
              last: oa(function (a, b) {
                return [b - 1];
              }),
              eq: oa(function (a, b, c) {
                return [0 > c ? c + b : c];
              }),
              even: oa(function (a, b) {
                for (var c = 0; b > c; c += 2) {
                  a.push(c);
                }
                return a;
              }),
              odd: oa(function (a, b) {
                for (var c = 1; b > c; c += 2) {
                  a.push(c);
                }
                return a;
              }),
              lt: oa(function (a, b, c) {
                for (var d = 0 > c ? c + b : c; --d >= 0;) {
                  a.push(d);
                }
                return a;
              }),
              gt: oa(function (a, b, c) {
                for (var d = 0 > c ? c + b : c; ++d < b;) {
                  a.push(d);
                }
                return a;
              })
            }
          }, d.pseudos.nth = d.pseudos.eq;
          for (b in {
            radio: !0,
            checkbox: !0,
            file: !0,
            password: !0,
            image: !0
          }) {
            d.pseudos[b] = ma(b);
          }
          for (b in {
            submit: !0,
            reset: !0
          }) {
            d.pseudos[b] = na(b);
          }
          function qa() {}
          qa.prototype = d.filters = d.pseudos, d.setFilters = new qa(), g = ga.tokenize = function (a, b) {
            var c,
              e,
              f,
              g,
              h,
              i,
              j,
              k = z[a + " "];
            if (k) return b ? 0 : k.slice(0);
            h = a, i = [], j = d.preFilter;
            while (h) {
              (!c || (e = S.exec(h))) && (e && (h = h.slice(e[0].length) || h), i.push(f = [])), c = !1, (e = T.exec(h)) && (c = e.shift(), f.push({
                value: c,
                type: e[0].replace(R, " ")
              }), h = h.slice(c.length));
              for (g in d.filter) {
                !(e = X[g].exec(h)) || j[g] && !(e = j[g](e)) || (c = e.shift(), f.push({
                  value: c,
                  type: g,
                  matches: e
                }), h = h.slice(c.length));
              }
              if (!c) break;
            }
            return b ? h.length : h ? ga.error(a) : z(a, i).slice(0);
          };
          function ra(a) {
            for (var b = 0, c = a.length, d = ""; c > b; b++) {
              d += a[b].value;
            }
            return d;
          }
          function sa(a, b, c) {
            var d = b.dir,
              e = c && "parentNode" === d,
              f = x++;
            return b.first ? function (b, c, f) {
              while (b = b[d]) {
                if (1 === b.nodeType || e) return a(b, c, f);
              }
            } : function (b, c, g) {
              var h,
                i,
                j = [w, f];
              if (g) {
                while (b = b[d]) {
                  if ((1 === b.nodeType || e) && a(b, c, g)) return !0;
                }
              } else while (b = b[d]) {
                if (1 === b.nodeType || e) {
                  if (i = b[u] || (b[u] = {}), (h = i[d]) && h[0] === w && h[1] === f) return j[2] = h[2];
                  if (i[d] = j, j[2] = a(b, c, g)) return !0;
                }
              }
            };
          }
          function ta(a) {
            return a.length > 1 ? function (b, c, d) {
              var e = a.length;
              while (e--) {
                if (!a[e](b, c, d)) return !1;
              }
              return !0;
            } : a[0];
          }
          function ua(a, b, c) {
            for (var d = 0, e = b.length; e > d; d++) {
              ga(a, b[d], c);
            }
            return c;
          }
          function va(a, b, c, d, e) {
            for (var f, g = [], h = 0, i = a.length, j = null != b; i > h; h++) {
              (f = a[h]) && (!c || c(f, d, e)) && (g.push(f), j && b.push(h));
            }
            return g;
          }
          function wa(a, b, c, d, e, f) {
            return d && !d[u] && (d = wa(d)), e && !e[u] && (e = wa(e, f)), ia(function (f, g, h, i) {
              var j,
                k,
                l,
                m = [],
                n = [],
                o = g.length,
                p = f || ua(b || "*", h.nodeType ? [h] : h, []),
                q = !a || !f && b ? p : va(p, m, a, h, i),
                r = c ? e || (f ? a : o || d) ? [] : g : q;
              if (c && c(q, r, h, i), d) {
                j = va(r, n), d(j, [], h, i), k = j.length;
                while (k--) {
                  (l = j[k]) && (r[n[k]] = !(q[n[k]] = l));
                }
              }
              if (f) {
                if (e || a) {
                  if (e) {
                    j = [], k = r.length;
                    while (k--) {
                      (l = r[k]) && j.push(q[k] = l);
                    }
                    e(null, r = [], j, i);
                  }
                  k = r.length;
                  while (k--) {
                    (l = r[k]) && (j = e ? J(f, l) : m[k]) > -1 && (f[j] = !(g[j] = l));
                  }
                }
              } else r = va(r === g ? r.splice(o, r.length) : r), e ? e(null, g, r, i) : H.apply(g, r);
            });
          }
          function xa(a) {
            for (var b, c, e, f = a.length, g = d.relative[a[0].type], h = g || d.relative[" "], i = g ? 1 : 0, k = sa(function (a) {
                return a === b;
              }, h, !0), l = sa(function (a) {
                return J(b, a) > -1;
              }, h, !0), m = [function (a, c, d) {
                var e = !g && (d || c !== j) || ((b = c).nodeType ? k(a, c, d) : l(a, c, d));
                return b = null, e;
              }]; f > i; i++) {
              if (c = d.relative[a[i].type]) m = [sa(ta(m), c)];else {
                if (c = d.filter[a[i].type].apply(null, a[i].matches), c[u]) {
                  for (e = ++i; f > e; e++) {
                    if (d.relative[a[e].type]) break;
                  }
                  return wa(i > 1 && ta(m), i > 1 && ra(a.slice(0, i - 1).concat({
                    value: " " === a[i - 2].type ? "*" : ""
                  })).replace(R, "$1"), c, e > i && xa(a.slice(i, e)), f > e && xa(a = a.slice(e)), f > e && ra(a));
                }
                m.push(c);
              }
            }
            return ta(m);
          }
          function ya(a, b) {
            var c = b.length > 0,
              e = a.length > 0,
              f = function f(_f, g, h, i, k) {
                var l,
                  m,
                  o,
                  p = 0,
                  q = "0",
                  r = _f && [],
                  s = [],
                  t = j,
                  u = _f || e && d.find.TAG("*", k),
                  v = w += null == t ? 1 : Math.random() || .1,
                  x = u.length;
                for (k && (j = g !== n && g); q !== x && null != (l = u[q]); q++) {
                  if (e && l) {
                    m = 0;
                    while (o = a[m++]) {
                      if (o(l, g, h)) {
                        i.push(l);
                        break;
                      }
                    }
                    k && (w = v);
                  }
                  c && ((l = !o && l) && p--, _f && r.push(l));
                }
                if (p += q, c && q !== p) {
                  m = 0;
                  while (o = b[m++]) {
                    o(r, s, g, h);
                  }
                  if (_f) {
                    if (p > 0) while (q--) {
                      r[q] || s[q] || (s[q] = F.call(i));
                    }
                    s = va(s);
                  }
                  H.apply(i, s), k && !_f && s.length > 0 && p + b.length > 1 && ga.uniqueSort(i);
                }
                return k && (w = v, j = t), r;
              };
            return c ? ia(f) : f;
          }
          return h = ga.compile = function (a, b) {
            var c,
              d = [],
              e = [],
              f = A[a + " "];
            if (!f) {
              b || (b = g(a)), c = b.length;
              while (c--) {
                f = xa(b[c]), f[u] ? d.push(f) : e.push(f);
              }
              f = A(a, ya(e, d)), f.selector = a;
            }
            return f;
          }, i = ga.select = function (a, b, e, f) {
            var i,
              j,
              k,
              l,
              m,
              n = "function" == typeof a && a,
              o = !f && g(a = n.selector || a);
            if (e = e || [], 1 === o.length) {
              if (j = o[0] = o[0].slice(0), j.length > 2 && "ID" === (k = j[0]).type && c.getById && 9 === b.nodeType && p && d.relative[j[1].type]) {
                if (b = (d.find.ID(k.matches[0].replace(ca, da), b) || [])[0], !b) return e;
                n && (b = b.parentNode), a = a.slice(j.shift().value.length);
              }
              i = X.needsContext.test(a) ? 0 : j.length;
              while (i--) {
                if (k = j[i], d.relative[l = k.type]) break;
                if ((m = d.find[l]) && (f = m(k.matches[0].replace(ca, da), aa.test(j[0].type) && pa(b.parentNode) || b))) {
                  if (j.splice(i, 1), a = f.length && ra(j), !a) return H.apply(e, f), e;
                  break;
                }
              }
            }
            return (n || h(a, o))(f, b, !p, e, aa.test(a) && pa(b.parentNode) || b), e;
          }, c.sortStable = u.split("").sort(B).join("") === u, c.detectDuplicates = !!l, m(), c.sortDetached = ja(function (a) {
            return 1 & a.compareDocumentPosition(n.createElement("div"));
          }), ja(function (a) {
            return a.innerHTML = "<a href='#'></a>", "#" === a.firstChild.getAttribute("href");
          }) || ka("type|href|height|width", function (a, b, c) {
            return c ? void 0 : a.getAttribute(b, "type" === b.toLowerCase() ? 1 : 2);
          }), c.attributes && ja(function (a) {
            return a.innerHTML = "<input/>", a.firstChild.setAttribute("value", ""), "" === a.firstChild.getAttribute("value");
          }) || ka("value", function (a, b, c) {
            return c || "input" !== a.nodeName.toLowerCase() ? void 0 : a.defaultValue;
          }), ja(function (a) {
            return null == a.getAttribute("disabled");
          }) || ka(K, function (a, b, c) {
            var d;
            return c ? void 0 : a[b] === !0 ? b.toLowerCase() : (d = a.getAttributeNode(b)) && d.specified ? d.value : null;
          }), ga;
        }(a);
        m.find = s, m.expr = s.selectors, m.expr[":"] = m.expr.pseudos, m.unique = s.uniqueSort, m.text = s.getText, m.isXMLDoc = s.isXML, m.contains = s.contains;
        var t = m.expr.match.needsContext,
          u = /^<(\w+)\s*\/?>(?:<\/\1>|)$/,
          v = /^.[^:#\[\.,]*$/;
        function w(a, b, c) {
          if (m.isFunction(b)) return m.grep(a, function (a, d) {
            return !!b.call(a, d, a) !== c;
          });
          if (b.nodeType) return m.grep(a, function (a) {
            return a === b !== c;
          });
          if ("string" == typeof b) {
            if (v.test(b)) return m.filter(b, a, c);
            b = m.filter(b, a);
          }
          return m.grep(a, function (a) {
            return m.inArray(a, b) >= 0 !== c;
          });
        }
        m.filter = function (a, b, c) {
          var d = b[0];
          return c && (a = ":not(" + a + ")"), 1 === b.length && 1 === d.nodeType ? m.find.matchesSelector(d, a) ? [d] : [] : m.find.matches(a, m.grep(b, function (a) {
            return 1 === a.nodeType;
          }));
        }, m.fn.extend({
          find: function find(a) {
            var b,
              c = [],
              d = this,
              e = d.length;
            if ("string" != typeof a) return this.pushStack(m(a).filter(function () {
              for (b = 0; e > b; b++) {
                if (m.contains(d[b], this)) return !0;
              }
            }));
            for (b = 0; e > b; b++) {
              m.find(a, d[b], c);
            }
            return c = this.pushStack(e > 1 ? m.unique(c) : c), c.selector = this.selector ? this.selector + " " + a : a, c;
          },
          filter: function filter(a) {
            return this.pushStack(w(this, a || [], !1));
          },
          not: function not(a) {
            return this.pushStack(w(this, a || [], !0));
          },
          is: function is(a) {
            return !!w(this, "string" == typeof a && t.test(a) ? m(a) : a || [], !1).length;
          }
        });
        var x,
          y = a.document,
          z = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/,
          A = m.fn.init = function (a, b) {
            var c, d;
            if (!a) return this;
            if ("string" == typeof a) {
              if (c = "<" === a.charAt(0) && ">" === a.charAt(a.length - 1) && a.length >= 3 ? [null, a, null] : z.exec(a), !c || !c[1] && b) return !b || b.jquery ? (b || x).find(a) : this.constructor(b).find(a);
              if (c[1]) {
                if (b = b instanceof m ? b[0] : b, m.merge(this, m.parseHTML(c[1], b && b.nodeType ? b.ownerDocument || b : y, !0)), u.test(c[1]) && m.isPlainObject(b)) for (c in b) {
                  m.isFunction(this[c]) ? this[c](b[c]) : this.attr(c, b[c]);
                }
                return this;
              }
              if (d = y.getElementById(c[2]), d && d.parentNode) {
                if (d.id !== c[2]) return x.find(a);
                this.length = 1, this[0] = d;
              }
              return this.context = y, this.selector = a, this;
            }
            return a.nodeType ? (this.context = this[0] = a, this.length = 1, this) : m.isFunction(a) ? "undefined" != typeof x.ready ? x.ready(a) : a(m) : (void 0 !== a.selector && (this.selector = a.selector, this.context = a.context), m.makeArray(a, this));
          };
        A.prototype = m.fn, x = m(y);
        var B = /^(?:parents|prev(?:Until|All))/,
          C = {
            children: !0,
            contents: !0,
            next: !0,
            prev: !0
          };
        m.extend({
          dir: function dir(a, b, c) {
            var d = [],
              e = a[b];
            while (e && 9 !== e.nodeType && (void 0 === c || 1 !== e.nodeType || !m(e).is(c))) {
              1 === e.nodeType && d.push(e), e = e[b];
            }
            return d;
          },
          sibling: function sibling(a, b) {
            for (var c = []; a; a = a.nextSibling) {
              1 === a.nodeType && a !== b && c.push(a);
            }
            return c;
          }
        }), m.fn.extend({
          has: function has(a) {
            var b,
              c = m(a, this),
              d = c.length;
            return this.filter(function () {
              for (b = 0; d > b; b++) {
                if (m.contains(this, c[b])) return !0;
              }
            });
          },
          closest: function closest(a, b) {
            for (var c, d = 0, e = this.length, f = [], g = t.test(a) || "string" != typeof a ? m(a, b || this.context) : 0; e > d; d++) {
              for (c = this[d]; c && c !== b; c = c.parentNode) {
                if (c.nodeType < 11 && (g ? g.index(c) > -1 : 1 === c.nodeType && m.find.matchesSelector(c, a))) {
                  f.push(c);
                  break;
                }
              }
            }
            return this.pushStack(f.length > 1 ? m.unique(f) : f);
          },
          index: function index(a) {
            return a ? "string" == typeof a ? m.inArray(this[0], m(a)) : m.inArray(a.jquery ? a[0] : a, this) : this[0] && this[0].parentNode ? this.first().prevAll().length : -1;
          },
          add: function add(a, b) {
            return this.pushStack(m.unique(m.merge(this.get(), m(a, b))));
          },
          addBack: function addBack(a) {
            return this.add(null == a ? this.prevObject : this.prevObject.filter(a));
          }
        });
        function D(a, b) {
          do {
            a = a[b];
          } while (a && 1 !== a.nodeType);
          return a;
        }
        m.each({
          parent: function parent(a) {
            var b = a.parentNode;
            return b && 11 !== b.nodeType ? b : null;
          },
          parents: function parents(a) {
            return m.dir(a, "parentNode");
          },
          parentsUntil: function parentsUntil(a, b, c) {
            return m.dir(a, "parentNode", c);
          },
          next: function next(a) {
            return D(a, "nextSibling");
          },
          prev: function prev(a) {
            return D(a, "previousSibling");
          },
          nextAll: function nextAll(a) {
            return m.dir(a, "nextSibling");
          },
          prevAll: function prevAll(a) {
            return m.dir(a, "previousSibling");
          },
          nextUntil: function nextUntil(a, b, c) {
            return m.dir(a, "nextSibling", c);
          },
          prevUntil: function prevUntil(a, b, c) {
            return m.dir(a, "previousSibling", c);
          },
          siblings: function siblings(a) {
            return m.sibling((a.parentNode || {}).firstChild, a);
          },
          children: function children(a) {
            return m.sibling(a.firstChild);
          },
          contents: function contents(a) {
            return m.nodeName(a, "iframe") ? a.contentDocument || a.contentWindow.document : m.merge([], a.childNodes);
          }
        }, function (a, b) {
          m.fn[a] = function (c, d) {
            var e = m.map(this, b, c);
            return "Until" !== a.slice(-5) && (d = c), d && "string" == typeof d && (e = m.filter(d, e)), this.length > 1 && (C[a] || (e = m.unique(e)), B.test(a) && (e = e.reverse())), this.pushStack(e);
          };
        });
        var E = /\S+/g,
          F = {};
        function G(a) {
          var b = F[a] = {};
          return m.each(a.match(E) || [], function (a, c) {
            b[c] = !0;
          }), b;
        }
        m.Callbacks = function (a) {
          a = "string" == typeof a ? F[a] || G(a) : m.extend({}, a);
          var b,
            c,
            d,
            e,
            f,
            g,
            h = [],
            i = !a.once && [],
            j = function j(l) {
              for (c = a.memory && l, d = !0, f = g || 0, g = 0, e = h.length, b = !0; h && e > f; f++) {
                if (h[f].apply(l[0], l[1]) === !1 && a.stopOnFalse) {
                  c = !1;
                  break;
                }
              }
              b = !1, h && (i ? i.length && j(i.shift()) : c ? h = [] : k.disable());
            },
            k = {
              add: function add() {
                if (h) {
                  var d = h.length;
                  !function f(b) {
                    m.each(b, function (b, c) {
                      var d = m.type(c);
                      "function" === d ? a.unique && k.has(c) || h.push(c) : c && c.length && "string" !== d && f(c);
                    });
                  }(arguments), b ? e = h.length : c && (g = d, j(c));
                }
                return this;
              },
              remove: function remove() {
                return h && m.each(arguments, function (a, c) {
                  var d;
                  while ((d = m.inArray(c, h, d)) > -1) {
                    h.splice(d, 1), b && (e >= d && e--, f >= d && f--);
                  }
                }), this;
              },
              has: function has(a) {
                return a ? m.inArray(a, h) > -1 : !(!h || !h.length);
              },
              empty: function empty() {
                return h = [], e = 0, this;
              },
              disable: function disable() {
                return h = i = c = void 0, this;
              },
              disabled: function disabled() {
                return !h;
              },
              lock: function lock() {
                return i = void 0, c || k.disable(), this;
              },
              locked: function locked() {
                return !i;
              },
              fireWith: function fireWith(a, c) {
                return !h || d && !i || (c = c || [], c = [a, c.slice ? c.slice() : c], b ? i.push(c) : j(c)), this;
              },
              fire: function fire() {
                return k.fireWith(this, arguments), this;
              },
              fired: function fired() {
                return !!d;
              }
            };
          return k;
        }, m.extend({
          Deferred: function Deferred(a) {
            var b = [["resolve", "done", m.Callbacks("once memory"), "resolved"], ["reject", "fail", m.Callbacks("once memory"), "rejected"], ["notify", "progress", m.Callbacks("memory")]],
              c = "pending",
              d = {
                state: function state() {
                  return c;
                },
                always: function always() {
                  return e.done(arguments).fail(arguments), this;
                },
                then: function then() {
                  var a = arguments;
                  return m.Deferred(function (c) {
                    m.each(b, function (b, f) {
                      var g = m.isFunction(a[b]) && a[b];
                      e[f[1]](function () {
                        var a = g && g.apply(this, arguments);
                        a && m.isFunction(a.promise) ? a.promise().done(c.resolve).fail(c.reject).progress(c.notify) : c[f[0] + "With"](this === d ? c.promise() : this, g ? [a] : arguments);
                      });
                    }), a = null;
                  }).promise();
                },
                promise: function promise(a) {
                  return null != a ? m.extend(a, d) : d;
                }
              },
              e = {};
            return d.pipe = d.then, m.each(b, function (a, f) {
              var g = f[2],
                h = f[3];
              d[f[1]] = g.add, h && g.add(function () {
                c = h;
              }, b[1 ^ a][2].disable, b[2][2].lock), e[f[0]] = function () {
                return e[f[0] + "With"](this === e ? d : this, arguments), this;
              }, e[f[0] + "With"] = g.fireWith;
            }), d.promise(e), a && a.call(e, e), e;
          },
          when: function when(a) {
            var b = 0,
              c = d.call(arguments),
              e = c.length,
              f = 1 !== e || a && m.isFunction(a.promise) ? e : 0,
              g = 1 === f ? a : m.Deferred(),
              h = function h(a, b, c) {
                return function (e) {
                  b[a] = this, c[a] = arguments.length > 1 ? d.call(arguments) : e, c === i ? g.notifyWith(b, c) : --f || g.resolveWith(b, c);
                };
              },
              i,
              j,
              k;
            if (e > 1) for (i = new Array(e), j = new Array(e), k = new Array(e); e > b; b++) {
              c[b] && m.isFunction(c[b].promise) ? c[b].promise().done(h(b, k, c)).fail(g.reject).progress(h(b, j, i)) : --f;
            }
            return f || g.resolveWith(k, c), g.promise();
          }
        });
        var H;
        m.fn.ready = function (a) {
          return m.ready.promise().done(a), this;
        }, m.extend({
          isReady: !1,
          readyWait: 1,
          holdReady: function holdReady(a) {
            a ? m.readyWait++ : m.ready(!0);
          },
          ready: function ready(a) {
            if (a === !0 ? ! --m.readyWait : !m.isReady) {
              if (!y.body) return setTimeout(m.ready);
              m.isReady = !0, a !== !0 && --m.readyWait > 0 || (H.resolveWith(y, [m]), m.fn.triggerHandler && (m(y).triggerHandler("ready"), m(y).off("ready")));
            }
          }
        });
        function I() {
          y.addEventListener ? (y.removeEventListener("DOMContentLoaded", J, !1), a.removeEventListener("load", J, !1)) : (y.detachEvent("onreadystatechange", J), a.detachEvent("onload", J));
        }
        function J() {
          (y.addEventListener || "load" === event.type || "complete" === y.readyState) && (I(), m.ready());
        }
        m.ready.promise = function (b) {
          if (!H) if (H = m.Deferred(), "complete" === y.readyState) setTimeout(m.ready);else if (y.addEventListener) y.addEventListener("DOMContentLoaded", J, !1), a.addEventListener("load", J, !1);else {
            y.attachEvent("onreadystatechange", J), a.attachEvent("onload", J);
            var c = !1;
            try {
              c = null == a.frameElement && y.documentElement;
            } catch (d) {}
            c && c.doScroll && !function e() {
              if (!m.isReady) {
                try {
                  c.doScroll("left");
                } catch (a) {
                  return setTimeout(e, 50);
                }
                I(), m.ready();
              }
            }();
          }
          return H.promise(b);
        };
        var K = "undefined",
          L;
        for (L in m(k)) {
          break;
        }
        k.ownLast = "0" !== L, k.inlineBlockNeedsLayout = !1, m(function () {
          var a, b, c, d;
          c = y.getElementsByTagName("body")[0], c && c.style && (b = y.createElement("div"), d = y.createElement("div"), d.style.cssText = "position:absolute;border:0;width:0;height:0;top:0;left:-9999px", c.appendChild(d).appendChild(b), _typeof(b.style.zoom) !== K && (b.style.cssText = "display:inline;margin:0;border:0;padding:1px;width:1px;zoom:1", k.inlineBlockNeedsLayout = a = 3 === b.offsetWidth, a && (c.style.zoom = 1)), c.removeChild(d));
        }), function () {
          var a = y.createElement("div");
          if (null == k.deleteExpando) {
            k.deleteExpando = !0;
            try {
              delete a.test;
            } catch (b) {
              k.deleteExpando = !1;
            }
          }
          a = null;
        }(), m.acceptData = function (a) {
          var b = m.noData[(a.nodeName + " ").toLowerCase()],
            c = +a.nodeType || 1;
          return 1 !== c && 9 !== c ? !1 : !b || b !== !0 && a.getAttribute("classid") === b;
        };
        var M = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,
          N = /([A-Z])/g;
        function O(a, b, c) {
          if (void 0 === c && 1 === a.nodeType) {
            var d = "data-" + b.replace(N, "-$1").toLowerCase();
            if (c = a.getAttribute(d), "string" == typeof c) {
              try {
                c = "true" === c ? !0 : "false" === c ? !1 : "null" === c ? null : +c + "" === c ? +c : M.test(c) ? m.parseJSON(c) : c;
              } catch (e) {}
              m.data(a, b, c);
            } else c = void 0;
          }
          return c;
        }
        function P(a) {
          var b;
          for (b in a) {
            if (("data" !== b || !m.isEmptyObject(a[b])) && "toJSON" !== b) return !1;
          }
          return !0;
        }
        function Q(a, b, d, e) {
          if (m.acceptData(a)) {
            var f,
              g,
              h = m.expando,
              i = a.nodeType,
              j = i ? m.cache : a,
              k = i ? a[h] : a[h] && h;
            if (k && j[k] && (e || j[k].data) || void 0 !== d || "string" != typeof b) return k || (k = i ? a[h] = c.pop() || m.guid++ : h), j[k] || (j[k] = i ? {} : {
              toJSON: m.noop
            }), ("object" == _typeof(b) || "function" == typeof b) && (e ? j[k] = m.extend(j[k], b) : j[k].data = m.extend(j[k].data, b)), g = j[k], e || (g.data || (g.data = {}), g = g.data), void 0 !== d && (g[m.camelCase(b)] = d), "string" == typeof b ? (f = g[b], null == f && (f = g[m.camelCase(b)])) : f = g, f;
          }
        }
        function R(a, b, c) {
          if (m.acceptData(a)) {
            var d,
              e,
              f = a.nodeType,
              g = f ? m.cache : a,
              h = f ? a[m.expando] : m.expando;
            if (g[h]) {
              if (b && (d = c ? g[h] : g[h].data)) {
                m.isArray(b) ? b = b.concat(m.map(b, m.camelCase)) : b in d ? b = [b] : (b = m.camelCase(b), b = b in d ? [b] : b.split(" ")), e = b.length;
                while (e--) {
                  delete d[b[e]];
                }
                if (c ? !P(d) : !m.isEmptyObject(d)) return;
              }
              (c || (delete g[h].data, P(g[h]))) && (f ? m.cleanData([a], !0) : k.deleteExpando || g != g.window ? delete g[h] : g[h] = null);
            }
          }
        }
        m.extend({
          cache: {},
          noData: {
            "applet ": !0,
            "embed ": !0,
            "object ": "clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"
          },
          hasData: function hasData(a) {
            return a = a.nodeType ? m.cache[a[m.expando]] : a[m.expando], !!a && !P(a);
          },
          data: function data(a, b, c) {
            return Q(a, b, c);
          },
          removeData: function removeData(a, b) {
            return R(a, b);
          },
          _data: function _data(a, b, c) {
            return Q(a, b, c, !0);
          },
          _removeData: function _removeData(a, b) {
            return R(a, b, !0);
          }
        }), m.fn.extend({
          data: function data(a, b) {
            var c,
              d,
              e,
              f = this[0],
              g = f && f.attributes;
            if (void 0 === a) {
              if (this.length && (e = m.data(f), 1 === f.nodeType && !m._data(f, "parsedAttrs"))) {
                c = g.length;
                while (c--) {
                  g[c] && (d = g[c].name, 0 === d.indexOf("data-") && (d = m.camelCase(d.slice(5)), O(f, d, e[d])));
                }
                m._data(f, "parsedAttrs", !0);
              }
              return e;
            }
            return "object" == _typeof(a) ? this.each(function () {
              m.data(this, a);
            }) : arguments.length > 1 ? this.each(function () {
              m.data(this, a, b);
            }) : f ? O(f, a, m.data(f, a)) : void 0;
          },
          removeData: function removeData(a) {
            return this.each(function () {
              m.removeData(this, a);
            });
          }
        }), m.extend({
          queue: function queue(a, b, c) {
            var d;
            return a ? (b = (b || "fx") + "queue", d = m._data(a, b), c && (!d || m.isArray(c) ? d = m._data(a, b, m.makeArray(c)) : d.push(c)), d || []) : void 0;
          },
          dequeue: function dequeue(a, b) {
            b = b || "fx";
            var c = m.queue(a, b),
              d = c.length,
              e = c.shift(),
              f = m._queueHooks(a, b),
              g = function g() {
                m.dequeue(a, b);
              };
            "inprogress" === e && (e = c.shift(), d--), e && ("fx" === b && c.unshift("inprogress"), delete f.stop, e.call(a, g, f)), !d && f && f.empty.fire();
          },
          _queueHooks: function _queueHooks(a, b) {
            var c = b + "queueHooks";
            return m._data(a, c) || m._data(a, c, {
              empty: m.Callbacks("once memory").add(function () {
                m._removeData(a, b + "queue"), m._removeData(a, c);
              })
            });
          }
        }), m.fn.extend({
          queue: function queue(a, b) {
            var c = 2;
            return "string" != typeof a && (b = a, a = "fx", c--), arguments.length < c ? m.queue(this[0], a) : void 0 === b ? this : this.each(function () {
              var c = m.queue(this, a, b);
              m._queueHooks(this, a), "fx" === a && "inprogress" !== c[0] && m.dequeue(this, a);
            });
          },
          dequeue: function dequeue(a) {
            return this.each(function () {
              m.dequeue(this, a);
            });
          },
          clearQueue: function clearQueue(a) {
            return this.queue(a || "fx", []);
          },
          promise: function promise(a, b) {
            var c,
              d = 1,
              e = m.Deferred(),
              f = this,
              g = this.length,
              h = function h() {
                --d || e.resolveWith(f, [f]);
              };
            "string" != typeof a && (b = a, a = void 0), a = a || "fx";
            while (g--) {
              c = m._data(f[g], a + "queueHooks"), c && c.empty && (d++, c.empty.add(h));
            }
            return h(), e.promise(b);
          }
        });
        var S = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,
          T = ["Top", "Right", "Bottom", "Left"],
          U = function U(a, b) {
            return a = b || a, "none" === m.css(a, "display") || !m.contains(a.ownerDocument, a);
          },
          V = m.access = function (a, b, c, d, e, f, g) {
            var h = 0,
              i = a.length,
              j = null == c;
            if ("object" === m.type(c)) {
              e = !0;
              for (h in c) {
                m.access(a, b, h, c[h], !0, f, g);
              }
            } else if (void 0 !== d && (e = !0, m.isFunction(d) || (g = !0), j && (g ? (b.call(a, d), b = null) : (j = b, b = function b(a, _b2, c) {
              return j.call(m(a), c);
            })), b)) for (; i > h; h++) {
              b(a[h], c, g ? d : d.call(a[h], h, b(a[h], c)));
            }
            return e ? a : j ? b.call(a) : i ? b(a[0], c) : f;
          },
          W = /^(?:checkbox|radio)$/i;
        !function () {
          var a = y.createElement("input"),
            b = y.createElement("div"),
            c = y.createDocumentFragment();
          if (b.innerHTML = "  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>", k.leadingWhitespace = 3 === b.firstChild.nodeType, k.tbody = !b.getElementsByTagName("tbody").length, k.htmlSerialize = !!b.getElementsByTagName("link").length, k.html5Clone = "<:nav></:nav>" !== y.createElement("nav").cloneNode(!0).outerHTML, a.type = "checkbox", a.checked = !0, c.appendChild(a), k.appendChecked = a.checked, b.innerHTML = "<textarea>x</textarea>", k.noCloneChecked = !!b.cloneNode(!0).lastChild.defaultValue, c.appendChild(b), b.innerHTML = "<input type='radio' checked='checked' name='t'/>", k.checkClone = b.cloneNode(!0).cloneNode(!0).lastChild.checked, k.noCloneEvent = !0, b.attachEvent && (b.attachEvent("onclick", function () {
            k.noCloneEvent = !1;
          }), b.cloneNode(!0).click()), null == k.deleteExpando) {
            k.deleteExpando = !0;
            try {
              delete b.test;
            } catch (d) {
              k.deleteExpando = !1;
            }
          }
        }(), function () {
          var b,
            c,
            d = y.createElement("div");
          for (b in {
            submit: !0,
            change: !0,
            focusin: !0
          }) {
            c = "on" + b, (k[b + "Bubbles"] = c in a) || (d.setAttribute(c, "t"), k[b + "Bubbles"] = d.attributes[c].expando === !1);
          }
          d = null;
        }();
        var X = /^(?:input|select|textarea)$/i,
          Y = /^key/,
          Z = /^(?:mouse|pointer|contextmenu)|click/,
          $ = /^(?:focusinfocus|focusoutblur)$/,
          _ = /^([^.]*)(?:\.(.+)|)$/;
        function aa() {
          return !0;
        }
        function ba() {
          return !1;
        }
        function ca() {
          try {
            return y.activeElement;
          } catch (a) {}
        }
        m.event = {
          global: {},
          add: function add(a, b, c, d, e) {
            var f,
              g,
              h,
              i,
              j,
              k,
              l,
              n,
              o,
              p,
              q,
              r = m._data(a);
            if (r) {
              c.handler && (i = c, c = i.handler, e = i.selector), c.guid || (c.guid = m.guid++), (g = r.events) || (g = r.events = {}), (k = r.handle) || (k = r.handle = function (a) {
                return _typeof(m) === K || a && m.event.triggered === a.type ? void 0 : m.event.dispatch.apply(k.elem, arguments);
              }, k.elem = a), b = (b || "").match(E) || [""], h = b.length;
              while (h--) {
                f = _.exec(b[h]) || [], o = q = f[1], p = (f[2] || "").split(".").sort(), o && (j = m.event.special[o] || {}, o = (e ? j.delegateType : j.bindType) || o, j = m.event.special[o] || {}, l = m.extend({
                  type: o,
                  origType: q,
                  data: d,
                  handler: c,
                  guid: c.guid,
                  selector: e,
                  needsContext: e && m.expr.match.needsContext.test(e),
                  namespace: p.join(".")
                }, i), (n = g[o]) || (n = g[o] = [], n.delegateCount = 0, j.setup && j.setup.call(a, d, p, k) !== !1 || (a.addEventListener ? a.addEventListener(o, k, !1) : a.attachEvent && a.attachEvent("on" + o, k))), j.add && (j.add.call(a, l), l.handler.guid || (l.handler.guid = c.guid)), e ? n.splice(n.delegateCount++, 0, l) : n.push(l), m.event.global[o] = !0);
              }
              a = null;
            }
          },
          remove: function remove(a, b, c, d, e) {
            var f,
              g,
              h,
              i,
              j,
              k,
              l,
              n,
              o,
              p,
              q,
              r = m.hasData(a) && m._data(a);
            if (r && (k = r.events)) {
              b = (b || "").match(E) || [""], j = b.length;
              while (j--) {
                if (h = _.exec(b[j]) || [], o = q = h[1], p = (h[2] || "").split(".").sort(), o) {
                  l = m.event.special[o] || {}, o = (d ? l.delegateType : l.bindType) || o, n = k[o] || [], h = h[2] && new RegExp("(^|\\.)" + p.join("\\.(?:.*\\.|)") + "(\\.|$)"), i = f = n.length;
                  while (f--) {
                    g = n[f], !e && q !== g.origType || c && c.guid !== g.guid || h && !h.test(g.namespace) || d && d !== g.selector && ("**" !== d || !g.selector) || (n.splice(f, 1), g.selector && n.delegateCount--, l.remove && l.remove.call(a, g));
                  }
                  i && !n.length && (l.teardown && l.teardown.call(a, p, r.handle) !== !1 || m.removeEvent(a, o, r.handle), delete k[o]);
                } else for (o in k) {
                  m.event.remove(a, o + b[j], c, d, !0);
                }
              }
              m.isEmptyObject(k) && (delete r.handle, m._removeData(a, "events"));
            }
          },
          trigger: function trigger(b, c, d, e) {
            var f,
              g,
              h,
              i,
              k,
              l,
              n,
              o = [d || y],
              p = j.call(b, "type") ? b.type : b,
              q = j.call(b, "namespace") ? b.namespace.split(".") : [];
            if (h = l = d = d || y, 3 !== d.nodeType && 8 !== d.nodeType && !$.test(p + m.event.triggered) && (p.indexOf(".") >= 0 && (q = p.split("."), p = q.shift(), q.sort()), g = p.indexOf(":") < 0 && "on" + p, b = b[m.expando] ? b : new m.Event(p, "object" == _typeof(b) && b), b.isTrigger = e ? 2 : 3, b.namespace = q.join("."), b.namespace_re = b.namespace ? new RegExp("(^|\\.)" + q.join("\\.(?:.*\\.|)") + "(\\.|$)") : null, b.result = void 0, b.target || (b.target = d), c = null == c ? [b] : m.makeArray(c, [b]), k = m.event.special[p] || {}, e || !k.trigger || k.trigger.apply(d, c) !== !1)) {
              if (!e && !k.noBubble && !m.isWindow(d)) {
                for (i = k.delegateType || p, $.test(i + p) || (h = h.parentNode); h; h = h.parentNode) {
                  o.push(h), l = h;
                }
                l === (d.ownerDocument || y) && o.push(l.defaultView || l.parentWindow || a);
              }
              n = 0;
              while ((h = o[n++]) && !b.isPropagationStopped()) {
                b.type = n > 1 ? i : k.bindType || p, f = (m._data(h, "events") || {})[b.type] && m._data(h, "handle"), f && f.apply(h, c), f = g && h[g], f && f.apply && m.acceptData(h) && (b.result = f.apply(h, c), b.result === !1 && b.preventDefault());
              }
              if (b.type = p, !e && !b.isDefaultPrevented() && (!k._default || k._default.apply(o.pop(), c) === !1) && m.acceptData(d) && g && d[p] && !m.isWindow(d)) {
                l = d[g], l && (d[g] = null), m.event.triggered = p;
                try {
                  d[p]();
                } catch (r) {}
                m.event.triggered = void 0, l && (d[g] = l);
              }
              return b.result;
            }
          },
          dispatch: function dispatch(a) {
            a = m.event.fix(a);
            var b,
              c,
              e,
              f,
              g,
              h = [],
              i = d.call(arguments),
              j = (m._data(this, "events") || {})[a.type] || [],
              k = m.event.special[a.type] || {};
            if (i[0] = a, a.delegateTarget = this, !k.preDispatch || k.preDispatch.call(this, a) !== !1) {
              h = m.event.handlers.call(this, a, j), b = 0;
              while ((f = h[b++]) && !a.isPropagationStopped()) {
                a.currentTarget = f.elem, g = 0;
                while ((e = f.handlers[g++]) && !a.isImmediatePropagationStopped()) {
                  (!a.namespace_re || a.namespace_re.test(e.namespace)) && (a.handleObj = e, a.data = e.data, c = ((m.event.special[e.origType] || {}).handle || e.handler).apply(f.elem, i), void 0 !== c && (a.result = c) === !1 && (a.preventDefault(), a.stopPropagation()));
                }
              }
              return k.postDispatch && k.postDispatch.call(this, a), a.result;
            }
          },
          handlers: function handlers(a, b) {
            var c,
              d,
              e,
              f,
              g = [],
              h = b.delegateCount,
              i = a.target;
            if (h && i.nodeType && (!a.button || "click" !== a.type)) for (; i != this; i = i.parentNode || this) {
              if (1 === i.nodeType && (i.disabled !== !0 || "click" !== a.type)) {
                for (e = [], f = 0; h > f; f++) {
                  d = b[f], c = d.selector + " ", void 0 === e[c] && (e[c] = d.needsContext ? m(c, this).index(i) >= 0 : m.find(c, this, null, [i]).length), e[c] && e.push(d);
                }
                e.length && g.push({
                  elem: i,
                  handlers: e
                });
              }
            }
            return h < b.length && g.push({
              elem: this,
              handlers: b.slice(h)
            }), g;
          },
          fix: function fix(a) {
            if (a[m.expando]) return a;
            var b,
              c,
              d,
              e = a.type,
              f = a,
              g = this.fixHooks[e];
            g || (this.fixHooks[e] = g = Z.test(e) ? this.mouseHooks : Y.test(e) ? this.keyHooks : {}), d = g.props ? this.props.concat(g.props) : this.props, a = new m.Event(f), b = d.length;
            while (b--) {
              c = d[b], a[c] = f[c];
            }
            return a.target || (a.target = f.srcElement || y), 3 === a.target.nodeType && (a.target = a.target.parentNode), a.metaKey = !!a.metaKey, g.filter ? g.filter(a, f) : a;
          },
          props: "altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),
          fixHooks: {},
          keyHooks: {
            props: "char charCode key keyCode".split(" "),
            filter: function filter(a, b) {
              return null == a.which && (a.which = null != b.charCode ? b.charCode : b.keyCode), a;
            }
          },
          mouseHooks: {
            props: "button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" "),
            filter: function filter(a, b) {
              var c,
                d,
                e,
                f = b.button,
                g = b.fromElement;
              return null == a.pageX && null != b.clientX && (d = a.target.ownerDocument || y, e = d.documentElement, c = d.body, a.pageX = b.clientX + (e && e.scrollLeft || c && c.scrollLeft || 0) - (e && e.clientLeft || c && c.clientLeft || 0), a.pageY = b.clientY + (e && e.scrollTop || c && c.scrollTop || 0) - (e && e.clientTop || c && c.clientTop || 0)), !a.relatedTarget && g && (a.relatedTarget = g === a.target ? b.toElement : g), a.which || void 0 === f || (a.which = 1 & f ? 1 : 2 & f ? 3 : 4 & f ? 2 : 0), a;
            }
          },
          special: {
            load: {
              noBubble: !0
            },
            focus: {
              trigger: function trigger() {
                if (this !== ca() && this.focus) try {
                  return this.focus(), !1;
                } catch (a) {}
              },
              delegateType: "focusin"
            },
            blur: {
              trigger: function trigger() {
                return this === ca() && this.blur ? (this.blur(), !1) : void 0;
              },
              delegateType: "focusout"
            },
            click: {
              trigger: function trigger() {
                return m.nodeName(this, "input") && "checkbox" === this.type && this.click ? (this.click(), !1) : void 0;
              },
              _default: function _default(a) {
                return m.nodeName(a.target, "a");
              }
            },
            beforeunload: {
              postDispatch: function postDispatch(a) {
                void 0 !== a.result && a.originalEvent && (a.originalEvent.returnValue = a.result);
              }
            }
          },
          simulate: function simulate(a, b, c, d) {
            var e = m.extend(new m.Event(), c, {
              type: a,
              isSimulated: !0,
              originalEvent: {}
            });
            d ? m.event.trigger(e, null, b) : m.event.dispatch.call(b, e), e.isDefaultPrevented() && c.preventDefault();
          }
        }, m.removeEvent = y.removeEventListener ? function (a, b, c) {
          a.removeEventListener && a.removeEventListener(b, c, !1);
        } : function (a, b, c) {
          var d = "on" + b;
          a.detachEvent && (_typeof(a[d]) === K && (a[d] = null), a.detachEvent(d, c));
        }, m.Event = function (a, b) {
          return this instanceof m.Event ? (a && a.type ? (this.originalEvent = a, this.type = a.type, this.isDefaultPrevented = a.defaultPrevented || void 0 === a.defaultPrevented && a.returnValue === !1 ? aa : ba) : this.type = a, b && m.extend(this, b), this.timeStamp = a && a.timeStamp || m.now(), void (this[m.expando] = !0)) : new m.Event(a, b);
        }, m.Event.prototype = {
          isDefaultPrevented: ba,
          isPropagationStopped: ba,
          isImmediatePropagationStopped: ba,
          preventDefault: function preventDefault() {
            var a = this.originalEvent;
            this.isDefaultPrevented = aa, a && (a.preventDefault ? a.preventDefault() : a.returnValue = !1);
          },
          stopPropagation: function stopPropagation() {
            var a = this.originalEvent;
            this.isPropagationStopped = aa, a && (a.stopPropagation && a.stopPropagation(), a.cancelBubble = !0);
          },
          stopImmediatePropagation: function stopImmediatePropagation() {
            var a = this.originalEvent;
            this.isImmediatePropagationStopped = aa, a && a.stopImmediatePropagation && a.stopImmediatePropagation(), this.stopPropagation();
          }
        }, m.each({
          mouseenter: "mouseover",
          mouseleave: "mouseout",
          pointerenter: "pointerover",
          pointerleave: "pointerout"
        }, function (a, b) {
          m.event.special[a] = {
            delegateType: b,
            bindType: b,
            handle: function handle(a) {
              var c,
                d = this,
                e = a.relatedTarget,
                f = a.handleObj;
              return (!e || e !== d && !m.contains(d, e)) && (a.type = f.origType, c = f.handler.apply(this, arguments), a.type = b), c;
            }
          };
        }), k.submitBubbles || (m.event.special.submit = {
          setup: function setup() {
            return m.nodeName(this, "form") ? !1 : void m.event.add(this, "click._submit keypress._submit", function (a) {
              var b = a.target,
                c = m.nodeName(b, "input") || m.nodeName(b, "button") ? b.form : void 0;
              c && !m._data(c, "submitBubbles") && (m.event.add(c, "submit._submit", function (a) {
                a._submit_bubble = !0;
              }), m._data(c, "submitBubbles", !0));
            });
          },
          postDispatch: function postDispatch(a) {
            a._submit_bubble && (delete a._submit_bubble, this.parentNode && !a.isTrigger && m.event.simulate("submit", this.parentNode, a, !0));
          },
          teardown: function teardown() {
            return m.nodeName(this, "form") ? !1 : void m.event.remove(this, "._submit");
          }
        }), k.changeBubbles || (m.event.special.change = {
          setup: function setup() {
            return X.test(this.nodeName) ? (("checkbox" === this.type || "radio" === this.type) && (m.event.add(this, "propertychange._change", function (a) {
              "checked" === a.originalEvent.propertyName && (this._just_changed = !0);
            }), m.event.add(this, "click._change", function (a) {
              this._just_changed && !a.isTrigger && (this._just_changed = !1), m.event.simulate("change", this, a, !0);
            })), !1) : void m.event.add(this, "beforeactivate._change", function (a) {
              var b = a.target;
              X.test(b.nodeName) && !m._data(b, "changeBubbles") && (m.event.add(b, "change._change", function (a) {
                !this.parentNode || a.isSimulated || a.isTrigger || m.event.simulate("change", this.parentNode, a, !0);
              }), m._data(b, "changeBubbles", !0));
            });
          },
          handle: function handle(a) {
            var b = a.target;
            return this !== b || a.isSimulated || a.isTrigger || "radio" !== b.type && "checkbox" !== b.type ? a.handleObj.handler.apply(this, arguments) : void 0;
          },
          teardown: function teardown() {
            return m.event.remove(this, "._change"), !X.test(this.nodeName);
          }
        }), k.focusinBubbles || m.each({
          focus: "focusin",
          blur: "focusout"
        }, function (a, b) {
          var c = function c(a) {
            m.event.simulate(b, a.target, m.event.fix(a), !0);
          };
          m.event.special[b] = {
            setup: function setup() {
              var d = this.ownerDocument || this,
                e = m._data(d, b);
              e || d.addEventListener(a, c, !0), m._data(d, b, (e || 0) + 1);
            },
            teardown: function teardown() {
              var d = this.ownerDocument || this,
                e = m._data(d, b) - 1;
              e ? m._data(d, b, e) : (d.removeEventListener(a, c, !0), m._removeData(d, b));
            }
          };
        }), m.fn.extend({
          on: function on(a, b, c, d, e) {
            var f, g;
            if ("object" == _typeof(a)) {
              "string" != typeof b && (c = c || b, b = void 0);
              for (f in a) {
                this.on(f, b, c, a[f], e);
              }
              return this;
            }
            if (null == c && null == d ? (d = b, c = b = void 0) : null == d && ("string" == typeof b ? (d = c, c = void 0) : (d = c, c = b, b = void 0)), d === !1) d = ba;else if (!d) return this;
            return 1 === e && (g = d, d = function d(a) {
              return m().off(a), g.apply(this, arguments);
            }, d.guid = g.guid || (g.guid = m.guid++)), this.each(function () {
              m.event.add(this, a, d, c, b);
            });
          },
          one: function one(a, b, c, d) {
            return this.on(a, b, c, d, 1);
          },
          off: function off(a, b, c) {
            var d, e;
            if (a && a.preventDefault && a.handleObj) return d = a.handleObj, m(a.delegateTarget).off(d.namespace ? d.origType + "." + d.namespace : d.origType, d.selector, d.handler), this;
            if ("object" == _typeof(a)) {
              for (e in a) {
                this.off(e, b, a[e]);
              }
              return this;
            }
            return (b === !1 || "function" == typeof b) && (c = b, b = void 0), c === !1 && (c = ba), this.each(function () {
              m.event.remove(this, a, c, b);
            });
          },
          trigger: function trigger(a, b) {
            return this.each(function () {
              m.event.trigger(a, b, this);
            });
          },
          triggerHandler: function triggerHandler(a, b) {
            var c = this[0];
            return c ? m.event.trigger(a, b, c, !0) : void 0;
          }
        });
        function da(a) {
          var b = ea.split("|"),
            c = a.createDocumentFragment();
          if (c.createElement) while (b.length) {
            c.createElement(b.pop());
          }
          return c;
        }
        var ea = "abbr|article|aside|audio|bdi|canvas|data|datalist|details|figcaption|figure|footer|header|hgroup|mark|meter|nav|output|progress|section|summary|time|video",
          fa = / jQuery\d+="(?:null|\d+)"/g,
          ga = new RegExp("<(?:" + ea + ")[\\s/>]", "i"),
          ha = /^\s+/,
          ia = /<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,
          ja = /<([\w:]+)/,
          ka = /<tbody/i,
          la = /<|&#?\w+;/,
          ma = /<(?:script|style|link)/i,
          na = /checked\s*(?:[^=]|=\s*.checked.)/i,
          oa = /^$|\/(?:java|ecma)script/i,
          pa = /^true\/(.*)/,
          qa = /^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g,
          ra = {
            option: [1, "<select multiple='multiple'>", "</select>"],
            legend: [1, "<fieldset>", "</fieldset>"],
            area: [1, "<map>", "</map>"],
            param: [1, "<object>", "</object>"],
            thead: [1, "<table>", "</table>"],
            tr: [2, "<table><tbody>", "</tbody></table>"],
            col: [2, "<table><tbody></tbody><colgroup>", "</colgroup></table>"],
            td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],
            _default: k.htmlSerialize ? [0, "", ""] : [1, "X<div>", "</div>"]
          },
          sa = da(y),
          ta = sa.appendChild(y.createElement("div"));
        ra.optgroup = ra.option, ra.tbody = ra.tfoot = ra.colgroup = ra.caption = ra.thead, ra.th = ra.td;
        function ua(a, b) {
          var c,
            d,
            e = 0,
            f = _typeof(a.getElementsByTagName) !== K ? a.getElementsByTagName(b || "*") : _typeof(a.querySelectorAll) !== K ? a.querySelectorAll(b || "*") : void 0;
          if (!f) for (f = [], c = a.childNodes || a; null != (d = c[e]); e++) {
            !b || m.nodeName(d, b) ? f.push(d) : m.merge(f, ua(d, b));
          }
          return void 0 === b || b && m.nodeName(a, b) ? m.merge([a], f) : f;
        }
        function va(a) {
          W.test(a.type) && (a.defaultChecked = a.checked);
        }
        function wa(a, b) {
          return m.nodeName(a, "table") && m.nodeName(11 !== b.nodeType ? b : b.firstChild, "tr") ? a.getElementsByTagName("tbody")[0] || a.appendChild(a.ownerDocument.createElement("tbody")) : a;
        }
        function xa(a) {
          return a.type = (null !== m.find.attr(a, "type")) + "/" + a.type, a;
        }
        function ya(a) {
          var b = pa.exec(a.type);
          return b ? a.type = b[1] : a.removeAttribute("type"), a;
        }
        function za(a, b) {
          for (var c, d = 0; null != (c = a[d]); d++) {
            m._data(c, "globalEval", !b || m._data(b[d], "globalEval"));
          }
        }
        function Aa(a, b) {
          if (1 === b.nodeType && m.hasData(a)) {
            var c,
              d,
              e,
              f = m._data(a),
              g = m._data(b, f),
              h = f.events;
            if (h) {
              delete g.handle, g.events = {};
              for (c in h) {
                for (d = 0, e = h[c].length; e > d; d++) {
                  m.event.add(b, c, h[c][d]);
                }
              }
            }
            g.data && (g.data = m.extend({}, g.data));
          }
        }
        function Ba(a, b) {
          var c, d, e;
          if (1 === b.nodeType) {
            if (c = b.nodeName.toLowerCase(), !k.noCloneEvent && b[m.expando]) {
              e = m._data(b);
              for (d in e.events) {
                m.removeEvent(b, d, e.handle);
              }
              b.removeAttribute(m.expando);
            }
            "script" === c && b.text !== a.text ? (xa(b).text = a.text, ya(b)) : "object" === c ? (b.parentNode && (b.outerHTML = a.outerHTML), k.html5Clone && a.innerHTML && !m.trim(b.innerHTML) && (b.innerHTML = a.innerHTML)) : "input" === c && W.test(a.type) ? (b.defaultChecked = b.checked = a.checked, b.value !== a.value && (b.value = a.value)) : "option" === c ? b.defaultSelected = b.selected = a.defaultSelected : ("input" === c || "textarea" === c) && (b.defaultValue = a.defaultValue);
          }
        }
        m.extend({
          clone: function clone(a, b, c) {
            var d,
              e,
              f,
              g,
              h,
              i = m.contains(a.ownerDocument, a);
            if (k.html5Clone || m.isXMLDoc(a) || !ga.test("<" + a.nodeName + ">") ? f = a.cloneNode(!0) : (ta.innerHTML = a.outerHTML, ta.removeChild(f = ta.firstChild)), !(k.noCloneEvent && k.noCloneChecked || 1 !== a.nodeType && 11 !== a.nodeType || m.isXMLDoc(a))) for (d = ua(f), h = ua(a), g = 0; null != (e = h[g]); ++g) {
              d[g] && Ba(e, d[g]);
            }
            if (b) if (c) for (h = h || ua(a), d = d || ua(f), g = 0; null != (e = h[g]); g++) {
              Aa(e, d[g]);
            } else Aa(a, f);
            return d = ua(f, "script"), d.length > 0 && za(d, !i && ua(a, "script")), d = h = e = null, f;
          },
          buildFragment: function buildFragment(a, b, c, d) {
            for (var e, f, g, h, i, j, l, n = a.length, o = da(b), p = [], q = 0; n > q; q++) {
              if (f = a[q], f || 0 === f) if ("object" === m.type(f)) m.merge(p, f.nodeType ? [f] : f);else if (la.test(f)) {
                h = h || o.appendChild(b.createElement("div")), i = (ja.exec(f) || ["", ""])[1].toLowerCase(), l = ra[i] || ra._default, h.innerHTML = l[1] + f.replace(ia, "<$1></$2>") + l[2], e = l[0];
                while (e--) {
                  h = h.lastChild;
                }
                if (!k.leadingWhitespace && ha.test(f) && p.push(b.createTextNode(ha.exec(f)[0])), !k.tbody) {
                  f = "table" !== i || ka.test(f) ? "<table>" !== l[1] || ka.test(f) ? 0 : h : h.firstChild, e = f && f.childNodes.length;
                  while (e--) {
                    m.nodeName(j = f.childNodes[e], "tbody") && !j.childNodes.length && f.removeChild(j);
                  }
                }
                m.merge(p, h.childNodes), h.textContent = "";
                while (h.firstChild) {
                  h.removeChild(h.firstChild);
                }
                h = o.lastChild;
              } else p.push(b.createTextNode(f));
            }
            h && o.removeChild(h), k.appendChecked || m.grep(ua(p, "input"), va), q = 0;
            while (f = p[q++]) {
              if ((!d || -1 === m.inArray(f, d)) && (g = m.contains(f.ownerDocument, f), h = ua(o.appendChild(f), "script"), g && za(h), c)) {
                e = 0;
                while (f = h[e++]) {
                  oa.test(f.type || "") && c.push(f);
                }
              }
            }
            return h = null, o;
          },
          cleanData: function cleanData(a, b) {
            for (var d, e, f, g, h = 0, i = m.expando, j = m.cache, l = k.deleteExpando, n = m.event.special; null != (d = a[h]); h++) {
              if ((b || m.acceptData(d)) && (f = d[i], g = f && j[f])) {
                if (g.events) for (e in g.events) {
                  n[e] ? m.event.remove(d, e) : m.removeEvent(d, e, g.handle);
                }
                j[f] && (delete j[f], l ? delete d[i] : _typeof(d.removeAttribute) !== K ? d.removeAttribute(i) : d[i] = null, c.push(f));
              }
            }
          }
        }), m.fn.extend({
          text: function text(a) {
            return V(this, function (a) {
              return void 0 === a ? m.text(this) : this.empty().append((this[0] && this[0].ownerDocument || y).createTextNode(a));
            }, null, a, arguments.length);
          },
          append: function append() {
            return this.domManip(arguments, function (a) {
              if (1 === this.nodeType || 11 === this.nodeType || 9 === this.nodeType) {
                var b = wa(this, a);
                b.appendChild(a);
              }
            });
          },
          prepend: function prepend() {
            return this.domManip(arguments, function (a) {
              if (1 === this.nodeType || 11 === this.nodeType || 9 === this.nodeType) {
                var b = wa(this, a);
                b.insertBefore(a, b.firstChild);
              }
            });
          },
          before: function before() {
            return this.domManip(arguments, function (a) {
              this.parentNode && this.parentNode.insertBefore(a, this);
            });
          },
          after: function after() {
            return this.domManip(arguments, function (a) {
              this.parentNode && this.parentNode.insertBefore(a, this.nextSibling);
            });
          },
          remove: function remove(a, b) {
            for (var c, d = a ? m.filter(a, this) : this, e = 0; null != (c = d[e]); e++) {
              b || 1 !== c.nodeType || m.cleanData(ua(c)), c.parentNode && (b && m.contains(c.ownerDocument, c) && za(ua(c, "script")), c.parentNode.removeChild(c));
            }
            return this;
          },
          empty: function empty() {
            for (var a, b = 0; null != (a = this[b]); b++) {
              1 === a.nodeType && m.cleanData(ua(a, !1));
              while (a.firstChild) {
                a.removeChild(a.firstChild);
              }
              a.options && m.nodeName(a, "select") && (a.options.length = 0);
            }
            return this;
          },
          clone: function clone(a, b) {
            return a = null == a ? !1 : a, b = null == b ? a : b, this.map(function () {
              return m.clone(this, a, b);
            });
          },
          html: function html(a) {
            return V(this, function (a) {
              var b = this[0] || {},
                c = 0,
                d = this.length;
              if (void 0 === a) return 1 === b.nodeType ? b.innerHTML.replace(fa, "") : void 0;
              if (!("string" != typeof a || ma.test(a) || !k.htmlSerialize && ga.test(a) || !k.leadingWhitespace && ha.test(a) || ra[(ja.exec(a) || ["", ""])[1].toLowerCase()])) {
                a = a.replace(ia, "<$1></$2>");
                try {
                  for (; d > c; c++) {
                    b = this[c] || {}, 1 === b.nodeType && (m.cleanData(ua(b, !1)), b.innerHTML = a);
                  }
                  b = 0;
                } catch (e) {}
              }
              b && this.empty().append(a);
            }, null, a, arguments.length);
          },
          replaceWith: function replaceWith() {
            var a = arguments[0];
            return this.domManip(arguments, function (b) {
              a = this.parentNode, m.cleanData(ua(this)), a && a.replaceChild(b, this);
            }), a && (a.length || a.nodeType) ? this : this.remove();
          },
          detach: function detach(a) {
            return this.remove(a, !0);
          },
          domManip: function domManip(a, b) {
            a = e.apply([], a);
            var c,
              d,
              f,
              g,
              h,
              i,
              j = 0,
              l = this.length,
              n = this,
              o = l - 1,
              p = a[0],
              q = m.isFunction(p);
            if (q || l > 1 && "string" == typeof p && !k.checkClone && na.test(p)) return this.each(function (c) {
              var d = n.eq(c);
              q && (a[0] = p.call(this, c, d.html())), d.domManip(a, b);
            });
            if (l && (i = m.buildFragment(a, this[0].ownerDocument, !1, this), c = i.firstChild, 1 === i.childNodes.length && (i = c), c)) {
              for (g = m.map(ua(i, "script"), xa), f = g.length; l > j; j++) {
                d = i, j !== o && (d = m.clone(d, !0, !0), f && m.merge(g, ua(d, "script"))), b.call(this[j], d, j);
              }
              if (f) for (h = g[g.length - 1].ownerDocument, m.map(g, ya), j = 0; f > j; j++) {
                d = g[j], oa.test(d.type || "") && !m._data(d, "globalEval") && m.contains(h, d) && (d.src ? m._evalUrl && m._evalUrl(d.src) : m.globalEval((d.text || d.textContent || d.innerHTML || "").replace(qa, "")));
              }
              i = c = null;
            }
            return this;
          }
        }), m.each({
          appendTo: "append",
          prependTo: "prepend",
          insertBefore: "before",
          insertAfter: "after",
          replaceAll: "replaceWith"
        }, function (a, b) {
          m.fn[a] = function (a) {
            for (var c, d = 0, e = [], g = m(a), h = g.length - 1; h >= d; d++) {
              c = d === h ? this : this.clone(!0), m(g[d])[b](c), f.apply(e, c.get());
            }
            return this.pushStack(e);
          };
        });
        var Ca,
          Da = {};
        function Ea(b, c) {
          var d,
            e = m(c.createElement(b)).appendTo(c.body),
            f = a.getDefaultComputedStyle && (d = a.getDefaultComputedStyle(e[0])) ? d.display : m.css(e[0], "display");
          return e.detach(), f;
        }
        function Fa(a) {
          var b = y,
            c = Da[a];
          return c || (c = Ea(a, b), "none" !== c && c || (Ca = (Ca || m("<iframe frameborder='0' width='0' height='0'/>")).appendTo(b.documentElement), b = (Ca[0].contentWindow || Ca[0].contentDocument).document, b.write(), b.close(), c = Ea(a, b), Ca.detach()), Da[a] = c), c;
        }
        !function () {
          var a;
          k.shrinkWrapBlocks = function () {
            if (null != a) return a;
            a = !1;
            var b, c, d;
            return c = y.getElementsByTagName("body")[0], c && c.style ? (b = y.createElement("div"), d = y.createElement("div"), d.style.cssText = "position:absolute;border:0;width:0;height:0;top:0;left:-9999px", c.appendChild(d).appendChild(b), _typeof(b.style.zoom) !== K && (b.style.cssText = "-webkit-box-sizing:content-box;-moz-box-sizing:content-box;box-sizing:content-box;display:block;margin:0;border:0;padding:1px;width:1px;zoom:1", b.appendChild(y.createElement("div")).style.width = "5px", a = 3 !== b.offsetWidth), c.removeChild(d), a) : void 0;
          };
        }();
        var Ga = /^margin/,
          Ha = new RegExp("^(" + S + ")(?!px)[a-z%]+$", "i"),
          Ia,
          Ja,
          Ka = /^(top|right|bottom|left)$/;
        a.getComputedStyle ? (Ia = function Ia(b) {
          return b.ownerDocument.defaultView.opener ? b.ownerDocument.defaultView.getComputedStyle(b, null) : a.getComputedStyle(b, null);
        }, Ja = function Ja(a, b, c) {
          var d,
            e,
            f,
            g,
            h = a.style;
          return c = c || Ia(a), g = c ? c.getPropertyValue(b) || c[b] : void 0, c && ("" !== g || m.contains(a.ownerDocument, a) || (g = m.style(a, b)), Ha.test(g) && Ga.test(b) && (d = h.width, e = h.minWidth, f = h.maxWidth, h.minWidth = h.maxWidth = h.width = g, g = c.width, h.width = d, h.minWidth = e, h.maxWidth = f)), void 0 === g ? g : g + "";
        }) : y.documentElement.currentStyle && (Ia = function Ia(a) {
          return a.currentStyle;
        }, Ja = function Ja(a, b, c) {
          var d,
            e,
            f,
            g,
            h = a.style;
          return c = c || Ia(a), g = c ? c[b] : void 0, null == g && h && h[b] && (g = h[b]), Ha.test(g) && !Ka.test(b) && (d = h.left, e = a.runtimeStyle, f = e && e.left, f && (e.left = a.currentStyle.left), h.left = "fontSize" === b ? "1em" : g, g = h.pixelLeft + "px", h.left = d, f && (e.left = f)), void 0 === g ? g : g + "" || "auto";
        });
        function La(a, b) {
          return {
            get: function get() {
              var c = a();
              if (null != c) return c ? void delete this.get : (this.get = b).apply(this, arguments);
            }
          };
        }
        !function () {
          var b, c, d, e, f, g, h;
          if (b = y.createElement("div"), b.innerHTML = "  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>", d = b.getElementsByTagName("a")[0], c = d && d.style) {
            var _i = function _i() {
              var b, c, d, i;
              c = y.getElementsByTagName("body")[0], c && c.style && (b = y.createElement("div"), d = y.createElement("div"), d.style.cssText = "position:absolute;border:0;width:0;height:0;top:0;left:-9999px", c.appendChild(d).appendChild(b), b.style.cssText = "-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;display:block;margin-top:1%;top:1%;border:1px;padding:1px;width:4px;position:absolute", e = f = !1, h = !0, a.getComputedStyle && (e = "1%" !== (a.getComputedStyle(b, null) || {}).top, f = "4px" === (a.getComputedStyle(b, null) || {
                width: "4px"
              }).width, i = b.appendChild(y.createElement("div")), i.style.cssText = b.style.cssText = "-webkit-box-sizing:content-box;-moz-box-sizing:content-box;box-sizing:content-box;display:block;margin:0;border:0;padding:0", i.style.marginRight = i.style.width = "0", b.style.width = "1px", h = !parseFloat((a.getComputedStyle(i, null) || {}).marginRight), b.removeChild(i)), b.innerHTML = "<table><tr><td></td><td>t</td></tr></table>", i = b.getElementsByTagName("td"), i[0].style.cssText = "margin:0;border:0;padding:0;display:none", g = 0 === i[0].offsetHeight, g && (i[0].style.display = "", i[1].style.display = "none", g = 0 === i[0].offsetHeight), c.removeChild(d));
            };
            c.cssText = "float:left;opacity:.5", k.opacity = "0.5" === c.opacity, k.cssFloat = !!c.cssFloat, b.style.backgroundClip = "content-box", b.cloneNode(!0).style.backgroundClip = "", k.clearCloneStyle = "content-box" === b.style.backgroundClip, k.boxSizing = "" === c.boxSizing || "" === c.MozBoxSizing || "" === c.WebkitBoxSizing, m.extend(k, {
              reliableHiddenOffsets: function reliableHiddenOffsets() {
                return null == g && _i(), g;
              },
              boxSizingReliable: function boxSizingReliable() {
                return null == f && _i(), f;
              },
              pixelPosition: function pixelPosition() {
                return null == e && _i(), e;
              },
              reliableMarginRight: function reliableMarginRight() {
                return null == h && _i(), h;
              }
            });
          }
        }(), m.swap = function (a, b, c, d) {
          var e,
            f,
            g = {};
          for (f in b) {
            g[f] = a.style[f], a.style[f] = b[f];
          }
          e = c.apply(a, d || []);
          for (f in b) {
            a.style[f] = g[f];
          }
          return e;
        };
        var Ma = /alpha\([^)]*\)/i,
          Na = /opacity\s*=\s*([^)]*)/,
          Oa = /^(none|table(?!-c[ea]).+)/,
          Pa = new RegExp("^(" + S + ")(.*)$", "i"),
          Qa = new RegExp("^([+-])=(" + S + ")", "i"),
          Ra = {
            position: "absolute",
            visibility: "hidden",
            display: "block"
          },
          Sa = {
            letterSpacing: "0",
            fontWeight: "400"
          },
          Ta = ["Webkit", "O", "Moz", "ms"];
        function Ua(a, b) {
          if (b in a) return b;
          var c = b.charAt(0).toUpperCase() + b.slice(1),
            d = b,
            e = Ta.length;
          while (e--) {
            if (b = Ta[e] + c, b in a) return b;
          }
          return d;
        }
        function Va(a, b) {
          for (var c, d, e, f = [], g = 0, h = a.length; h > g; g++) {
            d = a[g], d.style && (f[g] = m._data(d, "olddisplay"), c = d.style.display, b ? (f[g] || "none" !== c || (d.style.display = ""), "" === d.style.display && U(d) && (f[g] = m._data(d, "olddisplay", Fa(d.nodeName)))) : (e = U(d), (c && "none" !== c || !e) && m._data(d, "olddisplay", e ? c : m.css(d, "display"))));
          }
          for (g = 0; h > g; g++) {
            d = a[g], d.style && (b && "none" !== d.style.display && "" !== d.style.display || (d.style.display = b ? f[g] || "" : "none"));
          }
          return a;
        }
        function Wa(a, b, c) {
          var d = Pa.exec(b);
          return d ? Math.max(0, d[1] - (c || 0)) + (d[2] || "px") : b;
        }
        function Xa(a, b, c, d, e) {
          for (var f = c === (d ? "border" : "content") ? 4 : "width" === b ? 1 : 0, g = 0; 4 > f; f += 2) {
            "margin" === c && (g += m.css(a, c + T[f], !0, e)), d ? ("content" === c && (g -= m.css(a, "padding" + T[f], !0, e)), "margin" !== c && (g -= m.css(a, "border" + T[f] + "Width", !0, e))) : (g += m.css(a, "padding" + T[f], !0, e), "padding" !== c && (g += m.css(a, "border" + T[f] + "Width", !0, e)));
          }
          return g;
        }
        function Ya(a, b, c) {
          var d = !0,
            e = "width" === b ? a.offsetWidth : a.offsetHeight,
            f = Ia(a),
            g = k.boxSizing && "border-box" === m.css(a, "boxSizing", !1, f);
          if (0 >= e || null == e) {
            if (e = Ja(a, b, f), (0 > e || null == e) && (e = a.style[b]), Ha.test(e)) return e;
            d = g && (k.boxSizingReliable() || e === a.style[b]), e = parseFloat(e) || 0;
          }
          return e + Xa(a, b, c || (g ? "border" : "content"), d, f) + "px";
        }
        m.extend({
          cssHooks: {
            opacity: {
              get: function get(a, b) {
                if (b) {
                  var c = Ja(a, "opacity");
                  return "" === c ? "1" : c;
                }
              }
            }
          },
          cssNumber: {
            columnCount: !0,
            fillOpacity: !0,
            flexGrow: !0,
            flexShrink: !0,
            fontWeight: !0,
            lineHeight: !0,
            opacity: !0,
            order: !0,
            orphans: !0,
            widows: !0,
            zIndex: !0,
            zoom: !0
          },
          cssProps: {
            "float": k.cssFloat ? "cssFloat" : "styleFloat"
          },
          style: function style(a, b, c, d) {
            if (a && 3 !== a.nodeType && 8 !== a.nodeType && a.style) {
              var e,
                f,
                g,
                h = m.camelCase(b),
                i = a.style;
              if (b = m.cssProps[h] || (m.cssProps[h] = Ua(i, h)), g = m.cssHooks[b] || m.cssHooks[h], void 0 === c) return g && "get" in g && void 0 !== (e = g.get(a, !1, d)) ? e : i[b];
              if (f = _typeof(c), "string" === f && (e = Qa.exec(c)) && (c = (e[1] + 1) * e[2] + parseFloat(m.css(a, b)), f = "number"), null != c && c === c && ("number" !== f || m.cssNumber[h] || (c += "px"), k.clearCloneStyle || "" !== c || 0 !== b.indexOf("background") || (i[b] = "inherit"), !(g && "set" in g && void 0 === (c = g.set(a, c, d))))) try {
                i[b] = c;
              } catch (j) {}
            }
          },
          css: function css(a, b, c, d) {
            var e,
              f,
              g,
              h = m.camelCase(b);
            return b = m.cssProps[h] || (m.cssProps[h] = Ua(a.style, h)), g = m.cssHooks[b] || m.cssHooks[h], g && "get" in g && (f = g.get(a, !0, c)), void 0 === f && (f = Ja(a, b, d)), "normal" === f && b in Sa && (f = Sa[b]), "" === c || c ? (e = parseFloat(f), c === !0 || m.isNumeric(e) ? e || 0 : f) : f;
          }
        }), m.each(["height", "width"], function (a, b) {
          m.cssHooks[b] = {
            get: function get(a, c, d) {
              return c ? Oa.test(m.css(a, "display")) && 0 === a.offsetWidth ? m.swap(a, Ra, function () {
                return Ya(a, b, d);
              }) : Ya(a, b, d) : void 0;
            },
            set: function set(a, c, d) {
              var e = d && Ia(a);
              return Wa(a, c, d ? Xa(a, b, d, k.boxSizing && "border-box" === m.css(a, "boxSizing", !1, e), e) : 0);
            }
          };
        }), k.opacity || (m.cssHooks.opacity = {
          get: function get(a, b) {
            return Na.test((b && a.currentStyle ? a.currentStyle.filter : a.style.filter) || "") ? .01 * parseFloat(RegExp.$1) + "" : b ? "1" : "";
          },
          set: function set(a, b) {
            var c = a.style,
              d = a.currentStyle,
              e = m.isNumeric(b) ? "alpha(opacity=" + 100 * b + ")" : "",
              f = d && d.filter || c.filter || "";
            c.zoom = 1, (b >= 1 || "" === b) && "" === m.trim(f.replace(Ma, "")) && c.removeAttribute && (c.removeAttribute("filter"), "" === b || d && !d.filter) || (c.filter = Ma.test(f) ? f.replace(Ma, e) : f + " " + e);
          }
        }), m.cssHooks.marginRight = La(k.reliableMarginRight, function (a, b) {
          return b ? m.swap(a, {
            display: "inline-block"
          }, Ja, [a, "marginRight"]) : void 0;
        }), m.each({
          margin: "",
          padding: "",
          border: "Width"
        }, function (a, b) {
          m.cssHooks[a + b] = {
            expand: function expand(c) {
              for (var d = 0, e = {}, f = "string" == typeof c ? c.split(" ") : [c]; 4 > d; d++) {
                e[a + T[d] + b] = f[d] || f[d - 2] || f[0];
              }
              return e;
            }
          }, Ga.test(a) || (m.cssHooks[a + b].set = Wa);
        }), m.fn.extend({
          css: function css(a, b) {
            return V(this, function (a, b, c) {
              var d,
                e,
                f = {},
                g = 0;
              if (m.isArray(b)) {
                for (d = Ia(a), e = b.length; e > g; g++) {
                  f[b[g]] = m.css(a, b[g], !1, d);
                }
                return f;
              }
              return void 0 !== c ? m.style(a, b, c) : m.css(a, b);
            }, a, b, arguments.length > 1);
          },
          show: function show() {
            return Va(this, !0);
          },
          hide: function hide() {
            return Va(this);
          },
          toggle: function toggle(a) {
            return "boolean" == typeof a ? a ? this.show() : this.hide() : this.each(function () {
              U(this) ? m(this).show() : m(this).hide();
            });
          }
        });
        function Za(a, b, c, d, e) {
          return new Za.prototype.init(a, b, c, d, e);
        }
        m.Tween = Za, Za.prototype = {
          constructor: Za,
          init: function init(a, b, c, d, e, f) {
            this.elem = a, this.prop = c, this.easing = e || "swing", this.options = b, this.start = this.now = this.cur(), this.end = d, this.unit = f || (m.cssNumber[c] ? "" : "px");
          },
          cur: function cur() {
            var a = Za.propHooks[this.prop];
            return a && a.get ? a.get(this) : Za.propHooks._default.get(this);
          },
          run: function run(a) {
            var b,
              c = Za.propHooks[this.prop];
            return this.options.duration ? this.pos = b = m.easing[this.easing](a, this.options.duration * a, 0, 1, this.options.duration) : this.pos = b = a, this.now = (this.end - this.start) * b + this.start, this.options.step && this.options.step.call(this.elem, this.now, this), c && c.set ? c.set(this) : Za.propHooks._default.set(this), this;
          }
        }, Za.prototype.init.prototype = Za.prototype, Za.propHooks = {
          _default: {
            get: function get(a) {
              var b;
              return null == a.elem[a.prop] || a.elem.style && null != a.elem.style[a.prop] ? (b = m.css(a.elem, a.prop, ""), b && "auto" !== b ? b : 0) : a.elem[a.prop];
            },
            set: function set(a) {
              m.fx.step[a.prop] ? m.fx.step[a.prop](a) : a.elem.style && (null != a.elem.style[m.cssProps[a.prop]] || m.cssHooks[a.prop]) ? m.style(a.elem, a.prop, a.now + a.unit) : a.elem[a.prop] = a.now;
            }
          }
        }, Za.propHooks.scrollTop = Za.propHooks.scrollLeft = {
          set: function set(a) {
            a.elem.nodeType && a.elem.parentNode && (a.elem[a.prop] = a.now);
          }
        }, m.easing = {
          linear: function linear(a) {
            return a;
          },
          swing: function swing(a) {
            return .5 - Math.cos(a * Math.PI) / 2;
          }
        }, m.fx = Za.prototype.init, m.fx.step = {};
        var $a,
          _a,
          ab = /^(?:toggle|show|hide)$/,
          bb = new RegExp("^(?:([+-])=|)(" + S + ")([a-z%]*)$", "i"),
          cb = /queueHooks$/,
          db = [ib],
          eb = {
            "*": [function (a, b) {
              var c = this.createTween(a, b),
                d = c.cur(),
                e = bb.exec(b),
                f = e && e[3] || (m.cssNumber[a] ? "" : "px"),
                g = (m.cssNumber[a] || "px" !== f && +d) && bb.exec(m.css(c.elem, a)),
                h = 1,
                i = 20;
              if (g && g[3] !== f) {
                f = f || g[3], e = e || [], g = +d || 1;
                do {
                  h = h || ".5", g /= h, m.style(c.elem, a, g + f);
                } while (h !== (h = c.cur() / d) && 1 !== h && --i);
              }
              return e && (g = c.start = +g || +d || 0, c.unit = f, c.end = e[1] ? g + (e[1] + 1) * e[2] : +e[2]), c;
            }]
          };
        function fb() {
          return setTimeout(function () {
            $a = void 0;
          }), $a = m.now();
        }
        function gb(a, b) {
          var c,
            d = {
              height: a
            },
            e = 0;
          for (b = b ? 1 : 0; 4 > e; e += 2 - b) {
            c = T[e], d["margin" + c] = d["padding" + c] = a;
          }
          return b && (d.opacity = d.width = a), d;
        }
        function hb(a, b, c) {
          for (var d, e = (eb[b] || []).concat(eb["*"]), f = 0, g = e.length; g > f; f++) {
            if (d = e[f].call(c, b, a)) return d;
          }
        }
        function ib(a, b, c) {
          var d,
            e,
            f,
            g,
            h,
            i,
            j,
            l,
            n = this,
            o = {},
            p = a.style,
            q = a.nodeType && U(a),
            r = m._data(a, "fxshow");
          c.queue || (h = m._queueHooks(a, "fx"), null == h.unqueued && (h.unqueued = 0, i = h.empty.fire, h.empty.fire = function () {
            h.unqueued || i();
          }), h.unqueued++, n.always(function () {
            n.always(function () {
              h.unqueued--, m.queue(a, "fx").length || h.empty.fire();
            });
          })), 1 === a.nodeType && ("height" in b || "width" in b) && (c.overflow = [p.overflow, p.overflowX, p.overflowY], j = m.css(a, "display"), l = "none" === j ? m._data(a, "olddisplay") || Fa(a.nodeName) : j, "inline" === l && "none" === m.css(a, "float") && (k.inlineBlockNeedsLayout && "inline" !== Fa(a.nodeName) ? p.zoom = 1 : p.display = "inline-block")), c.overflow && (p.overflow = "hidden", k.shrinkWrapBlocks() || n.always(function () {
            p.overflow = c.overflow[0], p.overflowX = c.overflow[1], p.overflowY = c.overflow[2];
          }));
          for (d in b) {
            if (e = b[d], ab.exec(e)) {
              if (delete b[d], f = f || "toggle" === e, e === (q ? "hide" : "show")) {
                if ("show" !== e || !r || void 0 === r[d]) continue;
                q = !0;
              }
              o[d] = r && r[d] || m.style(a, d);
            } else j = void 0;
          }
          if (m.isEmptyObject(o)) "inline" === ("none" === j ? Fa(a.nodeName) : j) && (p.display = j);else {
            r ? "hidden" in r && (q = r.hidden) : r = m._data(a, "fxshow", {}), f && (r.hidden = !q), q ? m(a).show() : n.done(function () {
              m(a).hide();
            }), n.done(function () {
              var b;
              m._removeData(a, "fxshow");
              for (b in o) {
                m.style(a, b, o[b]);
              }
            });
            for (d in o) {
              g = hb(q ? r[d] : 0, d, n), d in r || (r[d] = g.start, q && (g.end = g.start, g.start = "width" === d || "height" === d ? 1 : 0));
            }
          }
        }
        function jb(a, b) {
          var c, d, e, f, g;
          for (c in a) {
            if (d = m.camelCase(c), e = b[d], f = a[c], m.isArray(f) && (e = f[1], f = a[c] = f[0]), c !== d && (a[d] = f, delete a[c]), g = m.cssHooks[d], g && "expand" in g) {
              f = g.expand(f), delete a[d];
              for (c in f) {
                c in a || (a[c] = f[c], b[c] = e);
              }
            } else b[d] = e;
          }
        }
        function kb(a, b, c) {
          var d,
            e,
            f = 0,
            g = db.length,
            h = m.Deferred().always(function () {
              delete i.elem;
            }),
            i = function i() {
              if (e) return !1;
              for (var b = $a || fb(), c = Math.max(0, j.startTime + j.duration - b), d = c / j.duration || 0, f = 1 - d, g = 0, i = j.tweens.length; i > g; g++) {
                j.tweens[g].run(f);
              }
              return h.notifyWith(a, [j, f, c]), 1 > f && i ? c : (h.resolveWith(a, [j]), !1);
            },
            j = h.promise({
              elem: a,
              props: m.extend({}, b),
              opts: m.extend(!0, {
                specialEasing: {}
              }, c),
              originalProperties: b,
              originalOptions: c,
              startTime: $a || fb(),
              duration: c.duration,
              tweens: [],
              createTween: function createTween(b, c) {
                var d = m.Tween(a, j.opts, b, c, j.opts.specialEasing[b] || j.opts.easing);
                return j.tweens.push(d), d;
              },
              stop: function stop(b) {
                var c = 0,
                  d = b ? j.tweens.length : 0;
                if (e) return this;
                for (e = !0; d > c; c++) {
                  j.tweens[c].run(1);
                }
                return b ? h.resolveWith(a, [j, b]) : h.rejectWith(a, [j, b]), this;
              }
            }),
            k = j.props;
          for (jb(k, j.opts.specialEasing); g > f; f++) {
            if (d = db[f].call(j, a, k, j.opts)) return d;
          }
          return m.map(k, hb, j), m.isFunction(j.opts.start) && j.opts.start.call(a, j), m.fx.timer(m.extend(i, {
            elem: a,
            anim: j,
            queue: j.opts.queue
          })), j.progress(j.opts.progress).done(j.opts.done, j.opts.complete).fail(j.opts.fail).always(j.opts.always);
        }
        m.Animation = m.extend(kb, {
          tweener: function tweener(a, b) {
            m.isFunction(a) ? (b = a, a = ["*"]) : a = a.split(" ");
            for (var c, d = 0, e = a.length; e > d; d++) {
              c = a[d], eb[c] = eb[c] || [], eb[c].unshift(b);
            }
          },
          prefilter: function prefilter(a, b) {
            b ? db.unshift(a) : db.push(a);
          }
        }), m.speed = function (a, b, c) {
          var d = a && "object" == _typeof(a) ? m.extend({}, a) : {
            complete: c || !c && b || m.isFunction(a) && a,
            duration: a,
            easing: c && b || b && !m.isFunction(b) && b
          };
          return d.duration = m.fx.off ? 0 : "number" == typeof d.duration ? d.duration : d.duration in m.fx.speeds ? m.fx.speeds[d.duration] : m.fx.speeds._default, (null == d.queue || d.queue === !0) && (d.queue = "fx"), d.old = d.complete, d.complete = function () {
            m.isFunction(d.old) && d.old.call(this), d.queue && m.dequeue(this, d.queue);
          }, d;
        }, m.fn.extend({
          fadeTo: function fadeTo(a, b, c, d) {
            return this.filter(U).css("opacity", 0).show().end().animate({
              opacity: b
            }, a, c, d);
          },
          animate: function animate(a, b, c, d) {
            var e = m.isEmptyObject(a),
              f = m.speed(b, c, d),
              g = function g() {
                var b = kb(this, m.extend({}, a), f);
                (e || m._data(this, "finish")) && b.stop(!0);
              };
            return g.finish = g, e || f.queue === !1 ? this.each(g) : this.queue(f.queue, g);
          },
          stop: function stop(a, b, c) {
            var d = function d(a) {
              var b = a.stop;
              delete a.stop, b(c);
            };
            return "string" != typeof a && (c = b, b = a, a = void 0), b && a !== !1 && this.queue(a || "fx", []), this.each(function () {
              var b = !0,
                e = null != a && a + "queueHooks",
                f = m.timers,
                g = m._data(this);
              if (e) g[e] && g[e].stop && d(g[e]);else for (e in g) {
                g[e] && g[e].stop && cb.test(e) && d(g[e]);
              }
              for (e = f.length; e--;) {
                f[e].elem !== this || null != a && f[e].queue !== a || (f[e].anim.stop(c), b = !1, f.splice(e, 1));
              }
              (b || !c) && m.dequeue(this, a);
            });
          },
          finish: function finish(a) {
            return a !== !1 && (a = a || "fx"), this.each(function () {
              var b,
                c = m._data(this),
                d = c[a + "queue"],
                e = c[a + "queueHooks"],
                f = m.timers,
                g = d ? d.length : 0;
              for (c.finish = !0, m.queue(this, a, []), e && e.stop && e.stop.call(this, !0), b = f.length; b--;) {
                f[b].elem === this && f[b].queue === a && (f[b].anim.stop(!0), f.splice(b, 1));
              }
              for (b = 0; g > b; b++) {
                d[b] && d[b].finish && d[b].finish.call(this);
              }
              delete c.finish;
            });
          }
        }), m.each(["toggle", "show", "hide"], function (a, b) {
          var c = m.fn[b];
          m.fn[b] = function (a, d, e) {
            return null == a || "boolean" == typeof a ? c.apply(this, arguments) : this.animate(gb(b, !0), a, d, e);
          };
        }), m.each({
          slideDown: gb("show"),
          slideUp: gb("hide"),
          slideToggle: gb("toggle"),
          fadeIn: {
            opacity: "show"
          },
          fadeOut: {
            opacity: "hide"
          },
          fadeToggle: {
            opacity: "toggle"
          }
        }, function (a, b) {
          m.fn[a] = function (a, c, d) {
            return this.animate(b, a, c, d);
          };
        }), m.timers = [], m.fx.tick = function () {
          var a,
            b = m.timers,
            c = 0;
          for ($a = m.now(); c < b.length; c++) {
            a = b[c], a() || b[c] !== a || b.splice(c--, 1);
          }
          b.length || m.fx.stop(), $a = void 0;
        }, m.fx.timer = function (a) {
          m.timers.push(a), a() ? m.fx.start() : m.timers.pop();
        }, m.fx.interval = 13, m.fx.start = function () {
          _a || (_a = setInterval(m.fx.tick, m.fx.interval));
        }, m.fx.stop = function () {
          clearInterval(_a), _a = null;
        }, m.fx.speeds = {
          slow: 600,
          fast: 200,
          _default: 400
        }, m.fn.delay = function (a, b) {
          return a = m.fx ? m.fx.speeds[a] || a : a, b = b || "fx", this.queue(b, function (b, c) {
            var d = setTimeout(b, a);
            c.stop = function () {
              clearTimeout(d);
            };
          });
        }, function () {
          var a, b, c, d, e;
          b = y.createElement("div"), b.setAttribute("className", "t"), b.innerHTML = "  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>", d = b.getElementsByTagName("a")[0], c = y.createElement("select"), e = c.appendChild(y.createElement("option")), a = b.getElementsByTagName("input")[0], d.style.cssText = "top:1px", k.getSetAttribute = "t" !== b.className, k.style = /top/.test(d.getAttribute("style")), k.hrefNormalized = "/a" === d.getAttribute("href"), k.checkOn = !!a.value, k.optSelected = e.selected, k.enctype = !!y.createElement("form").enctype, c.disabled = !0, k.optDisabled = !e.disabled, a = y.createElement("input"), a.setAttribute("value", ""), k.input = "" === a.getAttribute("value"), a.value = "t", a.setAttribute("type", "radio"), k.radioValue = "t" === a.value;
        }();
        var lb = /\r/g;
        m.fn.extend({
          val: function val(a) {
            var b,
              c,
              d,
              e = this[0];
            {
              if (arguments.length) return d = m.isFunction(a), this.each(function (c) {
                var e;
                1 === this.nodeType && (e = d ? a.call(this, c, m(this).val()) : a, null == e ? e = "" : "number" == typeof e ? e += "" : m.isArray(e) && (e = m.map(e, function (a) {
                  return null == a ? "" : a + "";
                })), b = m.valHooks[this.type] || m.valHooks[this.nodeName.toLowerCase()], b && "set" in b && void 0 !== b.set(this, e, "value") || (this.value = e));
              });
              if (e) return b = m.valHooks[e.type] || m.valHooks[e.nodeName.toLowerCase()], b && "get" in b && void 0 !== (c = b.get(e, "value")) ? c : (c = e.value, "string" == typeof c ? c.replace(lb, "") : null == c ? "" : c);
            }
          }
        }), m.extend({
          valHooks: {
            option: {
              get: function get(a) {
                var b = m.find.attr(a, "value");
                return null != b ? b : m.trim(m.text(a));
              }
            },
            select: {
              get: function get(a) {
                for (var b, c, d = a.options, e = a.selectedIndex, f = "select-one" === a.type || 0 > e, g = f ? null : [], h = f ? e + 1 : d.length, i = 0 > e ? h : f ? e : 0; h > i; i++) {
                  if (c = d[i], !(!c.selected && i !== e || (k.optDisabled ? c.disabled : null !== c.getAttribute("disabled")) || c.parentNode.disabled && m.nodeName(c.parentNode, "optgroup"))) {
                    if (b = m(c).val(), f) return b;
                    g.push(b);
                  }
                }
                return g;
              },
              set: function set(a, b) {
                var c,
                  d,
                  e = a.options,
                  f = m.makeArray(b),
                  g = e.length;
                while (g--) {
                  if (d = e[g], m.inArray(m.valHooks.option.get(d), f) >= 0) try {
                    d.selected = c = !0;
                  } catch (h) {
                    d.scrollHeight;
                  } else d.selected = !1;
                }
                return c || (a.selectedIndex = -1), e;
              }
            }
          }
        }), m.each(["radio", "checkbox"], function () {
          m.valHooks[this] = {
            set: function set(a, b) {
              return m.isArray(b) ? a.checked = m.inArray(m(a).val(), b) >= 0 : void 0;
            }
          }, k.checkOn || (m.valHooks[this].get = function (a) {
            return null === a.getAttribute("value") ? "on" : a.value;
          });
        });
        var mb,
          nb,
          ob = m.expr.attrHandle,
          pb = /^(?:checked|selected)$/i,
          qb = k.getSetAttribute,
          rb = k.input;
        m.fn.extend({
          attr: function attr(a, b) {
            return V(this, m.attr, a, b, arguments.length > 1);
          },
          removeAttr: function removeAttr(a) {
            return this.each(function () {
              m.removeAttr(this, a);
            });
          }
        }), m.extend({
          attr: function attr(a, b, c) {
            var d,
              e,
              f = a.nodeType;
            if (a && 3 !== f && 8 !== f && 2 !== f) return _typeof(a.getAttribute) === K ? m.prop(a, b, c) : (1 === f && m.isXMLDoc(a) || (b = b.toLowerCase(), d = m.attrHooks[b] || (m.expr.match.bool.test(b) ? nb : mb)), void 0 === c ? d && "get" in d && null !== (e = d.get(a, b)) ? e : (e = m.find.attr(a, b), null == e ? void 0 : e) : null !== c ? d && "set" in d && void 0 !== (e = d.set(a, c, b)) ? e : (a.setAttribute(b, c + ""), c) : void m.removeAttr(a, b));
          },
          removeAttr: function removeAttr(a, b) {
            var c,
              d,
              e = 0,
              f = b && b.match(E);
            if (f && 1 === a.nodeType) while (c = f[e++]) {
              d = m.propFix[c] || c, m.expr.match.bool.test(c) ? rb && qb || !pb.test(c) ? a[d] = !1 : a[m.camelCase("default-" + c)] = a[d] = !1 : m.attr(a, c, ""), a.removeAttribute(qb ? c : d);
            }
          },
          attrHooks: {
            type: {
              set: function set(a, b) {
                if (!k.radioValue && "radio" === b && m.nodeName(a, "input")) {
                  var c = a.value;
                  return a.setAttribute("type", b), c && (a.value = c), b;
                }
              }
            }
          }
        }), nb = {
          set: function set(a, b, c) {
            return b === !1 ? m.removeAttr(a, c) : rb && qb || !pb.test(c) ? a.setAttribute(!qb && m.propFix[c] || c, c) : a[m.camelCase("default-" + c)] = a[c] = !0, c;
          }
        }, m.each(m.expr.match.bool.source.match(/\w+/g), function (a, b) {
          var c = ob[b] || m.find.attr;
          ob[b] = rb && qb || !pb.test(b) ? function (a, b, d) {
            var e, f;
            return d || (f = ob[b], ob[b] = e, e = null != c(a, b, d) ? b.toLowerCase() : null, ob[b] = f), e;
          } : function (a, b, c) {
            return c ? void 0 : a[m.camelCase("default-" + b)] ? b.toLowerCase() : null;
          };
        }), rb && qb || (m.attrHooks.value = {
          set: function set(a, b, c) {
            return m.nodeName(a, "input") ? void (a.defaultValue = b) : mb && mb.set(a, b, c);
          }
        }), qb || (mb = {
          set: function set(a, b, c) {
            var d = a.getAttributeNode(c);
            return d || a.setAttributeNode(d = a.ownerDocument.createAttribute(c)), d.value = b += "", "value" === c || b === a.getAttribute(c) ? b : void 0;
          }
        }, ob.id = ob.name = ob.coords = function (a, b, c) {
          var d;
          return c ? void 0 : (d = a.getAttributeNode(b)) && "" !== d.value ? d.value : null;
        }, m.valHooks.button = {
          get: function get(a, b) {
            var c = a.getAttributeNode(b);
            return c && c.specified ? c.value : void 0;
          },
          set: mb.set
        }, m.attrHooks.contenteditable = {
          set: function set(a, b, c) {
            mb.set(a, "" === b ? !1 : b, c);
          }
        }, m.each(["width", "height"], function (a, b) {
          m.attrHooks[b] = {
            set: function set(a, c) {
              return "" === c ? (a.setAttribute(b, "auto"), c) : void 0;
            }
          };
        })), k.style || (m.attrHooks.style = {
          get: function get(a) {
            return a.style.cssText || void 0;
          },
          set: function set(a, b) {
            return a.style.cssText = b + "";
          }
        });
        var sb = /^(?:input|select|textarea|button|object)$/i,
          tb = /^(?:a|area)$/i;
        m.fn.extend({
          prop: function prop(a, b) {
            return V(this, m.prop, a, b, arguments.length > 1);
          },
          removeProp: function removeProp(a) {
            return a = m.propFix[a] || a, this.each(function () {
              try {
                this[a] = void 0, delete this[a];
              } catch (b) {}
            });
          }
        }), m.extend({
          propFix: {
            "for": "htmlFor",
            "class": "className"
          },
          prop: function prop(a, b, c) {
            var d,
              e,
              f,
              g = a.nodeType;
            if (a && 3 !== g && 8 !== g && 2 !== g) return f = 1 !== g || !m.isXMLDoc(a), f && (b = m.propFix[b] || b, e = m.propHooks[b]), void 0 !== c ? e && "set" in e && void 0 !== (d = e.set(a, c, b)) ? d : a[b] = c : e && "get" in e && null !== (d = e.get(a, b)) ? d : a[b];
          },
          propHooks: {
            tabIndex: {
              get: function get(a) {
                var b = m.find.attr(a, "tabindex");
                return b ? parseInt(b, 10) : sb.test(a.nodeName) || tb.test(a.nodeName) && a.href ? 0 : -1;
              }
            }
          }
        }), k.hrefNormalized || m.each(["href", "src"], function (a, b) {
          m.propHooks[b] = {
            get: function get(a) {
              return a.getAttribute(b, 4);
            }
          };
        }), k.optSelected || (m.propHooks.selected = {
          get: function get(a) {
            var b = a.parentNode;
            return b && (b.selectedIndex, b.parentNode && b.parentNode.selectedIndex), null;
          }
        }), m.each(["tabIndex", "readOnly", "maxLength", "cellSpacing", "cellPadding", "rowSpan", "colSpan", "useMap", "frameBorder", "contentEditable"], function () {
          m.propFix[this.toLowerCase()] = this;
        }), k.enctype || (m.propFix.enctype = "encoding");
        var ub = /[\t\r\n\f]/g;
        m.fn.extend({
          addClass: function addClass(a) {
            var b,
              c,
              d,
              e,
              f,
              g,
              h = 0,
              i = this.length,
              j = "string" == typeof a && a;
            if (m.isFunction(a)) return this.each(function (b) {
              m(this).addClass(a.call(this, b, this.className));
            });
            if (j) for (b = (a || "").match(E) || []; i > h; h++) {
              if (c = this[h], d = 1 === c.nodeType && (c.className ? (" " + c.className + " ").replace(ub, " ") : " ")) {
                f = 0;
                while (e = b[f++]) {
                  d.indexOf(" " + e + " ") < 0 && (d += e + " ");
                }
                g = m.trim(d), c.className !== g && (c.className = g);
              }
            }
            return this;
          },
          removeClass: function removeClass(a) {
            var b,
              c,
              d,
              e,
              f,
              g,
              h = 0,
              i = this.length,
              j = 0 === arguments.length || "string" == typeof a && a;
            if (m.isFunction(a)) return this.each(function (b) {
              m(this).removeClass(a.call(this, b, this.className));
            });
            if (j) for (b = (a || "").match(E) || []; i > h; h++) {
              if (c = this[h], d = 1 === c.nodeType && (c.className ? (" " + c.className + " ").replace(ub, " ") : "")) {
                f = 0;
                while (e = b[f++]) {
                  while (d.indexOf(" " + e + " ") >= 0) {
                    d = d.replace(" " + e + " ", " ");
                  }
                }
                g = a ? m.trim(d) : "", c.className !== g && (c.className = g);
              }
            }
            return this;
          },
          toggleClass: function toggleClass(a, b) {
            var c = _typeof(a);
            return "boolean" == typeof b && "string" === c ? b ? this.addClass(a) : this.removeClass(a) : this.each(m.isFunction(a) ? function (c) {
              m(this).toggleClass(a.call(this, c, this.className, b), b);
            } : function () {
              if ("string" === c) {
                var b,
                  d = 0,
                  e = m(this),
                  f = a.match(E) || [];
                while (b = f[d++]) {
                  e.hasClass(b) ? e.removeClass(b) : e.addClass(b);
                }
              } else (c === K || "boolean" === c) && (this.className && m._data(this, "__className__", this.className), this.className = this.className || a === !1 ? "" : m._data(this, "__className__") || "");
            });
          },
          hasClass: function hasClass(a) {
            for (var b = " " + a + " ", c = 0, d = this.length; d > c; c++) {
              if (1 === this[c].nodeType && (" " + this[c].className + " ").replace(ub, " ").indexOf(b) >= 0) return !0;
            }
            return !1;
          }
        }), m.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "), function (a, b) {
          m.fn[b] = function (a, c) {
            return arguments.length > 0 ? this.on(b, null, a, c) : this.trigger(b);
          };
        }), m.fn.extend({
          hover: function hover(a, b) {
            return this.mouseenter(a).mouseleave(b || a);
          },
          bind: function bind(a, b, c) {
            return this.on(a, null, b, c);
          },
          unbind: function unbind(a, b) {
            return this.off(a, null, b);
          },
          delegate: function delegate(a, b, c, d) {
            return this.on(b, a, c, d);
          },
          undelegate: function undelegate(a, b, c) {
            return 1 === arguments.length ? this.off(a, "**") : this.off(b, a || "**", c);
          }
        });
        var vb = m.now(),
          wb = /\?/,
          xb = /(,)|(\[|{)|(}|])|"(?:[^"\\\r\n]|\\["\\\/bfnrt]|\\u[\da-fA-F]{4})*"\s*:?|true|false|null|-?(?!0\d)\d+(?:\.\d+|)(?:[eE][+-]?\d+|)/g;
        m.parseJSON = function (b) {
          if (a.JSON && a.JSON.parse) return a.JSON.parse(b + "");
          var c,
            d = null,
            e = m.trim(b + "");
          return e && !m.trim(e.replace(xb, function (a, b, e, f) {
            return c && b && (d = 0), 0 === d ? a : (c = e || b, d += !f - !e, "");
          })) ? Function("return " + e)() : m.error("Invalid JSON: " + b);
        }, m.parseXML = function (b) {
          var c, d;
          if (!b || "string" != typeof b) return null;
          try {
            a.DOMParser ? (d = new DOMParser(), c = d.parseFromString(b, "text/xml")) : (c = new ActiveXObject("Microsoft.XMLDOM"), c.async = "false", c.loadXML(b));
          } catch (e) {
            c = void 0;
          }
          return c && c.documentElement && !c.getElementsByTagName("parsererror").length || m.error("Invalid XML: " + b), c;
        };
        var yb,
          zb,
          Ab = /#.*$/,
          Bb = /([?&])_=[^&]*/,
          Cb = /^(.*?):[ \t]*([^\r\n]*)\r?$/gm,
          Db = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/,
          Eb = /^(?:GET|HEAD)$/,
          Fb = /^\/\//,
          Gb = /^([\w.+-]+:)(?:\/\/(?:[^\/?#]*@|)([^\/?#:]*)(?::(\d+)|)|)/,
          Hb = {},
          Ib = {},
          Jb = "*/".concat("*");
        try {
          zb = location.href;
        } catch (Kb) {
          zb = y.createElement("a"), zb.href = "", zb = zb.href;
        }
        yb = Gb.exec(zb.toLowerCase()) || [];
        function Lb(a) {
          return function (b, c) {
            "string" != typeof b && (c = b, b = "*");
            var d,
              e = 0,
              f = b.toLowerCase().match(E) || [];
            if (m.isFunction(c)) while (d = f[e++]) {
              "+" === d.charAt(0) ? (d = d.slice(1) || "*", (a[d] = a[d] || []).unshift(c)) : (a[d] = a[d] || []).push(c);
            }
          };
        }
        function Mb(a, b, c, d) {
          var e = {},
            f = a === Ib;
          function g(h) {
            var i;
            return e[h] = !0, m.each(a[h] || [], function (a, h) {
              var j = h(b, c, d);
              return "string" != typeof j || f || e[j] ? f ? !(i = j) : void 0 : (b.dataTypes.unshift(j), g(j), !1);
            }), i;
          }
          return g(b.dataTypes[0]) || !e["*"] && g("*");
        }
        function Nb(a, b) {
          var c,
            d,
            e = m.ajaxSettings.flatOptions || {};
          for (d in b) {
            void 0 !== b[d] && ((e[d] ? a : c || (c = {}))[d] = b[d]);
          }
          return c && m.extend(!0, a, c), a;
        }
        function Ob(a, b, c) {
          var d,
            e,
            f,
            g,
            h = a.contents,
            i = a.dataTypes;
          while ("*" === i[0]) {
            i.shift(), void 0 === e && (e = a.mimeType || b.getResponseHeader("Content-Type"));
          }
          if (e) for (g in h) {
            if (h[g] && h[g].test(e)) {
              i.unshift(g);
              break;
            }
          }
          if (i[0] in c) f = i[0];else {
            for (g in c) {
              if (!i[0] || a.converters[g + " " + i[0]]) {
                f = g;
                break;
              }
              d || (d = g);
            }
            f = f || d;
          }
          return f ? (f !== i[0] && i.unshift(f), c[f]) : void 0;
        }
        function Pb(a, b, c, d) {
          var e,
            f,
            g,
            h,
            i,
            j = {},
            k = a.dataTypes.slice();
          if (k[1]) for (g in a.converters) {
            j[g.toLowerCase()] = a.converters[g];
          }
          f = k.shift();
          while (f) {
            if (a.responseFields[f] && (c[a.responseFields[f]] = b), !i && d && a.dataFilter && (b = a.dataFilter(b, a.dataType)), i = f, f = k.shift()) if ("*" === f) f = i;else if ("*" !== i && i !== f) {
              if (g = j[i + " " + f] || j["* " + f], !g) for (e in j) {
                if (h = e.split(" "), h[1] === f && (g = j[i + " " + h[0]] || j["* " + h[0]])) {
                  g === !0 ? g = j[e] : j[e] !== !0 && (f = h[0], k.unshift(h[1]));
                  break;
                }
              }
              if (g !== !0) if (g && a["throws"]) b = g(b);else try {
                b = g(b);
              } catch (l) {
                return {
                  state: "parsererror",
                  error: g ? l : "No conversion from " + i + " to " + f
                };
              }
            }
          }
          return {
            state: "success",
            data: b
          };
        }
        m.extend({
          active: 0,
          lastModified: {},
          etag: {},
          ajaxSettings: {
            url: zb,
            type: "GET",
            isLocal: Db.test(yb[1]),
            global: !0,
            processData: !0,
            async: !0,
            contentType: "application/x-www-form-urlencoded; charset=UTF-8",
            accepts: {
              "*": Jb,
              text: "text/plain",
              html: "text/html",
              xml: "application/xml, text/xml",
              json: "application/json, text/javascript"
            },
            contents: {
              xml: /xml/,
              html: /html/,
              json: /json/
            },
            responseFields: {
              xml: "responseXML",
              text: "responseText",
              json: "responseJSON"
            },
            converters: {
              "* text": String,
              "text html": !0,
              "text json": m.parseJSON,
              "text xml": m.parseXML
            },
            flatOptions: {
              url: !0,
              context: !0
            }
          },
          ajaxSetup: function ajaxSetup(a, b) {
            return b ? Nb(Nb(a, m.ajaxSettings), b) : Nb(m.ajaxSettings, a);
          },
          ajaxPrefilter: Lb(Hb),
          ajaxTransport: Lb(Ib),
          ajax: function ajax(a, b) {
            "object" == _typeof(a) && (b = a, a = void 0), b = b || {};
            var c,
              d,
              e,
              f,
              g,
              h,
              i,
              j,
              k = m.ajaxSetup({}, b),
              l = k.context || k,
              n = k.context && (l.nodeType || l.jquery) ? m(l) : m.event,
              o = m.Deferred(),
              p = m.Callbacks("once memory"),
              q = k.statusCode || {},
              r = {},
              s = {},
              t = 0,
              u = "canceled",
              v = {
                readyState: 0,
                getResponseHeader: function getResponseHeader(a) {
                  var b;
                  if (2 === t) {
                    if (!j) {
                      j = {};
                      while (b = Cb.exec(f)) {
                        j[b[1].toLowerCase()] = b[2];
                      }
                    }
                    b = j[a.toLowerCase()];
                  }
                  return null == b ? null : b;
                },
                getAllResponseHeaders: function getAllResponseHeaders() {
                  return 2 === t ? f : null;
                },
                setRequestHeader: function setRequestHeader(a, b) {
                  var c = a.toLowerCase();
                  return t || (a = s[c] = s[c] || a, r[a] = b), this;
                },
                overrideMimeType: function overrideMimeType(a) {
                  return t || (k.mimeType = a), this;
                },
                statusCode: function statusCode(a) {
                  var b;
                  if (a) if (2 > t) for (b in a) {
                    q[b] = [q[b], a[b]];
                  } else v.always(a[v.status]);
                  return this;
                },
                abort: function abort(a) {
                  var b = a || u;
                  return i && i.abort(b), x(0, b), this;
                }
              };
            if (o.promise(v).complete = p.add, v.success = v.done, v.error = v.fail, k.url = ((a || k.url || zb) + "").replace(Ab, "").replace(Fb, yb[1] + "//"), k.type = b.method || b.type || k.method || k.type, k.dataTypes = m.trim(k.dataType || "*").toLowerCase().match(E) || [""], null == k.crossDomain && (c = Gb.exec(k.url.toLowerCase()), k.crossDomain = !(!c || c[1] === yb[1] && c[2] === yb[2] && (c[3] || ("http:" === c[1] ? "80" : "443")) === (yb[3] || ("http:" === yb[1] ? "80" : "443")))), k.data && k.processData && "string" != typeof k.data && (k.data = m.param(k.data, k.traditional)), Mb(Hb, k, b, v), 2 === t) return v;
            h = m.event && k.global, h && 0 === m.active++ && m.event.trigger("ajaxStart"), k.type = k.type.toUpperCase(), k.hasContent = !Eb.test(k.type), e = k.url, k.hasContent || (k.data && (e = k.url += (wb.test(e) ? "&" : "?") + k.data, delete k.data), k.cache === !1 && (k.url = Bb.test(e) ? e.replace(Bb, "$1_=" + vb++) : e + (wb.test(e) ? "&" : "?") + "_=" + vb++)), k.ifModified && (m.lastModified[e] && v.setRequestHeader("If-Modified-Since", m.lastModified[e]), m.etag[e] && v.setRequestHeader("If-None-Match", m.etag[e])), (k.data && k.hasContent && k.contentType !== !1 || b.contentType) && v.setRequestHeader("Content-Type", k.contentType), v.setRequestHeader("Accept", k.dataTypes[0] && k.accepts[k.dataTypes[0]] ? k.accepts[k.dataTypes[0]] + ("*" !== k.dataTypes[0] ? ", " + Jb + "; q=0.01" : "") : k.accepts["*"]);
            for (d in k.headers) {
              v.setRequestHeader(d, k.headers[d]);
            }
            if (k.beforeSend && (k.beforeSend.call(l, v, k) === !1 || 2 === t)) return v.abort();
            u = "abort";
            for (d in {
              success: 1,
              error: 1,
              complete: 1
            }) {
              v[d](k[d]);
            }
            if (i = Mb(Ib, k, b, v)) {
              v.readyState = 1, h && n.trigger("ajaxSend", [v, k]), k.async && k.timeout > 0 && (g = setTimeout(function () {
                v.abort("timeout");
              }, k.timeout));
              try {
                t = 1, i.send(r, x);
              } catch (w) {
                if (!(2 > t)) throw w;
                x(-1, w);
              }
            } else x(-1, "No Transport");
            function x(a, b, c, d) {
              var j,
                r,
                s,
                u,
                w,
                x = b;
              2 !== t && (t = 2, g && clearTimeout(g), i = void 0, f = d || "", v.readyState = a > 0 ? 4 : 0, j = a >= 200 && 300 > a || 304 === a, c && (u = Ob(k, v, c)), u = Pb(k, u, v, j), j ? (k.ifModified && (w = v.getResponseHeader("Last-Modified"), w && (m.lastModified[e] = w), w = v.getResponseHeader("etag"), w && (m.etag[e] = w)), 204 === a || "HEAD" === k.type ? x = "nocontent" : 304 === a ? x = "notmodified" : (x = u.state, r = u.data, s = u.error, j = !s)) : (s = x, (a || !x) && (x = "error", 0 > a && (a = 0))), v.status = a, v.statusText = (b || x) + "", j ? o.resolveWith(l, [r, x, v]) : o.rejectWith(l, [v, x, s]), v.statusCode(q), q = void 0, h && n.trigger(j ? "ajaxSuccess" : "ajaxError", [v, k, j ? r : s]), p.fireWith(l, [v, x]), h && (n.trigger("ajaxComplete", [v, k]), --m.active || m.event.trigger("ajaxStop")));
            }
            return v;
          },
          getJSON: function getJSON(a, b, c) {
            return m.get(a, b, c, "json");
          },
          getScript: function getScript(a, b) {
            return m.get(a, void 0, b, "script");
          }
        }), m.each(["get", "post"], function (a, b) {
          m[b] = function (a, c, d, e) {
            return m.isFunction(c) && (e = e || d, d = c, c = void 0), m.ajax({
              url: a,
              type: b,
              dataType: e,
              data: c,
              success: d
            });
          };
        }), m._evalUrl = function (a) {
          return m.ajax({
            url: a,
            type: "GET",
            dataType: "script",
            async: !1,
            global: !1,
            "throws": !0
          });
        }, m.fn.extend({
          wrapAll: function wrapAll(a) {
            if (m.isFunction(a)) return this.each(function (b) {
              m(this).wrapAll(a.call(this, b));
            });
            if (this[0]) {
              var b = m(a, this[0].ownerDocument).eq(0).clone(!0);
              this[0].parentNode && b.insertBefore(this[0]), b.map(function () {
                var a = this;
                while (a.firstChild && 1 === a.firstChild.nodeType) {
                  a = a.firstChild;
                }
                return a;
              }).append(this);
            }
            return this;
          },
          wrapInner: function wrapInner(a) {
            return this.each(m.isFunction(a) ? function (b) {
              m(this).wrapInner(a.call(this, b));
            } : function () {
              var b = m(this),
                c = b.contents();
              c.length ? c.wrapAll(a) : b.append(a);
            });
          },
          wrap: function wrap(a) {
            var b = m.isFunction(a);
            return this.each(function (c) {
              m(this).wrapAll(b ? a.call(this, c) : a);
            });
          },
          unwrap: function unwrap() {
            return this.parent().each(function () {
              m.nodeName(this, "body") || m(this).replaceWith(this.childNodes);
            }).end();
          }
        }), m.expr.filters.hidden = function (a) {
          return a.offsetWidth <= 0 && a.offsetHeight <= 0 || !k.reliableHiddenOffsets() && "none" === (a.style && a.style.display || m.css(a, "display"));
        }, m.expr.filters.visible = function (a) {
          return !m.expr.filters.hidden(a);
        };
        var Qb = /%20/g,
          Rb = /\[\]$/,
          Sb = /\r?\n/g,
          Tb = /^(?:submit|button|image|reset|file)$/i,
          Ub = /^(?:input|select|textarea|keygen)/i;
        function Vb(a, b, c, d) {
          var e;
          if (m.isArray(b)) m.each(b, function (b, e) {
            c || Rb.test(a) ? d(a, e) : Vb(a + "[" + ("object" == _typeof(e) ? b : "") + "]", e, c, d);
          });else if (c || "object" !== m.type(b)) d(a, b);else for (e in b) {
            Vb(a + "[" + e + "]", b[e], c, d);
          }
        }
        m.param = function (a, b) {
          var c,
            d = [],
            e = function e(a, b) {
              b = m.isFunction(b) ? b() : null == b ? "" : b, d[d.length] = encodeURIComponent(a) + "=" + encodeURIComponent(b);
            };
          if (void 0 === b && (b = m.ajaxSettings && m.ajaxSettings.traditional), m.isArray(a) || a.jquery && !m.isPlainObject(a)) m.each(a, function () {
            e(this.name, this.value);
          });else for (c in a) {
            Vb(c, a[c], b, e);
          }
          return d.join("&").replace(Qb, "+");
        }, m.fn.extend({
          serialize: function serialize() {
            return m.param(this.serializeArray());
          },
          serializeArray: function serializeArray() {
            return this.map(function () {
              var a = m.prop(this, "elements");
              return a ? m.makeArray(a) : this;
            }).filter(function () {
              var a = this.type;
              return this.name && !m(this).is(":disabled") && Ub.test(this.nodeName) && !Tb.test(a) && (this.checked || !W.test(a));
            }).map(function (a, b) {
              var c = m(this).val();
              return null == c ? null : m.isArray(c) ? m.map(c, function (a) {
                return {
                  name: b.name,
                  value: a.replace(Sb, "\r\n")
                };
              }) : {
                name: b.name,
                value: c.replace(Sb, "\r\n")
              };
            }).get();
          }
        }), m.ajaxSettings.xhr = void 0 !== a.ActiveXObject ? function () {
          return !this.isLocal && /^(get|post|head|put|delete|options)$/i.test(this.type) && Zb() || $b();
        } : Zb;
        var Wb = 0,
          Xb = {},
          Yb = m.ajaxSettings.xhr();
        a.attachEvent && a.attachEvent("onunload", function () {
          for (var a in Xb) {
            Xb[a](void 0, !0);
          }
        }), k.cors = !!Yb && "withCredentials" in Yb, Yb = k.ajax = !!Yb, Yb && m.ajaxTransport(function (a) {
          if (!a.crossDomain || k.cors) {
            var _b3;
            return {
              send: function send(c, d) {
                var e,
                  f = a.xhr(),
                  g = ++Wb;
                if (f.open(a.type, a.url, a.async, a.username, a.password), a.xhrFields) for (e in a.xhrFields) {
                  f[e] = a.xhrFields[e];
                }
                a.mimeType && f.overrideMimeType && f.overrideMimeType(a.mimeType), a.crossDomain || c["X-Requested-With"] || (c["X-Requested-With"] = "XMLHttpRequest");
                for (e in c) {
                  void 0 !== c[e] && f.setRequestHeader(e, c[e] + "");
                }
                f.send(a.hasContent && a.data || null), _b3 = function b(c, e) {
                  var h, i, j;
                  if (_b3 && (e || 4 === f.readyState)) if (delete Xb[g], _b3 = void 0, f.onreadystatechange = m.noop, e) 4 !== f.readyState && f.abort();else {
                    j = {}, h = f.status, "string" == typeof f.responseText && (j.text = f.responseText);
                    try {
                      i = f.statusText;
                    } catch (k) {
                      i = "";
                    }
                    h || !a.isLocal || a.crossDomain ? 1223 === h && (h = 204) : h = j.text ? 200 : 404;
                  }
                  j && d(h, i, j, f.getAllResponseHeaders());
                }, a.async ? 4 === f.readyState ? setTimeout(_b3) : f.onreadystatechange = Xb[g] = _b3 : _b3();
              },
              abort: function abort() {
                _b3 && _b3(void 0, !0);
              }
            };
          }
        });
        function Zb() {
          try {
            return new a.XMLHttpRequest();
          } catch (b) {}
        }
        function $b() {
          try {
            return new a.ActiveXObject("Microsoft.XMLHTTP");
          } catch (b) {}
        }
        m.ajaxSetup({
          accepts: {
            script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
          },
          contents: {
            script: /(?:java|ecma)script/
          },
          converters: {
            "text script": function textScript(a) {
              return m.globalEval(a), a;
            }
          }
        }), m.ajaxPrefilter("script", function (a) {
          void 0 === a.cache && (a.cache = !1), a.crossDomain && (a.type = "GET", a.global = !1);
        }), m.ajaxTransport("script", function (a) {
          if (a.crossDomain) {
            var b,
              c = y.head || m("head")[0] || y.documentElement;
            return {
              send: function send(d, e) {
                b = y.createElement("script"), b.async = !0, a.scriptCharset && (b.charset = a.scriptCharset), b.src = a.url, b.onload = b.onreadystatechange = function (a, c) {
                  (c || !b.readyState || /loaded|complete/.test(b.readyState)) && (b.onload = b.onreadystatechange = null, b.parentNode && b.parentNode.removeChild(b), b = null, c || e(200, "success"));
                }, c.insertBefore(b, c.firstChild);
              },
              abort: function abort() {
                b && b.onload(void 0, !0);
              }
            };
          }
        });
        var _b = [],
          ac = /(=)\?(?=&|$)|\?\?/;
        m.ajaxSetup({
          jsonp: "callback",
          jsonpCallback: function jsonpCallback() {
            var a = _b.pop() || m.expando + "_" + vb++;
            return this[a] = !0, a;
          }
        }), m.ajaxPrefilter("json jsonp", function (b, c, d) {
          var e,
            f,
            g,
            h = b.jsonp !== !1 && (ac.test(b.url) ? "url" : "string" == typeof b.data && !(b.contentType || "").indexOf("application/x-www-form-urlencoded") && ac.test(b.data) && "data");
          return h || "jsonp" === b.dataTypes[0] ? (e = b.jsonpCallback = m.isFunction(b.jsonpCallback) ? b.jsonpCallback() : b.jsonpCallback, h ? b[h] = b[h].replace(ac, "$1" + e) : b.jsonp !== !1 && (b.url += (wb.test(b.url) ? "&" : "?") + b.jsonp + "=" + e), b.converters["script json"] = function () {
            return g || m.error(e + " was not called"), g[0];
          }, b.dataTypes[0] = "json", f = a[e], a[e] = function () {
            g = arguments;
          }, d.always(function () {
            a[e] = f, b[e] && (b.jsonpCallback = c.jsonpCallback, _b.push(e)), g && m.isFunction(f) && f(g[0]), g = f = void 0;
          }), "script") : void 0;
        }), m.parseHTML = function (a, b, c) {
          if (!a || "string" != typeof a) return null;
          "boolean" == typeof b && (c = b, b = !1), b = b || y;
          var d = u.exec(a),
            e = !c && [];
          return d ? [b.createElement(d[1])] : (d = m.buildFragment([a], b, e), e && e.length && m(e).remove(), m.merge([], d.childNodes));
        };
        var bc = m.fn.load;
        m.fn.load = function (a, b, c) {
          if ("string" != typeof a && bc) return bc.apply(this, arguments);
          var d,
            e,
            f,
            g = this,
            h = a.indexOf(" ");
          return h >= 0 && (d = m.trim(a.slice(h, a.length)), a = a.slice(0, h)), m.isFunction(b) ? (c = b, b = void 0) : b && "object" == _typeof(b) && (f = "POST"), g.length > 0 && m.ajax({
            url: a,
            type: f,
            dataType: "html",
            data: b
          }).done(function (a) {
            e = arguments, g.html(d ? m("<div>").append(m.parseHTML(a)).find(d) : a);
          }).complete(c && function (a, b) {
            g.each(c, e || [a.responseText, b, a]);
          }), this;
        }, m.each(["ajaxStart", "ajaxStop", "ajaxComplete", "ajaxError", "ajaxSuccess", "ajaxSend"], function (a, b) {
          m.fn[b] = function (a) {
            return this.on(b, a);
          };
        }), m.expr.filters.animated = function (a) {
          return m.grep(m.timers, function (b) {
            return a === b.elem;
          }).length;
        };
        var cc = a.document.documentElement;
        function dc(a) {
          return m.isWindow(a) ? a : 9 === a.nodeType ? a.defaultView || a.parentWindow : !1;
        }
        m.offset = {
          setOffset: function setOffset(a, b, c) {
            var d,
              e,
              f,
              g,
              h,
              i,
              j,
              k = m.css(a, "position"),
              l = m(a),
              n = {};
            "static" === k && (a.style.position = "relative"), h = l.offset(), f = m.css(a, "top"), i = m.css(a, "left"), j = ("absolute" === k || "fixed" === k) && m.inArray("auto", [f, i]) > -1, j ? (d = l.position(), g = d.top, e = d.left) : (g = parseFloat(f) || 0, e = parseFloat(i) || 0), m.isFunction(b) && (b = b.call(a, c, h)), null != b.top && (n.top = b.top - h.top + g), null != b.left && (n.left = b.left - h.left + e), "using" in b ? b.using.call(a, n) : l.css(n);
          }
        }, m.fn.extend({
          offset: function offset(a) {
            if (arguments.length) return void 0 === a ? this : this.each(function (b) {
              m.offset.setOffset(this, a, b);
            });
            var b,
              c,
              d = {
                top: 0,
                left: 0
              },
              e = this[0],
              f = e && e.ownerDocument;
            if (f) return b = f.documentElement, m.contains(b, e) ? (_typeof(e.getBoundingClientRect) !== K && (d = e.getBoundingClientRect()), c = dc(f), {
              top: d.top + (c.pageYOffset || b.scrollTop) - (b.clientTop || 0),
              left: d.left + (c.pageXOffset || b.scrollLeft) - (b.clientLeft || 0)
            }) : d;
          },
          position: function position() {
            if (this[0]) {
              var a,
                b,
                c = {
                  top: 0,
                  left: 0
                },
                d = this[0];
              return "fixed" === m.css(d, "position") ? b = d.getBoundingClientRect() : (a = this.offsetParent(), b = this.offset(), m.nodeName(a[0], "html") || (c = a.offset()), c.top += m.css(a[0], "borderTopWidth", !0), c.left += m.css(a[0], "borderLeftWidth", !0)), {
                top: b.top - c.top - m.css(d, "marginTop", !0),
                left: b.left - c.left - m.css(d, "marginLeft", !0)
              };
            }
          },
          offsetParent: function offsetParent() {
            return this.map(function () {
              var a = this.offsetParent || cc;
              while (a && !m.nodeName(a, "html") && "static" === m.css(a, "position")) {
                a = a.offsetParent;
              }
              return a || cc;
            });
          }
        }), m.each({
          scrollLeft: "pageXOffset",
          scrollTop: "pageYOffset"
        }, function (a, b) {
          var c = /Y/.test(b);
          m.fn[a] = function (d) {
            return V(this, function (a, d, e) {
              var f = dc(a);
              return void 0 === e ? f ? b in f ? f[b] : f.document.documentElement[d] : a[d] : void (f ? f.scrollTo(c ? m(f).scrollLeft() : e, c ? e : m(f).scrollTop()) : a[d] = e);
            }, a, d, arguments.length, null);
          };
        }), m.each(["top", "left"], function (a, b) {
          m.cssHooks[b] = La(k.pixelPosition, function (a, c) {
            return c ? (c = Ja(a, b), Ha.test(c) ? m(a).position()[b] + "px" : c) : void 0;
          });
        }), m.each({
          Height: "height",
          Width: "width"
        }, function (a, b) {
          m.each({
            padding: "inner" + a,
            content: b,
            "": "outer" + a
          }, function (c, d) {
            m.fn[d] = function (d, e) {
              var f = arguments.length && (c || "boolean" != typeof d),
                g = c || (d === !0 || e === !0 ? "margin" : "border");
              return V(this, function (b, c, d) {
                var e;
                return m.isWindow(b) ? b.document.documentElement["client" + a] : 9 === b.nodeType ? (e = b.documentElement, Math.max(b.body["scroll" + a], e["scroll" + a], b.body["offset" + a], e["offset" + a], e["client" + a])) : void 0 === d ? m.css(b, c, g) : m.style(b, c, d, g);
              }, b, f ? d : void 0, f, null);
            };
          });
        }), m.fn.size = function () {
          return this.length;
        }, m.fn.andSelf = m.fn.addBack;
        var ec = a.jQuery,
          fc = a.$;
        return m.noConflict = function (b) {
          return a.$ === m && (a.$ = fc), b && a.jQuery === m && (a.jQuery = ec), m;
        }, _typeof(b) === K && (a.jQuery = a.$ = m), m;
      });
    });

    var pptxsize;function pptx2html(file,size){var zip=new lib();var zip1=zip.load(file);if(size){pptxsize=size;}var rslt_ary=processPPTX(zip1);// const processSlideList = processPPTX(file)
    // const json = []
    // for (const item of processSlideList) {
    //   json.push(item.json)
    // }
    return rslt_ary;}var slideWidth=0;var slideHeight=0;var MsgQueue=new Array();var settings={// These are the defaults.
    pptxFileUrl:"",fileInputId:"",slidesScale:"",//Change Slides scale by percent
    slideMode:false/** true,false*/,slideType:"divs2slidesjs"/*'divs2slidesjs' (default) , 'revealjs'(https://revealjs.com)  -TODO*/,revealjsPath:""/*path to js file of revealjs - TODO*/,keyBoardShortCut:false/** true,false ,condition: slideMode: true XXXXX - need to remove - this is doublcated*/,mediaProcess:true/** true,false: if true then process video and audio files */,jsZipV2:false,themeProcess:true/*true (default) , false, "colorsAndImageOnly"*/,incSlide:{width:0,height:0},slideModeConfig:{first:1,nav:true/** true,false : show or not nav buttons*/,navTxtColor:"black"/** color */,keyBoardShortCut:true/** true,false ,condition: */,showSlideNum:true/** true,false */,showTotalSlideNum:true/** true,false */,autoSlide:true/** false or seconds , F8 to active ,keyBoardShortCut: true */,randomAutoSlide:false/** true,false ,autoSlide:true */,loop:false/** true,false */,background:false/** false or color*/,transition:"default"/** transition type: "slid","fade","default","random" , to show transition efects :transitionTime > 0.5 */,transitionTime:1/** transition time between slides in seconds */},revealjsConfig:{}};var defaultTextStyle=null;var chartID=0;var app_verssion;var rtl_langs_array=["he-IL","ar-AE","ar-SA","dv-MV","fa-IR","ur-PK"];var styleTable={};var slideFactor=96/914400;var fontSizeFactor=4/3.2;var dgmQuickStyleFileName;var tableStyles;var txBoxVal;function processPPTX(zip){var post_ary=[];var dateBefore=new Date();if(zip.file("docProps/thumbnail.jpeg")!==null){var pptxThumbImg=base64ArrayBuffer(zip.file("docProps/thumbnail.jpeg").asArrayBuffer());post_ary.push({type:"pptx-thumb",data:pptxThumbImg,slide_num:-1});}var filesInfo=getContentTypes(zip);var slideSize=getSlideSizeAndSetDefaultTextStyle(zip);tableStyles=readXmlFile(zip,"ppt/tableStyles.xml");//console.log("slideSize: ", slideSize)
    post_ary.push({type:"slideSize",data:slideSize,slide_num:0});var numOfSlides=filesInfo["slides"].length;var slide_number=0;for(var i=0;i<numOfSlides;i++){// var filename = filesInfo["slides"][i];
    var filename="ppt/slides/slide".concat(i+1,".xml");var filename_no_path="";var filename_no_path_ary=[];if(filename.indexOf("/")!=-1){filename_no_path_ary=filename.split("/");filename_no_path=filename_no_path_ary.pop();}else {filename_no_path=filename;}var filename_no_path_no_ext="";if(filename_no_path.indexOf(".")!=-1){var filename_no_path_no_ext_ary=filename_no_path.split(".");filename_no_path_no_ext_ary.pop();filename_no_path_no_ext=filename_no_path_no_ext_ary.join(".");}if(filename_no_path_no_ext!=""&&filename_no_path.indexOf("slide")!=-1){slide_number+=1;}var _processSingleSlide=processSingleSlide(zip,filename,i,slideSize),html=_processSingleSlide.html,json=_processSingleSlide.json;post_ary.push({type:"slide",data:html,json:json,slide_num:slide_number,file_name:filename_no_path_no_ext});slide_number+=1;post_ary.push({type:"progress-update",slide_num:slide_number,data:(i+1)*100/numOfSlides});}post_ary.sort(function(a,b){return a.slide_num-b.slide_num;});post_ary.push({type:"globalCSS",data:genGlobalCSS()});var dateAfter=new Date();post_ary.push({type:"ExecutionTime",data:dateAfter-dateBefore});return post_ary;}function processSingleSlide(zip,sldFileName,index,slideSize){// =====< Step 1 >=====
    // Read relationship filename of the slide (Get slideLayoutXX.xml)
    // @sldFileName: ppt/slides/slide1.xml
    // @resName: ppt/slides/_rels/slide1.xml.rels
    var resName=sldFileName.replace("slides/slide","slides/_rels/slide")+".rels";var resContent=readXmlFile(zip,resName);var RelationshipArray=resContent["Relationships"]["Relationship"];//console.log("RelationshipArray: " , RelationshipArray)
    var layoutFilename="";var diagramFilename="";var slideResObj={};if(RelationshipArray.constructor===Array){for(var i=0;i<RelationshipArray.length;i++){switch(RelationshipArray[i]["attrs"]["Type"]){case"http://schemas.openxmlformats.org/officeDocument/2006/relationships/slideLayout":layoutFilename=RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/");break;case"http://schemas.microsoft.com/office/2007/relationships/diagramDrawing":diagramFilename=RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/");slideResObj[RelationshipArray[i]["attrs"]["Id"]]={type:RelationshipArray[i]["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/")};break;case"http://schemas.openxmlformats.org/officeDocument/2006/relationships/notesSlide":case"http://schemas.openxmlformats.org/officeDocument/2006/relationships/image":case"http://schemas.openxmlformats.org/officeDocument/2006/relationships/chart":case"http://schemas.openxmlformats.org/officeDocument/2006/relationships/hyperlink":default:slideResObj[RelationshipArray[i]["attrs"]["Id"]]={type:RelationshipArray[i]["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/")};}}}else {layoutFilename=RelationshipArray["attrs"]["Target"].replace("../","ppt/");}// Open slideLayoutXX.xml
    var slideLayoutContent=readXmlFile(zip,layoutFilename);var slideLayoutTables=indexNodes(slideLayoutContent);var sldLayoutClrOvr=getTextByPathList(slideLayoutContent,["p:sldLayout","p:clrMapOvr","a:overrideClrMapping"]);if(sldLayoutClrOvr!==undefined){slideLayoutClrOvride=sldLayoutClrOvr["attrs"];}// =====< Step 2 >=====
    // Read slide master filename of the slidelayout (Get slideMasterXX.xml)
    // @resName: ppt/slideLayouts/slideLayout1.xml
    // @masterName: ppt/slideLayouts/_rels/slideLayout1.xml.rels
    var slideLayoutResFilename=layoutFilename.replace("slideLayouts/slideLayout","slideLayouts/_rels/slideLayout")+".rels";var slideLayoutResContent=readXmlFile(zip,slideLayoutResFilename);RelationshipArray=slideLayoutResContent["Relationships"]["Relationship"];var masterFilename="";var layoutResObj={};if(RelationshipArray.constructor===Array){for(var i=0;i<RelationshipArray.length;i++){switch(RelationshipArray[i]["attrs"]["Type"]){case"http://schemas.openxmlformats.org/officeDocument/2006/relationships/slideMaster":masterFilename=RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/");break;default:layoutResObj[RelationshipArray[i]["attrs"]["Id"]]={type:RelationshipArray[i]["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/")};}}}else {masterFilename=RelationshipArray["attrs"]["Target"].replace("../","ppt/");}// Open slideMasterXX.xml
    var slideMasterContent=readXmlFile(zip,masterFilename);var slideMasterTextStyles=getTextByPathList(slideMasterContent,["p:sldMaster","p:txStyles"]);var slideMasterTables=indexNodes(slideMasterContent);/////////////////Amir/////////////
    //Open slideMasterXX.xml.rels
    var slideMasterResFilename=masterFilename.replace("slideMasters/slideMaster","slideMasters/_rels/slideMaster")+".rels";var slideMasterResContent=readXmlFile(zip,slideMasterResFilename);RelationshipArray=slideMasterResContent["Relationships"]["Relationship"];var themeFilename="";var masterResObj={};if(RelationshipArray.constructor===Array){for(var i=0;i<RelationshipArray.length;i++){switch(RelationshipArray[i]["attrs"]["Type"]){case"http://schemas.openxmlformats.org/officeDocument/2006/relationships/theme":themeFilename=RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/");break;default:masterResObj[RelationshipArray[i]["attrs"]["Id"]]={type:RelationshipArray[i]["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:RelationshipArray[i]["attrs"]["Target"].replace("../","ppt/")};}}}else {themeFilename=RelationshipArray["attrs"]["Target"].replace("../","ppt/");}//console.log(themeFilename)
    //Load Theme file
    var themeResObj={};if(themeFilename!==undefined){var themeName=themeFilename.split("/").pop();var themeResFileName=themeFilename.replace(themeName,"_rels/"+themeName)+".rels";//console.log("themeFilename: ", themeFilename, ", themeName: ", themeName, ", themeResFileName: ", themeResFileName)
    var themeContent=readXmlFile(zip,themeFilename);var themeResContent=readXmlFile(zip,themeResFileName);if(themeResContent!==null){var relationshipArray=themeResContent["Relationships"]["Relationship"];if(relationshipArray!==undefined){var themeFilename="";if(relationshipArray.constructor===Array){for(var i=0;i<relationshipArray.length;i++){themeResObj[relationshipArray[i]["attrs"]["Id"]]={type:relationshipArray[i]["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:relationshipArray[i]["attrs"]["Target"].replace("../","ppt/")};}}else {//console.log("theme relationshipArray : ", relationshipArray)
    themeResObj[relationshipArray["attrs"]["Id"]]={type:relationshipArray["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:relationshipArray["attrs"]["Target"].replace("../","ppt/")};}}}}//Load diagram file
    var diagramResObj={};var digramFileContent={};if(diagramFilename!==undefined){var diagName=diagramFilename.split("/").pop();var diagramResFileName=diagramFilename.replace(diagName,"_rels/"+diagName)+".rels";//console.log("diagramFilename: ", diagramFilename, ", themeName: ", themeName, ", diagramResFileName: ", diagramResFileName)
    digramFileContent=readXmlFile(zip,diagramFilename);if(digramFileContent!==null&&digramFileContent!==undefined&&digramFileContent!=""){var digramFileContentObjToStr=JSON.stringify(digramFileContent);digramFileContentObjToStr=digramFileContentObjToStr.replace(/dsp:/g,"p:");digramFileContent=JSON.parse(digramFileContentObjToStr);}var digramResContent=readXmlFile(zip,diagramResFileName);if(digramResContent!==null){var relationshipArray=digramResContent["Relationships"]["Relationship"];var themeFilename="";if(relationshipArray.constructor===Array){for(var i=0;i<relationshipArray.length;i++){diagramResObj[relationshipArray[i]["attrs"]["Id"]]={type:relationshipArray[i]["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:relationshipArray[i]["attrs"]["Target"].replace("../","ppt/")};}}else {//console.log("theme relationshipArray : ", relationshipArray)
    diagramResObj[relationshipArray["attrs"]["Id"]]={type:relationshipArray["attrs"]["Type"].replace("http://schemas.openxmlformats.org/officeDocument/2006/relationships/",""),target:relationshipArray["attrs"]["Target"].replace("../","ppt/")};}}}//console.log("diagramResObj: " , diagramResObj)
    // =====< Step 3 >=====
    var slideContent=readXmlFile(zip,sldFileName);var nodes=slideContent["p:sld"]["p:cSld"]["p:spTree"];var warpObj={zip:zip,slideLayoutContent:slideLayoutContent,slideLayoutTables:slideLayoutTables,slideMasterContent:slideMasterContent,slideMasterTables:slideMasterTables,slideContent:slideContent,slideResObj:slideResObj,slideMasterTextStyles:slideMasterTextStyles,layoutResObj:layoutResObj,masterResObj:masterResObj,themeContent:themeContent,themeResObj:themeResObj,digramFileContent:digramFileContent,diagramResObj:diagramResObj,defaultTextStyle:defaultTextStyle};var bgResult="";var bgJson="";{var Background=getBackground(warpObj,slideSize,index);bgResult=Background.html;bgJson=Background.json&&Background.json.length?Background.json:'';}var bgColor="";var fill='';{if(bgJson&&Array.isArray(bgJson)){var slidebg=getSlideBackgroundFill(warpObj);if(slidebg){bgJson.push({type:'background',color:slidebg});}}else {fill=getSlideBackgroundFill(warpObj);}}var result; {var result="<div class='slide' style='width:"+slideSize.width+"px; height:"+slideSize.height+"px;"+bgColor+"'>";}result+=bgResult;var elements=[];for(var nodeKey in nodes){if(nodes[nodeKey].constructor===Array){for(var i=0;i<nodes[nodeKey].length;i++){var ret=processNodesInSlide(nodeKey,nodes[nodeKey][i],nodes,warpObj,"slide");if(ret){if(ret.html)result+=ret.html;if(ret.json)elements.push(ret.json);}}}else {var _ret=processNodesInSlide(nodeKey,nodes[nodeKey],nodes,warpObj,"slide");if(_ret){if(_ret.html)result+=_ret.html;if(_ret.json)elements.push(_ret.json);}}}var json={width:slideSize.width,height:slideSize.height,fill:bgJson?bgJson:fill,elements:elements};{return {html:result+"</div></div>",json:json};}}function processNodesInSlide(nodeKey,nodeValue,nodes,warpObj,source,sType){var html="";var json;var ret;switch(nodeKey){case"p:sp":// Shape, Text
    ret=processSpNode(nodeValue,nodes,warpObj,source,sType);html+=ret.html;json=ret.json;break;case"p:cxnSp":// Shape, Text (with connection)
    ret=processCxnSpNode(nodeValue,nodes,warpObj,source,sType);html+=ret.html;json=ret.json;break;case"p:pic":// Picture
    ret=processPicNode(nodeValue,warpObj,source);html+=ret.html;json=ret.json;break;case"p:graphicFrame":// Chart, Diagram, Table
    ret=processGraphicFrameNode(nodeValue,warpObj,source,sType);html+=ret.html;json=ret.json;break;case"p:grpSp":// 群組
    ret=processGroupSpNode(nodeValue,warpObj,source);html+=ret.html;json=ret.json;break;case"mc:AlternateContent"://Equations and formulas as Image
    //console.log("mc:AlternateContent nodeValue:" , nodeValue , "nodes:",nodes, "sType:",sType)
    var mcFallbackNode=getTextByPathList(nodeValue,["mc:Fallback"]);ret=processGroupSpNode(mcFallbackNode,warpObj,source);html+=ret.html;json=ret.json;break;}return {html:html,json:json};}function processGroupSpNode(node,warpObj,source){//console.log("processGroupSpNode: node: ", node)
    var xfrmNode=getTextByPathList(node,["p:grpSpPr","a:xfrm"]);if(xfrmNode!==undefined){var x=parseInt(xfrmNode["a:off"]["attrs"]["x"])*slideFactor;var y=parseInt(xfrmNode["a:off"]["attrs"]["y"])*slideFactor;var chx=parseInt(xfrmNode["a:chOff"]["attrs"]["x"])*slideFactor;var chy=parseInt(xfrmNode["a:chOff"]["attrs"]["y"])*slideFactor;var cx=parseInt(xfrmNode["a:ext"]["attrs"]["cx"])*slideFactor;var cy=parseInt(xfrmNode["a:ext"]["attrs"]["cy"])*slideFactor;var chcx=parseInt(xfrmNode["a:chExt"]["attrs"]["cx"])*slideFactor;var chcy=parseInt(xfrmNode["a:chExt"]["attrs"]["cy"])*slideFactor;var rotate=parseInt(xfrmNode["attrs"]["rot"]);var rotStr="";//;" border: 3px solid black;";
    // angleToDegrees(getTextByPathList(slideXfrmNode, ["attrs", "rot"]));
    // var rotX = 0;
    // var rotY = 0;
    var top=y-chy,left=x-chx,width=cx-chcx,height=cy-chcy;var sType="group";if(!isNaN(rotate)){rotate=angleToDegrees(rotate);rotStr+="transform: rotate("+rotate+"deg) ; transform-origin: center;";// var cLin = Math.sqrt(Math.pow((chy), 2) + Math.pow((chx), 2));
    // var rdian = degreesToRadians(rotate);
    // rotX = cLin * Math.cos(rdian);
    // rotY = cLin * Math.sin(rdian);
    if(rotate!=0){top=y;left=x;width=cx;height=cy;sType="group-rotate";}}}var grpStyle="";if(rotStr!==undefined&&rotStr!=""){grpStyle+=rotStr;}if(top!==undefined){grpStyle+="top: "+top+"px;";}if(left!==undefined){grpStyle+="left: "+left+"px;";}if(width!==undefined){grpStyle+="width:"+width+"px;";}if(height!==undefined){grpStyle+="height: "+height+"px;";}var order=node["attrs"]["order"];var result="<div class='block group' style='position: static !important; z-index: "+order+";"+grpStyle+"'>";// Procsee all child nodes
    var elements=[];for(var nodeKey in node){if(node[nodeKey].constructor===Array){for(var i=0;i<node[nodeKey].length;i++){var ret=processNodesInSlide(nodeKey,genGroupNodeKey(nodeKey,xfrmNode,node[nodeKey][i]),// node[nodeKey][i],
    node,warpObj,source,sType);if(ret){if(ret.html)result+=ret.html;if(ret.json)elements.push(ret.json);}}}else {var _ret2=processNodesInSlide(nodeKey,genGroupNodeKey(nodeKey,xfrmNode,node[nodeKey]),// node[nodeKey],
    node,warpObj,source,sType);if(_ret2){if(_ret2.html)result+=_ret2.html;if(_ret2.json)elements.push(_ret2.json);}}}var json={type:"group",top:y-chy,left:x-chx,width:cx-chcx,height:cy-chcy,order:order,elements:elements};result+="</div>";return {html:result,json:json};}function genGroupNodeKey(nodeKey,xfrmNode,node){var groupSpFactor=635;var x=parseInt(xfrmNode["a:off"]["attrs"]["x"]);var y=parseInt(xfrmNode["a:off"]["attrs"]["y"]);var chx=parseInt(xfrmNode["a:chOff"]["attrs"]["x"]);var chy=parseInt(xfrmNode["a:chOff"]["attrs"]["y"]);var cx=parseInt(xfrmNode["a:ext"]["attrs"]["cx"]);var cy=parseInt(xfrmNode["a:ext"]["attrs"]["cy"]);var chcx=parseInt(xfrmNode["a:chExt"]["attrs"]["cx"]);var chcy=parseInt(xfrmNode["a:chExt"]["attrs"]["cy"]);try{if(['p:sp','p:cxnSp','p:pic','p:graphicFrame','mc:AlternateContent'].includes(nodeKey)){var x__=parseInt(x+(-chx+Number(node['p:spPr']['a:xfrm']['a:off']['attrs']['x']))*groupSpFactor);var y__=parseInt(y+(-chy+Number(node['p:spPr']['a:xfrm']['a:off']['attrs']['y']))*groupSpFactor);var cx__=parseInt(cx+(-chcx+Number(node['p:spPr']['a:xfrm']['a:ext']['attrs']['cx']))*groupSpFactor);var cy__=parseInt(cy+(-chcy+Number(node['p:spPr']['a:xfrm']['a:ext']['attrs']['cy']))*groupSpFactor);// if (x__ < 1e8 && y__ < 1e8 && cx__ < 1e8 && cy__ < 1e8) {
    //   node['p:spPr']['a:xfrm']['a:off']['attrs']['x'] = x__
    //   node['p:spPr']['a:xfrm']['a:off']['attrs']['y'] = y__
    //   node['p:spPr']['a:xfrm']['a:ext']['attrs']['cy'] = cy__
    //   node['p:spPr']['a:xfrm']['a:ext']['attrs']['cx'] = cx__
    // }
    if(x__<1e8)node['p:spPr']['a:xfrm']['a:off']['attrs']['x']=x__;if(y__<1e8)node['p:spPr']['a:xfrm']['a:off']['attrs']['y']=y__;if(cy__<1e8)node['p:spPr']['a:xfrm']['a:ext']['attrs']['cy']=cy__;if(cx__<1e8)node['p:spPr']['a:xfrm']['a:ext']['attrs']['cx']=cx__;}if(['p:grpSp'].includes(nodeKey)){node['p:grpSpPr']['a:xfrm']['a:off']['attrs']['x']=x+parseInt(node['p:grpSpPr']['a:xfrm']['a:off']['attrs']['x'])*groupSpFactor;node['p:grpSpPr']['a:xfrm']['a:off']['attrs']['y']=y+parseInt(node['p:grpSpPr']['a:xfrm']['a:off']['attrs']['y'])*groupSpFactor;node['p:grpSpPr']['a:xfrm']['a:chOff']['attrs']['x']=chx+parseInt(node['p:grpSpPr']['a:xfrm']['a:chOff']['attrs']['x']);node['p:grpSpPr']['a:xfrm']['a:chOff']['attrs']['y']=chy+parseInt(node['p:grpSpPr']['a:xfrm']['a:chOff']['attrs']['y']);node['p:grpSpPr']['a:xfrm']['a:ext']['attrs']['cx']=parseInt(node['p:grpSpPr']['a:xfrm']['a:ext']['attrs']['cx'])*slideFactor;node['p:grpSpPr']['a:xfrm']['a:ext']['attrs']['cy']=parseInt(node['p:grpSpPr']['a:xfrm']['a:ext']['attrs']['cy'])*slideFactor;node['p:grpSpPr']['a:xfrm']['a:chExt']['attrs']['cx']=parseInt(node['p:grpSpPr']['a:xfrm']['a:chExt']['attrs']['cx'])*slideFactor;node['p:grpSpPr']['a:xfrm']['a:chExt']['attrs']['cy']=parseInt(node['p:grpSpPr']['a:xfrm']['a:chExt']['attrs']['cy'])*slideFactor;}}catch(e){}return node;}function genShape(node,pNode,slideLayoutSpNode,slideMasterSpNode,id,name,idx,type,order,warpObj,isUserDrawnBg,sType,source){//var dltX = 0;
    //var dltY = 0;
    var xfrmList=["p:spPr","a:xfrm"];var slideXfrmNode=getTextByPathList(node,xfrmList);var slideLayoutXfrmNode=getTextByPathList(slideLayoutSpNode,xfrmList);var slideMasterXfrmNode=getTextByPathList(slideMasterSpNode,xfrmList);var result="";var html="";var shpId=getTextByPathList(node,["attrs","order"]);//console.log("shpId: ",shpId)
    var shapType=getTextByPathList(node,["p:spPr","a:prstGeom","attrs","prst"]);//custGeom - Amir
    var custShapType=getTextByPathList(node,["p:spPr","a:custGeom"]);var isFlipV=false;var isFlipH=false;var flip="";if(getTextByPathList(slideXfrmNode,["attrs","flipV"])==="1"){isFlipV=true;}if(getTextByPathList(slideXfrmNode,["attrs","flipH"])==="1"){isFlipH=true;}if(isFlipH&&!isFlipV){flip=" scale(-1,1)";}else if(!isFlipH&&isFlipV){flip=" scale(1,-1)";}else if(isFlipH&&isFlipV){flip=" scale(-1,-1)";}/////////////////////////Amir////////////////////////
    //rotate
    var rotate=angleToDegrees(getTextByPathList(slideXfrmNode,["attrs","rot"]));//console.log("genShape rotate: " + rotate);
    var txtRotate;var txtXframeNode=getTextByPathList(node,["p:txXfrm"]);if(txtXframeNode!==undefined){var txtXframeRot=getTextByPathList(txtXframeNode,["attrs","rot"]);if(txtXframeRot!==undefined){txtRotate=angleToDegrees(txtXframeRot)+90;}}else {txtRotate=rotate;}//////////////////////////////////////////////////
    if(shapType!==undefined||custShapType!==undefined/*&& slideXfrmNode !== undefined*/){var off=getTextByPathList(slideXfrmNode,["a:off","attrs"]);parseInt(off["x"])*slideFactor;parseInt(off["y"])*slideFactor;var ext=getTextByPathList(slideXfrmNode,["a:ext","attrs"]);var w=parseInt(ext["cx"])*slideFactor;var h=parseInt(ext["cy"])*slideFactor;var svgCssName="_svg_css_"+(Object.keys(styleTable).length+1)+"_"+Math.floor(Math.random()*1001);//console.log("name:", name, "svgCssName: ", svgCssName)
    var effectsClassName=svgCssName+"_effects";result+="<svg class='drawing "+svgCssName+" "+effectsClassName+" ' _id='"+id+"' _idx='"+idx+"' _type='"+type+"' _name='"+name+"' style='"+getPosition(slideXfrmNode,pNode,undefined,undefined,sType)+getSize(slideXfrmNode,undefined,undefined)+" z-index: "+order+";"+"transform: rotate("+(rotate!==undefined?rotate:0)+"deg)"+flip+";"+"'>";result+="<defs>";// Fill Color
    var fillColor=getShapeFill(node,pNode,true,warpObj,source);//console.log("genShape: fillColor: ", fillColor)
    var grndFillFlg=false;var imgFillFlg=false;var clrFillType=getFillType(getTextByPathList(node,["p:spPr"]));if(clrFillType=="GROUP_FILL"){clrFillType=getFillType(getTextByPathList(pNode,["p:grpSpPr"]));}// if (clrFillType == "") {
    //     var clrFillType = getFillType(getTextByPathList(node, ["p:style","a:fillRef"]));
    // }
    //console.log("genShape: fillColor: ", fillColor, ", clrFillType: ", clrFillType, ", node: ", node)
    /////////////////////////////////////////
    if(clrFillType=="GRADIENT_FILL"){grndFillFlg=true;var color_arry=fillColor.color;var angl=fillColor.rot+90;var svgGrdnt=getSvgGradient(w,h,angl,color_arry,shpId);//fill="url(#linGrd)"
    //console.log("genShape: svgGrdnt: ", svgGrdnt)
    result+=svgGrdnt;}else if(clrFillType=="PIC_FILL"){imgFillFlg=true;var svgBgImg=getSvgImagePattern(node,fillColor,shpId,warpObj);//fill="url(#imgPtrn)"
    //console.log(svgBgImg)
    result+=svgBgImg;}else if(clrFillType=="PATTERN_FILL"){var styleText=fillColor;if(styleText in styleTable){styleText+="do-nothing: "+svgCssName+";";}styleTable[styleText]={name:svgCssName,text:styleText};//}
    fillColor="none";}else {if(clrFillType!="SOLID_FILL"&&clrFillType!="PATTERN_FILL"&&(shapType=="arc"||shapType=="bracketPair"||shapType=="bracePair"||shapType=="leftBracket"||shapType=="leftBrace"||shapType=="rightBrace"||shapType=="rightBracket")){//Temp. solution  - TODO
    fillColor="none";}}// Border Color
    var border=getBorder(node,pNode,true,"shape",warpObj);var headEndNodeAttrs=getTextByPathList(node,["p:spPr","a:ln","a:headEnd","attrs"]);var tailEndNodeAttrs=getTextByPathList(node,["p:spPr","a:ln","a:tailEnd","attrs"]);// type: none, triangle, stealth, diamond, oval, arrow
    ////////////////////effects/////////////////////////////////////////////////////
    //p:spPr => a:effectLst =>
    //"a:blur"
    //"a:fillOverlay"
    //"a:glow"
    //"a:innerShdw"
    //"a:outerShdw"
    //"a:prstShdw"
    //"a:reflection"
    //"a:softEdge"
    //p:spPr => a:scene3d
    //"a:camera"
    //"a:lightRig"
    //"a:backdrop"
    //"a:extLst"?
    //p:spPr => a:sp3d
    //"a:bevelT"
    //"a:bevelB"
    //"a:extrusionClr"
    //"a:contourClr"
    //"a:extLst"?
    //////////////////////////////outerShdw///////////////////////////////////////////
    //not support sizing the shadow
    var outerShdwNode=getTextByPathList(node,["p:spPr","a:effectLst","a:outerShdw"]);var oShadowSvgUrlStr="";if(outerShdwNode!==undefined){var chdwClrNode=getSolidFill(outerShdwNode,undefined,undefined,warpObj);var outerShdwAttrs=outerShdwNode["attrs"];//var algn = outerShdwAttrs["algn"];
    var dir=outerShdwAttrs["dir"]?parseInt(outerShdwAttrs["dir"])/60000:0;var dist=parseInt(outerShdwAttrs["dist"])*slideFactor;//(px) //* (3 / 4); //(pt)
    //var rotWithShape = outerShdwAttrs["rotWithShape"];
    var blurRad=outerShdwAttrs["blurRad"]?parseInt(outerShdwAttrs["blurRad"])*slideFactor:"";//+ "px"
    //var sx = (outerShdwAttrs["sx"]) ? (parseInt(outerShdwAttrs["sx"]) / 100000) : 1;
    //var sy = (outerShdwAttrs["sy"]) ? (parseInt(outerShdwAttrs["sy"]) / 100000) : 1;
    var vx=dist*Math.sin(dir*Math.PI/180);var hx=dist*Math.cos(dir*Math.PI/180);//SVG
    //var oShadowId = "outerhadow_" + shpId;
    //oShadowSvgUrlStr = "filter='url(#" + oShadowId+")'";
    //var shadowFilterStr = '<filter id="' + oShadowId + '" x="0" y="0" width="' + w * (6 / 8) + '" height="' + h + '">';
    //1:
    //shadowFilterStr += '<feDropShadow dx="' + vx + '" dy="' + hx + '" stdDeviation="' + blurRad * (3 / 4) + '" flood-color="#' + chdwClrNode +'" flood-opacity="1" />'
    //2:
    //shadowFilterStr += '<feFlood result="floodColor" flood-color="red" flood-opacity="0.5"   width="' + w * (6 / 8) + '" height="' + h + '"  />'; //#' + chdwClrNode +'
    //shadowFilterStr += '<feOffset result="offOut" in="SourceGraph ccfsdf-+ic"  dx="' + vx + '" dy="' + hx + '"/>'; //how much to offset
    //shadowFilterStr += '<feGaussianBlur result="blurOut" in="offOut" stdDeviation="' + blurRad*(3/4) +'"/>'; //tdDeviation is how much to blur
    //shadowFilterStr += '<feComponentTransfer><feFuncA type="linear" slope="0.5"/></feComponentTransfer>'; //slope is the opacity of the shadow
    //shadowFilterStr += '<feBlend in="SourceGraphic" in2="blurOut"  mode="normal" />'; //this contains the element that the filter is applied to
    //shadowFilterStr += '</filter>';
    //result += shadowFilterStr;
    //css:
    var svg_css_shadow="filter:drop-shadow("+hx+"px "+vx+"px "+blurRad+"px #"+chdwClrNode+");";if(svg_css_shadow in styleTable){svg_css_shadow+="do-nothing: "+svgCssName+";";}styleTable[svg_css_shadow]={name:effectsClassName,text:svg_css_shadow};}////////////////////////////////////////////////////////////////////////////////////////
    if(headEndNodeAttrs!==undefined&&(headEndNodeAttrs["type"]==="triangle"||headEndNodeAttrs["type"]==="arrow")||tailEndNodeAttrs!==undefined&&(tailEndNodeAttrs["type"]==="triangle"||tailEndNodeAttrs["type"]==="arrow")){var triangleMarker="<marker id='markerTriangle_"+shpId+"' viewBox='0 0 10 10' refX='1' refY='5' markerWidth='5' markerHeight='5' stroke='"+border.color+"' fill='"+border.color+"' orient='auto-start-reverse' markerUnits='strokeWidth'><path d='M 0 0 L 10 5 L 0 10 z' /></marker>";result+=triangleMarker;}result+="</defs>";}var _getPositionV=getPositionV1(slideXfrmNode,pNode,slideLayoutXfrmNode,slideMasterXfrmNode,sType),left=_getPositionV.left,top=_getPositionV.top;var _getSizeV=getSizeV1(slideXfrmNode,slideLayoutXfrmNode,slideMasterXfrmNode),width=_getSizeV.width,height=_getSizeV.height;if(shapType!==undefined&&custShapType===undefined){//console.log("shapType: ", shapType)
    switch(shapType){case"rect":case"flowChartProcess":case"flowChartPredefinedProcess":case"flowChartInternalStorage":case"actionButtonBlank":result+="<rect x='0' y='0' width='"+w+"' height='"+h+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' "+oShadowSvgUrlStr+"  />";if(shapType=="flowChartPredefinedProcess"){result+="<rect x='"+w*(1/8)+"' y='0' width='"+w*(6/8)+"' height='"+h+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";}else if(shapType=="flowChartInternalStorage"){result+=" <polyline points='"+w*(1/8)+" 0,"+w*(1/8)+" "+h+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";result+=" <polyline points='0 "+h*(1/8)+","+w+" "+h*(1/8)+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";}break;case"flowChartCollate":var d="M 0,0"+" L"+w+","+0+" L"+0+","+h+" L"+w+","+h+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartDocument":var y1,y2,y3,x1;x1=w*10800/21600;y1=h*17322/21600;y2=h*20172/21600;y3=h*23922/21600;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+y1+" C"+x1+","+y1+" "+x1+","+y3+" "+0+","+y2+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartMultidocument":var y1,y2,y3,y4,y5,y6,y7,y8,y9,x1,x2,x3,x4,x5,x6,x7;y1=h*18022/21600;y2=h*3675/21600;y3=h*23542/21600;y4=h*1815/21600;y5=h*16252/21600;y6=h*16352/21600;y7=h*14392/21600;y8=h*20782/21600;y9=h*14467/21600;x1=w*1532/21600;x2=w*20000/21600;x3=w*9298/21600;x4=w*19298/21600;x5=w*18595/21600;x6=w*2972/21600;x7=w*20800/21600;var d="M"+0+","+y2+" L"+x5+","+y2+" L"+x5+","+y1+" C"+x3+","+y1+" "+x3+","+y3+" "+0+","+y8+" z"+"M"+x1+","+y2+" L"+x1+","+y4+" L"+x2+","+y4+" L"+x2+","+y5+" C"+x4+","+y5+" "+x5+","+y6+" "+x5+","+y6+"M"+x6+","+y4+" L"+x6+","+0+" L"+w+","+0+" L"+w+","+y7+" C"+x7+","+y7+" "+x2+","+y9+" "+x2+","+y9;result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonBackPrevious":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+"M"+g11+","+vc+" L"+g12+","+g9+" L"+g12+","+g10+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonBeginning":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12,g13,g14,g15,g16,g17;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;g13=ss*3/4;g14=g13/8;g15=g13/4;g16=g11+g14;g17=g11+g15;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+"M"+g17+","+vc+" L"+g12+","+g9+" L"+g12+","+g10+" z"+"M"+g16+","+g9+" L"+g11+","+g9+" L"+g11+","+g10+" L"+g16+","+g10+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonDocument":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,dx1,g11,g12,g13,g14,g15;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;dx1=ss*9/32;g11=hc-dx1;g12=hc+dx1;g13=ss*3/16;g14=g12-g13;g15=g9+g13;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+"M"+g11+","+g9+" L"+g14+","+g9+" L"+g12+","+g15+" L"+g12+","+g10+" L"+g11+","+g10+" z"+"M"+g14+","+g9+" L"+g14+","+g15+" L"+g12+","+g15+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonEnd":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12,g13,g14,g15,g16,g17;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;g13=ss*3/4;g14=g13*3/4;g15=g13*7/8;g16=g11+g14;g17=g11+g15;var d="M"+0+","+h+" L"+w+","+h+" L"+w+","+0+" L"+0+","+0+" z"+" M"+g17+","+g9+" L"+g12+","+g9+" L"+g12+","+g10+" L"+g17+","+g10+" z"+" M"+g16+","+vc+" L"+g11+","+g9+" L"+g11+","+g10+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonForwardNext":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;var d="M"+0+","+h+" L"+w+","+h+" L"+w+","+0+" L"+0+","+0+" z"+" M"+g12+","+vc+" L"+g11+","+g9+" L"+g11+","+g10+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonHelp":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g11,g13,g14,g15,g16,g19,g20,g21,g23,g24,g27,g29,g30,g31,g33,g36,g37,g41,g42;dx2=ss*3/8;g9=vc-dx2;g11=hc-dx2;g13=ss*3/4;g14=g13/7;g15=g13*3/14;g16=g13*2/7;g19=g13*3/7;g20=g13*4/7;g21=g13*17/28;g23=g13*21/28;g24=g13*11/14;g27=g9+g16;g29=g9+g21;g30=g9+g23;g31=g9+g24;g33=g11+g15;g36=g11+g19;g37=g11+g20;g41=g13/14;g42=g13*3/28;var cX1=g33+g16;var cX2=g36+g14;var cY3=g31+g42;var cX4=(g37+g36+g16)/2;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+"M"+g33+","+g27+shapeArc(cX1,g27,g16,g16,180,360,false).replace("M","L")+shapeArc(cX4,g27,g14,g15,0,90,false).replace("M","L")+shapeArc(cX4,g29,g41,g42,270,180,false).replace("M","L")+" L"+g37+","+g30+" L"+g36+","+g30+" L"+g36+","+g29+shapeArc(cX2,g29,g14,g15,180,270,false).replace("M","L")+shapeArc(g37,g27,g41,g42,90,0,false).replace("M","L")+shapeArc(cX1,g27,g14,g14,0,-180,false).replace("M","L")+" z"+"M"+hc+","+g31+shapeArc(hc,cY3,g42,g42,270,630,false).replace("M","L")+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonHome":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12,g13,g14,g15,g16,g17,g18,g19,g20,g21,g22,g23,g24,g25,g26,g27,g28,g29,g30,g31,g32,g33;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;g13=ss*3/4;g14=g13/16;g15=g13/8;g16=g13*3/16;g17=g13*5/16;g18=g13*7/16;g19=g13*9/16;g20=g13*11/16;g21=g13*3/4;g22=g13*13/16;g23=g13*7/8;g24=g9+g14;g25=g9+g16;g26=g9+g17;g27=g9+g21;g28=g11+g15;g29=g11+g18;g30=g11+g19;g31=g11+g20;g32=g11+g22;g33=g11+g23;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+hc+","+g9+" L"+g11+","+vc+" L"+g28+","+vc+" L"+g28+","+g10+" L"+g33+","+g10+" L"+g33+","+vc+" L"+g12+","+vc+" L"+g32+","+g26+" L"+g32+","+g24+" L"+g31+","+g24+" L"+g31+","+g25+" z"+" M"+g29+","+g27+" L"+g30+","+g27+" L"+g30+","+g10+" L"+g29+","+g10+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonInformation":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g11,g13,g14,g17,g18,g19,g20,g22,g23,g24,g25,g28,g29,g30,g31,g32,g34,g35,g37,g38;dx2=ss*3/8;g9=vc-dx2;g11=hc-dx2;g13=ss*3/4;g14=g13/32;g17=g13*5/16;g18=g13*3/8;g19=g13*13/32;g20=g13*19/32;g22=g13*11/16;g23=g13*13/16;g24=g13*7/8;g25=g9+g14;g28=g9+g17;g29=g9+g18;g30=g9+g23;g31=g9+g24;g32=g11+g17;g34=g11+g19;g35=g11+g20;g37=g11+g22;g38=g13*3/32;var cY1=g9+dx2;var cY2=g25+g38;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+"M"+hc+","+g9+shapeArc(hc,cY1,dx2,dx2,270,630,false).replace("M","L")+" z"+"M"+hc+","+g25+shapeArc(hc,cY2,g38,g38,270,630,false).replace("M","L")+"M"+g32+","+g28+" L"+g35+","+g28+" L"+g35+","+g30+" L"+g37+","+g30+" L"+g37+","+g31+" L"+g32+","+g31+" L"+g32+","+g30+" L"+g34+","+g30+" L"+g34+","+g29+" L"+g32+","+g29+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonMovie":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12,g13,g14,g15,g16,g17,g18,g19,g20,g21,g22,g23,g24,g25,g26,g27,g28,g29,g30,g31,g32,g33,g34,g35,g36,g37,g38,g39,g40,g41,g42,g43,g44,g45,g46,g47;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;g13=ss*3/4;g14=g13*1455/21600;g15=g13*1905/21600;g16=g13*2325/21600;g17=g13*16155/21600;g18=g13*17010/21600;g19=g13*19335/21600;g20=g13*19725/21600;g21=g13*20595/21600;g22=g13*5280/21600;g23=g13*5730/21600;g24=g13*6630/21600;g25=g13*7492/21600;g26=g13*9067/21600;g27=g13*9555/21600;g28=g13*13342/21600;g29=g13*14580/21600;g30=g13*15592/21600;g31=g11+g14;g32=g11+g15;g33=g11+g16;g34=g11+g17;g35=g11+g18;g36=g11+g19;g37=g11+g20;g38=g11+g21;g39=g9+g22;g40=g9+g23;g41=g9+g24;g42=g9+g25;g43=g9+g26;g44=g9+g27;g45=g9+g28;g46=g9+g29;g47=g9+g30;var d="M"+0+","+h+" L"+w+","+h+" L"+w+","+0+" L"+0+","+0+" z"+"M"+g11+","+g39+" L"+g11+","+g44+" L"+g31+","+g44+" L"+g32+","+g43+" L"+g33+","+g43+" L"+g33+","+g47+" L"+g35+","+g47+" L"+g35+","+g45+" L"+g36+","+g45+" L"+g38+","+g46+" L"+g12+","+g46+" L"+g12+","+g41+" L"+g38+","+g41+" L"+g37+","+g42+" L"+g35+","+g42+" L"+g35+","+g41+" L"+g34+","+g40+" L"+g32+","+g40+" L"+g31+","+g39+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonReturn":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12,g13,g14,g15,g16,g17,g18,g19,g20,g21,g22,g23,g24,g25,g26,g27;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;g13=ss*3/4;g14=g13*7/8;g15=g13*3/4;g16=g13*5/8;g17=g13*3/8;g18=g13/4;g19=g9+g15;g20=g9+g16;g21=g9+g18;g22=g11+g14;g23=g11+g15;g24=g11+g16;g25=g11+g17;g26=g11+g18;g27=g13/8;var cX1=g24-g27;var cY2=g19-g27;var cX3=g11+g17;var cY4=g10-g17;var d="M"+0+","+h+" L"+w+","+h+" L"+w+","+0+" L"+0+","+0+" z"+" M"+g12+","+g21+" L"+g23+","+g9+" L"+hc+","+g21+" L"+g24+","+g21+" L"+g24+","+g20+shapeArc(cX1,g20,g27,g27,0,90,false).replace("M","L")+" L"+g25+","+g19+shapeArc(g25,cY2,g27,g27,90,180,false).replace("M","L")+" L"+g26+","+g21+" L"+g11+","+g21+" L"+g11+","+g20+shapeArc(cX3,g20,g17,g17,180,90,false).replace("M","L")+" L"+hc+","+g10+shapeArc(hc,cY4,g17,g17,90,0,false).replace("M","L")+" L"+g22+","+g21+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"actionButtonSound":var hc=w/2,vc=h/2,ss=Math.min(w,h);var dx2,g9,g10,g11,g12,g13,g14,g15,g16,g17,g18,g19,g20,g21,g22,g23,g24,g25,g26;dx2=ss*3/8;g9=vc-dx2;g10=vc+dx2;g11=hc-dx2;g12=hc+dx2;g13=ss*3/4;g14=g13/8;g15=g13*5/16;g16=g13*5/8;g17=g13*11/16;g18=g13*3/4;g19=g13*7/8;g20=g9+g14;g21=g9+g15;g22=g9+g17;g23=g9+g19;g24=g11+g15;g25=g11+g16;g26=g11+g18;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+g11+","+g21+" L"+g24+","+g21+" L"+g25+","+g9+" L"+g25+","+g10+" L"+g24+","+g22+" L"+g11+","+g22+" z"+" M"+g26+","+g21+" L"+g12+","+g20+" M"+g26+","+vc+" L"+g12+","+vc+" M"+g26+","+g22+" L"+g12+","+g23;result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"irregularSeal1":case"irregularSeal2":if(shapType=="irregularSeal1"){var d="M"+w*10800/21600+","+h*5800/21600+" L"+w*14522/21600+","+0+" L"+w*14155/21600+","+h*5325/21600+" L"+w*18380/21600+","+h*4457/21600+" L"+w*16702/21600+","+h*7315/21600+" L"+w*21097/21600+","+h*8137/21600+" L"+w*17607/21600+","+h*10475/21600+" L"+w+","+h*13290/21600+" L"+w*16837/21600+","+h*12942/21600+" L"+w*18145/21600+","+h*18095/21600+" L"+w*14020/21600+","+h*14457/21600+" L"+w*13247/21600+","+h*19737/21600+" L"+w*10532/21600+","+h*14935/21600+" L"+w*8485/21600+","+h+" L"+w*7715/21600+","+h*15627/21600+" L"+w*4762/21600+","+h*17617/21600+" L"+w*5667/21600+","+h*13937/21600+" L"+w*135/21600+","+h*14587/21600+" L"+w*3722/21600+","+h*11775/21600+" L"+0+","+h*8615/21600+" L"+w*4627/21600+","+h*7617/21600+" L"+w*370/21600+","+h*2295/21600+" L"+w*7312/21600+","+h*6320/21600+" L"+w*8352/21600+","+h*2295/21600+" z";}else if(shapType=="irregularSeal2"){var d="M"+w*11462/21600+","+h*4342/21600+" L"+w*14790/21600+","+0+" L"+w*14525/21600+","+h*5777/21600+" L"+w*18007/21600+","+h*3172/21600+" L"+w*16380/21600+","+h*6532/21600+" L"+w+","+h*6645/21600+" L"+w*16985/21600+","+h*9402/21600+" L"+w*18270/21600+","+h*11290/21600+" L"+w*16380/21600+","+h*12310/21600+" L"+w*18877/21600+","+h*15632/21600+" L"+w*14640/21600+","+h*14350/21600+" L"+w*14942/21600+","+h*17370/21600+" L"+w*12180/21600+","+h*15935/21600+" L"+w*11612/21600+","+h*18842/21600+" L"+w*9872/21600+","+h*17370/21600+" L"+w*8700/21600+","+h*19712/21600+" L"+w*7527/21600+","+h*18125/21600+" L"+w*4917/21600+","+h+" L"+w*4805/21600+","+h*18240/21600+" L"+w*1285/21600+","+h*17825/21600+" L"+w*3330/21600+","+h*15370/21600+" L"+0+","+h*12877/21600+" L"+w*3935/21600+","+h*11592/21600+" L"+w*1172/21600+","+h*8270/21600+" L"+w*5372/21600+","+h*7817/21600+" L"+w*4502/21600+","+h*3625/21600+" L"+w*8550/21600+","+h*6382/21600+" L"+w*9722/21600+","+h*1887/21600+" z";}result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartTerminator":var x1,x2,y1,cd2=180,cd4=90,c3d4=270;x1=w*3475/21600;x2=w*18125/21600;y1=h*10800/21600;//path attrs: w = 21600; h = 21600;
    var d="M"+x1+","+0+" L"+x2+","+0+shapeArc(x2,h/2,x1,y1,c3d4,c3d4+cd2,false).replace("M","L")+" L"+x1+","+h+shapeArc(x1,h/2,x1,y1,cd4,cd4+cd2,false).replace("M","L")+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartPunchedTape":var x1,x1,y1,y2,cd2=180;x1=w*5/20;y1=h*2/20;y2=h*18/20;var d="M"+0+","+y1+shapeArc(x1,y1,x1,y1,cd2,0,false).replace("M","L")+shapeArc(w*(3/4),y1,x1,y1,cd2,360,false).replace("M","L")+" L"+w+","+y2+shapeArc(w*(3/4),y2,x1,y1,0,-cd2,false).replace("M","L")+shapeArc(x1,y2,x1,y1,0,cd2,false).replace("M","L")+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartOnlineStorage":var x1,y1,c3d4=270,cd4=90;x1=w*1/6;y1=h*3/6;var d="M"+x1+","+0+" L"+w+","+0+shapeArc(w,h/2,x1,y1,c3d4,90,false).replace("M","L")+" L"+x1+","+h+shapeArc(x1,h/2,x1,y1,cd4,270,false).replace("M","L")+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartDisplay":var x1,x2,y1,c3d4=270,cd2=180;x1=w*1/6;x2=w*5/6;y1=h*3/6;//path attrs: w = 6; h = 6;
    var d="M"+0+","+y1+" L"+x1+","+0+" L"+x2+","+0+shapeArc(w,h/2,x1,y1,c3d4,c3d4+cd2,false).replace("M","L")+" L"+x1+","+h+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartDelay":var wd2=w/2,hd2=h/2,cd2=180,c3d4=270,cd4=90;var d="M"+0+","+0+" L"+wd2+","+0+shapeArc(wd2,hd2,wd2,hd2,c3d4,c3d4+cd2,false).replace("M","L")+" L"+0+","+h+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"flowChartMagneticTape":var wd2=w/2,hd2=h/2,cd2=180,c3d4=270,cd4=90;var idy,ib,ang1;idy=hd2*Math.sin(Math.PI/4);ib=hd2+idy;ang1=Math.atan(h/w);var ang1Dg=ang1*180/Math.PI;var d="M"+wd2+","+h+shapeArc(wd2,hd2,wd2,hd2,cd4,cd2,false).replace("M","L")+shapeArc(wd2,hd2,wd2,hd2,cd2,c3d4,false).replace("M","L")+shapeArc(wd2,hd2,wd2,hd2,c3d4,360,false).replace("M","L")+shapeArc(wd2,hd2,wd2,hd2,0,ang1Dg,false).replace("M","L")+" L"+w+","+ib+" L"+w+","+h+" z";result+="<path d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"ellipse":case"flowChartConnector":case"flowChartSummingJunction":case"flowChartOr":result+="<ellipse cx='"+w/2+"' cy='"+h/2+"' rx='"+w/2+"' ry='"+h/2+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";if(shapType=="flowChartOr"){result+=" <polyline points='"+w/2+" "+0+","+w/2+" "+h+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";result+=" <polyline points='"+0+" "+h/2+","+w+" "+h/2+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";}else if(shapType=="flowChartSummingJunction"){var iDx,idy,il,ir,it,ib,hc=w/2,vc=h/2,wd2=w/2,hd2=h/2;var angVal=Math.PI/4;iDx=wd2*Math.cos(angVal);idy=hd2*Math.sin(angVal);il=hc-iDx;ir=hc+iDx;it=vc-idy;ib=vc+idy;result+=" <polyline points='"+il+" "+it+","+ir+" "+ib+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";result+=" <polyline points='"+ir+" "+it+","+il+" "+ib+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";}break;case"roundRect":case"round1Rect":case"round2DiagRect":case"round2SameRect":case"snip1Rect":case"snip2DiagRect":case"snip2SameRect":case"flowChartAlternateProcess":case"flowChartPunchedCard":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val;// = 0.33334;
    var sAdj2,sAdj2_val;// = 0.33334;
    var shpTyp,adjTyp;if(shapAdjst_ary!==undefined&&shapAdjst_ary.constructor===Array){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=parseInt(sAdj1.substr(4))/50000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj2_val=parseInt(sAdj2.substr(4))/50000;}}}else if(shapAdjst_ary!==undefined&&shapAdjst_ary.constructor!==Array){var sAdj=getTextByPathList(shapAdjst_ary,["attrs","fmla"]);sAdj1_val=parseInt(sAdj.substr(4))/50000;sAdj2_val=0;}//console.log("shapType: ",shapType,",node: ",node )
    var tranglRott="";switch(shapType){case"roundRect":case"flowChartAlternateProcess":shpTyp="round";adjTyp="cornrAll";if(sAdj1_val===undefined)sAdj1_val=0.33334;sAdj2_val=0;break;case"round1Rect":shpTyp="round";adjTyp="cornr1";if(sAdj1_val===undefined)sAdj1_val=0.33334;sAdj2_val=0;break;case"round2DiagRect":shpTyp="round";adjTyp="diag";if(sAdj1_val===undefined)sAdj1_val=0.33334;if(sAdj2_val===undefined)sAdj2_val=0;break;case"round2SameRect":shpTyp="round";adjTyp="cornr2";if(sAdj1_val===undefined)sAdj1_val=0.33334;if(sAdj2_val===undefined)sAdj2_val=0;break;case"snip1Rect":case"flowChartPunchedCard":shpTyp="snip";adjTyp="cornr1";if(sAdj1_val===undefined)sAdj1_val=0.33334;sAdj2_val=0;if(shapType=="flowChartPunchedCard"){tranglRott="transform='translate("+w+",0) scale(-1,1)'";}break;case"snip2DiagRect":shpTyp="snip";adjTyp="diag";if(sAdj1_val===undefined)sAdj1_val=0;if(sAdj2_val===undefined)sAdj2_val=0.33334;break;case"snip2SameRect":shpTyp="snip";adjTyp="cornr2";if(sAdj1_val===undefined)sAdj1_val=0.33334;if(sAdj2_val===undefined)sAdj2_val=0;break;}var d_val=shapeSnipRoundRect(w,h,sAdj1_val,sAdj2_val,shpTyp,adjTyp);result+="<path "+tranglRott+"  d='"+d_val+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"snipRoundRect":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=0.33334;var sAdj2,sAdj2_val=0.33334;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=parseInt(sAdj1.substr(4))/50000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj2_val=parseInt(sAdj2.substr(4))/50000;}}}var d_val="M0,"+h+" L"+w+","+h+" L"+w+","+h/2*sAdj2_val+" L"+(w/2+w/2*(1-sAdj2_val))+",0 L"+w/2*sAdj1_val+",0 Q0,0 0,"+h/2*sAdj1_val+" z";result+="<path   d='"+d_val+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"bentConnector2":var d="";// if (isFlipV) {
    //     d = "M 0 " + w + " L " + h + " " + w + " L " + h + " 0";
    // } else {
    d="M "+w+" 0 L "+w+" "+h+" L 0 "+h;//}
    result+="<path d='"+d+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' fill='none' ";if(headEndNodeAttrs!==undefined&&(headEndNodeAttrs["type"]==="triangle"||headEndNodeAttrs["type"]==="arrow")){result+="marker-start='url(#markerTriangle_"+shpId+")' ";}if(tailEndNodeAttrs!==undefined&&(tailEndNodeAttrs["type"]==="triangle"||tailEndNodeAttrs["type"]==="arrow")){result+="marker-end='url(#markerTriangle_"+shpId+")' ";}result+="/>";break;case"rtTriangle":result+=" <polygon points='0 0,0 "+h+","+w+" "+h+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"triangle":case"flowChartExtract":case"flowChartMerge":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var shapAdjst_val=0.5;if(shapAdjst!==undefined){shapAdjst_val=parseInt(shapAdjst.substr(4))*slideFactor;//console.log("w: "+w+"\nh: "+h+"\nshapAdjst: "+shapAdjst+"\nshapAdjst_val: "+shapAdjst_val);
    }var tranglRott="";if(shapType=="flowChartMerge"){tranglRott="transform='rotate(180 "+w/2+","+h/2+")'";}result+=" <polygon "+tranglRott+" points='"+w*shapAdjst_val+" 0,0 "+h+","+w+" "+h+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"diamond":case"flowChartDecision":case"flowChartSort":result+=" <polygon points='"+w/2+" 0,0 "+h/2+","+w/2+" "+h+","+w+" "+h/2+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";if(shapType=="flowChartSort"){result+=" <polyline points='0 "+h/2+","+w+" "+h/2+"' fill='none' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";}break;case"trapezoid":case"flowChartManualOperation":case"flowChartManualInput":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adjst_val=0.2;var max_adj_const=0.7407;if(shapAdjst!==undefined){var adjst=parseInt(shapAdjst.substr(4))*slideFactor;adjst_val=adjst*0.5/max_adj_const;// console.log("w: "+w+"\nh: "+h+"\nshapAdjst: "+shapAdjst+"\nadjst_val: "+adjst_val);
    }var cnstVal=0;var tranglRott="";if(shapType=="flowChartManualOperation"){tranglRott="transform='rotate(180 "+w/2+","+h/2+")'";}if(shapType=="flowChartManualInput"){adjst_val=0;cnstVal=h/5;}result+=" <polygon "+tranglRott+" points='"+w*adjst_val+" "+cnstVal+",0 "+h+","+w+" "+h+","+(1-adjst_val)*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"parallelogram":case"flowChartInputOutput":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adjst_val=0.25;var max_adj_const;if(w>h){max_adj_const=w/h;}else {max_adj_const=h/w;}if(shapAdjst!==undefined){var adjst=parseInt(shapAdjst.substr(4))/100000;adjst_val=adjst/max_adj_const;//console.log("w: "+w+"\nh: "+h+"\nadjst: "+adjst_val+"\nmax_adj_const: "+max_adj_const);
    }result+=" <polygon points='"+adjst_val*w+" 0,0 "+h+","+(1-adjst_val)*w+" "+h+","+w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"pentagon":result+=" <polygon points='"+0.5*w+" 0,0 "+0.375*h+","+0.15*w+" "+h+","+0.85*w+" "+h+","+w+" "+0.375*h+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"hexagon":case"flowChartPreparation":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=25000*slideFactor;var vf=115470*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var angVal1=60*Math.PI/180;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var maxAdj,a,shd2,x1,x2,dy1,y1,y2,vc=h/2,hd2=h/2;var ss=Math.min(w,h);maxAdj=cnstVal1*w/ss;a=adj<0?0:adj>maxAdj?maxAdj:adj;shd2=hd2*vf/cnstVal2;x1=ss*a/cnstVal2;x2=w-x1;dy1=shd2*Math.sin(angVal1);y1=vc-dy1;y2=vc+dy1;var d="M"+0+","+vc+" L"+x1+","+y1+" L"+x2+","+y1+" L"+w+","+vc+" L"+x2+","+y2+" L"+x1+","+y2+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"heptagon":result+=" <polygon points='"+0.5*w+" 0,"+w/8+" "+h/4+",0 "+5/8*h+","+w/4+" "+h+","+3/4*w+" "+h+","+w+" "+5/8*h+","+7/8*w+" "+h/4+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"octagon":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj1=0.25;if(shapAdjst!==undefined){adj1=parseInt(shapAdjst.substr(4))/100000;}var adj2=1-adj1;//console.log("adj1: "+adj1+"\nadj2: "+adj2);
    result+=" <polygon points='"+adj1*w+" 0,0 "+adj1*h+",0 "+adj2*h+","+adj1*w+" "+h+","+adj2*w+" "+h+","+w+" "+adj2*h+","+w+" "+adj1*h+","+adj2*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"decagon":result+=" <polygon points='"+3/8*w+" 0,"+w/8+" "+h/8+",0 "+h/2+","+w/8+" "+7/8*h+","+3/8*w+" "+h+","+5/8*w+" "+h+","+7/8*w+" "+7/8*h+","+w+" "+h/2+","+7/8*w+" "+h/8+","+5/8*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"dodecagon":result+=" <polygon points='"+3/8*w+" 0,"+w/8+" "+h/8+",0 "+3/8*h+",0 "+5/8*h+","+w/8+" "+7/8*h+","+3/8*w+" "+h+","+5/8*w+" "+h+","+7/8*w+" "+7/8*h+","+w+" "+5/8*h+","+w+" "+3/8*h+","+7/8*w+" "+h/8+","+5/8*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star4":var a,iwd2,ihd2,sdx,sdy,sx1,sx2,sy1,sy2;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2;var adj=19098*slideFactor;var cnstVal1=50000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star4 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){var name=shapAdjst["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }}a=adj<0?0:adj>cnstVal1?cnstVal1:adj;iwd2=wd2*a/cnstVal1;ihd2=hd2*a/cnstVal1;sdx=iwd2*Math.cos(0.7853981634);//cd8 = 2700000; (45°) =>
    sdy=ihd2*Math.sin(0.7853981634);sx1=hc-sdx;sx2=hc+sdx;sy1=vc-sdy;sy2=vc+sdy;var d="M0"+","+vc+" L"+sx1+","+sy1+" L"+hc+",0"+" L"+sx2+","+sy1+" L"+w+","+vc+" L"+sx2+","+sy2+" L"+hc+","+h+" L"+sx1+","+sy2+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star5":var a,swd2,shd2,svc,dx1,dx2,dy1,dy2,x1,x2,x3,x4,y1,y2,iwd2,ihd2,sdx1,sdx2,sdy1,sdy2,sx1,sx2,sx3,sx4,sy1,sy2,sy3;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2;var adj=19098*slideFactor;var hf=105146*slideFactor;var vf=110557*slideFactor;var maxAdj=50000*slideFactor;var cnstVal1=100000*slideFactor;//var radians = angle * (Math.PI / 180);
    var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star5 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){Object.keys(shapAdjst).forEach(function(key){var name=shapAdjst[key]["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }else if(name=="hf"){hf=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;}else if(name=="vf"){vf=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;}});}a=adj<0?0:adj>maxAdj?maxAdj:adj;swd2=wd2*hf/cnstVal1;shd2=hd2*vf/cnstVal1;svc=vc*vf/cnstVal1;dx1=swd2*Math.cos(0.31415926536);// 1080000
    dx2=swd2*Math.cos(5.3407075111);// 18360000
    dy1=shd2*Math.sin(0.31415926536);//1080000
    dy2=shd2*Math.sin(5.3407075111);// 18360000
    x1=hc-dx1;x2=hc-dx2;x3=hc+dx2;x4=hc+dx1;y1=svc-dy1;y2=svc-dy2;iwd2=swd2*a/maxAdj;ihd2=shd2*a/maxAdj;sdx1=iwd2*Math.cos(5.9690260418);// 20520000
    sdx2=iwd2*Math.cos(0.94247779608);// 3240000
    sdy1=ihd2*Math.sin(0.94247779608);// 3240000
    sdy2=ihd2*Math.sin(5.9690260418);// 20520000
    sx1=hc-sdx1;sx2=hc-sdx2;sx3=hc+sdx2;sx4=hc+sdx1;sy1=svc-sdy1;sy2=svc-sdy2;sy3=svc+ihd2;var d="M"+x1+","+y1+" L"+sx2+","+sy1+" L"+hc+","+0+" L"+sx3+","+sy1+" L"+x4+","+y1+" L"+sx4+","+sy2+" L"+x3+","+y2+" L"+hc+","+sy3+" L"+x2+","+y2+" L"+sx1+","+sy2+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star6":var a,swd2,dx1,x1,x2,y2,iwd2,ihd2,sdx2,sx1,sx2,sx3,sx4,sdy1,sy1,sy2;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2,hd4=h/4;var adj=28868*slideFactor;var hf=115470*slideFactor;var maxAdj=50000*slideFactor;var cnstVal1=100000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star5 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){Object.keys(shapAdjst).forEach(function(key){var name=shapAdjst[key]["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }else if(name=="hf"){hf=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;}});}a=adj<0?0:adj>maxAdj?maxAdj:adj;swd2=wd2*hf/cnstVal1;dx1=swd2*Math.cos(0.5235987756);//1800000->30 ->0.5235987756
    x1=hc-dx1;x2=hc+dx1;y2=vc+hd4;iwd2=swd2*a/maxAdj;ihd2=hd2*a/maxAdj;sdx2=iwd2/2;sx1=hc-iwd2;sx2=hc-sdx2;sx3=hc+sdx2;sx4=hc+iwd2;sdy1=ihd2*Math.sin(1.0471975512);//3600000->60->1.0471975512
    sy1=vc-sdy1;sy2=vc+sdy1;var d="M"+x1+","+hd4+" L"+sx2+","+sy1+" L"+hc+",0"+" L"+sx3+","+sy1+" L"+x2+","+hd4+" L"+sx4+","+vc+" L"+x2+","+y2+" L"+sx3+","+sy2+" L"+hc+","+h+" L"+sx2+","+sy2+" L"+x1+","+y2+" L"+sx1+","+vc+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star7":var a,swd2,shd2,svc,dx1,dx2,dx3,dy1,dy2,dy3,x1,x2,x3,x4,x5,x6,y1,y2,y3,iwd2,ihd2,sdx1,sdx2,sdx3,sx1,sx2,sx3,sx4,sx5,sx6,sdy1,sdy2,sdy3,sy1,sy2,sy3,sy4;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2;var adj=34601*slideFactor;var hf=102572*slideFactor;var vf=105210*slideFactor;var maxAdj=50000*slideFactor;var cnstVal1=100000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star5 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){Object.keys(shapAdjst).forEach(function(key){var name=shapAdjst[key]["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }else if(name=="hf"){hf=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;}else if(name=="vf"){vf=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;}});}a=adj<0?0:adj>maxAdj?maxAdj:adj;swd2=wd2*hf/cnstVal1;shd2=hd2*vf/cnstVal1;svc=vc*vf/cnstVal1;dx1=swd2*97493/100000;dx2=swd2*78183/100000;dx3=swd2*43388/100000;dy1=shd2*62349/100000;dy2=shd2*22252/100000;dy3=shd2*90097/100000;x1=hc-dx1;x2=hc-dx2;x3=hc-dx3;x4=hc+dx3;x5=hc+dx2;x6=hc+dx1;y1=svc-dy1;y2=svc+dy2;y3=svc+dy3;iwd2=swd2*a/maxAdj;ihd2=shd2*a/maxAdj;sdx1=iwd2*97493/100000;sdx2=iwd2*78183/100000;sdx3=iwd2*43388/100000;sx1=hc-sdx1;sx2=hc-sdx2;sx3=hc-sdx3;sx4=hc+sdx3;sx5=hc+sdx2;sx6=hc+sdx1;sdy1=ihd2*90097/100000;sdy2=ihd2*22252/100000;sdy3=ihd2*62349/100000;sy1=svc-sdy1;sy2=svc-sdy2;sy3=svc+sdy3;sy4=svc+ihd2;var d="M"+x1+","+y2+" L"+sx1+","+sy2+" L"+x2+","+y1+" L"+sx3+","+sy1+" L"+hc+",0"+" L"+sx4+","+sy1+" L"+x5+","+y1+" L"+sx6+","+sy2+" L"+x6+","+y2+" L"+sx5+","+sy3+" L"+x4+","+y3+" L"+hc+","+sy4+" L"+x3+","+y3+" L"+sx2+","+sy3+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star8":var a,dx1,x1,x2,dy1,y1,y2,iwd2,ihd2,sdx1,sdx2,sdy1,sdy2,sx1,sx2,sx3,sx4,sy1,sy2,sy3,sy4;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2;var adj=37500*slideFactor;var maxAdj=50000*slideFactor;var cnstVal1=100000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star4 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){var name=shapAdjst["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }}a=adj<0?0:adj>maxAdj?maxAdj:adj;dx1=wd2*Math.cos(0.7853981634);//2700000
    x1=hc-dx1;x2=hc+dx1;dy1=hd2*Math.sin(0.7853981634);//2700000
    y1=vc-dy1;y2=vc+dy1;iwd2=wd2*a/maxAdj;ihd2=hd2*a/maxAdj;sdx1=iwd2*92388/100000;sdx2=iwd2*38268/100000;sdy1=ihd2*92388/100000;sdy2=ihd2*38268/100000;sx1=hc-sdx1;sx2=hc-sdx2;sx3=hc+sdx2;sx4=hc+sdx1;sy1=vc-sdy1;sy2=vc-sdy2;sy3=vc+sdy2;sy4=vc+sdy1;var d="M0"+","+vc+" L"+sx1+","+sy2+" L"+x1+","+y1+" L"+sx2+","+sy1+" L"+hc+",0"+" L"+sx3+","+sy1+" L"+x2+","+y1+" L"+sx4+","+sy2+" L"+w+","+vc+" L"+sx4+","+sy3+" L"+x2+","+y2+" L"+sx3+","+sy4+" L"+hc+","+h+" L"+sx2+","+sy4+" L"+x1+","+y2+" L"+sx1+","+sy3+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star10":var a,swd2,dx1,dx2,x1,x2,x3,x4,dy1,dy2,y1,y2,y3,y4,iwd2,ihd2,sdx1,sdx2,sdy1,sdy2,sx1,sx2,sx3,sx4,sx5,sx6,sy1,sy2,sy3,sy4;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2;var adj=42533*slideFactor;var hf=105146*slideFactor;var maxAdj=50000*slideFactor;var cnstVal1=100000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star5 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){Object.keys(shapAdjst).forEach(function(key){var name=shapAdjst[key]["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }else if(name=="hf"){hf=parseInt(shapAdjst[key]["attrs"]["fmla"].substr(4))*slideFactor;}});}a=adj<0?0:adj>maxAdj?maxAdj:adj;swd2=wd2*hf/cnstVal1;dx1=swd2*95106/100000;dx2=swd2*58779/100000;x1=hc-dx1;x2=hc-dx2;x3=hc+dx2;x4=hc+dx1;dy1=hd2*80902/100000;dy2=hd2*30902/100000;y1=vc-dy1;y2=vc-dy2;y3=vc+dy2;y4=vc+dy1;iwd2=swd2*a/maxAdj;ihd2=hd2*a/maxAdj;sdx1=iwd2*80902/100000;sdx2=iwd2*30902/100000;sdy1=ihd2*95106/100000;sdy2=ihd2*58779/100000;sx1=hc-iwd2;sx2=hc-sdx1;sx3=hc-sdx2;sx4=hc+sdx2;sx5=hc+sdx1;sx6=hc+iwd2;sy1=vc-sdy1;sy2=vc-sdy2;sy3=vc+sdy2;sy4=vc+sdy1;var d="M"+x1+","+y2+" L"+sx2+","+sy2+" L"+x2+","+y1+" L"+sx3+","+sy1+" L"+hc+",0"+" L"+sx4+","+sy1+" L"+x3+","+y1+" L"+sx5+","+sy2+" L"+x4+","+y2+" L"+sx6+","+vc+" L"+x4+","+y3+" L"+sx5+","+sy3+" L"+x3+","+y4+" L"+sx4+","+sy4+" L"+hc+","+h+" L"+sx3+","+sy4+" L"+x2+","+y4+" L"+sx2+","+sy3+" L"+x1+","+y3+" L"+sx1+","+vc+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star12":var a,dx1,dy1,x1,x3,x4,y1,y3,y4,iwd2,ihd2,sdx1,sdx2,sdx3,sdy1,sdy2,sdy3,sx1,sx2,sx3,sx4,sx5,sx6,sy1,sy2,sy3,sy4,sy5,sy6;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2,hd4=h/4,wd4=w/4;var adj=37500*slideFactor;var maxAdj=50000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star4 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){var name=shapAdjst["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }}a=adj<0?0:adj>maxAdj?maxAdj:adj;dx1=wd2*Math.cos(0.5235987756);dy1=hd2*Math.sin(1.0471975512);x1=hc-dx1;x3=w*3/4;x4=hc+dx1;y1=vc-dy1;y3=h*3/4;y4=vc+dy1;iwd2=wd2*a/maxAdj;ihd2=hd2*a/maxAdj;sdx1=iwd2*Math.cos(0.2617993878);//900000->15
    sdx2=iwd2*Math.cos(0.7853981634);sdx3=iwd2*Math.cos(1.308996939);//4500000->75
    sdy1=ihd2*Math.sin(1.308996939);sdy2=ihd2*Math.sin(0.7853981634);sdy3=ihd2*Math.sin(0.2617993878);sx1=hc-sdx1;sx2=hc-sdx2;sx3=hc-sdx3;sx4=hc+sdx3;sx5=hc+sdx2;sx6=hc+sdx1;sy1=vc-sdy1;sy2=vc-sdy2;sy3=vc-sdy3;sy4=vc+sdy3;sy5=vc+sdy2;sy6=vc+sdy1;var d="M0"+","+vc+" L"+sx1+","+sy3+" L"+x1+","+hd4+" L"+sx2+","+sy2+" L"+wd4+","+y1+" L"+sx3+","+sy1+" L"+hc+",0"+" L"+sx4+","+sy1+" L"+x3+","+y1+" L"+sx5+","+sy2+" L"+x4+","+hd4+" L"+sx6+","+sy3+" L"+w+","+vc+" L"+sx6+","+sy4+" L"+x4+","+y3+" L"+sx5+","+sy5+" L"+x3+","+y4+" L"+sx4+","+sy6+" L"+hc+","+h+" L"+sx3+","+sy6+" L"+wd4+","+y4+" L"+sx2+","+sy5+" L"+x1+","+y3+" L"+sx1+","+sy4+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star16":var a,dx1,dx2,dx3,dy1,dy2,dy3,x1,x2,x3,x4,x5,x6,y1,y2,y3,y4,y5,y6,iwd2,ihd2,sdx1,sdx2,sdx3,sdx4,sdy1,sdy2,sdy3,sdy4,sx1,sx2,sx3,sx4,sx5,sx6,sx7,sx8,sy1,sy2,sy3,sy4,sy5,sy6,sy7,sy8,iDx,idy,il,it,ir,ib;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2;var adj=37500*slideFactor;var maxAdj=50000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star4 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){var name=shapAdjst["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst["attrs"]["fmla"].substr(4))*slideFactor;//min = 0
    //max = 50000
    }}a=adj<0?0:adj>maxAdj?maxAdj:adj;dx1=wd2*92388/100000;dx2=wd2*70711/100000;dx3=wd2*38268/100000;dy1=hd2*92388/100000;dy2=hd2*70711/100000;dy3=hd2*38268/100000;x1=hc-dx1;x2=hc-dx2;x3=hc-dx3;x4=hc+dx3;x5=hc+dx2;x6=hc+dx1;y1=vc-dy1;y2=vc-dy2;y3=vc-dy3;y4=vc+dy3;y5=vc+dy2;y6=vc+dy1;iwd2=wd2*a/maxAdj;ihd2=hd2*a/maxAdj;sdx1=iwd2*98079/100000;sdx2=iwd2*83147/100000;sdx3=iwd2*55557/100000;sdx4=iwd2*19509/100000;sdy1=ihd2*98079/100000;sdy2=ihd2*83147/100000;sdy3=ihd2*55557/100000;sdy4=ihd2*19509/100000;sx1=hc-sdx1;sx2=hc-sdx2;sx3=hc-sdx3;sx4=hc-sdx4;sx5=hc+sdx4;sx6=hc+sdx3;sx7=hc+sdx2;sx8=hc+sdx1;sy1=vc-sdy1;sy2=vc-sdy2;sy3=vc-sdy3;sy4=vc-sdy4;sy5=vc+sdy4;sy6=vc+sdy3;sy7=vc+sdy2;sy8=vc+sdy1;iDx=iwd2*Math.cos(0.7853981634);idy=ihd2*Math.sin(0.7853981634);il=hc-iDx;it=vc-idy;ir=hc+iDx;ib=vc+idy;var d="M0"+","+vc+" L"+sx1+","+sy4+" L"+x1+","+y3+" L"+sx2+","+sy3+" L"+x2+","+y2+" L"+sx3+","+sy2+" L"+x3+","+y1+" L"+sx4+","+sy1+" L"+hc+",0"+" L"+sx5+","+sy1+" L"+x4+","+y1+" L"+sx6+","+sy2+" L"+x5+","+y2+" L"+sx7+","+sy3+" L"+x6+","+y3+" L"+sx8+","+sy4+" L"+w+","+vc+" L"+sx8+","+sy5+" L"+x6+","+y4+" L"+sx7+","+sy6+" L"+x5+","+y5+" L"+sx6+","+sy7+" L"+x4+","+y6+" L"+sx5+","+sy8+" L"+hc+","+h+" L"+sx4+","+sy8+" L"+x3+","+y6+" L"+sx3+","+sy7+" L"+x2+","+y5+" L"+sx2+","+sy6+" L"+x1+","+y4+" L"+sx1+","+sy5+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star24":var a,dx1,dx2,dx3,dx4,dx5,dy1,dy2,dy3,dy4,dy5,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,iwd2,ihd2,sdx1,sdx2,sdx3,sdx4,sdx5,sdx6,sdy1,sdy2,sdy3,sdy4,sdy5,sdy6,sx1,sx2,sx3,sx4,sx5,sx6,sx7,sx8,sx9,sx10,sx11,sx12,sy1,sy2,sy3,sy4,sy5,sy6,sy7,sy8,sy9,sy10,sy11,sy12,iDx,idy,il,it,ir,ib;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2,hd4=h/4,wd4=w/4;var adj=37500*slideFactor;var maxAdj=50000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star4 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){var name=shapAdjst["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst["attrs"]["fmla"].substr(4))*slideFactor;}}a=adj<0?0:adj>maxAdj?maxAdj:adj;dx1=wd2*Math.cos(0.2617993878);dx2=wd2*Math.cos(0.5235987756);dx3=wd2*Math.cos(0.7853981634);dx4=wd4;dx5=wd2*Math.cos(1.308996939);dy1=hd2*Math.sin(1.308996939);dy2=hd2*Math.sin(1.0471975512);dy3=hd2*Math.sin(0.7853981634);dy4=hd4;dy5=hd2*Math.sin(0.2617993878);x1=hc-dx1;x2=hc-dx2;x3=hc-dx3;x4=hc-dx4;x5=hc-dx5;x6=hc+dx5;x7=hc+dx4;x8=hc+dx3;x9=hc+dx2;x10=hc+dx1;y1=vc-dy1;y2=vc-dy2;y3=vc-dy3;y4=vc-dy4;y5=vc-dy5;y6=vc+dy5;y7=vc+dy4;y8=vc+dy3;y9=vc+dy2;y10=vc+dy1;iwd2=wd2*a/maxAdj;ihd2=hd2*a/maxAdj;sdx1=iwd2*99144/100000;sdx2=iwd2*92388/100000;sdx3=iwd2*79335/100000;sdx4=iwd2*60876/100000;sdx5=iwd2*38268/100000;sdx6=iwd2*13053/100000;sdy1=ihd2*99144/100000;sdy2=ihd2*92388/100000;sdy3=ihd2*79335/100000;sdy4=ihd2*60876/100000;sdy5=ihd2*38268/100000;sdy6=ihd2*13053/100000;sx1=hc-sdx1;sx2=hc-sdx2;sx3=hc-sdx3;sx4=hc-sdx4;sx5=hc-sdx5;sx6=hc-sdx6;sx7=hc+sdx6;sx8=hc+sdx5;sx9=hc+sdx4;sx10=hc+sdx3;sx11=hc+sdx2;sx12=hc+sdx1;sy1=vc-sdy1;sy2=vc-sdy2;sy3=vc-sdy3;sy4=vc-sdy4;sy5=vc-sdy5;sy6=vc-sdy6;sy7=vc+sdy6;sy8=vc+sdy5;sy9=vc+sdy4;sy10=vc+sdy3;sy11=vc+sdy2;sy12=vc+sdy1;iDx=iwd2*Math.cos(0.7853981634);idy=ihd2*Math.sin(0.7853981634);il=hc-iDx;it=vc-idy;ir=hc+iDx;ib=vc+idy;var d="M0"+","+vc+" L"+sx1+","+sy6+" L"+x1+","+y5+" L"+sx2+","+sy5+" L"+x2+","+y4+" L"+sx3+","+sy4+" L"+x3+","+y3+" L"+sx4+","+sy3+" L"+x4+","+y2+" L"+sx5+","+sy2+" L"+x5+","+y1+" L"+sx6+","+sy1+" L"+hc+","+0+" L"+sx7+","+sy1+" L"+x6+","+y1+" L"+sx8+","+sy2+" L"+x7+","+y2+" L"+sx9+","+sy3+" L"+x8+","+y3+" L"+sx10+","+sy4+" L"+x9+","+y4+" L"+sx11+","+sy5+" L"+x10+","+y5+" L"+sx12+","+sy6+" L"+w+","+vc+" L"+sx12+","+sy7+" L"+x10+","+y6+" L"+sx11+","+sy8+" L"+x9+","+y7+" L"+sx10+","+sy9+" L"+x8+","+y8+" L"+sx9+","+sy10+" L"+x7+","+y9+" L"+sx8+","+sy11+" L"+x6+","+y10+" L"+sx7+","+sy12+" L"+hc+","+h+" L"+sx6+","+sy12+" L"+x5+","+y10+" L"+sx5+","+sy11+" L"+x4+","+y9+" L"+sx4+","+sy10+" L"+x3+","+y8+" L"+sx3+","+sy9+" L"+x2+","+y7+" L"+sx2+","+sy8+" L"+x1+","+y6+" L"+sx1+","+sy7+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"star32":var a,dx1,dx2,dx3,dx4,dx5,dx6,dx7,dy1,dy2,dy3,dy4,dy5,dy6,dy7,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12,y13,y14,iwd2,ihd2,sdx1,sdx2,sdx3,sdx4,sdx5,sdx6,sdx7,sdx8,sdy1,sdy2,sdy3,sdy4,sdy5,sdy6,sdy7,sdy8,sx1,sx2,sx3,sx4,sx5,sx6,sx7,sx8,sx9,sx10,sx11,sx12,sx13,sx14,sx15,sx16,sy1,sy2,sy3,sy4,sy5,sy6,sy7,sy8,sy9,sy10,sy11,sy12,sy13,sy14,sy15,sy16,iDx,idy,il,it,ir,ib;var hc=w/2,vc=h/2,wd2=w/2,hd2=h/2,hd4=h/4,wd4=w/4;var adj=37500*slideFactor;var maxAdj=50000*slideFactor;var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);//[0]["attrs"]["fmla"];
    //console.log("star4 node: ", node, "shapAdjst:", shapAdjst)
    if(shapAdjst!==undefined){var name=shapAdjst["attrs"]["name"];if(name=="adj"){adj=parseInt(shapAdjst["attrs"]["fmla"].substr(4))*slideFactor;}}a=adj<0?0:adj>maxAdj?maxAdj:adj;dx1=wd2*98079/100000;dx2=wd2*92388/100000;dx3=wd2*83147/100000;dx4=wd2*Math.cos(0.7853981634);dx5=wd2*55557/100000;dx6=wd2*38268/100000;dx7=wd2*19509/100000;dy1=hd2*98079/100000;dy2=hd2*92388/100000;dy3=hd2*83147/100000;dy4=hd2*Math.sin(0.7853981634);dy5=hd2*55557/100000;dy6=hd2*38268/100000;dy7=hd2*19509/100000;x1=hc-dx1;x2=hc-dx2;x3=hc-dx3;x4=hc-dx4;x5=hc-dx5;x6=hc-dx6;x7=hc-dx7;x8=hc+dx7;x9=hc+dx6;x10=hc+dx5;x11=hc+dx4;x12=hc+dx3;x13=hc+dx2;x14=hc+dx1;y1=vc-dy1;y2=vc-dy2;y3=vc-dy3;y4=vc-dy4;y5=vc-dy5;y6=vc-dy6;y7=vc-dy7;y8=vc+dy7;y9=vc+dy6;y10=vc+dy5;y11=vc+dy4;y12=vc+dy3;y13=vc+dy2;y14=vc+dy1;iwd2=wd2*a/maxAdj;ihd2=hd2*a/maxAdj;sdx1=iwd2*99518/100000;sdx2=iwd2*95694/100000;sdx3=iwd2*88192/100000;sdx4=iwd2*77301/100000;sdx5=iwd2*63439/100000;sdx6=iwd2*47140/100000;sdx7=iwd2*29028/100000;sdx8=iwd2*9802/100000;sdy1=ihd2*99518/100000;sdy2=ihd2*95694/100000;sdy3=ihd2*88192/100000;sdy4=ihd2*77301/100000;sdy5=ihd2*63439/100000;sdy6=ihd2*47140/100000;sdy7=ihd2*29028/100000;sdy8=ihd2*9802/100000;sx1=hc-sdx1;sx2=hc-sdx2;sx3=hc-sdx3;sx4=hc-sdx4;sx5=hc-sdx5;sx6=hc-sdx6;sx7=hc-sdx7;sx8=hc-sdx8;sx9=hc+sdx8;sx10=hc+sdx7;sx11=hc+sdx6;sx12=hc+sdx5;sx13=hc+sdx4;sx14=hc+sdx3;sx15=hc+sdx2;sx16=hc+sdx1;sy1=vc-sdy1;sy2=vc-sdy2;sy3=vc-sdy3;sy4=vc-sdy4;sy5=vc-sdy5;sy6=vc-sdy6;sy7=vc-sdy7;sy8=vc-sdy8;sy9=vc+sdy8;sy10=vc+sdy7;sy11=vc+sdy6;sy12=vc+sdy5;sy13=vc+sdy4;sy14=vc+sdy3;sy15=vc+sdy2;sy16=vc+sdy1;iDx=iwd2*Math.cos(0.7853981634);idy=ihd2*Math.sin(0.7853981634);il=hc-iDx;it=vc-idy;ir=hc+iDx;ib=vc+idy;var d="M0"+","+vc+" L"+sx1+","+sy8+" L"+x1+","+y7+" L"+sx2+","+sy7+" L"+x2+","+y6+" L"+sx3+","+sy6+" L"+x3+","+y5+" L"+sx4+","+sy5+" L"+x4+","+y4+" L"+sx5+","+sy4+" L"+x5+","+y3+" L"+sx6+","+sy3+" L"+x6+","+y2+" L"+sx7+","+sy2+" L"+x7+","+y1+" L"+sx8+","+sy1+" L"+hc+","+0+" L"+sx9+","+sy1+" L"+x8+","+y1+" L"+sx10+","+sy2+" L"+x9+","+y2+" L"+sx11+","+sy3+" L"+x10+","+y3+" L"+sx12+","+sy4+" L"+x11+","+y4+" L"+sx13+","+sy5+" L"+x12+","+y5+" L"+sx14+","+sy6+" L"+x13+","+y6+" L"+sx15+","+sy7+" L"+x14+","+y7+" L"+sx16+","+sy8+" L"+w+","+vc+" L"+sx16+","+sy9+" L"+x14+","+y8+" L"+sx15+","+sy10+" L"+x13+","+y9+" L"+sx14+","+sy11+" L"+x12+","+y10+" L"+sx13+","+sy12+" L"+x11+","+y11+" L"+sx12+","+sy13+" L"+x10+","+y12+" L"+sx11+","+sy14+" L"+x9+","+y13+" L"+sx10+","+sy15+" L"+x8+","+y14+" L"+sx9+","+sy16+" L"+hc+","+h+" L"+sx8+","+sy16+" L"+x7+","+y14+" L"+sx7+","+sy15+" L"+x6+","+y13+" L"+sx6+","+sy14+" L"+x5+","+y12+" L"+sx5+","+sy13+" L"+x4+","+y11+" L"+sx4+","+sy12+" L"+x3+","+y10+" L"+sx3+","+sy11+" L"+x2+","+y9+" L"+sx2+","+sy10+" L"+x1+","+y8+" L"+sx1+","+sy9+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"pie":case"pieWedge":case"arc":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var adj1,adj2,H,shapAdjst1,shapAdjst2,isClose;if(shapType=="pie"){adj1=0;adj2=270;H=h;isClose=true;}else if(shapType=="pieWedge"){adj1=180;adj2=270;H=2*h;isClose=true;}else if(shapType=="arc"){adj1=270;adj2=0;H=h;isClose=false;}if(shapAdjst!==undefined){shapAdjst1=getTextByPathList(shapAdjst,["attrs","fmla"]);shapAdjst2=shapAdjst1;if(shapAdjst1===undefined){shapAdjst1=shapAdjst[0]["attrs"]["fmla"];shapAdjst2=shapAdjst[1]["attrs"]["fmla"];}if(shapAdjst1!==undefined){adj1=parseInt(shapAdjst1.substr(4))/60000;}if(shapAdjst2!==undefined){adj2=parseInt(shapAdjst2.substr(4))/60000;}}var pieVals=shapePie(H,w,adj1,adj2,isClose);//console.log("shapType: ",shapType,"\nimgFillFlg: ",imgFillFlg,"\ngrndFillFlg: ",grndFillFlg,"\nshpId: ",shpId,"\nfillColor: ",fillColor);
    result+="<path   d='"+pieVals[0]+"' transform='"+pieVals[1]+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"chord":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=45;var sAdj2,sAdj2_val=270;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=parseInt(sAdj1.substr(4))/60000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj2_val=parseInt(sAdj2.substr(4))/60000;}}}var hR=h/2;var wR=w/2;var d_val=shapeArc(wR,hR,wR,hR,sAdj1_val,sAdj2_val,true);//console.log("shapType: ",shapType,", sAdj1_val: ",sAdj1_val,", sAdj2_val: ",sAdj2_val)
    result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"frame":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj1=12500*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst!==undefined){adj1=parseInt(shapAdjst.substr(4))*slideFactor;}var a1,x1,x4,y4;if(adj1<0)a1=0;else if(adj1>cnstVal1)a1=cnstVal1;else a1=adj1;x1=Math.min(w,h)*a1/cnstVal2;x4=w-x1;y4=h-x1;var d="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+"M"+x1+","+x1+" L"+x1+","+y4+" L"+x4+","+y4+" L"+x4+","+x1+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"donut":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var a,dr,iwd2,ihd2;if(adj<0)a=0;else if(adj>cnstVal1)a=cnstVal1;else a=adj;dr=Math.min(w,h)*a/cnstVal2;iwd2=w/2-dr;ihd2=h/2-dr;var d="M"+0+","+h/2+shapeArc(w/2,h/2,w/2,h/2,180,270,false).replace("M","L")+shapeArc(w/2,h/2,w/2,h/2,270,360,false).replace("M","L")+shapeArc(w/2,h/2,w/2,h/2,0,90,false).replace("M","L")+shapeArc(w/2,h/2,w/2,h/2,90,180,false).replace("M","L")+" z"+"M"+dr+","+h/2+shapeArc(w/2,h/2,iwd2,ihd2,180,90,false).replace("M","L")+shapeArc(w/2,h/2,iwd2,ihd2,90,0,false).replace("M","L")+shapeArc(w/2,h/2,iwd2,ihd2,0,-90,false).replace("M","L")+shapeArc(w/2,h/2,iwd2,ihd2,270,180,false).replace("M","L")+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"noSmoking":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=18750*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var a,dr,iwd2,ihd2,ang,ct,st,m,n,drd2,dang,dang2,swAng,t3,stAng1,stAng2;if(adj<0)a=0;else if(adj>cnstVal1)a=cnstVal1;else a=adj;dr=Math.min(w,h)*a/cnstVal2;iwd2=w/2-dr;ihd2=h/2-dr;ang=Math.atan(h/w);//ang2rad = ang*Math.PI/180;
    ct=ihd2*Math.cos(ang);st=iwd2*Math.sin(ang);m=Math.sqrt(ct*ct+st*st);//"mod ct st 0"
    n=iwd2*ihd2/m;drd2=dr/2;dang=Math.atan(drd2/n);dang2=dang*2;swAng=-Math.PI+dang2;//t3 = Math.atan(h/w);
    stAng1=ang-dang;stAng2=stAng1-Math.PI;var ct1,st1,m1,n1,dx1,dy1,x1,y1,y1,y2;ct1=ihd2*Math.cos(stAng1);st1=iwd2*Math.sin(stAng1);m1=Math.sqrt(ct1*ct1+st1*st1);//"mod ct1 st1 0"
    n1=iwd2*ihd2/m1;dx1=n1*Math.cos(stAng1);dy1=n1*Math.sin(stAng1);x1=w/2+dx1;y1=h/2+dy1;x2=w/2-dx1;y2=h/2-dy1;var stAng1deg=stAng1*180/Math.PI;var stAng2deg=stAng2*180/Math.PI;var swAng2deg=swAng*180/Math.PI;var d="M"+0+","+h/2+shapeArc(w/2,h/2,w/2,h/2,180,270,false).replace("M","L")+shapeArc(w/2,h/2,w/2,h/2,270,360,false).replace("M","L")+shapeArc(w/2,h/2,w/2,h/2,0,90,false).replace("M","L")+shapeArc(w/2,h/2,w/2,h/2,90,180,false).replace("M","L")+" z"+"M"+x1+","+y1+shapeArc(w/2,h/2,iwd2,ihd2,stAng1deg,stAng1deg+swAng2deg,false).replace("M","L")+" z"+"M"+x2+","+y2+shapeArc(w/2,h/2,iwd2,ihd2,stAng2deg,stAng2deg+swAng2deg,false).replace("M","L")+" z";//console.log("adj: ",adj,"x1:",x1,",y1:",y1," x2:",x2,",y2:",y2,",stAng1:",stAng1,",stAng1deg:",stAng1deg,",stAng2:",stAng2,",stAng2deg:",stAng2deg,",swAng:",swAng,",swAng2deg:",swAng2deg)
    result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"halfFrame":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=3.5;var sAdj2,sAdj2_val=3.5;var cnsVal=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj2_val=parseInt(sAdj2.substr(4))*slideFactor;}}}var minWH=Math.min(w,h);var maxAdj2=cnsVal*w/minWH;var a1,a2;if(sAdj2_val<0)a2=0;else if(sAdj2_val>maxAdj2)a2=maxAdj2;else a2=sAdj2_val;var x1=minWH*a2/cnsVal;var g1=h*x1/w;var g2=h-g1;var maxAdj1=cnsVal*g2/minWH;if(sAdj1_val<0)a1=0;else if(sAdj1_val>maxAdj1)a1=maxAdj1;else a1=sAdj1_val;var y1=minWH*a1/cnsVal;var dx2=y1*w/h;var x2=w-dx2;var dy2=x1*h/w;var y2=h-dy2;var d="M0,0"+" L"+w+","+0+" L"+x2+","+y1+" L"+x1+","+y1+" L"+x1+","+y2+" L0,"+h+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";//console.log("w: ",w,", h: ",h,", sAdj1_val: ",sAdj1_val,", sAdj2_val: ",sAdj2_val,",maxAdj1: ",maxAdj1,",maxAdj2: ",maxAdj2)
    break;case"blockArc":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=180;var sAdj2,adj2=0;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))/60000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))/60000;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var stAng,istAng,a3,sw11,sw12,swAng,iswAng;var cd1=360;if(adj1<0)stAng=0;else if(adj1>cd1)stAng=cd1;else stAng=adj1;//180
    if(adj2<0)istAng=0;else if(adj2>cd1)istAng=cd1;else istAng=adj2;//0
    if(adj3<0)a3=0;else if(adj3>cnstVal1)a3=cnstVal1;else a3=adj3;sw11=istAng-stAng;// -180
    sw12=sw11+cd1;//180
    swAng=sw11>0?sw11:sw12;//180
    iswAng=-swAng;//-180
    var endAng=stAng+swAng;var iendAng=istAng+iswAng;var wt1,ht1,dx1,dy1,x1,y1,stRd,istRd,wd2,hd2,hc,vc;stRd=stAng*Math.PI/180;istRd=istAng*Math.PI/180;wd2=w/2;hd2=h/2;hc=w/2;vc=h/2;if(stAng>90&&stAng<270){wt1=wd2*Math.sin(Math.PI/2-stRd);ht1=hd2*Math.cos(Math.PI/2-stRd);dx1=wd2*Math.cos(Math.atan(ht1/wt1));dy1=hd2*Math.sin(Math.atan(ht1/wt1));x1=hc-dx1;y1=vc-dy1;}else {wt1=wd2*Math.sin(stRd);ht1=hd2*Math.cos(stRd);dx1=wd2*Math.cos(Math.atan(wt1/ht1));dy1=hd2*Math.sin(Math.atan(wt1/ht1));x1=hc+dx1;y1=vc+dy1;}var dr,iwd2,ihd2,wt2,ht2,dx2,dy2,x2,y2;dr=Math.min(w,h)*a3/cnstVal2;iwd2=wd2-dr;ihd2=hd2-dr;//console.log("stAng: ",stAng," swAng: ",swAng ," endAng:",endAng)
    if(endAng<=450&&endAng>270||endAng>=630&&endAng<720){wt2=iwd2*Math.sin(istRd);ht2=ihd2*Math.cos(istRd);dx2=iwd2*Math.cos(Math.atan(wt2/ht2));dy2=ihd2*Math.sin(Math.atan(wt2/ht2));x2=hc+dx2;y2=vc+dy2;}else {wt2=iwd2*Math.sin(Math.PI/2-istRd);ht2=ihd2*Math.cos(Math.PI/2-istRd);dx2=iwd2*Math.cos(Math.atan(ht2/wt2));dy2=ihd2*Math.sin(Math.atan(ht2/wt2));x2=hc-dx2;y2=vc-dy2;}var d="M"+x1+","+y1+shapeArc(wd2,hd2,wd2,hd2,stAng,endAng,false).replace("M","L")+" L"+x2+","+y2+shapeArc(wd2,hd2,iwd2,ihd2,istAng,iendAng,false).replace("M","L")+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"bracePair":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=8333*slideFactor;var cnstVal1=25000*slideFactor;var cnstVal2=50000*slideFactor;var cnstVal3=100000*slideFactor;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var vc=h/2,cd=360,cd2=180,cd4=90,c3d4=270,a,x1,x2,x3,x4,y2,y3,y4;if(adj<0)a=0;else if(adj>cnstVal1)a=cnstVal1;else a=adj;var minWH=Math.min(w,h);x1=minWH*a/cnstVal3;x2=minWH*a/cnstVal2;x3=w-x2;x4=w-x1;y2=vc-x1;y3=vc+x1;y4=h-x1;//console.log("w:",w," h:",h," x1:",x1," x2:",x2," x3:",x3," x4:",x4," y2:",y2," y3:",y3," y4:",y4)
    var d="M"+x2+","+h+shapeArc(x2,y4,x1,x1,cd4,cd2,false).replace("M","L")+" L"+x1+","+y3+shapeArc(0,y3,x1,x1,0,-cd4,false).replace("M","L")+shapeArc(0,y2,x1,x1,cd4,0,false).replace("M","L")+" L"+x1+","+x1+shapeArc(x2,x1,x1,x1,cd2,c3d4,false).replace("M","L")+" M"+x3+","+0+shapeArc(x3,x1,x1,x1,c3d4,cd,false).replace("M","L")+" L"+x4+","+y2+shapeArc(w,y2,x1,x1,cd2,cd4,false).replace("M","L")+shapeArc(w,y3,x1,x1,c3d4,cd2,false).replace("M","L")+" L"+x4+","+y4+shapeArc(x3,y4,x1,x1,0,cd4,false).replace("M","L");result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftBrace":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=8333*slideFactor;var sAdj2,adj2=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}}}var vc=h/2,cd2=180,cd4=90,c3d4=270,a1,a2,q1,q2,q3,y1,y2,y3,y4;if(adj2<0)a2=0;else if(adj2>cnstVal2)a2=cnstVal2;else a2=adj2;var minWH=Math.min(w,h);q1=cnstVal2-a2;if(q1<a2)q2=q1;else q2=a2;q3=q2/2;var maxAdj1=q3*h/minWH;if(adj1<0)a1=0;else if(adj1>maxAdj1)a1=maxAdj1;else a1=adj1;y1=minWH*a1/cnstVal2;y3=h*a2/cnstVal2;y2=y3-y1;y4=y3+y1;//console.log("w:",w," h:",h," q1:",q1," q2:",q2," q3:",q3," y1:",y1," y3:",y3," y4:",y4," maxAdj1:",maxAdj1)
    var d="M"+w+","+h+shapeArc(w,h-y1,w/2,y1,cd4,cd2,false).replace("M","L")+" L"+w/2+","+y4+shapeArc(0,y4,w/2,y1,0,-cd4,false).replace("M","L")+shapeArc(0,y2,w/2,y1,cd4,0,false).replace("M","L")+" L"+w/2+","+y1+shapeArc(w,y1,w/2,y1,cd2,c3d4,false).replace("M","L");result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"rightBrace":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=8333*slideFactor;var sAdj2,adj2=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}}}var vc=h/2,cd=360,cd2=180,cd4=90,c3d4=270,a1,a2,q1,q2,q3,y1,y2,y3,y4;if(adj2<0)a2=0;else if(adj2>cnstVal2)a2=cnstVal2;else a2=adj2;var minWH=Math.min(w,h);q1=cnstVal2-a2;if(q1<a2)q2=q1;else q2=a2;q3=q2/2;var maxAdj1=q3*h/minWH;if(adj1<0)a1=0;else if(adj1>maxAdj1)a1=maxAdj1;else a1=adj1;y1=minWH*a1/cnstVal2;y3=h*a2/cnstVal2;y2=y3-y1;y4=h-y1;//console.log("w:",w," h:",h," q1:",q1," q2:",q2," q3:",q3," y1:",y1," y2:",y2," y3:",y3," y4:",y4," maxAdj1:",maxAdj1)
    var d="M"+0+","+0+shapeArc(0,y1,w/2,y1,c3d4,cd,false).replace("M","L")+" L"+w/2+","+y2+shapeArc(w,y2,w/2,y1,cd2,cd4,false).replace("M","L")+shapeArc(w,y3+y1,w/2,y1,c3d4,cd2,false).replace("M","L")+" L"+w/2+","+y4+shapeArc(0,y4,w/2,y1,0,cd4,false).replace("M","L");result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"bracketPair":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=16667*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var r=w,b=h,cd2=180,cd4=90,c3d4=270,a,x1,x2,y2;if(adj<0)a=0;else if(adj>cnstVal1)a=cnstVal1;else a=adj;x1=Math.min(w,h)*a/cnstVal2;x2=r-x1;y2=b-x1;//console.log("w:",w," h:",h," x1:",x1," x2:",x2," y2:",y2)
    var d=shapeArc(x1,x1,x1,x1,c3d4,cd2,false)+shapeArc(x1,y2,x1,x1,cd2,cd4,false).replace("M","L")+shapeArc(x2,x1,x1,x1,c3d4,c3d4+cd4,false)+shapeArc(x2,y2,x1,x1,0,cd4,false).replace("M","L");result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftBracket":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=8333*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var maxAdj=cnstVal1*h/Math.min(w,h);if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var r=w,b=h,cd2=180,cd4=90,c3d4=270,a,y1,y2;if(adj<0)a=0;else if(adj>maxAdj)a=maxAdj;else a=adj;y1=Math.min(w,h)*a/cnstVal2;if(y1>w)y1=w;y2=b-y1;var d="M"+r+","+b+shapeArc(y1,y2,y1,y1,cd4,cd2,false).replace("M","L")+" L"+0+","+y1+shapeArc(y1,y1,y1,y1,cd2,c3d4,false).replace("M","L")+" L"+r+","+0;result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"rightBracket":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=8333*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var maxAdj=cnstVal1*h/Math.min(w,h);if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var cd=360,cd2=180,cd4=90,c3d4=270,a,y1,y2,y3;if(adj<0)a=0;else if(adj>maxAdj)a=maxAdj;else a=adj;y1=Math.min(w,h)*a/cnstVal2;y2=h-y1;y3=w-y1;//console.log("w:",w," h:",h," y1:",y1," y2:",y2," y3:",y3)
    var d="M"+0+","+h+shapeArc(y3,y2,y1,y1,cd4,0,false).replace("M","L")+//" L"+ r + "," + y2 +
    " L"+w+","+h/2+shapeArc(y3,y1,y1,y1,cd,c3d4,false).replace("M","L")+" L"+0+","+0;result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"moon":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=0.5;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))/100000;//*96/914400;;
    }var hd2,cd2,cd4;hd2=h/2;cd2=180;cd4=90;var adj2=(1-adj)*w;var d="M"+w+","+h+shapeArc(w,hd2,w,hd2,cd4,cd4+cd2,false).replace("M","L")+shapeArc(w,hd2,adj2,hd2,cd4+cd2,cd4,false).replace("M","L")+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"corner":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=50000*slideFactor;var sAdj2,sAdj2_val=50000*slideFactor;var cnsVal=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj2_val=parseInt(sAdj2.substr(4))*slideFactor;}}}var minWH=Math.min(w,h);var maxAdj1=cnsVal*h/minWH;var maxAdj2=cnsVal*w/minWH;var a1,a2,x1,dy1,y1;if(sAdj1_val<0)a1=0;else if(sAdj1_val>maxAdj1)a1=maxAdj1;else a1=sAdj1_val;if(sAdj2_val<0)a2=0;else if(sAdj2_val>maxAdj2)a2=maxAdj2;else a2=sAdj2_val;x1=minWH*a2/cnsVal;dy1=minWH*a1/cnsVal;y1=h-dy1;var d="M0,0"+" L"+x1+","+0+" L"+x1+","+y1+" L"+w+","+y1+" L"+w+","+h+" L0,"+h+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"diagStripe":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var sAdj1_val=50000*slideFactor;var cnsVal=100000*slideFactor;if(shapAdjst!==undefined){sAdj1_val=parseInt(shapAdjst.substr(4))*slideFactor;}var a1,x2,y2;if(sAdj1_val<0)a1=0;else if(sAdj1_val>cnsVal)a1=cnsVal;else a1=sAdj1_val;x2=w*a1/cnsVal;y2=h*a1/cnsVal;var d="M"+0+","+y2+" L"+x2+","+0+" L"+w+","+0+" L"+0+","+h+" z";result+="<path   d='"+d+"'  fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"gear6":case"gear9":txtRotate=0;var gearNum=shapType.substr(4),d;if(gearNum=="6"){d=shapeGear(w,h/3.5,parseInt(gearNum));}else {//gearNum=="9"
    d=shapeGear(w,h/3.5,parseInt(gearNum));}result+="<path   d='"+d+"' transform='rotate(20,"+3/7*h+","+3/7*h+")' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"bentConnector3":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var shapAdjst_val=0.5;if(shapAdjst!==undefined){shapAdjst_val=parseInt(shapAdjst.substr(4))/100000;// if (isFlipV) {
    //     result += " <polyline points='" + w + " 0," + ((1 - shapAdjst_val) * w) + " 0," + ((1 - shapAdjst_val) * w) + " " + h + ",0 " + h + "' fill='transparent'" +
    //         "' stroke='" + border.color + "' stroke-width='" + border.width + "' stroke-dasharray='" + border.strokeDasharray + "' ";
    // } else {
    result+=" <polyline points='0 0,"+shapAdjst_val*w+" 0,"+shapAdjst_val*w+" "+h+","+w+" "+h+"' fill='transparent'"+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' ";//}
    if(headEndNodeAttrs!==undefined&&(headEndNodeAttrs["type"]==="triangle"||headEndNodeAttrs["type"]==="arrow")){result+="marker-start='url(#markerTriangle_"+shpId+")' ";}if(tailEndNodeAttrs!==undefined&&(tailEndNodeAttrs["type"]==="triangle"||tailEndNodeAttrs["type"]==="arrow")){result+="marker-end='url(#markerTriangle_"+shpId+")' ";}result+="/>";}break;case"plus":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj1=0.25;if(shapAdjst!==undefined){adj1=parseInt(shapAdjst.substr(4))/100000;}var adj2=1-adj1;result+=" <polygon points='"+adj1*w+" 0,"+adj1*w+" "+adj1*h+",0 "+adj1*h+",0 "+adj2*h+","+adj1*w+" "+adj2*h+","+adj1*w+" "+h+","+adj2*w+" "+h+","+adj2*w+" "+adj2*h+","+w+" "+adj2*h+","+ +w+" "+adj1*h+","+adj2*w+" "+adj1*h+","+adj2*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"teardrop":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj1=100000*slideFactor;var cnsVal1=adj1;var cnsVal2=200000*slideFactor;if(shapAdjst!==undefined){adj1=parseInt(shapAdjst.substr(4))*slideFactor;}var a1,r2,tw,th,sw,sh,dx1,dy1,x1,y1,x2,y2,rd45;if(adj1<0)a1=0;else if(adj1>cnsVal2)a1=cnsVal2;else a1=adj1;r2=Math.sqrt(2);tw=r2*(w/2);th=r2*(h/2);sw=tw*a1/cnsVal1;sh=th*a1/cnsVal1;rd45=45*Math.PI/180;dx1=sw*Math.cos(rd45);dy1=sh*Math.cos(rd45);x1=w/2+dx1;y1=h/2-dy1;x2=(w/2+x1)/2;y2=(h/2+y1)/2;var d_val=shapeArc(w/2,h/2,w/2,h/2,180,270,false)+"Q "+x2+",0 "+x1+","+y1+"Q "+w+","+y2+" "+w+","+h/2+shapeArc(w/2,h/2,w/2,h/2,0,90,false).replace("M","L")+shapeArc(w/2,h/2,w/2,h/2,90,180,false).replace("M","L")+" z";result+="<path   d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";// console.log("shapAdjst: ",shapAdjst,", adj1: ",adj1);
    break;case"plaque":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj1=16667*slideFactor;var cnsVal1=50000*slideFactor;var cnsVal2=100000*slideFactor;if(shapAdjst!==undefined){adj1=parseInt(shapAdjst.substr(4))*slideFactor;}var a1,x1,x2,y2;if(adj1<0)a1=0;else if(adj1>cnsVal1)a1=cnsVal1;else a1=adj1;x1=a1*Math.min(w,h)/cnsVal2;x2=w-x1;y2=h-x1;var d_val="M0,"+x1+shapeArc(0,0,x1,x1,90,0,false).replace("M","L")+" L"+x2+","+0+shapeArc(w,0,x1,x1,180,90,false).replace("M","L")+" L"+w+","+y2+shapeArc(w,h,x1,x1,270,180,false).replace("M","L")+" L"+x1+","+h+shapeArc(0,h,x1,x1,0,-90,false).replace("M","L")+" z";result+="<path   d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"sun":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var refr=slideFactor;var adj1=25000*refr;var cnstVal1=12500*refr;var cnstVal2=46875*refr;if(shapAdjst!==undefined){adj1=parseInt(shapAdjst.substr(4))*refr;}var a1;if(adj1<cnstVal1)a1=cnstVal1;else if(adj1>cnstVal2)a1=cnstVal2;else a1=adj1;var cnstVa3=50000*refr;var cnstVa4=100000*refr;var g0=cnstVa3-a1,g1=g0*(30274*refr)/(32768*refr),g2=g0*(12540*refr)/(32768*refr),g3=g1+cnstVa3,g4=g2+cnstVa3,g5=cnstVa3-g1,g6=cnstVa3-g2,g7=g0*(23170*refr)/(32768*refr),g8=cnstVa3+g7,g9=cnstVa3-g7,g10=g5*3/4,g11=g6*3/4,g12=g10+3662*refr,g13=g11+36620*refr,g14=g11+12500*refr,g15=cnstVa4-g10,g16=cnstVa4-g12,g17=cnstVa4-g13,g18=cnstVa4-g14,ox1=w*(18436*refr)/(21600*refr),oy1=h*(3163*refr)/(21600*refr),ox2=w*(3163*refr)/(21600*refr),oy2=h*(18436*refr)/(21600*refr),x8=w*g8/cnstVa4,x9=w*g9/cnstVa4,x10=w*g10/cnstVa4,x12=w*g12/cnstVa4,x13=w*g13/cnstVa4,x14=w*g14/cnstVa4,x15=w*g15/cnstVa4,x16=w*g16/cnstVa4,x17=w*g17/cnstVa4,x18=w*g18/cnstVa4,x19=w*a1/cnstVa4,wR=w*g0/cnstVa4,hR=h*g0/cnstVa4,y8=h*g8/cnstVa4,y9=h*g9/cnstVa4,y10=h*g10/cnstVa4,y12=h*g12/cnstVa4,y13=h*g13/cnstVa4,y14=h*g14/cnstVa4,y15=h*g15/cnstVa4,y16=h*g16/cnstVa4,y17=h*g17/cnstVa4,y18=h*g18/cnstVa4;var d_val="M"+w+","+h/2+" L"+x15+","+y18+" L"+x15+","+y14+"z"+" M"+ox1+","+oy1+" L"+x16+","+y17+" L"+x13+","+y12+"z"+" M"+w/2+","+0+" L"+x18+","+y10+" L"+x14+","+y10+"z"+" M"+ox2+","+oy1+" L"+x17+","+y12+" L"+x12+","+y17+"z"+" M"+0+","+h/2+" L"+x10+","+y14+" L"+x10+","+y18+"z"+" M"+ox2+","+oy2+" L"+x12+","+y13+" L"+x17+","+y16+"z"+" M"+w/2+","+h+" L"+x14+","+y15+" L"+x18+","+y15+"z"+" M"+ox1+","+oy2+" L"+x13+","+y16+" L"+x16+","+y13+" z"+" M"+x19+","+h/2+shapeArc(w/2,h/2,wR,hR,180,540,false).replace("M","L")+" z";//console.log("adj1: ",adj1,d_val);
    result+="<path   d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"heart":var dx1,dx2,x1,x2,x3,x4,y1;dx1=w*49/48;dx2=w*10/48;x1=w/2-dx1;x2=w/2-dx2;x3=w/2+dx2;x4=w/2+dx1;y1=-h/3;var d_val="M"+w/2+","+h/4+"C"+x3+","+y1+" "+x4+","+h/4+" "+w/2+","+h+"C"+x1+","+h/4+" "+x2+","+y1+" "+w/2+","+h/4+" z";result+="<path   d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"lightningBolt":var x1=w*5022/21600,x2=w*11050/21600,x3=w*8472/21600,x4=w*8757/21600,x5=w*10012/21600,x6=w*14767/21600,x7=w*12222/21600,x8=w*12860/21600,x9=w*13917/21600,x10=w*7602/21600,x11=w*16577/21600,y1=h*3890/21600,y2=h*6080/21600,y3=h*6797/21600,y4=h*7437/21600,y5=h*12877/21600,y6=h*9705/21600,y7=h*12007/21600,y8=h*13987/21600,y9=h*8382/21600,y10=h*14277/21600,y11=h*14915/21600;var d_val="M"+x3+","+0+" L"+x8+","+y2+" L"+x2+","+y3+" L"+x11+","+y7+" L"+x6+","+y5+" L"+w+","+h+" L"+x5+","+y11+" L"+x7+","+y8+" L"+x1+","+y6+" L"+x10+","+y9+" L"+0+","+y1+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"cube":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var refr=slideFactor;var adj=25000*refr;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*refr;}var d_val;var cnstVal2=100000*refr;var ss=Math.min(w,h);var a,y1,y4,x4;a=adj<0?0:adj>cnstVal2?cnstVal2:adj;y1=ss*a/cnstVal2;y4=h-y1;x4=w-y1;d_val="M"+0+","+y1+" L"+y1+","+0+" L"+w+","+0+" L"+w+","+y4+" L"+x4+","+h+" L"+0+","+h+" z"+"M"+0+","+y1+" L"+x4+","+y1+" M"+x4+","+y1+" L"+w+","+0+"M"+x4+","+y1+" L"+x4+","+h;result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"bevel":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var refr=slideFactor;var adj=12500*refr;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*refr;}var d_val;var cnstVal1=50000*refr;var cnstVal2=100000*refr;var ss=Math.min(w,h);var a,x1,x2,y2;a=adj<0?0:adj>cnstVal1?cnstVal1:adj;x1=ss*a/cnstVal2;x2=w-x1;y2=h-x1;d_val="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+x1+","+x1+" L"+x2+","+x1+" L"+x2+","+y2+" L"+x1+","+y2+" z"+" M"+0+","+0+" L"+x1+","+x1+" M"+0+","+h+" L"+x1+","+y2+" M"+w+","+0+" L"+x2+","+x1+" M"+w+","+h+" L"+x2+","+y2;result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"foldedCorner":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var refr=slideFactor;var adj=16667*refr;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*refr;}var d_val;var cnstVal1=50000*refr;var cnstVal2=100000*refr;var ss=Math.min(w,h);var a,dy2,dy1,x1,x2,y2,y1;a=adj<0?0:adj>cnstVal1?cnstVal1:adj;dy2=ss*a/cnstVal2;dy1=dy2/5;x1=w-dy2;x2=x1+dy1;y2=h-dy2;y1=y2+dy1;d_val="M"+x1+","+h+" L"+x2+","+y1+" L"+w+","+y2+" L"+x1+","+h+" L"+0+","+h+" L"+0+","+0+" L"+w+","+0+" L"+w+","+y2;result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"cloud":case"cloudCallout":var x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,y0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,rx3,rx4,rx5,rx6,rx7,ry1,ry2,ry3,ry4;x0=w*3900/43200;x1=w*4693/43200;x2=w*6928/43200;x3=w*16478/43200;x4=w*28827/43200;x5=w*34129/43200;x6=w*41798/43200;x7=w*38324/43200;x8=w*29078/43200;x9=w*22141/43200;x10=w*14000/43200;x11=w*4127/43200;y0=h*14370/43200;y1=h*26177/43200;y2=h*34899/43200;y3=h*39090/43200;y4=h*34751/43200;y5=h*22954/43200;y6=h*15354/43200;y7=h*5426/43200;y8=h*3952/43200;y9=h*4720/43200;y10=h*5192/43200;y11=h*15789/43200;//Path:
    //(path attrs: w = 43200; h = 43200; )
    var rX1=w*6753/43200,rY1=h*9190/43200,rX2=w*5333/43200,rY2=h*7267/43200,rX3=w*4365/43200,rY3=h*5945/43200,rX4=w*4857/43200,rY4=h*6595/43200,rY5=h*7273/43200,rX6=w*6775/43200,rY6=h*9220/43200,rX7=w*5785/43200,rY7=h*7867/43200,rX8=w*6752/43200,rY8=h*9215/43200,rX9=w*7720/43200,rY9=h*10543/43200,rX10=w*4360/43200,rY10=h*5918/43200,rX11=w*4345/43200;var sA1=-11429249/60000,wA1=7426832/60000,sA2=-8646143/60000,wA2=5396714/60000,sA3=-8748475/60000,wA3=5983381/60000,sA4=-7859164/60000,wA4=7034504/60000,sA5=-4722533/60000,wA5=6541615/60000,sA6=-2776035/60000,wA6=7816140/60000,sA7=37501/60000,wA7=6842000/60000,sA8=1347096/60000,wA8=6910353/60000,sA9=3974558/60000,wA9=4542661/60000,sA10=-16496525/60000,wA10=8804134/60000,sA11=-14809710/60000,wA11=9151131/60000;var cX0,cX1,cX2,cX3,cX4,cX5,cX6,cX7,cX8,cX9,cX10,cY0,cY1,cY2,cY3,cY4,cY5,cY6,cY7,cY8,cY9,cY10;var arc1,arc2,arc3,arc4,arc5,arc6,arc7,arc8,arc9,arc10,arc11;var lxy1,lxy2,lxy3,lxy4,lxy5,lxy6,lxy7,lxy8,lxy9,lxy10;cX0=x0-rX1*Math.cos(sA1*Math.PI/180);cY0=y0-rY1*Math.sin(sA1*Math.PI/180);arc1=shapeArc(cX0,cY0,rX1,rY1,sA1,sA1+wA1,false).replace("M","L");lxy1=arc1.substr(arc1.lastIndexOf("L")+1).split(" ");cX1=parseInt(lxy1[0])-rX2*Math.cos(sA2*Math.PI/180);cY1=parseInt(lxy1[1])-rY2*Math.sin(sA2*Math.PI/180);arc2=shapeArc(cX1,cY1,rX2,rY2,sA2,sA2+wA2,false).replace("M","L");lxy2=arc2.substr(arc2.lastIndexOf("L")+1).split(" ");cX2=parseInt(lxy2[0])-rX3*Math.cos(sA3*Math.PI/180);cY2=parseInt(lxy2[1])-rY3*Math.sin(sA3*Math.PI/180);arc3=shapeArc(cX2,cY2,rX3,rY3,sA3,sA3+wA3,false).replace("M","L");lxy3=arc3.substr(arc3.lastIndexOf("L")+1).split(" ");cX3=parseInt(lxy3[0])-rX4*Math.cos(sA4*Math.PI/180);cY3=parseInt(lxy3[1])-rY4*Math.sin(sA4*Math.PI/180);arc4=shapeArc(cX3,cY3,rX4,rY4,sA4,sA4+wA4,false).replace("M","L");lxy4=arc4.substr(arc4.lastIndexOf("L")+1).split(" ");cX4=parseInt(lxy4[0])-rX2*Math.cos(sA5*Math.PI/180);cY4=parseInt(lxy4[1])-rY5*Math.sin(sA5*Math.PI/180);arc5=shapeArc(cX4,cY4,rX2,rY5,sA5,sA5+wA5,false).replace("M","L");lxy5=arc5.substr(arc5.lastIndexOf("L")+1).split(" ");cX5=parseInt(lxy5[0])-rX6*Math.cos(sA6*Math.PI/180);cY5=parseInt(lxy5[1])-rY6*Math.sin(sA6*Math.PI/180);arc6=shapeArc(cX5,cY5,rX6,rY6,sA6,sA6+wA6,false).replace("M","L");lxy6=arc6.substr(arc6.lastIndexOf("L")+1).split(" ");cX6=parseInt(lxy6[0])-rX7*Math.cos(sA7*Math.PI/180);cY6=parseInt(lxy6[1])-rY7*Math.sin(sA7*Math.PI/180);arc7=shapeArc(cX6,cY6,rX7,rY7,sA7,sA7+wA7,false).replace("M","L");lxy7=arc7.substr(arc7.lastIndexOf("L")+1).split(" ");cX7=parseInt(lxy7[0])-rX8*Math.cos(sA8*Math.PI/180);cY7=parseInt(lxy7[1])-rY8*Math.sin(sA8*Math.PI/180);arc8=shapeArc(cX7,cY7,rX8,rY8,sA8,sA8+wA8,false).replace("M","L");lxy8=arc8.substr(arc8.lastIndexOf("L")+1).split(" ");cX8=parseInt(lxy8[0])-rX9*Math.cos(sA9*Math.PI/180);cY8=parseInt(lxy8[1])-rY9*Math.sin(sA9*Math.PI/180);arc9=shapeArc(cX8,cY8,rX9,rY9,sA9,sA9+wA9,false).replace("M","L");lxy9=arc9.substr(arc9.lastIndexOf("L")+1).split(" ");cX9=parseInt(lxy9[0])-rX10*Math.cos(sA10*Math.PI/180);cY9=parseInt(lxy9[1])-rY10*Math.sin(sA10*Math.PI/180);arc10=shapeArc(cX9,cY9,rX10,rY10,sA10,sA10+wA10,false).replace("M","L");lxy10=arc10.substr(arc10.lastIndexOf("L")+1).split(" ");cX10=parseInt(lxy10[0])-rX11*Math.cos(sA11*Math.PI/180);cY10=parseInt(lxy10[1])-rY3*Math.sin(sA11*Math.PI/180);arc11=shapeArc(cX10,cY10,rX11,rY3,sA11,sA11+wA11,false).replace("M","L");var d1="M"+x0+","+y0+arc1+arc2+arc3+arc4+arc5+arc6+arc7+arc8+arc9+arc10+arc11+" z";if(shapType=="cloudCallout"){var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var refr=slideFactor;var sAdj1,adj1=-20833*refr;var sAdj2,adj2=62500*refr;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*refr;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*refr;}}}var d_val;var cnstVal2=100000*refr;var ss=Math.min(w,h);var wd2=w/2,hd2=h/2;var dxPos,dyPos,xPos,yPos,ht,wt,g2,g3,g4,g5,g6,g7,g8,g9,g10,g11,g12,g13,g14,g15,g16,g17,g18,g19,g20,g21,g22,g23,g24,g25,g26,x23,x24,x25;dxPos=w*adj1/cnstVal2;dyPos=h*adj2/cnstVal2;xPos=wd2+dxPos;yPos=hd2+dyPos;ht=hd2*Math.cos(Math.atan(dyPos/dxPos));wt=wd2*Math.sin(Math.atan(dyPos/dxPos));g2=wd2*Math.cos(Math.atan(wt/ht));g3=hd2*Math.sin(Math.atan(wt/ht));//console.log("adj1: ",adj1,"adj2: ",adj2)
    if(adj1>=0){g4=wd2+g2;g5=hd2+g3;}else {g4=wd2-g2;g5=hd2-g3;}g6=g4-xPos;g7=g5-yPos;g8=Math.sqrt(g6*g6+g7*g7);g9=ss*6600/21600;g10=g8-g9;g11=g10/3;g12=ss*1800/21600;g13=g11+g12;g14=g13*g6/g8;g15=g13*g7/g8;g16=g14+xPos;g17=g15+yPos;g18=ss*4800/21600;g19=g11*2;g20=g18+g19;g21=g20*g6/g8;g22=g20*g7/g8;g23=g21+xPos;g24=g22+yPos;g25=ss*1200/21600;g26=ss*600/21600;x23=xPos+g26;x24=g16+g25;x25=g23+g12;d_val=//" M" + x23 + "," + yPos +
    shapeArc(x23-g26,yPos,g26,g26,0,360,false)+//.replace("M","L") +
    " z"+" M"+x24+","+g17+shapeArc(x24-g25,g17,g25,g25,0,360,false).replace("M","L")+" z"+" M"+x25+","+g24+shapeArc(x25-g12,g24,g12,g12,0,360,false).replace("M","L")+" z";d1+=d_val;}result+="<path d='"+d1+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"smileyFace":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var refr=slideFactor;var adj=4653*refr;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*refr;}var d_val;var cnstVal1=50000*refr;var cnstVal2=100000*refr;var cnstVal3=4653*refr;var ss=Math.min(w,h);var a,x1,x2,x3,x4,y1,y3,dy2,y2,y4,dy3,y5,wR,hR,wd2,hd2;wd2=w/2;hd2=h/2;a=adj<-cnstVal3?-cnstVal3:adj>cnstVal3?cnstVal3:adj;x1=w*4969/21699;x2=w*6215/21600;x3=w*13135/21600;x4=w*16640/21600;y1=h*7570/21600;y3=h*16515/21600;dy2=h*a/cnstVal2;y2=y3-dy2;y4=y3+dy2;dy3=h*a/cnstVal1;y5=y4+dy3;wR=w*1125/21600;hR=h*1125/21600;var cX1=x2-wR*Math.cos(Math.PI);var cY1=y1-hR*Math.sin(Math.PI);var cX2=x3-wR*Math.cos(Math.PI);d_val=//eyes
    shapeArc(cX1,cY1,wR,hR,180,540,false)+shapeArc(cX2,cY1,wR,hR,180,540,false)+//mouth
    " M"+x1+","+y2+" Q"+wd2+","+y5+" "+x4+","+y2+" Q"+wd2+","+y5+" "+x1+","+y2+//head
    " M"+0+","+hd2+shapeArc(wd2,hd2,wd2,hd2,180,540,false).replace("M","L")+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"verticalScroll":case"horizontalScroll":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var refr=slideFactor;var adj=12500*refr;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*refr;}var d_val;var cnstVal1=25000*refr;var cnstVal2=100000*refr;var ss=Math.min(w,h);var t=0,l=0,b=h,r=w;var a,ch,ch2,ch4;a=adj<0?0:adj>cnstVal1?cnstVal1:adj;ch=ss*a/cnstVal2;ch2=ch/2;ch4=ch/4;if(shapType=="verticalScroll"){var x3,x4,x6,x7,x5,y3,y4;x3=ch+ch2;x4=ch+ch;x6=r-ch;x7=r-ch2;x5=x6-ch2;y3=b-ch;y4=b-ch2;d_val="M"+ch+","+y3+" L"+ch+","+ch2+shapeArc(x3,ch2,ch2,ch2,180,270,false).replace("M","L")+" L"+x7+","+t+shapeArc(x7,ch2,ch2,ch2,270,450,false).replace("M","L")+" L"+x6+","+ch+" L"+x6+","+y4+shapeArc(x5,y4,ch2,ch2,0,90,false).replace("M","L")+" L"+ch2+","+b+shapeArc(ch2,y4,ch2,ch2,90,270,false).replace("M","L")+" z"+" M"+x3+","+t+shapeArc(x3,ch2,ch2,ch2,270,450,false).replace("M","L")+shapeArc(x3,x3/2,ch4,ch4,90,270,false).replace("M","L")+" L"+x4+","+ch2+" M"+x6+","+ch+" L"+x3+","+ch+" M"+ch+","+y4+shapeArc(ch2,y4,ch2,ch2,0,270,false).replace("M","L")+shapeArc(ch2,(y4+y3)/2,ch4,ch4,270,450,false).replace("M","L")+" z"+" M"+ch+","+y4+" L"+ch+","+y3;}else if(shapType=="horizontalScroll"){var y3,y4,y6,y7,y5,x3,x4;y3=ch+ch2;y4=ch+ch;y6=b-ch;y7=b-ch2;y5=y6-ch2;x3=r-ch;x4=r-ch2;d_val="M"+l+","+y3+shapeArc(ch2,y3,ch2,ch2,180,270,false).replace("M","L")+" L"+x3+","+ch+" L"+x3+","+ch2+shapeArc(x4,ch2,ch2,ch2,180,360,false).replace("M","L")+" L"+r+","+y5+shapeArc(x4,y5,ch2,ch2,0,90,false).replace("M","L")+" L"+ch+","+y6+" L"+ch+","+y7+shapeArc(ch2,y7,ch2,ch2,0,180,false).replace("M","L")+" z"+"M"+x4+","+ch+shapeArc(x4,ch2,ch2,ch2,90,-180,false).replace("M","L")+shapeArc((x3+x4)/2,ch2,ch4,ch4,180,0,false).replace("M","L")+" z"+" M"+x4+","+ch+" L"+x3+","+ch+" M"+ch2+","+y4+" L"+ch2+","+y3+shapeArc(y3/2,y3,ch4,ch4,180,360,false).replace("M","L")+shapeArc(ch2,y3,ch2,ch2,0,180,false).replace("M","L")+" M"+ch+","+y3+" L"+ch+","+y6;}result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"wedgeEllipseCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var refr=slideFactor;var sAdj1,adj1=-20833*refr;var sAdj2,adj2=62500*refr;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*refr;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*refr;}}}var d_val;var cnstVal1=100000*slideFactor;var angVal1=11*Math.PI/180;var ss=Math.min(w,h);var dxPos,dyPos,xPos,yPos,sdx,sdy,pang,stAng,enAng,dx1,dy1,x1,y1,dx2,dy2,x2,y2,stAng1,swAng2,swAng,vc=h/2,hc=w/2;dxPos=w*adj1/cnstVal1;dyPos=h*adj2/cnstVal1;xPos=hc+dxPos;yPos=vc+dyPos;sdx=dxPos*h;sdy=dyPos*w;pang=Math.atan(sdy/sdx);stAng=pang+angVal1;enAng=pang-angVal1;// console.log("dxPos: ", dxPos, "dyPos: ", dyPos);
    dx1=hc*Math.cos(stAng);dy1=vc*Math.sin(stAng);dx2=hc*Math.cos(enAng);dy2=vc*Math.sin(enAng);if(dxPos>=0){x1=hc+dx1;y1=vc+dy1;x2=hc+dx2;y2=vc+dy2;}else {x1=hc-dx1;y1=vc-dy1;x2=hc-dx2;y2=vc-dy2;}/*
                    //stAng = pang+angVal1;
                    //enAng = pang-angVal1;
                    //dx1 = hc*Math.cos(stAng);
                    //dy1 = vc*Math.sin(stAng);
                    x1 = hc+dx1;
                    y1 = vc+dy1;
                    dx2 = hc*Math.cos(enAng);
                    dy2 = vc*Math.sin(enAng);
                    x2 = hc+dx2;
                    y2 = vc+dy2;
                    stAng1 = Math.atan(dy1/dx1);
                    enAng1 = Math.atan(dy2/dx2);
                    swAng1 = enAng1-stAng1;
                    swAng2 = swAng1+2*Math.PI;
                    swAng = (swAng1 > 0)?swAng1:swAng2;
                    var stAng1Dg = stAng1*180/Math.PI;
                    var swAngDg = swAng*180/Math.PI;
                    var endAng = stAng1Dg + swAngDg;
                    */d_val="M"+x1+","+y1+" L"+xPos+","+yPos+" L"+x2+","+y2+//" z" +
    shapeArc(hc,vc,hc,vc,0,360,true);// +
    //shapeArc(hc,vc,hc,vc,stAng1Dg,stAng1Dg+swAngDg,false).replace("M","L") +
    //" z";
    result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"wedgeRectCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var refr=slideFactor;var sAdj1,adj1=-20833*refr;var sAdj2,adj2=62500*refr;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*refr;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*refr;}}}var d_val;var cnstVal1=100000*slideFactor;var dxPos,dyPos,xPos,yPos,dx,dy,dq,ady,adq,dz,xg1,xg2,x1,x2,yg1,yg2,y1,y2,t1,xl,t2,xt,t3,xr,t4,xb,t5,yl,t6,yt,t7,yr,t8,yb,vc=h/2,hc=w/2;dxPos=w*adj1/cnstVal1;dyPos=h*adj2/cnstVal1;xPos=hc+dxPos;yPos=vc+dyPos;dx=xPos-hc;dy=yPos-vc;dq=dxPos*h/w;ady=Math.abs(dyPos);adq=Math.abs(dq);dz=ady-adq;xg1=dxPos>0?7:2;xg2=dxPos>0?10:5;x1=w*xg1/12;x2=w*xg2/12;yg1=dyPos>0?7:2;yg2=dyPos>0?10:5;y1=h*yg1/12;y2=h*yg2/12;t1=dxPos>0?0:xPos;xl=dz>0?0:t1;t2=dyPos>0?x1:xPos;xt=dz>0?t2:x1;t3=dxPos>0?xPos:w;xr=dz>0?w:t3;t4=dyPos>0?xPos:x1;xb=dz>0?t4:x1;t5=dxPos>0?y1:yPos;yl=dz>0?y1:t5;t6=dyPos>0?0:yPos;yt=dz>0?t6:0;t7=dxPos>0?yPos:y1;yr=dz>0?y1:t7;t8=dyPos>0?yPos:h;yb=dz>0?t8:h;d_val="M"+0+","+0+" L"+x1+","+0+" L"+xt+","+yt+" L"+x2+","+0+" L"+w+","+0+" L"+w+","+y1+" L"+xr+","+yr+" L"+w+","+y2+" L"+w+","+h+" L"+x2+","+h+" L"+xb+","+yb+" L"+x1+","+h+" L"+0+","+h+" L"+0+","+y2+" L"+xl+","+yl+" L"+0+","+y1+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"wedgeRoundRectCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var refr=slideFactor;var sAdj1,adj1=-20833*refr;var sAdj2,adj2=62500*refr;var sAdj3,adj3=16667*refr;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*refr;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*refr;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*refr;}}}var d_val;var cnstVal1=100000*slideFactor;var ss=Math.min(w,h);var dxPos,dyPos,xPos,yPos,dq,ady,adq,dz,xg1,xg2,x1,x2,yg1,yg2,y1,y2,t1,xl,t2,xt,t3,xr,t4,xb,t5,yl,t6,yt,t7,yr,t8,yb,u1,u2,v2,vc=h/2,hc=w/2;dxPos=w*adj1/cnstVal1;dyPos=h*adj2/cnstVal1;xPos=hc+dxPos;yPos=vc+dyPos;dq=dxPos*h/w;ady=Math.abs(dyPos);adq=Math.abs(dq);dz=ady-adq;xg1=dxPos>0?7:2;xg2=dxPos>0?10:5;x1=w*xg1/12;x2=w*xg2/12;yg1=dyPos>0?7:2;yg2=dyPos>0?10:5;y1=h*yg1/12;y2=h*yg2/12;t1=dxPos>0?0:xPos;xl=dz>0?0:t1;t2=dyPos>0?x1:xPos;xt=dz>0?t2:x1;t3=dxPos>0?xPos:w;xr=dz>0?w:t3;t4=dyPos>0?xPos:x1;xb=dz>0?t4:x1;t5=dxPos>0?y1:yPos;yl=dz>0?y1:t5;t6=dyPos>0?0:yPos;yt=dz>0?t6:0;t7=dxPos>0?yPos:y1;yr=dz>0?y1:t7;t8=dyPos>0?yPos:h;yb=dz>0?t8:h;u1=ss*adj3/cnstVal1;u2=w-u1;v2=h-u1;d_val="M"+0+","+u1+shapeArc(u1,u1,u1,u1,180,270,false).replace("M","L")+" L"+x1+","+0+" L"+xt+","+yt+" L"+x2+","+0+" L"+u2+","+0+shapeArc(u2,u1,u1,u1,270,360,false).replace("M","L")+" L"+w+","+y1+" L"+xr+","+yr+" L"+w+","+y2+" L"+w+","+v2+shapeArc(u2,v2,u1,u1,0,90,false).replace("M","L")+" L"+x2+","+h+" L"+xb+","+yb+" L"+x1+","+h+" L"+u1+","+h+shapeArc(u1,v2,u1,u1,90,180,false).replace("M","L")+" L"+0+","+y2+" L"+xl+","+yl+" L"+0+","+y1+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"accentBorderCallout1":case"accentBorderCallout2":case"accentBorderCallout3":case"borderCallout1":case"borderCallout2":case"borderCallout3":case"accentCallout1":case"accentCallout2":case"accentCallout3":case"callout1":case"callout2":case"callout3":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var refr=slideFactor;var sAdj1,adj1=18750*refr;var sAdj2,adj2=-8333*refr;var sAdj3,adj3=18750*refr;var sAdj4,adj4=-16667*refr;var sAdj5,adj5=100000*refr;var sAdj6,adj6=-16667*refr;var sAdj7,adj7=112963*refr;var sAdj8,adj8=-8333*refr;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*refr;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*refr;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*refr;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*refr;}else if(sAdj_name=="adj5"){sAdj5=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj5=parseInt(sAdj5.substr(4))*refr;}else if(sAdj_name=="adj6"){sAdj6=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj6=parseInt(sAdj6.substr(4))*refr;}else if(sAdj_name=="adj7"){sAdj7=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj7=parseInt(sAdj7.substr(4))*refr;}else if(sAdj_name=="adj8"){sAdj8=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj8=parseInt(sAdj8.substr(4))*refr;}}}var d_val;var cnstVal1=100000*refr;switch(shapType){case"borderCallout1":case"callout1":if(shapAdjst_ary===undefined){adj1=18750*refr;adj2=-8333*refr;adj3=112500*refr;adj4=-38333*refr;}var y1,x1,y2,x2;y1=h*adj1/cnstVal1;x1=w*adj2/cnstVal1;y2=h*adj3/cnstVal1;x2=w*adj4/cnstVal1;d_val="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+x1+","+y1+" L"+x2+","+y2;break;case"borderCallout2":case"callout2":if(shapAdjst_ary===undefined){adj1=18750*refr;adj2=-8333*refr;adj3=18750*refr;adj4=-16667*refr;adj5=112500*refr;adj6=-46667*refr;}var y1,x1,y2,x2,y3,x3;y1=h*adj1/cnstVal1;x1=w*adj2/cnstVal1;y2=h*adj3/cnstVal1;x2=w*adj4/cnstVal1;y3=h*adj5/cnstVal1;x3=w*adj6/cnstVal1;d_val="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+x1+","+y1+" L"+x2+","+y2+" L"+x3+","+y3+" L"+x2+","+y2;break;case"borderCallout3":case"callout3":if(shapAdjst_ary===undefined){adj1=18750*refr;adj2=-8333*refr;adj3=18750*refr;adj4=-16667*refr;adj5=100000*refr;adj6=-16667*refr;adj7=112963*refr;adj8=-8333*refr;}var y1,x1,y2,x2,y3,x3,y4,x4;y1=h*adj1/cnstVal1;x1=w*adj2/cnstVal1;y2=h*adj3/cnstVal1;x2=w*adj4/cnstVal1;y3=h*adj5/cnstVal1;x3=w*adj6/cnstVal1;y4=h*adj7/cnstVal1;x4=w*adj8/cnstVal1;d_val="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+x1+","+y1+" L"+x2+","+y2+" L"+x3+","+y3+" L"+x4+","+y4+" L"+x3+","+y3+" L"+x2+","+y2;break;case"accentBorderCallout1":case"accentCallout1":if(shapAdjst_ary===undefined){adj1=18750*refr;adj2=-8333*refr;adj3=112500*refr;adj4=-38333*refr;}var y1,x1,y2,x2;y1=h*adj1/cnstVal1;x1=w*adj2/cnstVal1;y2=h*adj3/cnstVal1;x2=w*adj4/cnstVal1;d_val="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+x1+","+y1+" L"+x2+","+y2+" M"+x1+","+0+" L"+x1+","+h;break;case"accentBorderCallout2":case"accentCallout2":if(shapAdjst_ary===undefined){adj1=18750*refr;adj2=-8333*refr;adj3=18750*refr;adj4=-16667*refr;adj5=112500*refr;adj6=-46667*refr;}var y1,x1,y2,x2,y3,x3;y1=h*adj1/cnstVal1;x1=w*adj2/cnstVal1;y2=h*adj3/cnstVal1;x2=w*adj4/cnstVal1;y3=h*adj5/cnstVal1;x3=w*adj6/cnstVal1;d_val="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+x1+","+y1+" L"+x2+","+y2+" L"+x3+","+y3+" L"+x2+","+y2+" M"+x1+","+0+" L"+x1+","+h;break;case"accentBorderCallout3":case"accentCallout3":if(shapAdjst_ary===undefined){adj1=18750*refr;adj2=-8333*refr;adj3=18750*refr;adj4=-16667*refr;adj5=100000*refr;adj6=-16667*refr;adj7=112963*refr;adj8=-8333*refr;}var y1,x1,y2,x2,y3,x3,y4,x4;y1=h*adj1/cnstVal1;x1=w*adj2/cnstVal1;y2=h*adj3/cnstVal1;x2=w*adj4/cnstVal1;y3=h*adj5/cnstVal1;x3=w*adj6/cnstVal1;y4=h*adj7/cnstVal1;x4=w*adj8/cnstVal1;d_val="M"+0+","+0+" L"+w+","+0+" L"+w+","+h+" L"+0+","+h+" z"+" M"+x1+","+y1+" L"+x2+","+y2+" L"+x3+","+y3+" L"+x4+","+y4+" L"+x3+","+y3+" L"+x2+","+y2+" M"+x1+","+0+" L"+x1+","+h;break;}//console.log("shapType: ", shapType, ",isBorder:", isBorder)
    //if(isBorder){
    result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";//}else{
    //    result += "<path d='"+d_val+"' fill='" + (!imgFillFlg?(grndFillFlg?"url(#linGrd_"+shpId+")":fillColor):"url(#imgPtrn_"+shpId+")") +
    //        "' stroke='none' />";
    //}
    break;case"leftRightRibbon":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var refr=slideFactor;var sAdj1,adj1=50000*refr;var sAdj2,adj2=50000*refr;var sAdj3,adj3=16667*refr;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*refr;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*refr;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*refr;}}}var d_val;var cnstVal1=33333*refr;var cnstVal2=100000*refr;var cnstVal3=200000*refr;var cnstVal4=400000*refr;var ss=Math.min(w,h);var a3,maxAdj1,a1,w1,maxAdj2,a2,x1,x4,dy1,dy2,ly1,ry4,ly2,ry3,ly4,ry1,ly3,ry2,hR,x2,x3,y1,y2,wd32=w/32,vc=h/2,hc=w/2;a3=adj3<0?0:adj3>cnstVal1?cnstVal1:adj3;maxAdj1=cnstVal2-a3;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;w1=hc-wd32;maxAdj2=cnstVal2*w1/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;x1=ss*a2/cnstVal2;x4=w-x1;dy1=h*a1/cnstVal3;dy2=h*a3/-cnstVal3;ly1=vc+dy2-dy1;ry4=vc+dy1-dy2;ly2=ly1+dy1;ry3=h-ly2;ly4=ly2*2;ry1=h-ly4;ly3=ly4-ly1;ry2=h-ly3;hR=a3*ss/cnstVal4;x2=hc-wd32;x3=hc+wd32;y1=ly1+hR;y2=ry2-hR;d_val="M"+0+","+ly2+"L"+x1+","+0+"L"+x1+","+ly1+"L"+hc+","+ly1+shapeArc(hc,y1,wd32,hR,270,450,false).replace("M","L")+shapeArc(hc,y2,wd32,hR,270,90,false).replace("M","L")+"L"+x4+","+ry2+"L"+x4+","+ry1+"L"+w+","+ry3+"L"+x4+","+h+"L"+x4+","+ry4+"L"+hc+","+ry4+shapeArc(hc,ry4-hR,wd32,hR,90,180,false).replace("M","L")+"L"+x2+","+ly3+"L"+x1+","+ly3+"L"+x1+","+ly4+" z"+"M"+x3+","+y1+"L"+x3+","+ry2+"M"+x2+","+y2+"L"+x2+","+ly3;result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"ribbon":case"ribbon2":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=16667*slideFactor;var sAdj2,adj2=50000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}}}var d_val;var cnstVal1=25000*slideFactor;var cnstVal2=33333*slideFactor;var cnstVal3=75000*slideFactor;var cnstVal4=100000*slideFactor;var cnstVal5=200000*slideFactor;var cnstVal6=400000*slideFactor;var hc=w/2,t=0,l=0,b=h,r=w,wd8=w/8,wd32=w/32;var a1,a2,x10,dx2,x2,x9,x3,x8,x5,x6,x4,x7,y1,y2,y4,y3,hR,y6;a1=adj1<0?0:adj1>cnstVal2?cnstVal2:adj1;a2=adj2<cnstVal1?cnstVal1:adj2>cnstVal3?cnstVal3:adj2;x10=r-wd8;dx2=w*a2/cnstVal5;x2=hc-dx2;x9=hc+dx2;x3=x2+wd32;x8=x9-wd32;x5=x2+wd8;x6=x9-wd8;x4=x5-wd32;x7=x6+wd32;hR=h*a1/cnstVal6;if(shapType=="ribbon2"){var dy1,dy2,y7;dy1=h*a1/cnstVal5;y1=b-dy1;dy2=h*a1/cnstVal4;y2=b-dy2;y4=t+dy2;y3=(y4+b)/2;y6=b-hR;///////////////////
    y7=y1-hR;d_val="M"+l+","+b+" L"+wd8+","+y3+" L"+l+","+y4+" L"+x2+","+y4+" L"+x2+","+hR+shapeArc(x3,hR,wd32,hR,180,270,false).replace("M","L")+" L"+x8+","+t+shapeArc(x8,hR,wd32,hR,270,360,false).replace("M","L")+" L"+x9+","+y4+" L"+x9+","+y4+" L"+r+","+y4+" L"+x10+","+y3+" L"+r+","+b+" L"+x7+","+b+shapeArc(x7,y6,wd32,hR,90,270,false).replace("M","L")+" L"+x8+","+y1+shapeArc(x8,y7,wd32,hR,90,-90,false).replace("M","L")+" L"+x3+","+y2+shapeArc(x3,y7,wd32,hR,270,90,false).replace("M","L")+" L"+x4+","+y1+shapeArc(x4,y6,wd32,hR,270,450,false).replace("M","L")+" z"+" M"+x5+","+y2+" L"+x5+","+y6+"M"+x6+","+y6+" L"+x6+","+y2+"M"+x2+","+y7+" L"+x2+","+y4+"M"+x9+","+y4+" L"+x9+","+y7;}else if(shapType=="ribbon"){var y5;y1=h*a1/cnstVal5;y2=h*a1/cnstVal4;y4=b-y2;y3=y4/2;y5=b-hR;///////////////////////
    y6=y2-hR;d_val="M"+l+","+t+" L"+x4+","+t+shapeArc(x4,hR,wd32,hR,270,450,false).replace("M","L")+" L"+x3+","+y1+shapeArc(x3,y6,wd32,hR,270,90,false).replace("M","L")+" L"+x8+","+y2+shapeArc(x8,y6,wd32,hR,90,-90,false).replace("M","L")+" L"+x7+","+y1+shapeArc(x7,hR,wd32,hR,90,270,false).replace("M","L")+" L"+r+","+t+" L"+x10+","+y3+" L"+r+","+y4+" L"+x9+","+y4+" L"+x9+","+y5+shapeArc(x8,y5,wd32,hR,0,90,false).replace("M","L")+" L"+x3+","+b+shapeArc(x3,y5,wd32,hR,90,180,false).replace("M","L")+" L"+x2+","+y4+" L"+l+","+y4+" L"+wd8+","+y3+" z"+" M"+x5+","+hR+" L"+x5+","+y2+"M"+x6+","+y2+" L"+x6+","+hR+"M"+x2+","+y4+" L"+x2+","+y6+"M"+x9+","+y6+" L"+x9+","+y4;}result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"doubleWave":case"wave":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=shapType=="doubleWave"?6250*slideFactor:12500*slideFactor;var sAdj2,adj2=0;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}}}var d_val;var cnstVal2=-10000*slideFactor;var cnstVal3=50000*slideFactor;var cnstVal4=100000*slideFactor;var hc=w/2,t=0,l=0,b=h,r=w,wd8=w/8,wd32=w/32;if(shapType=="doubleWave"){var cnstVal1=12500*slideFactor;var a1,a2,y1,dy2,y2,y3,y4,y5,y6,of2,dx2,x2,dx8,x8,dx3,x3,dx4,x4,x5,x6,x7,x9,x15,x10,x11,x12,x13,x14;a1=adj1<0?0:adj1>cnstVal1?cnstVal1:adj1;a2=adj2<cnstVal2?cnstVal2:adj2>cnstVal4?cnstVal4:adj2;y1=h*a1/cnstVal4;dy2=y1*10/3;y2=y1-dy2;y3=y1+dy2;y4=b-y1;y5=y4-dy2;y6=y4+dy2;of2=w*a2/cnstVal3;dx2=of2>0?0:of2;x2=l-dx2;dx8=of2>0?of2:0;x8=r-dx8;dx3=(dx2+x8)/6;x3=x2+dx3;dx4=(dx2+x8)/3;x4=x2+dx4;x5=(x2+x8)/2;x6=x5+dx3;x7=(x6+x8)/2;x9=l+dx8;x15=r+dx2;x10=x9+dx3;x11=x9+dx4;x12=(x9+x15)/2;x13=x12+dx3;x14=(x13+x15)/2;d_val="M"+x2+","+y1+" C"+x3+","+y2+" "+x4+","+y3+" "+x5+","+y1+" C"+x6+","+y2+" "+x7+","+y3+" "+x8+","+y1+" L"+x15+","+y4+" C"+x14+","+y6+" "+x13+","+y5+" "+x12+","+y4+" C"+x11+","+y6+" "+x10+","+y5+" "+x9+","+y4+" z";}else if(shapType=="wave"){var cnstVal5=20000*slideFactor;var a1,a2,y1,dy2,y2,y3,y4,y5,y6,of2,dx2,x2,dx5,x5,dx3,x3,x4,x6,x10,x7,x8;a1=adj1<0?0:adj1>cnstVal5?cnstVal5:adj1;a2=adj2<cnstVal2?cnstVal2:adj2>cnstVal4?cnstVal4:adj2;y1=h*a1/cnstVal4;dy2=y1*10/3;y2=y1-dy2;y3=y1+dy2;y4=b-y1;y5=y4-dy2;y6=y4+dy2;of2=w*a2/cnstVal3;dx2=of2>0?0:of2;x2=l-dx2;dx5=of2>0?of2:0;x5=r-dx5;dx3=(dx2+x5)/3;x3=x2+dx3;x4=(x3+x5)/2;x6=l+dx5;x10=r+dx2;x7=x6+dx3;x8=(x7+x10)/2;d_val="M"+x2+","+y1+" C"+x3+","+y2+" "+x4+","+y3+" "+x5+","+y1+" L"+x10+","+y4+" C"+x8+","+y6+" "+x7+","+y5+" "+x6+","+y4+" z";}result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"ellipseRibbon":case"ellipseRibbon2":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=50000*slideFactor;var sAdj3,adj3=12500*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var d_val;var cnstVal1=25000*slideFactor;var cnstVal3=75000*slideFactor;var cnstVal4=100000*slideFactor;var cnstVal5=200000*slideFactor;var hc=w/2,t=0,l=0,b=h,r=w,wd8=w/8;var a1,a2,q10,q11,q12,minAdj3,a3,dx2,x2,x3,x4,x5,x6,dy1,f1,q1,q2,cx1,cx2,q1,dy3,q3,q4,q5,rh,q8,cx4,q9,cx5;a1=adj1<0?0:adj1>cnstVal4?cnstVal4:adj1;a2=adj2<cnstVal1?cnstVal1:adj2>cnstVal3?cnstVal3:adj2;q10=cnstVal4-a1;q11=q10/2;q12=a1-q11;minAdj3=0>q12?0:q12;a3=adj3<minAdj3?minAdj3:adj3>a1?a1:adj3;dx2=w*a2/cnstVal5;x2=hc-dx2;x3=x2+wd8;x4=r-x3;x5=r-x2;x6=r-wd8;dy1=h*a3/cnstVal4;f1=4*dy1/w;q1=x3*x3/w;q2=x3-q1;cx1=x3/2;cx2=r-cx1;q1=h*a1/cnstVal4;dy3=q1-dy1;q3=x2*x2/w;q4=x2-q3;q5=f1*q4;rh=b-q1;q8=dy1*14/16;cx4=x2/2;q9=f1*cx4;cx5=r-cx4;if(shapType=="ellipseRibbon"){var y1,cy1,y3,q6,q7,cy3,y2,y5,y6,cy4,cy6,y7,y8;y1=f1*q2;cy1=f1*cx1;y3=q5+dy3;q6=dy1+dy3-y3;q7=q6+dy1;cy3=q7+dy3;y2=(q8+rh)/2;y5=q5+rh;y6=y3+rh;cy4=q9+rh;cy6=cy3+rh;y7=y1+dy3;y8=b-dy1;//
    d_val="M"+l+","+t+" Q"+cx1+","+cy1+" "+x3+","+y1+" L"+x2+","+y3+" Q"+hc+","+cy3+" "+x5+","+y3+" L"+x4+","+y1+" Q"+cx2+","+cy1+" "+r+","+t+" L"+x6+","+y2+" L"+r+","+rh+" Q"+cx5+","+cy4+" "+x5+","+y5+" L"+x5+","+y6+" Q"+hc+","+cy6+" "+x2+","+y6+" L"+x2+","+y5+" Q"+cx4+","+cy4+" "+l+","+rh+" L"+wd8+","+y2+" z"+"M"+x2+","+y5+" L"+x2+","+y3+"M"+x5+","+y3+" L"+x5+","+y5+"M"+x3+","+y1+" L"+x3+","+y7+"M"+x4+","+y7+" L"+x4+","+y1;}else if(shapType=="ellipseRibbon2"){var u1,y1,cu1,cy1,q3,q5,u3,y3,q6,q7,cu3,cy3,rh,q8,u2,y2,u5,y5,u6,y6,cu4,cy4,cu6,cy6,u7,y7;u1=f1*q2;y1=b-u1;cu1=f1*cx1;cy1=b-cu1;u3=q5+dy3;y3=b-u3;q6=dy1+dy3-u3;q7=q6+dy1;cu3=q7+dy3;cy3=b-cu3;u2=(q8+rh)/2;y2=b-u2;u5=q5+rh;y5=b-u5;u6=u3+rh;y6=b-u6;cu4=q9+rh;cy4=b-cu4;cu6=cu3+rh;cy6=b-cu6;u7=u1+dy3;y7=b-u7;d_val="M"+l+","+b+" L"+wd8+","+y2+" L"+l+","+q1+" Q"+cx4+","+cy4+" "+x2+","+y5+" L"+x2+","+y6+" Q"+hc+","+cy6+" "+x5+","+y6+" L"+x5+","+y5+" Q"+cx5+","+cy4+" "+r+","+q1+" L"+x6+","+y2+" L"+r+","+b+" Q"+cx2+","+cy1+" "+x4+","+y1+" L"+x5+","+y3+" Q"+hc+","+cy3+" "+x2+","+y3+" L"+x3+","+y1+" Q"+cx1+","+cy1+" "+l+","+b+" z"+"M"+x2+","+y3+" L"+x2+","+y5+"M"+x5+","+y5+" L"+x5+","+y3+"M"+x3+","+y7+" L"+x3+","+y1+"M"+x4+","+y1+" L"+x4+","+y7;}result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"line":case"straightConnector1":case"bentConnector4":case"bentConnector5":case"curvedConnector2":case"curvedConnector3":case"curvedConnector4":case"curvedConnector5":// if (isFlipV) {
    //     result += "<line x1='" + w + "' y1='0' x2='0' y2='" + h + "' stroke='" + border.color +
    //         "' stroke-width='" + border.width + "' stroke-dasharray='" + border.strokeDasharray + "' ";
    // } else {
    result+="<line x1='0' y1='0' x2='"+w+"' y2='"+h+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' ";//}
    if(headEndNodeAttrs!==undefined&&(headEndNodeAttrs["type"]==="triangle"||headEndNodeAttrs["type"]==="arrow")){result+="marker-start='url(#markerTriangle_"+shpId+")' ";}if(tailEndNodeAttrs!==undefined&&(tailEndNodeAttrs["type"]==="triangle"||tailEndNodeAttrs["type"]==="arrow")){result+="marker-end='url(#markerTriangle_"+shpId+")' ";}result+="/>";break;case"rightArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=0.25;//0.5;
    var sAdj2,sAdj2_val=0.5;var max_sAdj2_const=w/h;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=0.5-parseInt(sAdj1.substr(4))/200000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);var sAdj2_val2=parseInt(sAdj2.substr(4))/100000;sAdj2_val=1-sAdj2_val2/max_sAdj2_const;}}}//console.log("w: "+w+"\nh: "+h+"\nsAdj1: "+sAdj1_val+"\nsAdj2: "+sAdj2_val);
    result+=" <polygon points='"+w+" "+h/2+","+sAdj2_val*w+" 0,"+sAdj2_val*w+" "+sAdj1_val*h+",0 "+sAdj1_val*h+",0 "+(1-sAdj1_val)*h+","+sAdj2_val*w+" "+(1-sAdj1_val)*h+", "+sAdj2_val*w+" "+h+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=0.25;//0.5;
    var sAdj2,sAdj2_val=0.5;var max_sAdj2_const=w/h;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=0.5-parseInt(sAdj1.substr(4))/200000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);var sAdj2_val2=parseInt(sAdj2.substr(4))/100000;sAdj2_val=sAdj2_val2/max_sAdj2_const;}}}//console.log("w: "+w+"\nh: "+h+"\nsAdj1: "+sAdj1_val+"\nsAdj2: "+sAdj2_val);
    result+=" <polygon points='0 "+h/2+","+sAdj2_val*w+" "+h+","+sAdj2_val*w+" "+(1-sAdj1_val)*h+","+w+" "+(1-sAdj1_val)*h+","+w+" "+sAdj1_val*h+","+sAdj2_val*w+" "+sAdj1_val*h+", "+sAdj2_val*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"downArrow":case"flowChartOffpageConnector":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=0.25;//0.5;
    var sAdj2,sAdj2_val=0.5;var max_sAdj2_const=h/w;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=parseInt(sAdj1.substr(4))/200000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);var sAdj2_val2=parseInt(sAdj2.substr(4))/100000;sAdj2_val=sAdj2_val2/max_sAdj2_const;}}}if(shapType=="flowChartOffpageConnector"){sAdj1_val=0.5;sAdj2_val=0.212;}result+=" <polygon points='"+(0.5-sAdj1_val)*w+" 0,"+(0.5-sAdj1_val)*w+" "+(1-sAdj2_val)*h+",0 "+(1-sAdj2_val)*h+","+w/2+" "+h+","+w+" "+(1-sAdj2_val)*h+","+(0.5+sAdj1_val)*w+" "+(1-sAdj2_val)*h+", "+(0.5+sAdj1_val)*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"upArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=0.25;//0.5;
    var sAdj2,sAdj2_val=0.5;var max_sAdj2_const=h/w;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=parseInt(sAdj1.substr(4))/200000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);var sAdj2_val2=parseInt(sAdj2.substr(4))/100000;sAdj2_val=sAdj2_val2/max_sAdj2_const;}}}result+=" <polygon points='"+w/2+" 0,0 "+sAdj2_val*h+","+(0.5-sAdj1_val)*w+" "+sAdj2_val*h+","+(0.5-sAdj1_val)*w+" "+h+","+(0.5+sAdj1_val)*w+" "+h+","+(0.5+sAdj1_val)*w+" "+sAdj2_val*h+", "+w+" "+sAdj2_val*h+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftRightArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=0.25;var sAdj2,sAdj2_val=0.25;var max_sAdj2_const=w/h;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=0.5-parseInt(sAdj1.substr(4))/200000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);var sAdj2_val2=parseInt(sAdj2.substr(4))/100000;sAdj2_val=sAdj2_val2/max_sAdj2_const;}}}//console.log("w: "+w+"\nh: "+h+"\nsAdj1: "+sAdj1_val+"\nsAdj2: "+sAdj2_val);
    result+=" <polygon points='0 "+h/2+","+sAdj2_val*w+" "+h+","+sAdj2_val*w+" "+(1-sAdj1_val)*h+","+(1-sAdj2_val)*w+" "+(1-sAdj1_val)*h+","+(1-sAdj2_val)*w+" "+h+","+w+" "+h/2+", "+(1-sAdj2_val)*w+" 0,"+(1-sAdj2_val)*w+" "+sAdj1_val*h+","+sAdj2_val*w+" "+sAdj1_val*h+","+sAdj2_val*w+" 0' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"upDownArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,sAdj1_val=0.25;var sAdj2,sAdj2_val=0.25;var max_sAdj2_const=h/w;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);sAdj1_val=0.5-parseInt(sAdj1.substr(4))/200000;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);var sAdj2_val2=parseInt(sAdj2.substr(4))/100000;sAdj2_val=sAdj2_val2/max_sAdj2_const;}}}//console.log("w: "+w+"\nh: "+h+"\nsAdj1: "+sAdj1_val+"\nsAdj2: "+sAdj2_val);
    result+=" <polygon points='"+w/2+" 0,0 "+sAdj2_val*h+","+sAdj1_val*w+" "+sAdj2_val*h+","+sAdj1_val*w+" "+(1-sAdj2_val)*h+",0 "+(1-sAdj2_val)*h+","+w/2+" "+h+", "+w+" "+(1-sAdj2_val)*h+","+(1-sAdj1_val)*w+" "+(1-sAdj2_val)*h+","+(1-sAdj1_val)*w+" "+sAdj2_val*h+","+w+" "+sAdj2_val*h+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"quadArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=22500*slideFactor;var sAdj2,adj2=22500*slideFactor;var sAdj3,adj3=22500*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,a1,a2,a3,q1,x1,x2,dx2,x3,dx3,x4,x5,x6,y2,y3,y4,y5,y6,maxAdj1,maxAdj3;var minWH=Math.min(w,h);if(adj2<0)a2=0;else if(adj2>cnstVal1)a2=cnstVal1;else a2=adj2;maxAdj1=2*a2;if(adj1<0)a1=0;else if(adj1>maxAdj1)a1=maxAdj1;else a1=adj1;q1=cnstVal2-maxAdj1;maxAdj3=q1/2;if(adj3<0)a3=0;else if(adj3>maxAdj3)a3=maxAdj3;else a3=adj3;x1=minWH*a3/cnstVal2;dx2=minWH*a2/cnstVal2;x2=hc-dx2;x5=hc+dx2;dx3=minWH*a1/cnstVal3;x3=hc-dx3;x4=hc+dx3;x6=w-x1;y2=vc-dx2;y5=vc+dx2;y3=vc-dx3;y4=vc+dx3;y6=h-x1;var d_val="M"+0+","+vc+" L"+x1+","+y2+" L"+x1+","+y3+" L"+x3+","+y3+" L"+x3+","+x1+" L"+x2+","+x1+" L"+hc+","+0+" L"+x5+","+x1+" L"+x4+","+x1+" L"+x4+","+y3+" L"+x6+","+y3+" L"+x6+","+y2+" L"+w+","+vc+" L"+x6+","+y5+" L"+x6+","+y4+" L"+x4+","+y4+" L"+x4+","+y6+" L"+x5+","+y6+" L"+hc+","+h+" L"+x2+","+y6+" L"+x3+","+y6+" L"+x3+","+y4+" L"+x1+","+y4+" L"+x1+","+y5+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftRightUpArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,a1,a2,a3,q1,x1,x2,dx2,x3,dx3,x4,x5,x6,y2,dy2,y3,y4,y5,maxAdj1,maxAdj3;var minWH=Math.min(w,h);if(adj2<0)a2=0;else if(adj2>cnstVal1)a2=cnstVal1;else a2=adj2;maxAdj1=2*a2;if(adj1<0)a1=0;else if(adj1>maxAdj1)a1=maxAdj1;else a1=adj1;q1=cnstVal2-maxAdj1;maxAdj3=q1/2;if(adj3<0)a3=0;else if(adj3>maxAdj3)a3=maxAdj3;else a3=adj3;x1=minWH*a3/cnstVal2;dx2=minWH*a2/cnstVal2;x2=hc-dx2;x5=hc+dx2;dx3=minWH*a1/cnstVal3;x3=hc-dx3;x4=hc+dx3;x6=w-x1;dy2=minWH*a2/cnstVal1;y2=h-dy2;y4=h-dx2;y3=y4-dx3;y5=y4+dx3;var d_val="M"+0+","+y4+" L"+x1+","+y2+" L"+x1+","+y3+" L"+x3+","+y3+" L"+x3+","+x1+" L"+x2+","+x1+" L"+hc+","+0+" L"+x5+","+x1+" L"+x4+","+x1+" L"+x4+","+y3+" L"+x6+","+y3+" L"+x6+","+y2+" L"+w+","+y4+" L"+x6+","+h+" L"+x6+","+y5+" L"+x1+","+y5+" L"+x1+","+h+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftUpArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,a1,a2,a3,x1,x2,dx4,dx3,x3,x4,x5,y2,y3,y4,y5,maxAdj1,maxAdj3;var minWH=Math.min(w,h);if(adj2<0)a2=0;else if(adj2>cnstVal1)a2=cnstVal1;else a2=adj2;maxAdj1=2*a2;if(adj1<0)a1=0;else if(adj1>maxAdj1)a1=maxAdj1;else a1=adj1;maxAdj3=cnstVal2-maxAdj1;if(adj3<0)a3=0;else if(adj3>maxAdj3)a3=maxAdj3;else a3=adj3;x1=minWH*a3/cnstVal2;dx2=minWH*a2/cnstVal1;x2=w-dx2;y2=h-dx2;dx4=minWH*a2/cnstVal2;x4=w-dx4;y4=h-dx4;dx3=minWH*a1/cnstVal3;x3=x4-dx3;x5=x4+dx3;y3=y4-dx3;y5=y4+dx3;var d_val="M"+0+","+y4+" L"+x1+","+y2+" L"+x1+","+y3+" L"+x3+","+y3+" L"+x3+","+x1+" L"+x2+","+x1+" L"+x4+","+0+" L"+w+","+x1+" L"+x5+","+x1+" L"+x5+","+y5+" L"+x1+","+y5+" L"+x1+","+h+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"bentUpArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,a1,a2,a3,dx1,x1,dx2,x2,dx3,x3,x4,y1,y2,dy2;var minWH=Math.min(w,h);if(adj1<0)a1=0;else if(adj1>cnstVal1)a1=cnstVal1;else a1=adj1;if(adj2<0)a2=0;else if(adj2>cnstVal1)a2=cnstVal1;else a2=adj2;if(adj3<0)a3=0;else if(adj3>maxAdj3)a3=maxAdj3;else a3=adj3;y1=minWH*a3/cnstVal2;dx1=minWH*a2/cnstVal1;x1=w-dx1;dx3=minWH*a2/cnstVal2;x3=w-dx3;dx2=minWH*a1/cnstVal3;x2=x3-dx2;x4=x3+dx2;dy2=minWH*a1/cnstVal2;y2=h-dy2;var d_val="M"+0+","+y2+" L"+x2+","+y2+" L"+x2+","+y1+" L"+x1+","+y1+" L"+x3+","+0+" L"+w+","+y1+" L"+x4+","+y1+" L"+x4+","+h+" L"+0+","+h+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"bentArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var sAdj4,adj4=43750*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}}}var a1,a2,a3,a4,x3,x4,y3,y4,y5,y6,maxAdj1,maxAdj4;var minWH=Math.min(w,h);if(adj2<0)a2=0;else if(adj2>cnstVal1)a2=cnstVal1;else a2=adj2;maxAdj1=2*a2;if(adj1<0)a1=0;else if(adj1>maxAdj1)a1=maxAdj1;else a1=adj1;if(adj3<0)a3=0;else if(adj3>cnstVal1)a3=cnstVal1;else a3=adj3;var th,aw2,th2,dh2,ah,bw,bh,bs,bd,bd3,bd2,th=minWH*a1/cnstVal2;aw2=minWH*a2/cnstVal2;th2=th/2;dh2=aw2-th2;ah=minWH*a3/cnstVal2;bw=w-ah;bh=h-dh2;bs=bw<bh?bw:bh;maxAdj4=cnstVal2*bs/minWH;if(adj4<0)a4=0;else if(adj4>maxAdj4)a4=maxAdj4;else a4=adj4;bd=minWH*a4/cnstVal2;bd3=bd-th;bd2=bd3>0?bd3:0;x3=th+bd2;x4=w-ah;y3=dh2+th;y4=y3+dh2;y5=dh2+bd;y6=y3+bd2;var d_val="M"+0+","+h+" L"+0+","+y5+shapeArc(bd,y5,bd,bd,180,270,false).replace("M","L")+" L"+x4+","+dh2+" L"+x4+","+0+" L"+w+","+aw2+" L"+x4+","+y4+" L"+x4+","+y3+" L"+x3+","+y3+shapeArc(x3,y6,bd2,bd2,270,180,false).replace("M","L")+" L"+th+","+h+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"uturnArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var sAdj4,adj4=43750*slideFactor;var sAdj5,adj5=75000*slideFactor;var cnstVal1=25000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}else if(sAdj_name=="adj5"){sAdj5=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj5=parseInt(sAdj5.substr(4))*slideFactor;}}}var a1,a2,a3,a4,a5,q1,q2,q3,x3,x4,x5,x6,x7,x8,x9,y4,y5,minAdj5,maxAdj1,maxAdj3,maxAdj4;var minWH=Math.min(w,h);if(adj2<0)a2=0;else if(adj2>cnstVal1)a2=cnstVal1;else a2=adj2;maxAdj1=2*a2;if(adj1<0)a1=0;else if(adj1>maxAdj1)a1=maxAdj1;else a1=adj1;q2=a1*minWH/h;q3=cnstVal2-q2;maxAdj3=q3*h/minWH;if(adj3<0)a3=0;else if(adj3>maxAdj3)a3=maxAdj3;else a3=adj3;q1=a3+a1;minAdj5=q1*minWH/h;if(adj5<minAdj5)a5=minAdj5;else if(adj5>cnstVal2)a5=cnstVal2;else a5=adj5;var th,aw2,th2,dh2,ah,bw,bs,bd,bd3,bd2,th=minWH*a1/cnstVal2;aw2=minWH*a2/cnstVal2;th2=th/2;dh2=aw2-th2;y5=h*a5/cnstVal2;ah=minWH*a3/cnstVal2;y4=y5-ah;x9=w-dh2;bw=x9/2;bs=bw<y4?bw:y4;maxAdj4=cnstVal2*bs/minWH;if(adj4<0)a4=0;else if(adj4>maxAdj4)a4=maxAdj4;else a4=adj4;bd=minWH*a4/cnstVal2;bd3=bd-th;bd2=bd3>0?bd3:0;x3=th+bd2;x8=w-aw2;x6=x8-aw2;x7=x6+dh2;x4=x9-bd;x5=x7-bd2;cx=(th+x7)/2;var d_val="M"+0+","+h+" L"+0+","+bd+shapeArc(bd,bd,bd,bd,180,270,false).replace("M","L")+" L"+x4+","+0+shapeArc(x4,bd,bd,bd,270,360,false).replace("M","L")+" L"+x9+","+y4+" L"+w+","+y4+" L"+x8+","+y5+" L"+x6+","+y4+" L"+x7+","+y4+" L"+x7+","+x3+shapeArc(x5,x3,bd2,bd2,0,-90,false).replace("M","L")+" L"+x3+","+th+shapeArc(x3,x3,bd2,bd2,270,180,false).replace("M","L")+" L"+th+","+h+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"stripedRightArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=50000*slideFactor;var sAdj2,adj2=50000*slideFactor;var cnstVal1=100000*slideFactor;var cnstVal2=200000*slideFactor;var cnstVal3=84375*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}}}var a1,a2,x4,x5,dx5,x6,dx6,y1,dy1,y2,maxAdj2,vc=h/2;var minWH=Math.min(w,h);maxAdj2=cnstVal3*w/minWH;if(adj1<0)a1=0;else if(adj1>cnstVal1)a1=cnstVal1;else a1=adj1;if(adj2<0)a2=0;else if(adj2>maxAdj2)a2=maxAdj2;else a2=adj2;x4=minWH*5/32;dx5=minWH*a2/cnstVal1;x5=w-dx5;dy1=h*a1/cnstVal2;y1=vc-dy1;y2=vc+dy1;//dx6 = dy1*dx5/hd2;
    //x6 = w-dx6;
    var ssd8=minWH/8,ssd16=minWH/16,ssd32=minWH/32;var d_val="M"+0+","+y1+" L"+ssd32+","+y1+" L"+ssd32+","+y2+" L"+0+","+y2+" z"+" M"+ssd16+","+y1+" L"+ssd8+","+y1+" L"+ssd8+","+y2+" L"+ssd16+","+y2+" z"+" M"+x4+","+y1+" L"+x5+","+y1+" L"+x5+","+0+" L"+w+","+vc+" L"+x5+","+h+" L"+x5+","+y2+" L"+x4+","+y2+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"notchedRightArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=50000*slideFactor;var sAdj2,adj2=50000*slideFactor;var cnstVal1=100000*slideFactor;var cnstVal2=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}}}var a1,a2,x1,x2,dx2,y1,dy1,y2,maxAdj2,vc=h/2,hd2=vc;var minWH=Math.min(w,h);maxAdj2=cnstVal1*w/minWH;if(adj1<0)a1=0;else if(adj1>cnstVal1)a1=cnstVal1;else a1=adj1;if(adj2<0)a2=0;else if(adj2>maxAdj2)a2=maxAdj2;else a2=adj2;dx2=minWH*a2/cnstVal1;x2=w-dx2;dy1=h*a1/cnstVal2;y1=vc-dy1;y2=vc+dy1;x1=dy1*dx2/hd2;var d_val="M"+0+","+y1+" L"+x2+","+y1+" L"+x2+","+0+" L"+w+","+vc+" L"+x2+","+h+" L"+x2+","+y2+" L"+0+","+y2+" L"+x1+","+vc+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"homePlate":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=50000*slideFactor;var cnstVal1=100000*slideFactor;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var a,x1,dx1,maxAdj,vc=h/2;var minWH=Math.min(w,h);maxAdj=cnstVal1*w/minWH;if(adj<0)a=0;else if(adj>maxAdj)a=maxAdj;else a=adj;dx1=minWH*a/cnstVal1;x1=w-dx1;var d_val="M"+0+","+0+" L"+x1+","+0+" L"+w+","+vc+" L"+x1+","+h+" L"+0+","+h+" z";result+="<path  d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"chevron":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=50000*slideFactor;var cnstVal1=100000*slideFactor;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var a,x1,dx1,x2,maxAdj,vc=h/2;var minWH=Math.min(w,h);maxAdj=cnstVal1*w/minWH;if(adj<0)a=0;else if(adj>maxAdj)a=maxAdj;else a=adj;x1=minWH*a/cnstVal1;x2=w-x1;var d_val="M"+0+","+0+" L"+x2+","+0+" L"+w+","+vc+" L"+x2+","+h+" L"+0+","+h+" L"+x1+","+vc+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"rightArrowCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var sAdj4,adj4=64977*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}}}var maxAdj2,a2,maxAdj1,a1,maxAdj3,a3,q2,maxAdj4,a4,dy1,dy2,y1,y2,y3,y4,dx3,x3,x2,x1;var vc=h/2,r=w,b=h,l=0,t=0;var ss=Math.min(w,h);maxAdj2=cnstVal1*h/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;maxAdj1=a2*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;maxAdj3=cnstVal2*w/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;q2=a3*ss/w;maxAdj4=cnstVal-q2;a4=adj4<0?0:adj4>maxAdj4?maxAdj4:adj4;dy1=ss*a2/cnstVal2;dy2=ss*a1/cnstVal3;y1=vc-dy1;y2=vc-dy2;y3=vc+dy2;y4=vc+dy1;dx3=ss*a3/cnstVal2;x3=r-dx3;x2=w*a4/cnstVal2;x1=x2/2;var d_val="M"+l+","+t+" L"+x2+","+t+" L"+x2+","+y2+" L"+x3+","+y2+" L"+x3+","+y1+" L"+r+","+vc+" L"+x3+","+y4+" L"+x3+","+y3+" L"+x2+","+y3+" L"+x2+","+b+" L"+l+","+b+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"downArrowCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var sAdj4,adj4=64977*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}}}var maxAdj2,a2,maxAdj1,a1,maxAdj3,a3,q2,maxAdj4,a4,dx1,dx2,x1,x2,x3,x4,dy3,y3,y2,y1;var hc=w/2,r=w,b=h,l=0,t=0;var ss=Math.min(w,h);maxAdj2=cnstVal1*w/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;maxAdj1=a2*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;maxAdj3=cnstVal2*h/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;q2=a3*ss/h;maxAdj4=cnstVal2-q2;a4=adj4<0?0:adj4>maxAdj4?maxAdj4:adj4;dx1=ss*a2/cnstVal2;dx2=ss*a1/cnstVal3;x1=hc-dx1;x2=hc-dx2;x3=hc+dx2;x4=hc+dx1;dy3=ss*a3/cnstVal2;y3=b-dy3;y2=h*a4/cnstVal2;y1=y2/2;var d_val="M"+l+","+t+" L"+r+","+t+" L"+r+","+y2+" L"+x3+","+y2+" L"+x3+","+y3+" L"+x4+","+y3+" L"+hc+","+b+" L"+x1+","+y3+" L"+x2+","+y3+" L"+x2+","+y2+" L"+l+","+y2+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftArrowCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var sAdj4,adj4=64977*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}}}var maxAdj2,a2,maxAdj1,a1,maxAdj3,a3,q2,maxAdj4,a4,dy1,dy2,y1,y2,y3,y4,x1,dx2,x2,x3;var vc=h/2,r=w,b=h,l=0,t=0;var ss=Math.min(w,h);maxAdj2=cnstVal1*h/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;maxAdj1=a2*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;maxAdj3=cnstVal2*w/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;q2=a3*ss/w;maxAdj4=cnstVal2-q2;a4=adj4<0?0:adj4>maxAdj4?maxAdj4:adj4;dy1=ss*a2/cnstVal2;dy2=ss*a1/cnstVal3;y1=vc-dy1;y2=vc-dy2;y3=vc+dy2;y4=vc+dy1;x1=ss*a3/cnstVal2;dx2=w*a4/cnstVal2;x2=r-dx2;x3=(x2+r)/2;var d_val="M"+l+","+vc+" L"+x1+","+y1+" L"+x1+","+y2+" L"+x2+","+y2+" L"+x2+","+t+" L"+r+","+t+" L"+r+","+b+" L"+x2+","+b+" L"+x2+","+y3+" L"+x1+","+y3+" L"+x1+","+y4+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"upArrowCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var sAdj4,adj4=64977*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}}}var maxAdj2,a2,maxAdj1,a1,maxAdj3,a3,q2,maxAdj4,a4,dx1,dx2,x1,x2,x3,x4,y1,dy2,y2,y3;var hc=w/2,r=w,b=h,l=0,t=0;var ss=Math.min(w,h);maxAdj2=cnstVal1*w/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;maxAdj1=a2*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;maxAdj3=cnstVal2*h/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;q2=a3*ss/h;maxAdj4=cnstVal2-q2;a4=adj4<0?0:adj4>maxAdj4?maxAdj4:adj4;dx1=ss*a2/cnstVal2;dx2=ss*a1/cnstVal3;x1=hc-dx1;x2=hc-dx2;x3=hc+dx2;x4=hc+dx1;y1=ss*a3/cnstVal2;dy2=h*a4/cnstVal2;y2=b-dy2;y3=(y2+b)/2;var d_val="M"+l+","+y2+" L"+x2+","+y2+" L"+x2+","+y1+" L"+x1+","+y1+" L"+hc+","+t+" L"+x4+","+y1+" L"+x3+","+y1+" L"+x3+","+y2+" L"+r+","+y2+" L"+r+","+b+" L"+l+","+b+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftRightArrowCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=25000*slideFactor;var sAdj3,adj3=25000*slideFactor;var sAdj4,adj4=48123*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}}}var maxAdj2,a2,maxAdj1,a1,maxAdj3,a3,q2,maxAdj4,a4,dy1,dy2,y1,y2,y3,y4,x1,x4,dx2,x2,x3;var vc=h/2,hc=w/2,r=w,b=h,l=0,t=0;var ss=Math.min(w,h);maxAdj2=cnstVal1*h/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;maxAdj1=a2*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;maxAdj3=cnstVal1*w/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;q2=a3*ss/wd2;maxAdj4=cnstVal2-q2;a4=adj4<0?0:adj4>maxAdj4?maxAdj4:adj4;dy1=ss*a2/cnstVal2;dy2=ss*a1/cnstVal3;y1=vc-dy1;y2=vc-dy2;y3=vc+dy2;y4=vc+dy1;x1=ss*a3/cnstVal2;x4=r-x1;dx2=w*a4/cnstVal3;x2=hc-dx2;x3=hc+dx2;var d_val="M"+l+","+vc+" L"+x1+","+y1+" L"+x1+","+y2+" L"+x2+","+y2+" L"+x2+","+t+" L"+x3+","+t+" L"+x3+","+y2+" L"+x4+","+y2+" L"+x4+","+y1+" L"+r+","+vc+" L"+x4+","+y4+" L"+x4+","+y3+" L"+x3+","+y3+" L"+x3+","+b+" L"+x2+","+b+" L"+x2+","+y3+" L"+x1+","+y3+" L"+x1+","+y4+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"quadArrowCallout":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=18515*slideFactor;var sAdj2,adj2=18515*slideFactor;var sAdj3,adj3=18515*slideFactor;var sAdj4,adj4=48123*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,r=w,b=h,l=0,t=0;var ss=Math.min(w,h);var a2,maxAdj1,a1,maxAdj3,a3,q2,maxAdj4,a4,dx2,dx3,ah,dx1,dy1,x8,x2,x7,x3,x6,x4,x5,y8,y2,y7,y3,y6,y4,y5;a2=adj2<0?0:adj2>cnstVal1?cnstVal1:adj2;maxAdj1=a2*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;maxAdj3=cnstVal1-a2;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;q2=a3*2;maxAdj4=cnstVal2-q2;a4=adj4<a1?a1:adj4>maxAdj4?maxAdj4:adj4;dx2=ss*a2/cnstVal2;dx3=ss*a1/cnstVal3;ah=ss*a3/cnstVal2;dx1=w*a4/cnstVal3;dy1=h*a4/cnstVal3;x8=r-ah;x2=hc-dx1;x7=hc+dx1;x3=hc-dx2;x6=hc+dx2;x4=hc-dx3;x5=hc+dx3;y8=b-ah;y2=vc-dy1;y7=vc+dy1;y3=vc-dx2;y6=vc+dx2;y4=vc-dx3;y5=vc+dx3;var d_val="M"+l+","+vc+" L"+ah+","+y3+" L"+ah+","+y4+" L"+x2+","+y4+" L"+x2+","+y2+" L"+x4+","+y2+" L"+x4+","+ah+" L"+x3+","+ah+" L"+hc+","+t+" L"+x6+","+ah+" L"+x5+","+ah+" L"+x5+","+y2+" L"+x7+","+y2+" L"+x7+","+y4+" L"+x8+","+y4+" L"+x8+","+y3+" L"+r+","+vc+" L"+x8+","+y6+" L"+x8+","+y5+" L"+x7+","+y5+" L"+x7+","+y7+" L"+x5+","+y7+" L"+x5+","+y8+" L"+x6+","+y8+" L"+hc+","+b+" L"+x3+","+y8+" L"+x4+","+y8+" L"+x4+","+y7+" L"+x2+","+y7+" L"+x2+","+y5+" L"+ah+","+y5+" L"+ah+","+y6+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"curvedDownArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=50000*slideFactor;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,wd2=w/2,r=w,b=h,l=0,t=0,c3d4=270,cd2=180,cd4=90;var ss=Math.min(w,h);var maxAdj2,a2,a1,th,aw,q1,wR,q7,q8,q9,q10,q11,idy,maxAdj3,a3,ah,x3,q2,q3,q4,q5,dx,x5,x7,q6,dh,x4,x8,aw2,x6,y1,swAng,mswAng,q12,dang2,stAng,stAng2,swAng2,swAng3;maxAdj2=cnstVal1*w/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;a1=adj1<0?0:adj1>cnstVal2?cnstVal2:adj1;th=ss*a1/cnstVal2;aw=ss*a2/cnstVal2;q1=(th+aw)/4;wR=wd2-q1;q7=wR*2;q8=q7*q7;q9=th*th;q10=q8-q9;q11=Math.sqrt(q10);idy=q11*h/q7;maxAdj3=cnstVal2*idy/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;ah=ss*adj3/cnstVal2;x3=wR+th;q2=h*h;q3=ah*ah;q4=q2-q3;q5=Math.sqrt(q4);dx=q5*wR/h;x5=wR+dx;x7=x3+dx;q6=aw-th;dh=q6/2;x4=x5-dh;x8=x7+dh;aw2=aw/2;x6=r-aw2;y1=b-ah;swAng=Math.atan(dx/ah);var swAngDeg=swAng*180/Math.PI;mswAng=-swAngDeg;q12=th/2;dang2=Math.atan(q12/idy);var dang2Deg=dang2*180/Math.PI;stAng=c3d4+swAngDeg;stAng2=c3d4-dang2Deg;swAng2=dang2Deg-cd4;swAng3=cd4+dang2Deg;//var cX = x5 - Math.cos(stAng*Math.PI/180) * wR;
    //var cY = y1 - Math.sin(stAng*Math.PI/180) * h;
    var d_val="M"+x6+","+b+" L"+x4+","+y1+" L"+x5+","+y1+shapeArc(wR,h,wR,h,stAng,stAng+mswAng,false).replace("M","L")+" L"+x3+","+t+shapeArc(x3,h,wR,h,c3d4,c3d4+swAngDeg,false).replace("M","L")+" L"+(x5+th)+","+y1+" L"+x8+","+y1+" z"+"M"+x3+","+t+shapeArc(x3,h,wR,h,stAng2,stAng2+swAng2,false).replace("M","L")+shapeArc(wR,h,wR,h,cd2,cd2+swAng3,false).replace("M","L");result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"curvedLeftArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=50000*slideFactor;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,hd2=h/2,r=w,b=h,l=0,t=0,c3d4=270,cd2=180,cd4=90;var ss=Math.min(w,h);var maxAdj2,a2,a1,th,aw,q1,hR,q7,q8,q9,q10,q11,iDx,maxAdj3,a3,ah,y3,q2,q3,q4,q5,dy,y5,y7,q6,dh,y4,y8,aw2,y6,x1,swAng,mswAng,q12,dang2,swAng2,swAng3,stAng3;maxAdj2=cnstVal1*h/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;a1=adj1<0?0:adj1>a2?a2:adj1;th=ss*a1/cnstVal2;aw=ss*a2/cnstVal2;q1=(th+aw)/4;hR=hd2-q1;q7=hR*2;q8=q7*q7;q9=th*th;q10=q8-q9;q11=Math.sqrt(q10);iDx=q11*w/q7;maxAdj3=cnstVal2*iDx/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;ah=ss*a3/cnstVal2;y3=hR+th;q2=w*w;q3=ah*ah;q4=q2-q3;q5=Math.sqrt(q4);dy=q5*hR/w;y5=hR+dy;y7=y3+dy;q6=aw-th;dh=q6/2;y4=y5-dh;y8=y7+dh;aw2=aw/2;y6=b-aw2;x1=l+ah;swAng=Math.atan(dy/ah);mswAng=-swAng;q12=th/2;dang2=Math.atan(q12/iDx);swAng2=dang2-swAng;swAng3=swAng+dang2;stAng3=-dang2;var swAngDg,swAng2Dg,stAng3dg;swAngDg=swAng*180/Math.PI;swAng2Dg=swAng2*180/Math.PI;stAng3dg=stAng3*180/Math.PI;var d_val="M"+r+","+y3+shapeArc(l,hR,w,hR,0,-cd4,false).replace("M","L")+" L"+l+","+t+shapeArc(l,y3,w,hR,c3d4,c3d4+cd4,false).replace("M","L")+" L"+r+","+y3+shapeArc(l,y3,w,hR,0,swAngDg,false).replace("M","L")+" L"+x1+","+y7+" L"+x1+","+y8+" L"+l+","+y6+" L"+x1+","+y4+" L"+x1+","+y5+shapeArc(l,hR,w,hR,swAngDg,swAngDg+swAng2Dg,false).replace("M","L")+shapeArc(l,hR,w,hR,0,-cd4,false).replace("M","L")+shapeArc(l,y3,w,hR,c3d4,c3d4+cd4,false).replace("M","L");result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"curvedRightArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=50000*slideFactor;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,hd2=h/2,r=w,b=h,l=0,t=0,c3d4=270,cd2=180,cd4=90;var ss=Math.min(w,h);var maxAdj2,a2,a1,th,aw,q1,hR,q7,q8,q9,q10,q11,iDx,maxAdj3,a3,ah,y3,q2,q3,q4,q5,dy,y5,y7,q6,dh,y4,y8,aw2,y6,x1,swAng,stAng,mswAng,q12,dang2,swAng2,swAng3,stAng3;maxAdj2=cnstVal1*h/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;a1=adj1<0?0:adj1>a2?a2:adj1;th=ss*a1/cnstVal2;aw=ss*a2/cnstVal2;q1=(th+aw)/4;hR=hd2-q1;q7=hR*2;q8=q7*q7;q9=th*th;q10=q8-q9;q11=Math.sqrt(q10);iDx=q11*w/q7;maxAdj3=cnstVal2*iDx/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;ah=ss*a3/cnstVal2;y3=hR+th;q2=w*w;q3=ah*ah;q4=q2-q3;q5=Math.sqrt(q4);dy=q5*hR/w;y5=hR+dy;y7=y3+dy;q6=aw-th;dh=q6/2;y4=y5-dh;y8=y7+dh;aw2=aw/2;y6=b-aw2;x1=r-ah;swAng=Math.atan(dy/ah);stAng=Math.PI+0-swAng;mswAng=-swAng;q12=th/2;dang2=Math.atan(q12/iDx);swAng2=dang2-Math.PI/2;swAng3=Math.PI/2+dang2;stAng3=Math.PI-dang2;var stAngDg,mswAngDg,swAngDg,swAng2dg;stAngDg=stAng*180/Math.PI;mswAngDg=mswAng*180/Math.PI;swAngDg=swAng*180/Math.PI;swAng2dg=swAng2*180/Math.PI;var d_val="M"+l+","+hR+shapeArc(w,hR,w,hR,cd2,cd2+mswAngDg,false).replace("M","L")+" L"+x1+","+y5+" L"+x1+","+y4+" L"+r+","+y6+" L"+x1+","+y8+" L"+x1+","+y7+shapeArc(w,y3,w,hR,stAngDg,stAngDg+swAngDg,false).replace("M","L")+" L"+l+","+hR+shapeArc(w,hR,w,hR,cd2,cd2+cd4,false).replace("M","L")+" L"+r+","+th+shapeArc(w,y3,w,hR,c3d4,c3d4+swAng2dg,false).replace("M","L");result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"curvedUpArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=25000*slideFactor;var sAdj2,adj2=50000*slideFactor;var sAdj3,adj3=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*slideFactor;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,wd2=w/2,r=w,b=h,l=0,t=0,c3d4=270,cd2=180,cd4=90;var ss=Math.min(w,h);var maxAdj2,a2,a1,th,aw,q1,wR,q7,q8,q9,q10,q11,idy,maxAdj3,a3,ah,x3,q2,q3,q4,q5,dx,x5,x7,q6,dh,x4,x8,aw2,x6,y1,swAng,mswAng,q12,dang2,swAng2,stAng3,swAng3,stAng2;maxAdj2=cnstVal1*w/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;a1=adj1<0?0:adj1>cnstVal2?cnstVal2:adj1;th=ss*a1/cnstVal2;aw=ss*a2/cnstVal2;q1=(th+aw)/4;wR=wd2-q1;q7=wR*2;q8=q7*q7;q9=th*th;q10=q8-q9;q11=Math.sqrt(q10);idy=q11*h/q7;maxAdj3=cnstVal2*idy/ss;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;ah=ss*adj3/cnstVal2;x3=wR+th;q2=h*h;q3=ah*ah;q4=q2-q3;q5=Math.sqrt(q4);dx=q5*wR/h;x5=wR+dx;x7=x3+dx;q6=aw-th;dh=q6/2;x4=x5-dh;x8=x7+dh;aw2=aw/2;x6=r-aw2;y1=t+ah;swAng=Math.atan(dx/ah);mswAng=-swAng;q12=th/2;dang2=Math.atan(q12/idy);swAng2=dang2-swAng;stAng3=Math.PI/2-swAng;swAng3=swAng+dang2;stAng2=Math.PI/2-dang2;var stAng2dg,swAng2dg,swAngDg,swAng2dg;stAng2dg=stAng2*180/Math.PI;swAng2dg=swAng2*180/Math.PI;stAng3dg=stAng3*180/Math.PI;swAngDg=swAng*180/Math.PI;var d_val=//"M" + ix + "," +iy +
    shapeArc(wR,0,wR,h,stAng2dg,stAng2dg+swAng2dg,false)+//.replace("M","L") +
    " L"+x5+","+y1+" L"+x4+","+y1+" L"+x6+","+t+" L"+x8+","+y1+" L"+x7+","+y1+shapeArc(x3,0,wR,h,stAng3dg,stAng3dg+swAngDg,false).replace("M","L")+" L"+wR+","+b+shapeArc(wR,0,wR,h,cd4,cd2,false).replace("M","L")+" L"+th+","+t+shapeArc(x3,0,wR,h,cd2,cd4,false).replace("M","L")+"";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"mathDivide":case"mathEqual":case"mathMinus":case"mathMultiply":case"mathNotEqual":case"mathPlus":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1;var sAdj2,adj2;var sAdj3,adj3;if(shapAdjst_ary!==undefined){if(shapAdjst_ary.constructor===Array){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4));}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4));}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4));}}}else {sAdj1=getTextByPathList(shapAdjst_ary,["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4));}}var cnstVal1=50000*slideFactor;var cnstVal2=100000*slideFactor;var cnstVal3=200000*slideFactor;var dVal;var hc=w/2,vc=h/2,hd2=h/2;if(shapType=="mathNotEqual"){if(shapAdjst_ary===undefined){adj1=23520*slideFactor;adj2=110*Math.PI/180;adj3=11760*slideFactor;}else {adj1=adj1*slideFactor;adj2=adj2/60000*Math.PI/180;adj3=adj3*slideFactor;}var a1,crAng,a2a1,maxAdj3,a3,dy1,dy2,dx1,x1,x8,y2,y3,y1,y4,cadj2,xadj2,len,bhw,bhw2,x7,dx67,x6,dx57,x5,dx47,x4,dx37,x3,dx27,x2,rx7,rx6,rx5,rx4,rx3,dx7,rxt,lxt,rx,lx,dy3,dy4,ry,ly,dlx,drx,dly,dry;var angVal1=70*Math.PI/180,angVal2=110*Math.PI/180;var cnstVal4=73490*slideFactor;//var cd4 = 90;
    a1=adj1<0?0:adj1>cnstVal1?cnstVal1:adj1;crAng=adj2<angVal1?angVal1:adj2>angVal2?angVal2:adj2;a2a1=a1*2;maxAdj3=cnstVal2-a2a1;a3=adj3<0?0:adj3>maxAdj3?maxAdj3:adj3;dy1=h*a1/cnstVal2;dy2=h*a3/cnstVal3;dx1=w*cnstVal4/cnstVal3;x1=hc-dx1;x8=hc+dx1;y2=vc-dy2;y3=vc+dy2;y1=y2-dy1;y4=y3+dy1;cadj2=crAng-Math.PI/2;xadj2=hd2*Math.tan(cadj2);len=Math.sqrt(xadj2*xadj2+hd2*hd2);bhw=len*dy1/hd2;bhw2=bhw/2;x7=hc+xadj2-bhw2;dx67=xadj2*y1/hd2;x6=x7-dx67;dx57=xadj2*y2/hd2;x5=x7-dx57;dx47=xadj2*y3/hd2;x4=x7-dx47;dx37=xadj2*y4/hd2;x3=x7-dx37;dx27=xadj2*2;x2=x7-dx27;rx7=x7+bhw;rx6=x6+bhw;rx5=x5+bhw;rx4=x4+bhw;rx3=x3+bhw;dx7=dy1*hd2/len;rxt=x7+dx7;lxt=rx7-dx7;rx=cadj2>0?rxt:rx7;lx=cadj2>0?x7:lxt;dy3=dy1*xadj2/len;dy4=-dy3;ry=cadj2>0?dy3:0;ly=cadj2>0?0:dy4;dlx=w-rx;drx=w-lx;dly=h-ry;dry=h-ly;dVal="M"+x1+","+y1+" L"+x6+","+y1+" L"+lx+","+ly+" L"+rx+","+ry+" L"+rx6+","+y1+" L"+x8+","+y1+" L"+x8+","+y2+" L"+rx5+","+y2+" L"+rx4+","+y3+" L"+x8+","+y3+" L"+x8+","+y4+" L"+rx3+","+y4+" L"+drx+","+dry+" L"+dlx+","+dly+" L"+x3+","+y4+" L"+x1+","+y4+" L"+x1+","+y3+" L"+x4+","+y3+" L"+x5+","+y2+" L"+x1+","+y2+" z";}else if(shapType=="mathDivide"){if(shapAdjst_ary===undefined){adj1=23520*slideFactor;adj2=5880*slideFactor;adj3=11760*slideFactor;}else {adj1=adj1*slideFactor;adj2=adj2*slideFactor;adj3=adj3*slideFactor;}var a1,ma1,ma3h,ma3w,maxAdj3,a3,m4a3,maxAdj2,a2,dy1,yg,rad,dx1,y3,y4,a,y2,y1,y5,x1,x3,x2;var cnstVal4=1000*slideFactor;var cnstVal5=36745*slideFactor;var cnstVal6=73490*slideFactor;a1=adj1<cnstVal4?cnstVal4:adj1>cnstVal5?cnstVal5:adj1;ma1=-a1;ma3h=(cnstVal6+ma1)/4;ma3w=cnstVal5*w/h;maxAdj3=ma3h<ma3w?ma3h:ma3w;a3=adj3<cnstVal4?cnstVal4:adj3>maxAdj3?maxAdj3:adj3;m4a3=-4*a3;maxAdj2=cnstVal6+m4a3-a1;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;dy1=h*a1/cnstVal3;yg=h*a2/cnstVal2;rad=h*a3/cnstVal2;dx1=w*cnstVal6/cnstVal3;y3=vc-dy1;y4=vc+dy1;a=yg+rad;y2=y3-a;y1=y2-rad;y5=h-y1;x1=hc-dx1;x3=hc+dx1;x2=hc-rad;var cd4=90,c3d4=270;var cX1=hc-Math.cos(c3d4*Math.PI/180)*rad;var cY1=y1-Math.sin(c3d4*Math.PI/180)*rad;var cX2=hc-Math.cos(Math.PI/2)*rad;var cY2=y5-Math.sin(Math.PI/2)*rad;dVal="M"+hc+","+y1+shapeArc(cX1,cY1,rad,rad,c3d4,c3d4+360,false).replace("M","L")+" z"+" M"+hc+","+y5+shapeArc(cX2,cY2,rad,rad,cd4,cd4+360,false).replace("M","L")+" z"+" M"+x1+","+y3+" L"+x3+","+y3+" L"+x3+","+y4+" L"+x1+","+y4+" z";}else if(shapType=="mathEqual"){if(shapAdjst_ary===undefined){adj1=23520*slideFactor;adj2=11760*slideFactor;}else {adj1=adj1*slideFactor;adj2=adj2*slideFactor;}var cnstVal5=36745*slideFactor;var cnstVal6=73490*slideFactor;var a1,a2a1,mAdj2,a2,dy1,dy2,dx1,y2,y3,y1,y4,x1,x2;a1=adj1<0?0:adj1>cnstVal5?cnstVal5:adj1;a2a1=a1*2;mAdj2=cnstVal2-a2a1;a2=adj2<0?0:adj2>mAdj2?mAdj2:adj2;dy1=h*a1/cnstVal2;dy2=h*a2/cnstVal3;dx1=w*cnstVal6/cnstVal3;y2=vc-dy2;y3=vc+dy2;y1=y2-dy1;y4=y3+dy1;x1=hc-dx1;x2=hc+dx1;dVal="M"+x1+","+y1+" L"+x2+","+y1+" L"+x2+","+y2+" L"+x1+","+y2+" z"+"M"+x1+","+y3+" L"+x2+","+y3+" L"+x2+","+y4+" L"+x1+","+y4+" z";}else if(shapType=="mathMinus"){if(shapAdjst_ary===undefined){adj1=23520*slideFactor;}else {adj1=adj1*slideFactor;}var cnstVal6=73490*slideFactor;var a1,dy1,dx1,y1,y2,x1,x2;a1=adj1<0?0:adj1>cnstVal2?cnstVal2:adj1;dy1=h*a1/cnstVal3;dx1=w*cnstVal6/cnstVal3;y1=vc-dy1;y2=vc+dy1;x1=hc-dx1;x2=hc+dx1;dVal="M"+x1+","+y1+" L"+x2+","+y1+" L"+x2+","+y2+" L"+x1+","+y2+" z";}else if(shapType=="mathMultiply"){if(shapAdjst_ary===undefined){adj1=23520*slideFactor;}else {adj1=adj1*slideFactor;}var cnstVal6=51965*slideFactor;var a1,th,a,sa,ca,ta,dl,rw,lM,xM,yM,dxAM,dyAM,xA,yA,xB,yB,xBC,yBC,yC,xD,xE,yFE,xFE,xF,xL,yG,yH,yI;var ss=Math.min(w,h);a1=adj1<0?0:adj1>cnstVal6?cnstVal6:adj1;th=ss*a1/cnstVal2;a=Math.atan(h/w);sa=1*Math.sin(a);ca=1*Math.cos(a);ta=1*Math.tan(a);dl=Math.sqrt(w*w+h*h);rw=dl*cnstVal6/cnstVal2;lM=dl-rw;xM=ca*lM/2;yM=sa*lM/2;dxAM=sa*th/2;dyAM=ca*th/2;xA=xM-dxAM;yA=yM+dyAM;xB=xM+dxAM;yB=yM-dyAM;xBC=hc-xB;yBC=xBC*ta;yC=yBC+yB;xD=w-xB;xE=w-xA;yFE=vc-yA;xFE=yFE/ta;xF=xE-xFE;xL=xA+xFE;yG=h-yA;yH=h-yB;yI=h-yC;dVal="M"+xA+","+yA+" L"+xB+","+yB+" L"+hc+","+yC+" L"+xD+","+yB+" L"+xE+","+yA+" L"+xF+","+vc+" L"+xE+","+yG+" L"+xD+","+yH+" L"+hc+","+yI+" L"+xB+","+yH+" L"+xA+","+yG+" L"+xL+","+vc+" z";}else if(shapType=="mathPlus"){if(shapAdjst_ary===undefined){adj1=23520*slideFactor;}else {adj1=adj1*slideFactor;}var cnstVal6=73490*slideFactor;var ss=Math.min(w,h);var a1,dx1,dy1,dx2,x1,x2,x3,x4,y1,y2,y3,y4;a1=adj1<0?0:adj1>cnstVal6?cnstVal6:adj1;dx1=w*cnstVal6/cnstVal3;dy1=h*cnstVal6/cnstVal3;dx2=ss*a1/cnstVal3;x1=hc-dx1;x2=hc-dx2;x3=hc+dx2;x4=hc+dx1;y1=vc-dy1;y2=vc-dx2;y3=vc+dx2;y4=vc+dy1;dVal="M"+x1+","+y2+" L"+x2+","+y2+" L"+x2+","+y1+" L"+x3+","+y1+" L"+x3+","+y2+" L"+x4+","+y2+" L"+x4+","+y3+" L"+x3+","+y3+" L"+x3+","+y4+" L"+x2+","+y4+" L"+x2+","+y3+" L"+x1+","+y3+" z";}result+="<path d='"+dVal+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";//console.log(shapType);
    break;case"can":case"flowChartMagneticDisk":case"flowChartMagneticDrum":var shapAdjst=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd","attrs","fmla"]);var adj=25000*slideFactor;var cnstVal1=50000*slideFactor;var cnstVal2=200000*slideFactor;if(shapAdjst!==undefined){adj=parseInt(shapAdjst.substr(4))*slideFactor;}var ss=Math.min(w,h);var maxAdj,a,y1,y2,y3,dVal;if(shapType=="flowChartMagneticDisk"||shapType=="flowChartMagneticDrum"){adj=50000*slideFactor;}maxAdj=cnstVal1*h/ss;a=adj<0?0:adj>maxAdj?maxAdj:adj;y1=ss*a/cnstVal2;y2=y1+y1;y3=h-y1;var cd2=180,wd2=w/2;var tranglRott="";if(shapType=="flowChartMagneticDrum"){tranglRott="transform='rotate(90 "+w/2+","+h/2+")'";}dVal=shapeArc(wd2,y1,wd2,y1,0,cd2,false)+shapeArc(wd2,y1,wd2,y1,cd2,cd2+cd2,false).replace("M","L")+" L"+w+","+y3+shapeArc(wd2,y3,wd2,y1,0,cd2,false).replace("M","L")+" L"+0+","+y1;result+="<path "+tranglRott+" d='"+dVal+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"swooshArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var refr=slideFactor;var sAdj1,adj1=25000*refr;var sAdj2,adj2=16667*refr;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*refr;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))*refr;}}}var cnstVal1=1*refr;var cnstVal2=70000*refr;var cnstVal3=75000*refr;var cnstVal4=100000*refr;var ss=Math.min(w,h);var ssd8=ss/8;var hd6=h/6;var a1,maxAdj2,a2,ad1,ad2,xB,yB,alfa,dx0,xC,dx1,yF,xF,xE,yE,dy2,dy22,dy3,yD,dy4,yP1,xP1,dy5,yP2,xP2;a1=adj1<cnstVal1?cnstVal1:adj1>cnstVal3?cnstVal3:adj1;maxAdj2=cnstVal2*w/ss;a2=adj2<0?0:adj2>maxAdj2?maxAdj2:adj2;ad1=h*a1/cnstVal4;ad2=ss*a2/cnstVal4;xB=w-ad2;yB=ssd8;alfa=Math.PI/2/14;dx0=ssd8*Math.tan(alfa);xC=xB-dx0;dx1=ad1*Math.tan(alfa);yF=yB+ad1;xF=xB+dx1;xE=xF+dx0;yE=yF+ssd8;dy2=yE-0;dy22=dy2/2;dy3=h/20;yD=dy22-dy3;dy4=hd6;yP1=hd6+dy4;xP1=w/6;dy5=hd6/2;yP2=yF+dy5;xP2=w/4;var dVal="M"+0+","+h+" Q"+xP1+","+yP1+" "+xB+","+yB+" L"+xC+","+0+" L"+w+","+yD+" L"+xE+","+yE+" L"+xF+","+yF+" Q"+xP2+","+yP2+" "+0+","+h+" z";result+="<path d='"+dVal+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"circularArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=12500*slideFactor;var sAdj2,adj2=1142319/60000*Math.PI/180;var sAdj3,adj3=20457681/60000*Math.PI/180;var sAdj4,adj4=10800000/60000*Math.PI/180;var sAdj5,adj5=12500*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))/60000*Math.PI/180;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))/60000*Math.PI/180;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))/60000*Math.PI/180;}else if(sAdj_name=="adj5"){sAdj5=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj5=parseInt(sAdj5.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,r=w,b=h,l=0,t=0,wd2=w/2,hd2=h/2;var ss=Math.min(w,h);var a5,maxAdj1,a1,enAng,stAng,th,thh,th2,rw1,rh1,rw2,rh2,rw3,rh3,wtH,htH,dxH,dyH,xH,yH,rI,u1,u2,u3,u4,u5,u6,u7,u8,u9,u10,u11,u12,u13,u14,u15,u16,u17,u18,u19,u20,u21,maxAng,aAng,ptAng,wtA,htA,dxA,dyA,xA,yA,wtE,htE,dxE,dyE,xE,yE,dxG,dyG,xG,yG,dxB,dyB,xB,yB,sx1,sy1,sx2,sy2,rO,x1O,y1O,x2O,y2O,dxO,dyO,dO,q1,q2,DO,q3,q4,q5,q6,q7,q8,sdelO,ndyO,sdyO,q9,q10,q11,dxF1,q12,dxF2,adyO,q13,q14,dyF1,q15,dyF2,q16,q17,q18,q19,q20,q21,q22,dxF,dyF,sdxF,sdyF,xF,yF,x1I,y1I,x2I,y2I,dxI,dyI,dI,v1,v2,DI,v3,v4,v5,v6,v7,v8,sdelI,v9,v10,v11,dxC1,v12,dxC2,adyI,v13,v14,dyC1,v15,dyC2,v16,v17,v18,v19,v20,v21,v22,dxC,dyC,sdxC,sdyC,xC,yC,ist0,ist1,istAng,isw1,isw2,iswAng,p1,p2,p3,p4,p5,xGp,yGp,xBp,yBp,en0,en1,en2,sw0,sw1,swAng;var cnstVal1=25000*slideFactor;var cnstVal2=100000*slideFactor;var rdAngVal1=1/60000*Math.PI/180;var rdAngVal2=21599999/60000*Math.PI/180;var rdAngVal3=2*Math.PI;a5=adj5<0?0:adj5>cnstVal1?cnstVal1:adj5;maxAdj1=a5*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;enAng=adj3<rdAngVal1?rdAngVal1:adj3>rdAngVal2?rdAngVal2:adj3;stAng=adj4<0?0:adj4>rdAngVal2?rdAngVal2:adj4;//////////////////////////////////////////
    th=ss*a1/cnstVal2;thh=ss*a5/cnstVal2;th2=th/2;rw1=wd2+th2-thh;rh1=hd2+th2-thh;rw2=rw1-th;rh2=rh1-th;rw3=rw2+th2;rh3=rh2+th2;wtH=rw3*Math.sin(enAng);htH=rh3*Math.cos(enAng);//dxH = rw3*Math.cos(Math.atan(wtH/htH));
    //dyH = rh3*Math.sin(Math.atan(wtH/htH));
    dxH=rw3*Math.cos(Math.atan2(wtH,htH));dyH=rh3*Math.sin(Math.atan2(wtH,htH));xH=hc+dxH;yH=vc+dyH;rI=rw2<rh2?rw2:rh2;u1=dxH*dxH;u2=dyH*dyH;u3=rI*rI;u4=u1-u3;u5=u2-u3;u6=u4*u5/u1;u7=u6/u2;u8=1-u7;u9=Math.sqrt(u8);u10=u4/dxH;u11=u10/dyH;u12=(1+u9)/u11;//u13 = Math.atan(u12/1);
    u13=Math.atan2(u12,1);u14=u13+rdAngVal3;u15=u13>0?u13:u14;u16=u15-enAng;u17=u16+rdAngVal3;u18=u16>0?u16:u17;u19=u18-cd2;u20=u18-rdAngVal3;u21=u19>0?u20:u18;maxAng=Math.abs(u21);aAng=adj2<0?0:adj2>maxAng?maxAng:adj2;ptAng=enAng+aAng;wtA=rw3*Math.sin(ptAng);htA=rh3*Math.cos(ptAng);//dxA = rw3*Math.cos(Math.atan(wtA/htA));
    //dyA = rh3*Math.sin(Math.atan(wtA/htA));
    dxA=rw3*Math.cos(Math.atan2(wtA,htA));dyA=rh3*Math.sin(Math.atan2(wtA,htA));xA=hc+dxA;yA=vc+dyA;wtE=rw1*Math.sin(stAng);htE=rh1*Math.cos(stAng);//dxE = rw1*Math.cos(Math.atan(wtE/htE));
    //dyE = rh1*Math.sin(Math.atan(wtE/htE));
    dxE=rw1*Math.cos(Math.atan2(wtE,htE));dyE=rh1*Math.sin(Math.atan2(wtE,htE));xE=hc+dxE;yE=vc+dyE;dxG=thh*Math.cos(ptAng);dyG=thh*Math.sin(ptAng);xG=xH+dxG;yG=yH+dyG;dxB=thh*Math.cos(ptAng);dyB=thh*Math.sin(ptAng);xB=xH-dxB;yB=yH-dyB;sx1=xB-hc;sy1=yB-vc;sx2=xG-hc;sy2=yG-vc;rO=rw1<rh1?rw1:rh1;x1O=sx1*rO/rw1;y1O=sy1*rO/rh1;x2O=sx2*rO/rw1;y2O=sy2*rO/rh1;dxO=x2O-x1O;dyO=y2O-y1O;dO=Math.sqrt(dxO*dxO+dyO*dyO);q1=x1O*y2O;q2=x2O*y1O;DO=q1-q2;q3=rO*rO;q4=dO*dO;q5=q3*q4;q6=DO*DO;q7=q5-q6;q8=q7>0?q7:0;sdelO=Math.sqrt(q8);ndyO=dyO*-1;sdyO=ndyO>0?-1:1;q9=sdyO*dxO;q10=q9*sdelO;q11=DO*dyO;dxF1=(q11+q10)/q4;q12=q11-q10;dxF2=q12/q4;adyO=Math.abs(dyO);q13=adyO*sdelO;q14=DO*dxO/-1;dyF1=(q14+q13)/q4;q15=q14-q13;dyF2=q15/q4;q16=x2O-dxF1;q17=x2O-dxF2;q18=y2O-dyF1;q19=y2O-dyF2;q20=Math.sqrt(q16*q16+q18*q18);q21=Math.sqrt(q17*q17+q19*q19);q22=q21-q20;dxF=q22>0?dxF1:dxF2;dyF=q22>0?dyF1:dyF2;sdxF=dxF*rw1/rO;sdyF=dyF*rh1/rO;xF=hc+sdxF;yF=vc+sdyF;x1I=sx1*rI/rw2;y1I=sy1*rI/rh2;x2I=sx2*rI/rw2;y2I=sy2*rI/rh2;dxI=x2I-x1I;dyI=y2I-y1I;dI=Math.sqrt(dxI*dxI+dyI*dyI);v1=x1I*y2I;v2=x2I*y1I;DI=v1-v2;v3=rI*rI;v4=dI*dI;v5=v3*v4;v6=DI*DI;v7=v5-v6;v8=v7>0?v7:0;sdelI=Math.sqrt(v8);v9=sdyO*dxI;v10=v9*sdelI;v11=DI*dyI;dxC1=(v11+v10)/v4;v12=v11-v10;dxC2=v12/v4;adyI=Math.abs(dyI);v13=adyI*sdelI;v14=DI*dxI/-1;dyC1=(v14+v13)/v4;v15=v14-v13;dyC2=v15/v4;v16=x1I-dxC1;v17=x1I-dxC2;v18=y1I-dyC1;v19=y1I-dyC2;v20=Math.sqrt(v16*v16+v18*v18);v21=Math.sqrt(v17*v17+v19*v19);v22=v21-v20;dxC=v22>0?dxC1:dxC2;dyC=v22>0?dyC1:dyC2;sdxC=dxC*rw2/rI;sdyC=dyC*rh2/rI;xC=hc+sdxC;yC=vc+sdyC;//ist0 = Math.atan(sdyC/sdxC);
    ist0=Math.atan2(sdyC,sdxC);ist1=ist0+rdAngVal3;istAng=ist0>0?ist0:ist1;isw1=stAng-istAng;isw2=isw1-rdAngVal3;iswAng=isw1>0?isw2:isw1;p1=xF-xC;p2=yF-yC;p3=Math.sqrt(p1*p1+p2*p2);p4=p3/2;p5=p4-thh;xGp=p5>0?xF:xG;yGp=p5>0?yF:yG;xBp=p5>0?xC:xB;yBp=p5>0?yC:yB;//en0 = Math.atan(sdyF/sdxF);
    en0=Math.atan2(sdyF,sdxF);en1=en0+rdAngVal3;en2=en0>0?en0:en1;sw0=en2-stAng;sw1=sw0+rdAngVal3;swAng=sw0>0?sw0:sw1;var strtAng=stAng*180/Math.PI;var endAng=strtAng+swAng*180/Math.PI;var stiAng=istAng*180/Math.PI;var swiAng=iswAng*180/Math.PI;var ediAng=stiAng+swiAng;var d_val=shapeArc(w/2,h/2,rw1,rh1,strtAng,endAng,false)+" L"+xGp+","+yGp+" L"+xA+","+yA+" L"+xBp+","+yBp+" L"+xC+","+yC+shapeArc(w/2,h/2,rw2,rh2,stiAng,ediAng,false).replace("M","L")+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftCircularArrow":var shapAdjst_ary=getTextByPathList(node,["p:spPr","a:prstGeom","a:avLst","a:gd"]);var sAdj1,adj1=12500*slideFactor;var sAdj2,adj2=-1142319/60000*Math.PI/180;var sAdj3,adj3=1142319/60000*Math.PI/180;var sAdj4,adj4=10800000/60000*Math.PI/180;var sAdj5,adj5=12500*slideFactor;if(shapAdjst_ary!==undefined){for(var i=0;i<shapAdjst_ary.length;i++){var sAdj_name=getTextByPathList(shapAdjst_ary[i],["attrs","name"]);if(sAdj_name=="adj1"){sAdj1=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj1=parseInt(sAdj1.substr(4))*slideFactor;}else if(sAdj_name=="adj2"){sAdj2=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj2=parseInt(sAdj2.substr(4))/60000*Math.PI/180;}else if(sAdj_name=="adj3"){sAdj3=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj3=parseInt(sAdj3.substr(4))/60000*Math.PI/180;}else if(sAdj_name=="adj4"){sAdj4=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj4=parseInt(sAdj4.substr(4))/60000*Math.PI/180;}else if(sAdj_name=="adj5"){sAdj5=getTextByPathList(shapAdjst_ary[i],["attrs","fmla"]);adj5=parseInt(sAdj5.substr(4))*slideFactor;}}}var vc=h/2,hc=w/2,r=w,b=h,l=0,t=0,wd2=w/2,hd2=h/2;var ss=Math.min(w,h);var cnstVal1=25000*slideFactor;var cnstVal2=100000*slideFactor;var rdAngVal1=1/60000*Math.PI/180;var rdAngVal2=21599999/60000*Math.PI/180;var rdAngVal3=2*Math.PI;var a5,maxAdj1,a1,enAng,stAng,th,thh,th2,rw1,rh1,rw2,rh2,rw3,rh3,wtH,htH,dxH,dyH,xH,yH,rI,u1,u2,u3,u4,u5,u6,u7,u8,u9,u10,u11,u12,u13,u14,u15,u16,u17,u18,u19,u20,u21,u22,minAng,u23,a2,aAng,ptAng,wtA,htA,dxA,dyA,xA,yA,wtE,htE,dxE,dyE,xE,yE,wtD,htD,dxD,dyD,xD,yD,dxG,dyG,xG,yG,dxB,dyB,xB,yB,sx1,sy1,sx2,sy2,rO,x1O,y1O,x2O,y2O,dxO,dyO,dO,q1,q2,DO,q3,q4,q5,q6,q7,q8,sdelO,ndyO,sdyO,q9,q10,q11,dxF1,q12,dxF2,adyO,q13,q14,dyF1,q15,dyF2,q16,q17,q18,q19,q20,q21,q22,dxF,dyF,sdxF,sdyF,xF,yF,x1I,y1I,x2I,y2I,dxI,dyI,dI,v1,v2,DI,v3,v4,v5,v6,v7,v8,sdelI,v9,v10,v11,dxC1,v12,dxC2,adyI,v13,v14,dyC1,v15,dyC2,v16,v17,v18,v19,v20,v21,v22,dxC,dyC,sdxC,sdyC,xC,yC,ist0,ist1,istAng0,isw1,isw2,iswAng0,istAng,iswAng,p1,p2,p3,p4,p5,xGp,yGp,xBp,yBp,en0,en1,en2,sw0,sw1,swAng,stAng0;a5=adj5<0?0:adj5>cnstVal1?cnstVal1:adj5;maxAdj1=a5*2;a1=adj1<0?0:adj1>maxAdj1?maxAdj1:adj1;enAng=adj3<rdAngVal1?rdAngVal1:adj3>rdAngVal2?rdAngVal2:adj3;stAng=adj4<0?0:adj4>rdAngVal2?rdAngVal2:adj4;th=ss*a1/cnstVal2;thh=ss*a5/cnstVal2;th2=th/2;rw1=wd2+th2-thh;rh1=hd2+th2-thh;rw2=rw1-th;rh2=rh1-th;rw3=rw2+th2;rh3=rh2+th2;wtH=rw3*Math.sin(enAng);htH=rh3*Math.cos(enAng);dxH=rw3*Math.cos(Math.atan2(wtH,htH));dyH=rh3*Math.sin(Math.atan2(wtH,htH));xH=hc+dxH;yH=vc+dyH;rI=rw2<rh2?rw2:rh2;u1=dxH*dxH;u2=dyH*dyH;u3=rI*rI;u4=u1-u3;u5=u2-u3;u6=u4*u5/u1;u7=u6/u2;u8=1-u7;u9=Math.sqrt(u8);u10=u4/dxH;u11=u10/dyH;u12=(1+u9)/u11;u13=Math.atan2(u12,1);u14=u13+rdAngVal3;u15=u13>0?u13:u14;u16=u15-enAng;u17=u16+rdAngVal3;u18=u16>0?u16:u17;u19=u18-cd2;u20=u18-rdAngVal3;u21=u19>0?u20:u18;u22=Math.abs(u21);minAng=u22*-1;u23=Math.abs(adj2);a2=u23*-1;aAng=a2<minAng?minAng:a2>0?0:a2;ptAng=enAng+aAng;wtA=rw3*Math.sin(ptAng);htA=rh3*Math.cos(ptAng);dxA=rw3*Math.cos(Math.atan2(wtA,htA));dyA=rh3*Math.sin(Math.atan2(wtA,htA));xA=hc+dxA;yA=vc+dyA;wtE=rw1*Math.sin(stAng);htE=rh1*Math.cos(stAng);dxE=rw1*Math.cos(Math.atan2(wtE,htE));dyE=rh1*Math.sin(Math.atan2(wtE,htE));xE=hc+dxE;yE=vc+dyE;wtD=rw2*Math.sin(stAng);htD=rh2*Math.cos(stAng);dxD=rw2*Math.cos(Math.atan2(wtD,htD));dyD=rh2*Math.sin(Math.atan2(wtD,htD));xD=hc+dxD;yD=vc+dyD;dxG=thh*Math.cos(ptAng);dyG=thh*Math.sin(ptAng);xG=xH+dxG;yG=yH+dyG;dxB=thh*Math.cos(ptAng);dyB=thh*Math.sin(ptAng);xB=xH-dxB;yB=yH-dyB;sx1=xB-hc;sy1=yB-vc;sx2=xG-hc;sy2=yG-vc;rO=rw1<rh1?rw1:rh1;x1O=sx1*rO/rw1;y1O=sy1*rO/rh1;x2O=sx2*rO/rw1;y2O=sy2*rO/rh1;dxO=x2O-x1O;dyO=y2O-y1O;dO=Math.sqrt(dxO*dxO+dyO*dyO);q1=x1O*y2O;q2=x2O*y1O;DO=q1-q2;q3=rO*rO;q4=dO*dO;q5=q3*q4;q6=DO*DO;q7=q5-q6;q8=q7>0?q7:0;sdelO=Math.sqrt(q8);ndyO=dyO*-1;sdyO=ndyO>0?-1:1;q9=sdyO*dxO;q10=q9*sdelO;q11=DO*dyO;dxF1=(q11+q10)/q4;q12=q11-q10;dxF2=q12/q4;adyO=Math.abs(dyO);q13=adyO*sdelO;q14=DO*dxO/-1;dyF1=(q14+q13)/q4;q15=q14-q13;dyF2=q15/q4;q16=x2O-dxF1;q17=x2O-dxF2;q18=y2O-dyF1;q19=y2O-dyF2;q20=Math.sqrt(q16*q16+q18*q18);q21=Math.sqrt(q17*q17+q19*q19);q22=q21-q20;dxF=q22>0?dxF1:dxF2;dyF=q22>0?dyF1:dyF2;sdxF=dxF*rw1/rO;sdyF=dyF*rh1/rO;xF=hc+sdxF;yF=vc+sdyF;x1I=sx1*rI/rw2;y1I=sy1*rI/rh2;x2I=sx2*rI/rw2;y2I=sy2*rI/rh2;dxI=x2I-x1I;dyI=y2I-y1I;dI=Math.sqrt(dxI*dxI+dyI*dyI);v1=x1I*y2I;v2=x2I*y1I;DI=v1-v2;v3=rI*rI;v4=dI*dI;v5=v3*v4;v6=DI*DI;v7=v5-v6;v8=v7>0?v7:0;sdelI=Math.sqrt(v8);v9=sdyO*dxI;v10=v9*sdelI;v11=DI*dyI;dxC1=(v11+v10)/v4;v12=v11-v10;dxC2=v12/v4;adyI=Math.abs(dyI);v13=adyI*sdelI;v14=DI*dxI/-1;dyC1=(v14+v13)/v4;v15=v14-v13;dyC2=v15/v4;v16=x1I-dxC1;v17=x1I-dxC2;v18=y1I-dyC1;v19=y1I-dyC2;v20=Math.sqrt(v16*v16+v18*v18);v21=Math.sqrt(v17*v17+v19*v19);v22=v21-v20;dxC=v22>0?dxC1:dxC2;dyC=v22>0?dyC1:dyC2;sdxC=dxC*rw2/rI;sdyC=dyC*rh2/rI;xC=hc+sdxC;yC=vc+sdyC;ist0=Math.atan2(sdyC,sdxC);ist1=ist0+rdAngVal3;istAng0=ist0>0?ist0:ist1;isw1=stAng-istAng0;isw2=isw1+rdAngVal3;iswAng0=isw1>0?isw1:isw2;istAng=istAng0+iswAng0;iswAng=-iswAng0;p1=xF-xC;p2=yF-yC;p3=Math.sqrt(p1*p1+p2*p2);p4=p3/2;p5=p4-thh;xGp=p5>0?xF:xG;yGp=p5>0?yF:yG;xBp=p5>0?xC:xB;yBp=p5>0?yC:yB;en0=Math.atan2(sdyF,sdxF);en1=en0+rdAngVal3;en2=en0>0?en0:en1;sw0=en2-stAng;sw1=sw0-rdAngVal3;swAng=sw0>0?sw1:sw0;stAng0=stAng+swAng;var strtAng=stAng0*180/Math.PI;var endAng=stAng*180/Math.PI;var stiAng=istAng*180/Math.PI;var swiAng=iswAng*180/Math.PI;var ediAng=stiAng+swiAng;var d_val="M"+xE+","+yE+" L"+xD+","+yD+shapeArc(w/2,h/2,rw2,rh2,stiAng,ediAng,false).replace("M","L")+" L"+xBp+","+yBp+" L"+xA+","+yA+" L"+xGp+","+yGp+" L"+xF+","+yF+shapeArc(w/2,h/2,rw1,rh1,strtAng,endAng,false).replace("M","L")+" z";result+="<path d='"+d_val+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+border.color+"' stroke-width='"+border.width+"' stroke-dasharray='"+border.strokeDasharray+"' />";break;case"leftRightCircularArrow":case"chartPlus":case"chartStar":case"chartX":case"cornerTabs":case"flowChartOfflineStorage":case"folderCorner":case"funnel":case"lineInv":case"nonIsoscelesTrapezoid":case"plaqueTabs":case"squareTabs":case"upDownArrowCallout":console.log(shapType," -unsupported shape type.");break;case undefined:default:console.warn("Undefine shape type.("+shapType+")");}result+="</svg>";html+="<div class='block "+getVerticalAlign(node,slideLayoutSpNode,slideMasterSpNode)+//block content
    " "+getContentDir()+"' _id='"+id+"' _idx='"+idx+"' _type='"+type+"' _name='"+name+"' style='"+getPosition(slideXfrmNode,pNode,slideLayoutXfrmNode,slideMasterXfrmNode,sType)+getSize(slideXfrmNode,slideLayoutXfrmNode,slideMasterXfrmNode)+" z-index: "+order+";"+"transform: rotate("+(txtRotate!==undefined?txtRotate:0)+"deg);"+"'>";// TextBody
    var textBody;if(node["p:txBody"]!==undefined&&(isUserDrawnBg===undefined||isUserDrawnBg===true)){if(type!="diagram"&&type!="textBox"){type="shape";}textBody=genTextBody(node["p:txBody"],node,slideLayoutSpNode,slideMasterSpNode,type,idx,warpObj);//type='shape'
    html+=textBody;html+="</div>";}else {html="";}var json={type:(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")==="none"?"text":"shape",left:left,top:top,width:width,height:height,order:order,rotate:txtRotate,fillColor:fillColor,content:html,svg:result};return {html:result+html,json:json};}else if(custShapType!==undefined){//custGeom here - Amir ///////////////////////////////////////////////////////
    //http://officeopenxml.com/drwSp-custGeom.php
    var pathLstNode=getTextByPathList(custShapType,["a:pathLst"]);var pathNodes=getTextByPathList(pathLstNode,["a:path"]);//var pathNode = getTextByPathList(pathLstNode, ["a:path", "attrs"]);
    var maxX=parseInt(pathNodes["attrs"]["w"]);// * slideFactor;
    var maxY=parseInt(pathNodes["attrs"]["h"]);// * slideFactor;
    var cX=1/maxX*w;var cY=1/maxY*h;//console.log("w = "+w+"\nh = "+h+"\nmaxX = "+maxX +"\nmaxY = " + maxY);
    //cheke if it is close shape
    //console.log("custShapType : ", custShapType, ", pathLstNode: ", pathLstNode, ", node: ", node);//, ", y:", y, ", w:", w, ", h:", h);
    var moveToNode=getTextByPathList(pathNodes,["a:moveTo"]);moveToNode.length;var lnToNodes=pathNodes["a:lnTo"];//total a:pt : 1
    var cubicBezToNodes=pathNodes["a:cubicBezTo"];//total a:pt : 3
    var arcToNodes=pathNodes["a:arcTo"];//total a:pt : 0?1? ; attrs: ~4 ()
    var closeNode=getTextByPathList(pathNodes,["a:close"]);//total a:pt : 0
    //quadBezTo //total a:pt : 2 - TODO
    //console.log("ia moveToNode array: ", Array.isArray(moveToNode))
    if(!Array.isArray(moveToNode)){moveToNode=[moveToNode];}//console.log("ia moveToNode array: ", Array.isArray(moveToNode))
    var multiSapeAry=[];if(moveToNode.length>0){//a:moveTo
    Object.keys(moveToNode).forEach(function(key){var moveToPtNode=moveToNode[key]["a:pt"];if(moveToPtNode!==undefined){Object.keys(moveToPtNode).forEach(function(key2){var ptObj={};var moveToNoPt=moveToPtNode[key2];var spX=moveToNoPt[("x")];//parseInt(moveToNoPt["attrs", "x"]) * slideFactor;
    var spY=moveToNoPt[("y")];//parseInt(moveToNoPt["attrs", "y"]) * slideFactor;
    var ptOrdr=moveToNoPt[("order")];ptObj.type="movto";ptObj.order=ptOrdr;ptObj.x=spX;ptObj.y=spY;multiSapeAry.push(ptObj);//console.log(key2, lnToNoPt);
    });}});//a:lnTo
    if(lnToNodes!==undefined){Object.keys(lnToNodes).forEach(function(key){var lnToPtNode=lnToNodes[key]["a:pt"];if(lnToPtNode!==undefined){Object.keys(lnToPtNode).forEach(function(key2){var ptObj={};var lnToNoPt=lnToPtNode[key2];var ptX=lnToNoPt[("x")];var ptY=lnToNoPt[("y")];var ptOrdr=lnToNoPt[("order")];ptObj.type="lnto";ptObj.order=ptOrdr;ptObj.x=ptX;ptObj.y=ptY;multiSapeAry.push(ptObj);//console.log(key2, lnToNoPt);
    });}});}//a:cubicBezTo
    if(cubicBezToNodes!==undefined){var cubicBezToPtNodesAry=[];//console.log("cubicBezToNodes: ", cubicBezToNodes, ", is arry: ", Array.isArray(cubicBezToNodes))
    if(!Array.isArray(cubicBezToNodes)){cubicBezToNodes=[cubicBezToNodes];}Object.keys(cubicBezToNodes).forEach(function(key){//console.log("cubicBezTo[" + key + "]:");
    cubicBezToPtNodesAry.push(cubicBezToNodes[key]["a:pt"]);});//console.log("cubicBezToNodes: ", cubicBezToPtNodesAry)
    cubicBezToPtNodesAry.forEach(function(key2){//console.log("cubicBezToPtNodesAry: key2 : ", key2)
    var nodeObj={};nodeObj.type="cubicBezTo";nodeObj.order=key2[0]["attrs"]["order"];var pts_ary=[];key2.forEach(function(pt){var pt_obj={x:pt["attrs"]["x"],y:pt["attrs"]["y"]};pts_ary.push(pt_obj);});nodeObj.cubBzPt=pts_ary;//key2;
    multiSapeAry.push(nodeObj);});}//a:arcTo
    if(arcToNodes!==undefined){var arcToNodesAttrs=arcToNodes["attrs"];var arcOrder=arcToNodesAttrs["order"];var hR=arcToNodesAttrs["hR"];var wR=arcToNodesAttrs["wR"];var stAng=arcToNodesAttrs["stAng"];var swAng=arcToNodesAttrs["swAng"];var shftX=0;var shftY=0;var arcToPtNode=getTextByPathList(arcToNodes,["a:pt","attrs"]);if(arcToPtNode!==undefined){shftX=arcToPtNode["x"];shftY=arcToPtNode["y"];//console.log("shftX: ",shftX," shftY: ",shftY)
    }var ptObj={};ptObj.type="arcTo";ptObj.order=arcOrder;ptObj.hR=hR;ptObj.wR=wR;ptObj.stAng=stAng;ptObj.swAng=swAng;ptObj.shftX=shftX;ptObj.shftY=shftY;multiSapeAry.push(ptObj);}//a:quadBezTo - TODO
    //a:close
    if(closeNode!==undefined){if(!Array.isArray(closeNode)){closeNode=[closeNode];}// Object.keys(closeNode).forEach(function (key) {
    //     //console.log("cubicBezTo[" + key + "]:");
    //     cubicBezToPtNodesAry.push(closeNode[key]["a:pt"]);
    // });
    Object.keys(closeNode).forEach(function(key){//console.log("custShapType >> closeNode: key: ", key);
    var clsAttrs=closeNode[key]["attrs"];//var clsAttrs = closeNode["attrs"];
    var clsOrder=clsAttrs["order"];var ptObj={};ptObj.type="close";ptObj.order=clsOrder;multiSapeAry.push(ptObj);});}// console.log("custShapType >> multiSapeAry: ", multiSapeAry);
    multiSapeAry.sort(function(a,b){return a.order-b.order;});//console.log("custShapType >>sorted  multiSapeAry: ");
    //console.log(multiSapeAry);
    var k=0;var isClose=false;var d="";while(k<multiSapeAry.length){if(multiSapeAry[k].type=="movto"){//start point
    var spX=parseInt(multiSapeAry[k].x)*cX;//slideFactor;
    var spY=parseInt(multiSapeAry[k].y)*cY;//slideFactor;
    // if (d == "") {
    //     d = "M" + spX + "," + spY;
    // } else {
    //     //shape without close : then close the shape and start new path
    //     result += "<path d='" + d + "' fill='" + (!imgFillFlg ? (grndFillFlg ? "url(#linGrd_" + shpId + ")" : fillColor) : "url(#imgPtrn_" + shpId + ")") +
    //         "' stroke='" + ((border === undefined) ? "" : border.color) + "' stroke-width='" + ((border === undefined) ? "" : border.width) + "' stroke-dasharray='" + ((border === undefined) ? "" : border.strokeDasharray) + "' ";
    //     result += "/>";
    //     if (headEndNodeAttrs !== undefined && (headEndNodeAttrs["type"] === "triangle" || headEndNodeAttrs["type"] === "arrow")) {
    //         result += "marker-start='url(#markerTriangle_" + shpId + ")' ";
    //     }
    //     if (tailEndNodeAttrs !== undefined && (tailEndNodeAttrs["type"] === "triangle" || tailEndNodeAttrs["type"] === "arrow")) {
    //         result += "marker-end='url(#markerTriangle_" + shpId + ")' ";
    //     }
    //     result += "/>";
    //     d = "M" + spX + "," + spY;
    //     isClose = true;
    // }
    d+=" M"+spX+","+spY;}else if(multiSapeAry[k].type=="lnto"){var Lx=parseInt(multiSapeAry[k].x)*cX;//slideFactor;
    var Ly=parseInt(multiSapeAry[k].y)*cY;//slideFactor;
    d+=" L"+Lx+","+Ly;}else if(multiSapeAry[k].type=="cubicBezTo"){var Cx1=parseInt(multiSapeAry[k].cubBzPt[0].x)*cX;//slideFactor;
    var Cy1=parseInt(multiSapeAry[k].cubBzPt[0].y)*cY;//slideFactor;
    var Cx2=parseInt(multiSapeAry[k].cubBzPt[1].x)*cX;//slideFactor;
    var Cy2=parseInt(multiSapeAry[k].cubBzPt[1].y)*cY;//slideFactor;
    var Cx3=parseInt(multiSapeAry[k].cubBzPt[2].x)*cX;//slideFactor;
    var Cy3=parseInt(multiSapeAry[k].cubBzPt[2].y)*cY;//slideFactor;
    d+=" C"+Cx1+","+Cy1+" "+Cx2+","+Cy2+" "+Cx3+","+Cy3;}else if(multiSapeAry[k].type=="arcTo"){var hR=parseInt(multiSapeAry[k].hR)*cX;//slideFactor;
    var wR=parseInt(multiSapeAry[k].wR)*cY;//slideFactor;
    var stAng=parseInt(multiSapeAry[k].stAng)/60000;var swAng=parseInt(multiSapeAry[k].swAng)/60000;//var shftX = parseInt(multiSapeAry[k].shftX) * slideFactor;
    //var shftY = parseInt(multiSapeAry[k].shftY) * slideFactor;
    var endAng=stAng+swAng;d+=shapeArc(wR,hR,wR,hR,stAng,endAng,false);}else if(multiSapeAry[k].type=="quadBezTo"){console.log("custShapType: quadBezTo - TODO");}else if(multiSapeAry[k].type=="close"){// result += "<path d='" + d + "' fill='" + (!imgFillFlg ? (grndFillFlg ? "url(#linGrd_" + shpId + ")" : fillColor) : "url(#imgPtrn_" + shpId + ")") +
    //     "' stroke='" + ((border === undefined) ? "" : border.color) + "' stroke-width='" + ((border === undefined) ? "" : border.width) + "' stroke-dasharray='" + ((border === undefined) ? "" : border.strokeDasharray) + "' ";
    // result += "/>";
    // d = "";
    // isClose = true;
    d+="z";}k++;}//if (!isClose) {
    //only one "moveTo" and no "close"
    result+="<path d='"+d+"' fill='"+(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")+"' stroke='"+(border===undefined?"":border.color)+"' stroke-width='"+(border===undefined?"":border.width)+"' stroke-dasharray='"+(border===undefined?"":border.strokeDasharray)+"' ";result+="/>";//console.log(result);
    }result+="</svg>";html+="<div class='block "+getVerticalAlign(node,slideLayoutSpNode,slideMasterSpNode)+//block content
    " "+getContentDir()+"' _id='"+id+"' _idx='"+idx+"' _type='"+type+"' _name='"+name+"' style='"+getPosition(slideXfrmNode,pNode,slideLayoutXfrmNode,slideMasterXfrmNode,sType)+getSize(slideXfrmNode,slideLayoutXfrmNode,slideMasterXfrmNode)+" z-index: "+order+";"+"transform: rotate("+(txtRotate!==undefined?txtRotate:0)+"deg);"+"'>";// TextBody
    var _textBody;if(node["p:txBody"]!==undefined&&(isUserDrawnBg===undefined||isUserDrawnBg===true)){if(type!="diagram"&&type!="textBox"){type="shape";}_textBody=genTextBody(node["p:txBody"],node,slideLayoutSpNode,slideMasterSpNode,type,idx,warpObj);//type=shape
    html+=_textBody;html+="</div>";}else {html="";}var _json={type:(!imgFillFlg?grndFillFlg?"url(#linGrd_"+shpId+")":fillColor:"url(#imgPtrn_"+shpId+")")==="none"?"text":"shape",left:left,top:top,width:width,height:height,order:order,rotate:txtRotate,fillColor:fillColor,content:html,svg:result};return {html:result+html,json:_json};// result = "";
    }else {html+="<div class='block "+getVerticalAlign(node,slideLayoutSpNode,slideMasterSpNode)+//block content
    " "+getContentDir()+"' _id='"+id+"' _idx='"+idx+"' _type='"+type+"' _name='"+name+"' style='"+getPosition(slideXfrmNode,pNode,slideLayoutXfrmNode,slideMasterXfrmNode,sType)+getSize(slideXfrmNode,slideLayoutXfrmNode,slideMasterXfrmNode)+getBorder(node,pNode,false,"shape",warpObj)+getShapeFill(node,pNode,false,warpObj,source)+" z-index: "+order+";"+"transform: rotate("+(txtRotate!==undefined?txtRotate:0)+"deg);"+"'>";// TextBody
    var _textBody2;if(node["p:txBody"]!==undefined&&(isUserDrawnBg===undefined||isUserDrawnBg===true)){_textBody2=genTextBody(node["p:txBody"],node,slideLayoutSpNode,slideMasterSpNode,type,idx,warpObj);html+=_textBody2;html+="</div>";}else {html="";}var _json2={type:"text",left:left,top:top,width:width,height:height,order:order,rotate:txtRotate,fillColor:fillColor,content:html};return {html:html,json:_json2};}}function processPicNode(node,warpObj,source,sType){//console.log("processPicNode node:", node, "source:", source, "sType:", sType, "warpObj;", warpObj);
    var rtrnData="";var mediaPicFlag=false;var order=node["attrs"]["order"];var rid=node["p:blipFill"]["a:blip"]["attrs"]["r:embed"];var resObj;if(source=="slideMasterBg"){resObj=warpObj["masterResObj"];}else if(source=="slideLayoutBg"){resObj=warpObj["layoutResObj"];}else {//imgName = warpObj["slideResObj"][rid]["target"];
    resObj=warpObj["slideResObj"];}var imgName=resObj[rid]["target"];//console.log("processPicNode imgName:", imgName);
    var imgFileExt=extractFileExtension(imgName).toLowerCase();var zip=warpObj["zip"];var imgArrayBuffer=zip.file(imgName).asArrayBuffer();var mimeType="";var xfrmNode=node["p:spPr"]["a:xfrm"];if(xfrmNode===undefined){var idx=getTextByPathList(node,["p:nvPicPr","p:nvPr","p:ph","attrs","idx"]);getTextByPathList(node,["p:nvPicPr","p:nvPr","p:ph","attrs","type"]);if(idx!==undefined){xfrmNode=getTextByPathList(warpObj["slideLayoutTables"],["idxTable",idx,"p:spPr","a:xfrm"]);}}///////////////////////////////////////Amir//////////////////////////////
    var rotate=0;var rotateNode=getTextByPathList(node,["p:spPr","a:xfrm","attrs","rot"]);if(rotateNode!==undefined){rotate=angleToDegrees(rotateNode);}//video
    var vdoNode=getTextByPathList(node,["p:nvPicPr","p:nvPr","a:videoFile"]);var vdoRid,vdoFile,vdoFileExt,vdoMimeType,uInt8Array,blob,vdoBlob,mediaSupportFlag=false,isVdeoLink=false;var mediaProcess=settings.mediaProcess;if(vdoNode!==undefined&mediaProcess){vdoRid=vdoNode["attrs"]["r:link"];vdoFile=resObj[vdoRid]["target"];var checkIfLink=IsVideoLink(vdoFile);if(checkIfLink){vdoFile=escapeHtml(vdoFile);//vdoBlob = vdoFile;
    isVdeoLink=true;mediaSupportFlag=true;mediaPicFlag=true;}else {vdoFileExt=extractFileExtension(vdoFile).toLowerCase();if(vdoFileExt=="mp4"||vdoFileExt=="webm"||vdoFileExt=="ogg"){uInt8Array=zip.file(vdoFile).asArrayBuffer();vdoMimeType=getMimeType(vdoFileExt);blob=new Blob([uInt8Array],{type:vdoMimeType});vdoBlob=URL.createObjectURL(blob);mediaSupportFlag=true;mediaPicFlag=true;}}}//Audio
    var audioNode=getTextByPathList(node,["p:nvPicPr","p:nvPr","a:audioFile"]);var audioRid,audioFile,audioFileExt,audioMimeType,uInt8ArrayAudio,blobAudio,audioBlob;var audioPlayerFlag=false;if(audioNode!==undefined&mediaProcess){audioRid=audioNode["attrs"]["r:link"];audioFile=resObj[audioRid]["target"];audioFileExt=extractFileExtension(audioFile).toLowerCase();if(audioFileExt=="mp3"||audioFileExt=="wav"||audioFileExt=="ogg"){uInt8ArrayAudio=zip.file(audioFile).asArrayBuffer();audioMimeType=getMimeType(audioFileExt);blobAudio=new Blob([uInt8ArrayAudio]);audioBlob=URL.createObjectURL(blobAudio);parseInt(xfrmNode["a:ext"]["attrs"]["cx"])*20;xfrmNode["a:ext"]["attrs"]["cy"];parseInt(xfrmNode["a:off"]["attrs"]["x"])/2.5;xfrmNode["a:off"]["attrs"]["y"];audioPlayerFlag=true;mediaSupportFlag=true;mediaPicFlag=true;}}var _ref=audioPlayerFlag// ? getPositionV1(audioObjc, node, undefined, undefined)
    ?getPositionV1(xfrmNode,node,undefined,undefined):getPositionV1(xfrmNode,node,undefined,undefined),left=_ref.left,top=_ref.top;var _ref2=audioPlayerFlag// ? getSizeV1(audioObjc, undefined, undefined)
    ?getSizeV1(xfrmNode,undefined,undefined):getSizeV1(xfrmNode,undefined,undefined),width=_ref2.width,height=_ref2.height;//console.log(node)
    //////////////////////////////////////////////////////////////////////////
    mimeType=getMimeType(imgFileExt);rtrnData="<div class='block content' style='"+(audioPlayerFlag// ? getPosition(audioObjc, node, undefined, undefined)
    ?getPosition(xfrmNode,node,undefined,undefined):getPosition(xfrmNode,node,undefined,undefined))+(audioPlayerFlag// ? getSize(audioObjc, undefined, undefined)
    ?getSize(xfrmNode,undefined,undefined):getSize(xfrmNode,undefined,undefined))+" z-index: "+order+";"+"transform: rotate("+rotate+"deg);'>";if(vdoNode===undefined&&audioNode===undefined||!mediaProcess||!mediaSupportFlag){rtrnData+="<img src='data:"+mimeType+";base64,"+base64ArrayBuffer(imgArrayBuffer)+"' style='width: 100%; height: 100%'/>";}else if((vdoNode!==undefined||audioNode!==undefined)&&mediaProcess&&mediaSupportFlag){if(vdoNode!==undefined&&!isVdeoLink){rtrnData+="<video  src='"+vdoBlob+"' controls style='width: 100%; height: 100%'>Your browser does not support the video tag.</video>";}else if(vdoNode!==undefined&&isVdeoLink){rtrnData+="<iframe   src='"+vdoFile+"' controls style='width: 100%; height: 100%'></iframe >";}if(audioNode!==undefined){rtrnData+='<audio id="audio_player" controls ><source src="'+audioBlob+'"></audio>';//'<button onclick="audio_player.play()">Play</button>'+
    //'<button onclick="audio_player.pause()">Pause</button>';
    }}if(!mediaSupportFlag&&mediaPicFlag){rtrnData+="<span style='color:red;font-size:40px;position: absolute;'>This media file Not supported by HTML5</span>";}if((vdoNode!==undefined||audioNode!==undefined)&&!mediaProcess&&mediaSupportFlag){console.log("Founded supported media file but media process disabled (mediaProcess=false)");}rtrnData+="</div>";if(vdoNode===undefined&&audioNode===undefined||!mediaProcess||!mediaSupportFlag){var json={type:"image",top:top,left:left,width:width,height:height,order:order,rotate:rotate,mimeType:mimeType,src:"data:".concat(mimeType,";base64,").concat(base64ArrayBuffer(imgArrayBuffer))};return {html:rtrnData,json:json};}else if((vdoNode!==undefined||audioNode!==undefined)&&mediaProcess&&mediaSupportFlag){if(vdoNode!==undefined&&!isVdeoLink){var _json3={type:"video",top:top,left:left,width:width,height:height,order:order,rotate:rotate,mimeType:vdoMimeType,src:vdoBlob};return {html:rtrnData,json:_json3};}else if(vdoNode!==undefined&&isVdeoLink){var _json4={type:"videoLink",top:top,left:left,width:width,height:height,order:order,rotate:rotate,mimeType:vdoMimeType,src:vdoFile};return {html:rtrnData,json:_json4};}if(audioNode!==undefined){var _json5={type:"audio",top:top,left:left,width:width,height:height,order:order,rotate:rotate,mimeType:audioMimeType,src:audioBlob};return {html:rtrnData,json:_json5};}}}/////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    function genTable(node,warpObj){var _getPositionV2=getPositionV1(xfrmNode,undefined,undefined),top=_getPositionV2.top,left=_getPositionV2.left;var _getSizeV2=getSizeV1(xfrmNode,undefined,undefined),width=_getSizeV2.width,height=_getSizeV2.height;var data=[];var order=node["attrs"]["order"];var tableNode=getTextByPathList(node,["a:graphic","a:graphicData","a:tbl"]);var xfrmNode=getTextByPathList(node,["p:xfrm"]);/////////////////////////////////////////Amir////////////////////////////////////////////////
    var getTblPr=getTextByPathList(node,["a:graphic","a:graphicData","a:tbl","a:tblPr"]);var getColsGrid=getTextByPathList(node,["a:graphic","a:graphicData","a:tbl","a:tblGrid","a:gridCol"]);var tblDir="";if(getTblPr!==undefined){var isRTL=getTblPr["attrs"]["rtl"];tblDir=isRTL==1?"dir=rtl":"dir=ltr";}var firstRowAttr=getTblPr["attrs"]["firstRow"];//associated element <a:firstRow> in the table styles
    var firstColAttr=getTblPr["attrs"]["firstCol"];//associated element <a:firstCol> in the table styles
    var lastRowAttr=getTblPr["attrs"]["lastRow"];//associated element <a:lastRow> in the table styles
    var lastColAttr=getTblPr["attrs"]["lastCol"];//associated element <a:lastCol> in the table styles
    var bandRowAttr=getTblPr["attrs"]["bandRow"];//associated element <a:band1H>, <a:band2H> in the table styles
    var bandColAttr=getTblPr["attrs"]["bandCol"];//associated element <a:band1V>, <a:band2V> in the table styles
    //console.log("getTblPr: ", getTblPr);
    var tblStylAttrObj={isFrstRowAttr:firstRowAttr!==undefined&&firstRowAttr=="1"?1:0,isFrstColAttr:firstColAttr!==undefined&&firstColAttr=="1"?1:0,isLstRowAttr:lastRowAttr!==undefined&&lastRowAttr=="1"?1:0,isLstColAttr:lastColAttr!==undefined&&lastColAttr=="1"?1:0,isBandRowAttr:bandRowAttr!==undefined&&bandRowAttr=="1"?1:0,isBandColAttr:bandColAttr!==undefined&&bandColAttr=="1"?1:0};var thisTblStyle;var tbleStyleId=getTblPr["a:tableStyleId"];if(tbleStyleId!==undefined){var tbleStylList=tableStyles["a:tblStyleLst"]["a:tblStyle"];if(tbleStylList!==undefined){if(tbleStylList.constructor===Array){for(var k=0;k<tbleStylList.length;k++){if(tbleStylList[k]["attrs"]["styleId"]==tbleStyleId){thisTblStyle=tbleStylList[k];}}}else {if(tbleStylList["attrs"]["styleId"]==tbleStyleId){thisTblStyle=tbleStylList;}}}}if(thisTblStyle!==undefined){thisTblStyle["tblStylAttrObj"]=tblStylAttrObj;warpObj["thisTbiStyle"]=thisTblStyle;}var tblStyl=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcStyle"]);var tblBorderStyl=getTextByPathList(tblStyl,["a:tcBdr"]);var tbl_borders="";if(tblBorderStyl!==undefined){tbl_borders=getTableBorders(tblBorderStyl,warpObj);}var tbl_bgcolor="";var tbl_bgFillschemeClr=getTextByPathList(thisTblStyle,["a:tblBg","a:fillRef"]);//console.log( "thisTblStyle:", thisTblStyle, "warpObj:", warpObj)
    if(tbl_bgFillschemeClr!==undefined){tbl_bgcolor=getSolidFill(tbl_bgFillschemeClr,undefined,undefined,warpObj);}if(tbl_bgFillschemeClr===undefined){tbl_bgFillschemeClr=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcStyle","a:fill","a:solidFill"]);tbl_bgcolor=getSolidFill(tbl_bgFillschemeClr,undefined,undefined,warpObj);}if(tbl_bgcolor!==""){tbl_bgcolor="background-color: #"+tbl_bgcolor+";";}////////////////////////////////////////////////////////////////////////////////////////////
    var tableHtml="<table "+tblDir+" style='border-collapse: collapse;"+getPosition(xfrmNode,node,undefined,undefined)+getSize(xfrmNode,undefined,undefined)+" z-index: "+order+";"+tbl_borders+";"+tbl_bgcolor+"'>";var trNodes=tableNode["a:tr"];if(trNodes.constructor!==Array){trNodes=[trNodes];}//if (trNodes.constructor === Array) {
    var rowSpanAry=[];for(var i=0;i<trNodes.length;i++){var tr=[];//////////////rows Style ////////////Amir
    var rowHeightParam=trNodes[i]["attrs"]["h"];var rowHeight=0;var rowsStyl="";if(rowHeightParam!==undefined){rowHeight=parseInt(rowHeightParam)*slideFactor;rowsStyl+="height:"+rowHeight+"px;";}var fillColor="";var row_borders="";var fontClrPr="";var fontWeight="";if(thisTblStyle!==undefined&&thisTblStyle["a:wholeTbl"]!==undefined){var bgFillschemeClr=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcStyle","a:fill","a:solidFill"]);if(bgFillschemeClr!==undefined){var local_fillColor=getSolidFill(bgFillschemeClr,undefined,undefined,warpObj);if(local_fillColor!==undefined){fillColor=local_fillColor;}}var rowTxtStyl=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcTxStyle"]);if(rowTxtStyl!==undefined){var local_fontColor=getSolidFill(rowTxtStyl,undefined,undefined,warpObj);if(local_fontColor!==undefined){fontClrPr=local_fontColor;}var local_fontWeight=getTextByPathList(rowTxtStyl,["attrs","b"])=="on"?"bold":"";if(local_fontWeight!=""){fontWeight=local_fontWeight;}}}if(i==0&&tblStylAttrObj["isFrstRowAttr"]==1&&thisTblStyle!==undefined){var bgFillschemeClr=getTextByPathList(thisTblStyle,["a:firstRow","a:tcStyle","a:fill","a:solidFill"]);if(bgFillschemeClr!==undefined){var local_fillColor=getSolidFill(bgFillschemeClr,undefined,undefined,warpObj);if(local_fillColor!==undefined){fillColor=local_fillColor;}}var borderStyl=getTextByPathList(thisTblStyle,["a:firstRow","a:tcStyle","a:tcBdr"]);if(borderStyl!==undefined){var local_row_borders=getTableBorders(borderStyl,warpObj);if(local_row_borders!=""){row_borders=local_row_borders;}}var rowTxtStyl=getTextByPathList(thisTblStyle,["a:firstRow","a:tcTxStyle"]);if(rowTxtStyl!==undefined){var local_fontClrPr=getSolidFill(rowTxtStyl,undefined,undefined,warpObj);if(local_fontClrPr!==undefined){fontClrPr=local_fontClrPr;}var local_fontWeight=getTextByPathList(rowTxtStyl,["attrs","b"])=="on"?"bold":"";if(local_fontWeight!==""){fontWeight=local_fontWeight;}}}else if(i>0&&tblStylAttrObj["isBandRowAttr"]==1&&thisTblStyle!==undefined){fillColor="";row_borders=undefined;if(i%2==0&&thisTblStyle["a:band2H"]!==undefined){// console.log("i: ", i, 'thisTblStyle["a:band2H"]:', thisTblStyle["a:band2H"])
    //check if there is a row bg
    var bgFillschemeClr=getTextByPathList(thisTblStyle,["a:band2H","a:tcStyle","a:fill","a:solidFill"]);if(bgFillschemeClr!==undefined){var local_fillColor=getSolidFill(bgFillschemeClr,undefined,undefined,warpObj);if(local_fillColor!==""){fillColor=local_fillColor;}}var borderStyl=getTextByPathList(thisTblStyle,["a:band2H","a:tcStyle","a:tcBdr"]);if(borderStyl!==undefined){var local_row_borders=getTableBorders(borderStyl,warpObj);if(local_row_borders!=""){row_borders=local_row_borders;}}var rowTxtStyl=getTextByPathList(thisTblStyle,["a:band2H","a:tcTxStyle"]);if(rowTxtStyl!==undefined){var local_fontClrPr=getSolidFill(rowTxtStyl,undefined,undefined,warpObj);if(local_fontClrPr!==undefined){fontClrPr=local_fontClrPr;}}var local_fontWeight=getTextByPathList(rowTxtStyl,["attrs","b"])=="on"?"bold":"";if(local_fontWeight!==""){fontWeight=local_fontWeight;}}if(i%2!=0&&thisTblStyle["a:band1H"]!==undefined){var bgFillschemeClr=getTextByPathList(thisTblStyle,["a:band1H","a:tcStyle","a:fill","a:solidFill"]);if(bgFillschemeClr!==undefined){var local_fillColor=getSolidFill(bgFillschemeClr,undefined,undefined,warpObj);if(local_fillColor!==undefined){fillColor=local_fillColor;}}var borderStyl=getTextByPathList(thisTblStyle,["a:band1H","a:tcStyle","a:tcBdr"]);if(borderStyl!==undefined){var local_row_borders=getTableBorders(borderStyl,warpObj);if(local_row_borders!=""){row_borders=local_row_borders;}}var rowTxtStyl=getTextByPathList(thisTblStyle,["a:band1H","a:tcTxStyle"]);if(rowTxtStyl!==undefined){var local_fontClrPr=getSolidFill(rowTxtStyl,undefined,undefined,warpObj);if(local_fontClrPr!==undefined){fontClrPr=local_fontClrPr;}var local_fontWeight=getTextByPathList(rowTxtStyl,["attrs","b"])=="on"?"bold":"";if(local_fontWeight!=""){fontWeight=local_fontWeight;}}}}//last row
    if(i==trNodes.length-1&&tblStylAttrObj["isLstRowAttr"]==1&&thisTblStyle!==undefined){var bgFillschemeClr=getTextByPathList(thisTblStyle,["a:lastRow","a:tcStyle","a:fill","a:solidFill"]);if(bgFillschemeClr!==undefined){var local_fillColor=getSolidFill(bgFillschemeClr,undefined,undefined,warpObj);if(local_fillColor!==undefined){fillColor=local_fillColor;}// var local_colorOpacity = getColorOpacity(bgFillschemeClr);
    // if(local_colorOpacity !== undefined){
    //     colorOpacity = local_colorOpacity;
    // }
    }var borderStyl=getTextByPathList(thisTblStyle,["a:lastRow","a:tcStyle","a:tcBdr"]);if(borderStyl!==undefined){var local_row_borders=getTableBorders(borderStyl,warpObj);if(local_row_borders!=""){row_borders=local_row_borders;}}var rowTxtStyl=getTextByPathList(thisTblStyle,["a:lastRow","a:tcTxStyle"]);if(rowTxtStyl!==undefined){var local_fontClrPr=getSolidFill(rowTxtStyl,undefined,undefined,warpObj);if(local_fontClrPr!==undefined){fontClrPr=local_fontClrPr;}var local_fontWeight=getTextByPathList(rowTxtStyl,["attrs","b"])=="on"?"bold":"";if(local_fontWeight!==""){fontWeight=local_fontWeight;}}}rowsStyl+=row_borders!==undefined?row_borders:"";rowsStyl+=fontClrPr!==undefined?" color: #"+fontClrPr+";":"";rowsStyl+=fontWeight!=""?" font-weight:"+fontWeight+";":"";if(fillColor!==undefined&&fillColor!=""){//rowsStyl += "background-color: rgba(" + hexToRgbNew(fillColor) + "," + colorOpacity + ");";
    rowsStyl+="background-color: #"+fillColor+";";}tableHtml+="<tr style='"+rowsStyl+"'>";////////////////////////////////////////////////
    var tcNodes=trNodes[i]["a:tc"];if(tcNodes!==undefined){if(tcNodes.constructor===Array){//multi columns
    var j=0;if(rowSpanAry.length==0){rowSpanAry=Array.apply(null,Array(tcNodes.length)).map(function(){return 0;});}var totalColSpan=0;while(j<tcNodes.length){if(rowSpanAry[j]==0&&totalColSpan==0){var a_sorce;//j=0 : first col
    if(j==0&&tblStylAttrObj["isFrstColAttr"]==1){a_sorce="a:firstCol";if(tblStylAttrObj["isLstRowAttr"]==1&&i==trNodes.length-1&&getTextByPathList(thisTblStyle,["a:seCell"])!==undefined){a_sorce="a:seCell";}else if(tblStylAttrObj["isFrstRowAttr"]==1&&i==0&&getTextByPathList(thisTblStyle,["a:neCell"])!==undefined){a_sorce="a:neCell";}}else if(j>0&&tblStylAttrObj["isBandColAttr"]==1&&!(tblStylAttrObj["isFrstColAttr"]==1&&i==0)&&!(tblStylAttrObj["isLstRowAttr"]==1&&i==trNodes.length-1)&&j!=tcNodes.length-1){if(j%2!=0){var aBandNode=getTextByPathList(thisTblStyle,["a:band2V"]);if(aBandNode===undefined){aBandNode=getTextByPathList(thisTblStyle,["a:band1V"]);if(aBandNode!==undefined){a_sorce="a:band2V";}}else {a_sorce="a:band2V";}}}if(j==tcNodes.length-1&&tblStylAttrObj["isLstColAttr"]==1){a_sorce="a:lastCol";if(tblStylAttrObj["isLstRowAttr"]==1&&i==trNodes.length-1&&getTextByPathList(thisTblStyle,["a:swCell"])!==undefined){a_sorce="a:swCell";}else if(tblStylAttrObj["isFrstRowAttr"]==1&&i==0&&getTextByPathList(thisTblStyle,["a:nwCell"])!==undefined){a_sorce="a:nwCell";}}var cellParmAry=getTableCellParams(tcNodes[j],getColsGrid,i,j,thisTblStyle,a_sorce,warpObj);var text=cellParmAry[0];var colStyl=cellParmAry[1];var cssName=cellParmAry[2];var rowSpan=cellParmAry[3];var colSpan=cellParmAry[4];tr.push({text:text,colStyl:colStyl,cssName:cssName,rowSpan:rowSpan,colSpan:colSpan});if(rowSpan!==undefined){rowSpanAry[j]=parseInt(rowSpan)-1;tableHtml+="<td class='"+cssName+"' data-row='"+i+","+j+"' rowspan ='"+parseInt(rowSpan)+"' style='"+colStyl+"'>"+text+"</td>";}else if(colSpan!==undefined){tableHtml+="<td class='"+cssName+"' data-row='"+i+","+j+"' colspan = '"+parseInt(colSpan)+"' style='"+colStyl+"'>"+text+"</td>";totalColSpan=parseInt(colSpan)-1;}else {tableHtml+="<td class='"+cssName+"' data-row='"+i+","+j+"' style = '"+colStyl+"'>"+text+"</td>";}}else {if(rowSpanAry[j]!=0){rowSpanAry[j]-=1;}if(totalColSpan!=0){totalColSpan--;}}j++;}}else {//single column
    var a_sorce;if(tblStylAttrObj["isFrstColAttr"]==1&&!(tblStylAttrObj["isLstRowAttr"]==1)){a_sorce="a:firstCol";}else if(tblStylAttrObj["isBandColAttr"]==1&&!(tblStylAttrObj["isLstRowAttr"]==1)){var aBandNode=getTextByPathList(thisTblStyle,["a:band2V"]);if(aBandNode===undefined){aBandNode=getTextByPathList(thisTblStyle,["a:band1V"]);if(aBandNode!==undefined){a_sorce="a:band2V";}}else {a_sorce="a:band2V";}}if(tblStylAttrObj["isLstColAttr"]==1&&!(tblStylAttrObj["isLstRowAttr"]==1)){a_sorce="a:lastCol";}var cellParmAry=getTableCellParams(tcNodes,getColsGrid,i,undefined,thisTblStyle,a_sorce,warpObj);var text=cellParmAry[0];var colStyl=cellParmAry[1];var cssName=cellParmAry[2];var rowSpan=cellParmAry[3];tr.push({text:text,colStyl:colStyl,cssName:cssName,rowSpan:rowSpan,colSpan:colSpan});if(rowSpan!==undefined){tableHtml+="<td  class='"+cssName+"' rowspan='"+parseInt(rowSpan)+"' style = '"+colStyl+"'>"+text+"</td>";}else {tableHtml+="<td class='"+cssName+"' style='"+colStyl+"'>"+text+"</td>";}}}tableHtml+="</tr>";data.push(tr);}var json={type:"table",top:top,left:left,width:width,height:height,order:order,data:data};return {html:tableHtml,json:json};}function genChart(node,warpObj){var order=node["attrs"]["order"];var xfrmNode=getTextByPathList(node,["p:xfrm"]);var result="<div id='chart"+chartID+"' class='block content' style='"+getPosition(xfrmNode,node,undefined,undefined)+getSize(xfrmNode,undefined,undefined)+" z-index: "+order+";'></div>";var _getPositionV3=getPositionV1(xfrmNode,node,undefined,undefined),left=_getPositionV3.left,top=_getPositionV3.top;var _getSizeV3=getSizeV1(xfrmNode,undefined,undefined),width=_getSizeV3.width,height=_getSizeV3.height;var rid=node["a:graphic"]["a:graphicData"]["c:chart"]["attrs"]["r:id"];var refName=warpObj["slideResObj"][rid]["target"];var content=readXmlFile(warpObj["zip"],refName);var plotArea=getTextByPathList(content,["c:chartSpace","c:chart","c:plotArea"]);var chartData=null;for(var key in plotArea){switch(key){case"c:lineChart":chartData={type:"createChart",data:{chartID:"chart"+chartID,chartType:"lineChart",chartData:extractChartData(plotArea[key]["c:ser"])}};break;case"c:barChart":chartData={type:"createChart",data:{chartID:"chart"+chartID,chartType:"barChart",chartData:extractChartData(plotArea[key]["c:ser"])}};break;case"c:pieChart":chartData={type:"createChart",data:{chartID:"chart"+chartID,chartType:"pieChart",chartData:extractChartData(plotArea[key]["c:ser"])}};break;case"c:pie3DChart":chartData={type:"createChart",data:{chartID:"chart"+chartID,chartType:"pie3DChart",chartData:extractChartData(plotArea[key]["c:ser"])}};break;case"c:areaChart":chartData={type:"createChart",data:{chartID:"chart"+chartID,chartType:"areaChart",chartData:extractChartData(plotArea[key]["c:ser"])}};break;case"c:scatterChart":chartData={type:"createChart",data:{chartID:"chart"+chartID,chartType:"scatterChart",chartData:extractChartData(plotArea[key]["c:ser"])}};break;}}if(chartData!==null){MsgQueue.push(chartData);}chartID++;var json={};if(chartData){json={type:"chart",top:top,left:left,width:width,height:height,order:order,data:chartData};}return {html:result,json:json};}/////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////
    function genDiagram(node,warpObj,source,sType){//console.log(warpObj)
    //readXmlFile(zip, sldFileName)
    /**files define the diagram:
       * 1-colors#.xml,
       * 2-data#.xml,
       * 3-layout#.xml,
       * 4-quickStyle#.xml.
       * 5-drawing#.xml, which Microsoft added as an extension for persisting diagram layout information.
       */ ///get colors#.xml, data#.xml , layout#.xml , quickStyle#.xml
    var order=node["attrs"]["order"];var zip=warpObj["zip"];var xfrmNode=getTextByPathList(node,["p:xfrm"]);var dgmRelIds=getTextByPathList(node,["a:graphic","a:graphicData","dgm:relIds","attrs"]);//console.log(dgmRelIds)
    var dgmClrFileId=dgmRelIds["r:cs"];var dgmDataFileId=dgmRelIds["r:dm"];var dgmLayoutFileId=dgmRelIds["r:lo"];var dgmQuickStyleFileId=dgmRelIds["r:qs"];var dgmClrFileName=warpObj["slideResObj"][dgmClrFileId].target,dgmDataFileName=warpObj["slideResObj"][dgmDataFileId].target,dgmLayoutFileName=warpObj["slideResObj"][dgmLayoutFileId].target;dgmQuickStyleFileName=warpObj["slideResObj"][dgmQuickStyleFileId].target;//console.log("dgmClrFileName: " , dgmClrFileName,", dgmDataFileName: ",dgmDataFileName,", dgmLayoutFileName: ",dgmLayoutFileName,", dgmQuickStyleFileName: ",dgmQuickStyleFileName);
    readXmlFile(zip,dgmClrFileName);readXmlFile(zip,dgmDataFileName);readXmlFile(zip,dgmLayoutFileName);readXmlFile(zip,dgmQuickStyleFileName);//console.log(dgmClr,dgmData,dgmLayout,dgmQuickStyle)
    ///get drawing#.xml
    // var dgmDrwFileName = "";
    // var dataModelExt = getTextByPathList(dgmData, ["dgm:dataModel", "dgm:extLst", "a:ext", "dsp:dataModelExt", "attrs"]);
    // if (dataModelExt !== undefined) {
    //     var dgmDrwFileId = dataModelExt["relId"];
    //     dgmDrwFileName = warpObj["slideResObj"][dgmDrwFileId]["target"];
    // }
    // var dgmDrwFile = "";
    // if (dgmDrwFileName != "") {
    //     dgmDrwFile = readXmlFile(zip, dgmDrwFileName);
    // }
    // var dgmDrwSpArray = getTextByPathList(dgmDrwFile, ["dsp:drawing", "dsp:spTree", "dsp:sp"]);
    //var dgmDrwSpArray = getTextByPathList(warpObj["digramFileContent"], ["dsp:drawing", "dsp:spTree", "dsp:sp"]);
    var dgmDrwSpArray=getTextByPathList(warpObj["digramFileContent"],["p:drawing","p:spTree","p:sp"]);var rslt="";if(dgmDrwSpArray!==undefined){var dgmDrwSpArrayLen=dgmDrwSpArray.length;for(var i=0;i<dgmDrwSpArrayLen;i++){var dspSp=dgmDrwSpArray[i];// var dspSpObjToStr = JSON.stringify(dspSp);
    // var pSpStr = dspSpObjToStr.replace(/dsp:/g, "p:");
    // var pSpStrToObj = JSON.parse(pSpStr);
    //console.log("pSpStrToObj[" + i + "]: ", pSpStrToObj);
    //rslt += processSpNode(pSpStrToObj, node, warpObj, "diagramBg", sType)
    rslt+=processSpNode(dspSp,node,warpObj,"diagramBg",sType);}// dgmDrwFile: "dsp:"-> "p:"
    }var _getPositionV4=getPositionV1(xfrmNode,node,undefined,undefined,sType),left=_getPositionV4.left,top=_getPositionV4.top;var _getSizeV4=getSizeV1(xfrmNode,undefined,undefined),width=_getSizeV4.width,height=_getSizeV4.height;var html="<div class='block diagram-content' style='"+getPosition(xfrmNode,node,undefined,undefined,sType)+getSize(xfrmNode,undefined,undefined)+"'>"+rslt+"</div>";var json={type:"diagram",left:left,top:top,width:width,height:height,order:order};return {html:html,json:json};}function readXmlFile(zip,filename,isSlideContent){try{var fileContent=zip.file(filename).asText();if(isSlideContent&&app_verssion<=12){//< office2007
    //remove "<![CDATA[ ... ]]>" tag
    fileContent=fileContent.replace(/<!\[CDATA\[(.*?)\]\]>/g,"$1");}var xmlData=tXml(fileContent,{simplify:1});if(xmlData["?xml"]!==undefined){return xmlData["?xml"];}else {return xmlData;}}catch(e){//console.log("error readXmlFile: the file '", filename, "' not exit")
    return null;}}function getContentTypes(zip){var ContentTypesJson=readXmlFile(zip,"[Content_Types].xml");var subObj=ContentTypesJson["Types"]["Override"];var slidesLocArray=[];var slideLayoutsLocArray=[];for(var i=0;i<subObj.length;i++){switch(subObj[i]["attrs"]["ContentType"]){case"application/vnd.openxmlformats-officedocument.presentationml.slide+xml":slidesLocArray.push(subObj[i]["attrs"]["PartName"].substr(1));break;case"application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml":slideLayoutsLocArray.push(subObj[i]["attrs"]["PartName"].substr(1));break;}}return {slides:slidesLocArray,slideLayouts:slideLayoutsLocArray};}function getSlideSizeAndSetDefaultTextStyle(zip){//get app version
    var app=readXmlFile(zip,"docProps/app.xml");var app_verssion_str=app["Properties"]["AppVersion"];app_verssion=parseInt(app_verssion_str);// console.log("create by Office PowerPoint app verssion: ", app_verssion_str);
    //get slide dimensions
    var rtenObj={};var content=readXmlFile(zip,"ppt/presentation.xml");var sldSzAttrs=content["p:presentation"]["p:sldSz"]["attrs"];var sldSzWidth=parseInt(sldSzAttrs["cx"]);var sldSzHeight=parseInt(sldSzAttrs["cy"]);sldSzAttrs["type"];// console.log("Presentation size type: ", sldSzType);
    //1 inches  = 96px = 2.54cm
    // 1 EMU = 1 / 914400 inch
    // Pixel = EMUs * Resolution / 914400;  (Resolution = 96)
    //var standardHeight = 6858000;
    //console.log("slideFactor: ", slideFactor, "standardHeight:", standardHeight, (standardHeight - sldSzHeight) / standardHeight)
    //slideFactor = (96 * (1 + ((standardHeight - sldSzHeight) / standardHeight))) / 914400 ;
    //slideFactor = slideFactor + sldSzHeight*((standardHeight - sldSzHeight) / standardHeight) ;
    //var ration = sldSzWidth / sldSzHeight;
    //Scale
    // var viewProps = readXmlFile(zip, "ppt/viewProps.xml");
    // var scaleLoc = getTextByPathList(viewProps, ["p:viewPr", "p:slideViewPr", "p:cSldViewPr", "p:cViewPr","p:scale"]);
    // var scaleXnodes, scaleX = 1, scaleYnode, scaleY = 1;
    // if (scaleLoc !== undefined){
    //     scaleXnodes = scaleLoc["a:sx"]["attrs"];
    //     var scaleXnodesN = scaleXnodes["n"];
    //     var scaleXnodesD = scaleXnodes["d"];
    //     if (scaleXnodesN !== undefined && scaleXnodesD !== undefined && scaleXnodesN != 0){
    //         scaleX = parseInt(scaleXnodesD)/parseInt(scaleXnodesN);
    //     }
    //     scaleYnode = scaleLoc["a:sy"]["attrs"];
    //     var scaleYnodeN = scaleYnode["n"];
    //     var scaleYnodeD = scaleYnode["d"];
    //     if (scaleYnodeN !== undefined && scaleYnodeD !== undefined && scaleYnodeN != 0) {
    //         scaleY = parseInt(scaleYnodeD) / parseInt(scaleYnodeN) ;
    //     }
    // }
    //console.log("scaleX: ", scaleX, "scaleY:", scaleY)
    //slideFactor = slideFactor * scaleX;
    defaultTextStyle=content["p:presentation"]["p:defaultTextStyle"];slideWidth=sldSzWidth*slideFactor+settings.incSlide.width|0;// * scaleX;//parseInt(sldSzAttrs["cx"]) * 96 / 914400;
    slideHeight=sldSzHeight*slideFactor+settings.incSlide.height|0;// * scaleY;//parseInt(sldSzAttrs["cy"]) * 96 / 914400;
    rtenObj={width:slideWidth,height:slideHeight};return rtenObj;}function indexNodes(content){var keys=Object.keys(content);var spTreeNode=content[keys[0]]["p:cSld"]["p:spTree"];var idTable={};var idxTable={};var typeTable={};for(var key in spTreeNode){if(key=="p:nvGrpSpPr"||key=="p:grpSpPr"){continue;}var targetNode=spTreeNode[key];if(targetNode.constructor===Array){for(var i=0;i<targetNode.length;i++){var nvSpPrNode=targetNode[i]["p:nvSpPr"];var id=getTextByPathList(nvSpPrNode,["p:cNvPr","attrs","id"]);var idx=getTextByPathList(nvSpPrNode,["p:nvPr","p:ph","attrs","idx"]);var type=getTextByPathList(nvSpPrNode,["p:nvPr","p:ph","attrs","type"]);if(id!==undefined){idTable[id]=targetNode[i];}if(idx!==undefined){idxTable[idx]=targetNode[i];}if(type!==undefined){typeTable[type]=targetNode[i];}}}else {var nvSpPrNode=targetNode["p:nvSpPr"];var id=getTextByPathList(nvSpPrNode,["p:cNvPr","attrs","id"]);var idx=getTextByPathList(nvSpPrNode,["p:nvPr","p:ph","attrs","idx"]);var type=getTextByPathList(nvSpPrNode,["p:nvPr","p:ph","attrs","type"]);if(id!==undefined){idTable[id]=targetNode;}if(idx!==undefined){idxTable[idx]=targetNode;}if(type!==undefined){typeTable[type]=targetNode;}}}return {idTable:idTable,idxTable:idxTable,typeTable:typeTable};}function processSpNode(node,pNode,warpObj,source,sType){/*
       *  958    <xsd:complexType name="CT_GvmlShape">
       *  959   <xsd:sequence>
       *  960     <xsd:element name="nvSpPr" type="CT_GvmlShapeNonVisual"     minOccurs="1" maxOccurs="1"/>
       *  961     <xsd:element name="spPr"   type="CT_ShapeProperties"        minOccurs="1" maxOccurs="1"/>
       *  962     <xsd:element name="txSp"   type="CT_GvmlTextShape"          minOccurs="0" maxOccurs="1"/>
       *  963     <xsd:element name="style"  type="CT_ShapeStyle"             minOccurs="0" maxOccurs="1"/>
       *  964     <xsd:element name="extLst" type="CT_OfficeArtExtensionList" minOccurs="0" maxOccurs="1"/>
       *  965   </xsd:sequence>
       *  966 </xsd:complexType>
       */var id=getTextByPathList(node,["p:nvSpPr","p:cNvPr","attrs","id"]);var name=getTextByPathList(node,["p:nvSpPr","p:cNvPr","attrs","name"]);var idx=getTextByPathList(node,["p:nvSpPr","p:nvPr","p:ph","attrs","idx"])===undefined?undefined:getTextByPathList(node,["p:nvSpPr","p:nvPr","p:ph","attrs","idx"]);var type=getTextByPathList(node,["p:nvSpPr","p:nvPr","p:ph","attrs","type"])===undefined?undefined:getTextByPathList(node,["p:nvSpPr","p:nvPr","p:ph","attrs","type"]);var order=getTextByPathList(node,["attrs","order"]);var isUserDrawnBg;if(source=="slideLayoutBg"||source=="slideMasterBg"){var userDrawn=getTextByPathList(node,["p:nvSpPr","p:nvPr","attrs","userDrawn"]);if(userDrawn=="1"){isUserDrawnBg=true;}else {isUserDrawnBg=false;}}var slideLayoutSpNode=undefined;var slideMasterSpNode=undefined;if(idx!==undefined){slideLayoutSpNode=warpObj["slideLayoutTables"]["idxTable"][idx];if(type!==undefined){slideMasterSpNode=warpObj["slideMasterTables"]["typeTable"][type];}else {slideMasterSpNode=warpObj["slideMasterTables"]["idxTable"][idx];}}else {if(type!==undefined){slideLayoutSpNode=warpObj["slideLayoutTables"]["typeTable"][type];slideMasterSpNode=warpObj["slideMasterTables"]["typeTable"][type];}}if(type===undefined){txBoxVal=getTextByPathList(node,["p:nvSpPr","p:cNvSpPr","attrs","txBox"]);if(txBoxVal=="1"){type="textBox";}}if(type===undefined){type=getTextByPathList(slideLayoutSpNode,["p:nvSpPr","p:nvPr","p:ph","attrs","type"]);if(type===undefined){//type = getTextByPathList(slideMasterSpNode, ["p:nvSpPr", "p:nvPr", "p:ph", "attrs", "type"]);
    if(source=="diagramBg"){type="diagram";}else {type="obj";//default type
    }}}//console.log("processSpNode type:", type, "idx:", idx);
    return genShape(node,pNode,slideLayoutSpNode,slideMasterSpNode,id,name,idx,type,order,warpObj,isUserDrawnBg,sType,source);}function processCxnSpNode(node,pNode,warpObj,source,sType){var id=node["p:nvCxnSpPr"]["p:cNvPr"]["attrs"]["id"];var name=node["p:nvCxnSpPr"]["p:cNvPr"]["attrs"]["name"];var idx=node["p:nvCxnSpPr"]["p:nvPr"]["p:ph"]===undefined?undefined:node["p:nvSpPr"]["p:nvPr"]["p:ph"]["attrs"]["idx"];var type=node["p:nvCxnSpPr"]["p:nvPr"]["p:ph"]===undefined?undefined:node["p:nvSpPr"]["p:nvPr"]["p:ph"]["attrs"]["type"];//<p:cNvCxnSpPr>(<p:cNvCxnSpPr>, <a:endCxn>)
    var order=node["attrs"]["order"];return genShape(node,pNode,undefined,undefined,id,name,idx,type,order,warpObj,undefined,sType,source);}/*
    function shapePolygon(sidesNum) {
        var sides  = sidesNum;
        var radius = 100;
        var angle  = 2 * Math.PI / sides;
        var points = []; 
        
        for (var i = 0; i < sides; i++) {
            points.push(radius + radius * Math.sin(i * angle));
            points.push(radius - radius * Math.cos(i * angle));
        }
        
        return points;
    }
    */function processGraphicFrameNode(node,warpObj,source,sType){var result="";var graphicTypeUri=getTextByPathList(node,["a:graphic","a:graphicData","attrs","uri"]);switch(graphicTypeUri){case"http://schemas.openxmlformats.org/drawingml/2006/table":result=genTable(node,warpObj);break;case"http://schemas.openxmlformats.org/drawingml/2006/chart":result=genChart(node,warpObj);break;case"http://schemas.openxmlformats.org/drawingml/2006/diagram":result=genDiagram(node,warpObj,source,sType);break;case"http://schemas.openxmlformats.org/presentationml/2006/ole"://result = genDiagram(node, warpObj, source, sType);
    var oleObjNode=getTextByPathList(node,["a:graphic","a:graphicData","mc:AlternateContent","mc:Fallback","p:oleObj"]);if(oleObjNode===undefined){oleObjNode=getTextByPathList(node,["a:graphic","a:graphicData","p:oleObj"]);}//console.log("node:", node, "oleObjNode:", oleObjNode)
    if(oleObjNode!==undefined){result=processGroupSpNode(oleObjNode,warpObj,source);}break;}return result;}function shapePie(H,w,adj1,adj2,isClose){var pieVal=parseInt(adj2);var piAngle=parseInt(adj1);var size=parseInt(H),radius=size/2,value=pieVal-piAngle;if(value<0){value=360+value;}//console.log("value: ",value)
    value=Math.min(Math.max(value,0),360);//calculate x,y coordinates of the point on the circle to draw the arc to.
    var x=Math.cos(2*Math.PI/(360/value));var y=Math.sin(2*Math.PI/(360/value));//d is a string that describes the path of the slice.
    var longArc,d,rot;if(isClose){longArc=value<=180?0:1;d="M"+radius+","+radius+" L"+radius+","+0+" A"+radius+","+radius+" 0 "+longArc+",1 "+(radius+y*radius)+","+(radius-x*radius)+" z";rot="rotate("+(piAngle-270)+", "+radius+", "+radius+")";}else {longArc=value<=180?0:1;var radius1=radius;var radius2=w/2;d="M"+radius1+","+0+" A"+radius2+","+radius1+" 0 "+longArc+",1 "+(radius2+y*radius2)+","+(radius1-x*radius1);rot="rotate("+(piAngle+90)+", "+radius+", "+radius+")";}return [d,rot];}function shapeGear(w,h,points){var innerRadius=h;//gear.innerRadius;
    var outerRadius=1.5*innerRadius;var cx=outerRadius;//Math.max(innerRadius, outerRadius),                   // center x
    cy=outerRadius;//Math.max(innerRadius, outerRadius),                    // center y
    notches=points,//gear.points,                      // num. of notches
    radiusO=outerRadius,// outer radius
    radiusI=innerRadius,// inner radius
    taperO=50,// outer taper %
    taperI=35,// inner taper %
    // pre-calculate values for loop
    pi2=2*Math.PI,// cache 2xPI (360deg)
    angle=pi2/(notches*2),// angle between notches
    taperAI=angle*taperI*0.005,// inner taper offset (100% = half notch)
    taperAO=angle*taperO*0.005,// outer taper offset
    a=angle,// iterator (angle)
    toggle=false;// move to starting point
    var d=" M"+(cx+radiusO*Math.cos(taperAO))+" "+(cy+radiusO*Math.sin(taperAO));// loop
    for(;a<=pi2+angle;a+=angle){// draw inner to outer line
    if(toggle){d+=" L"+(cx+radiusI*Math.cos(a-taperAI))+","+(cy+radiusI*Math.sin(a-taperAI));d+=" L"+(cx+radiusO*Math.cos(a+taperAO))+","+(cy+radiusO*Math.sin(a+taperAO));}else {// draw outer to inner line
    d+=" L"+(cx+radiusO*Math.cos(a-taperAO))+","+(cy+radiusO*Math.sin(a-taperAO));// outer line
    d+=" L"+(cx+radiusI*Math.cos(a+taperAI))+","+(cy+radiusI*Math.sin(a+taperAI));// inner line
    }// switch level
    toggle=!toggle;}// close the final line
    d+=" ";return d;}function shapeArc(cX,cY,rX,rY,stAng,endAng,isClose){var dData;var angle=stAng;if(endAng>=stAng){while(angle<=endAng){var radians=angle*(Math.PI/180);// convert degree to radians
    var x=cX+Math.cos(radians)*rX;var y=cY+Math.sin(radians)*rY;if(angle==stAng){dData=" M"+x+" "+y;}dData+=" L"+x+" "+y;angle++;}}else {while(angle>endAng){var radians=angle*(Math.PI/180);// convert degree to radians
    var x=cX+Math.cos(radians)*rX;var y=cY+Math.sin(radians)*rY;if(angle==stAng){dData=" M "+x+" "+y;}dData+=" L "+x+" "+y;angle--;}}dData+=isClose?" z":"";return dData;}function shapeSnipRoundRect(w,h,adj1,adj2,shapeType,adjType){/* 
        shapeType: snip,round
        adjType: cornr1,cornr2,cornrAll,diag
        */var adjA,adjB,adjC,adjD;if(adjType=="cornr1"){adjA=0;adjB=0;adjC=0;adjD=adj1;}else if(adjType=="cornr2"){adjA=adj1;adjB=adj2;adjC=adj2;adjD=adj1;}else if(adjType=="cornrAll"){adjA=adj1;adjB=adj1;adjC=adj1;adjD=adj1;}else if(adjType=="diag"){adjA=adj1;adjB=adj2;adjC=adj1;adjD=adj2;}//d is a string that describes the path of the slice.
    var d;if(shapeType=="round"){d="M0"+","+(h/2+(1-adjB)*(h/2))+" Q"+0+","+h+" "+adjB*(w/2)+","+h+" L"+(w/2+(1-adjC)*(w/2))+","+h+" Q"+w+","+h+" "+w+","+(h/2+h/2*(1-adjC))+"L"+w+","+h/2*adjD+" Q"+w+","+0+" "+(w/2+w/2*(1-adjD))+",0 L"+w/2*adjA+",0"+" Q"+0+","+0+" 0,"+h/2*adjA+" z";}else if(shapeType=="snip"){d="M0"+","+adjA*(h/2)+" L0"+","+(h/2+h/2*(1-adjB))+"L"+adjB*(w/2)+","+h+" L"+(w/2+w/2*(1-adjC))+","+h+"L"+w+","+(h/2+h/2*(1-adjC))+" L"+w+","+adjD*(h/2)+"L"+(w/2+w/2*(1-adjD))+",0 L"+w/2*adjA+",0 z";}return d;}function getStyleTable(name){for(var key in styleTable){if(styleTable[key].name===name){return styleTable[key].text;}}}var is_first_br=false;function genTextBody(textBodyNode,spNode,slideLayoutSpNode,slideMasterSpNode,type,idx,warpObj,tbl_col_width){var text="";warpObj["slideMasterTextStyles"];if(textBodyNode===undefined){return text;}//rtl : <p:txBody>
    //          <a:bodyPr wrap="square" rtlCol="1">
    var pFontStyle=getTextByPathList(spNode,["p:style","a:fontRef"]);//console.log("genTextBody spNode: ", getTextByPathList(spNode,["p:spPr","a:xfrm","a:ext"]));
    //var lstStyle = textBodyNode["a:lstStyle"];
    var apNode=textBodyNode["a:p"];if(apNode.constructor!==Array){apNode=[apNode];}for(var i=0;i<apNode.length;i++){var pNode=apNode[i];var rNode=pNode["a:r"];var fldNode=pNode["a:fld"];var brNode=pNode["a:br"];if(rNode!==undefined){rNode=rNode.constructor===Array?rNode:[rNode];}if(rNode!==undefined&&fldNode!==undefined){fldNode=fldNode.constructor===Array?fldNode:[fldNode];rNode=rNode.concat(fldNode);}if(rNode!==undefined&&brNode!==undefined){is_first_br=true;brNode=brNode.constructor===Array?brNode:[brNode];brNode.forEach(function(item,indx){item.type="br";});if(brNode.length>1){brNode.shift();}rNode=rNode.concat(brNode);//console.log("single a:p  rNode:", rNode, "brNode:", brNode )
    rNode.sort(function(a,b){return a.attrs.order-b.attrs.order;});//console.log("sorted rNode:",rNode)
    }//rtlStr = "";//"dir='"+isRTL+"'";
    var styleText="";var marginsVer=getVerticalMargins(pNode,textBodyNode,type,idx,warpObj);if(marginsVer!=""){styleText=marginsVer;}if(type=="body"||type=="obj"||type=="shape"){styleText+="font-size: 0px;";//styleText += "line-height: 0;";
    styleText+="font-weight: 100;";styleText+="font-style: normal;";}var cssName="";if(styleText in styleTable){cssName=styleTable[styleText]["name"];}else {cssName="_css_"+(Object.keys(styleTable).length+1);styleTable[styleText]={name:cssName,text:styleText};}//console.log("textBodyNode: ", textBodyNode["a:lstStyle"])
    var prg_width_node=getTextByPathList(spNode,["p:spPr","a:xfrm","a:ext","attrs","cx"]);var prg_height_node;// = getTextByPathList(spNode, ["p:spPr", "a:xfrm", "a:ext", "attrs", "cy"]);
    var sld_prg_width=prg_width_node!==undefined?"width:"+parseInt(prg_width_node)*slideFactor+"px;":"width:inherit;";var sld_prg_height=prg_height_node!==undefined?"height:"+parseInt(prg_height_node)*slideFactor+"px;":"";var prg_dir=getPregraphDir(pNode,textBodyNode,idx,type,warpObj);text+="<div style='display: flex;"+sld_prg_width+sld_prg_height+getStyleTable(cssName)+"' class='slide-prgrph "+getHorizontalAlign(pNode,textBodyNode,idx,type,prg_dir,warpObj)+" "+prg_dir+" "+cssName+"' >";var buText_ary=genBuChar(pNode,i,spNode,textBodyNode,pFontStyle,idx,type,warpObj);var isBullate=buText_ary[0]!==undefined&&buText_ary[0]!==null&&buText_ary[0]!=""?true:false;var bu_width=buText_ary[1]!==undefined&&buText_ary[1]!==null&&isBullate?buText_ary[1]+buText_ary[2]:0;text+=buText_ary[0]!==undefined?buText_ary[0]:"";//get text margin
    var margin_ary=getPregraphMargn(pNode,idx,type,isBullate,warpObj);var margin=margin_ary[0];var mrgin_val=margin_ary[1];if(prg_width_node===undefined&&tbl_col_width!==undefined&&prg_width_node!=0){//sorce : table text
    prg_width_node=tbl_col_width;}var prgrph_text="";//var prgr_txt_art = [];
    var total_text_len=0;if(rNode===undefined&&pNode!==undefined){// without r
    var prgr_text=genSpanElement(pNode,undefined,spNode,textBodyNode,pFontStyle,slideLayoutSpNode,idx,type,1,warpObj);if(isBullate){var txt_obj=jquery1_11_3_min(prgr_text).css({position:"absolute","float":"left","white-space":"nowrap",visibility:"hidden"}).appendTo(jquery1_11_3_min("body"));total_text_len+=txt_obj.outerWidth();txt_obj.remove();}prgrph_text+=prgr_text;}else if(rNode!==undefined){// with multi r
    for(var j=0;j<rNode.length;j++){var prgr_text=genSpanElement(rNode[j],j,pNode,textBodyNode,pFontStyle,slideLayoutSpNode,idx,type,rNode.length,warpObj);if(isBullate){var txt_obj=jquery1_11_3_min(prgr_text).css({position:"absolute","float":"left","white-space":"nowrap",visibility:"hidden"}).appendTo(jquery1_11_3_min("body"));total_text_len+=txt_obj.outerWidth();txt_obj.remove();}prgrph_text+=prgr_text;}}prg_width_node=parseInt(prg_width_node)*slideFactor-bu_width-mrgin_val;if(isBullate){//get prg_width_node if there is a bulltes
    //console.log("total_text_len: ", total_text_len, "prg_width_node:", prg_width_node)
    if(total_text_len<prg_width_node){prg_width_node=total_text_len+bu_width;}}var prg_width=prg_width_node!==undefined?"width:"+prg_width_node+"px;":"width:inherit;";text+="<div style='height: 100%;direction: initial;overflow-wrap:break-word;word-wrap: break-word;"+prg_width+margin+"' >";text+="<p style=\"".concat(getHorizontalAlignV1(pNode,textBodyNode,idx,type,prg_dir,warpObj),";\">").concat(prgrph_text,"</p>");text+="</div>";text+="</div>";}return text;}function genBuChar(node,i,spNode,textBodyNode,pFontStyle,idx,type,warpObj){//console.log("genBuChar node: ", node, ", spNode: ", spNode, ", pFontStyle: ", pFontStyle, "type", type)
    ///////////////////////////////////////Amir///////////////////////////////
    warpObj["slideMasterTextStyles"];var lstStyle=textBodyNode["a:lstStyle"];var rNode=getTextByPathList(node,["a:r"]);if(rNode!==undefined&&rNode.constructor===Array){rNode=rNode[0];//bullet only to first "a:r"
    }var lvl=parseInt(getTextByPathList(node["a:pPr"],["attrs","lvl"]))+1;if(isNaN(lvl)){lvl=1;}var lvlStr="a:lvl"+lvl+"pPr";var dfltBultColor,dfltBultSize,bultColor,bultSize,color_tye;if(rNode!==undefined){dfltBultColor=getFontColorPr(rNode,spNode,lstStyle,pFontStyle,lvl,idx,type,warpObj);color_tye=dfltBultColor[2];dfltBultSize=getFontSize(rNode,textBodyNode,pFontStyle,lvl,type,warpObj);}else {return "";}//console.log("Bullet Size: " + bultSize);
    var bullet="",marRStr="",marLStr="",margin_val=0,font_val=0;/////////////////////////////////////////////////////////////////
    var pPrNode=node["a:pPr"];var BullNONE=getTextByPathList(pPrNode,["a:buNone"]);if(BullNONE!==undefined){return "";}var buType="TYPE_NONE";var layoutMasterNode=getLayoutAndMasterNode(node,idx,type,warpObj);var pPrNodeLaout=layoutMasterNode.nodeLaout;var pPrNodeMaster=layoutMasterNode.nodeMaster;var buChar=getTextByPathList(pPrNode,["a:buChar","attrs","char"]);var buNum=getTextByPathList(pPrNode,["a:buAutoNum","attrs","type"]);var buPic=getTextByPathList(pPrNode,["a:buBlip"]);if(buChar!==undefined){buType="TYPE_BULLET";}if(buNum!==undefined){buType="TYPE_NUMERIC";}if(buPic!==undefined){buType="TYPE_BULPIC";}var buFontSize=getTextByPathList(pPrNode,["a:buSzPts","attrs","val"]);if(buFontSize===undefined){buFontSize=getTextByPathList(pPrNode,["a:buSzPct","attrs","val"]);if(buFontSize!==undefined){var prcnt=parseInt(buFontSize)/100000;//dfltBultSize = XXpt
    //var dfltBultSizeNoPt = dfltBultSize.substr(0, dfltBultSize.length - 2);
    var dfltBultSizeNoPt=parseInt(dfltBultSize,"px");bultSize=prcnt*parseInt(dfltBultSizeNoPt)+"px";// + "pt";
    }}else {bultSize=parseInt(buFontSize)/100*fontSizeFactor+"px";}//get definde bullet COLOR
    var buClrNode=getTextByPathList(pPrNode,["a:buClr"]);if(buChar===undefined&&buNum===undefined&&buPic===undefined){if(lstStyle!==undefined){BullNONE=getTextByPathList(lstStyle,[lvlStr,"a:buNone"]);if(BullNONE!==undefined){return "";}buType="TYPE_NONE";buChar=getTextByPathList(lstStyle,[lvlStr,"a:buChar","attrs","char"]);buNum=getTextByPathList(lstStyle,[lvlStr,"a:buAutoNum","attrs","type"]);buPic=getTextByPathList(lstStyle,[lvlStr,"a:buBlip"]);if(buChar!==undefined){buType="TYPE_BULLET";}if(buNum!==undefined){buType="TYPE_NUMERIC";}if(buPic!==undefined){buType="TYPE_BULPIC";}if(buChar!==undefined||buNum!==undefined||buPic!==undefined){pPrNode=lstStyle[lvlStr];}}}if(buChar===undefined&&buNum===undefined&&buPic===undefined){//check in slidelayout and masterlayout - TODO
    if(pPrNodeLaout!==undefined){BullNONE=getTextByPathList(pPrNodeLaout,["a:buNone"]);if(BullNONE!==undefined){return "";}buType="TYPE_NONE";buChar=getTextByPathList(pPrNodeLaout,["a:buChar","attrs","char"]);buNum=getTextByPathList(pPrNodeLaout,["a:buAutoNum","attrs","type"]);buPic=getTextByPathList(pPrNodeLaout,["a:buBlip"]);if(buChar!==undefined){buType="TYPE_BULLET";}if(buNum!==undefined){buType="TYPE_NUMERIC";}if(buPic!==undefined){buType="TYPE_BULPIC";}}if(buChar===undefined&&buNum===undefined&&buPic===undefined){//masterlayout
    if(pPrNodeMaster!==undefined){BullNONE=getTextByPathList(pPrNodeMaster,["a:buNone"]);if(BullNONE!==undefined){return "";}buType="TYPE_NONE";buChar=getTextByPathList(pPrNodeMaster,["a:buChar","attrs","char"]);buNum=getTextByPathList(pPrNodeMaster,["a:buAutoNum","attrs","type"]);buPic=getTextByPathList(pPrNodeMaster,["a:buBlip"]);if(buChar!==undefined){buType="TYPE_BULLET";}if(buNum!==undefined){buType="TYPE_NUMERIC";}if(buPic!==undefined){buType="TYPE_BULPIC";}}}}//rtl
    var getRtlVal=getTextByPathList(pPrNode,["attrs","rtl"]);if(getRtlVal===undefined){getRtlVal=getTextByPathList(pPrNodeLaout,["attrs","rtl"]);if(getRtlVal===undefined&&type!="shape"){getRtlVal=getTextByPathList(pPrNodeMaster,["attrs","rtl"]);}}var isRTL=false;if(getRtlVal!==undefined&&getRtlVal=="1"){isRTL=true;}//align
    var alignNode=getTextByPathList(pPrNode,["attrs","algn"]);//"l" | "ctr" | "r" | "just" | "justLow" | "dist" | "thaiDist
    if(alignNode===undefined){alignNode=getTextByPathList(pPrNodeLaout,["attrs","algn"]);if(alignNode===undefined){alignNode=getTextByPathList(pPrNodeMaster,["attrs","algn"]);}}//indent?
    var indentNode=getTextByPathList(pPrNode,["attrs","indent"]);if(indentNode===undefined){indentNode=getTextByPathList(pPrNodeLaout,["attrs","indent"]);if(indentNode===undefined){indentNode=getTextByPathList(pPrNodeMaster,["attrs","indent"]);}}var indent=0;if(indentNode!==undefined){indent=parseInt(indentNode)*slideFactor;}//marL
    var marLNode=getTextByPathList(pPrNode,["attrs","marL"]);if(marLNode===undefined){marLNode=getTextByPathList(pPrNodeLaout,["attrs","marL"]);if(marLNode===undefined){marLNode=getTextByPathList(pPrNodeMaster,["attrs","marL"]);}}//console.log("genBuChar() isRTL", isRTL, "alignNode:", alignNode)
    if(marLNode!==undefined){var marginLeft=parseInt(marLNode)*slideFactor;if(isRTL){// && alignNode == "r") {
    marLStr="padding-right:";// "margin-right: ";
    }else {marLStr="padding-left:";//"margin-left: ";
    }margin_val=marginLeft+indent<0?0:marginLeft+indent;marLStr+=margin_val+"px;";}//marR?
    var marRNode=getTextByPathList(pPrNode,["attrs","marR"]);if(marRNode===undefined&&marLNode===undefined){//need to check if this posble - TODO
    marRNode=getTextByPathList(pPrNodeLaout,["attrs","marR"]);if(marRNode===undefined){marRNode=getTextByPathList(pPrNodeMaster,["attrs","marR"]);}}if(marRNode!==undefined){var marginRight=parseInt(marRNode)*slideFactor;if(isRTL){// && alignNode == "r") {
    marLStr="padding-right:";// "margin-right: ";
    }else {marLStr="padding-left:";//"margin-left: ";
    }marRStr+=(marginRight+indent<0?0:marginRight+indent)+"px;";}//console.log("NumericTypr: " + buNum);
    //console.log("buChar: " + (buChar === undefined?'':buChar.charCodeAt(0)));
    //get definde bullet COLOR
    if(buClrNode===undefined){//lstStyle
    buClrNode=getTextByPathList(lstStyle,[lvlStr,"a:buClr"]);}if(buClrNode===undefined){buClrNode=getTextByPathList(pPrNodeLaout,["a:buClr"]);if(buClrNode===undefined){buClrNode=getTextByPathList(pPrNodeMaster,["a:buClr"]);}}var defBultColor;if(buClrNode!==undefined){defBultColor=getSolidFill(buClrNode,undefined,undefined,warpObj);}else {if(pFontStyle!==undefined){//console.log("genBuChar pFontStyle: ", pFontStyle)
    defBultColor=getSolidFill(pFontStyle,undefined,undefined,warpObj);}}if(defBultColor===undefined||defBultColor=="NONE"){bultColor=dfltBultColor;}else {bultColor=[defBultColor,"","solid"];color_tye="solid";}//console.log("genBuChar node:", node, "pPrNode", pPrNode, " buClrNode: ", buClrNode, "defBultColor:", defBultColor,"dfltBultColor:" , dfltBultColor , "bultColor:", bultColor)
    //console.log("genBuChar: buClrNode: ", buClrNode, "bultColor", bultColor)
    //get definde bullet SIZE
    if(buFontSize===undefined){buFontSize=getTextByPathList(pPrNodeLaout,["a:buSzPts","attrs","val"]);if(buFontSize===undefined){buFontSize=getTextByPathList(pPrNodeLaout,["a:buSzPct","attrs","val"]);if(buFontSize!==undefined){var prcnt=parseInt(buFontSize)/100000;//var dfltBultSizeNoPt = dfltBultSize.substr(0, dfltBultSize.length - 2);
    var dfltBultSizeNoPt=parseInt(dfltBultSize,"px");bultSize=prcnt*parseInt(dfltBultSizeNoPt)+"px";// + "pt";
    }}else {bultSize=parseInt(buFontSize)/100*fontSizeFactor+"px";}}if(buFontSize===undefined){buFontSize=getTextByPathList(pPrNodeMaster,["a:buSzPts","attrs","val"]);if(buFontSize===undefined){buFontSize=getTextByPathList(pPrNodeMaster,["a:buSzPct","attrs","val"]);if(buFontSize!==undefined){var prcnt=parseInt(buFontSize)/100000;//dfltBultSize = XXpt
    //var dfltBultSizeNoPt = dfltBultSize.substr(0, dfltBultSize.length - 2);
    var dfltBultSizeNoPt=parseInt(dfltBultSize,"px");bultSize=prcnt*parseInt(dfltBultSizeNoPt)+"px";// + "pt";
    }}else {bultSize=parseInt(buFontSize)/100*fontSizeFactor+"px";}}if(buFontSize===undefined){bultSize=dfltBultSize;}font_val=parseInt(bultSize,"px");////////////////////////////////////////////////////////////////////////
    if(buType=="TYPE_BULLET"){var typefaceNode=getTextByPathList(pPrNode,["a:buFont","attrs","typeface"]);var typeface="";if(typefaceNode!==undefined){typeface="font-family: "+typefaceNode;}// var marginLeft = parseInt(getTextByPathList(marLNode)) * slideFactor;
    // var marginRight = parseInt(getTextByPathList(marRNode)) * slideFactor;
    // if (isNaN(marginLeft)) {
    //     marginLeft = 328600 * slideFactor;
    // }
    // if (isNaN(marginRight)) {
    //     marginRight = 0;
    // }
    bullet="<div style='height: 100%;"+typeface+";"+marLStr+marRStr+"font-size:"+bultSize+";";//bullet += "display: table-cell;";
    //"line-height: 0px;";
    if(color_tye=="solid"){if(bultColor[0]!==undefined&&bultColor[0]!=""){bullet+="color:#"+bultColor[0]+"; ";}if(bultColor[1]!==undefined&&bultColor[1]!=""&&bultColor[1]!=";"){bullet+="text-shadow:"+bultColor[1]+";";}//no highlight/background-color to bullet
    // if (bultColor[3] !== undefined && bultColor[3] != "") {
    //     styleText += "background-color: #" + bultColor[3] + ";";
    // }
    }else if(color_tye=="pattern"||color_tye=="pic"||color_tye=="gradient"){if(color_tye=="pattern"){bullet+="background:"+bultColor[0][0]+";";if(bultColor[0][1]!==null&&bultColor[0][1]!==undefined&&bultColor[0][1]!=""){bullet+="background-size:"+bultColor[0][1]+";";//" 2px 2px;" +
    }if(bultColor[0][2]!==null&&bultColor[0][2]!==undefined&&bultColor[0][2]!=""){bullet+="background-position:"+bultColor[0][2]+";";//" 2px 2px;" +
    }// bullet += "-webkit-background-clip: text;" +
    //     "background-clip: text;" +
    //     "color: transparent;" +
    //     "-webkit-text-stroke: " + bultColor[1].border + ";" +
    //     "filter: " + bultColor[1].effcts + ";";
    }else if(color_tye=="pic"){bullet+=bultColor[0]+";";// bullet += "-webkit-background-clip: text;" +
    //     "background-clip: text;" +
    //     "color: transparent;" +
    //     "-webkit-text-stroke: " + bultColor[1].border + ";";
    }else if(color_tye=="gradient"){var colorAry=bultColor[0].color;var rot=bultColor[0].rot;bullet+="background: linear-gradient("+rot+"deg,";for(var i=0;i<colorAry.length;i++){if(i==colorAry.length-1){bullet+="#"+colorAry[i]+");";}else {bullet+="#"+colorAry[i]+", ";}}// bullet += "color: transparent;" +
    //     "-webkit-background-clip: text;" +
    //     "background-clip: text;" +
    //     "-webkit-text-stroke: " + bultColor[1].border + ";";
    }bullet+="-webkit-background-clip: text;"+"background-clip: text;"+"color: transparent;";if(bultColor[1].border!==undefined&&bultColor[1].border!==""){bullet+="-webkit-text-stroke: "+bultColor[1].border+";";}if(bultColor[1].effcts!==undefined&&bultColor[1].effcts!==""){bullet+="filter: "+bultColor[1].effcts+";";}}if(isRTL){//bullet += "display: inline-block;white-space: nowrap ;direction:rtl"; // float: right;
    bullet+="white-space: nowrap ;direction:rtl";// display: table-cell;;
    }var isIE11=!!window.MSInputMethodContext&&!!document.documentMode;var htmlBu=buChar;if(!isIE11){//ie11 does not support unicode ?
    htmlBu=getHtmlBullet(typefaceNode,buChar);}bullet+="'><div style='line-height: "+font_val/2+"px;'>"+htmlBu+"</div></div>";//font_val
    //}
    // else {
    //     marginLeft = 328600 * slideFactor * lvl;
    //     bullet = "<div style='" + marLStr + "'>" + buChar + "</div>";
    // }
    }else if(buType=="TYPE_NUMERIC"){///////////Amir///////////////////////////////
    //if (buFontAttrs !== undefined) {
    // var marginLeft = parseInt(getTextByPathList(pPrNode, ["attrs", "marL"])) * slideFactor;
    // var marginRight = parseInt(buFontAttrs["pitchFamily"]);
    // if (isNaN(marginLeft)) {
    //     marginLeft = 328600 * slideFactor;
    // }
    // if (isNaN(marginRight)) {
    //     marginRight = 0;
    // }
    //var typeface = buFontAttrs["typeface"];
    bullet="<div style='height: 100%;"+marLStr+marRStr+"color:#"+bultColor[0]+";"+"font-size:"+bultSize+";";// +
    //"line-height: 0px;";
    if(isRTL){bullet+="display: inline-block;white-space: nowrap ;direction:rtl;";// float: right;
    }else {bullet+="display: inline-block;white-space: nowrap ;direction:ltr;";//float: left;
    }bullet+="' data-bulltname = '"+buNum+"' data-bulltlvl = '"+lvl+"' class='numeric-bullet-style'></div>";// } else {
    //     marginLeft = 328600 * slideFactor * lvl;
    //     bullet = "<div style='margin-left: " + marginLeft + "px;";
    //     if (isRTL) {
    //         bullet += " float: right; direction:rtl;";
    //     } else {
    //         bullet += " float: left; direction:ltr;";
    //     }
    //     bullet += "' data-bulltname = '" + buNum + "' data-bulltlvl = '" + lvl + "' class='numeric-bullet-style'></div>";
    // }
    }else if(buType=="TYPE_BULPIC"){//PIC BULLET
    // var marginLeft = parseInt(getTextByPathList(pPrNode, ["attrs", "marL"])) * slideFactor;
    // var marginRight = parseInt(getTextByPathList(pPrNode, ["attrs", "marR"])) * slideFactor;
    // if (isNaN(marginRight)) {
    //     marginRight = 0;
    // }
    // //console.log("marginRight: "+marginRight)
    // //buPic
    // if (isNaN(marginLeft)) {
    //     marginLeft = 328600 * slideFactor;
    // } else {
    //     marginLeft = 0;
    // }
    //var buPicId = getTextByPathList(buPic, ["a:blip","a:extLst","a:ext","asvg:svgBlip" , "attrs", "r:embed"]);
    var buPicId=getTextByPathList(buPic,["a:blip","attrs","r:embed"]);var buImg;if(buPicId!==undefined){//svgPicPath = warpObj["slideResObj"][buPicId]["target"];
    //buImg = warpObj["zip"].file(svgPicPath).asText();
    //}else{
    //buPicId = getTextByPathList(buPic, ["a:blip", "attrs", "r:embed"]);
    var imgPath=warpObj["slideResObj"][buPicId]["target"];//console.log("imgPath: ", imgPath);
    var imgArrayBuffer=warpObj["zip"].file(imgPath).asArrayBuffer();var imgExt=imgPath.split(".").pop();var imgMimeType=getMimeType(imgExt);buImg="<img src='data:"+imgMimeType+";base64,"+base64ArrayBuffer(imgArrayBuffer)+"' style='width: 100%;'/>";// height: 100%
    //console.log("imgPath: "+imgPath+"\nimgMimeType: "+imgMimeType)
    }if(buPicId===undefined){buImg="&#8227;";}bullet="<div style='height: 100%;"+marLStr+marRStr+"width:"+bultSize+";display: inline-block; ";// +
    //"line-height: 0px;";
    if(isRTL){bullet+="display: inline-block;white-space: nowrap ;direction:rtl;";//direction:rtl; float: right;
    }bullet+="'>"+buImg+"  </div>";//////////////////////////////////////////////////////////////////////////////////////
    }// else {
    //     bullet = "<div style='margin-left: " + 328600 * slideFactor * lvl + "px" +
    //         "; margin-right: " + 0 + "px;'></div>";
    // }
    //console.log("genBuChar: width: ", $(bullet).outerWidth())
    return [bullet,margin_val,font_val];//$(bullet).outerWidth()];
    }function getHtmlBullet(typefaceNode,buChar){//http://www.alanwood.net/demos/wingdings.html
    //not work for IE11
    //console.log("genBuChar typefaceNode:", typefaceNode, " buChar:", buChar, "charCodeAt:", buChar.charCodeAt(0))
    switch(buChar){case"§":return "&#9632;";//"■"; //9632 | U+25A0 | Black square
    case"q":return "&#10065;";//"❑"; // 10065 | U+2751 | Lower right shadowed white square
    case"v":return "&#10070;";//"❖"; //10070 | U+2756 | Black diamond minus white X
    case"Ø":return "&#11162;";//"⮚"; //11162 | U+2B9A | Three-D top-lighted rightwards equilateral arrowhead
    case"ü":return "&#10004;";//"✔";  //10004 | U+2714 | Heavy check mark
    default:if(/*typefaceNode == "Wingdings" ||*/typefaceNode=="Wingdings 2"||typefaceNode=="Wingdings 3"){var wingCharCode=getDingbatToUnicode(typefaceNode,buChar);if(wingCharCode!==null){return "&#"+wingCharCode+";";}}return "&#"+buChar.charCodeAt(0)+";";}}function getDingbatToUnicode(typefaceNode,buChar){if(dingbat_unicode){var dingbat_code=buChar.codePointAt(0)&0xfff;var char_unicode=null;var len=dingbat_unicode.length;var i=0;while(len--){// blah blah
    var item=dingbat_unicode[i];if(item.f==typefaceNode&&item.code==dingbat_code){char_unicode=item.unicode;break;}i++;}return char_unicode;}}function getLayoutAndMasterNode(node,idx,type,warpObj){var pPrNodeLaout,pPrNodeMaster;var pPrNode=node["a:pPr"];//lvl
    var lvl=1;var lvlNode=getTextByPathList(pPrNode,["attrs","lvl"]);if(lvlNode!==undefined){lvl=parseInt(lvlNode)+1;}if(idx!==undefined){//slidelayout
    pPrNodeLaout=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:lstStyle","a:lvl"+lvl+"pPr"]);if(pPrNodeLaout===undefined){pPrNodeLaout=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:p","a:pPr"]);if(pPrNodeLaout===undefined){pPrNodeLaout=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:p",lvl-1,"a:pPr"]);}}}if(type!==undefined){//slidelayout
    var lvlStr="a:lvl"+lvl+"pPr";if(pPrNodeLaout===undefined){pPrNodeLaout=getTextByPathList(warpObj,["slideLayoutTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr]);}//masterlayout
    if(type=="title"||type=="ctrTitle"){pPrNodeMaster=getTextByPathList(warpObj,["slideMasterTextStyles","p:titleStyle",lvlStr]);}else if(type=="body"||type=="obj"||type=="subTitle"){pPrNodeMaster=getTextByPathList(warpObj,["slideMasterTextStyles","p:bodyStyle",lvlStr]);}else if(type=="shape"||type=="diagram"){pPrNodeMaster=getTextByPathList(warpObj,["slideMasterTextStyles","p:otherStyle",lvlStr]);}else if(type=="textBox"){pPrNodeMaster=getTextByPathList(warpObj,["defaultTextStyle",lvlStr]);}else {pPrNodeMaster=getTextByPathList(warpObj,["slideMasterTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr]);}}return {nodeLaout:pPrNodeLaout,nodeMaster:pPrNodeMaster};}function genSpanElement(node,rIndex,pNode,textBodyNode,pFontStyle,slideLayoutSpNode,idx,type,rNodeLength,warpObj,isBullate){//https://codepen.io/imdunn/pen/GRgwaye ?
    var text_style="";var lstStyle=textBodyNode["a:lstStyle"];warpObj["slideMasterTextStyles"];var text=node["a:t"];//var text_count = text.length;
    var openElemnt="<sapn";//"<bdi";
    var closeElemnt="</sapn>";// "</bdi>";
    var styleText="";if(text===undefined&&node["type"]!==undefined){if(is_first_br){//openElemnt = "<br";
    //closeElemnt = "";
    //return "<br style='font-size: initial'>"
    is_first_br=false;return "<sapn class='line-break-br' ></sapn>";}styleText+="display: block;";//openElemnt = "<sapn";
    //closeElemnt = "</sapn>";
    }else {is_first_br=true;}if(typeof text!=="string"){text=getTextByPathList(node,["a:fld","a:t"]);if(typeof text!=="string"){text="&nbsp;";//return "<span class='text-block '>&nbsp;</span>";
    }// if (text === undefined) {
    //     return "";
    // }
    }var pPrNode=pNode["a:pPr"];//lvl
    var lvl=1;var lvlNode=getTextByPathList(pPrNode,["attrs","lvl"]);if(lvlNode!==undefined){lvl=parseInt(lvlNode)+1;}//console.log("genSpanElement node: ", node, "rIndex: ", rIndex, ", pNode: ", pNode, ",pPrNode: ", pPrNode, "pFontStyle:", pFontStyle, ", idx: ", idx, "type:", type, warpObj);
    var layoutMasterNode=getLayoutAndMasterNode(pNode,idx,type,warpObj);var pPrNodeLaout=layoutMasterNode.nodeLaout;var pPrNodeMaster=layoutMasterNode.nodeMaster;//Language
    var lang=getTextByPathList(node,["a:rPr","attrs","lang"]);var isRtlLan=lang!==undefined&&rtl_langs_array.indexOf(lang)!==-1?true:false;//rtl
    var getRtlVal=getTextByPathList(pPrNode,["attrs","rtl"]);if(getRtlVal===undefined){getRtlVal=getTextByPathList(pPrNodeLaout,["attrs","rtl"]);if(getRtlVal===undefined&&type!="shape"){getRtlVal=getTextByPathList(pPrNodeMaster,["attrs","rtl"]);}}var linkID=getTextByPathList(node,["a:rPr","a:hlinkClick","attrs","r:id"]);var linkTooltip="";var defLinkClr;if(linkID!==undefined){linkTooltip=getTextByPathList(node,["a:rPr","a:hlinkClick","attrs","tooltip"]);if(linkTooltip!==undefined){linkTooltip="title='"+linkTooltip+"'";}defLinkClr=getSchemeColorFromTheme("a:hlink",undefined,undefined,warpObj);var linkClrNode=getTextByPathList(node,["a:rPr","a:solidFill"]);// getTextByPathList(node, ["a:rPr", "a:solidFill"]);
    var rPrlinkClr=getSolidFill(linkClrNode,undefined,undefined,warpObj);//console.log("genSpanElement defLinkClr: ", defLinkClr, "rPrlinkClr:", rPrlinkClr)
    if(rPrlinkClr!==undefined&&rPrlinkClr!=""){defLinkClr=rPrlinkClr;}}/////////////////////////////////////////////////////////////////////////////////////
    //getFontColor
    var fontClrPr=getFontColorPr(node,pNode,lstStyle,pFontStyle,lvl,idx,type,warpObj);var fontClrType=fontClrPr[2];//console.log("genSpanElement fontClrPr: ", fontClrPr, "linkID", linkID);
    if(fontClrType=="solid"){if(linkID===undefined&&fontClrPr[0]!==undefined&&fontClrPr[0]!=""){styleText+="color: #"+fontClrPr[0]+";";}else if(linkID!==undefined&&defLinkClr!==undefined){styleText+="color: #"+defLinkClr+";";}if(fontClrPr[1]!==undefined&&fontClrPr[1]!=""&&fontClrPr[1]!=";"){styleText+="text-shadow:"+fontClrPr[1]+";";}if(fontClrPr[3]!==undefined&&fontClrPr[3]!=""){styleText+="background-color: #"+fontClrPr[3]+";";}}else if(fontClrType=="pattern"||fontClrType=="pic"||fontClrType=="gradient"){if(fontClrType=="pattern"){styleText+="background:"+fontClrPr[0][0]+";";if(fontClrPr[0][1]!==null&&fontClrPr[0][1]!==undefined&&fontClrPr[0][1]!=""){styleText+="background-size:"+fontClrPr[0][1]+";";//" 2px 2px;" +
    }if(fontClrPr[0][2]!==null&&fontClrPr[0][2]!==undefined&&fontClrPr[0][2]!=""){styleText+="background-position:"+fontClrPr[0][2]+";";//" 2px 2px;" +
    }// styleText += "-webkit-background-clip: text;" +
    //     "background-clip: text;" +
    //     "color: transparent;" +
    //     "-webkit-text-stroke: " + fontClrPr[1].border + ";" +
    //     "filter: " + fontClrPr[1].effcts + ";";
    }else if(fontClrType=="pic"){styleText+=fontClrPr[0]+";";// styleText += "-webkit-background-clip: text;" +
    //     "background-clip: text;" +
    //     "color: transparent;" +
    //     "-webkit-text-stroke: " + fontClrPr[1].border + ";";
    }else if(fontClrType=="gradient"){var colorAry=fontClrPr[0].color;var rot=fontClrPr[0].rot;styleText+="background: linear-gradient("+rot+"deg,";for(var i=0;i<colorAry.length;i++){if(i==colorAry.length-1){styleText+="#"+colorAry[i]+");";}else {styleText+="#"+colorAry[i]+", ";}}// styleText += "-webkit-background-clip: text;" +
    //     "background-clip: text;" +
    //     "color: transparent;" +
    //     "-webkit-text-stroke: " + fontClrPr[1].border + ";";
    }styleText+="-webkit-background-clip: text;"+"background-clip: text;"+"color: transparent;";if(fontClrPr[1].border!==undefined&&fontClrPr[1].border!==""){styleText+="-webkit-text-stroke: "+fontClrPr[1].border+";";}if(fontClrPr[1].effcts!==undefined&&fontClrPr[1].effcts!==""){styleText+="filter: "+fontClrPr[1].effcts+";";}}var font_size=getFontSize(node,textBodyNode,pFontStyle,lvl,type,warpObj);//text_style += "font-size:" + font_size + ";"
    text_style+="font-size:"+font_size+";"+// marLStr +
    "font-family:"+getFontType(node,type,warpObj,pFontStyle)+";"+"font-weight:"+getFontBold(node)+";"+"font-style:"+getFontItalic(node)+";"+"text-decoration:"+getFontDecoration(node)+";"+"text-align:"+getTextHorizontalAlign(node,pNode,type,warpObj)+";"+"vertical-align:"+getTextVerticalAlign(node)+";";//rNodeLength
    //console.log("genSpanElement node:", node, "lang:", lang, "isRtlLan:", isRtlLan, "span parent dir:", dirStr)
    if(isRtlLan){//|| rIndex === undefined
    styleText+="direction:rtl;";}else {//|| rIndex === undefined
    styleText+="direction:ltr;";}// } else if (dirStr == "rtl" && isRtlLan ) {
    //     styleText += "direction:rtl;";
    // } else if (dirStr == "ltr" && !isRtlLan ) {
    //     styleText += "direction:ltr;";
    // } else if (dirStr == "ltr" && isRtlLan){
    //     styleText += "direction:ltr;";
    // }else{
    //     styleText += "direction:inherit;";
    // }
    // if (dirStr == "rtl" && !isRtlLan) { //|| rIndex === undefined
    //     styleText += "direction:ltr;";
    // } else if (dirStr == "rtl" && isRtlLan) {
    //     styleText += "direction:rtl;";
    // } else if (dirStr == "ltr" && !isRtlLan) {
    //     styleText += "direction:ltr;";
    // } else if (dirStr == "ltr" && isRtlLan) {
    //     styleText += "direction:rtl;";
    // } else {
    //     styleText += "direction:inherit;";
    // }
    //     //"direction:" + dirStr + ";";
    //if (rNodeLength == 1 || rIndex == 0 ){
    //styleText += "display: table-cell;white-space: nowrap;";
    //}
    var highlight=getTextByPathList(node,["a:rPr","a:highlight"]);if(highlight!==undefined){styleText+="background-color:#"+getSolidFill(highlight,undefined,undefined,warpObj)+";";//styleText += "Opacity:" + getColorOpacity(highlight) + ";";
    }//letter-spacing:
    var spcNode=getTextByPathList(node,["a:rPr","attrs","spc"]);if(spcNode===undefined){spcNode=getTextByPathList(pPrNodeLaout,["a:defRPr","attrs","spc"]);if(spcNode===undefined){spcNode=getTextByPathList(pPrNodeMaster,["a:defRPr","attrs","spc"]);}}if(spcNode!==undefined){var ltrSpc=parseInt(spcNode)/100;//pt
    styleText+="letter-spacing: "+ltrSpc+"px;";// + "pt;";
    }//Text Cap Types
    var capNode=getTextByPathList(node,["a:rPr","attrs","cap"]);if(capNode===undefined){capNode=getTextByPathList(pPrNodeLaout,["a:defRPr","attrs","cap"]);if(capNode===undefined){capNode=getTextByPathList(pPrNodeMaster,["a:defRPr","attrs","cap"]);}}if(capNode=="small"||capNode=="all"){styleText+="text-transform: uppercase";}//styleText += "word-break: break-word;";
    //console.log("genSpanElement node: ", node, ", capNode: ", capNode, ",pPrNodeLaout: ", pPrNodeLaout, ", pPrNodeMaster: ", pPrNodeMaster, "warpObj:", warpObj);
    var cssName="";if(styleText in styleTable){cssName=styleTable[styleText]["name"];}else {cssName="_css_"+(Object.keys(styleTable).length+1);styleTable[styleText]={name:cssName,text:styleText};}var linkColorSyle="";if(fontClrType=="solid"&&linkID!==undefined){linkColorSyle="style='color: inherit;'";}if(linkID!==undefined&&linkID!=""){var linkURL=warpObj["slideResObj"][linkID]["target"];linkURL=escapeHtml(linkURL);return openElemnt+" class='text-block "+cssName+"' style='"+text_style+getStyleTable(cssName)+"'><a href='"+linkURL+"' "+linkColorSyle+"  "+linkTooltip+" target='_blank'>"+text.replace(/\t/g,"&nbsp;&nbsp;&nbsp;&nbsp;").replace(/\s/g,"&nbsp;")+"</a>"+closeElemnt;}else {return openElemnt+" class='text-block "+cssName+"' style='"+text_style+getStyleTable(cssName)+"'>"+text.replace(/\t/g,"&nbsp;&nbsp;&nbsp;&nbsp;").replace(/\s/g,"&nbsp;")+closeElemnt;//"</bdi>";
    }}function getPregraphMargn(pNode,idx,type,isBullate,warpObj){if(!isBullate){return ["",0];}var marLStr="",maginVal=0;var pPrNode=pNode["a:pPr"];var layoutMasterNode=getLayoutAndMasterNode(pNode,idx,type,warpObj);var pPrNodeLaout=layoutMasterNode.nodeLaout;var pPrNodeMaster=layoutMasterNode.nodeMaster;// var lang = getTextByPathList(node, ["a:rPr", "attrs", "lang"]);
    // var isRtlLan = (lang !== undefined && rtl_langs_array.indexOf(lang) !== -1) ? true : false;
    //rtl
    var getRtlVal=getTextByPathList(pPrNode,["attrs","rtl"]);if(getRtlVal===undefined){getRtlVal=getTextByPathList(pPrNodeLaout,["attrs","rtl"]);if(getRtlVal===undefined&&type!="shape"){getRtlVal=getTextByPathList(pPrNodeMaster,["attrs","rtl"]);}}var isRTL=false;if(getRtlVal!==undefined&&getRtlVal=="1"){isRTL=true;}//align
    var alignNode=getTextByPathList(pPrNode,["attrs","algn"]);//"l" | "ctr" | "r" | "just" | "justLow" | "dist" | "thaiDist
    if(alignNode===undefined){alignNode=getTextByPathList(pPrNodeLaout,["attrs","algn"]);if(alignNode===undefined){alignNode=getTextByPathList(pPrNodeMaster,["attrs","algn"]);}}//indent?
    var indentNode=getTextByPathList(pPrNode,["attrs","indent"]);if(indentNode===undefined){indentNode=getTextByPathList(pPrNodeLaout,["attrs","indent"]);if(indentNode===undefined){indentNode=getTextByPathList(pPrNodeMaster,["attrs","indent"]);}}var indent=0;if(indentNode!==undefined){indent=parseInt(indentNode)*slideFactor;}//
    //marL
    var marLNode=getTextByPathList(pPrNode,["attrs","marL"]);if(marLNode===undefined){marLNode=getTextByPathList(pPrNodeLaout,["attrs","marL"]);if(marLNode===undefined){marLNode=getTextByPathList(pPrNodeMaster,["attrs","marL"]);}}var marginLeft=0;if(marLNode!==undefined){marginLeft=parseInt(marLNode)*slideFactor;}if(indentNode!==undefined||marLNode!==undefined){//var lvlIndent = defTabSz * lvl;
    if(isRTL){// && alignNode == "r") {
    //marLStr = "margin-right: ";
    marLStr="padding-right: ";}else {//marLStr = "margin-left: ";
    marLStr="padding-left: ";}if(isBullate){maginVal=Math.abs(0-indent);marLStr+=maginVal+"px;";// (minus bullate numeric lenght/size - TODO
    }else {maginVal=Math.abs(marginLeft+indent);marLStr+=maginVal+"px;";// (minus bullate numeric lenght/size - TODO
    }}//marR?
    var marRNode=getTextByPathList(pPrNode,["attrs","marR"]);if(marRNode===undefined&&marLNode===undefined){//need to check if this posble - TODO
    marRNode=getTextByPathList(pPrNodeLaout,["attrs","marR"]);if(marRNode===undefined){marRNode=getTextByPathList(pPrNodeMaster,["attrs","marR"]);}}return [marLStr,maginVal];}function genGlobalCSS(){var cssText="";//console.log("styleTable: ", styleTable)
    for(var key in styleTable){var tagname="";// if (settings.slideMode && settings.slideType == "revealjs") {
    //     tagname = "section";
    // } else {
    //     tagname = "div";
    // }
    //ADD suffix
    cssText+=tagname+" ."+styleTable[key]["name"]+(styleTable[key]["suffix"]?styleTable[key]["suffix"]:"")+"{"+styleTable[key]["text"]+"}\n";//section > div
    }//cssText += " .slide{margin-bottom: 5px;}\n"; // TODO
    return cssText;}function getTableCellParams(tcNodes,getColsGrid,row_idx,col_idx,thisTblStyle,cellSource,warpObj){//thisTblStyle["a:band1V"] => thisTblStyle[cellSource]
    //text, cell-width, cell-borders,
    //var text = genTextBody(tcNodes["a:txBody"], tcNodes, undefined, undefined, undefined, undefined, warpObj);//tableStyles
    var rowSpan=getTextByPathList(tcNodes,["attrs","rowSpan"]);var colSpan=getTextByPathList(tcNodes,["attrs","gridSpan"]);getTextByPathList(tcNodes,["attrs","vMerge"]);getTextByPathList(tcNodes,["attrs","hMerge"]);var colStyl="word-wrap: break-word;";var colWidth;var celFillColor="";var colFontClrPr="";var colFontWeight="";var lin_bottm="",lin_top="",lin_left="",lin_right="";var colSapnInt=parseInt(colSpan);var total_col_width=0;if(!isNaN(colSapnInt)&&colSapnInt>1){for(var k=0;k<colSapnInt;k++){total_col_width+=parseInt(getTextByPathList(getColsGrid[col_idx+k],["attrs","w"]));}}else {total_col_width=getTextByPathList(col_idx===undefined?getColsGrid:getColsGrid[col_idx],["attrs","w"]);}var text=genTextBody(tcNodes["a:txBody"],tcNodes,undefined,undefined,undefined,undefined,warpObj,total_col_width);//tableStyles
    if(total_col_width!=0/*&& row_idx == 0*/){colWidth=parseInt(total_col_width)*slideFactor;colStyl+="width:"+colWidth+"px;";}//cell bords
    lin_bottm=getTextByPathList(tcNodes,["a:tcPr","a:lnB"]);if(lin_bottm===undefined&&cellSource!==undefined){if(cellSource!==undefined)lin_bottm=getTextByPathList(thisTblStyle[cellSource],["a:tcStyle","a:tcBdr","a:bottom","a:ln"]);if(lin_bottm===undefined){lin_bottm=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcStyle","a:tcBdr","a:bottom","a:ln"]);}}lin_top=getTextByPathList(tcNodes,["a:tcPr","a:lnT"]);if(lin_top===undefined){if(cellSource!==undefined)lin_top=getTextByPathList(thisTblStyle[cellSource],["a:tcStyle","a:tcBdr","a:top","a:ln"]);if(lin_top===undefined){lin_top=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcStyle","a:tcBdr","a:top","a:ln"]);}}lin_left=getTextByPathList(tcNodes,["a:tcPr","a:lnL"]);if(lin_left===undefined){if(cellSource!==undefined)lin_left=getTextByPathList(thisTblStyle[cellSource],["a:tcStyle","a:tcBdr","a:left","a:ln"]);if(lin_left===undefined){lin_left=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcStyle","a:tcBdr","a:left","a:ln"]);}}lin_right=getTextByPathList(tcNodes,["a:tcPr","a:lnR"]);if(lin_right===undefined){if(cellSource!==undefined)lin_right=getTextByPathList(thisTblStyle[cellSource],["a:tcStyle","a:tcBdr","a:right","a:ln"]);if(lin_right===undefined){lin_right=getTextByPathList(thisTblStyle,["a:wholeTbl","a:tcStyle","a:tcBdr","a:right","a:ln"]);}}getTextByPathList(tcNodes,["a:tcPr","a:lnBlToTr"]);getTextByPathList(tcNodes,["a:tcPr","a:InTlToBr"]);if(lin_bottm!==undefined&&lin_bottm!=""){var bottom_line_border=getBorder(lin_bottm,undefined,false,"",warpObj);if(bottom_line_border!=""){colStyl+="border-bottom:"+bottom_line_border+";";}}if(lin_top!==undefined&&lin_top!=""){var top_line_border=getBorder(lin_top,undefined,false,"",warpObj);if(top_line_border!=""){colStyl+="border-top: "+top_line_border+";";}}if(lin_left!==undefined&&lin_left!=""){var left_line_border=getBorder(lin_left,undefined,false,"",warpObj);if(left_line_border!=""){colStyl+="border-left: "+left_line_border+";";}}if(lin_right!==undefined&&lin_right!=""){var right_line_border=getBorder(lin_right,undefined,false,"",warpObj);if(right_line_border!=""){colStyl+="border-right:"+right_line_border+";";}}//cell fill color custom
    var getCelFill=getTextByPathList(tcNodes,["a:tcPr"]);if(getCelFill!==undefined&&getCelFill!=""){var cellObj={"p:spPr":getCelFill};celFillColor=getShapeFill(cellObj,undefined,false,warpObj,"slide");}//cell fill color theme
    if(celFillColor==""||celFillColor=="background-color: inherit;"){var bgFillschemeClr;if(cellSource!==undefined)bgFillschemeClr=getTextByPathList(thisTblStyle,[cellSource,"a:tcStyle","a:fill","a:solidFill"]);if(bgFillschemeClr!==undefined){var local_fillColor=getSolidFill(bgFillschemeClr,undefined,undefined,warpObj);if(local_fillColor!==undefined){celFillColor=" background-color: #"+local_fillColor+";";}}}var cssName="";if(celFillColor!==undefined&&celFillColor!=""){if(celFillColor in styleTable){cssName=styleTable[celFillColor]["name"];}else {cssName="_tbl_cell_css_"+(Object.keys(styleTable).length+1);styleTable[celFillColor]={name:cssName,text:celFillColor};}}//border
    // var borderStyl = getTextByPathList(thisTblStyle, [cellSource, "a:tcStyle", "a:tcBdr"]);
    // if (borderStyl !== undefined) {
    //     var local_col_borders = getTableBorders(borderStyl, warpObj);
    //     if (local_col_borders != "") {
    //         col_borders = local_col_borders;
    //     }
    // }
    // if (col_borders != "") {
    //     colStyl += col_borders;
    // }
    //Text style
    var rowTxtStyl;if(cellSource!==undefined){rowTxtStyl=getTextByPathList(thisTblStyle,[cellSource,"a:tcTxStyle"]);}// if (rowTxtStyl === undefined) {
    //     rowTxtStyl = getTextByPathList(thisTblStyle, ["a:wholeTbl", "a:tcTxStyle"]);
    // }
    if(rowTxtStyl!==undefined){var local_fontClrPr=getSolidFill(rowTxtStyl,undefined,undefined,warpObj);if(local_fontClrPr!==undefined){colFontClrPr=local_fontClrPr;}var local_fontWeight=getTextByPathList(rowTxtStyl,["attrs","b"])=="on"?"bold":"";if(local_fontWeight!==""){colFontWeight=local_fontWeight;}}colStyl+=colFontClrPr!==""?"color: #"+colFontClrPr+";":"";colStyl+=colFontWeight!=""?" font-weight:"+colFontWeight+";":"";return [text,colStyl,cssName,rowSpan,colSpan];}function getPosition(slideSpNode,pNode,slideLayoutSpNode,slideMasterSpNode,sType){var off;var x=-1,y=-1;if(slideSpNode!==undefined){off=slideSpNode["a:off"]["attrs"];}if(off===undefined&&slideLayoutSpNode!==undefined){off=slideLayoutSpNode["a:off"]["attrs"];}else if(off===undefined&&slideMasterSpNode!==undefined){off=slideMasterSpNode["a:off"]["attrs"];}var offX=0,offY=0;var grpX=0,grpY=0;if(sType=="group"){var grpXfrmNode=getTextByPathList(pNode,["p:grpSpPr","a:xfrm"]);if(xfrmNode!==undefined){grpX=parseInt(grpXfrmNode["a:off"]["attrs"]["x"])*slideFactor;grpY=parseInt(grpXfrmNode["a:off"]["attrs"]["y"])*slideFactor;// var chx = parseInt(grpXfrmNode["a:chOff"]["attrs"]["x"]) * slideFactor;
    // var chy = parseInt(grpXfrmNode["a:chOff"]["attrs"]["y"]) * slideFactor;
    // var cx = parseInt(grpXfrmNode["a:ext"]["attrs"]["cx"]) * slideFactor;
    // var cy = parseInt(grpXfrmNode["a:ext"]["attrs"]["cy"]) * slideFactor;
    // var chcx = parseInt(grpXfrmNode["a:chExt"]["attrs"]["cx"]) * slideFactor;
    // var chcy = parseInt(grpXfrmNode["a:chExt"]["attrs"]["cy"]) * slideFactor;
    // var rotate = parseInt(grpXfrmNode["attrs"]["rot"])
    }}if(sType=="group-rotate"&&pNode["p:grpSpPr"]!==undefined){var xfrmNode=pNode["p:grpSpPr"]["a:xfrm"];// var ox = parseInt(xfrmNode["a:off"]["attrs"]["x"]) * slideFactor;
    // var oy = parseInt(xfrmNode["a:off"]["attrs"]["y"]) * slideFactor;
    var chx=parseInt(xfrmNode["a:chOff"]["attrs"]["x"])*slideFactor;var chy=parseInt(xfrmNode["a:chOff"]["attrs"]["y"])*slideFactor;offX=chx;offY=chy;}if(off===undefined){return "";}else {x=parseInt(off["x"])*slideFactor;y=parseInt(off["y"])*slideFactor;// if (type = "body")
    //     console.log("getPosition: slideSpNode: ", slideSpNode, ", type: ", type, "x: ", x, "offX:", offX, "y:", y, "offY:", offY)
    return isNaN(x)||isNaN(y)?"":"top:"+(y-offY+grpY)+"px; left:"+(x-offX+grpX)+"px;";}}function getPositionV1(slideSpNode,pNode,slideLayoutSpNode,slideMasterSpNode,sType){var off;var x=-1,y=-1;if(slideSpNode!==undefined){off=slideSpNode["a:off"]["attrs"];}if(off===undefined&&slideLayoutSpNode!==undefined){off=slideLayoutSpNode["a:off"]["attrs"];}else if(off===undefined&&slideMasterSpNode!==undefined){off=slideMasterSpNode["a:off"]["attrs"];}var offX=0,offY=0;var grpX=0,grpY=0;if(sType=="group"){var grpXfrmNode=getTextByPathList(pNode,["p:grpSpPr","a:xfrm"]);if(xfrmNode!==undefined){grpX=parseInt(grpXfrmNode["a:off"]["attrs"]["x"])*slideFactor;grpY=parseInt(grpXfrmNode["a:off"]["attrs"]["y"])*slideFactor;// var chx = parseInt(grpXfrmNode["a:chOff"]["attrs"]["x"]) * slideFactor;
    // var chy = parseInt(grpXfrmNode["a:chOff"]["attrs"]["y"]) * slideFactor;
    // var cx = parseInt(grpXfrmNode["a:ext"]["attrs"]["cx"]) * slideFactor;
    // var cy = parseInt(grpXfrmNode["a:ext"]["attrs"]["cy"]) * slideFactor;
    // var chcx = parseInt(grpXfrmNode["a:chExt"]["attrs"]["cx"]) * slideFactor;
    // var chcy = parseInt(grpXfrmNode["a:chExt"]["attrs"]["cy"]) * slideFactor;
    // var rotate = parseInt(grpXfrmNode["attrs"]["rot"])
    }}if(sType=="group-rotate"&&pNode["p:grpSpPr"]!==undefined){var xfrmNode=pNode["p:grpSpPr"]["a:xfrm"];// var ox = parseInt(xfrmNode["a:off"]["attrs"]["x"]) * slideFactor;
    // var oy = parseInt(xfrmNode["a:off"]["attrs"]["y"]) * slideFactor;
    var chx=parseInt(xfrmNode["a:chOff"]["attrs"]["x"])*slideFactor;var chy=parseInt(xfrmNode["a:chOff"]["attrs"]["y"])*slideFactor;offX=chx;offY=chy;}if(off===undefined){return {top:0,left:0};}else {x=parseInt(off["x"])*slideFactor;y=parseInt(off["y"])*slideFactor;// if (type = "body")
    //     console.log("getPosition: slideSpNode: ", slideSpNode, ", type: ", type, "x: ", x, "offX:", offX, "y:", y, "offY:", offY)
    return isNaN(x)||isNaN(y)?{top:0,left:0}:{top:y-offY+grpY,left:x-offX+grpX};}}function getSize(slideSpNode,slideLayoutSpNode,slideMasterSpNode){var ext=undefined;var w=-1,h=-1;if(slideSpNode!==undefined){ext=slideSpNode["a:ext"]["attrs"];}else if(slideLayoutSpNode!==undefined){ext=slideLayoutSpNode["a:ext"]["attrs"];}else if(slideMasterSpNode!==undefined){ext=slideMasterSpNode["a:ext"]["attrs"];}if(ext===undefined){return "";}else {w=parseInt(ext["cx"])*slideFactor;h=parseInt(ext["cy"])*slideFactor;return isNaN(w)||isNaN(h)?"":"width:"+w+"px; height:"+h+"px;";}}function getSizeV1(slideSpNode,slideLayoutSpNode,slideMasterSpNode){var ext=undefined;var w=-1,h=-1;if(slideSpNode!==undefined){ext=slideSpNode["a:ext"]["attrs"];}else if(slideLayoutSpNode!==undefined){ext=slideLayoutSpNode["a:ext"]["attrs"];}else if(slideMasterSpNode!==undefined){ext=slideMasterSpNode["a:ext"]["attrs"];}if(ext===undefined){return {width:0,height:0};}else {w=parseInt(ext["cx"])*slideFactor;h=parseInt(ext["cy"])*slideFactor;return isNaN(w)||isNaN(h)?{width:0,height:0}:{width:w,height:h};}}function getVerticalMargins(pNode,textBodyNode,type,idx,warpObj){//margin-top ;
    //a:pPr => a:spcBef => a:spcPts (/100) | a:spcPct (/?)
    //margin-bottom
    //a:pPr => a:spcAft => a:spcPts (/100) | a:spcPct (/?)
    //+
    //a:pPr =>a:lnSpc => a:spcPts (/?) | a:spcPct (/?)
    //console.log("getVerticalMargins ", pNode, type,idx, warpObj)
    //var lstStyle = textBodyNode["a:lstStyle"];
    var lvl=1;var spcBefNode=getTextByPathList(pNode,["a:pPr","a:spcBef","a:spcPts","attrs","val"]);var spcAftNode=getTextByPathList(pNode,["a:pPr","a:spcAft","a:spcPts","attrs","val"]);var lnSpcNode=getTextByPathList(pNode,["a:pPr","a:lnSpc","a:spcPct","attrs","val"]);var lnSpcNodeType="Pct";if(lnSpcNode===undefined){lnSpcNode=getTextByPathList(pNode,["a:pPr","a:lnSpc","a:spcPts","attrs","val"]);if(lnSpcNode!==undefined){lnSpcNodeType="Pts";}}var lvlNode=getTextByPathList(pNode,["a:pPr","attrs","lvl"]);if(lvlNode!==undefined){lvl=parseInt(lvlNode)+1;}var fontSize;if(getTextByPathList(pNode,["a:r"])!==undefined){var fontSizeStr=getFontSize(pNode["a:r"],textBodyNode,undefined,lvl,type,warpObj);if(fontSizeStr!="inherit"){fontSize=parseInt(fontSizeStr,"px");//pt
    }}//var spcBef = "";
    //console.log("getVerticalMargins 1", fontSizeStr, fontSize, lnSpcNode, parseInt(lnSpcNode) / 100000, spcBefNode, spcAftNode)
    // if(spcBefNode !== undefined){
    //     spcBef = "margin-top:" + parseInt(spcBefNode)/100 + "pt;"
    // }
    // else{
    //    //i did not found case with percentage
    //     spcBefNode = getTextByPathList(pNode, ["a:pPr", "a:spcBef", "a:spcPct","attrs","val"]);
    //     if(spcBefNode !== undefined){
    //         spcBef = "margin-top:" + parseInt(spcBefNode)/100 + "%;"
    //     }
    // }
    //var spcAft = "";
    // if(spcAftNode !== undefined){
    //     spcAft = "margin-bottom:" + parseInt(spcAftNode)/100 + "pt;"
    // }
    // else{
    //    //i did not found case with percentage
    //     spcAftNode = getTextByPathList(pNode, ["a:pPr", "a:spcAft", "a:spcPct","attrs","val"]);
    //     if(spcAftNode !== undefined){
    //         spcBef = "margin-bottom:" + parseInt(spcAftNode)/100 + "%;"
    //     }
    // }
    // if(spcAftNode !== undefined){
    //     //check in layout and then in master
    // }
    var isInLayoutOrMaster=true;if(type=="shape"||type=="textBox"){isInLayoutOrMaster=false;}if(isInLayoutOrMaster&&(spcBefNode===undefined||spcAftNode===undefined||lnSpcNode===undefined)){//check in layout
    if(idx!==undefined){var laypPrNode=getTextByPathList(warpObj,["slideLayoutTables","idxTable",idx,"p:txBody","a:p",lvl-1,"a:pPr"]);if(spcBefNode===undefined){spcBefNode=getTextByPathList(laypPrNode,["a:spcBef","a:spcPts","attrs","val"]);// if(spcBefNode !== undefined){
    //     spcBef = "margin-top:" + parseInt(spcBefNode)/100 + "pt;"
    // }
    // else{
    //    //i did not found case with percentage
    //     spcBefNode = getTextByPathList(laypPrNode, ["a:spcBef", "a:spcPct","attrs","val"]);
    //     if(spcBefNode !== undefined){
    //         spcBef = "margin-top:" + parseInt(spcBefNode)/100 + "%;"
    //     }
    // }
    }if(spcAftNode===undefined){spcAftNode=getTextByPathList(laypPrNode,["a:spcAft","a:spcPts","attrs","val"]);// if(spcAftNode !== undefined){
    //     spcAft = "margin-bottom:" + parseInt(spcAftNode)/100 + "pt;"
    // }
    // else{
    //    //i did not found case with percentage
    //     spcAftNode = getTextByPathList(laypPrNode, ["a:spcAft", "a:spcPct","attrs","val"]);
    //     if(spcAftNode !== undefined){
    //         spcBef = "margin-bottom:" + parseInt(spcAftNode)/100 + "%;"
    //     }
    // }
    }if(lnSpcNode===undefined){lnSpcNode=getTextByPathList(laypPrNode,["a:lnSpc","a:spcPct","attrs","val"]);if(lnSpcNode===undefined){lnSpcNode=getTextByPathList(laypPrNode,["a:pPr","a:lnSpc","a:spcPts","attrs","val"]);if(lnSpcNode!==undefined){lnSpcNodeType="Pts";}}}}}if(isInLayoutOrMaster&&(spcBefNode===undefined||spcAftNode===undefined||lnSpcNode===undefined)){//check in master
    //slideMasterTextStyles
    var slideMasterTextStyles=warpObj["slideMasterTextStyles"];var dirLoc="";var lvl="a:lvl"+lvl+"pPr";switch(type){case"title":case"ctrTitle":dirLoc="p:titleStyle";break;case"body":case"obj":case"dt":case"ftr":case"sldNum":case"textBox":// case "shape":
    dirLoc="p:bodyStyle";break;case"shape"://case "textBox":
    default:dirLoc="p:otherStyle";}// if (type == "shape" || type == "textBox") {
    //     lvl = "a:lvl1pPr";
    // }
    var inLvlNode=getTextByPathList(slideMasterTextStyles,[dirLoc,lvl]);if(inLvlNode!==undefined){if(spcBefNode===undefined){spcBefNode=getTextByPathList(inLvlNode,["a:spcBef","a:spcPts","attrs","val"]);// if(spcBefNode !== undefined){
    //     spcBef = "margin-top:" + parseInt(spcBefNode)/100 + "pt;"
    // }
    // else{
    //    //i did not found case with percentage
    //     spcBefNode = getTextByPathList(inLvlNode, ["a:spcBef", "a:spcPct","attrs","val"]);
    //     if(spcBefNode !== undefined){
    //         spcBef = "margin-top:" + parseInt(spcBefNode)/100 + "%;"
    //     }
    // }
    }if(spcAftNode===undefined){spcAftNode=getTextByPathList(inLvlNode,["a:spcAft","a:spcPts","attrs","val"]);// if(spcAftNode !== undefined){
    //     spcAft = "margin-bottom:" + parseInt(spcAftNode)/100 + "pt;"
    // }
    // else{
    //    //i did not found case with percentage
    //     spcAftNode = getTextByPathList(inLvlNode, ["a:spcAft", "a:spcPct","attrs","val"]);
    //     if(spcAftNode !== undefined){
    //         spcBef = "margin-bottom:" + parseInt(spcAftNode)/100 + "%;"
    //     }
    // }
    }if(lnSpcNode===undefined){lnSpcNode=getTextByPathList(inLvlNode,["a:lnSpc","a:spcPct","attrs","val"]);if(lnSpcNode===undefined){lnSpcNode=getTextByPathList(inLvlNode,["a:pPr","a:lnSpc","a:spcPts","attrs","val"]);if(lnSpcNode!==undefined){lnSpcNodeType="Pts";}}}}}var spcBefor=0,spcAfter=0,spcLines=0;var marginTopBottomStr="";if(spcBefNode!==undefined){spcBefor=parseInt(spcBefNode)/100;}if(spcAftNode!==undefined){spcAfter=parseInt(spcAftNode)/100;}if(lnSpcNode!==undefined&&fontSize!==undefined){if(lnSpcNodeType=="Pts"){marginTopBottomStr+="padding-top: "+(parseInt(lnSpcNode)/100-fontSize)+"px;";//+ "pt;";
    }else {var fct=parseInt(lnSpcNode)/100000;spcLines=fontSize*(fct-1)-fontSize;// fontSize *
    var pBottom=fct>1?fontSize:0;// marginTopBottomStr += "padding-top: " + spcLines + "pt;";
    // marginTopBottomStr += "padding-bottom: " + pBottom + "pt;";
    marginTopBottomStr+="padding-top: "+pBottom+"px;";// + "pt;";
    marginTopBottomStr+="padding-bottom: "+spcLines+"px;";// + "pt;";
    }}//if (spcBefNode !== undefined || lnSpcNode !== undefined) {
    marginTopBottomStr+="margin-top: "+(spcBefor-1)+"px;";// + "pt;"; //margin-top: + spcLines // minus 1 - to fix space
    //}
    if(spcAftNode!==undefined||lnSpcNode!==undefined){//marginTopBottomStr += "margin-bottom: " + ((spcAfter - fontSize < 0) ? 0 : (spcAfter - fontSize)) + "pt;"; //margin-bottom: + spcLines
    //marginTopBottomStr += "margin-bottom: " + spcAfter * (1 / 4) + "px;";// + "pt;";
    marginTopBottomStr+="margin-bottom: "+spcAfter+"px;";// + "pt;";
    }//console.log("getVerticalMargins 2 fontSize:", fontSize, "lnSpcNode:", lnSpcNode, "spcLines:", spcLines, "spcBefor:", spcBefor, "spcAfter:", spcAfter)
    //console.log("getVerticalMargins 3 ", marginTopBottomStr, pNode, warpObj)
    //return spcAft + spcBef;
    return marginTopBottomStr;}function getHorizontalAlignV1(node,textBodyNode,idx,type,prg_dir,warpObj){var algn=getTextByPathList(node,["a:pPr","attrs","algn"]);if(algn===undefined){//var layoutMasterNode = getLayoutAndMasterNode(node, idx, type, warpObj);
    // var pPrNodeLaout = layoutMasterNode.nodeLaout;
    // var pPrNodeMaster = layoutMasterNode.nodeMaster;
    var lvlIdx=1;var lvlNode=getTextByPathList(node,["a:pPr","attrs","lvl"]);if(lvlNode!==undefined){lvlIdx=parseInt(lvlNode)+1;}var lvlStr="a:lvl"+lvlIdx+"pPr";var lstStyle=textBodyNode["a:lstStyle"];algn=getTextByPathList(lstStyle,[lvlStr,"attrs","algn"]);if(algn===undefined&&idx!==undefined){//slidelayout
    algn=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);if(algn===undefined){algn=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:p","a:pPr","attrs","algn"]);if(algn===undefined){algn=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:p",lvlIdx-1,"a:pPr","attrs","algn"]);}}}if(algn===undefined){if(type!==undefined){//slidelayout
    algn=getTextByPathList(warpObj,["slideLayoutTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);if(algn===undefined){//masterlayout
    if(type=="title"||type=="ctrTitle"){algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:titleStyle",lvlStr,"attrs","algn"]);}else if(type=="body"||type=="obj"||type=="subTitle"){algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:bodyStyle",lvlStr,"attrs","algn"]);}else if(type=="shape"||type=="diagram"){algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:otherStyle",lvlStr,"attrs","algn"]);}else if(type=="textBox"){algn=getTextByPathList(warpObj,["defaultTextStyle",lvlStr,"attrs","algn"]);}else {algn=getTextByPathList(warpObj,["slideMasterTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);}}}else {algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:bodyStyle",lvlStr,"attrs","algn"]);}}}if(algn===undefined){if(type=="title"||type=="subTitle"||type=="ctrTitle"){return "text-align: center;";}else if(type=="sldNum"){return "text-align: right;";}}if(algn!==undefined){switch(algn){case"l":return "text-align: left;";case"r":return "text-align: right;";case"ctr":return "text-align: center;";case"just":case"dist":default:return "h-"+algn;}}//return algn === "ctr" ? "h-mid" : algn === "r" ? "h-right" : "h-left";
    }function getHorizontalAlign(node,textBodyNode,idx,type,prg_dir,warpObj){var algn=getTextByPathList(node,["a:pPr","attrs","algn"]);if(algn===undefined){//var layoutMasterNode = getLayoutAndMasterNode(node, idx, type, warpObj);
    // var pPrNodeLaout = layoutMasterNode.nodeLaout;
    // var pPrNodeMaster = layoutMasterNode.nodeMaster;
    var lvlIdx=1;var lvlNode=getTextByPathList(node,["a:pPr","attrs","lvl"]);if(lvlNode!==undefined){lvlIdx=parseInt(lvlNode)+1;}var lvlStr="a:lvl"+lvlIdx+"pPr";var lstStyle=textBodyNode["a:lstStyle"];algn=getTextByPathList(lstStyle,[lvlStr,"attrs","algn"]);if(algn===undefined&&idx!==undefined){//slidelayout
    algn=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);if(algn===undefined){algn=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:p","a:pPr","attrs","algn"]);if(algn===undefined){algn=getTextByPathList(warpObj["slideLayoutTables"]["idxTable"][idx],["p:txBody","a:p",lvlIdx-1,"a:pPr","attrs","algn"]);}}}if(algn===undefined){if(type!==undefined){//slidelayout
    algn=getTextByPathList(warpObj,["slideLayoutTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);if(algn===undefined){//masterlayout
    if(type=="title"||type=="ctrTitle"){algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:titleStyle",lvlStr,"attrs","algn"]);}else if(type=="body"||type=="obj"||type=="subTitle"){algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:bodyStyle",lvlStr,"attrs","algn"]);}else if(type=="shape"||type=="diagram"){algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:otherStyle",lvlStr,"attrs","algn"]);}else if(type=="textBox"){algn=getTextByPathList(warpObj,["defaultTextStyle",lvlStr,"attrs","algn"]);}else {algn=getTextByPathList(warpObj,["slideMasterTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);}}}else {algn=getTextByPathList(warpObj,["slideMasterTextStyles","p:bodyStyle",lvlStr,"attrs","algn"]);}}}if(algn===undefined){if(type=="title"||type=="subTitle"||type=="ctrTitle"){return "h-mid";}else if(type=="sldNum"){return "h-right";}}if(algn!==undefined){switch(algn){case"l":if(prg_dir=="pregraph-rtl"){//return "h-right";
    return "h-left-rtl";}else {return "h-left";}case"r":if(prg_dir=="pregraph-rtl"){//return "h-left";
    return "h-right-rtl";}else {return "h-right";}case"ctr":return "h-mid";case"just":case"dist":default:return "h-"+algn;}}//return algn === "ctr" ? "h-mid" : algn === "r" ? "h-right" : "h-left";
    }function getPregraphDir(node,textBodyNode,idx,type,warpObj){var rtl=getTextByPathList(node,["a:pPr","attrs","rtl"]);//console.log("getPregraphDir node:", node, "textBodyNode", textBodyNode, "rtl:", rtl, "idx", idx, "type", type, "warpObj", warpObj)
    if(rtl===undefined){var layoutMasterNode=getLayoutAndMasterNode(node,idx,type,warpObj);var pPrNodeLaout=layoutMasterNode.nodeLaout;var pPrNodeMaster=layoutMasterNode.nodeMaster;rtl=getTextByPathList(pPrNodeLaout,["attrs","rtl"]);if(rtl===undefined&&type!="shape"){rtl=getTextByPathList(pPrNodeMaster,["attrs","rtl"]);}}if(rtl=="1"){return "pregraph-rtl";}else if(rtl=="0"){return "pregraph-ltr";}return "pregraph-inherit";// var contentDir = getContentDir(type, warpObj);
    // console.log("getPregraphDir node:", node["a:r"], "rtl:", rtl, "idx", idx, "type", type, "contentDir:", contentDir)
    // if (contentDir == "content"){
    //     return "pregraph-ltr";
    // } else if (contentDir == "content-rtl"){
    //     return "pregraph-rtl";
    // }
    // return "";
    }function getVerticalAlign(node,slideLayoutSpNode,slideMasterSpNode,type){//X, <a:bodyPr anchor="ctr">, <a:bodyPr anchor="b">
    var anchor=getTextByPathList(node,["p:txBody","a:bodyPr","attrs","anchor"]);//console.log("getVerticalAlign anchor:", anchor, "slideLayoutSpNode: ", slideLayoutSpNode)
    if(anchor===undefined){//console.log("getVerticalAlign type:", type," node:", node, "slideLayoutSpNode:", slideLayoutSpNode, "slideMasterSpNode:", slideMasterSpNode)
    anchor=getTextByPathList(slideLayoutSpNode,["p:txBody","a:bodyPr","attrs","anchor"]);if(anchor===undefined){anchor=getTextByPathList(slideMasterSpNode,["p:txBody","a:bodyPr","attrs","anchor"]);if(anchor===undefined){//"If this attribute is omitted, then a value of t, or top is implied."
    anchor="t";//getTextByPathList(slideMasterSpNode, ["p:txBody", "a:bodyPr", "attrs", "anchor"]);
    }}}//console.log("getVerticalAlign:", node, slideLayoutSpNode, slideMasterSpNode, type, anchor)
    return anchor==="ctr"?"v-mid":anchor==="b"?"v-down":"v-up";}function getContentDir(node,type,warpObj){return "content";}function getFontType(node,type,warpObj,pFontStyle){var typeface=getTextByPathList(node,["a:rPr","a:latin","attrs","typeface"]);if(typeface===undefined){var fontIdx="";var fontGrup="";if(pFontStyle!==undefined){fontIdx=getTextByPathList(pFontStyle,["attrs","idx"]);}var fontSchemeNode=getTextByPathList(warpObj["themeContent"],["a:theme","a:themeElements","a:fontScheme"]);if(fontIdx==""){if(type=="title"||type=="subTitle"||type=="ctrTitle"){fontIdx="major";}else {fontIdx="minor";}}fontGrup="a:"+fontIdx+"Font";typeface=getTextByPathList(fontSchemeNode,[fontGrup,"a:latin","attrs","typeface"]);}return typeface===undefined?"inherit":typeface;}function getFontColorPr(node,pNode,lstStyle,pFontStyle,lvl,idx,type,warpObj){//text border using: text-shadow: -1px 0 black, 0 1px black, 1px 0 black, 0 -1px black;
    //{getFontColor(..) return color} -> getFontColorPr(..) return array[color,textBordr/shadow]
    //https://stackoverflow.com/questions/2570972/css-font-border
    //https://www.w3schools.com/cssref/css3_pr_text-shadow.asp
    //themeContent
    //console.log("getFontColorPr>> type:", type, ", node: ", node)
    var rPrNode=getTextByPathList(node,["a:rPr"]);var filTyp,color,textBordr,colorType="",highlightColor="";//console.log("getFontColorPr type:", type, ", node: ", node, "pNode:", pNode, "pFontStyle:", pFontStyle)
    if(rPrNode!==undefined){filTyp=getFillType(rPrNode);if(filTyp=="SOLID_FILL"){var solidFillNode=rPrNode["a:solidFill"];// getTextByPathList(node, ["a:rPr", "a:solidFill"]);
    color=getSolidFill(solidFillNode,undefined,undefined,warpObj);var highlightNode=rPrNode["a:highlight"];if(highlightNode!==undefined){highlightColor=getSolidFill(highlightNode,undefined,undefined,warpObj);}colorType="solid";}else if(filTyp=="PATTERN_FILL"){var pattFill=rPrNode["a:pattFill"];// getTextByPathList(node, ["a:rPr", "a:pattFill"]);
    color=getPatternFill(pattFill,warpObj);colorType="pattern";}else if(filTyp=="PIC_FILL"){color=getBgPicFill(rPrNode,"slideBg",warpObj,undefined);//color = getPicFill("slideBg", rPrNode["a:blipFill"], warpObj);
    colorType="pic";}else if(filTyp=="GRADIENT_FILL"){var shpFill=rPrNode["a:gradFill"];color=getGradientFill(shpFill,warpObj);colorType="gradient";}}if(color===undefined&&getTextByPathList(lstStyle,["a:lvl"+lvl+"pPr","a:defRPr"])!==undefined){//lstStyle
    var lstStyledefRPr=getTextByPathList(lstStyle,["a:lvl"+lvl+"pPr","a:defRPr"]);filTyp=getFillType(lstStyledefRPr);if(filTyp=="SOLID_FILL"){var solidFillNode=lstStyledefRPr["a:solidFill"];// getTextByPathList(node, ["a:rPr", "a:solidFill"]);
    color=getSolidFill(solidFillNode,undefined,undefined,warpObj);var highlightNode=lstStyledefRPr["a:highlight"];if(highlightNode!==undefined){highlightColor=getSolidFill(highlightNode,undefined,undefined,warpObj);}colorType="solid";}else if(filTyp=="PATTERN_FILL"){var pattFill=lstStyledefRPr["a:pattFill"];// getTextByPathList(node, ["a:rPr", "a:pattFill"]);
    color=getPatternFill(pattFill,warpObj);colorType="pattern";}else if(filTyp=="PIC_FILL"){color=getBgPicFill(lstStyledefRPr,"slideBg",warpObj,undefined);//color = getPicFill("slideBg", rPrNode["a:blipFill"], warpObj);
    colorType="pic";}else if(filTyp=="GRADIENT_FILL"){var shpFill=lstStyledefRPr["a:gradFill"];color=getGradientFill(shpFill,warpObj);colorType="gradient";}}if(color===undefined){var sPstyle=getTextByPathList(pNode,["p:style","a:fontRef"]);if(sPstyle!==undefined){color=getSolidFill(sPstyle,undefined,undefined,warpObj);if(color!==undefined){colorType="solid";}var highlightNode=sPstyle["a:highlight"];//is "a:highlight" node in 'a:fontRef' ?
    if(highlightNode!==undefined){highlightColor=getSolidFill(highlightNode,undefined,undefined,warpObj);}}if(color===undefined){if(pFontStyle!==undefined){color=getSolidFill(pFontStyle,undefined,undefined,warpObj);if(color!==undefined){colorType="solid";}}}}//console.log("getFontColorPr node", node, "colorType: ", colorType,"color: ",color)
    if(color===undefined){var layoutMasterNode=getLayoutAndMasterNode(pNode,idx,type,warpObj);var pPrNodeLaout=layoutMasterNode.nodeLaout;var pPrNodeMaster=layoutMasterNode.nodeMaster;if(pPrNodeLaout!==undefined){var defRpRLaout=getTextByPathList(pPrNodeLaout,["a:defRPr","a:solidFill"]);if(defRpRLaout!==undefined){color=getSolidFill(defRpRLaout,undefined,undefined,warpObj);var highlightNode=getTextByPathList(pPrNodeLaout,["a:defRPr","a:highlight"]);if(highlightNode!==undefined){highlightColor=getSolidFill(highlightNode,undefined,undefined,warpObj);}colorType="solid";}}if(color===undefined){if(pPrNodeMaster!==undefined){var defRprMaster=getTextByPathList(pPrNodeMaster,["a:defRPr","a:solidFill"]);if(defRprMaster!==undefined){color=getSolidFill(defRprMaster,undefined,undefined,warpObj);var highlightNode=getTextByPathList(pPrNodeMaster,["a:defRPr","a:highlight"]);if(highlightNode!==undefined){highlightColor=getSolidFill(highlightNode,undefined,undefined,warpObj);}colorType="solid";}}}}var txtEffects=[];var txtEffObj={};//textBordr
    var txtBrdrNode=getTextByPathList(node,["a:rPr","a:ln"]);var textBordr="";if(txtBrdrNode!==undefined&&txtBrdrNode["a:noFill"]===undefined){var txBrd=getBorder(node,pNode,false,"text",warpObj);var txBrdAry=txBrd.split(" ");//var brdSize = (parseInt(txBrdAry[0].substring(0, txBrdAry[0].indexOf("pt")))) + "px";
    var brdSize=parseInt(txBrdAry[0].substring(0,txBrdAry[0].indexOf("px")))+"px";var brdClr=txBrdAry[2];//var brdTyp = txBrdAry[1]; //not in use
    //console.log("getFontColorPr txBrdAry:", txBrdAry)
    if(colorType=="solid"){textBordr="-"+brdSize+" 0 "+brdClr+", 0 "+brdSize+" "+brdClr+", "+brdSize+" 0 "+brdClr+", 0 -"+brdSize+" "+brdClr;// if (oShadowStr != "") {
    //     textBordr += "," + oShadowStr;
    // } else {
    //     textBordr += ";";
    // }
    txtEffects.push(textBordr);}else {//textBordr = brdSize + " " + brdClr;
    txtEffObj.border=brdSize+" "+brdClr;}}// else {
    //     //if no border but exist/not exist shadow
    //     if (colorType == "solid") {
    //         textBordr = oShadowStr;
    //     } else {
    //         //TODO
    //     }
    // }
    var txtGlowNode=getTextByPathList(node,["a:rPr","a:effectLst","a:glow"]);var oGlowStr="";if(txtGlowNode!==undefined){var glowClr=getSolidFill(txtGlowNode,undefined,undefined,warpObj);var rad=txtGlowNode["attrs"]["rad"]?txtGlowNode["attrs"]["rad"]*slideFactor:0;oGlowStr="0 0 "+rad+"px #"+glowClr+", 0 0 "+rad+"px #"+glowClr+", 0 0 "+rad+"px #"+glowClr+", 0 0 "+rad+"px #"+glowClr+", 0 0 "+rad+"px #"+glowClr+", 0 0 "+rad+"px #"+glowClr+", 0 0 "+rad+"px #"+glowClr;if(colorType=="solid"){txtEffects.push(oGlowStr);}else {// txtEffObj.glow = {
    //     radiuse: rad,
    //     color: glowClr
    // }
    txtEffects.push("drop-shadow(0 0 "+rad/3+"px #"+glowClr+") "+"drop-shadow(0 0 "+rad*2/3+"px #"+glowClr+") "+"drop-shadow(0 0 "+rad+"px #"+glowClr+")");}}var txtShadow=getTextByPathList(node,["a:rPr","a:effectLst","a:outerShdw"]);var oShadowStr="";if(txtShadow!==undefined){//https://developer.mozilla.org/en-US/docs/Web/CSS/filter-function/drop-shadow()
    //https://stackoverflow.com/questions/60468487/css-text-with-linear-gradient-shadow-and-text-outline
    //https://css-tricks.com/creating-playful-effects-with-css-text-shadows/
    //https://designshack.net/articles/css/12-fun-css-text-shadows-you-can-copy-and-paste/
    var shadowClr=getSolidFill(txtShadow,undefined,undefined,warpObj);var outerShdwAttrs=txtShadow["attrs"];// algn: "bl"
    // dir: "2640000"
    // dist: "38100"
    // rotWithShape: "0/1" - Specifies whether the shadow rotates with the shape if the shape is rotated.
    //blurRad (Blur Radius) - Specifies the blur radius of the shadow.
    //kx (Horizontal Skew) - Specifies the horizontal skew angle.
    //ky (Vertical Skew) - Specifies the vertical skew angle.
    //sx (Horizontal Scaling Factor) - Specifies the horizontal scaling slideFactor; negative scaling causes a flip.
    //sy (Vertical Scaling Factor) - Specifies the vertical scaling slideFactor; negative scaling causes a flip.
    outerShdwAttrs["algn"];var dir=outerShdwAttrs["dir"]?parseInt(outerShdwAttrs["dir"])/60000:0;var dist=parseInt(outerShdwAttrs["dist"])*slideFactor;//(px) //* (3 / 4); //(pt)
    outerShdwAttrs["rotWithShape"];var blurRad=outerShdwAttrs["blurRad"]?parseInt(outerShdwAttrs["blurRad"])*slideFactor+"px":"";outerShdwAttrs["sx"]?parseInt(outerShdwAttrs["sx"])/100000:1;outerShdwAttrs["sy"]?parseInt(outerShdwAttrs["sy"])/100000:1;var vx=dist*Math.sin(dir*Math.PI/180);var hx=dist*Math.cos(dir*Math.PI/180);//console.log("getFontColorPr outerShdwAttrs:", outerShdwAttrs, ", shadowClr:", shadowClr, ", algn: ", algn, ",dir: ", dir, ", dist: ", dist, ",rotWithShape: ", rotWithShape, ", color: ", color)
    if(!isNaN(vx)&&!isNaN(hx)){oShadowStr=hx+"px "+vx+"px "+blurRad+" #"+shadowClr;// + ";";
    if(colorType=="solid"){txtEffects.push(oShadowStr);}else {// txtEffObj.oShadow = {
    //     hx: hx,
    //     vx: vx,
    //     radius: blurRad,
    //     color: shadowClr
    // }
    //txtEffObj.oShadow = hx + "px " + vx + "px " + blurRad + " #" + shadowClr;
    txtEffects.push("drop-shadow("+hx+"px "+vx+"px "+blurRad+" #"+shadowClr+")");}}//console.log("getFontColorPr vx:", vx, ", hx: ", hx, ", sx: ", sx, ", sy: ", sy, ",oShadowStr: ", oShadowStr)
    }//console.log("getFontColorPr>>> color:", color)
    // if (color === undefined || color === "FFF") {
    //     color = "#000";
    // } else {
    //     color = "" + color;
    // }
    var text_effcts="",txt_effects;if(colorType=="solid"){if(txtEffects.length>0){text_effcts=txtEffects.join(",");}txt_effects=text_effcts+";";}else {if(txtEffects.length>0){text_effcts=txtEffects.join(" ");}txtEffObj.effcts=text_effcts;txt_effects=txtEffObj;}//console.log("getFontColorPr txt_effects:", txt_effects)
    //return [color, textBordr, colorType];
    return [color,txt_effects,colorType,highlightColor];}function getFontSize(node,textBodyNode,pFontStyle,lvl,type,warpObj){// if(type == "sldNum")
    //console.log("getFontSize node:", node, "lstStyle", lstStyle, "lvl:", lvl, 'type:', type, "warpObj:", warpObj)
    var lstStyle=textBodyNode!==undefined?textBodyNode["a:lstStyle"]:undefined;var lvlpPr="a:lvl"+lvl+"pPr";var fontSize=undefined;var sz,kern;if(node["a:rPr"]!==undefined){fontSize=parseInt(node["a:rPr"]["attrs"]["sz"])/100;}if(isNaN(fontSize)||fontSize===undefined&&node["a:fld"]!==undefined){sz=getTextByPathList(node["a:fld"],["a:rPr","attrs","sz"]);fontSize=parseInt(sz)/100;}if((isNaN(fontSize)||fontSize===undefined)&&node["a:t"]===undefined){sz=getTextByPathList(node["a:endParaRPr"],["attrs","sz"]);fontSize=parseInt(sz)/100;}if((isNaN(fontSize)||fontSize===undefined)&&lstStyle!==undefined){sz=getTextByPathList(lstStyle,[lvlpPr,"a:defRPr","attrs","sz"]);fontSize=parseInt(sz)/100;}//a:spAutoFit
    var isKerning=false;if(textBodyNode!==undefined){var spAutoFitNode=getTextByPathList(textBodyNode,["a:bodyPr","a:spAutoFit"]);// if (spAutoFitNode === undefined) {
    //     spAutoFitNode = getTextByPathList(textBodyNode, ["a:bodyPr", "a:normAutofit"]);
    // }
    if(spAutoFitNode!==undefined){isKerning=true;}}if(isNaN(fontSize)||fontSize===undefined){// if (type == "shape" || type == "textBox") {
    //     type = "body";
    //     lvlpPr = "a:lvl1pPr";
    // }
    sz=getTextByPathList(warpObj["slideLayoutTables"],["typeTable",type,"p:txBody","a:lstStyle",lvlpPr,"a:defRPr","attrs","sz"]);fontSize=parseInt(sz)/100;kern=getTextByPathList(warpObj["slideLayoutTables"],["typeTable",type,"p:txBody","a:lstStyle",lvlpPr,"a:defRPr","attrs","kern"]);if(isKerning&&kern!==undefined&&!isNaN(fontSize)&&fontSize-parseInt(kern)/100>0){fontSize=fontSize-parseInt(kern)/100;}}if(isNaN(fontSize)||fontSize===undefined){// if (type == "shape" || type == "textBox") {
    //     type = "body";
    //     lvlpPr = "a:lvl1pPr";
    // }
    sz=getTextByPathList(warpObj["slideMasterTables"],["typeTable",type,"p:txBody","a:lstStyle",lvlpPr,"a:defRPr","attrs","sz"]);kern=getTextByPathList(warpObj["slideMasterTables"],["typeTable",type,"p:txBody","a:lstStyle",lvlpPr,"a:defRPr","attrs","kern"]);if(sz===undefined){if(type=="title"||type=="subTitle"||type=="ctrTitle"){sz=getTextByPathList(warpObj["slideMasterTextStyles"],["p:titleStyle",lvlpPr,"a:defRPr","attrs","sz"]);kern=getTextByPathList(warpObj["slideMasterTextStyles"],["p:titleStyle",lvlpPr,"a:defRPr","attrs","kern"]);}else if(type=="body"||type=="obj"||type=="dt"||type=="sldNum"||type==="textBox"){sz=getTextByPathList(warpObj["slideMasterTextStyles"],["p:bodyStyle",lvlpPr,"a:defRPr","attrs","sz"]);kern=getTextByPathList(warpObj["slideMasterTextStyles"],["p:bodyStyle",lvlpPr,"a:defRPr","attrs","kern"]);}else if(type=="shape"){//textBox and shape text does not indent
    sz=getTextByPathList(warpObj["slideMasterTextStyles"],["p:otherStyle",lvlpPr,"a:defRPr","attrs","sz"]);kern=getTextByPathList(warpObj["slideMasterTextStyles"],["p:otherStyle",lvlpPr,"a:defRPr","attrs","kern"]);isKerning=false;}if(sz===undefined){sz=getTextByPathList(warpObj["defaultTextStyle"],[lvlpPr,"a:defRPr","attrs","sz"]);kern=kern===undefined?getTextByPathList(warpObj["defaultTextStyle"],[lvlpPr,"a:defRPr","attrs","kern"]):undefined;isKerning=false;}//  else if (type === undefined || type == "shape") {
    //     sz = getTextByPathList(warpObj["slideMasterTextStyles"], ["p:otherStyle", lvlpPr, "a:defRPr", "attrs", "sz"]);
    //     kern = getTextByPathList(warpObj["slideMasterTextStyles"], ["p:otherStyle", lvlpPr, "a:defRPr", "attrs", "kern"]);
    // }
    // else if (type == "textBox") {
    //     sz = getTextByPathList(warpObj["slideMasterTextStyles"], ["p:otherStyle", lvlpPr, "a:defRPr", "attrs", "sz"]);
    //     kern = getTextByPathList(warpObj["slideMasterTextStyles"], ["p:otherStyle", lvlpPr, "a:defRPr", "attrs", "kern"]);
    // }
    }fontSize=parseInt(sz)/100;if(isKerning&&kern!==undefined&&!isNaN(fontSize)&&fontSize-parseInt(kern)/100>parseInt(kern)/100){fontSize=fontSize-parseInt(kern)/100;//fontSize =  parseInt(kern) / 100;
    }}var baseline=getTextByPathList(node,["a:rPr","attrs","baseline"]);if(baseline!==undefined&&!isNaN(fontSize)){var baselineVl=parseInt(baseline)/100000;//fontSize -= 10;
    // fontSize = fontSize * baselineVl;
    fontSize-=baselineVl;}if(!isNaN(fontSize)){var normAutofit=getTextByPathList(textBodyNode,["a:bodyPr","a:normAutofit","attrs","fontScale"]);if(normAutofit!==undefined&&normAutofit!=0){//console.log("fontSize", fontSize, "normAutofit: ", normAutofit, normAutofit/100000)
    fontSize=Math.round(fontSize*(normAutofit/100000));}}if(pptxsize){return isNaN(fontSize)?type=="br"?"initial":"inherit":(fontSize*(pptxsize/slideWidth)).toFixed(0)+"px";// + "pt");
    }return isNaN(fontSize)?type=="br"?"initial":"inherit":fontSize+"px";// + "pt");
    }function getFontBold(node,type,slideMasterTextStyles){return node["a:rPr"]!==undefined&&node["a:rPr"]["attrs"]["b"]==="1"?"bold":"inherit";}function getFontItalic(node,type,slideMasterTextStyles){return node["a:rPr"]!==undefined&&node["a:rPr"]["attrs"]["i"]==="1"?"italic":"inherit";}function getFontDecoration(node,type,slideMasterTextStyles){///////////////////////////////Amir///////////////////////////////
    if(node["a:rPr"]!==undefined){var underLine=node["a:rPr"]["attrs"]["u"]!==undefined?node["a:rPr"]["attrs"]["u"]:"none";var strikethrough=node["a:rPr"]["attrs"]["strike"]!==undefined?node["a:rPr"]["attrs"]["strike"]:"noStrike";//console.log("strikethrough: "+strikethrough);
    if(underLine!="none"&&strikethrough=="noStrike"){return "underline";}else if(underLine=="none"&&strikethrough!="noStrike"){return "line-through";}else if(underLine!="none"&&strikethrough!="noStrike"){return "underline line-through";}else {return "inherit";}}else {return "inherit";}/////////////////////////////////////////////////////////////////
    //return (node["a:rPr"] !== undefined && node["a:rPr"]["attrs"]["u"] === "sng") ? "underline" : "inherit";
    }////////////////////////////////////Amir/////////////////////////////////////
    function getTextHorizontalAlign(node,pNode,type,warpObj){//console.log("getTextHorizontalAlign: type: ", type, ", node: ", node)
    var getAlgn=getTextByPathList(node,["a:pPr","attrs","algn"]);if(getAlgn===undefined){getAlgn=getTextByPathList(pNode,["a:pPr","attrs","algn"]);}if(getAlgn===undefined){if(type=="title"||type=="ctrTitle"||type=="subTitle"){var lvlIdx=1;var lvlNode=getTextByPathList(pNode,["a:pPr","attrs","lvl"]);if(lvlNode!==undefined){lvlIdx=parseInt(lvlNode)+1;}var lvlStr="a:lvl"+lvlIdx+"pPr";getAlgn=getTextByPathList(warpObj,["slideLayoutTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);if(getAlgn===undefined){getAlgn=getTextByPathList(warpObj,["slideMasterTables","typeTable",type,"p:txBody","a:lstStyle",lvlStr,"attrs","algn"]);if(getAlgn===undefined){getAlgn=getTextByPathList(warpObj,["slideMasterTextStyles","p:titleStyle",lvlStr,"attrs","algn"]);if(getAlgn===undefined&&type==="subTitle"){getAlgn=getTextByPathList(warpObj,["slideMasterTextStyles","p:bodyStyle",lvlStr,"attrs","algn"]);}}}}else if(type=="body"){getAlgn=getTextByPathList(warpObj,["slideMasterTextStyles","p:bodyStyle","a:lvl1pPr","attrs","algn"]);}else {getAlgn=getTextByPathList(warpObj,["slideMasterTables","typeTable",type,"p:txBody","a:lstStyle","a:lvl1pPr","attrs","algn"]);}}var align="inherit";if(getAlgn!==undefined){switch(getAlgn){case"l":align="left";break;case"r":align="right";break;case"ctr":align="center";break;case"just":align="justify";break;case"dist":align="justify";break;default:align="inherit";}}return align;}/////////////////////////////////////////////////////////////////////
    function getTextVerticalAlign(node,type,slideMasterTextStyles){var baseline=getTextByPathList(node,["a:rPr","attrs","baseline"]);return baseline===undefined?"baseline":parseInt(baseline)/1000+"%";}function getTableBorders(node,warpObj){var borderStyle="";if(node["a:bottom"]!==undefined){var obj={"p:spPr":{"a:ln":node["a:bottom"]["a:ln"]}};var borders=getBorder(obj,undefined,false,"shape",warpObj);borderStyle+=borders.replace("border","border-bottom");}if(node["a:top"]!==undefined){var obj={"p:spPr":{"a:ln":node["a:top"]["a:ln"]}};var borders=getBorder(obj,undefined,false,"shape",warpObj);borderStyle+=borders.replace("border","border-top");}if(node["a:right"]!==undefined){var obj={"p:spPr":{"a:ln":node["a:right"]["a:ln"]}};var borders=getBorder(obj,undefined,false,"shape",warpObj);borderStyle+=borders.replace("border","border-right");}if(node["a:left"]!==undefined){var obj={"p:spPr":{"a:ln":node["a:left"]["a:ln"]}};var borders=getBorder(obj,undefined,false,"shape",warpObj);borderStyle+=borders.replace("border","border-left");}return borderStyle;}//////////////////////////////////////////////////////////////////
    function getBorder(node,pNode,isSvgMode,bType,warpObj){//console.log("getBorder", node, pNode, isSvgMode, bType)
    var cssText,lineNode;if(bType=="shape"){cssText="border: ";lineNode=node["p:spPr"]["a:ln"];//subNodeTxt = "p:spPr";
    //node["p:style"]["a:lnRef"] =
    }else if(bType=="text"){cssText="";lineNode=node["a:rPr"]["a:ln"];//subNodeTxt = "a:rPr";
    }//var is_noFill = getTextByPathList(node, ["p:spPr", "a:noFill"]);
    var is_noFill=getTextByPathList(lineNode,["a:noFill"]);if(is_noFill!==undefined){return "hidden";}//console.log("lineNode: ", lineNode)
    if(lineNode==undefined){var lnRefNode=getTextByPathList(node,["p:style","a:lnRef"]);if(lnRefNode!==undefined){var lnIdx=getTextByPathList(lnRefNode,["attrs","idx"]);//console.log("lnIdx:", lnIdx, "lnStyleLst:", warpObj["themeContent"]["a:theme"]["a:themeElements"]["a:fmtScheme"]["a:lnStyleLst"]["a:ln"][Number(lnIdx) -1])
    lineNode=warpObj["themeContent"]["a:theme"]["a:themeElements"]["a:fmtScheme"]["a:lnStyleLst"]["a:ln"][Number(lnIdx)-1];}}if(lineNode==undefined){//is table
    cssText="";lineNode=node;}var borderColor;if(lineNode!==undefined){// Border width: 1pt = 12700, default = 0.75pt
    var borderWidth=parseInt(getTextByPathList(lineNode,["attrs","w"]))/12700;if(isNaN(borderWidth)||borderWidth<1){cssText+=4/3+"px ";//"1pt ";
    }else {cssText+=borderWidth+"px ";// + "pt ";
    }// Border type
    var borderType=getTextByPathList(lineNode,["a:prstDash","attrs","val"]);if(borderType===undefined){borderType=getTextByPathList(lineNode,["attrs","cmpd"]);}var strokeDasharray="0";switch(borderType){case"solid":cssText+="solid";strokeDasharray="0";break;case"dash":cssText+="dashed";strokeDasharray="5";break;case"dashDot":cssText+="dashed";strokeDasharray="5, 5, 1, 5";break;case"dot":cssText+="dotted";strokeDasharray="1, 5";break;case"lgDash":cssText+="dashed";strokeDasharray="10, 5";break;case"dbl":cssText+="double";strokeDasharray="0";break;case"lgDashDotDot":cssText+="dashed";strokeDasharray="10, 5, 1, 5, 1, 5";break;case"sysDash":cssText+="dashed";strokeDasharray="5, 2";break;case"sysDashDot":cssText+="dashed";strokeDasharray="5, 2, 1, 5";break;case"sysDashDotDot":cssText+="dashed";strokeDasharray="5, 2, 1, 5, 1, 5";break;case"sysDot":cssText+="dotted";strokeDasharray="2, 5";break;case undefined://console.log(borderType);
    default:cssText+="solid";strokeDasharray="0";}// Border color
    var fillTyp=getFillType(lineNode);//console.log("getBorder:node : fillTyp", fillTyp)
    if(fillTyp=="NO_FILL"){borderColor=isSvgMode?"none":"";//"background-color: initial;";
    }else if(fillTyp=="SOLID_FILL"){borderColor=getSolidFill(lineNode["a:solidFill"],undefined,undefined,warpObj);}else if(fillTyp=="GRADIENT_FILL"){borderColor=getGradientFill(lineNode["a:gradFill"],warpObj);//console.log("shpFill",shpFill,grndColor.color)
    }else if(fillTyp=="PATTERN_FILL"){borderColor=getPatternFill(lineNode["a:pattFill"],warpObj);}}//console.log("getBorder:node : borderColor", borderColor)
    // 2. drawingML namespace
    if(borderColor===undefined){//var schemeClrNode = getTextByPathList(node, ["p:style", "a:lnRef", "a:schemeClr"]);
    // if (schemeClrNode !== undefined) {
    //     var schemeClr = "a:" + getTextByPathList(schemeClrNode, ["attrs", "val"]);
    //     var borderColor = getSchemeColorFromTheme(schemeClr, undefined, undefined);
    // }
    var lnRefNode=getTextByPathList(node,["p:style","a:lnRef"]);//console.log("getBorder: lnRef : ", lnRefNode)
    if(lnRefNode!==undefined){borderColor=getSolidFill(lnRefNode,undefined,undefined,warpObj);}// if (borderColor !== undefined) {
    //     var shade = getTextByPathList(schemeClrNode, ["a:shade", "attrs", "val"]);
    //     if (shade !== undefined) {
    //         shade = parseInt(shade) / 10000;
    //         var color = tinycolor("#" + borderColor);
    //         borderColor = color.darken(shade).toHex8();//.replace("#", "");
    //     }
    // }
    }//console.log("getBorder: borderColor : ", borderColor)
    if(borderColor===undefined){if(isSvgMode){borderColor="none";}else {borderColor="hidden";}}else {borderColor="#"+borderColor;//wrong if not solid fill - TODO
    }cssText+=" "+borderColor+" ";//wrong if not solid fill - TODO
    if(isSvgMode){return {color:borderColor,width:borderWidth,type:borderType,strokeDasharray:strokeDasharray};}else {return cssText+";";}// } else {
    //     if (isSvgMode) {
    //         return { "color": 'none', "width": '0', "type": 'none', "strokeDasharray": '0' };
    //     } else {
    //         return "hidden";
    //     }
    // }
    }function getBackground(warpObj,slideSize,index){//var rslt = "";
    warpObj["slideContent"];var slideLayoutContent=warpObj["slideLayoutContent"];var slideMasterContent=warpObj["slideMasterContent"];var nodesSldLayout=getTextByPathList(slideLayoutContent,["p:sldLayout","p:cSld","p:spTree"]);var nodesSldMaster=getTextByPathList(slideMasterContent,["p:sldMaster","p:cSld","p:spTree"]);// console.log("slideContent : ", slideContent)
    // console.log("slideLayoutContent : ", slideLayoutContent)
    // console.log("slideMasterContent : ", slideMasterContent)
    //console.log("warpObj : ", warpObj)
    var showMasterSp=getTextByPathList(slideLayoutContent,["p:sldLayout","attrs","showMasterSp"]);//console.log("slideLayoutContent : ", slideLayoutContent, ", showMasterSp: ", showMasterSp)
    var bgColor=getSlideBackgroundFill(warpObj);var json=[];var result="<div class='slide-background-"+index+"' style='width:"+slideSize.width+"px; height:"+slideSize.height+"px;"+bgColor+"'>";if(nodesSldLayout!==undefined){for(var nodeKey in nodesSldLayout){if(nodesSldLayout[nodeKey].constructor===Array){for(var i=0;i<nodesSldLayout[nodeKey].length;i++){var ph_type=getTextByPathList(nodesSldLayout[nodeKey][i],["p:nvSpPr","p:nvPr","p:ph","attrs","type"]);// if (ph_type !== undefined && ph_type != "pic") {
    //     node_ph_type_ary.push(ph_type);
    // }
    if(ph_type!="pic"){var ret=processNodesInSlide(nodeKey,nodesSldLayout[nodeKey][i],nodesSldLayout,warpObj,"slideLayoutBg");//slideLayoutBg , slideMasterBg
    if(ret.html)result+=ret.html;if(ret.json)json=json.concat(ret.json);}}}else {var ph_type=getTextByPathList(nodesSldLayout[nodeKey],["p:nvSpPr","p:nvPr","p:ph","attrs","type"]);// if (ph_type !== undefined && ph_type != "pic") {
    //     node_ph_type_ary.push(ph_type);
    // }
    if(ph_type!="pic"){var _ret3=processNodesInSlide(nodeKey,nodesSldLayout[nodeKey],nodesSldLayout,warpObj,"slideLayoutBg");//slideLayoutBg, slideMasterBg
    if(_ret3.html)result+=_ret3.html;if(_ret3.json)json=json.concat(_ret3.json);}}}}if(nodesSldMaster!==undefined&&(showMasterSp=="1"||showMasterSp===undefined)){for(var nodeKey in nodesSldMaster){if(nodesSldMaster[nodeKey].constructor===Array){for(var i=0;i<nodesSldMaster[nodeKey].length;i++){var ph_type=getTextByPathList(nodesSldMaster[nodeKey][i],["p:nvSpPr","p:nvPr","p:ph","attrs","type"]);//if (node_ph_type_ary.indexOf(ph_type) > -1) {
    var _ret4=processNodesInSlide(nodeKey,nodesSldMaster[nodeKey][i],nodesSldMaster,warpObj,"slideMasterBg");//slideLayoutBg , slideMasterBg
    if(_ret4.html)result+=_ret4.html;if(_ret4.json)json=json.concat(_ret4.json);//}
    }}else {var ph_type=getTextByPathList(nodesSldMaster[nodeKey],["p:nvSpPr","p:nvPr","p:ph","attrs","type"]);//if (node_ph_type_ary.indexOf(ph_type) > -1) {
    var _ret5=processNodesInSlide(nodeKey,nodesSldMaster[nodeKey],nodesSldMaster,warpObj,"slideMasterBg");//slideLayoutBg, slideMasterBg
    if(_ret5.html)result+=_ret5.html;if(_ret5.json)json=json.concat(_ret5.json);//}
    }}}return {html:result,json:json};}function getSlideBackgroundFill(warpObj,index){var slideContent=warpObj["slideContent"];var slideLayoutContent=warpObj["slideLayoutContent"];var slideMasterContent=warpObj["slideMasterContent"];//console.log("slideContent: ", slideContent)
    //console.log("slideLayoutContent: ", slideLayoutContent)
    //console.log("slideMasterContent: ", slideMasterContent)
    //getFillType(node)
    var bgPr=getTextByPathList(slideContent,["p:sld","p:cSld","p:bg","p:bgPr"]);var bgRef=getTextByPathList(slideContent,["p:sld","p:cSld","p:bg","p:bgRef"]);//console.log("slideContent >> bgPr: ", bgPr, ", bgRef: ", bgRef)
    var bgcolor;if(bgPr!==undefined){//bgcolor = "background-color: blue;";
    var bgFillTyp=getFillType(bgPr);if(bgFillTyp=="SOLID_FILL"){var sldFill=bgPr["a:solidFill"];var clrMapOvr;var sldClrMapOvr=getTextByPathList(slideContent,["p:sld","p:clrMapOvr","a:overrideClrMapping","attrs"]);if(sldClrMapOvr!==undefined){clrMapOvr=sldClrMapOvr;}else {var sldClrMapOvr=getTextByPathList(slideLayoutContent,["p:sldLayout","p:clrMapOvr","a:overrideClrMapping","attrs"]);if(sldClrMapOvr!==undefined){clrMapOvr=sldClrMapOvr;}else {clrMapOvr=getTextByPathList(slideMasterContent,["p:sldMaster","p:clrMap","attrs"]);}}var sldBgClr=getSolidFill(sldFill,clrMapOvr,undefined,warpObj);//var sldTint = getColorOpacity(sldFill);
    //console.log("bgColor: ", bgColor)
    //bgcolor = "background: rgba(" + hexToRgbNew(bgColor) + "," + sldTint + ");";
    bgcolor="background: #"+sldBgClr+";";}else if(bgFillTyp=="GRADIENT_FILL"){bgcolor=getBgGradientFill(bgPr,undefined,slideMasterContent,warpObj);}else if(bgFillTyp=="PIC_FILL"){//console.log("PIC_FILL - ", bgFillTyp, bgPr, warpObj);
    bgcolor=getBgPicFill(bgPr,"slideBg",warpObj,undefined);}//console.log(slideContent,slideMasterContent,color_ary,tint_ary,rot,bgcolor)
    }else if(bgRef!==undefined){//console.log("slideContent",bgRef)
    var clrMapOvr;var sldClrMapOvr=getTextByPathList(slideContent,["p:sld","p:clrMapOvr","a:overrideClrMapping","attrs"]);if(sldClrMapOvr!==undefined){clrMapOvr=sldClrMapOvr;}else {var sldClrMapOvr=getTextByPathList(slideLayoutContent,["p:sldLayout","p:clrMapOvr","a:overrideClrMapping","attrs"]);if(sldClrMapOvr!==undefined){clrMapOvr=sldClrMapOvr;}else {clrMapOvr=getTextByPathList(slideMasterContent,["p:sldMaster","p:clrMap","attrs"]);}}var phClr=getSolidFill(bgRef,clrMapOvr,undefined,warpObj);// if (bgRef["a:srgbClr"] !== undefined) {
    //     phClr = getTextByPathList(bgRef, ["a:srgbClr", "attrs", "val"]); //#...
    // } else if (bgRef["a:schemeClr"] !== undefined) { //a:schemeClr
    //     var schemeClr = getTextByPathList(bgRef, ["a:schemeClr", "attrs", "val"]);
    //     phClr = getSchemeColorFromTheme("a:" + schemeClr, slideMasterContent, undefined); //#...
    // }
    var idx=Number(bgRef["attrs"]["idx"]);if(idx==0||idx==1000);else if(idx>0&&idx<1000);else if(idx>1000){//bgFillStyleLst  in themeContent
    //themeContent["a:fmtScheme"]["a:bgFillStyleLst"]
    var trueIdx=idx-1000;// themeContent["a:theme"]["a:themeElements"]["a:fmtScheme"]["a:bgFillStyleLst"];
    var bgFillLst=warpObj["themeContent"]["a:theme"]["a:themeElements"]["a:fmtScheme"]["a:bgFillStyleLst"];var sortblAry=[];Object.keys(bgFillLst).forEach(function(key){var bgFillLstTyp=bgFillLst[key];if(key!="attrs"){if(bgFillLstTyp.constructor===Array){for(var i=0;i<bgFillLstTyp.length;i++){var obj={};obj[key]=bgFillLstTyp[i];obj["idex"]=bgFillLstTyp[i]["attrs"]["order"];obj["attrs"]={order:bgFillLstTyp[i]["attrs"]["order"]};sortblAry.push(obj);}}else {var obj={};obj[key]=bgFillLstTyp;obj["idex"]=bgFillLstTyp["attrs"]["order"];obj["attrs"]={order:bgFillLstTyp["attrs"]["order"]};sortblAry.push(obj);}}});var sortByOrder=sortblAry.slice(0);sortByOrder.sort(function(a,b){return a.idex-b.idex;});var bgFillLstIdx=sortByOrder[trueIdx-1];var bgFillTyp=getFillType(bgFillLstIdx);if(bgFillTyp=="SOLID_FILL"){var sldFill=bgFillLstIdx["a:solidFill"];var sldBgClr=getSolidFill(sldFill,clrMapOvr,undefined,warpObj);//var sldTint = getColorOpacity(sldFill);
    //bgcolor = "background: rgba(" + hexToRgbNew(phClr) + "," + sldTint + ");";
    bgcolor="background: #"+sldBgClr+";";//console.log("slideMasterContent - sldFill",sldFill)
    }else if(bgFillTyp=="GRADIENT_FILL"){bgcolor=getBgGradientFill(bgFillLstIdx,phClr,slideMasterContent,warpObj);}else {console.log(bgFillTyp);}}}else {bgPr=getTextByPathList(slideLayoutContent,["p:sldLayout","p:cSld","p:bg","p:bgPr"]);bgRef=getTextByPathList(slideLayoutContent,["p:sldLayout","p:cSld","p:bg","p:bgRef"]);//console.log("slideLayoutContent >> bgPr: ", bgPr, ", bgRef: ", bgRef)
    var clrMapOvr;var sldClrMapOvr=getTextByPathList(slideLayoutContent,["p:sldLayout","p:clrMapOvr","a:overrideClrMapping","attrs"]);if(sldClrMapOvr!==undefined){clrMapOvr=sldClrMapOvr;}else {clrMapOvr=getTextByPathList(slideMasterContent,["p:sldMaster","p:clrMap","attrs"]);}if(bgPr!==undefined){var bgFillTyp=getFillType(bgPr);if(bgFillTyp=="SOLID_FILL"){var sldFill=bgPr["a:solidFill"];var sldBgClr=getSolidFill(sldFill,clrMapOvr,undefined,warpObj);//var sldTint = getColorOpacity(sldFill);
    // bgcolor = "background: rgba(" + hexToRgbNew(bgColor) + "," + sldTint + ");";
    bgcolor="background: #"+sldBgClr+";";}else if(bgFillTyp=="GRADIENT_FILL"){bgcolor=getBgGradientFill(bgPr,undefined,slideMasterContent,warpObj);}else if(bgFillTyp=="PIC_FILL"){bgcolor=getBgPicFill(bgPr,"slideLayoutBg",warpObj,undefined);}//console.log("slideLayoutContent",bgcolor)
    }else if(bgRef!==undefined){console.log("slideLayoutContent: bgRef",bgRef);//bgcolor = "background: white;";
    var phClr=getSolidFill(bgRef,clrMapOvr,undefined,warpObj);var idx=Number(bgRef["attrs"]["idx"]);//console.log("phClr=", phClr, "idx=", idx)
    if(idx==0||idx==1000);else if(idx>0&&idx<1000);else if(idx>1000){//bgFillStyleLst  in themeContent
    //themeContent["a:fmtScheme"]["a:bgFillStyleLst"]
    var trueIdx=idx-1000;var bgFillLst=warpObj["themeContent"]["a:theme"]["a:themeElements"]["a:fmtScheme"]["a:bgFillStyleLst"];var sortblAry=[];Object.keys(bgFillLst).forEach(function(key){//console.log("cubicBezTo[" + key + "]:");
    var bgFillLstTyp=bgFillLst[key];if(key!="attrs"){if(bgFillLstTyp.constructor===Array){for(var i=0;i<bgFillLstTyp.length;i++){var obj={};obj[key]=bgFillLstTyp[i];obj["idex"]=bgFillLstTyp[i]["attrs"]["order"];obj["attrs"]={order:bgFillLstTyp[i]["attrs"]["order"]};sortblAry.push(obj);}}else {var obj={};obj[key]=bgFillLstTyp;obj["idex"]=bgFillLstTyp["attrs"]["order"];obj["attrs"]={order:bgFillLstTyp["attrs"]["order"]};sortblAry.push(obj);}}});var sortByOrder=sortblAry.slice(0);sortByOrder.sort(function(a,b){return a.idex-b.idex;});var bgFillLstIdx=sortByOrder[trueIdx-1];var bgFillTyp=getFillType(bgFillLstIdx);if(bgFillTyp=="SOLID_FILL"){var sldFill=bgFillLstIdx["a:solidFill"];//console.log("sldFill: ", sldFill)
    //var sldTint = getColorOpacity(sldFill);
    //bgcolor = "background: rgba(" + hexToRgbNew(phClr) + "," + sldTint + ");";
    var sldBgClr=getSolidFill(sldFill,clrMapOvr,phClr,warpObj);//console.log("bgcolor: ", bgcolor)
    bgcolor="background: #"+sldBgClr+";";}else if(bgFillTyp=="GRADIENT_FILL"){//console.log("GRADIENT_FILL: ", bgFillLstIdx, phClr)
    bgcolor=getBgGradientFill(bgFillLstIdx,phClr,slideMasterContent,warpObj);}else if(bgFillTyp=="PIC_FILL"){//theme rels
    //console.log("PIC_FILL - ", bgFillTyp, bgFillLstIdx, bgFillLst, warpObj);
    bgcolor=getBgPicFill(bgFillLstIdx,"themeBg",warpObj,phClr);}else {console.log(bgFillTyp);}}}else {bgPr=getTextByPathList(slideMasterContent,["p:sldMaster","p:cSld","p:bg","p:bgPr"]);bgRef=getTextByPathList(slideMasterContent,["p:sldMaster","p:cSld","p:bg","p:bgRef"]);var clrMap=getTextByPathList(slideMasterContent,["p:sldMaster","p:clrMap","attrs"]);//console.log("slideMasterContent >> bgPr: ", bgPr, ", bgRef: ", bgRef)
    if(bgPr!==undefined){var bgFillTyp=getFillType(bgPr);if(bgFillTyp=="SOLID_FILL"){var sldFill=bgPr["a:solidFill"];var sldBgClr=getSolidFill(sldFill,clrMap,undefined,warpObj);// var sldTint = getColorOpacity(sldFill);
    // bgcolor = "background: rgba(" + hexToRgbNew(bgColor) + "," + sldTint + ");";
    bgcolor="background: #"+sldBgClr+";";}else if(bgFillTyp=="GRADIENT_FILL"){bgcolor=getBgGradientFill(bgPr,undefined,slideMasterContent,warpObj);}else if(bgFillTyp=="PIC_FILL"){bgcolor=getBgPicFill(bgPr,"slideMasterBg",warpObj,undefined);}}else if(bgRef!==undefined){//var obj={
    //    "a:solidFill": bgRef
    //}
    var phClr=getSolidFill(bgRef,clrMap,undefined,warpObj);// var phClr;
    // if (bgRef["a:srgbClr"] !== undefined) {
    //     phClr = getTextByPathList(bgRef, ["a:srgbClr", "attrs", "val"]); //#...
    // } else if (bgRef["a:schemeClr"] !== undefined) { //a:schemeClr
    //     var schemeClr = getTextByPathList(bgRef, ["a:schemeClr", "attrs", "val"]);
    //     phClr = getSchemeColorFromTheme("a:" + schemeClr, slideMasterContent, undefined); //#...
    // }
    var idx=Number(bgRef["attrs"]["idx"]);//console.log("phClr=", phClr, "idx=", idx)
    if(idx==0||idx==1000);else if(idx>0&&idx<1000);else if(idx>1000){//bgFillStyleLst  in themeContent
    //themeContent["a:fmtScheme"]["a:bgFillStyleLst"]
    var trueIdx=idx-1000;var bgFillLst=warpObj["themeContent"]["a:theme"]["a:themeElements"]["a:fmtScheme"]["a:bgFillStyleLst"];var sortblAry=[];Object.keys(bgFillLst).forEach(function(key){//console.log("cubicBezTo[" + key + "]:");
    var bgFillLstTyp=bgFillLst[key];if(key!="attrs"){if(bgFillLstTyp.constructor===Array){for(var i=0;i<bgFillLstTyp.length;i++){var obj={};obj[key]=bgFillLstTyp[i];obj["idex"]=bgFillLstTyp[i]["attrs"]["order"];obj["attrs"]={order:bgFillLstTyp[i]["attrs"]["order"]};sortblAry.push(obj);}}else {var obj={};obj[key]=bgFillLstTyp;obj["idex"]=bgFillLstTyp["attrs"]["order"];obj["attrs"]={order:bgFillLstTyp["attrs"]["order"]};sortblAry.push(obj);}}});var sortByOrder=sortblAry.slice(0);sortByOrder.sort(function(a,b){return a.idex-b.idex;});var bgFillLstIdx=sortByOrder[trueIdx-1];var bgFillTyp=getFillType(bgFillLstIdx);//console.log("bgFillLstIdx: ", bgFillLstIdx, ", bgFillTyp: ", bgFillTyp, ", phClr: ", phClr);
    if(bgFillTyp=="SOLID_FILL"){var sldFill=bgFillLstIdx["a:solidFill"];//console.log("sldFill: ", sldFill)
    //var sldTint = getColorOpacity(sldFill);
    //bgcolor = "background: rgba(" + hexToRgbNew(phClr) + "," + sldTint + ");";
    var sldBgClr=getSolidFill(sldFill,clrMap,phClr,warpObj);//console.log("bgcolor: ", bgcolor)
    bgcolor="background: #"+sldBgClr+";";}else if(bgFillTyp=="GRADIENT_FILL"){//console.log("GRADIENT_FILL: ", bgFillLstIdx, phClr)
    bgcolor=getBgGradientFill(bgFillLstIdx,phClr,slideMasterContent,warpObj);}else if(bgFillTyp=="PIC_FILL"){//theme rels
    // console.log("PIC_FILL - ", bgFillTyp, bgFillLstIdx, bgFillLst, warpObj);
    bgcolor=getBgPicFill(bgFillLstIdx,"themeBg",warpObj,phClr);}else {console.log(bgFillTyp);}}}}}//console.log("bgcolor: ", bgcolor)
    return bgcolor;}function getBgGradientFill(bgPr,phClr,slideMasterContent,warpObj){var bgcolor="";if(bgPr!==undefined){var grdFill=bgPr["a:gradFill"];var gsLst=grdFill["a:gsLst"]["a:gs"];//var startColorNode, endColorNode;
    var color_ary=[];var pos_ary=[];//var tint_ary = [];
    for(var i=0;i<gsLst.length;i++){var lo_color="";var lo_color=getSolidFill(gsLst[i],slideMasterContent["p:sldMaster"]["p:clrMap"]["attrs"],phClr,warpObj);var pos=getTextByPathList(gsLst[i],["attrs","pos"]);//console.log("pos: ", pos)
    if(pos!==undefined){pos_ary[i]=pos/1000+"%";}else {pos_ary[i]="";}//console.log("lo_color", lo_color)
    color_ary[i]="#"+lo_color;//tint_ary[i] = (lo_tint !== undefined) ? parseInt(lo_tint) / 100000 : 1;
    }//get rot
    var lin=grdFill["a:lin"];var rot=90;if(lin!==undefined){rot=angleToDegrees(lin["attrs"]["ang"]);// + 270;
    //console.log("rot: ", rot)
    rot=rot+90;}bgcolor="background: linear-gradient("+rot+"deg,";for(var i=0;i<gsLst.length;i++){if(i==gsLst.length-1){//if (phClr === undefined) {
    //bgcolor += "rgba(" + hexToRgbNew(color_ary[i]) + "," + tint_ary[i] + ")" + ");";
    bgcolor+=color_ary[i]+" "+pos_ary[i]+");";//} else {
    //bgcolor += "rgba(" + hexToRgbNew(phClr) + "," + tint_ary[i] + ")" + ");";
    // bgcolor += "" + phClr + ";";;
    //}
    }else {//if (phClr === undefined) {
    //bgcolor += "rgba(" + hexToRgbNew(color_ary[i]) + "," + tint_ary[i] + ")" + ", ";
    bgcolor+=color_ary[i]+" "+pos_ary[i]+", ";//} else {
    //bgcolor += "rgba(" + hexToRgbNew(phClr) + "," + tint_ary[i] + ")" + ", ";
    // bgcolor += phClr + ", ";
    //}
    }}}else {if(phClr!==undefined){//bgcolor = "rgba(" + hexToRgbNew(phClr) + ",0);";
    //bgcolor = phClr + ");";
    bgcolor="background: #"+phClr+";";}}return bgcolor;}function getBgPicFill(bgPr,sorce,warpObj,phClr,index){//console.log("getBgPicFill bgPr", bgPr)
    var bgcolor;var picFillBase64=getPicFill(sorce,bgPr["a:blipFill"],warpObj);var ordr=bgPr["attrs"]["order"];var aBlipNode=bgPr["a:blipFill"]["a:blip"];//a:duotone
    var duotone=getTextByPathList(aBlipNode,["a:duotone"]);if(duotone!==undefined){//console.log("pic duotone: ", duotone)
    var clr_ary=[];// duotone.forEach(function (clr) {
    //     console.log("pic duotone clr: ", clr)
    // })
    Object.keys(duotone).forEach(function(clr_type){//console.log("pic duotone clr: clr_type: ", clr_type, duotone[clr_type])
    if(clr_type!="attrs"){var obj={};obj[clr_type]=duotone[clr_type];clr_ary.push(getSolidFill(obj,undefined,phClr,warpObj));}// Object.keys(duotone[clr_type]).forEach(function (clr) {
    //     if (clr != "order") {
    //         var obj = {};
    //         obj[clr_type] = duotone[clr_type][clr];
    //         clr_ary.push(getSolidFill(obj, undefined, phClr, warpObj));
    //     }
    // })
    });//console.log("pic duotone clr_ary: ", clr_ary);
    //filter: url(file.svg#filter-element-id)
    //https://codepen.io/bhenbe/pen/QEZOvd
    //https://www.w3schools.com/cssref/css3_pr_filter.asp
    // var color1 = clr_ary[0];
    // var color2 = clr_ary[1];
    // var cssName = "";
    // var styleText_before_after = "content: '';" +
    //     "display: block;" +
    //     "width: 100%;" +
    //     "height: 100%;" +
    //     // "z-index: 1;" +
    //     "position: absolute;" +
    //     "top: 0;" +
    //     "left: 0;";
    // var cssName = "slide-background-" + index + "::before," + " .slide-background-" + index + "::after";
    // styleTable[styleText_before_after] = {
    //     "name": cssName,
    //     "text": styleText_before_after
    // };
    // var styleText_after = "background-color: #" + clr_ary[1] + ";" +
    //     "mix-blend-mode: darken;";
    // cssName = "slide-background-" + index + "::after";
    // styleTable[styleText_after] = {
    //     "name": cssName,
    //     "text": styleText_after
    // };
    // var styleText_before = "background-color: #" + clr_ary[0] + ";" +
    //     "mix-blend-mode: lighten;";
    // cssName = "slide-background-" + index + "::before";
    // styleTable[styleText_before] = {
    //     "name": cssName,
    //     "text": styleText_before
    // };
    }//a:alphaModFix
    var aphaModFixNode=getTextByPathList(aBlipNode,["a:alphaModFix","attrs"]);var imgOpacity="";if(aphaModFixNode!==undefined&&aphaModFixNode["amt"]!==undefined&&aphaModFixNode["amt"]!=""){var amt=parseInt(aphaModFixNode["amt"])/100000;//var opacity = amt;
    imgOpacity="opacity:"+amt+";";}//a:tile
    var tileNode=getTextByPathList(bgPr,["a:blipFill","a:tile","attrs"]);var prop_style="";if(tileNode!==undefined&&tileNode["sx"]!==undefined){parseInt(tileNode["sx"])/100000;parseInt(tileNode["sy"])/100000;parseInt(tileNode["tx"])/100000;parseInt(tileNode["ty"])/100000;tileNode["algn"];//tl(top left),t(top), tr(top right), l(left), ctr(center), r(right), bl(bottom left), b(bottm) , br(bottom right)
    tileNode["flip"];//none,x,y ,xy
    prop_style+="background-repeat: round;";//repeat|repeat-x|repeat-y|no-repeat|space|round|initial|inherit;
    //prop_style += "background-size: 300px 100px;"; size (w,h,sx, sy) -TODO
    //prop_style += "background-position: 50% 40%;"; //offset (tx, ty) -TODO
    }//a:srcRect
    //a:stretch => a:fillRect =>attrs (l:-17000, r:-17000)
    var stretch=getTextByPathList(bgPr,["a:blipFill","a:stretch"]);if(stretch!==undefined){var fillRect=getTextByPathList(stretch,["a:fillRect","attrs"]);//console.log("getBgPicFill=>bgPr: ", bgPr)
    // var top = fillRect["t"], right = fillRect["r"], bottom = fillRect["b"], left = fillRect["l"];
    prop_style+="background-repeat: no-repeat;";prop_style+="background-position: center;";if(fillRect!==undefined){//prop_style += "background-size: contain, cover;";
    prop_style+="background-size:  100% 100%;;";}}bgcolor="background: url("+picFillBase64+");  z-index: "+ordr+";"+prop_style+imgOpacity;return bgcolor;}// function hexToRgbNew(hex) {
    //     var arrBuff = new ArrayBuffer(4);
    //     var vw = new DataView(arrBuff);
    //     vw.setUint32(0, parseInt(hex, 16), false);
    //     var arrByte = new Uint8Array(arrBuff);
    //     return arrByte[1] + "," + arrByte[2] + "," + arrByte[3];
    // }
    function getShapeFill(node,pNode,isSvgMode,warpObj,source){// 1. presentationML
    // p:spPr/ [a:noFill, solidFill, gradFill, blipFill, pattFill, grpFill]
    // From slide
    //Fill Type:
    //console.log("getShapeFill ShapeFill: ", node, ", isSvgMode; ", isSvgMode)
    var fillType=getFillType(getTextByPathList(node,["p:spPr"]));//var noFill = getTextByPathList(node, ["p:spPr", "a:noFill"]);
    var fillColor;if(fillType=="NO_FILL"){return isSvgMode?"none":"";//"background-color: initial;";
    }else if(fillType=="SOLID_FILL"){var shpFill=node["p:spPr"]["a:solidFill"];fillColor=getSolidFill(shpFill,undefined,undefined,warpObj);}else if(fillType=="GRADIENT_FILL"){var shpFill=node["p:spPr"]["a:gradFill"];fillColor=getGradientFill(shpFill,warpObj);//console.log("shpFill",shpFill,grndColor.color)
    }else if(fillType=="PATTERN_FILL"){var shpFill=node["p:spPr"]["a:pattFill"];fillColor=getPatternFill(shpFill,warpObj);}else if(fillType=="PIC_FILL"){var shpFill=node["p:spPr"]["a:blipFill"];fillColor=getPicFill(source,shpFill,warpObj);}//console.log("getShapeFill ShapeFill: ", node, ", isSvgMode; ", isSvgMode, ", fillType: ", fillType, ", fillColor: ", fillColor, ", source: ", source)
    // 2. drawingML namespace
    if(fillColor===undefined){var clrName=getTextByPathList(node,["p:style","a:fillRef"]);var idx=parseInt(getTextByPathList(node,["p:style","a:fillRef","attrs","idx"]));if(idx==0||idx==1000){//no fill
    return isSvgMode?"none":"";}fillColor=getSolidFill(clrName,undefined,undefined,warpObj);}// 3. is group fill
    if(fillColor===undefined){var grpFill=getTextByPathList(node,["p:spPr","a:grpFill"]);if(grpFill!==undefined){//fillColor = getSolidFill(clrName, undefined, undefined, undefined, warpObj);
    //get parent fill style - TODO
    //console.log("ShapeFill: grpFill: ", grpFill, ", pNode: ", pNode)
    var grpShpFill=pNode["p:grpSpPr"];var spShpNode={"p:spPr":grpShpFill};return getShapeFill(spShpNode,node,isSvgMode,warpObj,source);}else if(fillType=="NO_FILL"){return isSvgMode?"none":"";}}//console.log("ShapeFill: fillColor: ", fillColor, ", fillType; ", fillType)
    if(fillColor!==undefined){if(fillType=="GRADIENT_FILL"){if(isSvgMode){// console.log("GRADIENT_FILL color", fillColor.color[0])
    return fillColor;}else {var colorAry=fillColor.color;var rot=fillColor.rot;var bgcolor="background: linear-gradient("+rot+"deg,";for(var i=0;i<colorAry.length;i++){if(i==colorAry.length-1){bgcolor+="#"+colorAry[i]+");";}else {bgcolor+="#"+colorAry[i]+", ";}}return bgcolor;}}else if(fillType=="PIC_FILL"){if(isSvgMode){return fillColor;}else {return "background-image:url("+fillColor+");";}}else if(fillType=="PATTERN_FILL"){/////////////////////////////////////////////////////////////Need to check -----------TODO
    // if (isSvgMode) {
    //     var color = tinycolor(fillColor);
    //     fillColor = color.toRgbString();
    //     return fillColor;
    // } else {
    var bgPtrn="",bgSize="",bgPos="";bgPtrn=fillColor[0];if(fillColor[1]!==null&&fillColor[1]!==undefined&&fillColor[1]!=""){bgSize=" background-size:"+fillColor[1]+";";}if(fillColor[2]!==null&&fillColor[2]!==undefined&&fillColor[2]!=""){bgPos=" background-position:"+fillColor[2]+";";}return "background: "+bgPtrn+";"+bgSize+bgPos;//}
    }else {if(isSvgMode){var color=tinycolor(fillColor);fillColor=color.toRgbString();return fillColor;}else {//console.log(node,"fillColor: ",fillColor,"fillType: ",fillType,"isSvgMode: ",isSvgMode)
    return "background-color: #"+fillColor+";";}}}else {if(isSvgMode){return "none";}else {return "background-color: inherit;";}}}///////////////////////Amir//////////////////////////////
    function getFillType(node){//Need to test/////////////////////////////////////////////
    //SOLID_FILL
    //PIC_FILL
    //GRADIENT_FILL
    //PATTERN_FILL
    //NO_FILL
    var fillType="";if(node["a:noFill"]!==undefined){fillType="NO_FILL";}if(node["a:solidFill"]!==undefined){fillType="SOLID_FILL";}if(node["a:gradFill"]!==undefined){fillType="GRADIENT_FILL";}if(node["a:pattFill"]!==undefined){fillType="PATTERN_FILL";}if(node["a:blipFill"]!==undefined){fillType="PIC_FILL";}if(node["a:grpFill"]!==undefined){fillType="GROUP_FILL";}return fillType;}function getGradientFill(node,warpObj){//console.log("getGradientFill: node", node)
    var gsLst=node["a:gsLst"]["a:gs"];//get start color
    var color_ary=[];for(var i=0;i<gsLst.length;i++){var lo_color=getSolidFill(gsLst[i],undefined,undefined,warpObj);//console.log("lo_color",lo_color)
    color_ary[i]=lo_color;}//get rot
    var lin=node["a:lin"];var rot=0;if(lin!==undefined){rot=angleToDegrees(lin["attrs"]["ang"])+90;}return {color:color_ary,rot:rot};}function getPicFill(type,node,warpObj){//Need to test/////////////////////////////////////////////
    //rId
    //TODO - Image Properties - Tile, Stretch, or Display Portion of Image
    //(http://officeopenxml.com/drwPic-tile.php)
    var img;var rId=node["a:blip"]["attrs"]["r:embed"];var imgPath;//console.log("getPicFill(...) rId: ", rId, ", warpObj: ", warpObj, ", type: ", type)
    if(type=="slideBg"||type=="slide"){imgPath=getTextByPathList(warpObj,["slideResObj",rId,"target"]);}else if(type=="slideLayoutBg"){imgPath=getTextByPathList(warpObj,["layoutResObj",rId,"target"]);}else if(type=="slideMasterBg"){imgPath=getTextByPathList(warpObj,["masterResObj",rId,"target"]);}else if(type=="themeBg"){imgPath=getTextByPathList(warpObj,["themeResObj",rId,"target"]);}else if(type=="diagramBg"){imgPath=getTextByPathList(warpObj,["diagramResObj",rId,"target"]);}if(imgPath===undefined){return undefined;}img=getTextByPathList(warpObj,["loaded-images",imgPath]);//, type, rId
    if(img===undefined){imgPath=escapeHtml(imgPath);var imgExt=imgPath.split(".").pop();if(imgExt=="xml"){return undefined;}var imgArrayBuffer=warpObj["zip"].file(imgPath).asArrayBuffer();var imgMimeType=getMimeType(imgExt);img="data:"+imgMimeType+";base64,"+base64ArrayBuffer(imgArrayBuffer);// warpObj["loaded-images"][imgPath] = img; //"defaultTextStyle": defaultTextStyle,
    setTextByPathList(warpObj,["loaded-images",imgPath],img);//, type, rId
    }return img;}function getPatternFill(node,warpObj){//https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Images/Using_CSS_gradients
    //https://cssgradient.io/blog/css-gradient-text/
    //https://css-tricks.com/background-patterns-simplified-by-conic-gradients/
    //https://stackoverflow.com/questions/6705250/how-to-get-a-pattern-into-a-written-text-via-css
    //https://stackoverflow.com/questions/14072142/striped-text-in-css
    //https://css-tricks.com/stripes-css/
    //https://yuanchuan.dev/gradient-shapes/
    var fgColor="",bgColor="",prst="";var bgClr=node["a:bgClr"];var fgClr=node["a:fgClr"];prst=node["attrs"]["prst"];fgColor=getSolidFill(fgClr,undefined,undefined,warpObj);bgColor=getSolidFill(bgClr,undefined,undefined,warpObj);//var angl_ary = getAnglefromParst(prst);
    //var ptrClr = "repeating-linear-gradient(" + angl + "deg,  #" + bgColor + ",#" + fgColor + " 2px);"
    //linear-gradient(0deg, black 10 %, transparent 10 %, transparent 90 %, black 90 %, black),
    //linear-gradient(90deg, black 10 %, transparent 10 %, transparent 90 %, black 90 %, black);
    var linear_gradient=getLinerGrandient(prst,bgColor,fgColor);//console.log("getPatternFill: node:", node, ", prst: ", prst, ", fgColor: ", fgColor, ", bgColor:", bgColor, ', linear_gradient: ', linear_gradient)
    return linear_gradient;}function getLinerGrandient(prst,bgColor,fgColor){// dashDnDiag (Dashed Downward Diagonal)-V
    // dashHorz (Dashed Horizontal)-V
    // dashUpDiag(Dashed Upward DIagonal)-V
    // dashVert(Dashed Vertical)-V
    // diagBrick(Diagonal Brick)-V
    // divot(Divot)-VX
    // dkDnDiag(Dark Downward Diagonal)-V
    // dkHorz(Dark Horizontal)-V
    // dkUpDiag(Dark Upward Diagonal)-V
    // dkVert(Dark Vertical)-V
    // dotDmnd(Dotted Diamond)-VX
    // dotGrid(Dotted Grid)-V
    // horzBrick(Horizontal Brick)-V
    // lgCheck(Large Checker Board)-V
    // lgConfetti(Large Confetti)-V
    // lgGrid(Large Grid)-V
    // ltDnDiag(Light Downward Diagonal)-V
    // ltHorz(Light Horizontal)-V
    // ltUpDiag(Light Upward Diagonal)-V
    // ltVert(Light Vertical)-V
    // narHorz(Narrow Horizontal)-V
    // narVert(Narrow Vertical)-V
    // openDmnd(Open Diamond)-V
    // pct10(10 %)-V
    // pct20(20 %)-V
    // pct25(25 %)-V
    // pct30(30 %)-V
    // pct40(40 %)-V
    // pct5(5 %)-V
    // pct50(50 %)-V
    // pct60(60 %)-V
    // pct70(70 %)-V
    // pct75(75 %)-V
    // pct80(80 %)-V
    // pct90(90 %)-V
    // smCheck(Small Checker Board) -V
    // smConfetti(Small Confetti)-V
    // smGrid(Small Grid) -V
    // solidDmnd(Solid Diamond)-V
    // sphere(Sphere)-V
    // trellis(Trellis)-VX
    // wave(Wave)-V
    // wdDnDiag(Wide Downward Diagonal)-V
    // wdUpDiag(Wide Upward Diagonal)-V
    // weave(Weave)-V
    // zigZag(Zig Zag)-V
    // shingle(Shingle)-V
    // plaid(Plaid)-V
    // cross (Cross)
    // diagCross(Diagonal Cross)
    // dnDiag(Downward Diagonal)
    // horz(Horizontal)
    // upDiag(Upward Diagonal)
    // vert(Vertical)
    switch(prst){case"smGrid":return ["linear-gradient(to right,  #"+fgColor+" -1px, transparent 1px ), "+"linear-gradient(to bottom,  #"+fgColor+" -1px, transparent 1px)  #"+bgColor+";","4px 4px"];case"dotGrid":return ["linear-gradient(to right,  #"+fgColor+" -1px, transparent 1px ), "+"linear-gradient(to bottom,  #"+fgColor+" -1px, transparent 1px)  #"+bgColor+";","8px 8px"];case"lgGrid":return ["linear-gradient(to right,  #"+fgColor+" -1px, transparent 1.5px ), "+"linear-gradient(to bottom,  #"+fgColor+" -1px, transparent 1.5px)  #"+bgColor+";","8px 8px"];case"wdUpDiag"://return ["repeating-linear-gradient(-45deg,  #" + bgColor + ", #" + bgColor + " 1px,#" + fgColor + " 5px);"];
    return ["repeating-linear-gradient(-45deg, transparent 1px , transparent 4px, #"+fgColor+" 7px)"+"#"+bgColor+";"];// return ["linear-gradient(45deg, transparent 0%, transparent calc(50% - 1px),  #" + fgColor + " 50%, transparent calc(50% + 1px),  transparent 100%) " +
    case"dkUpDiag":return ["repeating-linear-gradient(-45deg, transparent 1px , #"+bgColor+" 5px)"+"#"+fgColor+";"];case"ltUpDiag":return ["repeating-linear-gradient(-45deg, transparent 1px , transparent 2px, #"+fgColor+" 4px)"+"#"+bgColor+";"];case"wdDnDiag":return ["repeating-linear-gradient(45deg, transparent 1px , transparent 4px, #"+fgColor+" 7px)"+"#"+bgColor+";"];case"dkDnDiag":return ["repeating-linear-gradient(45deg, transparent 1px , #"+bgColor+" 5px)"+"#"+fgColor+";"];case"ltDnDiag":return ["repeating-linear-gradient(45deg, transparent 1px , transparent 2px, #"+fgColor+" 4px)"+"#"+bgColor+";"];case"dkHorz":return ["repeating-linear-gradient(0deg, transparent 1px , transparent 2px, #"+bgColor+" 7px)"+"#"+fgColor+";"];case"ltHorz":return ["repeating-linear-gradient(0deg, transparent 1px , transparent 5px, #"+fgColor+" 7px)"+"#"+bgColor+";"];case"narHorz":return ["repeating-linear-gradient(0deg, transparent 1px , transparent 2px, #"+fgColor+" 4px)"+"#"+bgColor+";"];case"dkVert":return ["repeating-linear-gradient(90deg, transparent 1px , transparent 2px, #"+bgColor+" 7px)"+"#"+fgColor+";"];case"ltVert":return ["repeating-linear-gradient(90deg, transparent 1px , transparent 5px, #"+fgColor+" 7px)"+"#"+bgColor+";"];case"narVert":return ["repeating-linear-gradient(90deg, transparent 1px , transparent 2px, #"+fgColor+" 4px)"+"#"+bgColor+";"];case"lgCheck":case"smCheck":var size="";var pos="";if(prst=="lgCheck"){size="8px 8px";pos="0 0, 4px 4px, 4px 4px, 8px 8px";}else {size="4px 4px";pos="0 0, 2px 2px, 2px 2px, 4px 4px";}return ["linear-gradient(45deg,  #"+fgColor+" 25%, transparent 0, transparent 75%,  #"+fgColor+" 0), "+"linear-gradient(45deg,  #"+fgColor+" 25%, transparent 0, transparent 75%,  #"+fgColor+" 0) "+"#"+bgColor+";",size,pos];//     return ["linear-gradient(45deg, transparent 0%, transparent calc(50% - 0.5px),  #" + fgColor + " 50%, transparent calc(50% + 0.5px),  transparent 100%), " +
    //         "linear-gradient(-45deg, transparent 0%, transparent calc(50% - 0.5px) , #" + fgColor + " 50%, transparent calc(50% + 0.5px),  transparent 100%)  " +
    //         "#" + bgColor + ";", "4px 4px"];
    //     break
    case"dashUpDiag":return ["repeating-linear-gradient(152deg, #"+fgColor+", #"+fgColor+" 5% , transparent 0, transparent 70%)"+"#"+bgColor+";","4px 4px"];case"dashDnDiag":return ["repeating-linear-gradient(45deg, #"+fgColor+", #"+fgColor+" 5% , transparent 0, transparent 70%)"+"#"+bgColor+";","4px 4px"];case"diagBrick":return ["linear-gradient(45deg, transparent 15%,  #"+fgColor+" 30%, transparent 30%), "+"linear-gradient(-45deg, transparent 15%,  #"+fgColor+" 30%, transparent 30%), "+"linear-gradient(-45deg, transparent 65%,  #"+fgColor+" 80%, transparent 0) "+"#"+bgColor+";","4px 4px"];case"horzBrick":return ["linear-gradient(335deg, #"+bgColor+" 1.6px, transparent 1.6px), "+"linear-gradient(155deg, #"+bgColor+" 1.6px, transparent 1.6px), "+"linear-gradient(335deg, #"+bgColor+" 1.6px, transparent 1.6px), "+"linear-gradient(155deg, #"+bgColor+" 1.6px, transparent 1.6px) "+"#"+fgColor+";","4px 4px","0 0.15px, 0.3px 2.5px, 2px 2.15px, 2.35px 0.4px"];case"dashVert":return ["linear-gradient(0deg,  #"+bgColor+" 30%, transparent 30%),"+"linear-gradient(90deg,transparent, transparent 40%, #"+fgColor+" 40%, #"+fgColor+" 60% , transparent 60%)"+"#"+bgColor+";","4px 4px"];case"dashHorz":return ["linear-gradient(90deg,  #"+bgColor+" 30%, transparent 30%),"+"linear-gradient(0deg,transparent, transparent 40%, #"+fgColor+" 40%, #"+fgColor+" 60% , transparent 60%)"+"#"+bgColor+";","4px 4px"];case"solidDmnd":return ["linear-gradient(135deg,  #"+fgColor+" 25%, transparent 25%), "+"linear-gradient(225deg,  #"+fgColor+" 25%, transparent 25%), "+"linear-gradient(315deg,  #"+fgColor+" 25%, transparent 25%), "+"linear-gradient(45deg,  #"+fgColor+" 25%, transparent 25%) "+"#"+bgColor+";","8px 8px"];case"openDmnd":return ["linear-gradient(45deg, transparent 0%, transparent calc(50% - 0.5px),  #"+fgColor+" 50%, transparent calc(50% + 0.5px),  transparent 100%), "+"linear-gradient(-45deg, transparent 0%, transparent calc(50% - 0.5px) , #"+fgColor+" 50%, transparent calc(50% + 0.5px),  transparent 100%) "+"#"+bgColor+";","8px 8px"];case"dotDmnd":return ["radial-gradient(#"+fgColor+" 15%, transparent 0), "+"radial-gradient(#"+fgColor+" 15%, transparent 0) "+"#"+bgColor+";","4px 4px","0 0, 2px 2px"];case"zigZag":case"wave":var size="";if(prst=="zigZag")size="0";else size="1px";return ["linear-gradient(135deg,  #"+fgColor+" 25%, transparent 25%) 50px "+size+", "+"linear-gradient(225deg,  #"+fgColor+" 25%, transparent 25%) 50px "+size+", "+"linear-gradient(315deg,  #"+fgColor+" 25%, transparent 25%), "+"linear-gradient(45deg,  #"+fgColor+" 25%, transparent 25%) "+"#"+bgColor+";","4px 4px"];case"lgConfetti":case"smConfetti":var size="";if(prst=="lgConfetti")size="4px 4px";else size="2px 2px";return ["linear-gradient(135deg,  #"+fgColor+" 25%, transparent 25%) 50px 1px, "+"linear-gradient(225deg,  #"+fgColor+" 25%, transparent 25%), "+"linear-gradient(315deg,  #"+fgColor+" 25%, transparent 25%) 50px 1px , "+"linear-gradient(45deg,  #"+fgColor+" 25%, transparent 25%) "+"#"+bgColor+";",size];//     return ["linear-gradient(45deg,  #" + bgColor + " 5%, transparent 25%) 50px 0, " +
    //         "linear-gradient(135deg,  #" + bgColor + " 25%, transparent 25%) 50px 0, " +
    //         "linear-gradient(45deg,  #" + bgColor + " 25%, transparent 25%) " +
    //         "#" + fgColor + ";", "4px 4px"];
    //     //background: linear-gradient(45deg, #dca 12%, transparent 0, transparent 88%, #dca 0),
    //     //linear-gradient(135deg, transparent 37 %, #a85 0, #a85 63 %, transparent 0),
    //     //linear-gradient(45deg, transparent 37 %, #dca 0, #dca 63 %, transparent 0) #753;
    //     // background-size: 25px 25px;
    //     break;
    case"plaid":return ["linear-gradient(0deg, transparent, transparent 25%, #"+fgColor+"33 25%, #"+fgColor+"33 50%),"+"linear-gradient(90deg, transparent, transparent 25%, #"+fgColor+"66 25%, #"+fgColor+"66 50%) "+"#"+bgColor+";","4px 4px"];case"sphere":return ["radial-gradient(#"+fgColor+" 50%, transparent 50%),"+"#"+bgColor+";","4px 4px"];case"weave":case"shingle":return ["linear-gradient(45deg, #"+bgColor+" 1.31px , #"+fgColor+" 1.4px, #"+fgColor+" 1.5px, transparent 1.5px, transparent 4.2px, #"+fgColor+" 4.2px, #"+fgColor+" 4.3px, transparent 4.31px), "+"linear-gradient(-45deg,  #"+bgColor+" 1.31px , #"+fgColor+" 1.4px, #"+fgColor+" 1.5px, transparent 1.5px, transparent 4.2px, #"+fgColor+" 4.2px, #"+fgColor+" 4.3px, transparent 4.31px) 0 4px, "+"#"+bgColor+";","4px 8px"];//linear-gradient(45deg, #708090 1.31px, #d9ecff 1.4px, #d9ecff 1.5px, transparent 1.5px, transparent 4.2px, #d9ecff 4.2px, #d9ecff 4.3px, transparent 4.31px),
    //linear-gradient(-45deg, #708090 1.31px, #d9ecff 1.4px, #d9ecff 1.5px, transparent 1.5px, transparent 4.2px, #d9ecff 4.2px, #d9ecff 4.3px, transparent 4.31px)0 4px;
    //background-color:#708090;
    //background-size: 4px 8px;
    case"pct5":case"pct10":case"pct20":case"pct25":case"pct30":case"pct40":case"pct50":case"pct60":case"pct70":case"pct75":case"pct80":case"pct90"://case "dotDmnd":
    case"trellis":case"divot":var px_pr_ary;switch(prst){case"pct5":px_pr_ary=["0.3px","10%","2px 2px"];break;case"divot":px_pr_ary=["0.3px","40%","4px 4px"];break;case"pct10":px_pr_ary=["0.3px","20%","2px 2px"];break;case"pct20"://case "dotDmnd":
    px_pr_ary=["0.2px","40%","2px 2px"];break;case"pct25":px_pr_ary=["0.2px","50%","2px 2px"];break;case"pct30":px_pr_ary=["0.5px","50%","2px 2px"];break;case"pct40":px_pr_ary=["0.5px","70%","2px 2px"];break;case"pct50":px_pr_ary=["0.09px","90%","2px 2px"];break;case"pct60":px_pr_ary=["0.3px","90%","2px 2px"];break;case"pct70":case"trellis":px_pr_ary=["0.5px","95%","2px 2px"];break;case"pct75":px_pr_ary=["0.65px","100%","2px 2px"];break;case"pct80":px_pr_ary=["0.85px","100%","2px 2px"];break;case"pct90":px_pr_ary=["1px","100%","2px 2px"];break;}return ["radial-gradient(#"+fgColor+" "+px_pr_ary[0]+", transparent "+px_pr_ary[1]+"),"+"#"+bgColor+";",px_pr_ary[2]];default:return [0,0];}}function getSolidFill(node,clrMap,phClr,warpObj){if(node===undefined){return undefined;}//console.log("getSolidFill node: ", node)
    var color="";var clrNode;if(node["a:srgbClr"]!==undefined){clrNode=node["a:srgbClr"];color=getTextByPathList(clrNode,["attrs","val"]);//#...
    }else if(node["a:schemeClr"]!==undefined){//a:schemeClr
    clrNode=node["a:schemeClr"];var schemeClr=getTextByPathList(clrNode,["attrs","val"]);color=getSchemeColorFromTheme("a:"+schemeClr,clrMap,phClr,warpObj);//console.log("schemeClr: ", schemeClr, "color: ", color)
    }else if(node["a:scrgbClr"]!==undefined){clrNode=node["a:scrgbClr"];//<a:scrgbClr r="50%" g="50%" b="50%"/>  //Need to test/////////////////////////////////////////////
    var defBultColorVals=clrNode["attrs"];var red=defBultColorVals["r"].indexOf("%")!=-1?defBultColorVals["r"].split("%").shift():defBultColorVals["r"];var green=defBultColorVals["g"].indexOf("%")!=-1?defBultColorVals["g"].split("%").shift():defBultColorVals["g"];var blue=defBultColorVals["b"].indexOf("%")!=-1?defBultColorVals["b"].split("%").shift():defBultColorVals["b"];//var scrgbClr = red + "," + green + "," + blue;
    color=toHex(255*(Number(red)/100))+toHex(255*(Number(green)/100))+toHex(255*(Number(blue)/100));//console.log("scrgbClr: " + scrgbClr);
    }else if(node["a:prstClr"]!==undefined){clrNode=node["a:prstClr"];//<a:prstClr val="black"/>  //Need to test/////////////////////////////////////////////
    var prstClr=getTextByPathList(clrNode,["attrs","val"]);//node["a:prstClr"]["attrs"]["val"];
    color=getColorName2Hex(prstClr);//console.log("blip prstClr: ", prstClr, " => hexClr: ", color);
    }else if(node["a:hslClr"]!==undefined){clrNode=node["a:hslClr"];//<a:hslClr hue="14400000" sat="100%" lum="50%"/>  //Need to test/////////////////////////////////////////////
    var defBultColorVals=clrNode["attrs"];var hue=Number(defBultColorVals["hue"])/100000;var sat=Number(defBultColorVals["sat"].indexOf("%")!=-1?defBultColorVals["sat"].split("%").shift():defBultColorVals["sat"])/100;var lum=Number(defBultColorVals["lum"].indexOf("%")!=-1?defBultColorVals["lum"].split("%").shift():defBultColorVals["lum"])/100;//var hslClr = defBultColorVals["hue"] + "," + defBultColorVals["sat"] + "," + defBultColorVals["lum"];
    var hsl2rgb=hslToRgb(hue,sat,lum);color=toHex(hsl2rgb.r)+toHex(hsl2rgb.g)+toHex(hsl2rgb.b);//defBultColor = cnvrtHslColor2Hex(hslClr); //TODO
    // console.log("hslClr: " + hslClr);
    }else if(node["a:sysClr"]!==undefined){clrNode=node["a:sysClr"];//<a:sysClr val="windowText" lastClr="000000"/>  //Need to test/////////////////////////////////////////////
    var sysClr=getTextByPathList(clrNode,["attrs","lastClr"]);if(sysClr!==undefined){color=sysClr;}}//console.log("color: [%cstart]", "color: #" + color, tinycolor(color).toHslString(), color)
    //fix color -------------------------------------------------------- TODO
    //
    //1. "alpha":
    //Specifies the opacity as expressed by a percentage value.
    // [Example: The following represents a green solid fill which is 50 % opaque
    // < a: solidFill >
    //     <a:srgbClr val="00FF00">
    //         <a:alpha val="50%" />
    //     </a:srgbClr>
    // </a: solidFill >
    var isAlpha=false;var alpha=parseInt(getTextByPathList(clrNode,["a:alpha","attrs","val"]))/100000;//console.log("alpha: ", alpha)
    if(!isNaN(alpha)){// var al_color = new colz.Color(color);
    // al_color.setAlpha(alpha);
    // var ne_color = al_color.rgba.toString();
    // color = (rgba2hex(ne_color))
    var al_color=tinycolor(color);al_color.setAlpha(alpha);color=al_color.toHex8();isAlpha=true;//console.log("al_color: ", al_color, ", color: ", color)
    }//2. "alphaMod":
    // Specifies the opacity as expressed by a percentage relative to the input color.
    //     [Example: The following represents a green solid fill which is 50 % opaque
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:alphaMod val="50%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //3. "alphaOff":
    // Specifies the opacity as expressed by a percentage offset increase or decrease to the
    // input color.Increases never increase the opacity beyond 100 %, decreases never decrease
    // the opacity below 0 %.
    // [Example: The following represents a green solid fill which is 90 % opaque
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:alphaOff val="-10%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //4. "blue":
    //Specifies the value of the blue component.The assigned value is specified as a
    //percentage with 0 % indicating minimal blue and 100 % indicating maximum blue.
    //  [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //      to value RRGGBB = (00, FF, FF)
    //          <a: solidFill >
    //              <a:srgbClr val="00FF00">
    //                  <a:blue val="100%" />
    //              </a:srgbClr>
    //          </a: solidFill >
    //5. "blueMod"
    // Specifies the blue component as expressed by a percentage relative to the input color
    // component.Increases never increase the blue component beyond 100 %, decreases
    // never decrease the blue component below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, 00, FF)
    //     to value RRGGBB = (00, 00, 80)
    //     < a: solidFill >
    //         <a:srgbClr val="0000FF">
    //             <a:blueMod val="50%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //6. "blueOff"
    // Specifies the blue component as expressed by a percentage offset increase or decrease
    // to the input color component.Increases never increase the blue component
    // beyond 100 %, decreases never decrease the blue component below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, 00, FF)
    // to value RRGGBB = (00, 00, CC)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:blueOff val="-20%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //7. "comp" - This element specifies that the color rendered should be the complement of its input color with the complement
    // being defined as such.Two colors are called complementary if, when mixed they produce a shade of grey.For
    // instance, the complement of red which is RGB(255, 0, 0) is cyan.(<a:comp/>)
    //8. "gamma" - This element specifies that the output color rendered by the generating application should be the sRGB gamma
    //              shift of the input color.
    //9. "gray" - This element specifies a grayscale of its input color, taking into relative intensities of the red, green, and blue
    //              primaries.
    //10. "green":
    // Specifies the value of the green component. The assigned value is specified as a
    // percentage with 0 % indicating minimal green and 100 % indicating maximum green.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, 00, FF)
    // to value RRGGBB = (00, FF, FF)
    //     < a: solidFill >
    //         <a:srgbClr val="0000FF">
    //             <a:green val="100%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //11. "greenMod":
    // Specifies the green component as expressed by a percentage relative to the input color
    // component.Increases never increase the green component beyond 100 %, decreases
    // never decrease the green component below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    // to value RRGGBB = (00, 80, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:greenMod val="50%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //12. "greenOff":
    // Specifies the green component as expressed by a percentage offset increase or decrease
    // to the input color component.Increases never increase the green component
    // beyond 100 %, decreases never decrease the green component below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    // to value RRGGBB = (00, CC, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:greenOff val="-20%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //13. "hue" (This element specifies a color using the HSL color model):
    // This element specifies the input color with the specified hue, but with its saturation and luminance unchanged.
    // < a: solidFill >
    //     <a:hslClr hue="14400000" sat="100%" lum="50%">
    // </a:solidFill>
    // <a:solidFill>
    //     <a:hslClr hue="0" sat="100%" lum="50%">
    //         <a:hue val="14400000"/>
    //     <a:hslClr/>
    // </a:solidFill>
    //14. "hueMod" (This element specifies a color using the HSL color model):
    // Specifies the hue as expressed by a percentage relative to the input color.
    // [Example: The following manipulates the fill color from having RGB value RRGGBB = (00, FF, 00) to value RRGGBB = (FF, FF, 00)
    //         < a: solidFill >
    //             <a:srgbClr val="00FF00">
    //                 <a:hueMod val="50%" />
    //             </a:srgbClr>
    //         </a: solidFill >
    var hueMod=parseInt(getTextByPathList(clrNode,["a:hueMod","attrs","val"]))/100000;//console.log("hueMod: ", hueMod)
    if(!isNaN(hueMod)){color=applyHueMod(color,hueMod,isAlpha);}//15. "hueOff"(This element specifies a color using the HSL color model):
    // Specifies the actual angular value of the shift.The result of the shift shall be between 0
    // and 360 degrees.Shifts resulting in angular values less than 0 are treated as 0. Shifts
    // resulting in angular values greater than 360 are treated as 360.
    // [Example:
    //     The following increases the hue angular value by 10 degrees.
    //     < a: solidFill >
    //         <a:hslClr hue="0" sat="100%" lum="50%"/>
    //             <a:hueOff val="600000"/>
    //     </a: solidFill >
    //var hueOff = parseInt(getTextByPathList(clrNode, ["a:hueOff", "attrs", "val"])) / 100000;
    // if (!isNaN(hueOff)) {
    //     //console.log("hueOff: ", hueOff, " (TODO)")
    //     //color = applyHueOff(color, hueOff, isAlpha);
    // }
    //16. "inv" (inverse)
    //This element specifies the inverse of its input color.
    //The inverse of red (1, 0, 0) is cyan (0, 1, 1 ).
    // The following represents cyan, the inverse of red:
    // <a:solidFill>
    //     <a:srgbClr val="FF0000">
    //         <a:inv />
    //     </a:srgbClr>
    // </a:solidFill>
    //17. "invGamma" - This element specifies that the output color rendered by the generating application should be the inverse sRGB
    //                  gamma shift of the input color.
    //18. "lum":
    // This element specifies the input color with the specified luminance, but with its hue and saturation unchanged.
    // Typically luminance values fall in the range[0 %, 100 %].
    // The following two solid fills are equivalent:
    // <a:solidFill>
    //     <a:hslClr hue="14400000" sat="100%" lum="50%">
    // </a:solidFill>
    // <a:solidFill>
    //     <a:hslClr hue="14400000" sat="100%" lum="0%">
    //         <a:lum val="50%" />
    //     <a:hslClr />
    // </a:solidFill>
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    // to value RRGGBB = (00, 66, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:lum val="20%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    // end example]
    //19. "lumMod":
    // Specifies the luminance as expressed by a percentage relative to the input color.
    // Increases never increase the luminance beyond 100 %, decreases never decrease the
    // luminance below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (00, 75, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:lumMod val="50%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    // end example]
    var lumMod=parseInt(getTextByPathList(clrNode,["a:lumMod","attrs","val"]))/100000;//console.log("lumMod: ", lumMod)
    if(!isNaN(lumMod)){color=applyLumMod(color,lumMod,isAlpha);}//var lumMod_color = applyLumMod(color, 0.5);
    //console.log("lumMod_color: ", lumMod_color)
    //20. "lumOff"
    // Specifies the luminance as expressed by a percentage offset increase or decrease to the
    // input color.Increases never increase the luminance beyond 100 %, decreases never
    // decrease the luminance below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (00, 99, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:lumOff val="-20%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    var lumOff=parseInt(getTextByPathList(clrNode,["a:lumOff","attrs","val"]))/100000;//console.log("lumOff: ", lumOff)
    if(!isNaN(lumOff)){color=applyLumOff(color,lumOff,isAlpha);}//21. "red":
    // Specifies the value of the red component.The assigned value is specified as a percentage
    // with 0 % indicating minimal red and 100 % indicating maximum red.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (FF, FF, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:red val="100%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //22. "redMod":
    // Specifies the red component as expressed by a percentage relative to the input color
    // component.Increases never increase the red component beyond 100 %, decreases never
    // decrease the red component below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (FF, 00, 00)
    //     to value RRGGBB = (80, 00, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="FF0000">
    //             <a:redMod val="50%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //23. "redOff":
    // Specifies the red component as expressed by a percentage offset increase or decrease to
    // the input color component.Increases never increase the red component beyond 100 %,
    //     decreases never decrease the red component below 0 %.
    //     [Example: The following manipulates the fill from having RGB value RRGGBB = (FF, 00, 00)
    //     to value RRGGBB = (CC, 00, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="FF0000">
    //             <a:redOff val="-20%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    //23. "sat":
    // This element specifies the input color with the specified saturation, but with its hue and luminance unchanged.
    // Typically saturation values fall in the range[0 %, 100 %].
    // [Example:
    //     The following two solid fills are equivalent:
    //     <a:solidFill>
    //         <a:hslClr hue="14400000" sat="100%" lum="50%">
    //     </a:solidFill>
    //     <a:solidFill>
    //         <a:hslClr hue="14400000" sat="0%" lum="50%">
    //             <a:sat val="100000" />
    //         <a:hslClr />
    //     </a:solidFill>
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (40, C0, 40)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:sat val="50%" />
    //         </a:srgbClr>
    //     <a: solidFill >
    // end example]
    //24. "satMod":
    // Specifies the saturation as expressed by a percentage relative to the input color.
    // Increases never increase the saturation beyond 100 %, decreases never decrease the
    // saturation below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (66, 99, 66)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:satMod val="20%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    var satMod=parseInt(getTextByPathList(clrNode,["a:satMod","attrs","val"]))/100000;if(!isNaN(satMod)){color=applySatMod(color,satMod,isAlpha);}//25. "satOff":
    // Specifies the saturation as expressed by a percentage offset increase or decrease to the
    // input color.Increases never increase the saturation beyond 100 %, decreases never
    // decrease the saturation below 0 %.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (19, E5, 19)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:satOff val="-20%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    // var satOff = parseInt(getTextByPathList(clrNode, ["a:satOff", "attrs", "val"])) / 100000;
    // if (!isNaN(satOff)) {
    //     console.log("satOff: ", satOff, " (TODO)")
    // }
    //26. "shade":
    // This element specifies a darker version of its input color.A 10 % shade is 10 % of the input color combined with 90 % black.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (00, BC, 00)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:shade val="50%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    // end example]
    var shade=parseInt(getTextByPathList(clrNode,["a:shade","attrs","val"]))/100000;if(!isNaN(shade)){color=applyShade(color,shade,isAlpha);}//27.  "tint":
    // This element specifies a lighter version of its input color.A 10 % tint is 10 % of the input color combined with
    // 90 % white.
    // [Example: The following manipulates the fill from having RGB value RRGGBB = (00, FF, 00)
    //     to value RRGGBB = (BC, FF, BC)
    //     < a: solidFill >
    //         <a:srgbClr val="00FF00">
    //             <a:tint val="50%" />
    //         </a:srgbClr>
    //     </a: solidFill >
    var tint=parseInt(getTextByPathList(clrNode,["a:tint","attrs","val"]))/100000;if(!isNaN(tint)){color=applyTint(color,tint,isAlpha);}//console.log("color [%cfinal]: ", "color: #" + color, tinycolor(color).toHslString(), color)
    return color;}function toHex(n){var hex=n.toString(16);while(hex.length<2){hex="0"+hex;}return hex;}function hslToRgb(hue,sat,light){var t1,t2,r,g,b;hue=hue/60;if(light<=0.5){t2=light*(sat+1);}else {t2=light+sat-light*sat;}t1=light*2-t2;r=hueToRgb(t1,t2,hue+2)*255;g=hueToRgb(t1,t2,hue)*255;b=hueToRgb(t1,t2,hue-2)*255;return {r:r,g:g,b:b};}function hueToRgb(t1,t2,hue){if(hue<0)hue+=6;if(hue>=6)hue-=6;if(hue<1)return (t2-t1)*hue+t1;else if(hue<3)return t2;else if(hue<4)return (t2-t1)*(4-hue)+t1;else return t1;}function getColorName2Hex(name){var hex;var colorName=["white","AliceBlue","AntiqueWhite","Aqua","Aquamarine","Azure","Beige","Bisque","black","BlanchedAlmond","Blue","BlueViolet","Brown","BurlyWood","CadetBlue","Chartreuse","Chocolate","Coral","CornflowerBlue","Cornsilk","Crimson","Cyan","DarkBlue","DarkCyan","DarkGoldenRod","DarkGray","DarkGrey","DarkGreen","DarkKhaki","DarkMagenta","DarkOliveGreen","DarkOrange","DarkOrchid","DarkRed","DarkSalmon","DarkSeaGreen","DarkSlateBlue","DarkSlateGray","DarkSlateGrey","DarkTurquoise","DarkViolet","DeepPink","DeepSkyBlue","DimGray","DimGrey","DodgerBlue","FireBrick","FloralWhite","ForestGreen","Fuchsia","Gainsboro","GhostWhite","Gold","GoldenRod","Gray","Grey","Green","GreenYellow","HoneyDew","HotPink","IndianRed","Indigo","Ivory","Khaki","Lavender","LavenderBlush","LawnGreen","LemonChiffon","LightBlue","LightCoral","LightCyan","LightGoldenRodYellow","LightGray","LightGrey","LightGreen","LightPink","LightSalmon","LightSeaGreen","LightSkyBlue","LightSlateGray","LightSlateGrey","LightSteelBlue","LightYellow","Lime","LimeGreen","Linen","Magenta","Maroon","MediumAquaMarine","MediumBlue","MediumOrchid","MediumPurple","MediumSeaGreen","MediumSlateBlue","MediumSpringGreen","MediumTurquoise","MediumVioletRed","MidnightBlue","MintCream","MistyRose","Moccasin","NavajoWhite","Navy","OldLace","Olive","OliveDrab","Orange","OrangeRed","Orchid","PaleGoldenRod","PaleGreen","PaleTurquoise","PaleVioletRed","PapayaWhip","PeachPuff","Peru","Pink","Plum","PowderBlue","Purple","RebeccaPurple","Red","RosyBrown","RoyalBlue","SaddleBrown","Salmon","SandyBrown","SeaGreen","SeaShell","Sienna","Silver","SkyBlue","SlateBlue","SlateGray","SlateGrey","Snow","SpringGreen","SteelBlue","Tan","Teal","Thistle","Tomato","Turquoise","Violet","Wheat","White","WhiteSmoke","Yellow","YellowGreen"];var colorHex=["ffffff","f0f8ff","faebd7","00ffff","7fffd4","f0ffff","f5f5dc","ffe4c4","000000","ffebcd","0000ff","8a2be2","a52a2a","deb887","5f9ea0","7fff00","d2691e","ff7f50","6495ed","fff8dc","dc143c","00ffff","00008b","008b8b","b8860b","a9a9a9","a9a9a9","006400","bdb76b","8b008b","556b2f","ff8c00","9932cc","8b0000","e9967a","8fbc8f","483d8b","2f4f4f","2f4f4f","00ced1","9400d3","ff1493","00bfff","696969","696969","1e90ff","b22222","fffaf0","228b22","ff00ff","dcdcdc","f8f8ff","ffd700","daa520","808080","808080","008000","adff2f","f0fff0","ff69b4","cd5c5c","4b0082","fffff0","f0e68c","e6e6fa","fff0f5","7cfc00","fffacd","add8e6","f08080","e0ffff","fafad2","d3d3d3","d3d3d3","90ee90","ffb6c1","ffa07a","20b2aa","87cefa","778899","778899","b0c4de","ffffe0","00ff00","32cd32","faf0e6","ff00ff","800000","66cdaa","0000cd","ba55d3","9370db","3cb371","7b68ee","00fa9a","48d1cc","c71585","191970","f5fffa","ffe4e1","ffe4b5","ffdead","000080","fdf5e6","808000","6b8e23","ffa500","ff4500","da70d6","eee8aa","98fb98","afeeee","db7093","ffefd5","ffdab9","cd853f","ffc0cb","dda0dd","b0e0e6","800080","663399","ff0000","bc8f8f","4169e1","8b4513","fa8072","f4a460","2e8b57","fff5ee","a0522d","c0c0c0","87ceeb","6a5acd","708090","708090","fffafa","00ff7f","4682b4","d2b48c","008080","d8bfd8","ff6347","40e0d0","ee82ee","f5deb3","ffffff","f5f5f5","ffff00","9acd32"];var findIndx=colorName.indexOf(name);if(findIndx!=-1){hex=colorHex[findIndx];}return hex;}function getSchemeColorFromTheme(schemeClr,clrMap,phClr,warpObj){//<p:clrMap ...> in slide master
    // e.g. tx2="dk2" bg2="lt2" tx1="dk1" bg1="lt1" slideLayoutClrOvride
    // console.log("getSchemeColorFromTheme: schemeClr: ", schemeClr, ",clrMap: ", clrMap)
    var slideLayoutClrOvride;if(clrMap!==undefined){slideLayoutClrOvride=clrMap;//getTextByPathList(clrMap, ["p:sldMaster", "p:clrMap", "attrs"])
    }else {// console.log(warpObj)
    var sldClrMapOvr=getTextByPathList(warpObj["slideContent"],["p:sld","p:clrMapOvr","a:overrideClrMapping","attrs"]);if(sldClrMapOvr!==undefined){slideLayoutClrOvride=sldClrMapOvr;}else {var sldClrMapOvr=getTextByPathList(warpObj["slideLayoutContent"],["p:sldLayout","p:clrMapOvr","a:overrideClrMapping","attrs"]);if(sldClrMapOvr!==undefined){slideLayoutClrOvride=sldClrMapOvr;}else {slideLayoutClrOvride=getTextByPathList(warpObj["slideMasterContent"],["p:sldMaster","p:clrMap","attrs"]);}}}//console.log("getSchemeColorFromTheme slideLayoutClrOvride: ", slideLayoutClrOvride);
    var schmClrName=schemeClr.substr(2);if(schmClrName=="phClr"&&phClr!==undefined){color=phClr;}else {if(slideLayoutClrOvride!==undefined){switch(schmClrName){case"tx1":case"tx2":case"bg1":case"bg2":schemeClr="a:"+slideLayoutClrOvride[schmClrName];break;}}else {switch(schmClrName){case"tx1":schemeClr="a:dk1";break;case"tx2":schemeClr="a:dk2";break;case"bg1":schemeClr="a:lt1";break;case"bg2":schemeClr="a:lt2";break;}}//console.log("getSchemeColorFromTheme:  schemeClr: ", schemeClr);
    var refNode=getTextByPathList(warpObj["themeContent"],["a:theme","a:themeElements","a:clrScheme",schemeClr]);var color=getTextByPathList(refNode,["a:srgbClr","attrs","val"]);//console.log("themeContent: color", color);
    if(color===undefined&&refNode!==undefined){color=getTextByPathList(refNode,["a:sysClr","attrs","lastClr"]);}}//console.log(color)
    return color;}function extractChartData(serNode){var dataMat=new Array();if(serNode===undefined){return dataMat;}if(serNode["c:xVal"]!==undefined){var dataRow=new Array();eachElement(serNode["c:xVal"]["c:numRef"]["c:numCache"]["c:pt"],function(innerNode,index){dataRow.push(parseFloat(innerNode["c:v"]));return "";});dataMat.push(dataRow);dataRow=new Array();eachElement(serNode["c:yVal"]["c:numRef"]["c:numCache"]["c:pt"],function(innerNode,index){dataRow.push(parseFloat(innerNode["c:v"]));return "";});dataMat.push(dataRow);}else {eachElement(serNode,function(innerNode,index){var dataRow=new Array();var colName=getTextByPathList(innerNode,["c:tx","c:strRef","c:strCache","c:pt","c:v"])||index;// Category (string or number)
    var rowNames={};if(getTextByPathList(innerNode,["c:cat","c:strRef","c:strCache","c:pt"])!==undefined){eachElement(innerNode["c:cat"]["c:strRef"]["c:strCache"]["c:pt"],function(innerNode,index){rowNames[innerNode["attrs"]["idx"]]=innerNode["c:v"];return "";});}else if(getTextByPathList(innerNode,["c:cat","c:numRef","c:numCache","c:pt"])!==undefined){eachElement(innerNode["c:cat"]["c:numRef"]["c:numCache"]["c:pt"],function(innerNode,index){rowNames[innerNode["attrs"]["idx"]]=innerNode["c:v"];return "";});}// Value
    if(getTextByPathList(innerNode,["c:val","c:numRef","c:numCache","c:pt"])!==undefined){eachElement(innerNode["c:val"]["c:numRef"]["c:numCache"]["c:pt"],function(innerNode,index){dataRow.push({x:innerNode["attrs"]["idx"],y:parseFloat(innerNode["c:v"])});return "";});}dataMat.push({key:colName,values:dataRow,xlabels:rowNames});return "";});}return dataMat;}// ===== Node functions =====
    /**
     * getTextByPathList
     * @param {Object} node
     * @param {string Array} path
     */function getTextByPathList(node,path){if(path.constructor!==Array){throw Error("Error of path type! path is not array.");}if(node===undefined){return undefined;}var l=path.length;for(var i=0;i<l;i++){node=node[path[i]];if(node===undefined){return undefined;}}return node;}/**
     * setTextByPathList
     * @param {Object} node
     * @param {string Array} path
     * @param {string} value
     */function setTextByPathList(node,path,value){if(path.constructor!==Array){throw Error("Error of path type! path is not array.");}if(node===undefined){return undefined;}var set=function set(node,parts,value){//var parts = prop.split('.');
    var obj=node;var lent=parts.length;for(var i=0;i<lent;i++){var p=parts[i];if(obj[p]===undefined){if(i==lent-1){obj[p]=value;}else {obj[p]={};}}obj=obj[p];}return obj;};set(node,path,value);}/**
     * eachElement
     * @param {Object} node
     * @param {function} doFunction
     */function eachElement(node,doFunction){if(node===undefined){return;}var result="";if(node.constructor===Array){var l=node.length;for(var i=0;i<l;i++){result+=doFunction(node[i],i);}}else {result+=doFunction(node,0);}return result;}// ===== Color functions =====
    /**
     * applyShade
     * @param {string} rgbStr
     * @param {number} shadeValue
     */function applyShade(rgbStr,shadeValue,isAlpha){var color=tinycolor(rgbStr).toHsl();//console.log("applyShade  color: ", color, ", shadeValue: ", shadeValue)
    if(shadeValue>=1){shadeValue=1;}var cacl_l=Math.min(color.l*shadeValue,1);//;color.l * shadeValue + (1 - shadeValue);
    // if (isAlpha)
    //     return color.lighten(tintValue).toHex8();
    // return color.lighten(tintValue).toHex();
    if(isAlpha)return tinycolor({h:color.h,s:color.s,l:cacl_l,a:color.a}).toHex8();return tinycolor({h:color.h,s:color.s,l:cacl_l,a:color.a}).toHex();}/**
     * applyTint
     * @param {string} rgbStr
     * @param {number} tintValue
     */function applyTint(rgbStr,tintValue,isAlpha){var color=tinycolor(rgbStr).toHsl();//console.log("applyTint  color: ", color, ", tintValue: ", tintValue)
    if(tintValue>=1){tintValue=1;}var cacl_l=color.l*tintValue+(1-tintValue);// if (isAlpha)
    //     return color.lighten(tintValue).toHex8();
    // return color.lighten(tintValue).toHex();
    if(isAlpha)return tinycolor({h:color.h,s:color.s,l:cacl_l,a:color.a}).toHex8();return tinycolor({h:color.h,s:color.s,l:cacl_l,a:color.a}).toHex();}/**
     * applyLumOff
     * @param {string} rgbStr
     * @param {number} offset
     */function applyLumOff(rgbStr,offset,isAlpha){var color=tinycolor(rgbStr).toHsl();//console.log("applyLumOff  color.l: ", color.l, ", offset: ", offset, ", color.l + offset : ", color.l + offset)
    var lum=offset+color.l;if(lum>=1){if(isAlpha)return tinycolor({h:color.h,s:color.s,l:1,a:color.a}).toHex8();return tinycolor({h:color.h,s:color.s,l:1,a:color.a}).toHex();}if(isAlpha)return tinycolor({h:color.h,s:color.s,l:lum,a:color.a}).toHex8();return tinycolor({h:color.h,s:color.s,l:lum,a:color.a}).toHex();}/**
     * applyLumMod
     * @param {string} rgbStr
     * @param {number} multiplier
     */function applyLumMod(rgbStr,multiplier,isAlpha){var color=tinycolor(rgbStr).toHsl();//console.log("applyLumMod  color.l: ", color.l, ", multiplier: ", multiplier, ", color.l * multiplier : ", color.l * multiplier)
    var cacl_l=color.l*multiplier;if(cacl_l>=1){cacl_l=1;}if(isAlpha)return tinycolor({h:color.h,s:color.s,l:cacl_l,a:color.a}).toHex8();return tinycolor({h:color.h,s:color.s,l:cacl_l,a:color.a}).toHex();}// /**
    //  * applyHueMod
    //  * @param {string} rgbStr
    //  * @param {number} multiplier
    //  */
    function applyHueMod(rgbStr,multiplier,isAlpha){var color=tinycolor(rgbStr).toHsl();//console.log("applyLumMod  color.h: ", color.h, ", multiplier: ", multiplier, ", color.h * multiplier : ", color.h * multiplier)
    var cacl_h=color.h*multiplier;if(cacl_h>=360){cacl_h=cacl_h-360;}if(isAlpha)return tinycolor({h:cocacl_h,s:color.s,l:color.l,a:color.a}).toHex8();return tinycolor({h:cacl_h,s:color.s,l:color.l,a:color.a}).toHex();}// /**
    //  * applyHueOff
    //  * @param {string} rgbStr
    //  * @param {number} offset
    //  */
    // function applyHueOff(rgbStr, offset, isAlpha) {
    //     var color = tinycolor(rgbStr).toHsl();
    //     //console.log("applyLumMod  color.h: ", color.h, ", offset: ", offset, ", color.h * offset : ", color.h * offset)
    //     var cacl_h = color.h * offset;
    //     if (cacl_h >= 360) {
    //         cacl_h = cacl_h - 360;
    //     }
    //     if (isAlpha)
    //         return tinycolor({ h: cocacl_h, s: color.s, l: color.l, a: color.a }).toHex8();
    //     return tinycolor({ h: cacl_h, s: color.s, l: color.l, a: color.a }).toHex();
    // }
    // /**
    //  * applySatMod
    //  * @param {string} rgbStr
    //  * @param {number} multiplier
    //  */
    function applySatMod(rgbStr,multiplier,isAlpha){var color=tinycolor(rgbStr).toHsl();//console.log("applySatMod  color.s: ", color.s, ", multiplier: ", multiplier, ", color.s * multiplier : ", color.s * multiplier)
    var cacl_s=color.s*multiplier;if(cacl_s>=1){cacl_s=1;}//return;
    // if (isAlpha)
    //     return tinycolor(rgbStr).saturate(multiplier * 100).toHex8();
    // return tinycolor(rgbStr).saturate(multiplier * 100).toHex();
    if(isAlpha)return tinycolor({h:color.h,s:cacl_s,l:color.l,a:color.a}).toHex8();return tinycolor({h:color.h,s:cacl_s,l:color.l,a:color.a}).toHex();}function angleToDegrees(angle){if(angle==""||angle==null){return 0;}return Math.round(angle/60000);}// function degreesToRadians(degrees) {
    //     //Math.PI
    //     if (degrees == "" || degrees == null || degrees == undefined) {
    //         return 0;
    //     }
    //     return degrees * (Math.PI / 180);
    // }
    function getMimeType(imgFileExt){var mimeType="";//console.log(imgFileExt)
    switch(imgFileExt.toLowerCase()){case"jpg":case"jpeg":mimeType="image/jpeg";break;case"png":mimeType="image/png";break;case"gif":mimeType="image/gif";break;case"emf":// Not native support
    mimeType="image/x-emf";break;case"wmf":// Not native support
    mimeType="image/x-wmf";break;case"svg":mimeType="image/svg+xml";break;case"mp4":mimeType="video/mp4";break;case"webm":mimeType="video/webm";break;case"ogg":mimeType="video/ogg";break;case"avi":mimeType="video/avi";break;case"mpg":mimeType="video/mpg";break;case"wmv":mimeType="video/wmv";break;case"mp3":mimeType="audio/mpeg";break;case"wav":mimeType="audio/wav";break;case"emf":mimeType="image/emf";break;case"wmf":mimeType="image/wmf";case"tif":case"tiff":mimeType="image/tiff";break;}return mimeType;}function getSvgGradient(w,h,angl,color_arry,shpId){var stopsArray=getMiddleStops(color_arry-2);var svgAngle="",svgHeight=h,svgWidth=w,svg="",xy_ary=SVGangle(angl,svgHeight,svgWidth),x1=xy_ary[0],y1=xy_ary[1],x2=xy_ary[2],y2=xy_ary[3];var sal=stopsArray.length,sr=sal<20?100:1000;svgAngle=' gradientUnits="userSpaceOnUse" x1="'+x1+'%" y1="'+y1+'%" x2="'+x2+'%" y2="'+y2+'%"';svgAngle='<linearGradient id="linGrd_'+shpId+'"'+svgAngle+">\n";svg+=svgAngle;for(var i=0;i<sal;i++){var tinClr=tinycolor("#"+color_arry[i]);var alpha=tinClr.getAlpha();//console.log("color: ", color_arry[i], ", rgba: ", tinClr.toHexString(), ", alpha: ", alpha)
    svg+='<stop offset="'+Math.round(parseFloat(stopsArray[i])/100*sr)/sr+'" style="stop-color:'+tinClr.toHexString()+"; stop-opacity:"+alpha+';"';svg+="/>\n";}svg+="</linearGradient>\n"+"";return svg;}function getMiddleStops(s){var sArry=["0%","100%"];if(s==0){return sArry;}else {var i=s;while(i--){var middleStop=100-100/(s+1)*(i+1),// AM: Ex - For 3 middle stops, progression will be 25%, 50%, and 75%, plus 0% and 100% at the ends.
    middleStopString=middleStop+"%";sArry.splice(-1,0,middleStopString);}// AM: add into stopsArray before 100%
    }return sArry;}function SVGangle(deg,svgHeight,svgWidth){var w=parseFloat(svgWidth),h=parseFloat(svgHeight),ang=parseFloat(deg),o=2,n=2,wc=w/2,hc=h/2,tx1=2,ty1=2,tx2=2,ty2=2,k=(ang%360+360)%360,j=(360-k)*Math.PI/180,i=Math.tan(j),l=hc-i*wc;if(k==0){tx1=w,ty1=hc,tx2=0,ty2=hc;}else if(k<90){n=w,o=0;}else if(k==90){tx1=wc,ty1=0,tx2=wc,ty2=h;}else if(k<180){n=0,o=0;}else if(k==180){tx1=0,ty1=hc,tx2=w,ty2=hc;}else if(k<270){n=0,o=h;}else if(k==270){tx1=wc,ty1=h,tx2=wc,ty2=0;}else {n=w,o=h;}// AM: I could not quite figure out what m, n, and o are supposed to represent from the original code on visualcsstools.com.
    var m=o+n/i,tx1=tx1==2?i*(m-l)/(Math.pow(i,2)+1):tx1,ty1=ty1==2?i*tx1+l:ty1,tx2=tx2==2?w-tx1:tx2,ty2=ty2==2?h-ty1:ty2,x1=Math.round(tx2/w*100*100)/100,y1=Math.round(ty2/h*100*100)/100,x2=Math.round(tx1/w*100*100)/100,y2=Math.round(ty1/h*100*100)/100;return [x1,y1,x2,y2];}function getSvgImagePattern(node,fill,shpId,warpObj){var pic_dim=getBase64ImageDimensions(fill);var width=pic_dim[0];var height=pic_dim[1];//console.log("getSvgImagePattern node:", node);
    var blipFillNode=node["p:spPr"]["a:blipFill"];var tileNode=getTextByPathList(blipFillNode,["a:tile","attrs"]);if(tileNode!==undefined&&tileNode["sx"]!==undefined){var sx=parseInt(tileNode["sx"])/100000*width;var sy=parseInt(tileNode["sy"])/100000*height;}var blipNode=node["p:spPr"]["a:blipFill"]["a:blip"];var tialphaModFixNode=getTextByPathList(blipNode,["a:alphaModFix","attrs"]);var imgOpacity="";if(tialphaModFixNode!==undefined&&tialphaModFixNode["amt"]!==undefined&&tialphaModFixNode["amt"]!=""){var amt=parseInt(tialphaModFixNode["amt"])/100000;var opacity=amt;var imgOpacity="opacity='"+opacity+"'";}if(sx!==undefined&&sx!=0){var ptrn='<pattern id="imgPtrn_'+shpId+'" x="0" y="0"  width="'+sx+'" height="'+sy+'" patternUnits="userSpaceOnUse">';}else {var ptrn='<pattern id="imgPtrn_'+shpId+'"  patternContentUnits="objectBoundingBox"  width="1" height="1">';}var duotoneNode=getTextByPathList(blipNode,["a:duotone"]);var fillterNode="";var filterUrl="";if(duotoneNode!==undefined){//console.log("pic duotoneNode: ", duotoneNode)
    var clr_ary=[];Object.keys(duotoneNode).forEach(function(clr_type){//Object.keys(duotoneNode[clr_type]).forEach(function (clr) {
    //console.log("blip pic duotone clr: ", duotoneNode[clr_type][clr], clr)
    if(clr_type!="attrs"){var obj={};obj[clr_type]=duotoneNode[clr_type];//console.log("blip pic duotone obj: ", obj)
    var hexClr=getSolidFill(obj,undefined,undefined,warpObj);//clr_ary.push();
    var color=tinycolor("#"+hexClr);clr_ary.push(color.toRgb());// { r: 255, g: 0, b: 0, a: 1 }
    }// })
    });if(clr_ary.length==2){fillterNode='<filter id="svg_image_duotone"> '+'<feColorMatrix type="matrix" values=".33 .33 .33 0 0'+".33 .33 .33 0 0"+".33 .33 .33 0 0"+'0 0 0 1 0">'+"</feColorMatrix>"+'<feComponentTransfer color-interpolation-filters="sRGB">'+//clr_ary.forEach(function(clr){
    '<feFuncR type="table" tableValues="'+clr_ary[0].r/255+" "+clr_ary[1].r/255+'"></feFuncR>'+'<feFuncG type="table" tableValues="'+clr_ary[0].g/255+" "+clr_ary[1].g/255+'"></feFuncG>'+'<feFuncB type="table" tableValues="'+clr_ary[0].b/255+" "+clr_ary[1].b/255+'"></feFuncB>'+//});
    "</feComponentTransfer>"+" </filter>";}filterUrl='filter="url(#svg_image_duotone)"';ptrn+=fillterNode;}fill=escapeHtml(fill);if(sx!==undefined&&sx!=0){ptrn+='<image  xlink:href="'+fill+'" x="0" y="0" width="'+sx+'" height="'+sy+'" '+imgOpacity+" "+filterUrl+"></image>";}else {ptrn+='<image  xlink:href="'+fill+'" preserveAspectRatio="none" width="1" height="1" '+imgOpacity+" "+filterUrl+"></image>";}ptrn+="</pattern>";//console.log("getSvgImagePattern(...) pic_dim:", pic_dim, ", fillColor: ", fill, ", blipNode: ", blipNode, ",sx: ", sx, ", sy: ", sy, ", clr_ary: ", clr_ary, ", ptrn: ", ptrn)
    return ptrn;}function getBase64ImageDimensions(imgSrc){var image=new Image();image.onload=function(){image.width;image.height;};image.src=imgSrc;do{if(image.width!==undefined){return [image.width,image.height];}}while(image.width===undefined);//return [w, h];
    }archaicNumbers([[1000,""],[400,"ת"],[300,"ש"],[200,"ר"],[100,"ק"],[90,"צ"],[80,"פ"],[70,"ע"],[60,"ס"],[50,"נ"],[40,"מ"],[30,"ל"],[20,"כ"],[10,"י"],[9,"ט"],[8,"ח"],[7,"ז"],[6,"ו"],[5,"ה"],[4,"ד"],[3,"ג"],[2,"ב"],[1,"א"],[/יה/,"ט״ו"],[/יו/,"ט״ז"],[/([א-ת])([א-ת])$/,"$1״$2"],[/^([א-ת])$/,"$1׳"]]);function archaicNumbers(arr){arr.slice().sort(function(a,b){return b[1].length-a[1].length;});return {format:function format(n){var ret="";jQuery.each(arr,function(){var num=this[0];if(parseInt(num)>0){for(;n>=num;n-=num){ret+=this[1];}}else {ret=ret.replace(num,this[1]);}});return ret;}};}function base64ArrayBuffer(arrayBuffer){var base64="";var encodings="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var bytes=new Uint8Array(arrayBuffer);var byteLength=bytes.byteLength;var byteRemainder=byteLength%3;var mainLength=byteLength-byteRemainder;var a,b,c,d;var chunk;for(var i=0;i<mainLength;i=i+3){chunk=bytes[i]<<16|bytes[i+1]<<8|bytes[i+2];a=(chunk&16515072)>>18;b=(chunk&258048)>>12;c=(chunk&4032)>>6;d=chunk&63;base64+=encodings[a]+encodings[b]+encodings[c]+encodings[d];}if(byteRemainder==1){chunk=bytes[mainLength];a=(chunk&252)>>2;b=(chunk&3)<<4;base64+=encodings[a]+encodings[b]+"==";}else if(byteRemainder==2){chunk=bytes[mainLength]<<8|bytes[mainLength+1];a=(chunk&64512)>>10;b=(chunk&1008)>>4;c=(chunk&15)<<2;base64+=encodings[a]+encodings[b]+encodings[c]+"=";}return base64;}function IsVideoLink(vdoFile){/*
        var ext = extractFileExtension(vdoFile);
        if (ext.length == 3){
            return false;
        }else{
            return true;
        }
        */var urlregex=/^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/;return urlregex.test(vdoFile);}function extractFileExtension(filename){return filename.substr((~-filename.lastIndexOf(".")>>>0)+2);}function escapeHtml(text){var map={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#039;"};return text.replace(/[&<>"']/g,function(m){return map[m];});}

    /* eslint-disable */

    return pptx2html;

}));
